      SUBROUTINE DPDDS2(Y1,N1,IORDAR,IORDMA,DELTAT,NUMVAR,ILOCV,
CCCCC1XTEMP1,XTEMP2,MAXNXT,PRED2,RES2,RESSD,RESDF,IBUGA3,IERROR)
CCCCC APRIL 1996. ADD XDDS, YDDS, AT, Y2 TO ARGUMENT LIST
     1XTEMP1,XTEMP2,XDDS,YDDS,AT,Y2,MAXNXT,PRED2,RES2,RESSD,RESDF,
     1IBUGA3,IERROR)
C
C     PURPOSE--THIS ROUTINE CARRIES OUT A DDS ANALYSIS
C              (1-SAMPLE OR 2-SAMPLE)
C     EXAMPLE--DDS Y 6 5 DELT
C              DDS Y 6 5  (== DDS Y 6 5 1)
C              DDS Y      (== DDS Y 6 5 1)
C     SAMPLE 1 IS IN INPUT VECTOR Y1
C              (WITH N1 OBSERVATIONS).
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--82/7
C     ORIGINAL VERSION--MAY       1984.
C     UPDATED         --APRIL     1987.  (LARRY KNAB CORRECTION--
C                                        BROWNLEE, P. 225)
C     UPDATED         --FEBRUARY  1994.  REFORMAT OUTPUT
C     UPDATED         --FEBRUARY  1994.  DPWRST: 'BUG ' => 'WRIT'
C     UPDATED         --APRIL     1996. DDS CODE MODIFIED (ALAN):
C                                       A) SOME DIMENSIONS TO DPDDS, USE
C                                          EQUIVALENCE
C                                       B) I/O CONSISTENT WITH DATAPLOT
C                                       C) USE IERROR RATHER THAN STOP
C                                       D) INCLUDE FILE FOR DDS COMMON
C                                          BLOCKS AND PARAMETER STATEMENTS
C                                       THESE CHANGES PROPOGATE TO LOWER
C                                       LEVEL DDS ROUTINES
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IBUGA3
      CHARACTER*4 IERROR
C
CCCCC CHARACTER*4 IWRITE
C
CCCCC THE FOLLOWING 3 LINES WERE ADDED   FEBRUARY 1994
CCCCC CHARACTER*6 ICONC1
CCCCC CHARACTER*6 ICONC2
CCCCC CHARACTER*6 ICONC3
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
C---------------------------------------------------------------------
C
      DIMENSION Y1(*)
CCCCC FUTURE--Y2 NEEDS TO BE MADE AN INPUT ARGUMENT
CCCCC APRIL 1996. MAKE Y2 AN INPUT ARGUMENT, ALSO ADD XDDS, YDDS
CCCCC DIMENSION Y2(100)
      DIMENSION Y2(*)
CCCCC APRIL 1996.  ADD FOLLOWING LINES
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION AT(MXNOB1,MXSER)
C
      DIMENSION XTEMP1(*)
      DIMENSION XTEMP2(*)
C
      DIMENSION PRED2(*)
      DIMENSION RES2(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      ISUBN1='DPCO'
      ISUBN2='F2  '
C
      IERROR='NO'
C
      N=(-99)
C
      IF(IBUGA3.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,51)
   51 FORMAT('**** AT THE BEGINNING OF DPDDS2--')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,52)IBUGA3
   52 FORMAT('IBUGA3 = ',A4)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,53)DELTAT,NUMVAR,ILOCV
   53 FORMAT('DELTAT,NUMVAR,ILOCV = ',E15.7,I8,I8)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,55)N1
   55 FORMAT('N1 = ',I8)
      CALL DPWRST('XXX','WRIT')
      DO56I=1,N1
      WRITE(ICOUT,57)I,Y1(I)
   57 FORMAT('I,Y1(I) = ',I8,E15.7)
      CALL DPWRST('XXX','WRIT')
   56 CONTINUE
      WRITE(ICOUT,65)IORDMA
   65 FORMAT('IORDMA = ',I8)
      CALL DPWRST('XXX','WRIT')
      DO66I=1,IORDMA
      WRITE(ICOUT,67)I,Y2(I)
   67 FORMAT('I,Y2(I) = ',I8,E15.7)
      CALL DPWRST('XXX','WRIT')
   66 CONTINUE
   90 CONTINUE
C
C               ********************************************
C               **  STEP 11--                             **
C               **  CHECK THE INPUT ARGUMENTS FOR ERRORS  **
C               ********************************************
C
      ISTEPN='11'
      IF(IBUGA3.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(N1.GE.1)GOTO1119
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1111)
 1111 FORMAT('***** ERROR IN DPDDS2--THE NUMBER OF OBSERVATIONS ',
     1'FOR VARIABLE 1 IS NON-POSITIVE')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1112)N1
 1112 FORMAT('SAMPLE SIZE = ',I8)
      CALL DPWRST('XXX','WRIT')
      IERROR='YES'
      GOTO9000
 1119 CONTINUE
C
      IF(N1.EQ.1)GOTO1120
      GOTO1129
 1120 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1121)
 1121 FORMAT('***** NOTE FROM DPDDS2--VARIABLE 1 ',
     1'HAS ONLY 1 ELEMENT')
      CALL DPWRST('XXX','WRIT')
      GOTO9000
 1129 CONTINUE
C
      HOLD=Y1(1)
      DO1135I=2,N1
      IF(Y1(I).NE.HOLD)GOTO1139
 1135 CONTINUE
 1130 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1131)HOLD
 1131 FORMAT('***** NOTE FROM DPDDS2--VARIABLE 1 ',
     1'HAS ALL ELEMENTS = ',E15.7)
      CALL DPWRST('XXX','WRIT')
      GOTO9000
 1139 CONTINUE
C
      IF(NUMVAR.LE.1)GOTO1290
C
      IF(IORDMA.GE.1)GOTO1219
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1211)
 1211 FORMAT('***** ERROR IN DPDDS2--THE NUMBER OF OBSERVATIONS ',
     1'FOR VARIABLE 2 IS NON-POSITIVE')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1212)IORDMA
 1212 FORMAT('SAMPLE SIZE = ',I8)
      CALL DPWRST('XXX','WRIT')
      IERROR='YES'
      GOTO9000
 1219 CONTINUE
C
      IF(IORDMA.EQ.1)GOTO1220
      GOTO1229
 1220 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1221)
 1221 FORMAT('***** NOTE FROM DPDDS2--VARIABLE 2 ',
     1'HAS ONLY 1 ELEMENT')
      CALL DPWRST('XXX','WRIT')
      GOTO9000
 1229 CONTINUE
C
      HOLD=Y2(1)
      DO1235I=2,IORDMA
      IF(Y2(I).NE.HOLD)GOTO1239
 1235 CONTINUE
 1230 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,1231)HOLD
 1231 FORMAT('***** NOTE FROM DPDDS2--VARIABLE 2 ',
     1'HAS ALL ELEMENTS = ',E15.7)
      CALL DPWRST('XXX','WRIT')
      GOTO9000
 1239 CONTINUE
C
 1290 CONTINUE
C
C               ************************************
C               **   STEP 21--                    **
C               **   BRANCH DEPENDING ON WHETHER  **
C               **   1-SAMPLE DDS ANALYSIS OR           **
C               **   2-SAMPLE DDS ANALYSIS.             **
C               ************************************
C
      ISTEPN='21'
      IF(IBUGA3.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMVAR.EQ.1)GOTO3100
      GOTO4100
C
C               ***********************************
C               **  STEP 31--                    **
C               **  CARRY OUT CALCULATIONS       **
C               **  FOR A 1-SAMPLE DDS ANALYSIS  **
C               ***********************************
C
 3100 CONTINUE
C
      ISTEPN='31'
      IF(IBUGA3.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC APRIL 1996.  ADD XDDS, YDDS, AT TO ARGUMENT LIST.
      CALL DPDDS3(Y1,N1,IORDAR,IORDMA,DELTAT,NUMVAR,ILOCV,
CCCCC1XTEMP1,XTEMP2,MAXNXT,PRED2,RES2,RESSD,RESDF,IBUGA3,IERROR)
     1XTEMP1,XTEMP2,XDDS,YDDS,AT,MAXNXT,PRED2,RES2,RESSD,RESDF,
     1IBUGA3,IERROR)
C
 4100 CONTINUE
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGA3.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPDDS2--')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,9012)N,IBUGA3,IERROR
 9012 FORMAT('N,IBUGA3,IERROR = ',I8,2X,A4,2X,A4)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,9013)DELTAT,NUMVAR,ILOCV
 9013 FORMAT('DELTAT,NUMVAR,ILOCV = ',E15.7,I8,I8)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,9015)N1
 9015 FORMAT('N1 = ',I8)
      CALL DPWRST('XXX','WRIT')
      DO9016I=1,N1
      WRITE(ICOUT,9017)I,Y1(I)
 9017 FORMAT('I,Y1(I) = ',I8,E15.7)
      CALL DPWRST('XXX','WRIT')
 9016 CONTINUE
      WRITE(ICOUT,9025)IORDMA
 9025 FORMAT('IORDMA = ',I8)
      CALL DPWRST('XXX','WRIT')
      DO9026I=1,IORDMA
      WRITE(ICOUT,9027)I,Y2(I)
 9027 FORMAT('I,Y2(I) = ',I8,E15.7)
      CALL DPWRST('XXX','WRIT')
 9026 CONTINUE
 9090 CONTINUE
C
      RETURN
      END

      SUBROUTINE WIINWS(IERASE)
C
C     PURPOSE--INITIALIZE THE WINDOW SYSTEM
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IERASE
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'INWS')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIINWS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IERASE,IWERIN
   55 FORMAT('IERASE,IWERIN = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWERIN=IERASE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 8-45          **
C               ************************************************
C
 1100 CONTINUE
      CALL SHINIT(' ')
      IF(IERASE.EQ.'ON')CALL CLSCRN
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'INWS')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIINWS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IERASE,IWERIN
 9015 FORMAT('IERASE,IWERIN = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIEXWS(IERASE)
C
C     PURPOSE--EXIT FROM THE WINDOW SYSTEM
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IERASE
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'INIT')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIEXWS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IERASE,IWEREX
   55 FORMAT('IERASE,IWEREX = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWEREX=IERASE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 8-47          **
C               ************************************************
C
 1100 CONTINUE
      IF(IWEREX.EQ.'OFF')CALL SHQUIT(' ')
      IF(IWEREX.EQ.'ON')CALL SHQUIT('C')
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'INIT')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIEXWS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IERASE,IWEREX
 9015 FORMAT('IERASE,IWEREX = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIOPWI
C
C     PURPOSE--OPEN A WINDOW
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'OPWI')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIOPWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW,MAXWIN
   54 FORMAT('IWINCW,MAXWIN = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)IWINBC(IWINCW),IWINFC(IWINCW),IWINCW
   61 FORMAT('IWINBC(IWINCW),IWINFC(IWINCW),IWINCW = ',
     1A4,2X,A4,2X,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,62)IWINFR(IWINCW),IWEROP(IWINCW),WIPOP(IWINCW)
   62 FORMAT('IWINFR(IWINCW),IWEROP(IWINCW),WIPOP(IWINCW) = ',
     1A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,63)IWINX1(IWINCW),IWINY1(IWINCW)
   63 FORMAT('IWINX1(IWINCW),IWINY1(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,64)IWINX2(IWINCW),IWINY2(IWINCW)
   64 FORMAT('IWINX2(IWINCW),IWINY2(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEED BE DONE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-30          **
C               ************************************************
C
 1100 CONTINUE
      IX1=IWINX1(IWINCW)
      IY1=IWINY1(IWINCW)
      IXLEN=IWINXL(IWINCW)
      IYLEN=IWINYL(IWINCW)
      CALL WNOPEN(IX1,IY1,IXLEN,IYLEN)
      WRITE(ICOUT,777)
  777 FORMAT('WNOPEN HAS JUST BEEN CALLED')
      CALL DPWRST('XXX','BUG ')
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'OPWI')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIOPWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW,MAXWIN
 9014 FORMAT('IWINCW,MAXWIN = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX1,IY1,IXLEN,IYLEN
 9015 FORMAT('IX1,IY1,IXLEN,IYLEN = ',4I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)IWINBC(IWINCW),IWINFC(IWINCW),IWINCW
 9021 FORMAT('IWINBC(IWINCW),IWINFC(IWINCW),IWINCW = ',
     1A4,2X,A4,2X,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)IWINFR(IWINCW),IWEROP(IWINCW),WIPOP(IWINCW)
 9022 FORMAT('IWINFR(IWINCW),IWEROP(IWINCW),WIPOP(IWINCW) = ',
     1A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9023)IWINX1(IWINCW),IWINY1(IWINCW)
 9023 FORMAT('IWINX1(IWINCW),IWINY1(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9024)IWINXL(IWINCW),IWINYL(IWINCW)
 9024 FORMAT('IWINXL(IWINCW),IWINYL(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9025)IWINX2(IWINCW),IWINY2(IWINCW)
 9025 FORMAT('IWINX2(IWINCW),IWINY2(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WICLWI(IERASE,IWRPRE)
C
C     PURPOSE--CLOSE A WINDOW
C              (CLEAR?  WRITE PREVIOUS WINDOW?)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IERASE
      CHARACTER*4 IWRPRE
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'CLWI')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WICLWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IERASE,IWRPRE
   55 FORMAT('IERASE,IWRPRE = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)IWEROP(IWINCW),IWINTY(IWINCW)
   56 FORMAT('IWEROP(IWINCW),IWINTY(IWINCW) = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWERCL(IWINCW)=IERASE
      IWWRPR(IWINCW)=IWRPRE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-28          **
C               ************************************************
C
 1100 CONTINUE
      IFLAG=0
      IF(IERASE.EQ.'ON'.OR.IWRPRE.EQ.'ON')IFLAG=1
      CALL WNCLOS(IFLAG)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'CLWI')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WICLWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IERASE,IWRPRE
 9015 FORMAT('IERASE,IWRPRE = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IWEROP(IWINCW),IWINTY(IWINCW)
 9016 FORMAT('IWEROP(IWINCW),IWINTY(IWINCW) = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)IFLAG
 9017 FORMAT('IFLAG = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISEWI(ICURWI)
C
C     PURPOSE--SELECT A WINDOW (TO OPERATE ON)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEWI')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISEWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)ICURWI
   54 FORMAT('ICURWI = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IWINCW
   55 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINCW=ICURWI
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-37          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNSEL(ICURWI)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEWI')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISEWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ICURWI
 9014 FORMAT('ICURWI = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IWINCW
 9015 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISECO(IBCOL,IFCOL)
C
C     PURPOSE--SET THE COLOR FOR A WINDOW
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IBCOL
      CHARACTER*4 IFCOL
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SECO')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISECO--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW,MAXWIN
   54 FORMAT('IWINCW,MAXWIN = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IBCOL,IFCOL,IWINCW
   55 FORMAT('IBCOL,IFCOL,IWINCW = ',A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)IWINBC(IWINCW),IWINFC(IWINCW),IWINCW
   56 FORMAT('IWINBC(IWINCW),IWINFC(IWINCW),IWINCW = ',
     1A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINBC(IWINCW)=IBCOL
      IWINFC(IWINCW)=IFCOL
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-15          **
C               ************************************************
C
 1100 CONTINUE
      CALL COLOR(IFCOL,IBCOL)
      WRITE(ICOUT,777)
  777 FORMAT('COLOR HAS JUST BEEN CALLED')
      CALL DPWRST('XXX','BUG ')
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SECO')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISECO--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW,MAXWIN
 9014 FORMAT('IWINCW,MAXWIN = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IBCOL,IFCOL,IWINCW
 9015 FORMAT('IBCOL,IFCOL,IWINCW = ',A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IWINBC(IWINCW),IWINFC(IWINCW),IWINCW
 9016 FORMAT('IWINBC(IWINCW),IWINFC(IWINCW),IWINCW = ',
     1A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISETY(ITYPE)
C
C     PURPOSE--SET THE FRAME (ON/OFF) FOR A WINDOW
C              FOR OTG INTERACTER WINDOW WYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IERASE
      CHARACTER*4 ITYPE
      CHARACTER*4 IFRAME
C
      CHARACTER*4 IC4
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
      IC4='XXXX'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SETY')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISETY--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)ITYPE
   55 FORMAT('ITYPE = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)IWEROP(IWINCW)
   57 FORMAT('IWEROP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,58)WIPOP(IWINCW)
   58 FORMAT('WIPOP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IWINFR(IWINCW)
   59 FORMAT('IWINFR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      WIPOP(IWINCW)=ITYPE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-27          **
C               ************************************************
C
 1100 CONTINUE
      IERASE=IWEROP(IWINCW)
      IFRAME=IWINFR(IWINCW)
      IC4='    '
      IF(IERASE.EQ.'ON')IC4(1:1)='C'
      IF(ITYPE.EQ.'POP')IC4(2:2)='P'
      IF(IFRAME.EQ.'ON')IC4(3:3)='F'
      CALL WNACTN(IC4)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SETY')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISETY--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)ITYPE
 9015 FORMAT('ITYPE = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)IWEROP(IWINCW)
 9017 FORMAT('IWEROP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)WIPOP(IWINCW)
 9018 FORMAT('WIPOP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9019)IWINFR(IWINCW)
 9019 FORMAT('IWINFR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)IC4
 9021 FORMAT('IC4 = ',A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISEFR(IFRAME)
C
C     PURPOSE--SET THE FRAME (ON/OFF) FOR A WINDOW
C              FOR OTG INTERACTER WINDOW WYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IERASE
      CHARACTER*4 ITYPE
      CHARACTER*4 IFRAME
C
      CHARACTER*4 IC4
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEFR')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISEFR--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IFRAME
   55 FORMAT('IFRAME = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)IWEROP(IWINCW)
   57 FORMAT('IWEROP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,58)WIPOP(IWINCW)
   58 FORMAT('WIPOP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IWINFR(IWINCW)
   59 FORMAT('IWINFR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINFR(IWINCW)=IFRAME
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-27          **
C               ************************************************
C
 1100 CONTINUE
      IERASE=IWEROP(IWINCW)
      ITYPE=WIPOP(IWINCW)
      IC4='    '
      IF(IERASE.EQ.'ON')IC4(1:1)='C'
      IF(ITYPE.EQ.'POP')IC4(2:2)='P'
      IF(IFRAME.EQ.'ON')IC4(3:3)='F'
      CALL WNACTN(IC4)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEFR')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISEFR--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IFRAME
 9015 FORMAT('IFRAME = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)IWEROP(IWINCW)
 9017 FORMAT('IWEROP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)WIPOP(IWINCW)
 9018 FORMAT('WIPOP(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9019)IWINFR(IWINCW)
 9019 FORMAT('IWINFR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)IC4
 9021 FORMAT('IC4 = ',A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISEWR(IWRAP)
C
C     PURPOSE--SET THE WITHIN-WINDOW TEXT WRAP ATTRIBUTE
C              (OFF = NO WRAP        ON = WRAP)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IWRAP
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEWR')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISEWR--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IWRAP,IWINCW
   55 FORMAT('IWRAP,IWINCW = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)IWINWR(IWINCW)
   56 FORMAT('IWINWR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINWR(IWINCW)=IWRAP
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-15          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNWRAP(IWRAP)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SEWR')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISEWR--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IWRAP,IWINCW
 9015 FORMAT('IWRAP,IWINCW = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IWINWR(IWINCW)
 9016 FORMAT('IWINWR(IWINCW) = ',A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISELS(IX1,IY1,IXLEN,IYLEN)
C
C     PURPOSE--SET THE LOCATION AND SIZE OF A WINDOW
C              (IX1,IY1) IXLEN,IYLEN
C             WHERE (1,1) IS TOP/LEFT POINT ON THE SCREEN
C             AND SCREEN IS 80 COLUMNS WIDE AND 24 LINES DOWN
C             FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SELS')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISELS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IX1,IY1,IXLEN,IYLEN
   55 FORMAT('IX1,IY1,IXLEN,IYLEN = ',4I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)IWINX1(IWINCW),IWINY1(IWINCW)
   56 FORMAT('IWINX1(IWINCW),IWINY1(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)IWINXL(IWINCW),IWINYL(IWINCW)
   57 FORMAT('IWINXL(IWINCW),IWINYL(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,58)IWINX2(IWINCW),IWINY2(IWINCW)
   58 FORMAT('IWINX2(IWINCW),IWINY2(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)IERRWI='YES'
      IF(IWINCW.LE.0.OR.IWINCW.GE.MAXWIN)GOTO9000
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINX1(IWINCW)=IX1
      IWINY1(IWINCW)=IY1
      IWINXL(IWINCW)=IXLEN
      IWINYL(IWINCW)=IYLEN
      IX2=IX1+IXLEN-1
      IY2=IY1+IYLEN-1
      IWINX2(IWINCW)=IX2
      IWINY2(IWINCW)=IY2
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-30          **
C               **  (NO ACTION DONE UNTIL WNOPEN(.) COMMAND   **
C               ************************************************
C
 1100 CONTINUE
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SELS')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISELS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX1,IY1,IXLEN,IYLEN,IX2,IY2
 9015 FORMAT('IX1,IY1,IXLEN,IYLEN,IX2,IY2 = ',6I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IWINX1(IWINCW),IWINY1(IWINCW)
 9016 FORMAT('IWINX1(IWINCW),IWINY1(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)IWINXL(IWINCW),IWINYL(IWINCW)
 9017 FORMAT('IWINXL(IWINCW),IWINYL(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)IWINX2(IWINCW),IWINY2(IWINCW)
 9018 FORMAT('IWINX2(IWINCW),IWINY2(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIERWI
C
C     PURPOSE--ERASE (= CLEAR) CURRENT WINDOW
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'ERWI')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIERWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEED BE DONE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-28          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNCLR
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'ERWI')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIERWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIMOHO
C
C     PURPOSE--MOVE TO HOME POSITION (= UPPER LEFT) OF CURRENT WINDOW
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MOHO')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIMOHO--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEED BE DONE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNHOME
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MOHO')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIMOHO--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIMOCU(IX,IY)
C
C     PURPOSE--MOVE WINDOW CURSOR TO (IX,IY)
C              (WHERE (1,1) IS THE UPPER LEFT OF THE WINDOW)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MOCU')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIMOCU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IX,IY
   55 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)IWINXC(IWINCW),IWINYC(IWINCW)
   56 FORMAT('IWINXC(IWINCW),IWINYC(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
      IWINXC(IWINCW)=IX
      IWINYC(IWINCW)=IY
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNCUXY(IX,IY)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MOCU')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIMOCU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX,IY
 9015 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IWINXC(IWINCW),IWINYC(IWINCW)
 9016 FORMAT('IWINXC(IWINCW),IWINYC(IWINCW) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIMWST(IX,IY,ISTRIN,NSTRIN)
C
C     PURPOSE--MOVE TO (IX,IY) WITHIN A WINDOW
C              AND WRITE NSTRIN CHARACTERS
C              OF THE STRING ISTRIN
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*80 ISTRIN
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWST')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIMWST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IX,IY
   55 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)NSTRIN
   56 FORMAT('NSTRIN = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)(ISTRIN(I:I),I=1,NSTRIN)
   57 FORMAT('ISTRIN = ',80A1)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEEDED
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNOUSX(IX,IY,ISTRIN(1:NSTRIN))
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWST')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIMWST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX,IY
 9015 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)NSTRIN
 9016 FORMAT('NSTRIN = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)(ISTRIN(I:I),I=1,NSTRIN)
 9017 FORMAT('ISTRIN = ',80A1)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIMWIN(IX,IY,IVALUE,NVALUE)
C
C     PURPOSE--MOVE TO (IX,IY) WITHIN A WINDOW
C              AND WRITE OUT THE INTEGER    IVALUE
C              WITH AN I-NVALUE FORMAT (E.G., I1,I2,I3,...)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWIN')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIMWIN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IX,IY
   55 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)NVALUE
   56 FORMAT('NVALUE = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)IVALUE
   57 FORMAT('IVALUE = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEEDED
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29 AND 5-34 **
C               ************************************************
C
 1100 CONTINUE
 
      CALL WNCUXY(IX,IY)
      CALL WNOUIN(IVALUE,NVALUE)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWIN')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIMWIN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX,IY
 9015 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)NVALUE
 9016 FORMAT('NVALUE = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)IVALUE
 9017 FORMAT('IVALUE = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIMWRE(IX,IY,VALUE,ICFORM,NCFORM)
C
C     PURPOSE--MOVE TO (IX,IY) WITHIN A WINDOW
C              AND WRITE OUT THE REAL    VALUE
C              WITH A F FORMAT AS DEFINED BY THE FIRST NCFORM
C              CHARACTERS OF THE STRING ICFORM
C              (WITH FIRST AND LAST CHARACTERS BEING ( AND ))
C              (E.G., (F6.2), (F10.4), ETC.)
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*80 ICFORM
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWRE')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIMWRE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IX,IY
   55 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)NCFORM
   56 FORMAT('NCFORM = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)(ICFORM(I:I),I=1,NCFORM)
   57 FORMAT('ICFORM = ',80A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,58)VALUE
   58 FORMAT('VALUE = ',E15.7)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEED BE DONE
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29 AND 5-35 **
C               ************************************************
C
 1100 CONTINUE
      CALL WNCUXY(IX,IY)
      CALL WNOURE(VALUE,ICFORM(1:NCFORM))
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'MWRE')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIMWRE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IX,IY
 9015 FORMAT('IX,IY = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)NCFORM
 9016 FORMAT('NCFORM = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)(ICFORM(I:I),I=1,NCFORM)
 9017 FORMAT('ICFORM = ',80A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)VALUE
 9018 FORMAT('VALUE = ',E15.7)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WIREST(ISTRIN,NSTRIN)
C
C     PURPOSE--READ A STRING (ISTRIN) WITHIN A WINDOW
C              AND REPORT NUMBER OF ENTERED CHARACTERS (NSTRIN).
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*80 ISTRIN
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
      ISTRIN=' '
      NSTRIN=(-999)
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'REST')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WIREST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)NSTRIN
   56 FORMAT('NSTRIN = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NSTRIN.GE.1)WRITE(ICOUT,57)(ISTRIN(I:I),I=1,NSTRIN)
   57 FORMAT('ISTRIN = ',80A1)
      IF(NSTRIN.GE.1)CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     NO COPYING NEEDED
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-29          **
C               ************************************************
C
 1100 CONTINUE
      CALL INSTR(ISTRIN,NSTRIN)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'REST')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WIREST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)NSTRIN
 9016 FORMAT('NSTRIN = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NSTRIN.GE.1)WRITE(ICOUT,9017)(ISTRIN(I:I),I=1,NSTRIN)
 9017 FORMAT('ISTRIN = ',80A1)
      IF(NSTRIN.GE.1)CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WISCWI(IDIR,NUMLIN)
C
C     PURPOSE--SCROLL WINDOW CONTENTS UP/DOWN BY NUMLIN LINES
C              FOR OTG INTERACTER WINDOW SYSTEM
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION --AUGUST      1990
C
C-----NON-COMMON VARIABLES-----------------------------
C
      CHARACTER*4 IDIR
C
C-----COMMON (FOR WINDOW SYSTEM)-----------------------------
C
      INCLUDE 'DPCOWI.INC'
      INCLUDE 'DPCOHO.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRWI='NO'
C
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SCWI')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF WISCWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGWI,ISUBWI,IERRWI
   52 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IWINSY,IHOST1,IHOST2
   53 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)IWINCW
   54 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)IDIR
   55 FORMAT('IDIR = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)NUMLIN
   56 FORMAT('NUMLIN = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  COPY OVER THE TEMPORARY INPUT VARIABLES     **
C               **  INTO PERMANENT COMMON VARIABLES             **
C               **************************************************
C
C     COPYING NOT NEEDED
C
C               ************************************************
C               **  STEP 11--                                 **
C               **  TREAT THE OTG (UNIV. OF SALFORD) SYSTEM   **
C               **  OTG INTERACTOR MANUAL, PAGE 5-36          **
C               ************************************************
C
 1100 CONTINUE
      CALL WNSCRL(IDIR,NUMLIN)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWI.EQ.'OFF'.AND.ISUBWI.NE.'SCWI')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF WISCWI--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGWI,ISUBWI,IERRWI
 9012 FORMAT('IBUGWI,ISUBWI,IERRWI = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IWINSY,IHOST1,IHOST2
 9013 FORMAT('IWINSY,IHOST1,IHOST2 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)IWINCW
 9014 FORMAT('IWINCW = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)IDIR
 9015 FORMAT('IDIR = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)NUMLIN
 9016 FORMAT('NUMLIN = ',I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE WNCLR
      RETURN
      END
      SUBROUTINE WNSEL(IN)
      RETURN
      END
      SUBROUTINE SHQUIT(IA)
      CHARACTER*(*) IA
      RETURN
      END
      SUBROUTINE WNHOME
      RETURN
      END
      SUBROUTINE WNWRAP(IA)
      CHARACTER*(*) IA
      RETURN
      END
      SUBROUTINE WNOUSX(IN1,IN2,IA)
      CHARACTER*(*) IA
      RETURN
      END
      SUBROUTINE WNACTN(IA)
      CHARACTER*(*) IA
      RETURN
      END
      SUBROUTINE COLOR(IA1,IA2)
      CHARACTER*(*) IA1, IA2
      RETURN
      END
      SUBROUTINE INSTR(IA1,LENGTH)
      CHARACTER*(*) IA1
      RETURN
      END
      SUBROUTINE WNSCRL(IA1,LENGTH)
      CHARACTER*(*) IA1
      RETURN
      END
      SUBROUTINE SHINIT(IA1)
      CHARACTER*(*) IA1
      RETURN
      END
      SUBROUTINE CLSCRN
      RETURN
      END
      SUBROUTINE WNOURE(VALUE,IA1)
      CHARACTER*(*) IA1
      RETURN
      END
      SUBROUTINE WNCUXY(IX,IY)
      RETURN
      END
      SUBROUTINE WNOUIN(IVALUE,NVALUE)
      RETURN
      END

      LOGICAL(4) FUNCTION INITIALSETTINGS()
C
C  MARCH 2002: ADD "-true" OPTION TO SPECIFY TRUE COLOR MODE
C  OCTOBER 2002: ADD "-tile" OPTION TO SPECIFY THAT TEXT AND GRAPHICS
C                WINDOWS WILL BE TILED.
C
      USE DFWIN
      USE DFLIB
      INTEGER*2 I, ISTATUS
CCCCC LOGICAL(4) RESULT
      TYPE (QWINFO) QWI
      CHARACTER*80 BUF
      TYPE (WINDOWCONFIG) DPSCREEN
      CHARACTER*4 QWSCRN
      COMMON/QUICKWN/DPSCREEN,QWSCRN,IQWNFT,IQWNFN
      CHARACTER*4 IECHO
      CHARACTER*80 FTEMP
      COMMON/QUICKW2/IECHO,FTEMP
      COMMON/QUICKW3/NCFTMP
      CHARACTER*4 IQWNTL
      COMMON/QUICKW4/IQWNTL
C
      CHARACTER*4 IQWNFC
      CHARACTER*4 IQWNCL
      CHARACTER*80 IQWNFZ
      CHARACTER*4 IQWNPF
      CHARACTER*4 IQWNPM
      CHARACTER*4 IQWNTC
      COMMON/CQWNCP/IQWNFC,IQWNCL,IQWNFZ,IQWNPF,IQWNTC,IQWNPM(255)
C
CCCCC MAY 2001.  EXTRACT FILE NAME AND ECHO ARGUMENTS OFF COMMAND
CCCCC LINE FOR PROCESSING IN CKCLAR ROUTINE
C
C  SET DEFAULT SIZE OF FRAME WINDOW
C
      QWI.X = 0
      QWI.Y = 0
      QWI.W = 630
      QWI.H = 460
      QWI.TYPE = QWIN$SET
      QWSCRN='VGA'
      NUM=NARGS()
      IECHO='    '
      FTEMP=' '
      NCFTMP=0
      IQWNCL='VGA '
      IQWNTL='OFF'
      IF(NUM.GT.1)THEN
        DO10I=1,NUM
          CALL GETARG(I,BUF,ISTATUS)
          IF(ISTATUS.GE.2 .AND. BUF(1:2).EQ.'-W' .OR.
     &       BUF(1:2).EQ.'-w')THEN
            READ(BUF(3:ISTATUS),'(I4.4)',ERR=19) QWI.W
          ELSEIF(ISTATUS.GE.2 .AND. BUF(1:2).EQ.'-H' .OR.
     &       BUF(1:2).EQ.'-h')THEN
            READ(BUF(3:ISTATUS),'(I4.4)',ERR=19) QWI.H
          ELSEIF(ISTATUS.GE.5 .AND. BUF(1:5).EQ.'-SVGA' .OR.
     &           BUF(1:5).EQ.'-svga')THEN
            QWI.W = 950
            QWI.H = 700
            QWSCRN='SVGA'
          ELSEIF(ISTATUS.GE.6 .AND. BUF(1:6).EQ.'-LARGE' .OR.
     &           BUF(1:6).EQ.'-large')THEN
            QWI.W = 1150
            QWI.H = 1000
            QWSCRN='LARG'
          ELSEIF(ISTATUS.GE.9 .AND. BUF(1:9).EQ.'-FILLIBEN' .OR.
     &           BUF(1:9).EQ.'-filliben')THEN
            QWI.W = 1150
            QWI.H = 1000
            QWSCRN='LARG'
            IQWNTL='ON'
          ELSEIF(ISTATUS.GE.5 .AND. BUF(1:5).EQ.'-TILE' .OR.
     &           BUF(1:5).EQ.'-tile')THEN
            IQWNTL='ON'
          ELSEIF(ISTATUS.GE.5 .AND. BUF(1:5).EQ.'-TRUE' .OR.
     &           BUF(1:5).EQ.'-true')THEN
            IQWNCL='RGB'
          ELSEIF(ISTATUS.GE.4 .AND. BUF(1:4).EQ.'ECHO' .OR.
     &           BUF(1:4).EQ.'echo')THEN
            IECHO(1:4)='ECHO'
          ELSE
            IF(ISTATUS.GE.3 .AND. ISTATUS.LE.80)THEN
              NCFTMP=ISTATUS
              FTEMP(1:ISTATUS)=BUF(1:ISTATUS)
            ENDIF
          ENDIF
   10   CONTINUE
   19   CONTINUE
      ENDIF
      I = SetWSizeQQ(QWIN$FRAMEWINDOW, QWI)
CCCCC I = DISPLAYCURSOR($GCURSORON)
      INITIALSETTINGS = .TRUE.
      END FUNCTION INITIALSETTINGS

      SUBROUTINE GDDRAW(IX1,IY1,IX2,IY2,JCOL,JPATT)
      RETURN
      END
      SUBROUTINE GDPOIN(IX,IY,JCOL)
      INTEGER IX(*), IY(*), JCOL
      RETURN
      END
      SUBROUTINE GDCIRC(IX,IY,IRAD,IFILL,JCOL)
      RETURN
      END
      SUBROUTINE GDEND(INAME)
      INTEGER INAME(*)
      RETURN
      END
      SUBROUTINE GDRGFL(IX,IY,NPTS,JCOL)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE GDSECO(INDEX)
      RETURN
      END
      SUBROUTINE GDSEPA(INDEX)
      RETURN
      END
      SUBROUTINE GDTXTV(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE GDTXTH(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE GDINIT(ITYPE)
      INTEGER ITYPE
      WRITE(*,*) ' GD DRIVERS HAVE NOT BEEN INSTALLED AT YOUR SITE'
      WRITE(*,*) ' CONTACT YOUR LOCAL SITE COORDINATER FOR '
      WRITE(*,*) ' MORE INFORMATION'
      RETURN
      END
      SUBROUTINE GDERAS(IX,IY,IBACK,IFILE)
      INTEGER IX(*)
      INTEGER IY(*)
      INTEGER IFILE(*)
      RETURN
      END

      SUBROUTINE EDMAI2(ISOURC,IEDINA,IDPSW)
CCCCC PROGRAM EDMAIN      COMMENTED OUT TO MAKE IT A SUBROUTINE 7/92
CCCCC THE ABOVE     SUBROUTINE   LINE WAS ADDED JULY 1992
CCCCC THE    IDPSW   ARGUMENT (= DATAPLOT SWITCH) WAS ADDED JULY 1993
C
C     PURPOSE--THIS IS THE SUBROUTINE VERSION OF THE MAIN ROUTINE
C              FOR THE EDITOR.  IT IS THE SUBROUTINE VERSION BECAUSE
C              IT MUST BE CALLED BY DATAPLOT.
C              IT DIFFERS ONLY IN THAT--
C                          1) PROGRAM EDMAIN  ==>   SUBROUTINE EDMAI2
C                          2) CALL EXIT(1)    ==>   RETURN
C
C     PURPOSE--THIS IS THE SECONDARY MAIN ROUTINE FOR THE EDITOR
C
C     ORIGINAL VERSION (AS A SEPARATE ROUTINE)--JANUARY 19,1985
C     UPDATED--APRIL  1990  ADD LIST OF UNSET VARAIBLES (FROM IBM-PC)
C     UPDATED--APRIL  1990  DEFINE CPUMIN
C     UPDATED--APRIL  1990  PUT DISK & DIRECTORY FOR HELP, MESS., ETC. FED FILES
C     UPDATED--APRIL  1990  ALLOW    EXRR FILE.EXT   PLUS OLD   EXRR
C     UPDATED--APRIL  1990  EXTEND OLD   EXRR (NO ARGS)   TO    EXRR FILE.EXT
C     UPDATED--APRIL  1990  ZX COMMANDS = CALL ZX. COMMANDS
C     UPDATED--MARCH  1991  ADD BYTE NUMBER TO STATUS
C     UPDATED--MARCH  1991  \EDITOR CHANGED TO \FED   FOR I/O
C     UPDATED--JULY   1992  STOP SWITCH SO EXIT FROM EDMAIN
C     UPDATED--JULY   1992  FIX    ER   INFINITE LOOP PROBLEM
C     UPDATED--AUGUST 1992  MODIFY FILE NAMES FOR PORTABILITY
C     UPDATED--AUGUST 1992  RENAME TO AVOID DATAPLOT CONFLICTS
C                              MAXCHA => MAXEDC
C                              MAXLIN => MAXEDL
C                              MAXCOM => MAXCMN
C     UPDATED--APRIL  1993  DEFINE IMASK (WAS DONE IN EDINIT)
C     UPDATED--APRIL  1993  DEFINE UNIX FILES
C     UPDATED--MAY    1993  GUI/MENU
C     UPDATED--JULY   1993  DEFINE IRD, IPR, ETC.
C                           ONLY IF STAND-ALONE FED
C     UPDATED--JULY   1993  DEFINE NON-PRINTING ASCII CHARACTERS
C                           ONLY IF STAND-ALONE FED
C     UPDATED--JULY   1993  DEFINE HOST
C                           ONLY IF STAND-ALONE FED
C     UPDATED--AUGUST 1993  COMPILE ERROR ON RS-6000
C
C---------------------------------------------------------------------
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED JULY 1992
      CHARACTER*4 ISOURC
      CHARACTER*80 IEDINA
CCCCC THE FOLLOWING LINE WAS ADDED    JULY 1993
      CHARACTER*4 IDPSW
C
      CHARACTER*80 IFILE
      CHARACTER*12 ISTAT
      CHARACTER*12 IFORM
      CHARACTER*12 IACCES
      CHARACTER*12 IREWR
      CHARACTER*4 ISUBN0
      CHARACTER*4 IERRFI
      CHARACTER*4 IENDFI
      CHARACTER*4 IREWIN
C
      CHARACTER*4 ID
      CHARACTER*4 IHNAME
      CHARACTER*4 IHNAM2
      CHARACTER*4 IUSE
      CHARACTER*12 ITEMP
C
      CHARACTER*4 IEOF
      CHARACTER*4 ILCSW
      CHARACTER*1 IANS0
      CHARACTER*1 IANSV
C
      CHARACTER*4 IBLASW
C
      CHARACTER*4 IEXEIM
C
      CHARACTER*240 ICTEMP
C
      CHARACTER*10 ICSEQN
C
      CHARACTER*4 IERASW
C
      CHARACTER*4 IMANUF
      CHARACTER*4 IMODEL
C
      CHARACTER*4 IHARLC
      CHARACTER*4 IHARL2
C
      CHARACTER*4 IEXESL
      CHARACTER*4 IEXIST
C
CCCCC THE FOLLOWING LINE WAS ADDED APRIL 1990
      CHARACTER*4 ICJUNK
C
CCCCC THE FOLLOWING 5 LINES WERE ADDED MAY 1990
      CHARACTER*80 ITEMNA
      CHARACTER*12 ITEMST
      CHARACTER*12 ITEMFO
      CHARACTER*12 ITEMAC
      CHARACTER*12 ITEMRW
C
CCCCC THE FOLLOWING LINE WAS ADDED JULY 1992
      CHARACTER*4 STOPSW
C
CCCCC THE FOLLOWING 3 LINES WERE ADDED AUGUST 1992
      CHARACTER*6 INAME
      CHARACTER*4 IBUGIN
CCCCC OCTOBER 1993.  FOLLOWING IS DECLARED IN EDCOMM.INC
CCCCC CHARACTER*80 IEDDIR
      CHARACTER*80 IEDDI2
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED (FOR GUI/MENU)    MAY 1993
      CHARACTER*80 IB
      CHARACTER*80 STRING
CCCCC AUGUST 1993.  ADD FOLLOWING TO AVOID COMPILE ERROR
      CHARACTER*4 IMODE1
      CHARACTER*4 IMODE2
      CHARACTER*4 ISITE1
      CHARACTER*4 ISITE2
CCCCC END CHANGE
C
      DIMENSION IHNAME(100)
      DIMENSION IHNAM2(100)
      DIMENSION IUSE(100)
      DIMENSION IVALUE(100)
      DIMENSION VALUE(100)
C
      DIMENSION IANS0(240)
      DIMENSION IANSV(240)
C
      DIMENSION IHARLC(100)
      DIMENSION IHARL2(100)
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
C-----COMMON VARIABLES (EDITING)-----------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCOHO.INC'
      INCLUDE 'DPCONP.INC'
      INCLUDE 'EDCOMM.INC'
CCCCC THE FOLLOWING LINE WAS ADDED (FOR MENU/GUI)   MAY 1993
      INCLUDE 'DPCODV.INC'
C
C-----COMMON VARIABLES (GENERAL)-----------------------------------------------
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
C
C-----START POINT-------------------------------------------
C
      ISUBN1='EDMA'
      ISUBN2='I2  '
C
CCCCC THE FOLLOWING SECTION OF SETTINGS WERE ADDED APRIL 1990
CCCCC AS A RESULT OF UNSET VARIABLES AS DETECTED
CCCCC BY THE OTG COMPILER ON MY IBM-PC 386
C
      NUMNAM=0
      NUMINL=0
      MAXINL=0
      MAXCPL=0
      IWIDTH=0
      IPRINT='    '
      IP2LI1=0
      IP2LI1=0
      IMAX=0
      IFLIM1=0
      IFLIM2=0
      ICERAS='    '
      IBLIM1=0
      IBLIM2=0
C
C
      ICOLL1=1
      ICOLL2=50
      IBLASW='YES'
C
      IEXEIM='NO'
C
      IWIDSV=240
C
      IPPLIN=50
      IPPOFF=0
      IERASW='ON'
C
      ILPOFF=0
C
      IEXESL='-999'
      IEXIST='-999'
C
      IPASS=0
C
 1000 CONTINUE
C
CCCCC IF NON-DATAPLOT, THEN DEFINE IRD, IRP, ETC.     JULY 1993
      IF(IDPSW.EQ.'OFF')THEN
         IRD=5
         IPR=6
C
         NUMBPC=8
         NUMCPW=4
         NUMBPW=32
C
         CPUMAX=10.0**15
CCCCC    THE FOLLOWING LINE WAS ADDED APRIL 1990
         CPUMIN=(-CPUMAX)
      ENDIF
C
CCCCC IF NON-DATAPLOT, THEN DEFINE NON-PRINTING ASCII CHAR. JULY 1993
      IF(IDPSW.EQ.'OFF')THEN
         INULC=CHAR(0)
         ISOHC=CHAR(1)
         ISTXC=CHAR(2)
         IETXC=CHAR(3)
         IEOTC=CHAR(4)
         IENQC=CHAR(5)
         IACKC=CHAR(6)
         IBELC=CHAR(7)
         IBSC=CHAR(8)
         IHTC=CHAR(9)
         ILFC=CHAR(10)
         IVTC=CHAR(11)
         IFFC=CHAR(12)
         ICRC=CHAR(13)
         ISOC=CHAR(14)
         ISIC=CHAR(15)
         IDLEC=CHAR(16)
         IDC1C=CHAR(17)
         IDC2C=CHAR(18)
         IDC3C=CHAR(19)
         IDC4C=CHAR(20)
         INAKC=CHAR(21)
         ISYNC=CHAR(22)
         IETBC=CHAR(23)
         ICANC=CHAR(24)
         IEMC=CHAR(25)
         ISUBC=CHAR(26)
         IESCC=CHAR(27)
         IFSC=CHAR(28)
         IGSC=CHAR(29)
         IRSC=CHAR(30)
         IUSC=CHAR(31)
      ENDIF
C
CCCCC IF NON-DATAPLOT, THEN DEFINE THE HOST       JULY 1993
      IF(IDPSW.EQ.'OFF')THEN
         IHOST1='IBM-'
         IHOST2='PC  '
CCCCC    IHOST1='UNIX'
CCCCC    IHOST2='    '
         IMANUF='TEKT'
         IMODEL='4014'
      ENDIF
C
      IF(IDPSW.EQ.'OFF')THEN
         IMODE1=' '
         IMODE2=' '
         IOPSY1=' '
         IOPSY2=' '
         ISITE1=' '
         ISITE2=' '
      ENDIF
C
      CALL EDINIT
C
CCCCC THE FOLLOWING LINE IS DELIBERATEDLY SET AT A DOUBLE BACKSLASH
CCCCC TO ACCOMODATE BOTH NON-UNIX AND UNIX MACHINES.   APRIL 1993
CCCCC IT WILL GENERATE A COMPILER WARNING              APRIL 1993
CCCCC (BUT WILL SUCCESFULLY COMPILE) ON AN IBM-PC.     APRIL 1993
      IMASK='\\'
C
CCCCC AUGUST 1992.  FOLLOWING SECTION MODIFIED.  FOR BETTER PORTABILITY
CCCCC AND EASIER INSTALLATION, DEFINE
CCCCC      EDITOR DIRECTOR    IEDDIR
CCCCC      AND EDITOR PATH NAME   IED
CCCCC      AND EDITOR CASE (PPER/LOWER) IEDCAS
CCCCC      AND EDITRO FILE EXTENSION   IEDEXT
CCCCC INITFO, USE THOSE NAMES HERE TO DEFINE THE FILES.  USE SAME
CCCCC SCHEME AS INITFO.
C
      IBUGIN='OFF'
CCCCC FEBRUARY 1995.  COMMENT OUT FOLLOWING LINE (DONE IN INITFO).
CCCCC FOLLOWING LINE WIPES OUT DEFINITION IN INITFO.
CCCCC DEFINE IEDDI2 TO BE NULL FOR FILES FOUND IN CURRENT DIRECTORY
CCCCC IEDDIR=' '
      IEDDI2=' '
      NCNULL=0
C
CCCCC THE FOLLOWING 6 LINES WERE ADDED MAY 1990
      ITEMNU=20
CCCCC ITEMNA='C:\FED\FEDARG.TEX'
      INAME='FEDARG'
      IF(IEDCAS.EQ.'LOWE')INAME='fedarg'
      NC=6
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,ITEMNA,IBUGIN)
C
      ITEMST='UNKNOWN'
      ITEMFO='FORMATTED'
      ITEMAC='SEQUENTIAL'
      ITEMRW='READONLY'
C
      IORINU=21
      IORINA='-999'
      IORIST='NEW'
      IF(IHOST1.EQ.'HONE')IORIST='UNKNOWN'
      IF(IHOST1.EQ.'PERK')IORIST='UNKNOWN'
      IF(IHOST1.EQ.'NVE')IORIST='UNKNOWN'
      IF(IHOST1.EQ.'205')IORIST='UNKNOWN'
      IF(IHOST1.EQ.'CDC')IORIST='UNKNOWN'
      IF(IHOST1.EQ.'IBM-')IORIST='UNKNOWN'
      IF(IOPSY1.EQ.'UNIX')IORIST='UNKNOWN'
      IORIFO='FORMATTED'
      IORIAC='SEQUENTIAL'
      IORIRW='READWRITE'
C
      ISAVNU=22
CCCCC ISAVNA='EDSAVE.TEX'
      INAME='EDSAVE'
      IF(IEDCAS.EQ.'LOWE')INAME='edsave'
      NC=6
CCCCC CALL INITF2(INAME,NC,IEDDIR,NCNULL,IEDEXT,NCEDT2,ISAVNA,IBUGIN)
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ISAVNA,IBUGIN)
C
CCCCC ISAVST='UNKNOWN'
      ISAVST='NEW'
      IF(IHOST1.EQ.'HONE')ISAVST='UNKNOWN'
      IF(IHOST1.EQ.'PERK')ISAVST='UNKNOWN'
      IF(IHOST1.EQ.'NVE')ISAVST='UNKNOWN'
      IF(IHOST1.EQ.'205')ISAVST='UNKNOWN'
      IF(IHOST1.EQ.'CDC')ISAVST='UNKNOWN'
      IF(IHOST1.EQ.'IBM-')ISAVST='UNKNOWN'
      IF(IOPSY1.EQ.'UNIX')ISAVST='UNKNOWN'
      ISAVFO='FORMATTED'
      ISAVAC='SEQUENTIAL'
      ISAVRW='READWRITE'
C
      IHELNU=23
CCCCC IHELNA='FED$:EDHELP.TEX'
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990 FOR MY IBM-PC 386
CCCCC IF(IHOST1.EQ.'IBM-')IHELNA='EDHELP.TEX'
CCCCC IF(IHOST1.EQ.'IBM-')IHELNA='C:\FED\EDHELP.TEX'
      INAME='EDHELP'
      IF(IEDCAS.EQ.'LOWE')INAME='edhelp'
      NC=6
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,IHELNA,IBUGIN)
C
CCCCC IHELST='UNKNOWN'
      IHELST='OLD'
      IHELFO='FORMATTED'
      IHELAC='SEQUENTIAL'
      IHELRW='READONLY'
C
      ICOPNU=24
CCCCC ICOPNA='EDCOPY.TEX'
      INAME='EDCOPY'
      IF(IEDCAS.EQ.'LOWE')INAME='edcopy'
      NC=6
CCCCC CALL INITF2(INAME,NC,IEDDIR,NCNULL,IEDEXT,NCEDT2,ICOPNA,IBUGIN)
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ICOPNA,IBUGIN)
C
CCCCC ICOPST='UNKNOWN'
      ICOPST='NEW'
      IF(IHOST1.EQ.'HONE')ICOPST='UNKNOWN'
      IF(IHOST1.EQ.'PERK')ICOPST='UNKNOWN'
      IF(IHOST1.EQ.'NVE')ICOPST='UNKNOWN'
      IF(IHOST1.EQ.'205')ICOPST='UNKNOWN'
      IF(IHOST1.EQ.'CDC')ICOPST='UNKNOWN'
      IF(IHOST1.EQ.'IBM-')ICOPST='UNKNOWN'
      IF(IOPSY1.EQ.'UNIX')ICOPST='UNKNOWN'
      ICOPFO='FORMATTED'
      ICOPAC='SEQUENTIAL'
      ICOPRW='READWRITE'
C
      ICOMNU=25
CCCCC ICOMNA='EDCOMM.TEX'
      INAME='EDCOMM'
      IF(IEDCAS.EQ.'LOWE')INAME='edcomm'
      NC=6
CCCCC CALL INITF2(INAME,NC,IEDDIR,NCNULL,IEDEXT,NCEDT2,ICOMNA,IBUGIN)
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ICOMNA,IBUGIN)
C
CCCCC ICOMST='UNKNOWN'
      ICOMST='NEW'
      IF(IHOST1.EQ.'HONE')ICOMST='UNKNOWN'
      IF(IHOST1.EQ.'PERK')ICOMST='UNKNOWN'
      IF(IHOST1.EQ.'NVE')ICOMST='UNKNOWN'
      IF(IHOST1.EQ.'205')ICOMST='UNKNOWN'
      IF(IHOST1.EQ.'CDC')ICOMST='UNKNOWN'
      IF(IHOST1.EQ.'IBM-')ICOMST='UNKNOWN'
      IF(IOPSY1.EQ.'UNIX')ICOMST='UNKNOWN'
      ICOMFO='FORMATTED'
      ICOMAC='SEQUENTIAL'
      ICOMRW='READWRITE'
C
      ICALNU=26
CCCCC ICALNA='EDCALL.TEX'
      INAME='EDCALL'
      IF(IEDCAS.EQ.'LOWE')INAME='edcall'
      NC=6
CCCCC CALL INITF2(INAME,NC,IEDDIR,NCNULL,IEDEXT,NCEDT2,ICALNA,IBUGIN)
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ICALNA,IBUGIN)
C
CCCCC ICALST='UNKNOWN'
      ICALST='OLD'
      ICALFO='FORMATTED'
      ICALAC='SEQUENTIAL'
CCCCC ICALRW='READWRITE'
      ICALRW='READONLY'
C
      IPRINU=27
      IF(IHOST1.EQ.'IBM-')THEN
        IPRINA='PRN'
      ELSE
        IPRINA='PRINT.DAT'
      ENDIF
CCCCC FEBRUARY 1995.  REVERT TO UNKNOWN.  PRINTER OUTPUT WILL BE SENT
CCCCC TO FILE ON NON-PC SYSTEMS.
      IF(IHOST1.EQ.'IBM-')THEN
        IPRIST='OLD'
      ELSE
        IPRIST='UNKNOWN'
      ENDIF
      IPRIFO='FORMATTED'
      IPRIAC='SEQUENTIAL'
      IPRIRW='READWRITE'
C
      ILISNU=28
CCCCC ILISNA='EDLIST.TEX'
      INAME='EDLIST'
      IF(IEDCAS.EQ.'LOWE')INAME='edlist'
      NC=6
CCCCC CALL INITF2(INAME,NC,IEDDIR,NCNULL,IEDEXT,NCEDT2,ILISNA,IBUGIN)
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ILISNA,IBUGIN)
C
CCCCC ILISST='UNKNOWN'
      ILISST='OLD'
      ILISFO='FORMATTED'
      ILISAC='SEQUENTIAL'
      ILISRW='READONLY'
C
      IMESNU=29
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990 FOR MY IBM-PC 386
CCCCC IF(IHOST1.EQ.'IBM-')IMESNA='EDMESS.TEX'
CCCCC IF(IHOST1.EQ.'IBM-')IMESNA='C:\FED\EDMESS.TEX'
      INAME='EDMESS'
      IF(IEDCAS.EQ.'LOWE')INAME='edmess'
      NC=6
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,IMESNA,IBUGIN)
C
CCCCC IMESST='UNKNOWN'
      IMESST='OLD'
      IMESFO='FORMATTED'
      IMESAC='SEQUENTIAL'
      IMESRW='READONLY'
C
      ISYSNU=30
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990 FOR MY IBM-PC 386
CCCCC IF(IHOST1.EQ.'IBM-')ISYSNA='EDSYST.TEX'
CCCCC IF(IHOST1.EQ.'IBM-')ISYSNA='C:\FED\EDSYST.TEX'
      INAME='EDSYST'
      IF(IEDCAS.EQ.'LOWE')INAME='edsyst'
      NC=6
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,ISYSNA,IBUGIN)
C
CCCCC ISYSST='UNKNOWN'
      ISYSST='OLD'
      ISYSFO='FORMATTED'
      ISYSAC='SEQUENTIAL'
      ISYSRW='READONLY'
C
      ILOGNU=31
CCCCC ILOGNA='EDLOGI.TEX'
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990 FOR MY IBM-PC 386
CCCCC IF(IHOST1.EQ.'IBM-')ILOGNA='EDLOGI.TEX'
CCCCC IF(IHOST1.EQ.'IBM-')ILOGNA='C:\FED\EDLOGI.TEX'
      INAME='EDLOGI'
      IF(IEDCAS.EQ.'LOWE')INAME='edlogi'
      NC=6
CCCCC FEBRUARY 1995.  FOR PC, EDLOGI IN FED DIRECTORY.  FOR NON-PC, 
CCCCC GET EDLOGI FROM CURRENT DIRECTORY (TO ALLOW USER TO CHANGE).
      IF(IHOST1.EQ.'IBM-')THEN
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,ILOGNA,IBUGIN)
      ELSE
      CALL INITF2(INAME,NC,IEDDI2,NCNULL,IEDEXT,NCEDT2,ILOGNA,IBUGIN)
      ENDIF
C
CCCCC ILOGST='UNKNOWN'
      ILOGST='OLD'
      ILOGFO='FORMATTED'
      ILOGAC='SEQUENTIAL'
      ILOGRW='READONLY'
C
      INEWNU=32
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990 FOR MY IBM-PC 386
CCCCC IF(IHOST1.EQ.'IBM-')INEWNA='EDNEWS.TEX'
CCCCC IF(IHOST1.EQ.'IBM-')INEWNA='C:\FED\EDNEWS.TEX'
CCCCC IF(IHOST1.EQ.'HONE')INEWNA='ednews.text'
      INAME='EDNEWS'
      IF(IEDCAS.EQ.'LOWE')INAME='ednews'
      NC=6
      CALL INITF2(INAME,NC,IEDDIR,NCEDT1,IEDEXT,NCEDT2,INEWNA,IBUGIN)
C
CCCCC INEWST='UNKNOWN'
      INEWST='OLD'
      INEWFO='FORMATTED'
      INEWAC='SEQUENTIAL'
      INEWRW='READONLY'
C
      IOPENU=33
      IF(IHOST1.EQ.'IBM-')THEN
        IOPENA='PRN'
        IOPEST='OLD'
      ELSE
        IOPENA='PRINT.DAT'
        IOPEST='UNKNOWN'
      END IF
      IOPEFO='FORMATTED'
      IOPEAC='SEQUENTIAL'
      IOPERW='READWRITE'
C
      ICOM='    '
      ICOM2='    '
      ICOMT='-999'
      ICOMI=(-999)
      ACOM=(-999.0)
C
C     ----------
C
      NUMCHA=10
      ICHA(1)='A'
      ICHA(2)='B'
      ICHA(3)='C'
      ICHA(4)='D'
      ICHA(5)='E'
      ICHA(6)='F'
      ICHA(7)='G'
      ICHA(8)='H'
      ICHA(9)='I'
      ICHA(10)='J'
C
      NUMLIN=4
C
      NUMROW=4
      IPOINT(1)=1
      IPOINT(2)=2
      IPOINT(3)=3
      IPOINT(4)=4
C
      ILOCC1(1)=1
      ILOCC1(2)=4
      ILOCC1(3)=6
      ILOCC1(4)=8
C
      NUMCPL(1)=3
      NUMCPL(2)=2
      NUMCPL(3)=2
      NUMCPL(4)=3
C
      ICURLN=1
C
      IEOF='NO'
      IECHSW='OFF'
      ILCSW='OFF'
C
      NUMCOM=0
CCCCC MAXCMN=100   JULY 1993
      DO310I=1,MAXCMN
      ICOM3(I)='    '
      ICOM4(I)='    '
      ICOM5(I)='                              '
      NCOM5(I)=0
  310 CONTINUE
C
C     THE INTEGER VARIABLE ISEQNU IS THE CURRENT SEQUENCE NUMBER
C     THAT IS USED IN THE CHANGE COMMAND
C     TO DO AUTOMATIC SEQUENCING
C     AS IN     LS XXXXXX
C
      ISEQNU=1
      ICSEQN='1         '
      NCSEQN=1
C
      IPRISW='OFF'
C
CCCCC THE FOLLOWING LINE WAS ADDED JULY 1992
C
      STOPSW='NO'
C
C     ----------
C
C               ********************************************************
C               **  STEP 0.5--
C               **  (FOR NBS UNIVAC COMPUTER ONLY)
C               **  HAVE A DUMMY READ OF 1 LINE AFTER THE EDITOR  HEADER
C               **  TO ABSORB AN EXTRANEOUS LINE GENERATED
C               **  BY THE UNIVAC SYSTEM SOFTWARE WHEN FIRST ACCESSING T
C               **  VIA @FED.
C               ********************************************************
C
      IF(IHOST1.EQ.'UNIV')READ(IRD,501)
  501 FORMAT(1X)
C
C               ****************************************************
C               **  STEP 0.6--                                    **
C               **  IF A SIGN-ON MESSAGE FILE                     **
C               **  (CONSISTING OF CURRENT EDITOR   INFORMATION)  **
C               **  EXISTS AT THIS COMPUTER INSTALLATION,         **
C               **  WRITE OUT SUCH MESSAGES FOR THE ANALYST'S     **
C               **  PERUSAL                                       **
C               ****************************************************
C
      ISTEPN='0.6'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IMESST.EQ.'NONE')GOTO690
CCCCC IBUGS2='ON'
      IF(IPASS.LE.1)CALL EDLIME
  690 CONTINUE
C
C               ****************************
C               **  STEP 11--             **
C               **  READ IN BUG SWITCHES  **
C               ****************************
C
CCCCC CALL EDERAS(IMANUF,IMODEL)     AUGUST 14, 1986
C
      IPASS=IPASS+1
      IF(IPASS.GE.2)GOTO1190
C
CCCCC IBUGED='ON'
CCCCC IBUGE2='ON'
CCCCC IBUGE3='ON'
CCCCC IBUGMA='ON'
C
 1190 CONTINUE
C
C               **************************************
C               **  STEP 12--                       **
C               **  READ IN FILE NAME TO BE EDITED  **
C               **  AND DETERMINE STATUS OF FILE    **
C               **************************************
C
CCCCC THE FOLLOWING SECTION WAS REWRITTEN JULY 1992
CCCCC NUMCFI=80
CCCCC IF(IHOST1.EQ.'VAX')GOTO1220
CCCCC GOTO1223
C
C1220 CONTINUE
CCCCC IF(IHOST1.EQ.'VAX'.AND.IPASS.EQ.1)CALL EDGETF(IORINA)
CCCCC IF(IPASS.EQ.1)GOTO1229
CCCCC WRITE(ICOUT,1221)
C1221 FORMAT('NAME OF FILE TO BE EDITED = ?')
CCCCC READ(IRD,1222)IORINA
C1222 FORMAT(A80)
CCCCC GOTO1229
C
      NUMCFI=80
C
      IF(IHOST1.EQ.'VAX')THEN
         IF(IPASS.EQ.1)THEN
            CALL EDGETF(IORINA)
            GOTO1229
         ENDIF
         WRITE(ICOUT,1221)
 1221    FORMAT('NAME OF FILE TO BE EDITED = ?')
         CALL EDWRST('EDMAI2')
         READ(IRD,1222)IORINA
 1222    FORMAT(A80)
         GOTO1229
      ENDIF
C
CCCCC THE FOLLOWING SECTION IS FOR NON-VAX (ESPECIALLY IBM-PC)
CCCCC THE FOLLOWING SECTION (TO 1229 CONTINUE) WAS CHANGED MAY 1990
CCCCC THE FOLLOWING SECTION WAS CHANGED JULY 1992
C
      IF(ISOURC.EQ.'SUBR')THEN
         IORINA=IEDINA
      ENDIF
C
      IF(ISOURC.EQ.'FILE')THEN
         IOUNIT=ITEMNU
         IFILE=ITEMNA
         ISTAT=ITEMST
         IFORM=ITEMFO
         IACCES=ITEMAC
         IREWR=ITEMRW
         ISUBN0='MAIN'
         IERRFI='NO'
C
         CALL EDINFI(IFILE,IEXIST,ISUBN0,IERRFI)
CCCCC    INQUIRE(FILE=IFILE,EXIST=ILEXIS,IOSTAT=IOS)
         IF(IEXIST.EQ.'YES')GOTO1224
         GOTO1226
C
 1224    CONTINUE
CCCCC    WRITE(ICOUT,777)IEXIST
CC777    FORMAT('IEXIST = ',A4)
         CALL EDOPFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IREWR,ISUBN0,
     1               IERRFI)
         READ(IOUNIT,1225)IORINA
 1225    FORMAT(A80)
CCCCC    WRITE(ICOUT,778)IORINA
CC778    FORMAT('FILE = ',A80)
         CALL EDCLFI(IOUNIT,IENDFI,IREWIN)
         IF(IORINA(1:4).EQ.'    ')GOTO1226
         GOTO1229
 1226    CONTINUE
         WRITE(ICOUT,1227)
 1227    FORMAT('NAME OF FILE TO BE EDITED = ?')
         CALL EDWRST('EDMAI2')
         READ(IRD,1228)IORINA
 1228    FORMAT(A80)
         GOTO1229
      ENDIF
C
 1229 CONTINUE
C
      DO1235I=1,NUMCFI
      IREV=NUMCFI-I+1
      IF(IORINA(IREV:IREV).NE.' ')GOTO1239
 1235 CONTINUE
      IREV=0
 1239 CONTINUE
      NUMCFI=IREV
C
      ITEMP=IORIST
      IORIST='UNKNOWN'
      ID='ORIG'
      CALL EDREFW(ID)
      IORIST=ITEMP
      NUMLOR=NUMLIN
C
CCCCC ID='SAVE'
CCCCC CALL EDWRWF(ID)
C
CCCCC WRITE(ICOUT,1241)IORINA
C1241 FORMAT('FILE              = ',A80)
      WRITE(ICOUT,1241)(IORINA(I:I),I=1,NUMCFI)
 1241 FORMAT('FILE              = ',80A1)
      CALL EDWRST('EDMAI2')
CCCCC WRITE(ICOUT,1242)IORIST
C1242 FORMAT('FILE STATUS       = ',A4)
      WRITE(ICOUT,1243)NUMLIN
 1243 FORMAT('NUMBER OF LINES   = ',I8)
      CALL EDWRST('EDMAI2')
C
CCCCC WRITE(ICOUT,999)
  999 FORMAT(1X)
CCCCC WRITE(ICOUT,1251)
C1251 FORMAT('YOU ARE IN EDIT MODE--')
      WRITE(ICOUT,1251)
 1251 FORMAT('MODE (EDIT/INPUT) = EDIT')
      CALL EDWRST('EDMAI2')
CCCCC WRITE(ICOUT,1252)
C1252 FORMAT('    TO TOGGLE INTO    INPUT MODE, ENTER      INPUT')
CCCCC WRITE(ICOUT,1253)
C1253 FORMAT('    TO TOGGLE BACK TO EDIT  MODE, ENTER      EDIT')
CCCCC WRITE(ICOUT,1254)
C1254 FORMAT('FOR GENERAL ON-LINE ASSISTANCE,   ENTER      HELP')
CCCCC WRITE(ICOUT,999)
C
      NUMARG=0
      CALL EDPRIN
C
C               **********************************************
C               **  STEP 13--                               **
C               **  OPEN THE COMMAND-SAVE (= JOURNAL) FILE  **
C               **********************************************
C
      ISTEPN='13'
      IF(IBUGFI.EQ.'ON'.OR.ISUBRO.EQ.'CALL')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
      IOUNIT=ICOMNU
      IFORM=ICOMFO
      IFILE=ICOMNA
      ISTAT=ICOMST
      IACCES=ICOMAC
      IREWR=ICOMRW
      ISUBN0='MAIN'
      IERRFI='NO'
C
      IF(IORINA.NE.ICOMNA.AND.IORINA.NE.ISAVNA)
     1CALL EDOPFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IREWR,ISUBN0,IERRFI)
C
C               *************************************************************
C               **  STEP 14--                                              **
C               **  GENERATE A COMMAND STATEMENT (AND THEN EXECUTE IT)     **
C               **  WHICH STATES THAT WE SHOULD    CALL EDSYST.TEX         **
C               **  (THIS ALLOWS US TO EXECUTE A SYSTEM "LOGIN" FILE       **
C               **  WHEN SIGNING ONT THE EDITOR WHICH IN TURN ALLOWS       **
C               **  AN IMPLEMENTORTO EASILY TAILOR THE EDITOR              **
C               **  FOR AN INDIVIDUAL SITE).                               **
C               *************************************************************
C
      ISTEPN='14'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
      ICTEMP(1:5)='CALL '
      ICTEMP(6:85)=ISYSNA(1:80)
      NCTEMP=85
      IF(IPASS.LE.1)CALL EDCOST(ICTEMP,NCTEMP)
      IEXEIM='YES'
      IEXESL='YES'
      GOTO2300
C
C               *************************************************************
C               **  STEP 15--                                              **
C               **  GENERATE A COMMAND STATEMENT (AND THEN EXECUTE IT)     **
C               **  WHICH STATES THAT WE SHOULD    CALL EDLOGI.TEX         **
C               **  (THIS ALLOWS US TO EXECUTE A USER "LOGIN" FILE         **
C               **  WHEN SIGNING ONTO THE EDITOR WHICH IN TURN ALLOWS      **
C               **  A USER TO EASILY TAILOR THE EDITOR                     **
C               *************************************************************
C
 1500 CONTINUE
      ISTEPN='15'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
      IOUNIT=ILOGNU
      IFORM=ILOGFO
      IFILE=ILOGNA
      ISTAT=ILOGST
      IACCES=ILOGAC
      IREWR=ILOGRW
      ISUBN0='MAIN'
      IERRFI='NO'
C
      CALL EDINFI(IFILE,IEXIST,ISUBN0,IERRFI)
      IF(IERRFI.EQ.'YES')GOTO1590
      IF(IEXIST.EQ.'NO')GOTO1590
C
      ICTEMP(1:5)='CALL '
      ICTEMP(6:85)=ILOGNA(1:80)
      NCTEMP=85
      IF(IPASS.LE.1)CALL EDCOST(ICTEMP,NCTEMP)
      IEXEIM='YES'
      GOTO2300
C
 1590 CONTINUE
C
C               **************************
C               **  STEP 21--           **
C               **  WRITE OUT A PROMPT  **
C               **************************
C
 2100 CONTINUE
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')THEN
         WRITE(ICOUT,999)
         CALL EDWRST('EDMAI2')
         WRITE(ICOUT,2101)
 2101    FORMAT('----------START OF NEW CYCLE----------')
         CALL EDWRST('EDMAI2')
      ENDIF
C
      ISTEPN='21'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')THEN
         WRITE(ICOUT,2102)ICCALL,ICXQT,ILCSW,IEOF,IPROSW
 2102    FORMAT('ICCALL,ICXQT,ILCSW,IEOF,IPROSW = ',
     1   A4,2X,A4,2X,A4,2X,A4,2X,A4)
         CALL EDWRST('EDMAI2')
      ENDIF
C
CCCCC IPRISW='OFF'
      IALL='OFF'
      IEOF='NO'
C
      IF(ICCALL.EQ.'ON')GOTO2190
C
      IF(IPROSW.EQ.'ON')GOTO2110
      GOTO2190
C
 2110 CONTINUE
      IF(IMODE.EQ.'EDIT')GOTO2120
      GOTO2140
C
 2120 CONTINUE
      IF(IHOST1.EQ.'VAX ')GOTO2130
      IF(0.LE.ICURLN.AND.ICURLN.LE.9)THEN
         WRITE(ICOUT,2121)ICURLN
 2121    FORMAT(5X,I1,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10.LE.ICURLN.AND.ICURLN.LE.99)THEN
         WRITE(ICOUT,2122)ICURLN
 2122    FORMAT(4X,I2,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(100.LE.ICURLN.AND.ICURLN.LE.999)THEN
         WRITE(ICOUT,2123)ICURLN
 2123    FORMAT(3X,I3,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(1000.LE.ICURLN.AND.ICURLN.LE.9999)THEN
         WRITE(ICOUT,2124)ICURLN
 2124    FORMAT(2X,I4,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10000.LE.ICURLN.AND.ICURLN.LE.99999)THEN
         WRITE(ICOUT,2125)ICURLN
 2125    FORMAT(1X,I5,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      GOTO2190
C
 2130 CONTINUE
      IF(0.LE.ICURLN.AND.ICURLN.LE.9)THEN
         WRITE(ICOUT,2131)ICURLN
 2131    FORMAT(5X,I1,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10.LE.ICURLN.AND.ICURLN.LE.99)THEN
         WRITE(ICOUT,2132)ICURLN
 2132    FORMAT(4X,I2,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(100.LE.ICURLN.AND.ICURLN.LE.999)THEN
         WRITE(ICOUT,2133)ICURLN
 2133    FORMAT(3X,I3,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(1000.LE.ICURLN.AND.ICURLN.LE.9999)THEN
         WRITE(ICOUT,2134)ICURLN
 2134    FORMAT(2X,I4,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10000.LE.ICURLN.AND.ICURLN.LE.99999)THEN
         WRITE(ICOUT,2135)ICURLN
 2135    FORMAT(1X,I5,'> ')
         CALL EDWRST('EDMAI2')
      ENDIF
      GOTO2190
C
 2140 CONTINUE
      ICURLP=ICURLN+1
      IF(IHOST1.EQ.'VAX ')GOTO2140
      IF(0.LE.ICURLP.AND.ICURLP.LE.9)THEN
         WRITE(ICOUT,2141)ICURLP
 2141    FORMAT(5X,I1,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10.LE.ICURLP.AND.ICURLP.LE.99)THEN
         WRITE(ICOUT,2142)ICURLP
 2142    FORMAT(4X,I2,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(100.LE.ICURLP.AND.ICURLP.LE.999)THEN
         WRITE(ICOUT,2143)ICURLP
 2143    FORMAT(3X,I3,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(1000.LE.ICURLP.AND.ICURLP.LE.9999)THEN
         WRITE(ICOUT,2144)ICURLP
 2144    FORMAT(2X,I4,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10000.LE.ICURLP.AND.ICURLP.LE.99999)THEN
         WRITE(ICOUT,2145)ICURLP
 2145    FORMAT(1X,I5,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      GOTO2190
 
C
 2150 CONTINUE
      IF(0.LE.ICURLP.AND.ICURLP.LE.9)THEN
         WRITE(ICOUT,2151)ICURLP
 2151    FORMAT(5X,I1,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10.LE.ICURLP.AND.ICURLP.LE.99)THEN
         WRITE(ICOUT,2152)ICURLP
 2152    FORMAT(4X,I2,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(100.LE.ICURLP.AND.ICURLP.LE.999)THEN
         WRITE(ICOUT,2153)ICURLP
 2153    FORMAT(3X,I3,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(1000.LE.ICURLP.AND.ICURLP.LE.9999)THEN
         WRITE(ICOUT,2154)ICURLP
 2154    FORMAT(2X,I4,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      IF(10000.LE.ICURLP.AND.ICURLP.LE.99999)THEN
         WRITE(ICOUT,2155)ICURLP
 2155    FORMAT(1X,I5,'>   ')
         CALL EDWRST('EDMAI2')
      ENDIF
      GOTO2190
C
 2190 CONTINUE
C
C               ********************************
C               **  STEP 22--                 **
C               **  READ IN A COMMAND LINE.   **
C               **  DETERMINE WHERE ITS LAST  **
C               **  NON-BLANK CHARACTER IS.   **
C               ********************************
C
 2200 CONTINUE
      ISTEPN='22'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IWIDTH=80
      DO2205I=1,IWIDTH
      IANS(I)=' '
 2205 CONTINUE
C
      IF(ICXQT.EQ.'ON')GOTO2210
      IF(ICCALL.EQ.'ON')GOTO2220
      IF(TCMENU.EQ.'ON')GOTO2230
      GOTO2280
C
 2210 CONTINUE
      ISTEPN='22.1'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IWIDTH=(-999)
      IF(IXQT.EQ.1)IWIDTH=NCHH1
      IF(IXQT.EQ.2)IWIDTH=NCHH2
      IF(IXQT.EQ.3)IWIDTH=NCHH3
      IF(IXQT.EQ.4)IWIDTH=NCHH4
      IF(IXQT.EQ.5)IWIDTH=NCHH5
      IF(IXQT.EQ.6)IWIDTH=NCHH6
      IF(IXQT.EQ.7)IWIDTH=NCHH7
      IF(IXQT.EQ.8)IWIDTH=NCHH8
      IF(IXQT.EQ.9)IWIDTH=NCHH9
      IF(IXQT.EQ.10)IWIDTH=NCHH10
      IF(IWIDTH.LE.0)GOTO2219
      DO2211I=1,IWIDTH
      IF(IXQT.EQ.1)IANS(I)=IHOLS1(I:I)
      IF(IXQT.EQ.2)IANS(I)=IHOLS2(I:I)
      IF(IXQT.EQ.3)IANS(I)=IHOLS3(I:I)
      IF(IXQT.EQ.4)IANS(I)=IHOLS4(I:I)
      IF(IXQT.EQ.5)IANS(I)=IHOLS5(I:I)
      IF(IXQT.EQ.6)IANS(I)=IHOLS6(I:I)
      IF(IXQT.EQ.7)IANS(I)=IHOLS7(I:I)
      IF(IXQT.EQ.8)IANS(I)=IHOLS8(I:I)
      IF(IXQT.EQ.9)IANS(I)=IHOLS9(I:I)
      IF(IXQT.EQ.10)IANS(I)=IHOL10(I:I)
 2211 CONTINUE
 2219 CONTINUE
      ICXQT='OFF'
      IXQT=(-999)
      GOTO2290
C
 2220 CONTINUE
      ISTEPN='22.2'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      READ(ICALNU,2221,END=2225)(IANS(I),I=1,IWIDTH)
 2221 FORMAT(240A1)
      GOTO2290
C
 2225 CONTINUE
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2226)
 2226 FORMAT('-----AN END OF FILE WAS ENCOUNTERED-----')
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
      ISTEPN='2225'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2227)ICCALL,ICXQT,ILCSW,IEOF,IPROSW
 2227 FORMAT('ICCALL,ICXQT,ILCSW,IEOF,IPROSW = ',
     1A4,2X,A4,2X,A4,2X,A4,2X,A4)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
      IEOF='YES'
CCCCC REWIND ICALNU
CCCCC CLOSE(UNIT=ICALNU)
      IOUNIT=ICALNU
      IENDFI='OFF'
      IREWIN='ON'
      CALL EDCLFI(IOUNIT,IENDFI,IREWIN)
C
      ICCALL='OFF'
      IF(IEXESL.EQ.'YES')GOTO2228
      GOTO2229
 2228 CONTINUE
      IEXESL='DONE'
      GOTO1500
 2229 CONTINUE
      IF(ILCSW.EQ.'EXMA')GOTO4100
      GOTO2100
C
CCCCC THE FOLLOWING SECTION WAS ADDED (FOR GUI/MENU)   MAY 1993
 2230 CONTINUE
      ISTEPN='22.3'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      CALL TCGECO(IB,NUMCHA,IBUGE2,ISUBRO)
      IWIDTH=NUMCHA
      IF(NUMCHA.LE.0)GOTO2239
      DO2231I=1,NUMCHA
      IANS(I)=IB(I:I)
 2231 CONTINUE
 2239 CONTINUE
      GOTO2290
C
 2280 CONTINUE
      ISTEPN='22.8'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC WRITE(IPR,777)LOOPCT
CC777 FORMAT('FROM EDMAI2--LOOPCT = ',I8)
      IF(LOOPCT.GE.1)THEN
         DO2281I=1,LOOPIW
            IANS(I)=LOOPST(I:I)
 2281    CONTINUE
         LOOPCT=LOOPCT-1
      ELSE
         READ(IRD,2282,END=2285)(IANS(I),I=1,IWIDTH)
 2282    FORMAT(240A1)
      ENDIF
C
      GOTO2290
 2285 CONTINUE
      WRITE(ICOUT,2286)
 2286 FORMAT('-----AN END OF FILE WAS ENCOUNTERED-----')
      CALL EDWRST('EDMAI2')
      IF(IMODE.EQ.'INPU')CALL EDEDIT
      GOTO2100
C
 2290 CONTINUE
C
C               *********************************
C               **  STEP 22A--                 **
C               **  SAVE THE COMMAND LINE      **
C               *********************************
C
      IF(IORINA.NE.ICOMNA.AND.IORINA.NE.ISAVNA)
     1WRITE(ICOMNU,2291)(IANS(I),I=1,IWIDTH)
 2291 FORMAT(80A1)
C
CCCCC THE FOLLOWING SECTION WAS ADDED (FOR GUI/MENU)   MAY 1993
C               **************************************************
C               **  STEP 22B--                                  **
C               **  WRITE OUT (= APPEND) THE COMMAND LINE       **
C               **  TO A COMPLETE COMMAND LOG FILE              **
C               **  SO AS TO ALLOW SCROLLING ON THE C-SIDE.     **
C               **************************************************
C
      IF(TCMENU.EQ.'ON')THEN
         DO2292I=1,80
            STRING(I:I)=IANS(I)
 2292    CONTINUE
         CALL TCWRCO(STRING,ISUBRO)
      ENDIF
C
C               *********************************
C               **  STEP 23--                  **
C               **  DEBLANK THE COMMAND LINE   **
C               *********************************
C
 2300 CONTINUE
      ISTEPN='23'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2301)IWIDTH,IANS(1)
 2301 FORMAT('IWIDTH,IANS(1) = ',I8,2X,A1)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
C
      IEXEIM='NO'
      CALL EDDEBL(IANS,IWIDTH)
C
C               ****************************************
C               **  STEP 24--                         **
C               **  TREAT THE REPEAT (R) COMMAND CASE **
C               ****************************************
 
      ISTEPN='24'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2401)IWIDTH,IANS(1)
 2401 FORMAT('IWIDTH,IANS(1) = ',I8,2X,A1)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
C
      IF(IWIDTH.EQ.1.AND.IANS(1).EQ.'R')GOTO2410
      IF(IWIDTH.EQ.1.AND.IANS(1).EQ.'r')GOTO2410
      GOTO2420
C
 2410 CONTINUE
      DO2411I=1,240
      IANS(I)=IANSV(I)
 2411 CONTINUE
      IWIDTH=IWIDSV
      GOTO2490
C
 2420 CONTINUE
      DO2421I=1,240
      IANSV(I)=IANS(I)
 2421 CONTINUE
      IWIDSV=IWIDTH
      GOTO2490
C
 2490 CONTINUE
C
C               *********************************
C               **  STEP 25--                  **
C               **  ECHO BACK THE COMMAND LINE **
C               **  (IF CALLED FOR)            **
C               *********************************
C
      IF(IECHSW.EQ.'ON')CALL EDECCO
C
C               ******************************************************
C               **  STEP 26--                                       **
C               **  DECOMPOSE THE INSTRUCTION LINE INTO COMPONENTS  **
C               ******************************************************
C
 2600 CONTINUE
      ICOMT='-999'
      CALL EDTYPE(IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM)
C
C               *****************************************
C               **  STEP 27--                          **
C               **  CONVERT THE COMMAND AND ARGUMENTS  **
C               **  TO UPPER CASE                      **
C               *****************************************
C
      CALL EDUPP4(ICOM,ICOM)
      CALL EDUPP4(ICOM2,ICOM2)
C
      IF(NUMARG.LE.0)GOTO2790
      DO2700I=1,NUMARG
      IHARLC(I)=IHARG(I)
      IHARL2(I)=IHARG2(I)
      CALL EDUPP4(IHARG(I),IHARG(I))
      CALL EDUPP4(IHARG2(I),IHARG2(I))
 2700 CONTINUE
 2790 CONTINUE
C
C               *****************************************
C               **  STEP 41--                          **
C               **  TREAT THE LOCATE-CALL   CASE       **
C               *****************************************
C
 4100 CONTINUE
      ISTEPN='41'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,4101)ILCSW
 4101 FORMAT('ILCSW = ',A4)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
      IF(ILCSW.EQ.'OFF')GOTO4105
      GOTO4106
 4105 CONTINUE
      IF(ICOM.EQ.'LC')GOTO4110
      GOTO4190
 4106 CONTINUE
      IF(ILCSW.EQ.'EXLO')GOTO4120
      IF(ILCSW.EQ.'CAMA')GOTO4130
      IF(ILCSW.EQ.'EXMA'.AND.IEOF.EQ.'NO')GOTO4140
      IF(ILCSW.EQ.'EXMA'.AND.IEOF.EQ.'YES')GOTO4150
      GOTO4190
C
 4110 CONTINUE
      ISTEPN='41.1'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IWIDT0=IWIDTH
      DO4111I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,4112)I,IANS(I),IANS0(I)
 4112 FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
 4111 CONTINUE
      ILCSW='EXLO'
      GOTO4100
C
 4120 CONTINUE
      ISTEPN='41.2'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.4)GOTO4128
      DO4121I=4,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO4128
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,4122)I,J,IANS0(I),IANS(J)
 4122 FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
 4121 CONTINUE
      IWIDTH=J
 4128 CONTINUE
      ICOM='LO'
      CALL EDLOCA
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,4129)ICURLN,NUMLIN
 4129 FORMAT('ICURLN,NUMLIN = ',2I8)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
      ILCSW='CAMA'
      IF(ICURLN.GT.NUMLIN)ILCSW='OFF'
      IF(ICURLN.GT.NUMLIN)GOTO2100
      GOTO4100
C
 4130 CONTINUE
      ISTEPN='41.4'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IANS(1)='C'
      IANS(2)='A'
      IANS(3)='L'
      IANS(4)='L'
      IANS(5)=' '
      IARGUM=1
      J=5
      IF(IWIDT0.LT.4)GOTO4134
      DO4131I=4,IWIDT0
      IF(IANS0(I).EQ.' ')IARGUM=IARGUM+1
      IF(IARGUM.EQ.1)GOTO4131
      IF(IARGUM.EQ.2.AND.IANS0(I).EQ.' ')GOTO4131
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,4132)I,J,IANS0(I),IANS(J)
 4132 FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
 4131 CONTINUE
 4134 CONTINUE
      IWIDTH=J
      ICOM='CALL'
      CALL EDCALL
C
      IF(IERROR.EQ.'YES'.AND.IEXESL.EQ.'YES')GOTO4135
      GOTO4136
 4135 CONTINUE
      IEXESL='DONE'
      GOTO1500
 4136 CONTINUE
      IF(IERROR.EQ.'YES')GOTO2100
      ILCSW='EXMA'
      GOTO2100
C
 4140 CONTINUE
      ISTEPN='41.5'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      GOTO4190
C
 4150 CONTINUE
      ISTEPN='41.6'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IEOF='NO'
      ILCSW='EXLO'
      GOTO4100
C
 4190 CONTINUE
      ISTEPN='41.9'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
C               *************************************************
C               **  STEP 61--                                  **
C               **  SEARCH FOR VARIOUS EDITOR INSTRUCTIONS     **
C               **  AND (IF FOUND) CARRY OUT THE INSTRUCTION.  **
C               *************************************************
C
 6100 CONTINUE
      ISTEPN='61'
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6101)ILCSW
 6101 FORMAT('ILCSW = ',A4)
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL EDWRST('EDMAI2')
CCCCC IF(ICOM.EQ.'EXIT')GOTO9000
C
      IF(ICOM.EQ.'PP'.AND.IERASW.EQ.'ON')GOTO6110
      GOTO6115
 6110 CONTINUE
      ICOM='ERAS'
      ICOM2='E   '
      CALL EDSEUC
      IF(IFOUND.EQ.'NO')CALL EDERAS(IMANUF,IMODEL)
      ICOM='PP  '
      ICOM2='    '
      GOTO6119
 6115 CONTINUE
      CALL EDSEUC
      IF(IFOUND.EQ.'YES')GOTO6200
      GOTO6119
 6119 CONTINUE
C
      CALL EDSEAR(IMARK,ICOLL1,ICOLL2,IBLASW,ISHIFN,IEXEIM,
     1ISEQNU,ICSEQN,NCSEQN,IPPLIN,IPPOFF,IERASW,IMANUF,IMODEL,
     1ILPOFF,
     1IHARLC,IHARL2,STOPSW)
C
CCCCC THE FOLLOWING LINE WAS ADDED JULY 1992
      IF(STOPSW.EQ.'YES')GOTO9000
CCCCC IF(IEXEIM.EQ.'YES')ILCSW='EXMA'
      IF(IEXEIM.EQ.'YES')GOTO2300
      IF(IFOUND.EQ.'YES')GOTO6200
C
CCCCC THE FOLLOWING SECTION WAS ADDED APRIL 1990
CCCCC TO ALLOW FOR    Z   COMMAND = CALL Z.
CCCCC Z1 COMMAND = CALL Z1.    ...    Z5 COMMAND = CALL Z5.
      IF(IWIDTH.GE.3)GOTO6149
      IF(IWIDTH.LE.0)GOTO6149
      IF(IANS(1).EQ.'Z')GOTO6140
      GOTO6149
 6140 CONTINUE
      ICJUNK=' '
      IWJUNK=IWIDTH
      IF(IWIDTH.EQ.2)ICJUNK=IANS(2)
      IANS(1)='C'
      IANS(2)='A'
      IANS(3)='L'
      IANS(4)='L'
      IANS(5)=' '
      IANS(6)='Z'
      IANS(7)='.'
      IWIDTH=7
      IF(IWJUNK.EQ.2)IANS(7)=ICJUNK
      IF(IWJUNK.EQ.2)IANS(8)='.'
      IF(IWJUNK.EQ.2)IWIDTH=8
      GOTO2300
 6149 CONTINUE
C
      WRITE(ICOUT,6181)
 6181 FORMAT('NO MATCH FOUND FOR COMMAND.')
      CALL EDWRST('EDMAI2')
      IF(IFOUND.EQ.'NO')WRITE(ICOUT,6182)(IANS(I),I=1,IWIDTH)
 6182 FORMAT('COMMAND LINE--',100A1)
      IF(IFOUND.EQ.'NO')CALL EDWRST('EDMAI2')
C
C               **************************************************
C               **  STEP 62--                                   **
C               **  LOOP BACK AND GET ANOTHER INSTRUCTION LINE  **
C               **************************************************
C
 6200 CONTINUE
CCCCC THE FOLLOWING COMPLETE SECTION WAS UPDATED APRIL 1990
CCCCC SO CAN SAY     EXRR JUNK.DAT     AS A SINGLE COMMAND
CCCCC THE FOLLOWING 2 LINES WERE COMMENTED OUT   JULY 1992
CCCCC IF(ICOM.EQ.'ER')GOTO6220
CCCCC IF(ICOM.EQ.'ERR')GOTO6230
      IF(ICOM.EQ.'EXR')GOTO6230
      IF(ICOM.EQ.'EXRR')GOTO6240
      IF(ICOM.EQ.'ABR')GOTO6230
      IF(ICOM.EQ.'ABRR')GOTO6240
      GOTO2100
C
CCCCC FEBRUARY 1995.  IF NO FILE NAME GIVEN, PUT IN INFINITE LOOP.
CCCCC IN THIS CASE, SET STOPSW TO ON.
 6220 CONTINUE
CCCCC IF(NUMARG.LE.0)GOTO1000
      IF(NUMARG.LE.0)THEN
        STOPSW='ON'
        GOTO9000
      ENDIF
      DO6221I=1,77
      IP3=I+3
      IORINA(I:I)=IANS(IP3)
 6221 CONTINUE
      IORINA(78:80)='   '
      GOTO1229
C
 6230 CONTINUE
CCCCC IF(NUMARG.LE.0)GOTO1000
      IF(NUMARG.LE.0)THEN
        STOPSW='ON'
        GOTO9000
      ENDIF
      DO6231I=1,76
      IP4=I+4
      IORINA(I:I)=IANS(IP4)
 6231 CONTINUE
      IORINA(77:80)='    '
      GOTO1229
C
 6240 CONTINUE
CCCCC IF(NUMARG.LE.0)GOTO1000
      IF(NUMARG.LE.0)THEN
        STOPSW='ON'
        GOTO9000
      ENDIF
      DO6241I=1,75
      IP5=I+5
      IORINA(I:I)=IANS(IP5)
 6241 CONTINUE
      IORINA(76:80)='     '
      GOTO1229
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
CCCCC STOP
CCCCC CALL EXIT(1)     COMMENTED OUT TO MAKE IT A SUBROUTINE  7/92
      RETURN
      END

      SUBROUTINE DPDDS(XTEMP1,XTEMP2,MAXNXT,
     1IBUGA2,IBUGA3,IBUGQ,IFOUND,IERROR)
C
C     PURPOSE--CARRY OUT A DDS (DATA-DEPENDENT SYSTEM) ANALYSIS
C              (1-SAMPLE)
C     EXAMPLE--DDS Y 6 5 DELT
C              DDS Y 6 5  (== DDS Y 6 5 1)
C              DDS Y      (== DDS Y 6 5 1)
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--94/4
C     ORIGINAL VERSION--MARCH     1994.
C     UPDATED         --APRIL     1996. DDS CODE MODIFIED (ALAN):
C                                       A) SOME DIMENSIONS TO DPDDS, USE
C                                          EQUIVALENCE
C                                       B) I/O CONSISTENT WITH DATAPLOT
C                                       C) USE IERROR RATHER THAN STOP
C                                       D) INCLUDE FILE FOR DDS COMMON
C                                          BLOCKS AND PARAMETER STATEMENTS
C                                       THESE CHANGES PROPOGATE TO LOWER
C                                       LEVEL DDS ROUTINES
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IBUGA2
      CHARACTER*4 IBUGA3
      CHARACTER*4 IBUGQ
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
      CHARACTER*4 IHWUSE
      CHARACTER*4 MESSAG
      CHARACTER*4 ICASEQ
C
      CHARACTER*4 IH11
      CHARACTER*4 IH12
      CHARACTER*4 IH21
      CHARACTER*4 IH22
      CHARACTER*4 IH31
      CHARACTER*4 IH32
      CHARACTER*4 IH41
      CHARACTER*4 IH42
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
      CHARACTER*4 IUSE1
      CHARACTER*4 IUSE2
CCCCC MAY 1995.  ADD FOLLOWING LINES
      CHARACTER*4 IUSE3
      CHARACTER*4 IUSE4
      CHARACTER*4 IREPU
      CHARACTER*4 IRESU
C
C---------------------------------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
C
      DIMENSION XTEMP1(*)
      DIMENSION XTEMP2(*)
C
      DIMENSION PRED2(MAXOBV)
      DIMENSION RES2(MAXOBV)
CCCCC APRIL 1996.  USE EQUIVALENCE, MOVE DIMENSIONS TO DPDDS
      INCLUDE 'DPCODD.INC'
      INCLUDE 'DPCOZZ.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
      DIMENSION Y2(100)
      DIMENSION AT(MXNOB1,MXSER)
      EQUIVALENCE (GARBAG(IGARB1),PRED2(1))
      EQUIVALENCE (GARBAG(IGARB2),RES2(1))
      EQUIVALENCE (GARBAG(IGARB3),XDDS(1,1))
      EQUIVALENCE (GARBAG(IGARB3+3*MAXOBV),YDDS(1,1))
      EQUIVALENCE (GARBAG(IGARB3+6*MAXOBV),AT(1,1))
      EQUIVALENCE (GARBAG(IGARB3+6*MAXOBV+3*MXNOB1),Y2(1))
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOHK.INC'
      INCLUDE 'DPCOSU.INC'
      INCLUDE 'DPCODA.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      ISUBN1='DPDD'
      ISUBN2='S   '
C
      MAXCP1=MAXCOL+1
      MAXCP2=MAXCOL+2
      MAXCP3=MAXCOL+3
      MAXCP4=MAXCOL+4
      MAXCP5=MAXCOL+5
      MAXCP6=MAXCOL+6
C
      IFOUND='NO'
      IERROR='NO'
C
      N1=(-999)
      N2=(-999)
C
      IUSE1='-999'
      IUSE2='-999'
C
      NUMVAR=(-999)
      ILOCV=(-999)
C
      VALUE1=(-999.0)
      VALUE2=(-999.0)
C
      ICOL1=(-999)
      ICOL2=(-999)
C
      MINN2=2
C
      IFOUND='YES'
C
      NLEFT=0
C
      ICASEQ='UNKN'
C
C               ********************************
C               **  TREAT THE DDS    CASE  **
C               ********************************
C
      IF(IBUGA2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPDDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGA2,IBUGA3
   52 FORMAT('IBUGA2,IBUGA3 = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IBUGQ
   53 FORMAT('IBUGQ = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)MAXNXT
   55 FORMAT('MAXNXT = ',I8)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               *******************************************************
C               **  STEP 2--                                         **
C               **  CHECK FOR THE PROPER NUMBER OF INPUT ARGUMENTS.  **
C               *******************************************************
C
      ISTEPN='2'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      MINNA=1
      MAXNA=100
      CALL CHECKA(NUMARG,MINNA,MAXNA,IANS,IWIDTH,ISUBN1,ISUBN2,
     1IERROR)
      IF(IERROR.EQ.'YES')GOTO9000
C
C               ****************************************
C               **  STEP 11--                         **
C               **  CHECK THE VALIDITY OF ARGUMENT 1  **
C               **  (THIS SHOULD BE A VARIABLE)       **
C               ****************************************
C
      ISTEPN='11'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IH11=IHARG(1)
      IH12=IHARG2(1)
      IHWUSE='V'
      MESSAG='YES'
      CALL CHECKN(IH11,IH12,IHWUSE,
     1IHNAME,IHNAM2,IUSE,IN,IVALUE,VALUE,NUMNAM,MAXNAM,
     1ISUBN1,ISUBN2,MESSAG,IANS,IWIDTH,ILOCV,IERROR)
      IF(IERROR.EQ.'YES')GOTO9000
      IUSE1=IUSE(ILOCV)
      ICOL1=IVALUE(ILOCV)
      N1=IN(ILOCV)
      NUMVAR=1
C
C               ********************************************************
C               **  STEP 12--                                         **
C               **  IF ARGUMENT 1 IS A VARIABLE,                      **
C               **  CHECK THAT THE INPUT NUMBER OF OBSERVATIONS (N1)  **
C               **  FOR ARGUMENT 1 IS 2 OR MORE.                      **
C               ********************************************************
C
      ISTEPN='12'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IUSE1.NE.'V')GOTO1290
      IF(N1.GE.MINN2)GOTO1290
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1211)
 1211 FORMAT('***** ERROR IN DPDDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1212)
 1212 FORMAT('      THE INPUT NUMBER OF OBSERVATIONS')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1213)
 1213 FORMAT('      (FOR WHICH A DDS ANALYSIS ')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1214)
 1214 FORMAT('      WAS TO HAVE BEEN CARRIED OUT)')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1215)MINN2
 1215 FORMAT('      MUST BE ',I8,' OR LARGER;')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1216)
 1216 FORMAT('      SUCH WAS NOT THE CASE HERE')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1217)IH11,IH12
 1217 FORMAT('      FOR VARIABLE ',A4,A4,' WHICH HAD')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1218)N1
 1218 FORMAT('      NUMBER OF OBSERVATIONS = ',I8,';')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1219)
 1219 FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
      CALL DPWRST('XXX','BUG ')
      IF(IWIDTH.GE.1)WRITE(ICOUT,1220)(IANS(I),I=1,IWIDTH)
 1220 FORMAT(80A1)
      IF(IWIDTH.GE.1)CALL DPWRST('XXX','BUG ')
      IERROR='YES'
      GOTO9000
 1290 CONTINUE
C
C               ****************************************
C               **  STEP 22--                         **
C               **  CHECK THE VALIDITY OF ARGUMENT 2  **
C               **  (THIS SHOULD BE A                 **
C               **  A PARAMETER, OR A NUMBER).        **
C               ****************************************
C
      ISTEPN='22'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMARG.LE.1)IORDAR=2
      IF(NUMARG.GE.2)THEN
         IH21=IHARG(2)
         IH22=IHARG2(2)
         IF(IARGT(2).EQ.'NUMB')THEN
            VALUE2=ARG(2)
            IORDAR=IARG(2)
            IUSE2='P'
         ENDIF
      ENDIF
C
C               ****************************************
C               **  STEP 23--                         **
C               **  CHECK THE VALIDITY OF ARGUMENT 3  **
C               **  (THIS SHOULD BE A                 **
C               **  A PARAMETER, OR A NUMBER).        **
C               ****************************************
C
      ISTEPN='23'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMARG.LE.2)IORDMA=1
      IF(NUMARG.GE.3)THEN
         IH31=IHARG(3)
         IH32=IHARG2(3)
         IF(IARGT(3).EQ.'NUMB')THEN
            VALUE3=ARG(3)
            IORDMA=IARG(3)
            IUSE3='P'
         ENDIF
      ENDIF
C
C               ****************************************
C               **  STEP 24--                         **
C               **  CHECK THE VALIDITY OF ARGUMENT 4  **
C               **  (THIS SHOULD BE A                 **
C               **  A PARAMETER, OR A NUMBER).        **
C               ****************************************
C
      ISTEPN='24'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMARG.LE.3)DELTAT=1.0
      IF(NUMARG.GE.4)THEN
         IH41=IHARG(4)
         IH42=IHARG2(4)
         IF(IARGT(4).EQ.'NUMB')THEN
            VALUE4=ARG(4)
            DELTAT=VALUE4
            IUSE4='P'
         ENDIF
      ENDIF
C
C               ****************************************************************
C               **  STEP 31--                                                 **
C               **  FOR A DDS ANALYSIS,                                             **
C               **  THE FIRST ARGUMENT                               **
C               **  MUST BE A VARIABLE.                                       **
C               **  CHECK FOR THIS.                                           **
C               **  IF ONLY 1 ARGUMENT IS A VARIABLE,                         **
C               **  THIS IMPLIES A 1-SAMPLE DDS ANALYSIS.                           **
C               **  (IF SO, COPY THE OTHER ARGUMENT AS THE TARGET MU VALUE).  **
C               ****************************************************************
C
      ISTEPN='31'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IUSE1.NE.'V')GOTO3140
      GOTO3190
C
 3140 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3141)
 3141 FORMAT('***** ERROR IN DPDDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3142)
 3142 FORMAT('      FOR A DDS ANALYSIS,')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3143)
 3143 FORMAT('      THE FIRST ARGUMENT')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3146)
 3146 FORMAT('      MUST BE A VARIABLE')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3147)
 3147 FORMAT('      (AS OPPOSED TO A PARAMETER OR FUNCTION).')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3148)
 3148 FORMAT('      SUCH WAS NOT THE CASE HERE.')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3149)
 3149 FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
      CALL DPWRST('XXX','BUG ')
      IF(IWIDTH.GE.1)WRITE(ICOUT,3150)(IANS(I),I=1,IWIDTH)
 3150 FORMAT(80A1)
      IF(IWIDTH.GE.1)CALL DPWRST('XXX','BUG ')
      IERROR='YES'
      GOTO9000
C
 3190 CONTINUE
C
C               *****************************************
C               **  STEP 40--                          **
C               **  CHECK TO SEE THE TYPE CASE--       **
C               **    1) UNQUALIFIED (THAT IS, FULL);  **
C               **    2) SUBSET/EXCEPT; OR             **
C               **    3) FOR.                          **
C               *****************************************
C
      ISTEPN='40'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      ICASEQ='FULL'
      ILOCQ=NUMARG+1
      IF(NUMARG.LT.1)GOTO4090
      DO4000J=1,NUMARG
      J1=J
      IF(IHARG(J).EQ.'SUBS'.AND.IHARG2(J).EQ.'ET  ') GOTO4010
      IF(IHARG(J).EQ.'EXCE'.AND.IHARG2(J).EQ.'PT  ') GOTO4010
      IF(IHARG(J).EQ.'FOR '.AND.IHARG2(J).EQ.'    ') GOTO4020
 4000 CONTINUE
      GOTO4090
 4010 CONTINUE
      ICASEQ='SUBS'
      ILOCQ=J1
      GOTO4090
 4020 CONTINUE
      ICASEQ='FOR'
      ILOCQ=J1
      GOTO4090
 4090 CONTINUE
      IF(IBUGA2.EQ.'OFF')GOTO4095
      WRITE(ICOUT,4091)NUMARG,ILOCQ
 4091 FORMAT('NUMARG,ILOCQ = ',2I8)
      CALL DPWRST('XXX','BUG ')
 4095 CONTINUE
C
C               ***********************************************
C               **  STEP 41--                                **
C               **  TEMPORARILY FORM THE VARIABLE Y(.)       **
C               **  WHICH WILL HOLD THE DATA FROM SAMPLE 1.  **
C               **  FORM THIS VARIABLE BY                    **
C               **  BRANCHING TO THE APPROPRIATE SUBCASE     **
C               **  (FULL, SUBSET, OR FOR).                  **
C               ***********************************************
C
      IF(IUSE1.NE.'V')GOTO4190
C
      ISTEPN='41'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICASEQ.EQ.'FULL')GOTO4110
      IF(ICASEQ.EQ.'SUBS')GOTO4120
      IF(ICASEQ.EQ.'FOR')GOTO4130
C
 4110 CONTINUE
      DO4115I=1,N1
      ISUB(I)=1
 4115 CONTINUE
      NQ=N1
      GOTO4150
C
 4120 CONTINUE
      NIOLD=N1
      CALL DPSUBS(NIOLD,ILOCS,NS,IBUGQ,IERROR)
      NQ=NIOLD
      GOTO4150
C
 4130 CONTINUE
      NIOLD=N1
      CALL DPFOR(NIOLD,NFOR,IROW1,IROWN,
     1NLOCAL,ILOCS,NS,IBUGQ,IERROR)
      NQ=NFOR
      GOTO4150
C
 4150 CONTINUE
      IF(NQ.GE.MINN2)GOTO4160
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4151)
 4151 FORMAT('***** ERROR IN DPDDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4152)
 4152 FORMAT('      AFTER THE APPROPRIATE SUBSET HAS BEEN ',
     1'EXTRACTED,')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4153)IH11,IH12
 4153 FORMAT('      THE NUMBER OF OBSERVATIONS REMAINING',
     1'FROM VARIABLE ',A4,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4154)
 4154 FORMAT('      (FOR WHICH A DDS ANALYSIS ')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4155)
 4155 FORMAT('      IS TO BE CARRIED OUT)')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4156)MINN2
 4156 FORMAT('      MUST BE ',I8,' OR LARGER;')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4157)NQ
 4157 FORMAT('      SUCH WAS NOT THE CASE HERE.  (N = ',I8,')')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,4158)
 4158 FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
      CALL DPWRST('XXX','BUG ')
      IF(IWIDTH.GE.1)WRITE(ICOUT,4159)(IANS(I),I=1,IWIDTH)
 4159 FORMAT('      ',80A1)
      IF(IWIDTH.GE.1)CALL DPWRST('XXX','BUG ')
      IERROR='YES'
      GOTO9000
C
 4160 CONTINUE
      J=0
      IMAX=N1
      IF(NQ.LT.N1)IMAX=NQ
      DO4170I=1,IMAX
      IF(ISUB(I).EQ.0)GOTO4170
      J=J+1
C
      IJ=MAXN*(ICOL1-1)+I
      IF(ICOL1.LE.MAXCOL)Y(J)=V(IJ)
      IF(ICOL1.EQ.MAXCP1)Y(J)=PRED(I)
      IF(ICOL1.EQ.MAXCP2)Y(J)=RES(I)
      IF(ICOL1.EQ.MAXCP3)Y(J)=YPLOT(I)
      IF(ICOL1.EQ.MAXCP4)Y(J)=XPLOT(I)
      IF(ICOL1.EQ.MAXCP5)Y(J)=X2PLOT(I)
      IF(ICOL1.EQ.MAXCP6)Y(J)=TAGPLO(I)
C
 4170 CONTINUE
      N1=J
C
 4190 CONTINUE
C
C               *********************************
C               **  STEP 52--                  **
C               **  FORM THE DDS ANALYSIS **
C               *********************************
C
      ISTEPN='52'
      IF(IBUGA2.EQ.'ON')CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGA2.EQ.'OFF')GOTO5290
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,5211)
 5211 FORMAT('***** FROM DPDDS, AS WE ARE ABOUT TO CALL DPTTE2--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,5212)N1,N2,N1,N2,MAXN
 5212 FORMAT('N1,N2,N1,N2,MAXN = ',5I8)
      CALL DPWRST('XXX','BUG ')
      DO5215I=1,N1
      WRITE(ICOUT,5216)I,Y(I)
 5216 FORMAT('I,Y(I) = ',I8,2E15.7)
      CALL DPWRST('XXX','BUG ')
 5215 CONTINUE
      DO5217I=1,N1
      WRITE(ICOUT,5218)I,Y(I)
 5218 FORMAT('I,Y(I) = ',I8,2E15.7)
      CALL DPWRST('XXX','BUG ')
 5217 CONTINUE
CCCCC IBUGA3='ABCD'
      WRITE(ICOUT,5231)IBUGA3
 5231 FORMAT('IBUGA3 = ',A4)
      CALL DPWRST('XXX','BUG ')
 5290 CONTINUE
C
CCCCC APRIL 1996.  ADD XDDS, YDDS, Y2 TO ARGUMENT LIST (DIMENSIONING DONE
CCCCC IN DPDDS RATHER THAN IN DPDDS2 AND DPDDS3 TO ALLOW USE OF EQUIVALENCE
CCCCC WITH DATAPLOT SCRATCH ARRAYS)
      CALL DPDDS2(Y,N1,IORDAR,IORDMA,DELTAT,NUMVAR,ILOCV,
CCCCC1XTEMP1,XTEMP2,MAXNXT,PRED2,RES2,RESSD,RESDF,IBUGA3,IERROR)
     1XTEMP1,XTEMP2,XDDS,YDDS,AT,Y2,MAXNXT,PRED2,RES2,RESSD,RESDF,
     1IBUGA3,IERROR)
C
C               ***************************************
C               **  STEP 15--                        **
C               **  UPDATE INTERNAL DATAPLOT TABLES  **
C               ***************************************
C
 7000 CONTINUE
C
      ISTEPN='15'
      IF(IBUGA2.EQ.'ON')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      ICOLPR=MAXCP1
      ICOLRE=MAXCP2
      IREPU='OFF'
      IRESU='ON'
      NLEFT=N1
      CALL UPDAPR(ICOLPR,ICOLRE,PRED2,RES2,PRED,RES,ISUB,NLEFT,
     1IREPU,REPSD,REPDF,IRESU,RESSD,RESDF,ALFCDF,
     1IHNAME,IHNAM2,IUSE,IN,IVALUE,VALUE,NUMNAM,MAXNAM,
     1IANS,IWIDTH,ILOCN,IBUGA3,IERROR)
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGA2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPDDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGA2,IBUGA3
 9012 FORMAT('IBUGA2,IBUGA3 = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IBUGQ
 9013 FORMAT('IBUGQ = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)NLEFT,NS
 9014 FORMAT('NLEFT,NS = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)ICASEQ
 9015 FORMAT('ICASEQ = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)IFOUND,IERROR
 9016 FORMAT('IFOUND,IERROR = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END

      PROGRAM DATAPLOT
C
C     PURPOSE--THIS IS THE MAIN ROUTINE FOR DATAPLOT--
C              THE INTERACTIVE GRAPHICAL DATA ANALYSIS LANGUAGE.
C
C     THE MAIN ROUTINE FOR DATAPLOT IS MAIN.
C     MAIN CALLS 6 SEARCH SUBROUTINES--
C           MAINGR--SEARCH FOR AND EXECUTE GRAPHICS COMMANDS.
C           MAINPC--SEARCH FOR AND EXECUTE PLOT CONTROL COMMANDS.
C           MAINOD--SEARCH FOR AND EXECUTE OUTPUT DEVICE COMMANDS.
C           MAINAN--SEARCH FOR AND EXECUTE ANALYSIS COMMANDS.
C           MAINSU--SEARCH FOR AND EXECUTE SUPPORT COMMANDS.
C           MAINDG--SEARCH FOR AND EXECUTE DIAGRAMMATIC GRAPHICSM COMMAN
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--88/9
C     ORIGINAL VERSION--NOVEMBER 10, 1977.
C     UPDATED         --OCTOBER   1978.
C     UPDATED         --NOVEMBER  1978.
C     UPDATED         --JANUARY   1979.
C     UPDATED         --FEBRUARY  1979.
C     UPDATED         --JUNE      1979.
C     UPDATED         --JULY      1979.
C     UPDATED         --SEPTEMBER 1980.
C     UPDATED         --FEBRUARY  1981.
C     UPDATED         --MARCH     1981.
C     UPDATED         --SEPTEMBER 1981.
C     UPDATED         --OCTOBER   1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --SEPTEMBER 1983.
C     UPDATED         --JULY      1988. CHANGE HELP MAX FROM NO LIMIT TO 20
C     UPDATED         --SEPTEMBER 1988. 3D PROJECTION (ORTHOGRAP./PERSPECT.)
C     UPDATED         --DECEMBER  1988. ADD ISEED TO CALL TO MAINGR (DPFRAC)
C     UPDATED         --DECEMBER  1988. RESET DATA, IO, PC, ETC & RESET2
C     UPDATED         --DECEMBER  1988. SET WRITE FORMAT
C     UPDATED         --DECEMBER  1988. SET READ  REWIND
C     UPDATED         --DECEMBER  1988. SET WRITE REWIND
C     UPDATED         --DECEMBER  1988. SUP ERR MESS FOR BACKSLASH IN FALSE IF
C     UPDATED         --DECEMBER  1988. FIX NON-STOR OF SET/PROBE IF IN LOOP
C     UPDATED         --DECEMBER  1988. LOWESS FRACTION
C     UPDATED         --JANAURY   1989. # CHAR IN AUTO-X3LABEL FOR NOR. P.P.
C     UPDATED         --JANUARY   1989. FIX 4-PLOT OF NON-EX VAR STAYED SMALL
C     UPDATED         --JANUARY   1989. 4-PLOT CODE AS A SEPARATE SUBROUTINE
C     UPDATED         --JANUARY   1989. ADD BOOTSTRAP SIZE TO MAINGR/SU
C     UPDATED         --FEBRUARY  1989. ADD 3-D COMMON
C     UPDATED         --FEBRUARY  1989. ADD DEVICE & SET COMMON (ALAN)
C     UPDATED         --APRIL     1989. DELETE SOME ARGS IN CALLS TO DP4PLO
C     UPDATED         --APRIL     1989. SOFT-CODE BACKSLASH FOR UNIX
C     UPDATED         --MAY       1989. VERSION COMMAND
C     UPDATED         --JUNE      1989. CHANGE BACKSLASH TO # FOR IBM-PC & COM
C     UPDATED         --JUNE      1989. BACKSLASH TO # FOR IBM-PC & COMPAQ
C     UPDATED         --JUNE      1989. BACKSLASH ADDED TO MAINSU ARG LIST
C     UPDATED         --JUNE      1989. SUPPRESS ERROR MESSAGE FOR \ IN COMMENT
C     UPDATED         --JUNE      1989. ICAPSW AND IPRDEF DEFINED FOR CAPTURE
C     UPDATED         --JULY      1989. SOME IANSLC ENTRIES TOO LONG/SHORT
C     UPDATED         --NOVEMBER  1989. LOWESS FRACTION DEFAULT TO .1
C     UPDATED         --NOVEMBER  1989. SELECTIVE PRINTING OF YATES COEF
C     UPDATED         --MAY       1990. UPDATE X11 SCREEN IF NEEDED.
C                                       DEFINE NON-PRINTING CHARACTERS AFTER
C                                       CALL INITMC.
C     UPDATED         --JUNE      1990. IGUNIT=IPR (FIX DEF TO DPPL1F.DAT)
C     UPDATED         --JUNE      1990. ADD SOME INCLUDE FILES
C     UPDATED         --JUNE      1990. NORMAL PLOT
C     UPDATED         --JUNE      1990. MENU SUBSYSTEM
C     UPDATED         --JULY      1990. X-WINDOWS UPDATE (ALAN)
C     UPDATED         --JULY      1990. COMMENT OUT IHOST1/2 DEF.
C     UPDATED         --JULY      1990. FREE R CHART FROM R (REPEAT)
C     UPDATED         --AUGUST    1990. ADD 11 MENU CHAR SECTIONS
C     UPDATED         --AUGUST    1990. FIRST PASS AT WINDOW SYSTEM
C     UPDATED         --AUGUST    1990. WINDOW SYSTEM COMMON
C     UPDATED         --JUNE      1991. TURBO-C GUI MENU
C     UPDATED         --JUNE      1991. KILL OLD TC WINDOW LOGIC.
C     UPDATED         --JULY      1991. AUTO-VGA WHITH TURBO-C MENU
C     UPDATED         --OCTOBER   1991. ADD BLOCK DATA (ALAN)
C     UPDATED         --FEBRUARY  1992. ALLOW ARGS ON DP COMMAND LINE
C     UPDATED         --MARCH     1992. EXEC & WRITE TO FILE
C     UPDATED         --MARCH     1992. EXEC & WRITE TO LASER PRINTER
C     UPDATED         --APRIL     1992. BAR EXPANSION FACTORS ... ...
C     UPDATED         --APRIL     1992. NPLOTP ADDED TO MAINSU ARGS
C     UPDATED         --APRIL     1992. NPLOTP ADDED TO DPSET ARGS
C     UPDATED         --APRIL     1992. NPLOTP ADDED TO DPPROB ARGS
C     UPDATED         --APRIL     1992. LINE FOR NOS/VE COMMAND LINE
C     UPDATED         --MAY       1992. DEFINE/OPEN DEVICE 3 AS POST
C     UPDATED         --JUNE      1992. EMPTY THE COMMAND LOG FILE
C     UPDATED         --JULY      1992. ADD EDITOR (FED)
C     UPDATED         --AUGUST    1992. FIX X3LABEL AUTOMATIC INTERACTIONS
C     UPDATED         --AUGUST    1992. REWRITE ... AUTOMATIC SECTION
C     UPDATED                           (MAKE GO-TO-LESS)
C     UPDATED         --AUGUST    1992. PASS ... AUTOMATIC SWITCHES
C     UPDATED                           TO MAINPC
C     UPDATED         --AUGUST    1992. ARGUMENT LIST TO DPGRAP
C     UPDATED         --NOVEMBER  1992. ALLOW NESTED IF BLOCKS
C     UPDATED         --FEBRUARY  1993. IPRITY ADDED TO DPSET ARGS
C     UPDATED         --FEBRUARY  1993. IPRITY ADDED TO DPPROB ARGS
C     UPDATED         --FEBRUARY  1993. ERROR MESSAGE 8112 AUGMENTED
C     UPDATED         --FEBRUARY  1993. MENU IDMANU(1) VGA => TURB
C     UPDATED         --FEBRUARY  1993. INITIAL VALUE FOR IPLATF
C     UPDATED         --JULY      1993. ADD ALAN'S NAME TO BANNER
C     UPDATED         --SEPTEMBER 1993. AUTO LABELS: ALLOW for
C     UPDATED         --SEPTEMBER 1993. X2LABEL AUTO ==> BLANK
C     UPDATED         --SEPTEMBER 1993. Y2LABEL AUTO ==> BLANK
C     UPDATED         --SEPTEMBER 1993. CCAM ==> CAML in title
C     UPDATED         --DECEMBER  1993. 6-PLOT
C     UPDATED         --DECEMBER  1993. DEFAULT PATH FOR IBM-PC
C     UPDATED         --JANUARY   1994. WEIB MINMAX TO DPCOS2.INC
C     UPDATED         --FEBRUARY  1994. ARGUMENTS TO DPLOEX
C     UPDATED         --MARCH     1994. ARGUMENTS TO MAINAN, MAINSU
C     UPDATED         --AUGUST    1994. EXECUTE SUBSET OF MACRO
C     UPDATED         --APRIL     1995. IUNFOF, IUNFNR, IUNFMC
C     UPDATED         --MAY       1995. EQUIVALENCE SOME ARRAYS TO COMMON
C     UPDATED         --JULY      1995. ALWAYS CALL C:\DATAPLOT\DPLOGF
C     UPDATED         --JULY      1995. FIT SETTINGS IN DPSET/DPPROB
C     UPDATED         --AUGUST    1995. IFTORD (SET FOURIER ORDER 
C                                                  <STANDARD/DATAPLOT>
C     UPDATED         --FEBRUARY  1996. INITIALIZE    MENU PATH
C     UPDATED         --FEBRUARY  1996. MOVE  CALL TCINCF  TO AFTER MENU PATH
C     UPDATED         --FEBRUARY  1996. MOVE  CALL TCINCO  FROM INITOD
C     UPDATED         --MARCH     1996. IRHSTG (SET RELATIVE HISTOGRAM 
C                                                  <AREA/PERCENT>
C     UPDATED         --MARCH     1996. ARGUMENT LIST TO MAINSU
C     UPDATED         --APRIL     1996. DPCODD INCLUDE FILE FOR DDS
C     UPDATED         --JULY      1996. INITIALIZE IWBFLG VARIABLE
C     UPDATED         --JANUARY   1997. CHECK FOR SUCCESSFUL OPENING
C                                       OF DPPL2F.DAT FILE
C     UPDATED         --APRIL     1997. DPCOPM INCLUDE FILE
C     UPDATED         --NOVEMBER  1997. DON'T STORE "GUI" COMMANDS
C     UPDATED         --DECEMBER  1997. REPLOT COMMAND
C     UPDATED         --JANUARY   1998. CALL DPFLSH FOR TCL/TK
C     UPDATED         --MAY       1998. HAZARD PLOT UPDATE
C     UPDATED         --SEPTEMBER 1998. MAINDG ARGUMENT LIST
C     UPDATED         --AUGUST    1999. MAINPC, DPGRAP ARGUMENT LIST
C     UPDATED         --SEPTEMBER 1999. ADD R-F SPREAD PLOT
C     UPDATED         --SEPTEMBER 1999. ADD SCATTER PLOT MATRIX
C     UPDATED         --SEPTEMBER 1999. ADD CONDITITIONING PLOT
C     UPDATED         --JANUARY   2000. ARGUMENT LIST TO DPREP2
C     UPDATED         --MARCH     2002. ACTIVATE VERSION COMMAND
C                                       (DATE WILL BE UPDATED
C                                       APPROXIMATELY ONCE A MONTH)
C     UPDATED         --MARCH     2002. ARGUMENT LIST TO DP4PLO, DP6PLO
C     UPDATED         --JUNE      2002. ADD PARTIAL REGRESSION PLOT
C     UPDATED         --JUNE      2002. ADD PARTIAL RESIDUAL PLOT
C     UPDATED         --JUNE      2002. ADD PARTIAL LEVERAGE PLOT
C     UPDATED         --JULY      2002. ELSE CLAUSE FOR IF
C     UPDATED         --JANUARY   2005. BUG IN NESTED IF'S
C     UPDATED         --FEBRUARY  2005. CHECK FOR REPEAT SD PLOT
C                                       FOR REPEAT COMMAND
C     UPDATED         --MARCH     2006. OPNPLOT COMMON BLOCK
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IVGMSW
      CHARACTER*4 IHGMSW
C
      CHARACTER*4 IMPSW
      CHARACTER*4 IERASV
CCCCC THE FOLLOWING LINE WAS ADDED JULY 1991 (JJF)
      CHARACTER*4 IFEESV
C
      CHARACTER*4 ICOMT
C
      CHARACTER*4 ISQUAR
      CHARACTER*4 ITOPIC
      CHARACTER*4 IPROSW
      CHARACTER*4 IOFILE
C
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
      CHARACTER*4 IMACOL
      CHARACTER*4 ICASAN
      CHARACTER*4 ICASPL
      CHARACTER*4 ICONT
      CHARACTER*4 IAND1
      CHARACTER*4 IAND2
C
      CHARACTER*4 IMAFIL
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
      CHARACTER*4 ILOOST
      CHARACTER*4 IHPNV
      CHARACTER*4 IHPNV2
      CHARACTER*4 IANSLO
      CHARACTER*4 IBUGLO
C
      CHARACTER*4 IMACRO
      CHARACTER*12 IMACCS
C
      CHARACTER*4 IBUGI2
      CHARACTER*4 ICOMHO
      CHARACTER*4 ICOMH2
C
      CHARACTER*4 IBUGUG
      CHARACTER*4 IBUGU2
      CHARACTER*4 IBUGU3
      CHARACTER*4 IBUGU4
C
      CHARACTER*4 ISUBRO
C
      CHARACTER*4 IBUGEX
      CHARACTER*4 IBUGE2
C
      CHARACTER*4 IBUGHE
      CHARACTER*4 IBUGH2
C
      CHARACTER*4 IREPST
      CHARACTER*1 IANSSV
CCCCC DECEMBER 1997.  ADD FOLLOWING 2 LINES
      CHARACTER*4 IPLTST
      CHARACTER*1 IPLTSV
C
      CHARACTER*80 ISACNC
C
      CHARACTER*1 IC1
      CHARACTER*4 IC4
C
      CHARACTER*4 IAUTSW
      CHARACTER*4 IAUTEX
C
      CHARACTER*4 ICASIF
CCCCC FOLLOWING 2 LINES ADDED NOVEMBER 1992.
      PARAMETER(MAXIF=10)
      CHARACTER*4 ICASI2(MAXIF)
      CHARACTER*4 ICASI3(MAXIF)
C
      CHARACTER*4 IIFSW
C
CCCCC THE FOLLOWING SECTION WAS CHANGED AUGUST 1992
CCCCC CHARACTER*4 IX3AUT
CCCCC CHARACTER*4 ITIAUT
CCCCC CHARACTER*4 IY1AUT
CCCCC CHARACTER*4 IX1AUT
      CHARACTER*4 ITIAUT
      CHARACTER*4 IX1AUT
      CHARACTER*4 IX2AUT
      CHARACTER*4 IX3AUT
      CHARACTER*4 IY1AUT
      CHARACTER*4 IY2AUT
C
      CHARACTER*4 I4PLOT
      CHARACTER*4 IERAS2
      CHARACTER*4 ICOPS2
      CHARACTER*4 ICHAP2
      CHARACTER*4 ILINP2
      CHARACTER*4 IFEED9
C
CCCCC CHARACTER*4 IANSRS     JANUARY 1989
CCCCC CHARACTER*4 IANSLP     JANUARY 1989
CCCCC CHARACTER*4 IANSHI     JANUARY 1989
CCCCC CHARACTER*4 IANSNP     JANUARY 1989
C
      CHARACTER*4 IEXPSW
      CHARACTER*12 IEXPCO
      CHARACTER*4 IEXPAL
      CHARACTER*12 IEX1CO
      CHARACTER*4 IEX1AL
      CHARACTER*12 IEX2CO
      CHARACTER*4 IEX2AL
      CHARACTER*12 IEX3CO
      CHARACTER*4 IEX3AL
      CHARACTER*12 IEX4CO
      CHARACTER*4 IEX4AL
      CHARACTER*12 IEX5CO
      CHARACTER*4 IEX5AL
C
      CHARACTER*4 IHELSW
      CHARACTER*12 IHELCO
      CHARACTER*4 IHELAL
      CHARACTER*12 IHE1CO
      CHARACTER*4 IHE1AL
      CHARACTER*12 IHE2CO
      CHARACTER*4 IHE2AL
      CHARACTER*12 IHE3CO
      CHARACTER*4 IHE3AL
      CHARACTER*12 IHE4CO
      CHARACTER*4 IHE4AL
      CHARACTER*12 IHE5CO
      CHARACTER*4 IHE5AL
      CHARACTER*12 IHE6CO
      CHARACTER*4 IHE6AL
      CHARACTER*12 IHE7CO
      CHARACTER*4 IHE7AL
      CHARACTER*12 IHE8CO
      CHARACTER*4 IHE8AL
      CHARACTER*12 IHE9CO
      CHARACTER*4 IHE9AL
C
CCCCC THE FOLLOWING SECTION WAS ADDED JUNE 1990
      CHARACTER*4 IMENSW
      CHARACTER*12 IMENCO
      CHARACTER*4 IMENAL
      CHARACTER*12 IME1CO
      CHARACTER*4 IME1AL
      CHARACTER*12 IME2CO
      CHARACTER*4 IME2AL
      CHARACTER*12 IME3CO
      CHARACTER*4 IME3AL
      CHARACTER*12 IME4CO
      CHARACTER*4 IME4AL
      CHARACTER*12 IME5CO
      CHARACTER*4 IME5AL
      CHARACTER*12 IME6CO
      CHARACTER*4 IME6AL
      CHARACTER*12 IME7CO
      CHARACTER*4 IME7AL
      CHARACTER*12 IME8CO
      CHARACTER*4 IME8AL
      CHARACTER*12 IME9CO
      CHARACTER*4 IME9AL
C
CCCCC THE FOLLOWING 11 SECTIONS (10 TO 20) WERE ADDED AUGUST 1990
      CHARACTER*12 IM10CO
      CHARACTER*4 IM10AL
C
      CHARACTER*12 IM11CO
      CHARACTER*4 IM11AL
C
      CHARACTER*12 IM12CO
      CHARACTER*4 IM12AL
C
      CHARACTER*12 IM13CO
      CHARACTER*4 IM13AL
C
      CHARACTER*12 IM14CO
      CHARACTER*4 IM14AL
C
      CHARACTER*12 IM15CO
      CHARACTER*4 IM15AL
C
      CHARACTER*12 IM16CO
      CHARACTER*4 IM16AL
C
      CHARACTER*12 IM17CO
      CHARACTER*4 IM17AL
C
      CHARACTER*12 IM18CO
      CHARACTER*4 IM18AL
C
      CHARACTER*12 IM19CO
      CHARACTER*4 IM19AL
C
      CHARACTER*12 IM20CO
      CHARACTER*4 IM20AL
C
      CHARACTER*1 IANSEX
C
      CHARACTER*12 IVERSI
C
      CHARACTER*4 IPROGR
      CHARACTER*4 ICONCL
      CHARACTER*4 IEOF
C
      CHARACTER*4 ICOM3
      CHARACTER*4 ICOM4
      CHARACTER*40 ICOM5
      CHARACTER*130 ICJUNK
C
      CHARACTER*1 IREPCH
C
      CHARACTER*4 IOSW
C
      CHARACTER*80 IFILE
CCCCC CHARACTER*12 ISTAT
CCCCC CHARACTER*12 IFORM
CCCCC CHARACTER*12 IACCES
CCCCC CHARACTER*12 IPROT
      CHARACTER*12 ICURST
CCCCC THE FOLLOWING LINE WAS COMMENTED OUT    APRIL 1987
CCCCC CHARACTER*4 IREWIN
CCCCC THE FOLLOWING 2 LINES WERE ADDED    MARCH 1992
      CHARACTER*4 IREWIN
      CHARACTER*4 IENDFI
      CHARACTER*4 ISUBN0
      CHARACTER*4 IERRFI
C
      CHARACTER*4 ISYSSW
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1992
      CHARACTER*4 ISYSS2
      CHARACTER*4 IEXIST
C
      CHARACTER*4 IX1TSV
      CHARACTER*4 IX2TSV
      CHARACTER*4 IY1TSV
      CHARACTER*4 IY2TSV
C
      CHARACTER*4 IX1ZSV
      CHARACTER*4 IX2ZSV
      CHARACTER*4 IY1ZSV
      CHARACTER*4 IY2ZSV
C
      CHARACTER*40 ICPREH
      CHARACTER*40 ICPOSH
C
      CHARACTER*4 IFTEXP
CCCCC AUGUST 1995.  ADD FOLLOWING LINE
      CHARACTER*4 IFTORD
CCCCC MARCH 1996.  ADD FOLLOWING LINE
CCCCC NOVEMBER 1998.  ADD TO DPCOST.INC
CCCCC CHARACTER*4 IRHSTG
C
      CHARACTER*4 IFORSW
      CHARACTER*80 ICREAF
      CHARACTER*80 ICWRIF
C
      CHARACTER*4 IREARW
      CHARACTER*4 IWRIRW
C
CCCCC THE FOLLOWING LINE WAS ADDED JUNE 1989
      CHARACTER*4 ICAPSW
C
CCCCC THE FOLLOWING 8 LINES WERE ADDED FEBRUARY 1992
      CHARACTER*80 ITEMNA
      CHARACTER*12 ITEMST
      CHARACTER*12 ITEMFO
      CHARACTER*12 ITEMAC
      CHARACTER*12 ITEMPR
      CHARACTER*12 ITEMCS
      CHARACTER*4 ITEMEF
CCCCC AUGUST 1992.  FOLLOWING LINE MODIFIED
CCCCC CHARACTER*4 ITEMRW
      CHARACTER*12 ITEMRW
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED FEBRUARY 1992
      CHARACTER*80 CLARG1
      CHARACTER*1 CLARG2
C
CCCCC THE FOLLOWING 6 LINES WERE ADDED MARCH 1992
CCCCC FOR THE ASCII/POSTCRIPT PRINTING TO FILES, AND
CCCCC FOR THE ASCII/POSTCRIPT PRINTING TO THE LASER PRINTER.
      CHARACTER*4 IOUTTY
      CHARACTER*4 IOUTSW
      CHARACTER*4 IPRITY
      CHARACTER*4 IPRISW
      CHARACTER*132 IANSST
      CHARACTER*80 IOUTN0
      CHARACTER*4 IANS4
C
      CHARACTER*4 IHWUSE
      CHARACTER*4 MESSAG
C
C---------------------------------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
C
      DIMENSION IHPNV(10)
      DIMENSION IHPNV2(10)
      DIMENSION ILOCPN(10)
      DIMENSION ASTARV(10)
      DIMENSION AINCV(10)
      DIMENSION ASTOPV(10)
      DIMENSION NUMLOI(10)
      DIMENSION ILOOIT(10)
      DIMENSION ILOOSP(10)
      DIMENSION ILOOEP(10)
      DIMENSION IANSLO(MAXLIL,MAXCIL)
      DIMENSION IWIDLL(MAXLIL)
C
CCCCC THE FOLLOWING LINE WAS CHANGE APRIL 1993
CCCCC DIMENSION IANSSV(MAXLIS,80)
      DIMENSION IANSSV(MAXLIS,MAXCIS)
CCCCC DECEMBER 1997.  ADD FOLLOWING LINE
      DIMENSION IPLTSV(MAXLIP,MAXCIS)
C
      DIMENSION IMAFIL(6)
C
      DIMENSION TEMP(MAXOBV)
      DIMENSION TEMP2(MAXOBV)
      DIMENSION TEMP3(MAXOBV)
      DIMENSION XTEMP1(MAXOBV)
      DIMENSION XTEMP2(MAXOBV)
CCCCC MAY 1995.  EQUIVALENCE ABOVE ARRAYS TO A DUMMY COMMON BLOCK.
CCCCC THIS IS DONE TO AVOID COMPILATION PROBLEMS ON SOME MACHINES
CCCCC THAT HAVE LIMITS ON "LOCAL DATA".  SPECIFICALLY, IT WAS DONE
CCCCC TO MAKE IT COMPILE ON A POWER MACINTOSH.  THIS STEP ISN'T
CCCCC NECCESSARY FOR MOST COMPILERS.
CCCCC COMMON/RGARB3/G3RBAG(5*MAXOBV)
CCCCC EQUIVALENCE (G3RBAG(1),TEMP(1))
CCCCC EQUIVALENCE (G3RBAG(MAXOBV+1),TEMP2(1))
CCCCC EQUIVALENCE (G3RBAG(2*MAXOBV+1),TEMP3(1))
CCCCC EQUIVALENCE (G3RBAG(3*MAXOBV+1),XTEMP1(1))
CCCCC EQUIVALENCE (G3RBAG(4*MAXOBV+1),XTEMP2(1))
C
CCCCC DIMENSION IANSRS(20)     JANUARY 1989
CCCCC DIMENSION IANSLP(10)     JANUARY 1989
CCCCC DIMENSION IANSHI(10)     JANUARY 1989
CCCCC DIMENSION IANSNP(30)     JANUARY 1989
C
      DIMENSION IANSEX(1000)
C
      DIMENSION ICOM3(100)
      DIMENSION ICOM4(100)
      DIMENSION ICOM5(100)
      DIMENSION NCOM5(100)
C
CCCCC CHARACTER*80 CL
C
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1993
      CHARACTER*80 ISTRIN
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED JULY 1993
C
      CHARACTER*1 HORDAS
      CHARACTER*1 VERBAR
      CHARACTER*1 UPLECO
      CHARACTER*1 UPRICO
      CHARACTER*1 LOLECO
      CHARACTER*1 LORICO
 
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOMC.INC'
      INCLUDE 'DPCODB.INC'
      INCLUDE 'DPCOHK.INC'
      INCLUDE 'DPCOPC.INC'
      INCLUDE 'DPCOSU.INC'
CCCCC THE FOLLOWING LINE (FOR WEIBULL MINMAX) WAS ADDED JANUARY 1994
      INCLUDE 'DPCOS2.INC'
      INCLUDE 'DPCODA.INC'
      INCLUDE 'DPCOFO.INC'
      INCLUDE 'DPCOF2.INC'
      INCLUDE 'DPCOSO.INC'
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCONP.INC'
      INCLUDE 'DPCOHO.INC'
      INCLUDE 'DPCOTR.INC'
      INCLUDE 'DPCOBE.INC'
      INCLUDE 'DPCODG.INC'
      INCLUDE 'DPCOCO.INC'
CCCCC THE FOLLOWING COMMON WAS ADDED JANUARY 1989
      INCLUDE 'DPCO3D.INC'
CCCCC THE FOLLOWING 2 COMMON STATEMENTS WERE ADDED (ALAN) FEBRUARY 1989
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCOST.INC'
      INCLUDE 'DPCOCP.INC'
CCCCC THE FOLLOWING DES. OF EXP. COMMON WAS ADDED MAY 1989
      INCLUDE 'DPCODE.INC'
CCCCC THE FOLLOWING MAXCOL COMMON WAS ADDED JULY 1989
      INCLUDE 'DPCOM2.INC'
CCCCC THE FOLLOWING 3 INCLUDE FILES ADDED JUNE 1990.
       INCLUDE 'DPCOZZ.INC'
       INCLUDE 'DPCOZI.INC'
       INCLUDE 'DPCOZD.INC'
       INCLUDE 'DPCOZ2.INC'
CCCCC THE FOLLOWING WINDOW SYSTEM COMMON WAS ADDED AUGUST 1990
      INCLUDE 'DPCOWI.INC'
CCCCC THE FOLLOWING DDS COMMON WAS ADDED APRIL 1996
      INCLUDE 'DPCODD.INC'
CCCCC THE FOLLOWING DDS COMMON WAS ADDED APRIL 1997
      INCLUDE 'DPCOPM.INC'
C
      LOGICAL IOPPLO
      COMMON/OPNPLT/IOPPLO
C
C  OCTOBER 1991.  EXTERNAL STATEMENT FOR BLOCK DATA$
C  NOVEMBER 1991.  BREAK UP BLOCK DATA INTO 10 CHUNKS (PROBLEM ON SGI)
C
      EXTERNAL INITD1
      EXTERNAL INITD2
      EXTERNAL INITD3
      EXTERNAL INITD4
      EXTERNAL INITD5
      EXTERNAL INITD6
CCCCC THE FOLLOWING LINE WAS COMMENTED OUT  SEPTEMBER 1992
CCCCC AND REPLACED WITH THE FOLLOWING 5 LINES  SEPTEMBER 1992
CCCCC EXTERNAL INITD7
      EXTERNAL INID7A
      EXTERNAL INID7B
      EXTERNAL INID7C
      EXTERNAL INID7D
      EXTERNAL INID7E
      EXTERNAL INITD8
      EXTERNAL INITD9
      EXTERNAL INITDZ
C
C  APRIL 1992.  FOLLOWING ADDED FOR NOS/VE.  NOTE THAT LINE MUST START
C  WITH "C$".  IT SHOULD BE A COMMENT ON NON-NOS/VE SYSTEMS.
C  USED TO EXTRACT COMMAND LINE ARGUMENT (CKCLAR).  NOTE THAT THIS
C  STATEMENT MUST BE IN THE MAIN PROGRAM AND THAT THE ARGUMENTS MUST
C  BE NAMED.
C$NVE PARAM('F:STRING;B:STRING')
C
C-----COMMON VARIABLES (GENERAL)-----------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----DATA STATEMENTS-------------------------------------------------
C
CCCCC DATA STATEMENTS FOR IANSRS, IANSLP, IANSHI, AND IANSNP     (JANUARY 1989)
CCCCC WERE REMOVED TO A SEPARATE SUBROUTINE  (DP4PLO)            (JANUARY 1989)
C
C-----START POINT-----------------------------------------------------
C
CCCCC THE FOLLOWING LINE IS AN (UNSUCCESSFUL) TEST LINE OF OTG INTERACTER
CCCCC CALL MENU7
C
      ISUBN1='MAIN'
      ISUBN2='    '
CCCCC APRIL 1995.  ADD FOLLOWING LINE, DO NOT RE-CHECK COMMAND
CCCCC LINE IF RESET COMMAND ENTERED.
      ICKCL=0
CCCCC JULY 1996.  ADD FOLLOWING LINE
      IWBFLG='OFF '
C
C               **************************************
C               **  STEP 1--                        **
C               **  DEFINE NON-PRINTING CHARACTERS  **
C               **************************************
C
C  MAY, 1988: MOVE TO AFTER SET HOST, USE DPCONA ROUTINE
C
CCCCC INULC=CHAR(0)
CCCCC ISOHC=CHAR(1)
CCCCC ISTXC=CHAR(2)
CCCCC IETXC=CHAR(3)
CCCCC IEOTC=CHAR(4)
CCCCC IENQC=CHAR(5)
CCCCC IACKC=CHAR(6)
CCCCC IBELC=CHAR(7)
CCCCC IBSC=CHAR(8)
CCCCC IHTC=CHAR(9)
CCCCC ILFC=CHAR(10)
CCCCC IVTC=CHAR(11)
CCCCC IFFC=CHAR(12)
CCCCC ICRC=CHAR(13)
CCCCC ISOC=CHAR(14)
CCCCC ISIC=CHAR(15)
CCCCC IDLEC=CHAR(16)
CCCCC IDC1C=CHAR(17)
CCCCC IDC2C=CHAR(18)
CCCCC IDC3C=CHAR(19)
CCCCC IDC4C=CHAR(20)
CCCCC INAKC=CHAR(21)
CCCCC ISYNC=CHAR(22)
CCCCC IETBC=CHAR(23)
CCCCC ICANC=CHAR(24)
CCCCC IEMC=CHAR(25)
CCCCC ISUBC=CHAR(26)
CCCCC IESCC=CHAR(27)
CCCCC IFSC=CHAR(28)
CCCCC IGSC=CHAR(29)
CCCCC IRSC=CHAR(30)
CCCCC IUSC=CHAR(31)
C
CCCCC THE FOLLOWING LINE WAS INSERTED (SOFT-CODE BACKSLASH) APRIL 1989
      IBASLC=CHAR(92)
C
C               *********************************************
C               **  STEP 2--                               **
C               **  INITIALIZE VARIABLES AND PARAMETERS.   **
C               **  CALL    MAININ    WHICH IN TURN CALLS  **
C               **  OTHER INITIALIZATION SUBROUTINES       **
C               *********************************************
C
      IBUGIN='OFF'
CCCCC IBUGIN='ON'
  200 CONTINUE
      IBUGI2=IBUGIN
C
CCCCC FOLLOWING CODE MOVED FROM BELOW                   APRIL 1996
      CALL DPCONA(92,IBASLC)
      IF(IHOST1.EQ.'IBM-')THEN
         PATH(1:12)='C: DATAPLOT '
         PATH(3:3)=IBASLC
         PATH(12:12)=IBASLC
         NCPATH=12
      ENDIF
CCCCC THE FOLLOWING 4 LINES WERE ADDED              FEBRUARY 1996
CCCCC BUT THE MENU PATH SETTING MAY BE OVERRIDDEN BY   FEBRUARY 1996
CCCCC A    SET MENU PATH    COMMAND IN DPLOGF.TEX   FEBRUARY 1996
CCCCC OR BY MANUAL ENTRY OF    SET MENU PATH ...    FEBRUARY 1996
CCCCC SOFT-CODE BACKSLASH TO AVOID COMPILATION ERRORS
CCCCC ON UNIX PLATFORMS (WHERE \ IS AN ESCAPE CHARACTER)  APRIL 1996
      IF(IHOST1.EQ.'IBM-')THEN
         MPATH(1:19)='C: TURBOC FRONTEND '
         PATH(3:3)=IBASLC
         PATH(10:10)=IBASLC
         PATH(19:19)=IBASLC
         NCMPAT=19
      ENDIF
C
      ICOMHO=ICOM
      ICOMH2=ICOM2
CCCCC WRITE(ICOUT,769)IBUGMA,IBUGIN,ICOM,ICOM2,ICOMHO,ICOMH2,NUMDEV
CC769 FORMAT('IBUGMA,IBUGIN,ICOM,ICOM2,ICOMHO,ICOMH2,NUMDEV = ',
CCCCC CALL DPWRST('XXX','BUG ')
CCCCC1A4,2X,A4,2X,A4,2X,A4,2X,A4,2X,A4,I8)
      CALL MAININ(IBUGIN,ICOMHO,ICOMH2)
C
CCCCC WRITE(ICOUT,769)IBUGMA,IBUGIN,ICOM,ICOM2,ICOMHO,ICOMH2,NUMDEV
CCCCC CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,770)IMANUF,NUMDEV,IDMANU(1)
  770 FORMAT('AFTER 200 & CALL MAININ--IMANUF,NUMDEV,IDMANU(1) = ',
     1A4,I8,2X,A4)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
CCCCC THE FOLLOWING 3 LINES WERE ADDED JUNE 1992 (JJF)
CCCCC TO INITIALIZE (= EMPTY) THE COMMAND LOG FILE   JUNE 1992
CCCCC FOR SCROLLING USE IN THE C-SIDE FRONT END.   JUNE 1992
CCCCC THE FOLLOWING SECTION WAS MOVED DOWN AFTER      FEBRUARY 1996
CCCCC THE DEFINITIONS OF THE MENU PATH (MPATH)        FEBRUARY 1996
CCCCC THE FOLLOWING 3 LINES WERE ADDED JUNE 1992 (JJF)
CCCCC TO INITIALIZE (= EMPTY) THE COMMAND LOG FILE   JUNE 1992
CCCCC FOR SCROLLING USE IN THE C-SIDE FRONT END.   JUNE 1992
CCCCC IF(IHOST1.EQ.'IBM-')THEN
CCCCC    CALL TCINCF(ISUBRO)
CCCCC ENDIF
C
C               *************************************
C               **  STEP 3--                       **
C               **  INITIALIZE OTHER VARIABLES.    **
C               *************************************
C
      ISTEPN='3'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IVGMSW='OFF'
      IHGMSW='OFF'
C
      IMALE8=(-999)
      IMACN8=(-999)
C
CCCCC THE FOLLOWING 2 LINES ARE NO LONGER NEEDED   JULY 1990
CCCCC (SINCE IHOST1 DEFINITION IS NOW DONE IN INITMC) JULY 1990
CCCCC IHOST1='VAX '
CCCCC IHOST2='    '
      IHOST(1)=IHOST1
      IHOST(2)=IHOST2
CCCCC ISITE='NBS'
C
CCCCC THE FOLLOWING 4 LINES WERE ADDED              DECEMBER 1993
CCCCC BUT THE PATH SETTING MAY BE OVERRIDDEN BY     DECEMBER 1993
CCCCC A    SET PATH    COMMAND IN DPLOGF.TEX        DECEMBER 1993
CCCCC OR BY MANUAL ENTRY OF    SET PATH ...         DECEMBER 1993
CCCCC SOFT-CODE BACKSLASH TO AVOID COMPILATION ERRORS
CCCCC ON UNIX PLATFORMS (WHERE \ IS AN ESCAPE CHARACTER)  APRIL 1996
CCCCC MOVE FOLLOWING BLOCK TO BEFORE CALL TO MAININ
CCCCC (WHICH CALLS INITFO) WHICH CAN OVERRIDE DEFAULT   APRIL 1996
CCCCC CALL DPCONA(92,IBASLC)
CCCCC IF(IHOST1.EQ.'IBM-')THEN
CIBM-    PATH(1:12)='C:\DATAPLOT\'
CCCCC    PATH(1:12)='C: DATAPLOT '
CCCCC    PATH(3:3)=IBASLC
CCCCC    PATH(12:12)=IBASLC
CCCCC    NCPATH=12
CCCCC ENDIF
CCCCC THE FOLLOWING 4 LINES WERE ADDED              FEBRUARY 1996
CCCCC BUT THE MENU PATH SETTING MAY BE OVERRIDDEN BY   FEBRUARY 1996
CCCCC A    SET MENU PATH    COMMAND IN DPLOGF.TEX   FEBRUARY 1996
CCCCC OR BY MANUAL ENTRY OF    SET MENU PATH ...    FEBRUARY 1996
CCCCC SOFT-CODE BACKSLASH TO AVOID COMPILATION ERRORS
CCCCC ON UNIX PLATFORMS (WHERE \ IS AN ESCAPE CHARACTER)  APRIL 1996
CCCCC IF(IHOST1.EQ.'IBM-')THEN
CIBM-    MPATH(1:19)='C:\TURBOC\FRONTEND\'
CCCCC    MPATH(1:19)='C: TURBOC FRONTEND '
CCCCC    PATH(3:3)=IBASLC
CCCCC    PATH(10:10)=IBASLC
CCCCC    PATH(19:19)=IBASLC
CCCCC    NCMPAT=19
CCCCC ENDIF
C
CCCCC THE FOLLOWING SECTION WAS MOVED FROM ABOVE           FEBRUARY 1996
CCCCC TO HERE AFTER THE DEFINITIONS OF THE MENU PATH (MPATH) FEBRUARY 1996
CCCCC THE FOLLOWING 3 LINES WERE ADDED JUNE 1992 (JJF)
CCCCC TO INITIALIZE (= EMPTY) THE COMMAND LOG FILE   JUNE 1992
CCCCC FOR SCROLLING USE IN THE C-SIDE FRONT END.   JUNE 1992
      IF(IHOST1.EQ.'IBM-')THEN
         CALL TCINCF(ISUBRO)
      ENDIF
C
CCCCC THE FOLLOWING CALL TO TCINCO WAS MOVED      FEBRUARY 1996
CCCCC FROM INITOD                                 FEBRUARY 1996
CCCCC SO THAT THE MENU PATH WILL ALREADY EXIST       FEBRUARY 1996
      IF(IHOST1.EQ.'IBM-')THEN
         CALL TCINCO(ISUBRO)
      ENDIF
C
CCCCC THE FOLLOWING 6 LINES WERE ADDED FEBRUARY 1992
      ITEMNU=19
      ITEMNA='DPARG.TEX'
      ITEMST='UNKNOWN'
      ITEMFO='FORMATTED'
      ITEMAC='SEQUENTIAL'
      ITEMRW='READONLY'
C
C  MAY,1988.  SET NON-PRINTING CHARACTERS AFTER HOST IS DEFINED.
C             USE "DPCONA" ROUTINE RATHER THAN EXPLICIT CHAR FUNCTION.
C             INTENDED FOR NON-ASCII MACHINES.
C               **************************************
C               **  STEP 1--                        **
C               **  DEFINE NON-PRINTING CHARACTERS  **
C               **************************************
C  MAY, 1988: MOVE TO AFTER SET HOST, USE DPCONA ROUTINE
C
      CALL DPCONA(0,INULC)
      CALL DPCONA(1,ISOHC)
      CALL DPCONA(2,ISTXC)
      CALL DPCONA(3,IETXC)
      CALL DPCONA(4,IEOTC)
      CALL DPCONA(5,IENQC)
      CALL DPCONA(6,IACKC)
      CALL DPCONA(7,IBELC)
      CALL DPCONA(8,IBSC)
      CALL DPCONA(9,IHTC)
      CALL DPCONA(10,ILFC)
      CALL DPCONA(11,IVTC)
      CALL DPCONA(12,IFFC)
      CALL DPCONA(13,ICRC)
      CALL DPCONA(14,ISOC)
      CALL DPCONA(15,ISIC)
      CALL DPCONA(16,IDLEC)
      CALL DPCONA(17,IDC1C)
      CALL DPCONA(18,IDC2C)
      CALL DPCONA(19,IDC3C)
      CALL DPCONA(20,IDC4C)
      CALL DPCONA(21,INAKC)
      CALL DPCONA(22,ISYNC)
      CALL DPCONA(23,IETBC)
      CALL DPCONA(24,ICANC)
      CALL DPCONA(25,IEMC)
      CALL DPCONA(26,ISUBC)
      CALL DPCONA(27,IESCC)
      CALL DPCONA(28,IFSC)
      CALL DPCONA(29,IGSC)
      CALL DPCONA(30,IRSC)
      CALL DPCONA(31,IUSC)
CCCCC THE FOLLOWING LINE WAS INSERTED (SOFT-CODE BACKSLASH) APRIL 1989
      CALL DPCONA(92,IBASLC)
C
CCCCC MAXNPP=1000    AUGUST 15, 1986
CCCCC MAXNPP=5000         JUNE 1987
      MAXNPP=MAXPOP
C
      DEFANG=ADEFAN
      ANGLE=ATEXAN
      IDEANU=IDEFAU
      IANGLU=ITEXAU
C
CCCCC MAXNXT=MAXN
C CHANGED OCTOBER, 1987 (IF SET ROWS GREATER THAN DEFAULT)
      MAXNXT=MAXOBV
C
      IWIDEX=(-999)
C
CCCCC THE FOLLOWING LINE WAS ADDED DECEMBER 1988
CCCCC AND THEN CHANGED (FROM .5 TO .1) NOVEMBER 1989
CCCCC ALOWFR=0.5
      ALOWFR=0.1
CCCCC THE FOLLOWING LINE WAS ADDED MARCH 1994
      ALOWDG=1.0
C
CCCCC THE FOLLOWING 4 LINES WERE INSERTED NOVEMBER 1989
      YATCCU=CPUMAX
      YATTCU=CPUMAX
      YATRCU=CPUMAX
      IYATOS='123'
      IYATRS='MEAN'
C
      IFOUND='NO'
      IERROR='NO'
C
      IMACRO='OFF'
      IMACNU=IRD
      IMACCS='JUNK        '
CCCCC THE FOLLOWING 3 LINES WERE ADDED     AUGUST 1994
CCCCC IMACL1 = FIRST LINE OF MACRO TO EXECUTE
CCCCC IMACL2 = LAST  LINE OF MACRO TO EXECUTE
CCCCC IMACLR = NUMBER OF LINES OF MACRO ALREADY EXECUTED
      IMACL1=1
      IMACL2=99999
      IMACLR=0
      IMACOL='OFF'
      IMALEV=0
C
      IOUNI0=IRD
C
      IPROGR='OFF'
      ICONCL='OFF'
      IEOF='NO'
C
      ITOPIC='JUNK'
C
      ICASIF='TRUE'
      IIFSW='TRUE'
CCCCC FOLLOWING 4 LINES ADDED NOVEMBER 1992 (NESTED IF'S)
      DO210I=1,MAXIF
        ICASI2(I)='TRUE'
        ICASI3(I)='FALS'
 210  CONTINUE
      NUMIF=0
C
CCCCC THE FOLLOWING SECTION WAS CHANGED AUGUST 1992
CCCCC IX3AUT='OFF'
CCCCC ITIAUT='OFF'
CCCCC IY1AUT='OFF'
CCCCC IX1AUT='OFF'
      ITIAUT='OFF'
      IX1AUT='OFF'
      IX2AUT='OFF'
      IX3AUT='OFF'
      IY1AUT='OFF'
      IY2AUT='OFF'
C
      I4PLOT='OFF'
      I4DONE=(-999)
      IERAS2='-999'
      ICOPS2='-999'
      ICHAP2='-999'
      ILINP2='-999'
      IFEED9='-999'
C
      IEXPSW='TOP'
      IEXPCO='0           '
      IEXPAL='OFF'
      IEX1CO='0           '
      IEX1AL='OFF'
      IEX2CO='0           '
      IEX2AL='OFF'
      IEX3CO='0           '
      IEX3AL='OFF'
      IEX4CO='0           '
      IEX4AL='OFF'
      IEX5CO='0           '
      IEX5AL='OFF'
C
      IHELSW='TOP'
      IHELCO='0           '
      IHELAL='OFF'
      IHE1CO='0           '
      IHE1AL='OFF'
      IHE2CO='0           '
      IHE2AL='OFF'
      IHE3CO='0           '
      IHE3AL='OFF'
      IHE4CO='0           '
      IHE4AL='OFF'
      IHE5CO='0           '
      IHE5AL='OFF'
      IHE6CO='0           '
      IHE6AL='OFF'
      IHE7CO='0           '
      IHE7AL='OFF'
      IHE8CO='0           '
      IHE8AL='OFF'
      IHE9CO='0           '
      IHE9AL='OFF'
C
CCCCC IF(IHOST1.EQ.'CDC')OPEN(IRD,FILE='INPUT')
CCCCC IF(IHOST1.EQ.'CDC')OPEN(IPR,FILE='OUTUT')
C
      IPASS=0
      IWIDSV=0
      IWIDTH=0
      NUMCHA=0
C
      IMPSW='OFF'
      IMPNR=2
      IMPNC=2
      IMPCO=1
      PMXMIN=15.0
      PMXMAX=85.0
      PMYMIN=20.0
      PMYMAX=90.0
C
      IERASV=IERASW
      PWXMIS=PWXMIN
      PWXMAS=PWXMAX
      PWYMIS=PWYMIN
      PWYMAS=PWYMAX
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED     APRIL 1992
      BARHEF=1.0
      BARWEF=1.0
C
C     THE FOLLOWING IS FOR ALL 32-BIT AND HIGHER COMPUTERS
C
      IDEFSE=305
C
C     THE FOLLOWING IS FOR THE UNIVAC--
CCCCC IDEFSE=20867350019
C
C     THE FOLLOWING IS FOR THE VAX--
CCCCC IDEFSE=867350019
C
      ISEED=IDEFSE
CCCCC THE FOLLOWING 2 LINES WERE ADDED JANUARY 1989
      IDEBOO=100
      IBOOSS=IDEBOO
      ANOPL1=CPUMIN
      ANOPL2=CPUMAX
      ICASAN='NONE'
      ICASPL='NONE'
      ICONT='ON'
      IAND1='NO'
      IAND2='NO'
      INEGSW='OFF'
C
      IREPST='OFF'
      IREPS1=1
      IREPS2=1
      IREPNU=1
      IREPTO=1
      IREPPO=1
      IPOINT=1
CCCCC IREPMX=10
CCCCC IREPMX=20
CCCCC IREPMX=50     JUNE 1987
      IREPMX=MAXLIS
      ILISMX=20
C
      DO310J=1,IREPMX
      DO320I=1,MAXWID
      IANSSV(J,I)=' '
  320 CONTINUE
  310 CONTINUE
CCCCC ADD FOLLOWING SECTION DECEMBER 1997
      IPLTST='OFF'
      IPLTNU=0
      IPLTPO=0
      IPLTMX=MAXLIP
C
      DO330J=1,IPLTMX
      DO340I=1,MAXWID
      IPLTSV(J,I)=' '
  340 CONTINUE
  330 CONTINUE
C
      ISACNC=ISACNA
C
      IAUTSW='OFF'
      IAUTEX='OFF'
C
      IFENSW='OFF'
C
      ITRANS='OFF'
C
      DEMATN=CPUMIN
      XMATN=DEMATN
      YMATN=DEMATN
      DEMITN=CPUMIN
      XMITN=DEMITN
      YMITN=DEMITN
C
      ILOOST='OFF'
      ILOOLI=0
      NUMLIL=0
      NUMLOS=0
      NUMENS=0
      NUMLOE=0
      NUMENE=0
C
      DO350I=1,10
        IHPNV(I)='    '
        IHPNV2(I)='    '
        ILOCPN(I)=-99
        ASTARV(I)=-99.0
        AINCV(I)=-99.0
        ASTOPV(I)=-99.0
        NUMLOI(I)=0
        ILOOIT(I)=0
        ILOOSP(I)=-99
        ILOOEP(I)=-99
  350 CONTINUE
C
      DO360I=1,MAXLIL
        IWIDLL(I)=0
        DO370J=1,MAXCIL
          IANSLO(I,J)='    '
  370   CONTINUE
  360 CONTINUE
C
      MAXMAC=6
      DO380I=1,MAXMAC
        IMAFIL(I)='NO'
  380 CONTINUE
C
      IBUGLO='OFF'
C
      IBUGUG='OFF'
      IBUGU2='OFF'
      IBUGU3='OFF'
      IBUGU4='OFF'
C
      ISUBRO='XXXX'
C
      IBUGEX='OFF'
      IBUGE2='OFF'
C
      IBUGHE='OFF'
      IBUGH2='OFF'
C
      ISQUAR='OFF'
      IPROSW='ON'
      IOFILE='-999'
      IFILNU=(-999)
C
      NUMCOM=0
      NCTEMP=0
      DO390I=1,100
      NCOM5(I)=0
  390 CONTINUE
C
CCCCC THE FOLLOWING LINE WAS FIXED (SOFT-CODE BACKSLASH) APRIL 1989
CCCCC IREPCH=IBASLC
CCCCC THE FOLLOWING 2 LINES WERE ADDED JUNE 1989
CCCCC IF(IHOST1.EQ.'IBM-')IREPCH='#'
CCCCC IF(IHOST1.EQ.'COMP')IREPCH='#'
CCCCC THE FOLLOWING LINES WAS ADDED JULY 1989
      IREPCH='^'
C
      IOSW='FLOA'
C
      ISYSSW='-999'
      IEXIST='-999'
C
CCCCC THE FOLLOWING LINE WAS FIXED JUNE 1990
CCCCC IGUNIT=IPR
      IGUNIT=IPRGR
C
      NUMTRA=0
C
      IPPDE1='-999'
      IPPDE2='-999'
      ICPREP='                                        '
      ICPOST='                                        '
      NCPREP=0
      NCPOST=0
C
      ICPREH='                                        '
      ICPOSH='                                        '
      NCPREH=0
      NCPOSH=0
C
CCCCC IHELMX=100000  JULY 1988
      IHELMX=20
C
CCCCC AUGUST 1995.  SET THIS TO DO THE "+" CASE BY DEFAULT.
CCCCC IFTEXP='-'
      IFTEXP='+'
CCCCC AUGUST 1995.  ADD FOLLOWING LINE
      IFTORD='DATA'
C
      IFORSW='E'
C
      ICREAF(1:40)='                                        '
      ICREAF(41:80)='                                        '
      NCREAF=0
      ICWRIF(1:40)='                                        '
      ICWRIF(41:80)='                                        '
      NCWRIF=0
C
      IREARW='ON'
      IWRIRW='ON'
C
CCCCC FOLLOWING 3 LINES ADDED APRIL 1995
      IUNFOF=0
      IUNFNR=0
      IUNFMC=0
CCCCC FOLLOWING LINE ADDED MARCH 1996
      IRHSTG='AREA'
C
      IX1TSV=IX1TSC
      IX2TSV=IX2TSC
      IY1TSV=IY1TSC
      IY2TSV=IY2TSC
C
      IX1ZSV=IX1ZFM
      IX2ZSV=IX2ZFM
      IY1ZSV=IY1ZFM
      IY2ZSV=IY2ZFM
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED JUNE 1989
      ICAPSW='OFF'
      IPRDEF=IPR
C
CCCCC THE FOLLOWING 5 LINES WERE ADDED MARCH 1992
CCCCC FOR THE ASCII/POSTCRIPT PRINTING TO FILES, AND
CCCCC FOR THE ASCII/POSTCRIPT PRINTING TO THE LASER PRINTER.
      IOUTTY='ASCI'
      IOUTSW='OFF'
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1993
CCCCC IPRITY='ASCI'
      IPRITY='POST'
      IPRISW='OFF'
      IOUTN0=IOUTNA
C
      IOPPLO=.FALSE.
C
CCCCC THE FOLLOWING LINE WAS ADDED             FEBRUARY 1993
CCCCC TO PROVIDE AN INITIAL VALUE TO THE       FEBRUARY 1993
CCCCC TURBO-C MENU GRAPHICS PLATFORM VARIABLE  FEBRUARY 1993
      IPLATF='      '
 
C               *************************************
C               **  STEP 4--                       **
C               **  PRINT OUT POST-INITIALIZATION  **
C               **  SETTINGS OF                    **
C               **  IMPORTANT VARIABLES.           **
C               *************************************
C
      ISTEPN='4'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGI2.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO490
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,451)
  451 FORMAT('YOU HAVE JUST RETURNED TO    MAIN    AFTER ')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,452)
  452 FORMAT('EXECUTION OF ALL OF THE INITIALIZATION SUBROUTINES--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,453)IPR,IRD,CPUMIN,CPUMAX
  453 FORMAT('IPR,4IRD,CPUMIN,CPUMAX = ',2I6,2E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,454)NUMBPC,NUMCPW,NUMBPW
  454 FORMAT('NUMBPC,NUMCPW,NUMBPW = ',3I6)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,461)IMESNU,IMESNA,IMESST
  461 FORMAT('IMESNU,IMESNA,IMESST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,462)INEWNU,INEWNA,INEWST
  462 FORMAT('INEWNU,INEWNA,INEWST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,463)IMAINU,IMAINA,IMAIST
  463 FORMAT('IMAINU,IMAINA,IMAIST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,464)IHELNU,IHELNA,IHELST
  464 FORMAT('IHELNU,IHELNA,IHELST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,465)IBUGNU,IBUGNA,IBUGST
  465 FORMAT('IBUGNU,IBUGNA,IBUGST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,466)IQUENU,IQUENA,IQUEST
  466 FORMAT('IQUENU,IQUENA,IQUEST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,467)ILOGNU,ILOGNA,ILOGST
  467 FORMAT('ILOGNU,ILOGNA,ILOGST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,468)IREANU,IREANA,IREAST
  468 FORMAT('IREANU,IREANA,IREAST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,469)IWRINU,IWRINA,IWRIST
  469 FORMAT('IWRINU,IWRINA,IWRIST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,470)ISAVNU,ISAVNA,ISAVST
  470 FORMAT('ISAVNU,ISAVNA,ISAVST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,471)ILISNU,ILISNA,ILISST
  471 FORMAT('ILISNU,ILISNA,ILISST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,472)ICRENU,ICRENA,ICREST
  472 FORMAT('ICRENU,ICRENA,ICREST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,473)ISCRNU,ISCRNA,ISCRST
  473 FORMAT('ISCRNU,ISCRNA,ISCRST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,474)IDATNU,IDATNA,IDATST
  474 FORMAT('IDATNU,IDATNA,IDATST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,475)IPL1NU,IPL1NA,IPL1ST
  475 FORMAT('IPL1NU,IPL1NA,IPL1ST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,476)IPL2NU,IPL2NA,IPL2ST
  476 FORMAT('IPL2NU,IPL2NA,IPL2ST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,477)IPRONU,IPRONA,IPROST
  477 FORMAT('IPRONU,IPRONA,IPROST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,478)ICONNU,ICONNA,ICONST
  478 FORMAT('ICONNU,ICONNA,ICONST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,479)IEX1NU,IEX1NA,IEX1ST
  479 FORMAT('IEX1NU,IEX1NA,IEX1ST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,480)ISYSNU,ISYSNA,ISYSST
  480 FORMAT('ISYSNU,ISYSNA,ISYSST = ',I8,2X,A80,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,483)ICRENU,ICREST
  483 FORMAT('ICRENU,ICREST = ',I8,2X,A12)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,484)MAXN,MAXCOL,MAXNAM,NUMNAM
  484 FORMAT('MAXN,MAXCOL,MAXNAM,NUMNAM = ',4I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,485)IBUGIN,IBUGMA
  485 FORMAT('IBUGIN,IBUGMA = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,486)ICASAN,IMACRO
  486 FORMAT('ICASAN,IMACRO = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,487)IAND1,IAND2
  487 FORMAT('IAND1,IAND2 = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
CCCCC WRITE(ICOUT,488)ICOLOR,IPLOTF
CC488 FORMAT('ICOLOR,IPLOTF = ',A4,2X,A4)
CCCCC CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
  490 CONTINUE
CCCCC IF(ICOMHO.EQ.'RESE')GOTO1000
      IF(ICOMHO.EQ.'RESE')GOTO920
C
C               **********************************
C               **  STEP 5--                    **
C               **  ACCUMULATE LOG  STATISTICS  **
C               **  (IF CALLED FOR)             **
C               **********************************
C
CCCCC ISTEPN='5'
CCCCC IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
CCCCC1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
CCCCC
CCCCC CALL DPLOGS(ILOGNU,ILOGFS,ILOGST,
CCCCC1IANS,IWIDTH,IBUGMA,IFOUND,IERROR)
C
CCCCC THE FOLLOWING SECTION WAS ADDED AUGUST 1990
C               ******************************************
C               **  IF A WINDOW SYSTEM IS AVAILABLE,    **
C               **  OPEN  THE SYSTEM,                   **
C               **  DEFINE COLORS, SIZE, TYPE, ETC.     **
C               **  AND OPEN  THE WINDOW.               **
C               ******************************************
C
CCCCC IBUGWI='ON'
CCCCC IF(IWINSY.EQ.'NONE')GOTO609
CCCCC ICURWI=1
CCCCC CALL WIINIT('OFF ')
CCCCC CALL WISECO('BLUE','WHIT',ICURWI)
CCCCC CALL WISETY('ON  ','OFF ','OFF ',ICURWI)
CCCCC CALL WISECC(1,1,80,24,ICURWI)
CCCCC CALL WIOPEN(ICURWI)
CCCCC THE FOLLOWING LINE WAS COMMENTED OUT FEBRUARY 1992
CC609 CONTINUE
CCCCC THE FOLLOWING LINE IS AN (UNSUCCESSFUL) TEST LINE OF OTG INTERACTER
CCCCC CALL MENU7
C
CCCCC THE FOLLOWING SECTION (OPEN CONCLUSIONS FILE)  FEBRUARY 1992
CCCCC WAS MOVED FROM BELOW SECTION 7   FEBRUARY 1992
CCCCC IT USED TO BE CALLED SECTION 8.   FEBRUARY 1992
CCCCC IT IS NOW CALLED SECTION 5B.     FEBRUARY 1992
C               ****************************************************
C               **  STEP 5B--                                      **
C               **  IF A CONCLUSIONS FILE                         **
C               **  (USED BY THE AUTOCORRELATION PLOT AND         **
C               **  THE CROSS-CORRELATION PLOT COMMANDS)          **
C               **  MAY EXIST, OPEN IT NOW.                       **
C               ****************************************************
C
      ISTEPN='5B'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICONST.EQ.'NONE')GOTO890
      IFILNU=ICONNU
      CALL DPOPF0(IFILNU,IBUGMA,ISUBRO,IERROR)
  890 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED MAY 1992 (JJF)
C               **************************************************
C               **  STEP XX--                                   **
C               **  DEFINE (AND OPEN) DEVICE 3                  **
C               **  POSTSCRIPT FILE                             **
C               **  TO BE USED IN CONJUNCTION                   **
C               **  WITH THE    P     COMMAND                   **
C               **  FOR AFTER-THE-FACT POSTSCRIPT PRINTING      **
C               **************************************************
C
      IDTEMP=3
      IF(IPL2CS.EQ.'CLOSED')
     1CALL DPDEV(IDTEMP,'DEFI','POST',ICAPSW,IBUGMA,ISUBRO,IERROR)
CCCCC JANUARY 1997.  IF IERROR IS YES, THEN PRINT A MESSAGE AND
CCCCC TERMINATE DATAPLOT.  PROBABLE CAUSE IS THAT DATAPLOT IS RUN
CCCCC IN A "READ-ONLY" DIRECTORY.  STOP RATHER THAN HAVE AN ABORT.
C
CCCCC AUGUST 2005: DON'T ABORT. THIS CAUSES PROBLEMS IN THE WINDOWS
CCCCC              VERSION OF GUI.
C
      IF(IERROR.EQ.'YES')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,891)
  891   FORMAT('DATAPLOT WAS UNABLE TO OPEN THE PLOT OUTPUT FILE ',
     1         'DPPL2F.DAT.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,892)
  892   FORMAT('POSSIBLE CAUSES INCLUDE:')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,893)
  893   FORMAT(' 1. RUNNING DATAPLOT FROM A READ-ONLY DIRECTORY.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,894)
  894   FORMAT(' 2. DPPL2F.DAT MAY BE "LOCKED" BY ANOTHER ',
     1         'APPLICATION.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,895)
  895   FORMAT('    IN THIS CASE, TRY CLOSING THE OTHER APPLICATION.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,896)
  896   FORMAT('    IN PARTICULAR, IF THE GUI VERSION IS NOT ',
     1         'CLOSED CLEANLY,')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,897)
  897   FORMAT('    A "DPLAHEY.EXE" PROCESS MAY STILL BE RUNNING.  ',
     1         'IN THIS CASE')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,898)
  898   FORMAT('    A. ENTER CNTRL-ALT-DELETE TO INITIATE THE ',
     1         'WINDOWS TASK MANAGER.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,899)
  899   FORMAT('    B. SELECT "PROCESSES".')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,88991)
88991   FORMAT('    C. IF MULTIPLE OCCURENCES OF "DPLAHEY.EXE" ARE',
     1         'FOUND, THEN')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,88993)
88993   FORMAT('    CLOSE THE CURRENT DATAPLOT SESSION AND DELETE ')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,88995)
88995   FORMAT('    ANY REMAINING OCCURENCES OF "DPLAHEY.EXE"')
        CALL DPWRST('XXX','BUG ')
CCCCC   WRITE(ICOUT,893)
CC893   FORMAT('DATAPLOT SESSION WILL BE TERMINATED.')
CCCCC   CALL DPWRST('XXX','BUG ')
        IPL2CS='CLOSED'
        IDMOD3(NUMDEV)='DEV3'
CCCCC   STOP
      ELSE
        IPL2CS='OPEN'
        IDMOD3(NUMDEV)='DEV3'
      ENDIF
C
C
CCCCC THE FOLLOWING SECTION WAS ADDED FEBRUARY 1992
C               **********************************************
C               **  STEP 6A--                               **
C               **  TREAT COMMAND LINE ARGUMENTS.        **
C               **  HOW MANY ARGUMENTS EXIST      **
C               **  AFTER THE DP COMMAND?          **
C               **  NONE, 1, OR 2?          **
C               **  0) IF NONE,          **
C               **     THEN HAVE THE USUAL ENTRY INTO DATAPLOT          **
C               **     (PRINT BANNER, PRINT MESSAGE          **
C               **     AND EXECUTE 2 LOGIN FILES)          **
C               **  1) IF 1 ARGUMENT,          **
C               **     THEN HAVE THE USUAL ENTRY INTO DATAPLOT          **
C               **     (PRINT BANNER, PRINT MESSAGE          **
C               **     AND EXECUTE 2 LOGIN FILES)          **
C               **     + FORM AND EXECUTE A LINE          **
C               **          CALL ARGUMENT-1          **
C               **  2A) IF 2 ARGUMENTS AND ARG 2 = 1          **
C               **     THEN HAVE THE USUAL ENTRY INTO DATAPLOT          **
C               **     (PRINT BANNER, PRINT MESSAGE          **
C               **     AND EXECUTE 2 LOGIN FILES)          **
C               **     + FORM AND EXECUTE A LINE          **
C               **          CALL ARGUMENT-1          **
C               **  2B) IF 2 ARGUMENTS AND ARG 2 = 0          **
C               **     THEN SKIP THE USUAL ENTRY INTO DATAPLOT          **
C               **     (THEREFORE NOT PRINT BANNER, NOT PRINT MESSAGE          **
C               **     AND NOT EXECUTE 2 LOGIN FILES)          **
C               **     BUT DO FORM AND EXECUTE A LINE          **
C               **          CALL ARGUMENT-1          **
C               **     (THEREFORE SHOULD BE FAST)          **
C               **********************************************
C
      ISTEPN='6A'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC ISUBN0='MAIN'
CCCCC ISUBRO='CLAR'
CCCCC ISUBRO='MACR'
CCCCC APRIL 1995.  ADD FOLLOWING LINE, DO NOT RE-CHECK COMMAND
CCCCC LINE IF RESET COMMAND ENTERED.
      IF(ICKCL.GT.0)GOTO608
      CALL CKCLAR(ITEMNU,ITEMNA,ITEMST,ITEMFO,
     1ITEMAC,ITEMPR,ITEMCS,ITEMEF,ITEMRW,
     1NUMCLA,CLARG1,CLARG2,ISUBN0,IBUGS2,ISUBRO,IERRFI)
 608  CONTINUE
C
      IF(NUMCLA.LE.1)GOTO609
      IF(CLARG2(1:1).EQ.'0')GOTO970
      IF(CLARG2(1:1).EQ.'1')GOTO920
      IF(CLARG2(1:1).EQ.'2')GOTO960
  609 CONTINUE
C
C               **********************************************
C               **  STEP 6B--                               **
C               **  WRITE OUT THE DATAPLOT BANNER.          **
C               **********************************************
C
      ISTEPN='6B'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC THE FOLLOWING 14 LINES WERE ADDED   JULY 1993
      IF(IHOST1.EQ.'IBM-')THEN
         HORDAS=CHAR(205)
         VERBAR=CHAR(186)
         UPLECO=CHAR(201)
         UPRICO=CHAR(187)
         LOLECO=CHAR(200)
         LORICO=CHAR(188)
      ELSE
         HORDAS='-'
         VERBAR='|'
         UPLECO='-'
         UPRICO='-'
         LOLECO='-'
         LORICO='-'
      ENDIF
C
CCCCC THE BANNER SECTION WAS CHANGED   JULY 1993
CCCCC ALONG WITH A FEW FORMAT NUMBERS   JULY 1993
CCCCC THE FOLLOWING LINE WAS CHANGED JULY 1992
CCCCC IVERSI='92.8'
      IVERSI='2006.3'
C
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
C
CCCCC WRITE(ICOUT,610)
CC610 FORMAT(6X,'----------------------------------------------------')
CCCCC CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,610)UPLECO,(HORDAS,I=1,50),UPRICO
  610 FORMAT(6X,52A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,611)VERBAR,VERBAR
  611 FORMAT(6X,A1,
     1'                    Dataplot                      ',A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,612)VERBAR,VERBAR
  612 FORMAT(6X,A1,
     1'  Interactive Graphics & Data Analysis Language   ',A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,613)VERBAR,VERBAR
  613 FORMAT(6X,A1,
     1'       James J. Filliben   and   Alan Heckert     ',A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,614)VERBAR,VERBAR
  614 FORMAT(6X,A1,
     1'    Information Technology Laboratory             ',A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,615)VERBAR,VERBAR
  615 FORMAT(6X,A1,
     1'   National Institute of Standards and Technology ',A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,616)VERBAR,VERBAR
  616 FORMAT(6X,A1,
     1'          301-975-2855  and  301-975-2899         ',A1)
      CALL DPWRST('XXX','BUG ')
C
CCCCC THE FOLLOWING 3 LINES WERE CHANGED JULY 1992
CCCCC WRITE(ICOUT,615)IVERSI
CC615 FORMAT(6X,'----------------------------------------------------',
CCCCC1'  VERSION ',A12)
CCCCC CALL DPWRST('XXX','BUG ')
CCCCC WRITE(ICOUT,610)
CCCCC CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,617)LOLECO,(HORDAS,I=1,50),LORICO
  617 FORMAT(6X,52A1)
      CALL DPWRST('XXX','BUG ')
C
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,621)MAXN
  621 FORMAT('         Number of Observations per Variable = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,622)MAXCOL
  622 FORMAT('         Number of Variables                 = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,623)MAXNK
  623 FORMAT('         Total Internal Data Space Size      = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,624)IREPCH
  624 FORMAT('         Substitution/Replacement Character  = ',7X,A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
C
C               ****************************************************
C               **  STEP 7--                                      **
C               **  IF A SIGN-ON MESSAGE FILE                     **
C               **  (CONSISTING OF CURRENT DATAPLOT INFORMATION)  **
C               **  EXISTS AT THIS COMPUTER INSTALLATION,         **
C               **  WRITE OUT SUCH MESSAGES FOR THE ANALYST'S     **
C               **  PERUSAL                                       **
C               ****************************************************
C
      ISTEPN='7'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IMESST.EQ.'NONE')GOTO790
C
CCCCC -----SET EARLY DEBUG INFO HERE   INIT
CCCCC IBUGS2='ON'
CCCCC IBUGMA='ON'
C
      CALL DPMESS(IBUGS2,ISUBRO,IFOUND,IERROR)
  790 CONTINUE
C
CCCCC SECTION 8 (OPEN CONCLUSIONS FILE)    FEBRUARY 1992
CCCCC WAS MOVED UP TO BEFORE SECTION 6A   FEBRUARY 1992
CCCCC IN ITS NEW PLACE, SECTION 8 IS CALLED SECTION 5B FEBRUARY 1992
CCCCC (SECTION 8 USED TO BE RIGHT HERE)  FEBRUARY 1992
C
C               *************************************************************
C               **  STEP 9A--                                              **
C               **  (FOR NBS UNIVAC COMPUTER ONLY)                         **
C               **  HAVE A DUMMY READ OF 1 LINE AFTER THE DATAPLOT HEADER  **
C               **  TO ABSORB AN EXTRANEOUS LINE GENERATED                 **
C               **  BY THE UNIVAC SYSTEM SOFTWARE WHEN FIRST ACCESSING DATAPLOT.
C               *************************************************************
C
      ISTEPN='9A'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IHOST1.EQ.'UNIV'.AND.ICOM.NE.'RESE')READ(IRD,911)
  911 FORMAT(1X)
C
C               *************************************************************
C               **  STEP 9B--                                              **
C               **  GENERATE A COMMAND STATEMENT (AND THEN EXECUTE IT)     **
C               **  WHICH STATES THAT WE SHOULD    CALL DPSYSF.TEX         **
C               **  (THIS ALLOWS US TO EXECUTE A SYSTEM "LOGIN" FILE        **
C               **  WHEN SIGNING ONTO DATAPLOT WHICH IN TURN ALLOWS        **
C               **  AN IMPLEMENTOR TO EASILY TAILOR DATAPLOT               **
C               **  FOR AN INDIVIDUAL SITE/INSTITUTIONS/).                 **
C               *************************************************************
C
  920 CONTINUE
C
      ISTEPN='9B'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IANSLC(1)='C   '
      IANSLC(2)='A   '
      IANSLC(3)='L   '
      IANSLC(4)='L   '
      IANSLC(5)='    '
      J=0
      DO950I=6,80
      J=J+1
      IANSLC(I)=ISYSNA(J:J)
  950 CONTINUE
      IWIDTH=80
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1992
CCCCC ISYSSW='EXEC'
      ISYSSW='EXSY'
      GOTO1400
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1992
  959 CONTINUE
      IF(NUMCLA.GE.2.AND.CLARG2(1:1).EQ.'1')GOTO970
C
C               *************************************************************
C               **  STEP 9C--                                              **
C               **  GENERATE A COMMAND STATEMENT (AND THEN EXECUTE IT)     **
C               **  WHICH STATES THAT WE SHOULD    CALL DPLOGF.TEX         **
C               **  (THIS ALLOWS US TO EXECUTE A USER "LOGIN" FILE         **
C               **  WHEN SIGNING ONTO DATAPLOT WHICH IN TURN ALLOWS        **
C               **  AN INDIVIDUAL USER TO EASILY TAILOR DATAPLOT           **
C               **  FOR HIS/HER OWN TERMINAL/PLOTTER.).                    **
C               *************************************************************
C
  960 CONTINUE
      ISTEPN='9C'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC THE FOLLOWING 12 LINES WERE COMMENTED OUT             JUNE 1995
CCCCC SO AS TO ALLOW THE    DPLOGF.TEX    FILE              JULY 1995
CCCCC IN THE DEFAULT DIRECTORY (E.G., C:\DATAPLOT FOR PC'S) JULY 1995
CCCCC TO BE ALWAYS EXECUTED REGARDLESS OF WHAT DIRECTORY    JULY 1995
CCCCC THE ANALYST HAPPENS TO BE IN.                         JULY 1995
C
CCCCC ON UNIX, CHANGE WAS MADE SO THAT LOGIN FILE SEARCHED FOR
CCCCC IN USER'S HOME DIRECTORY (IF HOME ENVIORNMENT VARIABLE EXISTS)
CCCCC RATHER THAN THE CURRENT DIRECTORY.  NOTE THAT THIS CAUSES A
CCCCC AN ERROR MESSAGE SAYING THAT DPLOGF FILE NOT FOUND.  THIS IS
CCCCC BECAUSE A PATH NAME IS NOW GIVEN AS PART OF THE DPLOGF NAME
CCCCC (AND IT THEREFORE DOES NOT SEARCH THE DATAPLOT AUXILLARY FILES
CCCCC DIRECOTRIES CORRECTLY.  TO FIX, CHECK FOR EXISTENCE OF DPLOGF
CCCCC FILE, AND IF NOT FOUND, GIVE THE NAME AS DPLOGF.TEX WITH NO
CCCCC PATH.  THIS WILL LOOK FOR IT IN THE AUXILLARY DIRECTORY. JULY 1996
      IANSLC(1)='C   '
      IANSLC(2)='A   '
      IANSLC(3)='L   '
      IANSLC(4)='L   '
      IANSLC(5)='    '
      J=0
      IF(IOPSY1.EQ.'UNIX')THEN
CCCCC   IOUNIT=ILOGNU
CCCCC   IFORM=ILOGFO
        IFILE=ILOGNA
CCCCC   ISTAT=ILOGST
CCCCC   IACCES=ILOGAC
CCCCC   IREWR=ILOGRW    APRIL 10, 1987 (THIS LINE ONLY)
        ISUBN0='MAIN'
        IERRFI='NO'
C
        CALL DPINFI(IFILE,IEXIST,ISUBN0,IBUGS2,ISUBRO,IERRFI)
        IF(IERRFI.EQ.'YES'.OR.IEXIST.EQ.'NO')THEN
          DO961I=6,80
          IANSLC(I)=' '
  961     CONTINUE
          IANSLC(6)='D   '
          IANSLC(7)='P   '
          IANSLC(8)='L   '
          IANSLC(9)='O   '
          IANSLC(10)='G   '
          IANSLC(11)='F   '
          IANSLC(12)='.   '
          IANSLC(13)='T   '
          IANSLC(14)='E   '
          IANSLC(15)='X   '
          IWIDTH=15
          CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1992
          ISYSSW='EXLO'
          GOTO1400
        ELSE
          DO964I=6,80
          J=J+1
          IANSLC(I)=ILOGNA(J:J)
  964     CONTINUE
          IWIDTH=80
          CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1992
          ISYSSW='EXLO'
          GOTO1400
        ENDIF
      ELSE
CCCCC IF(IERRFI.EQ.'YES')GOTO969
CCCCC IF(IEXIST.EQ.'NO')GOTO969
C
        DO965I=6,80
        J=J+1
        IANSLC(I)=ILOGNA(J:J)
  965   CONTINUE
        IWIDTH=80
        CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
CCCCC THE FOLLOWING LINE WAS ADDED FEBRUARY 1992
        ISYSSW='EXLO'
        GOTO1400
      ENDIF
  969 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED FEBRUARY 1992
C               *************************************************************
C               **  STEP 9D--                                      **
C               **  IF THE COMMAND LINE HAS 1 OR MORE ARGUMENTS,   **
C               ** GENERATE A COMMAND STATEMENT                    **
C               ** CONSISTING OF                                   **
C               **        CALL ARGUMENT     -1                     **
C               ** AND THEN EXECUTE IT                             **
C               *********************************************************
C
  970 CONTINUE
C
      ISTEPN='9D'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMCLA.LE.0)GOTO979
CCCCC APRIL 1995.  ADD FOLLOWING LINE.  DO NOT EXECUTE AFTER A RESET
CCCCC COMMAND.
      IF(ICKCL.GT.0)GOTO979
      ICKCL=ICKCL+1
      IANSLC(1)='C   '
      IANSLC(2)='A   '
      IANSLC(3)='L   '
      IANSLC(4)='L   '
      IANSLC(5)='    '
      J=0
      DO975I=6,80
      J=J+1
      IANSLC(I)=CLARG1(J:J)
  975 CONTINUE
      IWIDTH=80
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
      ISYSSW='EXUS'
      GOTO1400
  979 CONTINUE
CCCCC JANUARY 1998.  ADD FOLLOWING LINE FOR TCL/TK FRONT-END
      CALL DPFLSH(IPR,IBUGS2,ISUBRO,IFOUND,IERROR)
C
C               *********************************************************
C               **  STEP 10--                                          **
C               **  START THE CYCLE--                                  **
C               **  READ IN A LINE FROM THE TERMINAL                   **
C               **  (UNLESS WE ARE IN THE MIDDLE OF EXECUTING A LOOP). **
C               *********************************************************
C
 1000 CONTINUE
C
      IF(IBUGMA.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO1019
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1011)
 1011 FORMAT('---------------------NEW CYCLE-------------------')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      ISTEPN='10'
      CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      WRITE(ICOUT,1004)ICAPSW,ICAPNU,ICAPCS,IPR,IPRDEF
 1004 FORMAT('ICAPSW,ICAPNU,ICAPCS,IPR,IPRDEF = ',A4,I8,2X,A12,2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
  777 FORMAT('IMANUF,NUMDEV,IDMANU(1) = ',A4,I8,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1012)IMACOL,IMACRO,ILOOST,IMALEV,ICRENU,IMACNU
 1012 FORMAT('IMACOL,IMACRO,ILOOST,IMALEV,ICRENU,IMACNU = ',
     1A4,2X,A4,2X,A4,I8,I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1013)ICRENU,ICRECS,IMACCS,IPROGR,ITOPIC,IAUTSW,IAUTEX
 1013 FORMAT('ICRENU,ICRECS,IMACCS,IPROGR,ITOPIC,IAUTSW,IAUTEX = ',
     1I8,2X,A12,2X,A12,2X,A4,2X,A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1014)IMACRO,IPROGR,ICONCL,IEOF
 1014 FORMAT('IMACRO,IPROGR,ICONCL,IEOF = ',A4,2X,A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1015)IWIDTH
 1015 FORMAT('IWIDTH = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1016)(IANS(I),I=1,100)
 1016 FORMAT('(IANS(I),I=1,100) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1017)NUMCHA
 1017 FORMAT('NUMCHA = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1018)(IA(I),I=1,100)
 1018 FORMAT('(IA(I),I=1,100) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
 1019 CONTINUE
CCCCC FOLLOWING BLOCK OF CODE ADDED MAY, 1990.
C
C               ***************************************************************
C               **  STEP 10.5--                                              **
C               **  FOR X11, CALL UPDATE ROUTINE IF PIXMAP SWITCH IS SET.    **
C               **  NOTE THAT THIS IS A TEMPORARY PATCH.  SHOULD PROBABLY    **
C               **  BE MADE MORE GENERAL, I.E., CALL A "REFRESH" ROUTINE     **
C               **  FOR ANY WINDOWING SYSTEM THAT DATAPLOT MIGHT BE RUNNING  **
C               **  UNDER.                                                   **
C               ***************************************************************
C
      ISTEPN='10.5'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
CCCCC JULY 1995.  IF RUNNING FRONT-END MENU SYSTEM, AUTOMATICALLY
CCCCC UPDATE THE GRAPICS SCREEN (XCHECK SEEMS NOT TO WORK WITH TCL/TK
CCCCC AND EXPECT RUNNING THINGS).  REWRITE FOLLOWING SECTION.
CCCCC IF(IX11OF.EQ.'OFF'.OR.IX11PM.EQ.'OFF')GOTO1089
      IF(IX11OF.EQ.'OFF')GOTO1089
      DO1080LL=1,3
        IF(IDMANU(LL).EQ.'X11 ')THEN
          IF(IDMODE(LL).EQ.'    ')THEN
            IF(IX11PM.EQ.'ON')THEN
              CALL XCHECK(IEXPOS,IERRNO)
              IJUNK=0
              IF(IEXPOS.EQ.1)CALL XUPDAT(IJUNK)
            ENDIF
          ELSE
            IJUNK=1
            CALL XUPDAT(IJUNK)
          ENDIF
        ENDIF
 1080 CONTINUE
 1089 CONTINUE
C
C               ***************************************************************
C               **  STEP 11--                                                **
C               **  ARE WE EXECUTING FROM WITHIN A LOOP?                     **
C               **  CHECK LOOP STATUS--                                      **
C               **  IF LOOP STATUS = OFF,     THEN READ A LINE FROM TERMINAL **
C               **  IF LOOP STATUS = STORE,   THEN READ A LINE FROM TERMINAL **
C               **  IF LOOP STATUS = EXECUTE, THEN RETRIEVE A LINE           **
C               **                            FROM AN INTERNAL TABLE OF      **
C               **                            PREVIOUSLY-STORED COMMANDS.    **
C               **  THE MOST COMMON LOOP STATUS IS OFF.                      **
C               ***************************************************************
C
      ISTEPN='11'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
 
      IF(ILOOST.EQ.'EXEC')GOTO1110
      GOTO1190
C
 1110 CONTINUE
      CALL DPLOEX(ILOOST,ILOOLI,NUMLIL,NUMLOE,NUMENE,
     1IHPNV,IHPNV2,ILOCPN,ASTARV,AINCV,ASTOPV,NUMLOI,ILOOIT,
     1ILOOSP,ILOOEP,IANSLO,IWIDLL,MAXLIL,MAXCIL,
     1IANS,IANSLC,IWIDTH,
     1ICOM,ICOM2,ICOMT,ICOMI,ACOM,ICOMLC,ICOML2,
     1IHARG,IHARG2,IARGT,IARG,ARG,IHARLC,IHARL2,NUMARG,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,MAXNAM,
CCCCC ADD FOLLOWING LINE TO FIX DELETE IN LOOP BUG.  FEBRUARY 1994.
     1IN,IIFSW,NUMIF,
     1IHOST1,IHOST2,
     1IBUGLO,IBUGTY,ISUBRO,IERROR)
      IF(ICOM.EQ.'BREA'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'LOOP')
     1GOTO1000
      IF(ILOOST.EQ.'EXEC')GOTO1490
 1190 CONTINUE
C
C               *******************************************************
C               **  STEP 12--                                        **
C               **  ARE WE EXECUTING A PRE-PROGRAM?                  **
C               **  HAVE WE JUST FINISHED EXECUTING A NESTED MACRO?  **
C               *******************************************************
C
      ISTEPN='12'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
 
CCCCC IPASS=1
CCCCC IF(IMACRO.EQ.'OFF')GOTO1219
CCCCC IDEV='MACR'
CCCCC IOP='INPU'
CCCCC IOUNI0=ICRENU
 1219 CONTINUE
C
      IOUNI0=IMACNU
      IF(IPROGR.EQ.'EXEC')IOUNI0=IPRONU
C
      IF(IMACRO.EQ.'EOF'.AND.IMALEV.GE.1)IMACRO='EXEC'
      IF(IMALEV.LE.0)GOTO1290
      IOFILE=IMAFIL(IMALEV)
C
 1290 CONTINUE
      IF(IBUGMA.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO1299
      WRITE(ICOUT,1291)IMALEV,IOUNI0,IOFILE,IMACRO
 1291 FORMAT('IMALEV,IOUNI0,IOFILE,IMACRO = ',
     1I8,I8,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1292)ICRENU,ICRECS,IMACCS
 1292 FORMAT('ICRENU,ICRECS,IMACCS = ',I8,2X,A12,2X,A12)
      CALL DPWRST('XXX','BUG ')
 1299 CONTINUE
C
C               *************************************
C               **  STEP 13--                      **
C               **  GET A COMMAND STATEMENT        **
C               *************************************
C
      ISTEPN='13'
      IF(IBUGMA.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO1309
      CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1301)IAUTSW,IAUTEX,IOUNI0
 1301 FORMAT('IAUTSW,IAUTEX,IOUNI0 = ',A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1302)
 1302 FORMAT('GOING INTO DPGETC TO GET ANOTHER COMMAND...')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1303)
 1303 FORMAT('. . . . . . . . . .')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
 1309 CONTINUE
C
      IF(IAUTSW.EQ.'ON'.AND.IAUTEX.EQ.'ON')GOTO1320
C
CCCCC THE IIFSW ARGUEMNT WAS ADDED TO THE FOLLOWING CALLING SEQUENCE (DEC 1988)
CCCCC TO CORRECT EXTRANEOUS ERROR MESSAGE WHEN HAVE  (DECEMBER 1988)
CCCCC BACKSLASH INSIDE NON-EXECUTING (= FALSE)-IF. (DECEMBER 1988)
CCCCC THE    ICAPSW & IPRDEF    ARGUMENTS WERE ADDED              JUNE 1989
CCCCC TO ALLOW SCREEN-WRITING OF THE PROMPT            JUNE 1989
CCCCC EVEN AS TEXT OUTPUT IS BEING CAPTURED TO A FILE. JUNE 1989
C
      CALL DPGETC(IOUNI0,MAXWID,ITERCH,ICONCH,IANS,IANSLC,IWIDTH,
     1IANSV,IWIDSV,
     1IREPST,IREPPO,IANSSV,IREPMX,IPOINT,
CCCCC ADD FOLLOWING LINE DECEMBER 1997.
     1IPLTST,IPLTPO,IPLTSV,
     1IPROSW,
CCCCC THE FOLLOWING LINE WAS AUGMENTED      AUGUST 1994
CCCCC1IMACRO,IMACNU,IMACCS,
     1IMACRO,IMACNU,IMACCS,IMACL1,IMACL2,IMACLR,IMALEV,
     1IPROGR,
     1ICONCL,
     1IEOF,
     1IIFSW,
     1ICAPSW,IPRDEF,
     1IATXSW,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,IVARLB,
     1IVSTAR,IVSTOP,IFUNC,NUMCHF,IREPCH,ILOOST,
     1IBUGGC,ISUBRO,IFOUND,IERROR)
CCCCC IF(IAUTSW.EQ.'ON'.AND.IMACRO.EQ.'OFF')IAUTEX='ON'
      GOTO1390
C
 1320 CONTINUE
      IWIDTH=1
CCCCC THE FOLLOWING LINE WAS FIXED JULY 1989
CCCCC IANSLC(1)='/    '
      IANSLC(1)='/   '
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
      IAUTEX='OFF'
      GOTO1390
C
 1390 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')WRITE(ICOUT,1391)
     1IAUTSW,IAUTEX
 1391 FORMAT('IAUTSW,IAUTEX = ',A4,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')CALL DPWRST('XXX','BUG ')
C
CCCCC THE FOLLOWING SECTION WAS REWRITTEN    MARCH 1992
C               ***********************************************
C               **  STEP 14.1--                              **
C               **  TREAT THE REEXECUTE SAVED COMMANDS CASE  **
C               ***********************************************
C
 1400 CONTINUE
      ISTEPN='14.1'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')THEN
         CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
         WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
         CALL DPWRST('XXX','BUG ')
         WRITE(ICOUT,1401)(IANS(I),I=1,20)
 1401    FORMAT('(IANS(.) = ',20A1)
         CALL DPWRST('XXX','BUG ')
      ENDIF
C
      IF(IANS(1).EQ.'/')THEN
         IF(IWIDTH.GE.2)THEN
            IANSST=' '
            DO1402I=1,IWIDTH
               IANS4=IANS(I)
               IANSST(I:I)=IANS4(1:1)
 1402       CONTINUE
            IF(IANSST(3:4).EQ.'LP'.OR.
     1      IANSST(3:6).EQ.'LASE'.OR.
     1      IANSST(3:5).EQ.'PRN'.OR.
     1      IANSST(3:9).EQ.'PRINTER'.OR.
     1      IANSST(3:6).EQ.'LPT1')THEN
               IREWIN='ON'
               CALL DPOPFI(IOUTNU,IOUTNA,IOUTST,IOUTFO,IOUTAC,IOUTPR,
     1         ICURST,IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
               IF(IERRFI.EQ.'YES')GOTO1409
               IF(IFEEDB.EQ.'ON')THEN
                  WRITE(ICOUT,1403)
 1403             FORMAT('THE PRINTER HAS JUST BEEN OPENED.')
                  CALL DPWRST('XXX','BUG ')
                  WRITE(ICOUT,1404)IOUTNA
 1404             FORMAT('THE FILE ',A40,' HAS JUST BEEN OPENED.')
                  CALL DPWRST('XXX','BUG ')
               ENDIF
               IOUTCS=ICURST
               IPR=IOUTNU
               IOUTSW='ON'
               IPRISW='ON'
            ELSE
               CALL STRLEZ(IANSST,NC)
               IOUTNA=IANSST(3:NC)
               IREWIN='ON'
               CALL DPOPFI(IOUTNU,IOUTNA,IOUTST,IOUTFO,IOUTAC,IOUTPR,
     1         ICURST,IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
               IF(IERRFI.EQ.'YES')GOTO1409
               IF(IFEEDB.EQ.'ON')THEN
                  WRITE(ICOUT,1413)IOUTNA
 1413             FORMAT('THE FILE ',A40,' HAS JUST BEEN OPENED.')
                  CALL DPWRST('XXX','BUG ')
               ENDIF
               IOUTCS=ICURST
               IPR=IOUTNU
               IOUTSW='ON'
               IPRISW='OFF'
            ENDIF
         ENDIF
C
         IANSLC(1)='C   '
         IANSLC(2)='A   '
         IANSLC(3)='L   '
         IANSLC(4)='L   '
         IANSLC(5)='    '
         I2=5
         J=0
         DO1407I=6,MAXWID
            I2=I
            J=J+1
            IC1=ISACNC(J:J)
            IF(IC1.EQ.' ')I2=I2-1
            IF(IC1.EQ.' ')GOTO1408
            IC4='    '
            IC4(1:1)=IC1
            IANSLC(I)=IC4
 1407    CONTINUE
 1408    CONTINUE
         IWIDTH=I2
         CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
CCCCC    IAUTEX='OFF'
      ENDIF
 1409 CONTINUE
C
C               *************************************
C               **  STEP 14.2--                    **
C               **  TREAT THE EXECUTE STRING CASE  **
C               *************************************
C
 1410 CONTINUE
      ISTEPN='14.2'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      IF(IWIDTH.EQ.1.AND.
     1IANS(1).EQ.'X')GOTO1411
      IF(IWIDTH.GE.2.AND.
     1IANS(1).EQ.'X'.AND.IANS(2).EQ.' ')GOTO1411
      IF(IWIDTH.GE.14.AND.
     1IANS(1).EQ.'E'.AND.IANS(9).EQ.'S')GOTO1411
      GOTO1419
C
 1411 CONTINUE
      CALL DPEXEC(IANSEX,IWIDEX,IBUGMA,IFOUND,IERROR)
      IF(IFOUND.EQ.'NO')GOTO1419
      IF(IERROR.EQ.'YES')GOTO1418
C
      IWIDTH=IWIDEX
      IF(IWIDEX.LT.0)IWIDTH=0
      IF(IWIDEX.GT.MAXWID)IWIDTH=MAXWID
C
      IF(IWIDTH.LE.0)GOTO1416
      DO1415I=1,IWIDTH
      IANSLC(I)=IANSEX(I)
 1415 CONTINUE
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
 1416 CONTINUE
      GOTO1419
C
 1418 CONTINUE
      IERROR='NO'
C
 1419 CONTINUE
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,1421)IMACRO,IMACNU,IMACCS,IPROGR
 1421 FORMAT('IMACRO,IMACNU,IMACCS,IPROGR = ',A4,I8,2X,A12,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,1422)IREPST,IREPNU,IREPTO,IREPPO,IREPMX
 1422 FORMAT('IREPST,IREPNU,IREPTO,IREPPO,IREPMX = ',A4,5I8)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
C
      IF(IPROGR.EQ.'OFF')GOTO1439
      IF(IPROGR.EQ.'EXEC')GOTO1439
      IPROGR='OFF'
      GOTO1000
C
 1439 CONTINUE
C
      IF(IREPST.EQ.'ON')GOTO1460
CCCCC ADD FOLLOWING LINE DECEMBER 1997.
      IF(IPLTST.EQ.'ON')GOTO1465
C
      IF(IANS(1).EQ.'L'.AND.IANS(2).EQ.'I'.AND.
     1IANS(3).EQ.'S'.AND.IANS(4).EQ.'T')GOTO1469
      IF(IANS(1).EQ.'L'.AND.IANS(2).EQ.' ')GOTO1469
      IF(IANS(1).EQ.'L'.AND.IWIDTH.LE.1)GOTO1469
      IF(IANS(1).EQ.'R'.AND.IANS(2).EQ.'E'.AND.
     1IANS(3).EQ.'C'.AND.IANS(4).EQ.'A')GOTO1469
C
      IF(IANS(1).EQ.'R'.AND.IANS(2).EQ.'E'.AND.
     1IANS(3).EQ.'P'.AND.IANS(4).EQ.'E')GOTO1469
CCCCC THE FOLLOWING LINE WAS CHANGED JULY 1990
CCCCC IF(IANS(1).EQ.'R'.AND.IANS(2).EQ.' ')GOTO1469
      IF(IANS(1).EQ.'R'.AND.IANS(2).EQ.' '.AND.
     1IANS(3).NE.'C')GOTO1469
      IF(IANS(1).EQ.'R'.AND.IWIDTH.LE.1)GOTO1469
C
      IF(IANS(1).EQ.'S'.AND.IANS(2).EQ.'A'.AND.
     1IANS(3).EQ.'V'.AND.IANS(4).EQ.'E')GOTO1469
CCCCC THE FOLLOWING LINE WAS CHANGED JULY 1990
CCCCC IF(IANS(1).EQ.'S'.AND.IANS(2).EQ.' ')GOTO1469
      IF(IANS(1).EQ.'S'.AND.IANS(2).EQ.' '.AND.
     1IANS(3).NE.'C')GOTO1469
      IF(IANS(1).EQ.'S'.AND.IWIDTH.LE.1)GOTO1469
C
CCCCC IF(IANS(1).EQ.' '.AND.IWIDTH.LE.1)GOTO1469
      IF(IANS(1).EQ.'/'.AND.IWIDTH.LE.1)GOTO1469
CCCCC NOVEMBER 1997.  ADD FOLLOWING LINE.
      IF(IANS(1).EQ.'G'.AND.IANS(2).EQ.'U'.AND.
     1IANS(3).EQ.'I'.AND.IANS(4).EQ.' ')GOTO1469
C
      IF(IWIDTH.LE.0)GOTO1469
C
      IPOINT=IPOINT+1
      IF(IPOINT.GT.IREPMX)IPOINT=1
      GOTO1469
C
 1460 CONTINUE
      IREPNU=IREPNU+1
      IF(IREPNU.GE.IREPTO+1)IREPST='OFF'
CCCCC IF(IREPNU.GE.IREPTO+1)IPOINT=IPOINT-1
      IF(IREPNU.EQ.IREPTO+1)GOTO1469
      IF(IREPNU.GE.IREPTO+2)GOTO1000
      IREPPO=IREPPO+1
      IF(IREPPO.GT.IREPMX)IREPPO=1
      GOTO1469
CCCCC ADD FOLLOWING LINES DECEMBER 1997.
 1465 CONTINUE
      IPLTPO=IPLTPO+1
      IF(IPLTPO.GT.IPLTMX)IPLTPO=1
      IF(IPLTPO.EQ.IPLTNU+1)THEN
        GOTO1469
      ELSEIF(IPLTPO.EQ.IPLTNU+2)THEN
        IPLTST='OFF'
        IPLTPO=0
        GOTO1000
      ENDIF
 1469 CONTINUE
C
      IF(IMACRO.EQ.'EOF')GOTO1470
      GOTO1479
C
 1470 CONTINUE
      DO1475I=1,NUMCHA
      IANSLC(I)=IA(I)
 1475 CONTINUE
      IWIDTH=NUMCHA
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
 1479 CONTINUE
      GOTO1490
C
 1490 CONTINUE
C
C               *******************************************************
C               **  STEP 15--                                        **
C               **  SCAN THE ENTIRE STRING--                         **
C               **  SEARCH FOR THE SUBSTITUTION-VALUE CHARACTER.     **
C               **  IF FOUND (AND IF WE ARE NOT IN THE MIDDLE OF     **
C               **  STORING THE BODY OF A LOOP),
C               **  THEN FORM A NEW STRING BY SUBSTITUTING           **
C               **  THE VALUE OF THE IMMEDIATELY SUCCEEDING VARIABLE **
C               **  IF NOT FOUND (OR IF WE ARE IN THE MIDDLE OF      **
C               **  STORING THE BODY OF A LOOP),                     **
C               **  THEN DO NOTHING.                                 **
C               **  NOTE--AT THIS POINT, WE SHOULD BE WORKING ONLY   **
C               **        WITH IANS(.) (AS OPPOSED TO IANSLC()       **
C               **        AS IN SUBROUTINE DPGETC).                  **
C               *******************************************************
C
      ISTEPN='15'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,1505)ILOOST,IIFSW,IANSLC(1)
 1505 FORMAT('ILOOST,IIFSW,IANSLC(1) = ',A4,2X,A4,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(ILOOST.EQ.'STOR')GOTO1510
CCCCC THE FOLLOWING LINE WAS ADDED DECEMBER 1988
CCCCC TO SUPPRESS EXTRANEOUS ERROR MESSAGE WHEN HAVE  (DECEMBER 1988)
CCCCC BACKSLASH INSIDE NON-EXECUTING (= FALSE)-IF. (DECEMBER 1988)
CCCCC IF(IIFSW.EQ.'TRUE')
CCCCC THE FOLLOWING IF STATEMENT WAS ADDED                 JUNE 1989
CCCCC TO CORRECT THE PROBLEM OF ATTEMPTING TO SUBSTITUTE   JUNE 1989
CCCCC WITHIN A COMMENT LINE (UNNEEDED)                     JUNE 1989
      IF(IIFSW.EQ.'TRUE'.AND.IANSLC(1).NE.'.')
     1CALL DPREP2(IANSLC,IWIDTH,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,
     1IVARLB,
     1IVSTAR,IVSTOP,IFUNC,NUMCHF,IREPCH,
     1IMALEV,
     1IBUGMA,IERROR)
 1510 CONTINUE
      CALL DPUPPE(IANSLC,IWIDTH,IANS,IBUGMA,IERROR)
C
C               ************************************************
C               **  STEP 21--                                  **
C               **  IF THE ECHO SWITCH HAS BEEN TURNED ON     **
C               **  THEN ECHO THE CURRENT COMMAND STATEMENT.  **
C               ************************************************
C
      ISTEPN='21'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')THEN
         CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
         WRITE(ICOUT,2181)IMACRO,IECHO
 2181    FORMAT('IMACRO,IECHO = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      ENDIF
C
      IF(IMACRO.EQ.'EOF')GOTO2190
      IF(IECHO.EQ.'ON')CALL DPECHO(IANSLC,IWIDTH)
 2190 CONTINUE
C
C               ******************************************
C               **  STEP 22--                           **
C               **  EXTRACT THE COMMAND NAME AND        **
C               **  SEPARATE OUT THE VARIOUS ARGUMENTS  **
C               ******************************************
C
      ISTEPN='22'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2211)
 2211 FORMAT('WE ARE IN MAIN ABOUT TO ENTER DPTYPE')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      CALL DPTYPE(IANSLC,IWIDTH,IBUGTY,
     1ICOM,ICOM2,ICOMT,ICOMI,ACOM,ICOMLC,ICOML2,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,
     1IHARG,IHARG2,IARGT,IARG,ARG,IHARLC,IHARL2,NUMARG,
     1IHOST1,IHOST2)
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,2212)
 2212 FORMAT('WE ARE IN MAIN AFTER RETURNING FROM DPTYPE')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
C               ******************************
C               **  STEP 31--               **
C               **  CHECK FOR    IF         **
C               **  CHECK FOR    END OF IF  **
C               ******************************
C
      ISTEPN='31'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,3101)ICOM,ICASIF,IIFSW,ILOOST
 3101 FORMAT('ICOM,ICASIF,IIFSW,ILOOST = ',A4,2X,A4,2X,A4,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
C
C     THE FOLLOWING LINE WAS ENTERED JULY 1987
C     TO CORRECT AN    IF INSIDE A LOOP    PROBLEM
      IF(ILOOST.EQ.'STOR')GOTO3190
      IF(ICOM.EQ.'IF')GOTO3110
      IF(ICOM.EQ.'END')GOTO3120
      IF(ICOM.EQ.'ELSE' .AND. IHARG(1).EQ.'IF')GOTO13110
      IF(ICOM.EQ.'ELSE')GOTO3170
      IF(IIFSW.EQ.'TRUE')GOTO3190
      GOTO1000
C
 3110 CONTINUE
      ILOCS=1
      CALL DPIF(ILOCS,ICASIF,IBUGQ,IERROR)
CCCCC FOLLOWING 12 LINES ADDED NOVEMBER 1992 (NESTED IF'S)
      NUMIF=NUMIF+1
      IF(NUMIF.GT.MAXIF)THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,3112)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,3113)
        CALL DPWRST('XXX','BUG ')
        IIFSW='FALSE'
        GOTO1000
      ENDIF
 3112 FORMAT('MAXIMUM NUMBER OF NESTED IF BLOCKS EXCEEDED.')
 3113 FORMAT('IF STATUS SET TO FALSE.')
      ICASI2(NUMIF)=ICASIF
C
      IF(ICASIF.EQ.'TRUE')ICASI3(NUMIF)='TRUE'
      IF(ICASIF.EQ.'TRUE')GOTO3150
      GOTO3160
C
CCCCC JULY 2002: ELSE IF CLAUSE SIMILAR TO IF, HOWEVER DON'T
CCCCC MODIFY NUMIF (I.E., STAY WITH CURRENT NESTING LEVEL).
13110 CONTINUE
      IF(NUMIF.LT.1)THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13112)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13113)
        CALL DPWRST('XXX','BUG ')
        IIFSW='FALSE'
        GOTO1000
      ENDIF
13112 FORMAT('***** ERROR FROM ELSE IF: NO IF BLOCK CURRENTLY ',
     1       'DEFINED.')
13113 FORMAT('      IF STATUS SET TO FALSE.')
      ISHIFT=1
      CALL SHIFTL(ISHIFT,IHARG,IHARG2,IARG,ARG,IARGT,NUMARG,
     1            IBUGG2,IERROR)
      ICOM='IF  '
      ICOM2='    '
      ILOCS=1
      CALL DPIF(ILOCS,ICASIF,IBUGQ,IERROR)
      ICASI2(NUMIF)=ICASIF
C
      IF(ICASIF.EQ.'TRUE')ICASI3(NUMIF)='TRUE'
      IF(ICASIF.EQ.'TRUE')GOTO3150
      GOTO3160
C
 3120 CONTINUE
CCCCC FOLLOWING BLOCK MODIFIED NOVEMBER 1992 
CCCCC IF(NUMARG.GE.1.AND.IHARG(1).EQ.'IF')GOTO3150
CCCCC IF(NUMARG.GE.2.AND.IHARG(1).EQ.'OF'.AND.
CCCCC1IHARG(2).EQ.'IF')GOTO3150
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'IF')THEN
        IF(NUMIF.GE.1)THEN
          ICASI2(NUMIF)='TRUE'
          ICASI3(NUMIF)='FALS'
          NUMIF=NUMIF-1
        ENDIF
        GOTO3150
      ENDIF
      IF(NUMARG.GE.2.AND.IHARG(1).EQ.'OF'.AND.
     1IHARG(2).EQ.'IF')THEN
        IF(NUMIF.GE.1)THEN
          ICASI2(NUMIF)='TRUE'
          ICASI3(NUMIF)='FALS'
          NUMIF=NUMIF-1
        ENDIF
        GOTO3150
      ENDIF
C
      IF(IIFSW.EQ.'TRUE')GOTO3190
      GOTO1000
C
CCCCC FOLLOWING BLOCK MODIFIED NOVEMBER 1992.  FOR NESTED IF'S, MAKE
CCCCC IIFSW FALSE IF ANY OF THE IF'S ARE FALSE
 3150 CONTINUE
CCCCC IIFSW='TRUE'
      IIFSW='TRUE'
      IF(NUMIF.EQ.0)GOTO1000
      DO3155I=1,NUMIF
        IF(ICASI2(I).EQ.'FALS')THEN
          IIFSW='FALS'
          GOTO1000
        ENDIF
 3155 CONTINUE
      GOTO1000
C
 3160 CONTINUE
      IIFSW='FALS'
      GOTO1000
C
CCCCC JULY 2002.  IMPLEMENT AN ELSE CLAUSE FOR THE IF.
CCCCC             ELSE WILL CHANGE THE CURRENT STATUS, BUT
CCCCC             NOT DECREMENT THE LOOP COUNTER.
 3170 CONTINUE
C
      IF(ICASI3(NUMIF).EQ.'TRUE')THEN
        ICASI2(NUMIF)='FALS'
        IIFSW='FALS'
      ELSE
        ICASI2(NUMIF)='TRUE'
        IIFSW='TRUE'
      ENDIF
C
CCCCC JANUARY 2005.  ADD FOLLOWING LINE.  BUG WITH NESTED IF
CCCCC                WHEN OUTER IF IS FALSE, INNER IF'S SHOULD
CCCCC                BE IGNORED REGARDLESS.
      IF(IIFSW.EQ.'TRUE')GOTO3150
      GOTO1000
C
 3190 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,3191)ICOM,ICASIF,IIFSW
 3191 FORMAT('ICOM,ICASIF,IIFSW = ',A4,2X,A4,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
C
C               ********************************************************
C               **  STEP 32--                                         **
C               **  IF REPEAT COMMAND WAS ENTERED,                    **
C               **  THEN JUMP BACK TO DPGETC TO GET ANOTHER COMMAND.  **
C               ********************************************************
C
      ISTEPN='32'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC CHECK FOR NAME CONFLICT FOR REPEAT PLOT, REPEAT GRAPH  APRIL 1997
      IF(ICOM.EQ.'REPE'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')GOTO3290
      IF(ICOM.EQ.'REPE'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'GRAP')GOTO3290
      IF(ICOM.EQ.'REPE'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'STAN')GOTO3290
      IF(ICOM.EQ.'REPE'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'SD  ')GOTO3290
      IF(ICOM.EQ.'REPE'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'STAT')GOTO3290
      IF(ICOM.EQ.'REPE')GOTO3210
CCCCC THE FOLLOWING LINE WAS REPLACED BY SUBSEQUENT 3 LINES JULY 1990
CCCCC IF(ICOM.EQ.'R')GOTO3210
      IF(ICOM.EQ.'R'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'CONT')GOTO3290
      IF(ICOM.EQ.'R'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'CHAR')GOTO3290
      IF(ICOM.EQ.'R')GOTO3210
      GOTO3290
C
 3210 CONTINUE
      IREPST='ON'
C
      IHOLD1=1
      IHOLD2=1
      IF(NUMARG.EQ.1)IHOLD1=IABS(IARG(1))
      IF(NUMARG.EQ.1)IHOLD2=IABS(IARG(1))
      IF(NUMARG.GE.2)IHOLD1=IABS(IARG(1))
      IF(NUMARG.GE.2)IHOLD2=IABS(IARG(2))
      IHOLD3=IHOLD1
      IHOLD4=IHOLD2
      IF(IHOLD1.LT.IHOLD2)IHOLD3=IHOLD2
      IF(IHOLD1.LT.IHOLD2)IHOLD4=IHOLD1
      IF(IHOLD3.GT.IREPMX)IHOLD3=IREPMX
      IF(IHOLD4.GT.IREPMX)IHOLD4=IREPMX
      IREPS1=IPOINT-IHOLD3
      IREPS2=IPOINT-IHOLD4
C
      IREPNU=1
      IREPTO=IREPS2-IREPS1+1
      IF(IREPTO.GT.IREPMX)IREPTO=IREPMX
      IREPPO=IREPS1
      IF(IREPPO.LE.0)IREPPO=IREPMX+IREPPO
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,3211)IREPST,IREPS1,IREPS2,IREPNU,NUMARG,IREPMX,IREPTO,
     1IREPPO
 3211 FORMAT('IREPST,IREPS1,IREPS2,IREPNU,NUMARG,IREPMX,IREPTO,',
     1'IREPPO = ',A4,7I8)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      GOTO1000
C
 3290 CONTINUE
C
C               *******************************************************
C               **  STEP 32B--                                       **
C               **  IF REPLOT COMMAND WAS ENTERED,                   **
C               **  THEN JUMP BACK TO DPGETC TO GET ANOTHER COMMAND. **
C               **  FOR NOW, ONLY REPLOT MOST RECENT GRAPH.          **
C               *******************************************************
C
      ISTEPN='32B'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICOM.EQ.'REPL')GOTO13210
      GOTO13290
13210 CONTINUE
C
      IPLTST='ON'
C
      IPLTPO=1
      IF(IPLTNU.LT.1)IPLTST='OFF'
C
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')THEN
        WRITE(ICOUT,13211)IPLTST,IPLTPO,IPLTNU
13211   FORMAT('IPLTST,IPLTPO,IPLTNU = ',A4,2I8)
        CALL DPWRST('XXX','BUG ')
      ENDIF
      GOTO1000
C
13290 CONTINUE
C
C               *******************************************************
C               **  STEP 33--                                        **
C               **  TREAT THE 3 MACRO CASES--
C               **    1) A MACRO HAS JUST BEEN CALLED
C               **    2) A MACRO HAS JUST FINISHED
C               **    3) A MACRO IS BEING WRITTEN OUT TO
C               *******************************************************
C
      ISTEPN='33'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO3309
      WRITE(ICOUT,3301)
 3301 FORMAT('<<<<<FROM THE MIDDLE OF MAIN>>>>>')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3302)ICOM,ICOM2
 3302 FORMAT('ICOM,ICOM2 = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3303)IMACRO,IMACNU,IMACCS,IMALEV
 3303 FORMAT('IMACRO,IMACNU,IMACCS,IMALEV = ',A4,I8,2X,A12,I8)
      CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
 3309 CONTINUE
C
      IF(ICOM.EQ.'CALL'.AND.ICOM2.EQ.'    ')GOTO3310
      IF(IMACRO.EQ.'EOF ')GOTO3320
      GOTO3330
C
C               *******************************************************
C               **  STEP 33.1--                                      **
C               **  IF A MACRO HAS JUST BEEN CALLED,                 **
C               **  INCREMENT THE FILE/SUBFILE UNIT NUMBER AND       **
C               **  OPEN THE FILE/SUBFILE.                           **
C               *******************************************************
C
 3310 CONTINUE
      ISTEPN='33.1'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      IMALE8=IMALEV
      IMACN8=IMACNU
      IMALEV=IMALEV+1
      IF(IMALEV.LE.MAXMAC)GOTO3315
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3312)
 3312 FORMAT('***** ERROR IN MAIN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3313)
 3313 FORMAT('      AN ATTEMPT WAS MADE TO NEST SUBPROGRAMS')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,3314)MAXMAC
 3314 FORMAT('      DEEPER THAN THE MAXIMUM ALLOWABLE (',I2,').')
      CALL DPWRST('XXX','BUG ')
      IERROR='YES'
      GOTO8100
 3315 CONTINUE
C
      IF(IMALEV.LE.0)IMACNU=IRD
      IF(IMALEV.EQ.1)IMACNU=ICRENU
CCCCC APRIL 1997.  THE "CALL" COMMAND SHOULD BE WRITTEN TO 
CCCCC THE "CREATE" FILE, BUT ONLY IF FIRST LEVEL MACRO.
      IF(IMACRO.EQ.'ON'.AND.IMALEV.EQ.1)THEN
        WRITE(ICREN2,3335)(IANS(I),I=1,MIN(IWIDTH,132))
      ENDIF
C
      IF(IMALEV.GE.2)IMACNU=IMACNU+1
      CALL DPMACR(ICOM,ICOM2,
CCCCC THE FOLLOWING LINE WAS AUGMENTED      AUGUST 1994
CCCCC1IMACRO,IMACNU,IMACCS,
     1IMACRO,IMACNU,IMACCS,IMACL1,IMACL2,IMACLR,IMALEV,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,MAXNAM,IANSLC,IWIDTH,
     1IHARG,IHARG2,IARGT,IARG,ARG,NUMARG,
     1IOFILE,
     1IBUGS2,ISUBRO,IFOUND,IERROR)
      IF(IERROR.EQ.'NO')GOTO3319
      IMALEV=IMALE8
      IMACNU=IMACN8
C
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1992
CCCCC IF(ISYSSW.EQ.'EXEC')GOTO3317
      ISYSS2=ISYSSW
      IF(ISYSS2.EQ.'EXSY')GOTO3317
      IF(ISYSS2.EQ.'EXLO')GOTO3317
      IF(ISYSS2.EQ.'EXUS')GOTO3317
      GOTO3318
 3317 CONTINUE
      ISYSSW='DONE'
      IF(IMALEV.GE.1)IMAFIL(IMALEV)=IOFILE
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1992
CCCCC GOTO960
      IF(ISYSS2.EQ.'EXSY')GOTO959
      IF(ISYSS2.EQ.'EXLO')GOTO969
      IF(ISYSS2.EQ.'EXUS')GOTO979
 3318 CONTINUE
C
 3319 CONTINUE
      IF(IMALEV.GE.1)IMAFIL(IMALEV)=IOFILE
      GOTO1000
C
C               *******************************************************
C               **  STEP 33.2--                                      **
C               **  IF A MACRO FILE/SUBFILE HAS JUST BEEN FINISHED,  **
C               **  DECREMENT THE FILE/SUBFILE UNIT NUMBER AND       **
C               **  CLOSE THE FILE/SUBFILE.                          **
C               *******************************************************
C
 3320 CONTINUE
      ISTEPN='33.2'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      IMACCS='CLO2        '
      CALL DPMACR(ICOM,ICOM2,
CCCCC1IMACRO,IMACNU,IMACCS,
     1IMACRO,IMACNU,IMACCS,IMACL1,IMACL2,IMACLR,IMALEV,
     1IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,MAXNAM,IANSLC,IWIDTH,
     1IHARG,IHARG2,IARGT,IARG,ARG,NUMARG,
     1IOFILE,
     1IBUGS2,ISUBRO,IFOUND,IERROR)
      IMACCS='JUNK        '
      IF(IMALEV.GE.1)IMAFIL(IMALEV)='NO'
      IMALEV=IMALEV-1
      IF(IMALEV.LE.0)IMACNU=IRD
      IF(IMALEV.EQ.1)IMACNU=ICRENU
      IF(IMALEV.GE.2)IMACNU=IMACNU-1
      IF(IMALEV.LE.0)IMALEV=0
CCCCC IMACRO='OFF'
      IF(IMALEV.LE.0)IMACRO='OFF'
C
CCCCC THE FOLLOWING SECTION WAS ADDED     MARCH 1992
      IF(IMALEV.LE.0.AND.IOUTSW.EQ.'ON')THEN
         IOUTSW='OFF'
         IPR=IPRDEF
         IENDFI='ON'
         IREWIN='ON'
         CALL DPCLFI(IOUTNU,IOUTNA,IOUTST,IOUTFO,IOUTAC,IOUTPR,
     1   ICURST,IENDFI,IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
         IF(IERRFI.EQ.'YES')GOTO3321
         IF(IFEEDB.EQ.'ON')THEN
            WRITE(ICOUT,3311)IOUTNA
 3311       FORMAT('THE FILE ',A40,' HAS JUST BEEN CLOSED.')
      CALL DPWRST('XXX','BUG ')
         ENDIF
         IOUTCS=ICURST
         IF(IPRITY.EQ.'POST')THEN
            CALL COPYFI(IOUTNA,ISCRNA,IBUGS2,ISUBRO,IERROR)
            CALL CONVFP(ISCRNA,IOUTNA,IBUGS2,ISUBRO,IERROR)
         ENDIF
         IF(IPRISW.EQ.'ON')THEN
            IF(IOUTTY.EQ.'ASCI'.AND.IPRITY.EQ.'ASCI')THEN
               CALL PRINFI(IOUTNA,IBUGS2,ISUBRO,IERROR)
            ELSE IF(IOUTTY.EQ.'POST'.AND.IPRITY.EQ.'POST')THEN
               CALL PRINFI(IOUTNA,IBUGS2,ISUBRO,IERROR)
            ELSE IF(IOUTTY.EQ.'ASCI'.AND.IPRITY.EQ.'POST')THEN
CCCCC THE FOLLOWING 2 LINES WERE FIXED FEBRUARY 1993
CCCCC          CALL CONVFP(IOUTNA,ISCRNA,IBUGS2,ISUBRO,IERROR)
CCCCC          CALL PRINFI(ISCRNA,IBUGS2,ISUBRO,IERROR)
               ISTRIN(1:6)='DOS PP'
               NSTRIN=6
               CALL CONV14(ISTRIN,NSTRIN,IANS,IANSLC,IWIDTH,
     1         IBUGMA,IERROR)
               CALL DPSYST(IANS,IANSLC,IWIDTH,
     1         IHNAME,IHNAM2,IUSE,IVALUE,VALUE,NUMNAM,
     1         IVSTAR,IVSTOP,IFUNC,NUMCHF,IREPCH,
     1         IBUGMA,ISUBRO,IFOUND,IERROR)
            ELSE IF(IOUTTY.EQ.'POST'.AND.IPRITY.EQ.'ASCI')THEN
               WRITE(ICOUT,3322)
 3322          FORMAT('ERROR 3322 IN MAIN--')
      CALL DPWRST('XXX','BUG ')
               WRITE(ICOUT,3323)
 3323          FORMAT('ATTEMPT TO DUMP A POSTSCRIPT FILE')
      CALL DPWRST('XXX','BUG ')
               WRITE(ICOUT,3324)
 3324          FORMAT('TO A NON-POSTSCRIPT PRINTER.')
      CALL DPWRST('XXX','BUG ')
            ENDIF
            IF(IFEEDB.EQ.'ON')THEN
               WRITE(ICOUT,3327)
 3327          FORMAT('THE PRINTER HAS JUST BEEN CLOSED.')
      CALL DPWRST('XXX','BUG ')
            ENDIF
            IPRISW='OFF'
         ENDIF
         IOUTNA=IOUTN0
      ENDIF
 3321 CONTINUE
C
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1992
CCCCC IF(ISYSSW.EQ.'EXEC')GOTO3325
      ISYSS2=ISYSSW
      IF(ISYSS2.EQ.'EXSY')GOTO3325
      IF(ISYSS2.EQ.'EXLO')GOTO3325
      IF(ISYSS2.EQ.'EXUS')GOTO3325
      GOTO3329
 3325 CONTINUE
      ISYSSW='DONE'
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1992
CCCCC GOTO960
      IF(ISYSS2.EQ.'EXSY')GOTO959
      IF(ISYSS2.EQ.'EXLO')GOTO969
      IF(ISYSS2.EQ.'EXUS')GOTO979
 3329 CONTINUE
C
      GOTO1000
C
C               ******************************************
C               **  STEP 33.3--                          **
C               **  IF THE MACRO SWITCH IS ON,          **
C               **  COPY THE CURRENT COMMAND STATEMENT  **
C               **  OUT TO THE MACRO FILE/SUBFILE.      **
C               ******************************************
C
 3330 CONTINUE
      ISTEPN='33.3'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      IF(ICOM.EQ.'END ')GOTO3331
      GOTO3332
C
 3331 CONTINUE
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'CREA')IMACRO='OFF'
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'MACR')IMACRO='OFF'
      IF(NUMARG.GE.2.AND.IHARG(1).EQ.'OF  '.AND.
     1IHARG(2).EQ.'CREA')IMACRO='OFF'
      IF(NUMARG.GE.2.AND.IHARG(1).EQ.'OF  '.AND.
     1IHARG(2).EQ.'MACR')IMACRO='OFF'
C
 3332 CONTINUE
      IF(IMACRO.EQ.'OFF')GOTO3339
      IF(ICOM.EQ.'MACR'.AND.ICOM2.EQ.'O   ')THEN
        IF(IHARG(1).EQ.'SUBS' .AND. IHARG(2).EQ.'CHAR')THEN
          CONTINUE
        ELSE
          GOTO3339
        ENDIF
      ENDIF
CCCCC APRIL 1997.  SEPARATE UNITS FOR "CALL" AND "CREATE"
CCCCC IF(IMACRO.EQ.'ON')WRITE(ICRENU,3335)(IANS(I),I=1,IWIDTH)
      IF(IMACRO.EQ.'ON')WRITE(ICREN2,3335)(IANS(I),I=1,MIN(IWIDTH,132))
 3335 FORMAT(132A1)
 3339 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS REWRITTEN GO-T0-LESS AUGUST 1992
C               ***********************************************************
C               **  STEP 41--                                            **
C               **  ARE THE AUTO-LABEL SWITCHES BEING TURNED ON OR OFF?  **
C               **  ARE THEY ALREADY ON?                                 **
C               **  1) IF THE AUTO-X3LABEL SWITCH IS ALREADY ON,         **
C               **     COPY THE CURRENT COMMAND STATEMENT                **
C               **     SO THAT IT WILL APPEAR AUTOMATICALLY AS X3LABEL   **
C               **     UNDER PLOTS.                                      **
C               **  2) IF THE AUTO-TITLE LABEL SWITCH IS ALREADY ON,     **
C               **     COPY THE CURRENT COMMAND STATEMENT                **
C               **     SO THAT IT WILL APPEAR AUTOMATICALLY AS TITLE     **
C               **     ABOVE PLOTS.                                      **
C               **  3) IF THE AUTO-LABEL SWITCH IS ALREADY ON,           **
C               **     COPY WORDS 2 AND 3 OF CURRENT COMMAND STATEMENT   **
C               **     SO THAT IT WILL APPEAR AUTOMATICALLY AS Y1LABEL   **
C               **     AND X1LABEL                                       **
C               ***********************************************************
C
      ISTEPN='41'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMARG.EQ.1.AND.IHARG(1).EQ.'AUTO'.AND.
     1IHARG2(1).EQ.'MATI')THEN
         IF(ICOM.EQ.'X3LA')IX3AUT='ON'
         IF(ICOM.EQ.'TITL')ITIAUT='ON'
         IF(ICOM.EQ.'Y1LA')IY1AUT='ON'
         IF(ICOM.EQ.'X1LA')IX1AUT='ON'
         IF(ICOM.EQ.'XLAB')IX1AUT='ON'
         IF(ICOM.EQ.'LABE')THEN
            IY1AUT='ON'
            IX1AUT='ON'
         ENDIF
      ENDIF
C
      IF(IX3AUT.EQ.'ON')THEN
         NCX3LA=IWIDTH
         IF(IWIDTH.GE.1)THEN
            DO4110I=1,IWIDTH
            IX3LTE(I)=IANSLC(I)
 4110       CONTINUE
         ENDIF
      ENDIF
C
CCCCC THE FOLLOWING 3 LINES WERE ADDED   SEPTEMBER 1993
CCCCC TO BLANK OUT X2LABEL IF AUTOMATIC  SEPTEMBER 1993
      IF(IX2AUT.EQ.'ON')THEN
         NCX2LA=0
      ENDIF
C
CCCCC THE FOLLOWING 3 LINES WERE ADDED   SEPTEMBER 1993
CCCCC TO BLANK OUT Y2LABEL IF AUTOMATIC  SEPTEMBER 1993
      IF(IY2AUT.EQ.'ON')THEN
         NCY2LA=0
      ENDIF
C
      IF(ITIAUT.EQ.'ON')THEN
         NCTITL=IWIDTH
         IF(IWIDTH.GE.1)THEN
            DO4120I=1,IWIDTH
            ITITTE(I)=IANSLC(I)
 4120       CONTINUE
         ENDIF
      ENDIF
C
CCCCC JANUARY 2000.  Y1LABEL AUTOMATIC WILL GET THE VARIABLE
CCCCC NAME IN IHARG(1).  IT WILL SUBSTITUTE A VARIABLE LABEL
CCCCC IF FOUND.
C
      IF(IY1AUT.EQ.'ON')THEN
         IF(ICOM.EQ.'PLOT')THEN
C
            IHWUSE='V'
            MESSAG='NO'
            CALL CHECKN(IHARG(1),IHARG2(1),IHWUSE,
     1              IHNAME,IHNAM2,IUSE,IN,IVALUE,VALUE,NUMNAM,MAXNAM,
     1              ISUBN1,ISUBN2,MESSAG,IANS,IWIDTH,ILOCV,IERROR)
            IF(IERROR.EQ.'NO')THEN
              ICOL=IVALUE(ILOCV)
              ILAST=0
              DO4161I=40,1,-1
                IF(IVARLB(ICOL)(I:I).NE.' ')THEN
                  ILAST=I
                  GOTO4163
                ENDIF
 4161         CONTINUE
 4163         CONTINUE
              IF(ILAST.GE.1)THEN
                DO4164I=1,ILAST
                  IY1LTE(I)(1:1)=IVARLB(ICOL)(I:I)
 4164           CONTINUE
                NCY1LA=ILAST
              ELSE
                DO4166I=1,4
                  IY1LTE(I)=IHARG(1)(I:I)
                  IY1LTE(I+4)=IHARG2(1)(I:I)
 4166           CONTINUE
                NCY1LA=8
                DO4168I=8,1,-1
                  NCY1LA=I
                  IF(IY1LTE(I).NE.' ')GOTO4169
 4168           CONTINUE
 4169           CONTINUE
              ENDIF
            ELSE
              J=0
              ISTART=6
              IF(ISTART.GT.IWIDTH)GOTO4172
              DO4171I=ISTART,IWIDTH
                 IF(IANSLC(I).EQ.'    ')GOTO4172
                 J=J+1
                 IY1LTE(J)=IANSLC(I)
 4171         CONTINUE
 4172         CONTINUE
              NCY1LA=J
C
            ENDIF
         ENDIF
      ENDIF
C
      IF(IX1AUT.EQ.'ON')THEN
         IF(ICOM.EQ.'PLOT')THEN
C
            IHWUSE='V'
            MESSAG='NO'
            IPOS=2
            IF(IHARG(2).EQ.'VS  ' .OR. IHARG(2).EQ.'VERS')IPOS=3
            CALL CHECKN(IHARG(IPOS),IHARG2(IPOS),IHWUSE,
     1              IHNAME,IHNAM2,IUSE,IN,IVALUE,VALUE,NUMNAM,MAXNAM,
     1              ISUBN1,ISUBN2,MESSAG,IANS,IWIDTH,ILOCV,IERROR)
            IF(IERROR.EQ.'NO')THEN
              ICOL=IVALUE(ILOCV)
              ILAST=0
              DO4181I=52,1,-1
                IF(IVARLB(ICOL)(I:I).NE.' ')THEN
                  ILAST=I
                  GOTO4183
                ENDIF
 4181         CONTINUE
 4183         CONTINUE
              IF(ILAST.GE.1)THEN
                DO4184I=1,ILAST
                  IX1LTE(I)(1:1)=IVARLB(ICOL)(I:I)
 4184           CONTINUE
                NCX1LA=ILAST
              ELSE
                DO4186I=1,4
                  IX1LTE(I)=IHARG(IPOS)(I:I)
                  IX1LTE(I+4)=IHARG2(IPOS)(I:I)
 4186           CONTINUE
                NCX1LA=8
                DO4188I=8,1,-1
                  NCX1LA=I
                  IF(IX1LTE(I).NE.' ')GOTO4189
 4188           CONTINUE
 4189           CONTINUE
              ENDIF
            ELSE
C
            ISTART=6
            I1=ISTART
            IF(ISTART.GT.IWIDTH)GOTO4192
            DO4191I=ISTART,IWIDTH
               I1=I
               IF(IANSLC(I).EQ.'    ')GOTO4192
 4191       CONTINUE
 4192       CONTINUE
            IBL1=I1
C
            J=0
            ISTART=IBL1+1
            I2=ISTART
            IF(ISTART.GT.IWIDTH)GOTO4194
            DO4193I=ISTART,IWIDTH
               I2=I
               IF(IANSLC(I).EQ.'    ')GOTO4194
               J=J+1
               IX1LTE(J)=IANSLC(I)
 4193       CONTINUE
 4194       CONTINUE
            NCX1LA=J
            IBL2=I2
C
            IF(NCX1LA.EQ.3.AND.
CCCCC THE FOLLOWING LINE WAS FIXED      SEPTEMBER 1993
CCCCC TO ALLOW FOR LOWER CASE for       SEPTEMBER 1993
CCCCC1      IX1LTE(1).EQ.'F   '.AND.IX1LTE(2).EQ.'O   '.AND.
CCCCC1      IX1LTE(3).EQ.'R   ')THEN
     1      (IX1LTE(1).EQ.'F   '.AND.IX1LTE(2).EQ.'O   '.AND.
     1      IX1LTE(3).EQ.'R   ').OR.
     1      (IX1LTE(1).EQ.'f   '.AND.IX1LTE(2).EQ.'o   '.AND.
     1      IX1LTE(3).EQ.'r   '))THEN
               J=0
               ISTART=IBL2+1
               I3=ISTART
               IF(ISTART.GT.IWIDTH)GOTO4196
               DO4195I=ISTART,IWIDTH
                  I3=I
                  IF(IANSLC(I).EQ.'    ')GOTO4196
                  J=J+1
                  IX1LTE(J)=IANSLC(I)
 4195          CONTINUE
 4196          CONTINUE
               NCX1LA=J
            ENDIF
C
           ENDIF
         ENDIF
      ENDIF
C
C               ***************************************
C               **  STEP 42--                        **
C               **  DETERMINE IF A SETTING OR        **
C               **            IF A PROBE             **
C               **  OF VARIOUS INTERNAL DATAPLOT     **
C               **  PARAMETERS IS BEING CALLED FOR.  **
C               ***************************************
C
      ISTEPN='42'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      IFOUND='NO'
      IERROR='NO'
C
CCCCC THE FOLLOWING LINE WAS ADDED (DECEMBER 1988)
CCCCC TO FIX THE BUG WHEREBY   SET   COMMANDS    (DECEMBER 1988)
CCCCC WERE NOT BEING STORED IF IN A LOOP    (DECEMBER 1988)
      IF(ICOM.EQ.'SET'.AND.ILOOST.EQ.'STOR')GOTO5100
      IF(ICOM.EQ.'SET')CALL DPSET(ILISMX,IREPCH,IOSW,
     1IPPDE1,IPPDE2,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IBUGEX,IBUGE2,IBUGHE,IBUGH2,IBUGLO,
CCCCC AUGUST 1995.  ADD IFTORD ARGUEMENT
CCCCC1IHELMX,IFTEXP,
     1IHELMX,IFTEXP,IFTORD,
     1IFORSW,ICREAF,NCREAF,ICWRIF,NCWRIF,
     1IREARW,IWRIRW,
CCCCC THE FOLLOWING LINE WAS ADDED   APRIL 1992
     1NPLOTP,
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1993
     1IPRITY,
CCCCC FOLLOWING LINE ADD APRIL 1995
     1IUNFOF,IUNFNR,IUNFMC,
CCCCC FOLLOWING LINE ADD MARCH 1996
CCCCC1IRHSTG,
     1IFOUND,IERROR)
      IF(ICOM.EQ.'SET ')IBUGLO=IBUGMA
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
CCCCC THE FOLLOWING LINE WAS ADDED (DECEMBER 1988)
CCCCC TO FIX THE BUG WHEREBY   PROBE   COMMANDS    (DECEMBER 1988)
CCCCC WERE NOT BEING STORED IF IN A LOOP    (DECEMBER 1988)
      IF(ICOM.EQ.'PROB'.AND.ILOOST.EQ.'STOR')GOTO5100
      IF(ICOM.EQ.'PROB')CALL DPPROB(ILISMX,IREPCH,IOSW,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IBUGEX,IBUGE2,IBUGHE,IBUGH2,IBUGLO,
CCCCC AUGUST 1995.  ADD IFTORD ARGUEMENT
CCCCC1IHELMX,IFTEXP,
     1IHELMX,IFTEXP,IFTORD,
     1IFORSW,ICREAF,NCREAF,ICWRIF,NCWRIF,
     1IREARW,IWRIRW,
CCCCC THE FOLLOWING LINE WAS ADDED   APRIL 1992
     1NPLOTP,
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1993
     1IPRITY,
CCCCC FOLLOWING LINE ADD APRIL 1995
     1IUNFOF,IUNFNR,IUNFMC,
CCCCC FOLLOWING LINE ADD MARCH 1996
CCCCC1IRHSTG,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
CCCCC IF(ICOM.EQ.'END')GOTO9000
CCCCC IF(ICOM.EQ.'STOP')GOTO9000
C
CCCCC ABOUT 300 LINES OF CODE DEALING WITH 4-PLOT     (JANUARY 1989)
CCCCC WERE REMOVED TO A SEPARATE SUBROUTINE (DP4PLO)  (JANUARY 1989)
C
C               ********************************************************
C               **  STEP 51--
C               **  CHECK LOOP STATUS--
C               **  SHOULD THE COMMAND LINE BE STORED?
C               **  IF LOOP STATUS = STORE, THEN STORE THE CURRENT
C               **                          COMMAND LINE (DO NOT EXECUTE
C               **  OR IF CURRENT COMMAND = LOOP, THEN STORE THE CURRENT
C               **                                COMMAND LINE (DO NOT E
C               ********************************************************
C
CCCCC THE FOLLOWING LINE (5100 CONTINUE) WAS ADDED (DECEMBER 1988)
CCCCC TO FIX THE BUG WHEREBY   SET AND PROBE   COMMANDS    (DECEMBER 1988)
CCCCC WERE NOT BEING STORED IF IN A LOOP    (DECEMBER 1988)
 5100 CONTINUE
      ISTEPN='51'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      IF(ILOOST.EQ.'EXEC')GOTO5190
      IF(ILOOST.EQ.'STOR')GOTO5150
      IF(ICOM.EQ.'LOOP')GOTO5150
      GOTO5190
C
 5150 CONTINUE
      CALL DPLOST(ILOOST,ILOOLI,NUMLIL,NUMLOS,NUMENS,
     1IANSLC,IWIDTH,ICOM,IHARG,IHARG2,NUMARG,IANSLO,IWIDLL,
     1MAXCIL,MAXLIL,
     1IBUGLO,ISUBRO,IERROR)
      GOTO1000
C
 5190 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED   JUNE 1991   JJF
C               **************************************
C               **  STEP 52.01--                    **
C               **  ENTER TURBO-C MENU   SUBSYSTEM  **
C               **************************************
C
      ISTEPN='5201'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IHOST1.EQ.'IBM-')GOTO5180
      GOTO5189
 5180 CONTINUE
      IF(ICOM.EQ.'MENU')GOTO5181
      IF(ICOM.EQ.'M')GOTO5181
CCCCC IF(ICOM.EQ.'GUI')GOTO5181
      IF(ICOM.EQ.'GUI')GOTO5181
      IF(ICOM.EQ.'G')GOTO5181
      GOTO5189
 5181 CONTINUE
CCCCC NOVEMBER 1997.  CHECK FOR: "GUI PRINT/WRITE" AND "GUI STATUS"
CCCCC "GUI SAVE PLOT CONTROL"
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'WRIT')GOTO5189
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'PRIN')GOTO5189
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'STAT')GOTO5189
      IF(NUMARG.GE.1.AND.IHARG(1).EQ.'SAVE')GOTO5189
      CALL TCLOTC(ISUBRO)
      CALL TCSHME(ISUBRO)
C
      IFEESV=IFEEDB
      IFEEDB='OFF'
      ICOM='DEVI'
      ICOM2='CE  '
      IHARG(1)='1   '
      IHARG2(1)='    '
      IARGT(1)='NUMB'
      IARG(1)=1
C
CCCCC 5-HOUR NOTE--I HAD THE FOLLOWING SET TO    VGA    FEBRUARY 1993
CCCCC SO AS TO SHIP OUT DATAPLOT WITHOUT THE TURBO-C    FEBRUARY 1993
CCCCC MENU GRAPHICS WORKING                             FEBRUARY 1993
CCCCC BUT WITH A CLEAN CUSTOMER INSTALLATION.           FEBRUARY 1993
CCCCC TO REACTIVATE AND TEST THE GRAPHICS WITHIN THE    FEBRUARY 1993
CCCCC TURBO-C MENU, I SHOULD CHANGE THE                 FEBRUARY 1993
CCCCC FOLLOWING TO    TURB                              FEBRUARY 1993
C
CCCCC IHARG(2)='VGA '                                   FEBRUARY 1993
      IHARG(2)='TURB'
C
      IHARG2(2)='    '
      IARGT(2)='WORD'
      NUMARG=2
      CALL DPDEMN(IHARG,IHARG2,IARGT,IARG,NUMARG,
     1IPL1NU,IPL1NA,
     1IPL2NU,IPL2NA,
     1IPL1CS,IPL2CS,
     1IDEFMA,IDEFMO,IDEFM2,IDEFM3,
     1IDEFPO,IDEFCN,IDEFDC,IDEFVP,IDEFHP,IDEFUN,
     1NUMDEV,MAXDEV,
     1IDMANU,IDMODE,IDMOD2,IDMOD3,
     1IDPOWE,IDCONT,IDCOLO,IDFONT,IDNVPP,IDNHPP,IDUNIT,
     1IDNVOF,IDNHOF,
     1ICAPSW,ICAPNU,
     1IANS,IWIDTH,IBUGO2,ISUBRO,IFOUND,IERROR)
      IFEEDB=IFEESV
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
 5189 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED JUNE 1990
C               *************************************
C               **  STEP 52.05--                    **
C               **  ENTER MENU   SUBSYSTEM MODULE  **
C               *************************************
C
      ISTEPN='5205'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
CCCCC THE IM10XX TO IM20XX ARGS WERE ADDED BELOW           AUGUST 1990
CCCCC THE IHELMX LINE WAS ADDED TO FOLLOWING ARGUMENT LIST AUGUST 1990
C
CCCCC THE FOLLOWING LINE WAS ADDED   JUNE 1991    JJF
      IF(IHOST1.EQ.'IBM-')GOTO5195
C
      CALL DPMENU(ICOM,ICOM2,ICOMT,ICOMI,
     1IHARG,IHARG2,IARGT,IARG,NUMARG,
     1IMENSW,
     1IME1CO,IME1AL,IME2CO,IME2AL,
     1IME3CO,IME3AL,IME4CO,IME4AL,
     1IME5CO,IME5AL,IME6CO,IME6AL,
     1IME7CO,IME7AL,IME8CO,IME8AL,
     1IME9CO,IME9AL,IM10CO,IM10AL,
     1IM11CO,IM11AL,IM12CO,IM12AL,
     1IM13CO,IM13AL,IM14CO,IM14AL,
     1IM15CO,IM15AL,IM16CO,IM16AL,
     1IM17CO,IM17AL,IM18CO,IM18AL,
     1IM19CO,IM19AL,IM20CO,IM20AL,
     1IMENCO,IMENAL,
     1IHELMX,ICPREH,NCPREH,ICPOSH,NCPOSH,
     1IANS,IWIDTH,IBUGEX,IBUGE2,ISUBRO,IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
CCCCC THE FOLLOWING LINE WAS ADDED   JUNE 1991    JJF
 5195 CONTINUE
C
C               *************************************
C               **  STEP 52.1--                    **
C               **  ENTER EXPERT SUBSYSTEM MODULE  **
C               *************************************
C
      ISTEPN='52.1'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      CALL DPEXP1(ICOM,ICOM2,ICOMT,ICOMI,
     1IHARG,IHARG2,IARGT,IARG,NUMARG,
     1IEXPSW,
     1IEX1CO,IEX1AL,
     1IEX2CO,IEX2AL,
     1IEX3CO,IEX3AL,
     1IEX4CO,IEX4AL,
     1IEX5CO,IEX5AL,
     1IEXPCO,IEXPAL,
     1IANS,IWIDTH,IBUGEX,IBUGE2,ISUBRO,IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
C               *************************************
C               **  STEP 52.2--                    **
C               **  ENTER HELP   SUBSYSTEM MODULE  **
C               *************************************
C
      ISTEPN='52.2'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
CCCCC THE FOLLOWING LINE WAS CHANGED   JUNE 1991   JJF
CCCCC IF(ICOM.EQ.'HELQ')GOTO5191
      IF(ICOM.EQ.'HELQ')GOTO5196
      GOTO5199
CCCCC THE FOLLOWING LINE WAS CHANGED   JUNE 1991   JJF
C5191 CONTINUE
 5196 CONTINUE
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      CALL DPHEL1(ICOM,ICOM2,ICOMT,ICOMI,
     1IHARG,IHARG2,IARGT,IARG,NUMARG,
     1IHELSW,
     1IHE1CO,IHE1AL,
     1IHE2CO,IHE2AL,
     1IHE3CO,IHE3AL,
     1IHE4CO,IHE4AL,
     1IHE5CO,IHE5AL,
     1IHE6CO,IHE6AL,
     1IHE7CO,IHE7AL,
     1IHE8CO,IHE8AL,
     1IHE9CO,IHE9AL,
     1IHELCO,IHELAL,
     1IHELMX,
     1ICPREH,NCPREH,ICPOSH,NCPOSH,
     1IANS,IWIDTH,IBUGHE,IBUGH2,ISUBRO,IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
 5199 CONTINUE
C
CCCCC THE FOLLOWING SECTION WERE ENTERED JULY 1990 TO GET 386 COLOR
      IF(IHOST1.EQ.'IBM-'.AND.IHOST2.EQ.'PC  ')GOTO5210
      GOTO5290
 5210 CONTINUE
CCCCC MAY 2002.  CONFLICT WITH B BASIS TOLERANCE LIMIT COMMAND
CCCCC IF(ICOM.EQ.'B')GOTO5211
      IF(ICOM.EQ.'B' .AND. IHARG(1).NE.'BASI')GOTO5211
      IF(ICOM.EQ.'BLUE')GOTO5211
      GOTO5219
 5211 CONTINUE
CCCCC THE FOLLOWING 2 LINES DID NOT APPEAR TO WORK
CCCCC IESC WAS CHANGED TO IESCC    SEPTEMBER 1990
CCCCC WRITE(ICOUT,5212)IESCC,IFF
C5212 FORMAT(A1,A1)
CCCCC CALL DPWRST('XXX','BUG ')
CCCCC CALL WNCLOS(1)
CCCCC CALL WNOPEN(1,1,80,24)
      IFOUND='YES'
      IERROR='NO'
      GOTO8000
 5219 CONTINUE
 5290 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED JULY 1992 (JJF)
C               ********************************************
C               **  STEP 52.3--                           **
C               **  ENTER    EDIT/FED   SUBSYSTEM MODULE  **
C               ********************************************
C
      ISTEPN='52.3'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICOM.EQ.'EDIT'.OR.ICOM.EQ.'FED')THEN
CCCCC AUGUST 1992.  COMMENT OUT THIS COMMAND ON UNIX SYSTEMS.
CCCCC PRIMARILY FOR SPACE REASONS.  CAN GET SAME CAPABILITY
CCCCC WITH      "system vi <filename>"     COMMAND.
CCCCC TO ACTIVATE, UNCOMMENT THE CALL DPEDIT(.) LINE, AND
CCCCC COMMENT OUT THE 2 WRITE STATEMENTS.
         CALL DPEDIT(ICOM,IANSLC,IWIDTH,IBUGMA,ISUBRO,IERROR)
CCCCC    WRITE(ICOUT,5293)
C5293    FORMAT('THE EDIT COMMAND HAS BEEN DE-ACTIVATED. ')
CCCCC    CALL DPWRST('XXX','BUG ')
CCCCC    WRITE(ICOUT,5294)
C5294    FORMAT('CONTACT YOUR SITE INSTALLER TO HAVE IT ACTIVATED.')
CCCCC    CALL DPWRST('XXX','BUG ')
         IFOUND='YES'
         IERROR='NO'
         GOTO8000
      ENDIF
C
C               ********************************************************
C               **  STEP 53--
C               **  DETERMINE IF AN EMPTY LINE HAD BEEN ENTERED
C               **  (THAT IS, NO COMMAND WAS ENTERED--JUST A CARRIAGE RE
C               ********************************************************
C
      ISTEPN='53'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICOM.EQ.'    '.OR.ICOM.EQ.'.   ')GOTO1000
C
C               **********************************************
C               **  STEP 61--                               **
C               **  SEARCH FOR APPROPRIATE COMMAND--        **
C               **    1) SEARCH FOR USER-DEFINED COMMANDS   **
C               **    1.6) SEARCH FOR 4-PLOT COMMAND        **
CCCCC THE FOLLOWING LINE WAS ADDED   DECEMBER 1993
C               **    1.5) SEARCH FOR 6-PLOT COMMAND        **
C               **    2) SEARCH FOR PLOT CONTROL COMMANDS   **
C               **    3) SEARCH FOR DIAGRAMMATIC GRAPHICS COMMANDS   **
C               **    4) SEARCH FOR OUTPUT DEVICE COMMANDS  **
C               **    5) SEARCH FOR SUPPORT COMMANDS        **
C               **    6) SEARCH FOR GRAPHICS COMMANDS       **
C               **    7) SEARCH FOR ANALYSIS COMMANDS       **
C               **********************************************
C
      ISTEPN='61'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGMA.EQ.'OFF'.AND.ISUBRO.NE.'MAIN')GOTO6115
      WRITE(ICOUT,6111)
 6111 FORMAT('***** FROM MAIN--BEFORE CHECK FOR USER-DEF. COMMANDS')
      CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,6112)ICOM,ICOM2,NUMCOM
 6112 FORMAT('ICOM,ICOM2,NUMCOM = ',A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,6113)ICOM3(1),ICOM4(1),NCOM5(1)
 6113 FORMAT('ICOM3(1),ICOM4(1),NCOM5(1) = ',A4,2X,A4,I8)
      CALL DPWRST('XXX','BUG ')
CCCCC WRITE(ICOUT,6114)ICOM5(1)
C6114 FORMAT('ICOM5(1) = ',A40)
CCCCC CALL DPWRST('XXX','BUG ')
 6115 CONTINUE
C
      IF(ICOM.EQ.'ERAS'.AND.NUMARG.GE.1.AND.
     1IHARG(1).EQ.'DELA')GOTO6119
      IF(NUMCOM.LE.0)GOTO6119
      DO6116I=1,NUMCOM
      I2=I
      IF(ICOM.EQ.ICOM3(I).AND.ICOM2.EQ.ICOM4(I))GOTO6117
 6116 CONTINUE
      GOTO6119
 6117 CONTINUE
C
      NCTEMP=NCOM5(I2)
      IF(NCTEMP.LE.0)GOTO6118
      ICJUNK(001:025)='                         '
      ICJUNK(026:050)='                         '
      ICJUNK(051:075)='                         '
      ICJUNK(076:100)='                         '
      ICJUNK(101:125)='                         '
      ICJUNK(126:130)='     '
      ICJUNK(1:40)=ICOM5(I2)
      ISUBN0='MAIN'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6110)I2,NCTEMP,ISUBN0
 6110 FORMAT('I2,NCTEMP,ISUBN0 = ',2I8,2X,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
CCCCC JUNE, 1990.  SET GRAPHICS UNIT
CCCCC THE FOLLOWING LINE WAS ADDED JUNE 1990 (FOR ROCKY PROBLEM
CCCCC WHEREBY DEFINED STRINGS (E.G., ESC FF) WERE ENDING UP
CCCCC IN DPPL1F.DAT AND CORRUPTING POSTSCRIPT FILES TO HP LASERJET)
      IGUNIT=IPRGR
      CALL GRWRST(ICJUNK,NCTEMP,ISUBN0)
 6118 CONTINUE
      IFOUND='YES'
      IERROR='NO'
      GOTO8000
C
 6119 CONTINUE
C
CCCCC THE FOLLOWING 20 LINES OF CODE DEALING WITH 4-PLOT    (JANUARY 1989)
CCCCC WAS INSERTED JANUARY 1989
C
      IF(ICOM.EQ.'4PLO')GOTO6180
      IF(ICOM.EQ.'4'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')GOTO6180
CCCCC THE FOLLOWING LINE WAS CHANGED     DECEMBER 1993
CCCCC GOTO6189
      GOTO6181
 6180 CONTINUE
      CALL DP4PLO(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1IX3AUT,ITIAUT,
CCCCC MARCH 1996.  ADD FOLLOWING LINE.
     1IRHSTG,IHSTCW,IASHWT,
CCCCC MARCH 2002.  ADD FOLLOWING LINE.
     1I4PLMC,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
CCCCC ADD FOLLOWING SECTION DECEMBER 1997.
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO16181I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
16181   CONTINUE
        DO16183I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16183   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
CCCCC THE FOLLOWING LINE WAS CHANGED     DECEMBER 1993
C6189 CONTINUE
 6181 CONTINUE
C
CCCCC THE FOLLOWING 20 LINES OF CODE DEALING WITH 6-PLOT (DECEMBER 1993)
CCCCC WAS INSERTED DECEMBER 1993
C
      IF(ICOM.EQ.'6PLO')GOTO6182
      IF(ICOM.EQ.'6'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')GOTO6182
      GOTO6183
 6182 CONTINUE
      CALL DP6PLO(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1IX3AUT,ITIAUT,
CCCCC MARCH 1996.  ADD FOLLOWING LINE
     1IRHSTG,IHSTCW,IASHWT,
CCCCC MARCH 2002.  ADD FOLLOWING LINE.
     1I6PLMC,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
CCCCC ADD FOLLOWING SECTION DECEMBER 1997.
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO16182I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
16182   CONTINUE
        DO16184I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16184   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
 6183 CONTINUE
C
CCCCC THE FOLLOWING 20 LINES OF CODE DEALING WITH RF SPREAD PLOT
CCCCC WAS INSERTED SEPTEMBER 1999
C
      IF(ICOM.EQ.'R   '.AND.NUMARG.GE.3.AND.IHARG(1).EQ.'F   '.AND.
     1IHARG(2).EQ.'SPRE'.AND.IHARG(3).EQ.'PLOT')GOTO16185
      IF(ICOM.EQ.'RF  '.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'SPRE'.AND.
     1IHARG(2).EQ.'PLOT')GOTO16185
      IF(ICOM.EQ.'R   '.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'F   '.AND.
     1IHARG(2).EQ.'PLOT')GOTO16185
      IF(ICOM.EQ.'RF'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')GOTO16185
C
      GOTO16186
16185 CONTINUE
      CALL DPRF(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1IX3AUT,ITIAUT,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO16187I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
16187   CONTINUE
        DO16188I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16188   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
16186 CONTINUE
C
CCCCC THE FOLLOWING BLOCK OF CODE DEALING WITH SCATTER PLOT MATRIX
CCCCC WAS INSERTED SEPTEMBER 1999
C
      IF(ICOM.EQ.'SCAT'.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'PLOT'.AND.
     1IHARG(2).EQ.'MATR')GOTO17185
      IF(ICOM.EQ.'YOUD'.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'MATR'.AND.
     1IHARG(2).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'INTE'.AND.
     1IHARG2(1).EQ.'RACT'.AND.IHARG(2).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.3.AND.IHARG(1).EQ.'INTE'.AND.
     1IHARG2(1).EQ.'RACT'.AND.IHARG(2).EQ.'EFFE'.AND.
     1IHARG(3).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.4.AND.IHARG(2).EQ.'INTE'.AND.
     1IHARG2(2).EQ.'RACT'.AND.IHARG(3).EQ.'EFFE'.AND.
     1IHARG(4).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.3.AND.IHARG(2).EQ.'INTE'.AND.
     1IHARG2(2).EQ.'RACT'.AND.IHARG(3).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.5.AND.IHARG(3).EQ.'INTE'.AND.
     1IHARG2(3).EQ.'RACT'.AND.IHARG(4).EQ.'EFFE'.AND.
     1IHARG(5).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'DEX '.AND.NUMARG.GE.4.AND.IHARG(3).EQ.'INTE'.AND.
     1IHARG2(3).EQ.'RACT'.AND.IHARG(4).EQ.'PLOT')GOTO17185
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')
     1GOTO17185
      GOTO17186
C
17185 CONTINUE
      CALL DPSPMA(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,NUMVPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1TEMP,TEMP2,TEMP3,XTEMP1,XTEMP2,MAXNXT,
     1ALOWFR,ALOWDG,
     1IFORSW,
     1ANOPL1,ANOPL2,ISEED,IBOOSS,BARHEF,BARWEF,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO17187I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
17187   CONTINUE
        DO17188I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
17188   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
17186 CONTINUE
C
CCCCC THE FOLLOWING BLOCK OF CODE DEALING WITH CONDITIONING PLOT
CCCCC WAS INSERTED SEPTEMBER 1999
C
      IF(ICOM.EQ.'COND'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')
     1GOTO18185
      IF(ICOM.EQ.'SUBS'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')
     1GOTO18185
      GOTO18186
C
18185 CONTINUE
      CALL DPCOND(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,NUMVPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1TEMP,TEMP2,TEMP3,XTEMP1,XTEMP2,MAXNXT,
     1ALOWFR,ALOWDG,
     1IFORSW,
     1ANOPL1,ANOPL2,ISEED,IBOOSS,BARHEF,BARWEF,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO18187I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
18187   CONTINUE
        DO18188I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
18188   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
18186 CONTINUE
C
CCCCC THE FOLLOWING BLOCK OF CODE DEALING WITH FACTOR PLOT
CCCCC WAS INSERTED SEPTEMBER 1999
C
      IF(ICOM.EQ.'FACT'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT')
     1GOTO18195
      IF(ICOM.EQ.'SCAT'.AND.NUMARG.GE.1.AND.IHARG(1).EQ.'PLOT'.AND.
     1   IHARG(2).NE.'MATR')
     1GOTO18195
      GOTO18196
C
18195 CONTINUE
      CALL DPFACT(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,NUMVPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1TEMP,TEMP2,TEMP3,XTEMP1,XTEMP2,MAXNXT,
     1ALOWFR,ALOWDG,
     1IFORSW,
     1ANOPL1,ANOPL2,ISEED,IBOOSS,BARHEF,BARWEF,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO18197I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
18197   CONTINUE
        DO18198I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
18198   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
18196 CONTINUE
C
CCCCC THE FOLLOWING BLOCK OF CODE DEALING WITH:
CCCCC 1) PARTIAL REGRESSION PLOT
CCCCC 2) PARTIAL LEVERAGE PLOT
CCCCC 3) PARTIAL RESIDUAL PLOT
CCCCC WAS INSERTED JUNE 2002
CCCCC NOTE: THIS IS THE MATRIX FORM OF THE COMMAND.  FOR A SINGLE
CCCCC PLOT, PROCESS IN MAINGR.
C
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.3.AND.IHARG(1).EQ.'PART'.AND.
     1  IHARG(2).EQ.'REGR'.AND.IHARG(3).EQ.'PLOT')GOTO18205
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.3.AND.IHARG(1).EQ.'PART'.AND.
     1  IHARG(2).EQ.'LEVE'.AND.IHARG(3).EQ.'PLOT')GOTO18205
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.3.AND.iHARG(1).EQ.'PART'.AND.
     1  IHARG(2).EQ.'RESI'.AND.IHARG(3).EQ.'PLOT')GOTO18205
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.3.AND.IHARG(1).EQ.'ADDE'.AND.
     1  IHARG(2).EQ.'VARI'.AND.IHARG(3).EQ.'PLOT')GOTO18205
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.4.AND.IHARG(1).EQ.'COMP'.AND.
     1  IHARG(2).EQ.'PLUS'.AND.IHARG(3).EQ.'RESI'.AND.
     1  IHARG(4).EQ.'PLOT')GOTO18205
      IF(ICOM.EQ.'MATR'.AND.NUMARG.GE.2.AND.IHARG(1).EQ.'CCPR'.AND.
     1  IHARG(2).EQ.'PLOT')THEN
        ICASPL='CCPR'
        GOTO18205
      ENDIF
C
      GOTO18206
C
18205 CONTINUE
      ICOM='PART'
      ICOM2='IAL '
      ISHIFT=1
      CALL SHIFTL(ISHIFT,IHARG,IHARG2,IARG,ARG,IARGT,NUMARG,
     1            IBUGG2,IERROR)
C
      CALL DPPRPL(NPLOTV,NPLOTP,NS,ICASPL,IAND1,IAND2,
     1IANGLU,MAXNPP,
     1CLLIMI,CLWIDT,
     1ICONT,NUMHPP,NUMVPP,IMANUF,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1TEMP,TEMP2,TEMP3,XTEMP1,XTEMP2,MAXNXT,
     1ALOWFR,ALOWDG,
     1IFORSW,
     1ANOPL1,ANOPL2,ISEED,IBOOSS,BARHEF,BARWEF,
     1ICAPSW,
     1IBUGG2,IBUGG3,IBUGCO,IBUGEV,IBUGQ,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO8000
        IPLTNU=1
        IPLTPO=0
        DO18207I=1,MAXCIS
          IPLTSV(IPLTNU,I)=' '
18207   CONTINUE
        DO18208I=1,IWIDTH
          IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
18208   CONTINUE
        GOTO8000
      ENDIF
      IF(IERROR.EQ.'YES')GOTO8100
18206 CONTINUE
C
CCCCC THE FOLLOWING 10 LINES DEALING WITH    VERSION     (MAY 1989)
CCCCC WERE INSERTED MAY 1989
C
      IF(ICOM.EQ.'VERS')GOTO6190
      GOTO6199
 6190 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,6191)IVERSI
 6191 FORMAT('THIS IS DATAPLOT VERSION ',A12)
      CALL DPWRST('XXX','BUG ')
      IFOUND='YES'
      IERROR='NO'
      GOTO8000
 6199 CONTINUE
C
 6120 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6121)
 6121 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINPC')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      CALL MAINPC(IBUGPC,IBUGP2,IBUGQ,
     1IVGMSW,IHGMSW,
     1IMPSW,IMPNR,IMPNC,IMPCO,
CCCCC ADD FOLLOWING LINE AUGUST 1999.
     1IMPARG,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1IERASV,
     1PWXMIS,PWXMAS,PWYMIS,PWYMAS,
CCCCC THE FOLLOWING LINE WAS ADDED     APRIL 1992
     1BARHEF,BARWEF,
CCCCC THE FOLLOWING LINE WAS ADDED AUGUST 1992
     1ITIAUT,IX1AUT,IX2AUT,IX3AUT,IY1AUT,IY2AUT,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES'.AND.IERROR.EQ.'NO')IAUTEX='ON'
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
 6130 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6131)
 6131 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINDG')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      CALL MAINDG(IBUGDG,IBUGD2,IBUGU2,ISUBRO,
     1DEFANG,ANGLE,IDEANU,IANGLU,IREPCH,
CCCCC ADD FOLLOWING LINE SEPTEMBER 1998
     1IMPSW,
     1ICAPSW,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
 6140 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6141)
 6141 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINOD')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      CALL MAINOD(IBUGOD,IBUGO2,ISUBRO,
     1ICAPSW,
     1IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
 6150 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6151)
 6151 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINSU--')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6152)IMACRO,IMACNU,IMACCS,IPROGR,ICONCL,ITOPIC
 6152 FORMAT('      IMACRO,IMACNU,IMACCS,IPROGR,ICONCL,ITOPIC = ',
     1A4,I8,2X,A12,2X,A12,2X,A4,2X,A4)
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
CCCCC AN ADDITIONAL ARGUMENT (ALOWFR) WAS ADDED DECEMBER 1988
CCCCC AN ADDITIONAL ARGUMENT (IBASLC) WAS ADDED JUNE 1989
CCCCC 2 ADDITIONAL ARGUMENTS (ICAPSW & IPRDEF) WERE ADDED JUNE 1989
CCCCC AN ADDITIONAL ARGUMENT (ALOWDG) WAS ADDED MARCH 1994.
      CALL MAINSU(IDEFSE,ISEED,ANOPL1,ANOPL2,
     1ISQUAR,IBOOSS,IDEBOO,
     1IANSSV,IREPMX,ILISMX,IPOINT,
     1ISACNC,
     1IAUTSW,IAUTEX,
     1ITOPIC,
     1MAXNXT,
     1IPROSW,
CCCCC THE FOLLOWING LINE WAS AUGMENTED      AUGUST 1994
CCCCC1IMACRO,IMACNU,IMACCS,IOFILE,
CCCCC1IMACRO,IMACNU,IMACCS,IMACL1,IMACL2,IMACLR,IOFILE,
CCCCC THE FOLLOWING LINE WAS AUGMENTED      MARCH 1996
     1IMACRO,IMACNU,IMACCS,IMACL1,IMACL2,IMACLR,IOFILE,IMALEV,
     1IPROGR,ICONCL,
     1ICOM3,ICOM4,ICOM5,NUMCOM,NCOM5,
     1ICTRA1,NCTRA1,ICTRA2,NCTRA2,NUMTRA,
     1IBASLC,IREPCH,IOSW,ICAPSW,IPRDEF,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IBUGEX,IBUGE2,IBUGHE,IBUGH2,IBUGLO,
CCCCC THE FOLLOWING LINE WAS AUGMENTED   MARCH 1992
CCCCC1ICPREH,NCPREH,ICPOSH,NCPOSH,
     1ICPREH,NCPREH,ICPOSH,NCPOSH,IPRITY,IOUTTY,
CCCCC1IHELMX,IFTEXP,ALOWFR,
CCCCC1IHELMX,IFTEXP,ALOWFR,ALOWDG,
     1IHELMX,IFTEXP,IFTORD,ALOWFR,ALOWDG,
     1IFORSW,ICREAF,NCREAF,ICWRIF,NCWRIF,IREARW,IWRIRW,
CCCCC FOLLOWING LINE ADD APRIL 1995
     1IUNFOF,IUNFNR,IUNFMC,
CCCCC THE FOLLOWING LINE WAS FIXED   APRIL 1992
CCCCC1IFOUND,IERROR)
     1IRHSTG,IMPSW,
CCCCC FOLLOWING LINE ADDED SEPTEMBER 2003
     1ITABTI,NCTABT,ITABBR,ITABSP,ITABWD,ITABHT,
CCCCC THE FOLLOWING LINE WAS FIXED   APRIL 1992
     1NPLOTP,IFOUND,IERROR)
      IF(IFOUND.EQ.'YES')GOTO8000
      IF(IERROR.EQ.'YES')GOTO8100
C
 6160 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6161)
 6161 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINGR')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
      CALL MAINGR(ANOPL1,ANOPL2,NPLOTV,NPLOTP,NS,ICASPL,
     1MAXNPP,ISEED,IBOOSS,
     1IX1TSV,IX2TSV,IY1TSV,IY2TSV,
     1IX1ZSV,IX2TSV,IY1TSV,IY2TSV,
CCCCC THE FOLLOWING LINE WAS ADDED    APRIL 1992
     1BARHEF,BARWEF,
CCCCC THE FOLLOWING LINE WAS ADDED    MARCH 1996
     1IRHSTG,IHSTCW,
     1ICAPSW,IFORSW,
     1IAND1,IAND2,ICONT,NUMHPP,NUMVPP,
     1TEMP,TEMP2,TEMP3,XTEMP1,XTEMP2,MAXNXT,
     1ISUBRO,IFOUND,IERROR)
      IF(IERROR.EQ.'YES')GOTO8100
CCCCC ADD FOLLOWING SECTION DECEMBER 1997.
CCCCC STORE GRAPHICS COMMAND FOR REPLOT COMMAND.
CCCCC CHECK FOR "PLOT AND" SYNTAX CREATES SOME COMPLICATIONS.
CCCCC DON'T STORE IF ALREADY EXECUTING.
      IF(IFOUND.EQ.'YES')THEN
        IF(IPLTST.EQ.'ON')GOTO16999
        IF(IPLTNU.GT.1 .AND. IPLTPO.GE.IPLTNU)GOTO16999
        IF(IAND1.EQ.'NO'.AND.IAND2.EQ.'NO')THEN
          IPLTNU=1
          IPLTPO=0
          DO17163I=1,MAXCIS
            IPLTSV(IPLTNU,I)=' '
17163     CONTINUE
          DO16163I=1,IWIDTH
            IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16163     CONTINUE
        ELSEIF(IAND1.EQ.'NO'.AND.IAND2.EQ.'YES')THEN
          IPLTNU=1
          IPLTPO=0
          DO17164I=1,MAXCIS
            IPLTSV(IPLTNU,I)=' '
17164     CONTINUE
          DO16164I=1,IWIDTH
            IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16164     CONTINUE
        ELSEIF(IAND1.EQ.'YES'.AND.IAND2.EQ.'NO')THEN
          IPLTNU=IPLTNU+1
          IPLTPO=0
          DO17165I=1,MAXCIS
            IPLTSV(IPLTNU,I)=' '
17165     CONTINUE
          DO16165I=1,IWIDTH
            IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16165     CONTINUE
        ELSEIF(IAND1.EQ.'YES'.AND.IAND2.EQ.'YES')THEN
          IPLTNU=IPLTNU+1
          IPLTPO=0
          DO17166I=1,MAXCIS
            IPLTSV(IPLTNU,I)=' '
17166     CONTINUE
          DO16166I=1,IWIDTH
            IPLTSV(IPLTNU,I)=IANSLC(I)(1:1)
16166     CONTINUE
        ENDIF
16999   CONTINUE
      ENDIF
 6165 CONTINUE
      ICONT=IDCONT(1)
      NUMHPP=IDNHPP(1)
      IF(IFOUND.EQ.'YES'.AND.IAND2.EQ.'NO'.AND.ICOM.NE.'STEM')
     1CALL DPGRAP(Y,X,X3D,D,N,NPLOTP,ICASPL,ICONT,NUMHPP,
     1XMATN,YMATN,XMITN,YMITN,
     1ISQUAR,
     1IVGMSW,IHGMSW,
     1IHNAME,IHNAM2,IUSE,IN,IVALUE,VALUE,NUMNAM,
     1IVSTAR,IVSTOP,IFUNC,NUMCHF,IREPCH,
     1YPLOT,XPLOT,X2PLOT,TAGPLO,
     1IMPSW,IMPNR,IMPNC,IMPCO,
CCCCC ADD FOLLOWING LINE AUGUST 1999.
     1IMPARG,
     1PMXMIN,PMXMAX,PMYMIN,PMYMAX,
     1MAXCOL,
CCCCC AUGUST 1992.  ADD FOLLOWING LINE
     1DSIZE,DSYMB,DCOLOR,DFILL,
     1ICAPSW,
     1IBUGUG,IBUGU2,IBUGU3,IBUGU4,ISUBRO,
     1IERROR)
CCCCC IF(IFOUND.EQ.'YES'.AND.IAND2.EQ.'NO'.AND.ICOM.NE.'STEM')
CCCCC1IAUTEX='OFF'
      IF(ICASPL.EQ.'WEIB')GOTO6166
CCCCC THE FOLLOWING LINE WAS ADDED JUNE 1990
      IF(ICASPL.EQ.'NORM')GOTO6166
CCCCC THE FOLLOWING 4 LINES ADDED MAY 1998
      IF(ICASPL.EQ.'NHAZ')GOTO6166
      IF(ICASPL.EQ.'LHAZ')GOTO6166
      IF(ICASPL.EQ.'EHAZ')GOTO6166
      IF(ICASPL.EQ.'WHAZ')GOTO6166
      GOTO6167
 6166 CONTINUE
      IX1TSC=IX1TSV
      IX2TSC=IX2TSV
      IY1TSC=IY1TSV
      IY2TSC=IY2TSV
      IF(ICASPL.EQ.'WEIB')GOTO6167
      IF(ICASPL.EQ.'NORM')GOTO6167
      IX1ZFM=IX1ZSV
      IX2ZFM=IX2ZSV
      IY1ZFM=IY1ZSV
      IY2ZFM=IY2ZSV
 6167 CONTINUE
      IF(IERROR.EQ.'NO')IAND1=IAND2
      IF(IERROR.EQ.'YES')GOTO8100
      IF(IFOUND.EQ.'YES')GOTO8000
C
 6170 CONTINUE
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1WRITE(ICOUT,6171)
 6171 FORMAT('***** FROM MAIN--BEFORE CALL TO MAINAN')
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL DPWRST('XXX','BUG ')
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
CCCCC AN ADDITIONAL ARGUMENT (ALOWFR) WAS ADDED DECEMBER 1988
CCCCC AN ADDITIONAL ARGUMENT (ALOWDG) WAS ADDED MARCH 1994
      CALL MAINAN(ICASAN,ISEED,ANOPL1,ANOPL2,
     1TEMP,TEMP2,XTEMP1,XTEMP2,MAXNXT,
CCCCC1IFTEXP,
     1IFTEXP,IFTORD,
CCCCC1ALOWFR,
     1ALOWFR,ALOWDG,
CCCCC JULY 2002: FOLLOWING LINE FOR BOOTSTRAP FIT
     1IBOOSS,
CCCCC AUGUST 2002: FOLLOWING LINE FOR CROSS TABULATE, TABULATE
     1ICAPSW,
     1IFORSW,
     1IBUGAN,IBUGA2,IBUGA3,
     1IBUGCO,IBUGEV,IBUGQ,ISUBRO,IFOUND,IERROR)
C
C               ********************************************************
C               **  STEP 62--                                         **
C               **  NO MATCH FOUND FOR COMMAND;
C               **  THEREFORE, CHECK TO SEE IF A DEFAULT COMMAND EXISTS,
C               **  IF SO, INSERT THE DEFAULT COMMAND AND SEARCH AGAIN;
C               **  IF NOT, GENERATE A MESSAGE STATING THAT
C               **  THERE WAS NO MATCH.
C               ********************************************************
C
      ISTEPN='62'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
      IF(IBUGMA.EQ.'ON')WRITE(ICOUT,777)IMANUF,NUMDEV,IDMANU(1)
      IF(IBUGMA.EQ.'ON')CALL DPWRST('XXX','BUG ')
C
      IF(IDEFCM.EQ.'OFF')GOTO8000
      IF(IWIDDC.LE.0)GOTO8000
      IF(IPASS.GE.2)GOTO8000
      IPASS=2
C
      DO6210I=1,IWIDTH
      IREV=IWIDTH-I+1
      JREV=IREV+IWIDDC+1
      IANSLC(JREV)=IANSLC(IREV)
      IANS(JREV)=IANS(IREV)
 6210 CONTINUE
C
      DO6220I=1,IWIDDC
      IANSLC(I)=IDEFC(I)
      IANS(I)=IDEFC(I)
 6220 CONTINUE
C
      I=IWIDDC+1
CCCCC THE FOLLOWING LINE WAS FIXED JULY 1989
CCCCC IANSLC(I)=' '
      IANSLC(I)='    '
      IANS(I)=' '
C
      GOTO1490
C
CCCCC ITEXCO='ANYT'
CCCCC
CCCCC NUMHPP=IDEVPP(1,1)
CCCCC NUMVPP=IDEVPP(1,2)
CCCCC ANUMHP=NUMHPP
CCCCC ANUMVP=NUMVPP
CCCCC
CCCCC ICOLOR=IDEVCL(1)
CCCCC
CCCCC XSTART=XEND
CCCCC YSTART=YEND
CCCCC
CCCCC CALL DPTEXT(ITEXCO,IANS,IWIDTH,XSTART,YSTART,
CCCCC1IFONT,ICASE,IJUST,ANGLE,IANGLU,WIDTH,HEIGHT,
CCCCC1XFACT,YFACT,ANUMHP,ANUMVP,ICOLOR,
CCCCC1XEND,YEND,IFOUND,IBUGTE,IERROR)
CCCCC IF(IFOUND.EQ.'YES')GOTO8000
CCCCC IF(IERROR.EQ.'YES')GOTO8100
C
C               ***********************************************
C               **  STEP 80--                                **
C               **  DETERMINE IF COMMAND FOUND OR NOT.       **
C               **  IF FOUND, LOOP BACK TO READ ANOTHER      **
C               **  LINE FROM THE TERMINAL.                  **
C               **  IF NOT FOUND, GENERATE AN ERROR MESSAGE  **
C               **  AND THEN LOOP BACK TO READ ANOTHER       **
C               **  LINE FROM THE TERMINAL.                  **
C               ***********************************************
C
 8000 CONTINUE
      ISTEPN='80'
      IF(IBUGMA.EQ.'ON'.OR.ISUBRO.EQ.'MAIN')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
C     THE FOLLOWING 3 LINES WERE COMMENTED OUT DEC. 1988
C     AND REPLACED WITH THE SUCCEEDING 8 LINES
C
CCCCC IF(IFOUND.EQ.'YES'.AND.ICOM.NE.'RESE')GOTO1000
CCCCC IF(IFOUND.EQ.'YES'.AND.ICOM.EQ.'RESE')GOTO200
CCCCC GOTO8100
C
      IF(IFOUND.EQ.'YES')GOTO8010
      GOTO8100
 8010 CONTINUE
      IF(ICOM.NE.'RESE')GOTO1000
      IF(ICOM.EQ.'RESE'.AND.NUMARG.LE.0)GOTO200
      IF(ICOM.EQ.'RESE'.AND.NUMARG.GE.1.AND.
     1   IHARG(1).EQ.'ALL')GOTO200
      GOTO1000
C
 8100 CONTINUE
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      IF(IFOUND.EQ.'NO'.AND.IERROR.EQ.'NO')WRITE(ICOUT,8111)
 8111 FORMAT('***** NO MATCH FOUND FOR COMMAND.')
      IF(IFOUND.EQ.'NO'.AND.IERROR.EQ.'NO')CALL DPWRST('XXX','BUG ')
      IF(IERROR.EQ.'YES')WRITE(ICOUT,8112)
      IF(IERROR.EQ.'YES')CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING LINE WAS CHANGED FEBRUARY 1993
C8112 FORMAT('***** ERROR CONDITION ENCOUNTERED.')
 8112 FORMAT('***** ERROR CONDITION ENCOUNTERED AT MAIN 8112.')
      WRITE(ICOUT,8113)
 8113 FORMAT('      THE FIRST 8 CHARACTERS OF THE FIRST WORD ')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,8114)ICOM,ICOM2
 8114 FORMAT('      OF THE COMMAND ARE ',A4,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,8115)
 8115 FORMAT('      PLEASE REENTER COMMAND LINE.')
      CALL DPWRST('XXX','BUG ')
 8190 CONTINUE
      GOTO1000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT.      **
C               *****************
C
 9000 CONTINUE
CCCCC STOP
      END

C     THIS IS FILE TCDRIV.FOR
C     PURPOSE--THESE ARE THE FORTRAN ROUTINES WHICH SERVE AS
C              A DRIVER & BRIDGE BETWEEN THE DATAPLOT FORTRAN
C              AND THE TURBO-C C DRIVER, AND ULTIMATELY
C              THE TURBO C C ROUTINES.
C
C     TIME DRAIN--THE C CODE WILL NOT WORK & WILL GET ERROR MESSAGE:
C                 "REAL MODE LIBRARY TERMINATED IMPROPERLY--
C                 PLEASE REBOOT"
C                 UNLESS    COMSPACE   IN AUTOEXEC.BAT
C                 IS AT LEAST 400000 .
C                 THIS HAS BEEN A PROBLEM 3 TIMES!
C
C     NOTE--IT IS BEST THAT THE TURBO-C LOAD SWITCH (1/0) LOGIC
C           AND THE TURBO-C GRAPHICS STATUS (OPEN/CLOSE) LOGIC
C           IS DONE HEREIN RATHER THAN BE SCATTERED ABOUT
C           IN THE REST OF THE DATAPLOT CODE.
CCCCC NOTE--THE COMMON STRUCTURE IS--
CCCCC COMMON /FC/NTEXTF,NTEXTC,NPLOTF,TEXTFC,TEXTCF,PLOTFC(11)
CCCCC BYTES:       4      4      4      84     84     84*11
C
C NOTE--THESE ARE THE TURBO-C FILES--
C TEXT OUTPUT       7 C:\TURBOC\FRONTEND\DPTEXT.TEX TCSHME+ TCGECO-+
C GRAPHICS OUTPUT   8 C:\TURBOC\FRONTEND\DPPLOT.TEX
C TCDRIV DEBUG      9 C:\TURBOC\FRONTEND\TCDEBU.TEX TCLOTC+ TCGETC-
C COM. HIST. INPUT 10 C:\TURBOC\FRONTEND\DPCOMM.TEX TCINCF+- TCWRCO+-+-
C
C     NOTE--THERE ARE 4 TURBO-C SWITCHES--
C           1. TCLOAD
C              HAS CMAIN.EXE BEEN LOADED (& INIT. EXEC.)? YES/NO
C           2. TCMENU
C              IS THE TURBO C MENU ON THE SCREEN?         YES/NO
C           3. TCPLFI        FILE 8
C              WHAT IS STATUS OF THE TURBO C PLOT FILE?   OPEN/CLOS
C           4. TCTEFI        FILE 7
C              WHAT IS STATUS OF THE TURBO C TEXT FILE?   OPEN/CLOS
C              C:\TURBOC\FRONTEND\DPTEXT.TEX:
C              INITIAL OPENING:  MAIN => TCDRIV(TCSHME)
C                                (& SET TCTEFI TO OPEN)
C              REPEATEDLY CLOSE AND OPEN: TCDRIV(TCGECO)
C                                (& SET TCTEFI TO CLOS THEN OPEN)
C              REPEATEDLY WRITTEN: Many => GRWRST with IGUNIT=7
C              CLOSE WHEN HAVE   EXIT   COMMAND:  TCDRIV(TCGECO)
C                                (& SET TCTEFI TO CLOS)
C
C     NOTE--WHEN THE COMMAND    MENU   IS ENTERED ON THE FORTRAN SIDE,
C           THIS IS DETECTED IN     MAIN.FOR
C           AND THEN   TCLOTC IS CALLED FIRST
C           AND        TCSHME IS CALLED SECOND
C           (BOTH FROM    MAIN.FOR)
C     NOTE--THEY ARE INITIALLY ALLOCATED IN DPCODV.INC
C           THEY ARE INITIALLY DEFINED   IN INITOD.FOR
C     WRITTEN BY--JAMES J. FILLIBEN
C     ORIGINAL VERSION--MAY         1991
C     UPDATED         --MAY         1991
C     UPDATED         --JUNE        1991
C     UPDATED         --FEBRUARY    1995
C     UPDATED         --MARCH       1995
C
C ----------TCINCO-----------------------------
C
      SUBROUTINE TCINCO(ISUBRO)
C
C     PURPOSE--INITIALIZE TURBO-C COMMON
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     DATAPLOT CALLING ROUTINE--INITOD ONLY (MAIN--MAININ--INITOD)
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCINCO IS THE FIRST ROUTINE CALLED
C           TCLOTC IS THE SECOND ROUTINE CALLED
C           AND TCSHME IS THE THIRD ROUTINE CALLED
C           (ALL FROM MAIN)
CCCCC THE FOLLOWING COMMENT LINES WERE ADDED MAY 1992 (JJF)
C     DEFINE THE 4 GENERAL TURBO-C SWITCHES.
C     NOTE--THERE ARE 4 TURBO-C SWITCHES--
C           1. TCLOAD
C              HAS CMAIN.EXE BEEN LOADED (& INIT. EXEC.)? YES/NO
C           2. TCMENU
C              IS THE TURBO C MENU ON/OFF THE SCREEN?     ON/OFF
C           3. TCPLFI
C              WHAT IS STATUS OF THE TURBO C PLOT FILE?   OPEN/CLOS
C           4. TCTEFI
C              WHAT IS STATUS OF THE TURBO C TEXT FILE?   OPEN/CLOS
C     NOTE--THEY ARE INITIALLY ALLOCATED IN DPCODV.INC
C           THEY ARE INITIALLY DEFINED   IN TCINCO.FOR IN TCDRIV.FOR
C           THEY ARE USED                IN TCDRIV.FOR
C
C     UPDATED         --FEBRUARY  1995. COMMAND NUMBER ICOMID SET = 0
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*4 ISUBRO
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
CCCCC DELETE THE FOLLOWING LINE AFTER DEBUGGED
CCCCC THE FOLLOWING LINE WAS FIXED     FEBRUARY 1996
CCCCC OPEN(UNIT=9,FILE='C:\TURBOC\FRONTEND\TCDEBU.TEX')
      OPEN(UNIT=9,FILE='C:\TURBOC\FRONTEND\TCDEBU.TEX',ERR=9010)
 9010 CONTINUE
CLAHE FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
CLAHE FILEXX(NCMPAT+1:NCMPAT+11)='TCDEBU.TEX'
CLAHE OPEN(UNIT=9,FILE=FILEXX)
C
      IF(ISUBRO.EQ.'INCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINCO IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
         WRITE(9,53)NCMPAT
   53    FORMAT(1H ,'NCMPAT = ',I8)
         WRITE(9,54)MPATH
   54    FORMAT(1H ,'MPATH = ',A80)
         WRITE(9,55)FILEXX
   55    FORMAT(1H ,'FILEXX = ',A80)
      ENDIF
C
      TCLOAD='NO'
      TCMENU='OFF'
CCCCC THE FOLLOWING 2 LINES WERE CORRECTED JULY 1992 (JJF)
CCCCC TCPLFI='OFF'
CCCCC TCTEFI='OFF'
      TCPLFI='CLOS'
      TCTEFI='CLOS'
      ITCST='OFF'
      TEXTFC=' '
      NTEXTF=0
CCCCC THE FOLLOWING 4 LINES WERE ADDED MAY 1992 (JJF)
      NPLOTF=0
      DO2100I=1,11
      PLOTFC(I)=' '
 2100 CONTINUE
C
CCCCC THE FOLLOWING LINE WAS ADDED                 FEBRUARY 1995
CCCCC TO COUNT COMMAND LINES ENTERED               FEBRUARY 1995
CCCCC SO THAT TEXT OUTPUT PAGES MAY BE NUMBERED    FEBRUARY 1995
CCCCC IN THE OUTPUT FILE DPTEXT.TEX                FEBRUARY 1995
CCCCC (NOTE--ICOMID IS IN DPCODV.COM)              FEBRUARY 1995
      ICOMID=0
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCLOTC IN TCDRIV--')
         WRITE(9,9012)ISUBRO
 9012    FORMAT(1H ,'ISUBRO= ',A4)
         WRITE(IPR,9013)TCLOAD,TCMENU,TCPLFI,TCTEFI
 9013    FORMAT(1H ,'TCLOAD,TCMENU,TCPLFI,TCTEFI = ',
     1               A4,2X,A4,2X,A4,2X,A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCLOTC-----------------------------
C
      SUBROUTINE TCLOTC(ISUBRO)
C
C     PURPOSE--INITIALIZE (LOAD IN) THE TURBO-C C DRIVER (CMAIN.C)
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--MAIN ONLY
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCLOTC IS THE FIRST ROUTINE CALLED
C           AND TCSHME IS THE SECOND ROUTINE CALLED
C           (BOTH FROM MAIN)
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*4 ISUBRO
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCLOTC IN TCDRIV--')
         WRITE(9,52)ISUBRO,TCLOAD
   52    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
         WRITE(9,53)NCMPAT
   53    FORMAT(1H ,'NCMPAT = ',I8)
         WRITE(9,54)MPATH
   54    FORMAT(1H ,'MPATH = ',A80)
      ENDIF
C
      IF(TCLOAD.EQ.'NO')THEN
CLAHE    CALL REAL_MODE_SHORT_CUT@
CCCCC CALL PAUSE('1')
C
CCCCC THE FOLLOWING LINE WAS FIXED     FEBRUARY 1996
CCCCC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAIN.EXE')
CCCCCOLD CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAINF.EXE')
         FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
         FILEXX(NCMPAT+1:NCMPAT+10)='CMAIN.EXE'
CLAHE    CALL LOAD_REAL_MODE_LIBRARY@(FILEXX)
C
CCCCC ****************** DANGER ABOVE *********************
CCCCC ***** NOTE--DATAPLOT AND FED HAVE DIFFERENCE C-SIDE MAIN ROUTINES
CCCCC             DATAPLOT USES CMAIN.EXE
CCCCC             FED      USED CMAINF.EXE
CCCCC        IF NOT HAV PROPER CMAIN..  LOADED
CCCCC THEN WILL GET MESSAGE:
CCCCC REAL MODE LIBRARY HAS TERMINATED IMPROPERLY,
CCCCC SYSTEM MUST BE REBOOTED
CCCCC CALL PAUSE('2')
CCCCC CHANGE ABOVE AND ALSO WELL BELOW
         TCLOAD='YES'
      ENDIF
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCLOTC IN TCDRIV--')
         WRITE(9,9012)ISUBRO,TCLOAD
 9012    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
         WRITE(9,999)
         WRITE(9,9011)
         WRITE(9,9012)ISUBRO,TCLOAD
      ENDIF
C
      RETURN
      END
C
C ----------TCSHME-----------------------------
C
      SUBROUTINE TCSHME(ISUBRO)
C
C     PURPOSE--SHOW THE DATAPLOT GUI MENU UNDER TURBO-C
C     DATAPLOT CALLING ROUTINE--MAIN
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCLOTC IS THE FIRST ROUTINE CALLED
C           AND TCSHME IS THE SECOND ROUTINE CALLED
C           (BOTH FROM MAIN)
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*4 ISUBRO
      INTEGER*4 NBYTES
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'SHME'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCSHME IN TCDRIV--')
         WRITE(9,52)ISUBRO,TCLOAD
   52    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
         WRITE(9,53)NCMPAT
   53    FORMAT(1H ,'NCMPAT = ',I8)
         WRITE(9,54)MPATH
   54    FORMAT(1H ,'MPATH = ',A80)
      ENDIF
C
      IF(TCMENU.EQ.'OFF')THEN
         TEXTFC(1:4)='SHME'
         TEXTFC(5:8)='SHME'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CLAHE    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CLAHE    CALL REAL_MODE@
         TCMENU='ON'
CCCCC THE FOLLOWING LINE WAS FIXED     FEBRUARY 1996
CCCCC    OPEN(UNIT=7,FILE='C:\TURBOC\FRONTEND\DPTEXT.TEX')
         OPEN(UNIT=7,FILE='C:\TURBOC\FRONTEND\DPTEXT.TEX',ERR=9010)
 9010    CONTINUE
CLAHE    FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
CLAHE    FILEXX(NCMPAT+1:NCMPAT+11)='DPTEXT.TEX'
CLAHE    OPEN(UNIT=7,FILE=FILEXX)
         IPR=7
         TCTEFI='OPEN'
      ENDIF
C
      IF(ISUBRO.EQ.'SHME'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCSHME IN TCDRIV--')
         WRITE(9,9012)ISUBRO,TCLOAD,TEXTCF(1:4)
 9012    FORMAT(1H ,'ISUBRO,TCLOAD,TEXTCF(1:4) = ',A4,2X,A4,2X,A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCGECO-----------------------------
C
      SUBROUTINE TCGECO(IB,NIB,IBUGS2,ISUBRO)
C
C     PURPOSE--GET A DATAPLOT COMMAND FROM THE GUI MENU
C     DATAPLOT CALLING ROUTINE--DPGETC
C
C     UPDATED         --FEBRUARY 1995. ALLOW ACCUMULATION OF DPTEXT.TEXT
C     UPDATED         --FEBRUARY 1995. WRITE _____ AS TEXT SEPARATOR
C                                      IN DPTEXT.TEX
C     UPDATED         --FEBRUARY 1995. WRITE COMMAND LINE NUMBER
C                                      ON _____ LINE IN DPTEXT.TEX
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      INTEGER*4 NBYTES
      CHARACTER*4 ISUBRO
      CHARACTER*4 ISTEPN
      CHARACTER*4 IBUGS2
CCCCC CHARACTER*4 IFOUND
CCCCC CHARACTER*4 IERROR
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      CHARACTER*80 IB
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
C
      ISUBN1='TCGE'
      ISUBN2='CO  '
C
      ISTEPN='--0-'
CCCCC ISUBRO='GECO'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
  105 FORMAT(1H ,'TRACE AT STEP ',A4,' OF ',A4,A4)
      NIB=0
      IF(TCMENU.EQ.'ON')THEN
C
CMS-F    ENDFILE 7
         CLOSE(7)
         IPR=6
         TCTEFI='CLOS'
         TEXTCF=' '
         TEXTFC(1:4)='GECO'
         TEXTFC(5:8)='GECO'
      ISTEPN='1'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
C
CLAHE    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CLAHE    CALL REAL_MODE@
C
CCCCC    NBYTES=8+80
         NBYTES=12+84+84
CLAHE    CALL COPY_FROM_REAL_MODE@(NTEXTF,NBYTES)
      ISTEPN='4'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
      WRITE(9,885)NTEXTF,NTEXTC
  885 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--NTEXTF,NTEXTC = ',2I8)
      WRITE(9,886)TEXTFC(1:10)
  886 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTFC(1:10) = ',A10)
      WRITE(9,887)TEXTCF(1:10)
  887 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTCF(1:10) = ',A10)
C
         NIB=NTEXTC
         IB=TEXTCF
C
         IF(TEXTCF(1:4).EQ.'EXME'.OR.TEXTCF(1:4).EQ.'ERRO')THEN
            TCMENU='OFF'
            TCTEFI='CLOS'
         ELSE IF(TEXTCF(1:4).EQ.'EXIT')THEN
            TCMENU='OFF'
            TCTEFI='CLOS'
CCCCC       ENDFILE 9  6/12/92
CCCCC       CLOSE(9) 6/12/92
CMS-F       ENDFILE 9
            CLOSE(9)
CCCCC THE FOLLOWING LINE WAS ADDED AUGUST 1992
            RETURN
         ELSE
CCCCC THE FOLLOWING LINE WAS COMMENTED OUT        FEBRUARY 1995
CCCCC AND REPLACED BY THE SUCCEEDING LINE         FEBRUARY 1995
CCCCC (WHICH HAPPENS TO BE NON-STANDARD FORTRAN)  FEBRUARY 1995
CCCCC SO AS TO ALLOW TEXT OUTPUT TO BE            FEBRUARY 1995
CCCCC ACCUMULATED IN THE DPTEXT.TEX FILE          FEBRUARY 1995
CCCCC SO AS TO ALLOW                              FEBRUARY 1995
CCCCC C-SIDE SCROLLING OF ALL TEXT OUTPUT         FEBRUARY 1995
CCCCC       OPEN(UNIT=7,FILE='C:\TURBOC\FRONTEND\DPTEXT.TEX')
CCCCC THE FOLLOWING 2 LINES WERE FIXED     FEBRUARY 1996
CCCCC       OPEN(UNIT=7,STATUS='APPEND',
            OPEN(UNIT=7,
CCCCC1           FILE='C:\TURBOC\FRONTEND\DPTEXT.TEX')
     1           FILE='C:\TURBOC\FRONTEND\DPTEXT.TEX',ERR=9020)
 9020       CONTINUE
CLAHE FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
CLAHE FILEXX(NCMPAT+1:NCMPAT+11)='DPTEXT.TEX'
CLAHE       OPEN(UNIT=7,STATUS='APPEND',
CLAHE1           FILE=FILEXX)
            IPR=7
            TCTEFI='OPEN'
C
CCCCC THE FOLLOWING 19 LINES WERE ADDED SO AS TO PROVIDE FEBRUARY 1995
CCCCC A VISUAL SEPARATOR OF UNDERSCORES BETWEEN         FEBRUARY 1995
CCCCC ACCUMULATED SUCCESSIVE TEXT OUTPUT                FEBRUARY 1995
CCCCC IN DPTEXT.TEX                                     FEBRUARY 1995
C
      ICOMID=ICOMID+1
      IF(ICOMID.LE.9)THEN
         WRITE(7,111)ICOMID
  111    FORMAT(1X,'_____','[',I1,']')
      ELSE IF(ICOMID.LE.99)THEN
         WRITE(7,112)ICOMID
  112    FORMAT(1X,'_____','[',I2,']')
      ELSE IF(ICOMID.LE.999)THEN
         WRITE(7,113)ICOMID
  113    FORMAT(1X,'_____','[',I3,']')
      ELSE IF(ICOMID.LE.9999)THEN
         WRITE(7,114)ICOMID
  114    FORMAT(1X,'_____','[',I4,']')
      ELSE IF(ICOMID.LE.99999)THEN
         WRITE(7,115)ICOMID
  115    FORMAT(1X,'_____','[',I4,']')
      ELSE
         WRITE(7,116)ICOMID
  116    FORMAT(1X,'_____','[',I8,']')
      ENDIF
C
         ENDIF
C
      ENDIF
C
      WRITE(9,888)TEXTCF(1:10)
  888 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTCF(1:10) = ',A10)
      WRITE(9,889)IB
  889 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--IB = ',A80)
      WRITE(9,890)NIB
  890 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--NIB = ',I4)
      DO895I=1,80
      JIB=ICHAR(IB(I:I))
      IF(JIB.LE.31)IB(I:I)=' '
CCCCC WRITE(9,896)I,IB(I:I),JIB
CC896 FORMAT(1H ,'I,IB(I:I),JIB = ',I8,2X,A1,I8)
  895 CONTINUE
      WRITE(9,990)
  990 FORMAT(1H )
C
      ISTEPN='-99-'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
      RETURN
      END
C
C ----------TCINDE-----------------------------
C
      SUBROUTINE TCINDE
C
C     PURPOSE--INITIALIZE (LOAD IN) THE TURBO-C C DRIVER (CMAIN.C)
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--INITOD AND GRINDE
C     NOTE--WHEN THE MENU IS ON THE SCREEN
C           AND THE USER ENTERS A PLOT COMMAND (SUCH AS HISTOGRAM Y),
C           TCINDE IS THE FIRST ROUTINE CALLED
C           AND TCOPDE IS THE SECOND ROUTINE CALLED
C           IN GETTING THE PLOT ONTO THE MENU'S PLOT WINDOW.
C           (TCINDE FROM GRINDE    AND    TCOPDE FROM GROPDE).
C           NOTE THAT THE FIRST CALL (TCINDE) IS IN FACT UNNECESSARY
C           SINCE THE FORTRAN-TO-C LINK HAS ALREADY BEEN ESTABLISHED
C           BACK IN THE SUBROUTINE TCLOTC--WHICH WAS CALLED
C           WHEN THE USER CAUSED THE MENU TO APPEAR
C           BY ENTERING THE FORTRAN-SIDE COMMAND    MENU.
C     NOTE--TCINDE.FOR    HAS NO CORRESPONDANCE IN    TUDRIV.C
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*4 ISUBRO
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
CCCCC THE FOLLOWING LINE SHOULD BE COMMENTED OUT WHEN DEBUGGED
      ISUBRO='DRIV'
      IF(ISUBRO.EQ.'INDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINDE IN TCDRIV--')
         WRITE(9,53)TCPLFI,TCTEFI,TCLOAD
   53    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,54)TCMENU,IPLATF
   54    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,55)TEXTFC(1:20)
   55    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,56)TEXTCF(1:20)
   56    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      IF(TCLOAD.EQ.'NO')THEN
CLAHE    CALL REAL_MODE_SHORT_CUT@
CCCCC THE FOLLOWING LINE WAS FIXED     FEBRUARY 1996
CCCCC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAIN.EXE')
CCCCCOLD CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAINF.EXE')
         FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
         FILEXX(NCMPAT+1:NCMPAT+11)='CMAIN.EXE'
CLAHE    CALL LOAD_REAL_MODE_LIBRARY@(FILEXX)
         TCLOAD='YES'
      ENDIF
C
      IPLATF='WITHINMENU'
      IF(TCMENU.EQ.'OFF')IPLATF='STANDALONE'
C
      IF(ISUBRO.EQ.'INDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCINDE IN TCDRIV--')
         WRITE(9,9013)TCPLFI,TCTEFI,TCLOAD
 9013    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,9014)TCMENU,IPLATF
 9014    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,9015)TEXTFC(1:20)
 9015    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,9016)TEXTCF(1:20)
 9016    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      RETURN
      END
C
C ----------TCOPDE-----------------------------
C
      SUBROUTINE TCOPDE
C
C     PURPOSE--OPEN TURBO-C GRAPHICS
C              (THE INITIALIZATION IS ALREADY ASSUMED TO BE DONE)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--GROPDE
C     NOTE--WHEN THE MENU IS ON THE SCREEN
C           AND THE USER ENTERS A PLOT COMMAND (SUCH AS HISTOGRAM Y),
C           TCINDE IS THE FIRST ROUTINE CALLED
C           AND TCOPDE IS THE SECOND ROUTINE CALLED
C           IN GETTING THE PLOT ONTO THE MENU'S PLOT WINDOW.
C           (TCINDE FROM GRINDE    AND    TCOPDE FROM GROPDE).
C           NOTE THAT THE FIRST CALL (TCINDE) IS IN FACT UNNECESSARY
C           SINCE THE FORTRAN-TO-C LINK HAS ALREADY BEEN ESTABLISHED
C           BACK IN THE SUBROUTINE TCLOTC--WHICH WAS CALLED
C           WHEN THE USER CAUSED THE MENU TO APPEAR
C           BY ENTERING THE FORTRAN-SIDE COMMAND    MENU.
C
      CHARACTER*4 ISUBRO
      INTEGER*4 NBYTES
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
CCCCC THE FOLLOWING LINE SHOULD BE COMMENTED OUT WHEN DEBUGGED
      ISUBRO='DRIV'
      IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCOPDE IN TCDRIV--')
         WRITE(9,53)TCPLFI,TCTEFI,TCLOAD
   53    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,54)TCMENU,IPLATF
   54    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,55)TEXTFC(1:20)
   55    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,56)TEXTCF(1:20)
   56    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
CCCCC WRITE(6,777)TCPLFI
CC777 FORMAT(1H ,'TCPLFI = ',A4)
C
      IF(TCPLFI.EQ.'CLOS')THEN
CCCCC    OPEN(UNIT=8,FILE='C:\TURBOC\FRONTEND\DPPLOT.TEX')
         TEXTFC(1:4)='PLOT'
         TEXTFC(5:8)='OPDE'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CLAHE    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CLAHE    CALL REAL_MODE@
         NPLOTF=0
         TCPLFI='OPEN'
      ENDIF
C
CCCCC WRITE(6,778)TCPLFI
CC778 FORMAT(1H ,'TCPLFI = ',A4)
C
      COMMFC='INDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IPLATF,INULC
  112 FORMAT(A4,1X,A10,A1)
CCCCC IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCOPDE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='OPDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
      IF(NPLOTF.GE.10) CALL TCSEND
C
      IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCOPDE IN TCDRIV--')
         WRITE(9,9013)TCPLFI,TCTEFI,TCLOAD
 9013    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,9014)TCMENU,IPLATF
 9014    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,9015)TEXTFC(1:20)
 9015    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,9016)TEXTCF(1:20)
 9016    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      RETURN
      END
C
C ----------TCCLDE-----------------------------
C
      SUBROUTINE TCCLDE
C
C     PURPOSE--CLOSE TURBO C GRAPHICS
C     DATAPLOT CALLING ROUTINE--GRCLDE
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='CLDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(NPLOTF.GE.10) CALL TCSEND
      CALL TCSEND
C
CCCCC ENDFILE 8
CCCCC CLOSE(8)
      TCPLFI='CLOS'
C
CCCCC CLOSE(9)
C
CCCCC TEXTFC=' '
CCCCC TEXTFC(1:4)='CLDE'
CCCCC NBYTES=8+4
CCCCC CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CCCCC CALL REAL_MODE@
C
      RETURN
      END
C
C ----------TCCHEX-----------------------------
C
      SUBROUTINE TCCHEX
C
C     PURPOSE--CHECK FOR EXPOSE AND CONFIGURATION EVENTS.
C              (NOT NEEDED FOR TURBO C)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCREMO-----------------------------
C
      SUBROUTINE TCREMO
C
C     PURPOSE--READ POSITION FROM THE GRAPHICS WINDOW.
C              THE MOUSE POSITION AT THE NEXT MOUSE CLICK
C              WILL BE DETERMINED.
C              THIS ROUTINE WILL WAIT UNTIL A MOUSE BUTTON
C              IS PRESSED.
C              THIS IS USED BY THE DATAPLOT CROSS-HAIR COMMAND.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCERSC-----------------------------
C
      SUBROUTINE TCERSC(ICOLOR)
C
C     PURPOSE--ERASE THE SCREEN (= REGION (X1,Y1)-(X2,Y2).)
C              DEFINE A VIEWPORT THAT WILL BE USED
C              AS THE GRAPHICS AREA.
C              (AND ERASE THE AREA ONLY).
C
C     ROUTINES CALLING TCERSC--GRERSC(38)
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      CHARACTER*4 ICOLOR
C
      COMMFC='ERSC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'ERSC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCERSC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCRIBE-----------------------------
C
      SUBROUTINE TCRIBE
C
C     PURPOSE--RING THE BELL
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='RIBE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'RIBE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCRIBE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCCOSC-----------------------------
C
      SUBROUTINE TCCOSC
C
C     PURPOSE--COPY THE SCREEN
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='COSC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'COSC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCCOSC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCRESC----------------------------
C
      SUBROUTINE TCRESC(PX1,PY1)
C
C     PURPOSE--READ THE SCREEN (VIA CROSS-HAIR OR MOUSE)
CCCCC ***** NOT YET WORKING *****
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='RESC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'RESC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCRESC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCUPSC-----------------------------
C
      SUBROUTINE TCUPSC
C
C     PURPOSE--COPY THE PIXMAP TO THE SCREEN.
C              UPDATE THE GRAPHICS WINDOW WITH
C              A PREVIOUSLY SAVED WINDOW.
C              (NOT USED FOR PC DRIVER)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCFLBU-----------------------------
C
      SUBROUTINE TCFLBU
C
C     PURPOSE--FLUSH THE SCREEN BUFFER.
C              (NEEDED ON PC?)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCSEMO-----------------------------
C
      SUBROUTINE TCSEMO(IMODE)
C
C     PURPOSE--SET THE MODE
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 IMODE
C
      COMMFC='SEMO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IMODE,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEMO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEMO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSECO-----------------------------
C
      SUBROUTINE TCSECO(ICASE,ICOL)
C
C     PURPOSE--SET THE COLOR
C
      INTEGER*4 NBYTES
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 ICASE
      CHARACTER*4 ICOL
C
      IF(TCPLFI.EQ.'CLOS')THEN
CCCCC    OPEN(UNIT=8,FILE='C:\TURBOC\FRONTEND\DPPLOT.TEX')
         TEXTFC(1:4)='PLOT'
         TEXTFC(5:8)='SECO'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CLAHE    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CLAHE    CALL REAL_MODE@
         NPLOTF=0
         TCPLFI='OPEN'
C
         COMMFC='INDE'
         NPLOTF=NPLOTF+1
         PLOTFC(NPLOTF)=' '
         WRITE(PLOTFC(NPLOTF),112)COMMFC,IPLATF,INULC
  112    FORMAT(A4,1X,A10,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSECO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
         IF(NPLOTF.GE.10) CALL TCSEND
C
         COMMFC='OPDE'
         NPLOTF=NPLOTF+1
         PLOTFC(NPLOTF)=' '
         WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111    FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
         IF(NPLOTF.GE.10) CALL TCSEND
C
      ENDIF
C
      COMMFC='SECO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),113)COMMFC,ICASE,ICOL,INULC
  113 FORMAT(A4,1X,A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEPA-----------------------------
C
      SUBROUTINE TCSEPA(ICASE,IPATT)
C
C     PURPOSE--SET THE PATTERN
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 ICASE
      CHARACTER*4 IPATT
C
      COMMFC='SEPA'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),113)COMMFC,ICASE,IPATT,INULC
  113 FORMAT(A4,1X,A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEPA'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEPA.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSETH----------------------------
C
      SUBROUTINE TCSETH(PTHICK)
C
C     PURPOSE--SET LINE THICKNESS.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='SETH'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PTHICK,INULC
  122 FORMAT(A4,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'SETH'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSETH.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEFO----------------------------
C
      SUBROUTINE TCSEFO(FONT)
C
C     PURPOSE--SET TEXT FONT.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 FONT
C
      COMMFC='SEFO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,FONT,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEFO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEFO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSECA----------------------------
C
      SUBROUTINE TCSECA(ICASE)
C
C     PURPOSE--SET TEXT CASE.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 ICASE
C
      COMMFC='SECA'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,ICASE,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SECA'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSECA.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEFI----------------------------
C
      SUBROUTINE TCSEFI(IFILL)
C
C     PURPOSE--SET REGION FILL.???
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      CHARACTER*4 IFILL
C
      COMMFC='SEFI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IFILL,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEFI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEFI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSESI----------------------------
C
      SUBROUTINE TCSESI(PHEIG2,PWIDT2,PVEGA2,PHOGA2)
CCCCC SUBROUTINE TCSESI(PHEIGH,PWIDTH,PVEGAP,PHOGAP)
C     THE ABOVE LINE WAS FIXED                        MARCH 1995
C     TO ALLOW CORRECT SIZING OF TEXT CHARACTERS,     MARCH 1995
C     TITLES, LABEL, LEGENDS, ETC.                    MARCH 1995
C
C     PURPOSE--SET TEXT SIZE.
C     UPDATED         --MARCH    1995. MORE FIX FOR MULTI-PLOT
C                                      LABEL SIZE FOR VGA/TURBOC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='SESI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
C     THE FOLLOWING LINE WAS FIXED                    MARCH 1995
C     TO ALLOW CORRECT SIZING OF TEXT CHARACTERS,     MARCH 1995
C     TITLES, LABEL, LEGENDS, ETC.                    MARCH 1995
CCCCC WRITE(PLOTFC(NPLOTF),123)COMMFC,PHEIGH,PWIDTH,INULC
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PHEIG2,PWIDT2,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'SESI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSESI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEDI----------------------------
C
      SUBROUTINE TCSEDI(IDIR)
C
C     PURPOSE--SET TEXT DIRECTION.
      CHARACTER*4 IDIR
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='SEDI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IDIR,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEDI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEDI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEJU----------------------------
C
      SUBROUTINE TCSEJU(JUST)
C
C     PURPOSE--SET TEXT JUSTIFICATION.
      CHARACTER*4 JUST
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='SEJU'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,JUST,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEJU'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEJU.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCMOTO----------------------------
C
      SUBROUTINE TCMOTO(PX1,PY1)
C
C     PURPOSE--MOVE TO A POINT (INVISIBLY)
C              DO NOT DRAW.   DO NOT ACTIVATE THE PIXEL.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'MOTO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCMOTO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRPO----------------------------
C
      SUBROUTINE TCDRPO(PX1,PY1)
C
C     PURPOSE--DRAW A POINT (ACTIVATE A PIXEL).
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='DRPO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRPO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRPO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRLI----------------------------
C
      SUBROUTINE TCDRLI(PX1,PY1,PX2,PY2)
C
C     PURPOSE--DRAW A (P1-SEGMENT) LINE FROM (PX1,PY1) TO (PX2,PY2).
C
C     ROUTINES CALLING TCDRLI--GRDRLI(37)
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRLI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRLI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRLI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRBO----------------------------
C
      SUBROUTINE TCDRBO(PX1,PY1,PX2,PY2)
C
C     PURPOSE--DRAW A BOX (BUT DO NOTHING ABOUT FILL).
C              THE COLOR OF THE BOX BORDER IS DICTATED BY
C              THE LAST CALL TO TCFIFC (FORE!GROUND COLOR).
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRBO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY1,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRPL----------------------------
C
      SUBROUTINE TCDRPL(PXV,PYV,NV)
C
C     PURPOSE--DRAW A LINE OR POLYLINE.
C              NOTE THAT THE ATTRIBUTES OF THE LINE HAVE ALREADY
C              BEEN SET (BY THE TCSELP, TCSELT, AND TCSEFG ROUTINES).
C
C     ROUTINES CALLING TCDRPL--GRDRPL(37) (ONLY)
C     CALLING SEQUENCE--
C        PLOT TRACE--DPDRPL(13) CALLS GRDRPL(37) CALLS TCDRPL(37)
C        BARS      --D3DRBA(36) CALLS GRDRPL(37) CALLS TCDRPL(37)
C        SPIKES    --D3DRSP(36) CALLS GRDRPL(37) CALLS TCDRPL(37)
C        TIC MARKS --DPDRFR(XX) CALLS
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      DIMENSION PXV(*)
      DIMENSION PYV(*)
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
C
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PXV(1),PYV(1),INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
C
CCCCC IF(ISUBRO.EQ.'DRPL'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)NV,PXV(1),PYV(1)
  811    FORMAT(1H ,'FROM TCDRPL.FOR--NV,PXV(1),PYV(1) = ',I8,2F10.1)
         WRITE(9,812)
  812    FORMAT(1H ,'FROM TCDRPL.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,813)NPLOTF,PLOTFC(NPLOTF)
  813    FORMAT(1H ,2X,I4,2X,A84)
CCCCC ENDIF
C
      IF(NPLOTF.GE.10) CALL TCSEND
C
      IF(NV.LE.1)GOTO1090
      COMMFC='DRTO'
      DO1000I=2,NV
         NPLOTF=NPLOTF+1
         PLOTFC(NPLOTF)=' '
         WRITE(PLOTFC(NPLOTF),123)COMMFC,PXV(I),PYV(I),INULC
CCCCC    IF(ISUBRO.EQ.'DRPL'.OR.ISUBRO.EQ.'DRIV')THEN
            WRITE(9,811)NV,PXV(1),PYV(1)
            WRITE(9,812)
            WRITE(9,813)NPLOTF,PLOTFC(NPLOTF)
CCCCC    ENDIF
         IF(NPLOTF.GE.10) CALL TCSEND
 1000 CONTINUE
 1090 CONTINUE
C
      RETURN
      END
C
C ----------TCFIBO----------------------------
C
      SUBROUTINE TCFIBO(PX1,PY1,PX2,PY2)
C
C     PURPOSE--FILL A BOX (BUT ONLY WITH SOLID FILL).
C              THE COLOR OF THE FILL IS DICTATED BY
C              THE LAST CALL TO ...
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              PROGRAM (I.E., SEND THE INDIVIDUAL LINES TO THE
C              TCDRLI ROUTINE).  ???
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCFIBO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY1,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
      IF(NPLOTF.GE.10) CALL TCSEND
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY2,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCWRTE----------------------------
C
      SUBROUTINE TCWRTE(ISTRI4,NSTRI4)
C
C     PURPOSE--WRITE OUT A HORIZONTAL STRING AT CURRENT POISTION
CCCCC THE FOLLOWING 3 LINES WERE ADDED     SEPTEMBER 1994
C     NOTE--A TYPICAL TURBO-C CALLING SEQUENCE (FOR CHAR X & PLOT):
C           PLOTG2(42) DPDRCH(13) DPCLCH(11) DPDRPM(13) GRDRPM(37)
C                      GRDRPH(37) TCWRTE(TCDRIV)
C
C     ROUTINES CALLING TCWRTE--GRDRPH(37), GRWRTH(39), GRWRTV(39)
C
      CHARACTER*4 ISTRI4
      DIMENSION ISTRI4(*)
C
CCCCC THE FOLLOWING 2 LINES WERE ADDED      SEPTEMBER 1995
      CHARACTER*1 ISTRI1
      DIMENSION ISTRI1(200)
      CHARACTER*1 IC1
      CHARACTER*4 IC4
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
C
      COMMFC='WRTE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
C
CCCCC IF(ISUBRO.EQ.'WRTE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM BEGINNING OF TCWRTE.FOR--')
         WRITE(9,812)NSTRI4
  812    FORMAT(1H ,'NSTRI4 = ',I8)
         WRITE(9,813)ISTRI4(1),ISTRI4(2)
CC813    FORMAT(1H ,'ISTRI4(1),ISTRI4(2) = ',A1,2X,A1)
  813    FORMAT(1H ,'ISTRI4(1),ISTRI4(2) = ',2A4)
CCCCC ENDIF
C
ccccc bombing on the next line   sept 4, 1993
CCCCC WRITE(PLOTFC(NPLOTF),132)COMMFC,(ISTRI4(I),I=1,NSTRI4),INULC
CC132 FORMAT(A4,1X,80A1,A1)
C
CCCCC THE FOLLOWING 9 LINES WERE ADDED      SEPTEMBER 1995
      DO150I=1,NSTRI4
         IC4=ISTRI4(I)
         IC1=IC4(1:1)
         ISTRI1(I)=IC1
  150 CONTINUE
      WRITE(9,814)ISTRI1(1),ISTRI1(2)
  814 FORMAT(1H ,'ISTRI1(1),ISTRI1(2) = ',2A1)
C
      WRITE(PLOTFC(NPLOTF),132)COMMFC,(ISTRI1(I),I=1,NSTRI4),INULC
  132 FORMAT(A4,1X,80A1,A1)
C
      WRITE(9,815)NPLOTF,PLOTFC(NPLOTF)
  815 FORMAT(1H ,I4,2X,A84)
C
      IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCFIRE----------------------------
C
      SUBROUTINE TCFIRE(PXV,PYV,NV)
C
C     PURPOSE--FILL A REGION.
C              RECTANGULAR REGIONS WILL BE FILLED DIFFERENTLY
C              THAN NON-RECTANGULAR REGIONS.  DATAPLOT ONLY
C              HANDLES CONVEX POLYGONS, SO SET THIS (FOR FASTER
C              PERFORMANCE).
C              THIS ROUTINE ONLY DOES SOLID FILL.
C              THE COLOR OF THE FILL IS DICTATED BY
C              THE LAST CALL TO TCFIFC (FORE!GROUND COLOR).
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              PROGRAM (I.E., SEND THE INDIVIDUAL LINES TO THE
C              TCDRLI ROUTINE).
C
C     DATAPLOT CALLING ROUTINES--TCFIRE(38)
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 COMMFC
      DIMENSION PXV(*)
      DIMENSION PYV(*)
C
      COMMFC='FIRE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      DO2100I=1,NV
CCCCC NOT YET DONE
CCCCC IF(ISUBRO.EQ.'FIRE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCFIRE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
 2100 CONTINUE
C
      RETURN
      END
C
C ----------TCSEND----------------------------
C
      SUBROUTINE TCSEND
C
C     PURPOSE--SEND NGRBYT BYTES
C              OF TC'S COMMON--
C                 84 BYTES OF TEXTFC,
C                 4 BYTES OF NTEXTF,
C                 4 BYTES FOR NPLOTF,
C                 (AT MOST) 11*84 BYTES OF PLOTFC
C              TO THE C-SIDE.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C     ORIGINAL VERSION--MAY  18, 1991
C
      INTEGER*4 NBYTES
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
CCCCC IF(ISUBRO.EQ.'SEND'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEND.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
C
CCCCC NBYTES=(8+84)+(84*NPLOTF)
      NBYTES=(12+84+84)+(84*NPLOTF)
CLAHE CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CLAHE CALL REAL_MODE@
      NPLOTF=0
C
      RETURN
      END
C
C ----------TCINCF-----------------------------
C
      SUBROUTINE TCINCF(ISUBRO)
C
C     PURPOSE--INITIALIZE (= MAKE EMPTY) THE FILE ...DPCOMM
C              THAT WILL RECEIVE COMMAND LINES.
C     DATAPLOT CALLING ROUTINE--MAIN
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*4 ISUBRO
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'INCF'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINCF IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
      ENDIF
C
CCCCC THE FOLLOWING LINE WAS FIXED     FEBRUARY 1996
CCCCC OPEN(UNIT=10,FILE='C:\TURBOC\FRONTEND\DPCOMM.TEX')
      OPEN(UNIT=10,FILE='C:\TURBOC\FRONTEND\DPCOMM.TEX',ERR=9010)
 9010 CONTINUE
CLAHE FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
CLAHE FILEXX(NCMPAT+1:NCMPAT+11)='DPCOMM.TEX'
CLAHE OPEN(UNIT=10,FILE=FILEXX)
CMS-F ENDFILE 10
      CLOSE(10)
C
      IF(ISUBRO.EQ.'INCF'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9021)
 9021    FORMAT(1H ,'***** AT THE END       OF TCINCF IN TCDRIV--')
         WRITE(9,9022)ISUBRO
 9022    FORMAT(1H ,'ISUBRO = ',A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCWRCO-----------------------------
C
      SUBROUTINE TCWRCO(STRING,ISUBRO)
C
C     PURPOSE--WRITE THE LAST ENTERED COMMAND LINE
C              (CONSISTING OF 80 CHARACTERS IN STRING())
C              TO THE    END
C              OF FILE C:\TURBOC\FRONTEND\DPCOMM.TEX
C
C     TCWRCO DOES THE FOLLOWING--
C        1) OPEN THE FILE
C        2) GO TO THE END OF THE FILEXX
C        3) BACK UP 1 RECORD
C        4) APPEND THE SINGLE COMMAND LINE TO THE FILE
C
C     DATAPLOT CALLING ROUTINE--DPGETC
C
CCCCC UPDATED         --FEBRUARY 1995. SPEED UP APPEND
C     UPDATED         --FEBRUARY  1996. SOFT-CODE THE MENU PATH
C                                       TO ALLOW DRIVE D: TO BE USED
C
CCCCC THE FOLLOWING LINE WAS ADDED   FEBRUARY 1996
      INCLUDE 'DPCOF2.INC'
C
      CHARACTER*80 STRING
      CHARACTER*4 ISUBRO
      CHARACTER*1 ICJUNK
CCCCC THE FOLLOWING LINE WAS ADDED     FEBRUARY 1996
      CHARACTER*80 FILEXX
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'WRCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCWRCO IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
         WRITE(9,54)STRING(1:80)
   54    FORMAT(1H ,'STRING(1:80) = ',A80)
      ENDIF
C
C      STEP 1--OPEN & GO TO THE END OF THE DPCOMM.TEX FILE
C
CCCCC THE FOLLOWING 7 LINES WERE COMMENTED OUT        FEBRUARY 1995
CCCCC AND REPLACED BY A NON-STANDARD OPEN STATEMENT   FEBRUARY 1995
CCCCC SO AS TO ATTEMPT TO SPEED UP THE OPEN & APPEND  FEBRUARY 1995
C
CCCCC OPEN(UNIT=10,FILE='C:\TURBOC\FRONTEND\DPCOMM.TEX')
CCCCC DO1100I=1,1000000
CCCCC    READ(10,1105,END=1180)ICJUNK
C1105    FORMAT(A1)
C1100 CONTINUE
C1180 CONTINUE
CCCCC BACKSPACE 10
C
CCCCC THE FOLLOWING 2 LINES WERE FIXED     FEBRUARY 1996
CCCCC OPEN(UNIT=10,STATUS='APPEND',
      OPEN(UNIT=10,
CCCCC1      FILE='C:\TURBOC\FRONTEND\DPCOMM.TEX')
     1      FILE='C:\TURBOC\FRONTEND\DPCOMM.TEX',ERR=9020)
 9020 CONTINUE
CLAHE FILEXX(1:NCMPAT)=MPATH(1:NCMPAT)
CLAHE FILEXX(NCMPAT+1:NCMPAT+11)='DPCOMM.TEX'
CLAHE OPEN(UNIT=10,STATUS='APPEND',
CLAHE1      FILE=FILEXX)
C
C     STEP 2--WRITE OUT THE COMMAND LINE TO DPCOMM.TEX
C
      WRITE(10,1181)STRING(1:80)
 1181 FORMAT(A80)
C
C     STEP 3--CLOSE THE FILE DPCOMM.TEX
C
CMS-F ENDFILE 10
      CLOSE(10)
C
      IF(ISUBRO.EQ.'WRCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9021)
 9021    FORMAT(1H ,'***** AT THE END       OF TCWRCO IN TCDRIV--')
         WRITE(9,9022)ISUBRO
 9022    FORMAT(1H ,'ISUBRO = ',A4)
         WRITE(9,9024)STRING(1:80)
 9024    FORMAT(1H ,'STRING(1:80) = ',A80)
      ENDIF
C
      RETURN
      END

      SUBROUTINE ASPECT(AJUNK)
C
C  DUMMY ROUTINE FOR ZETA EXTENSION TO CALCOMP LIBRARY.
C  IF YOU HAVE ZETA, LOAD WITH ZETA LIBRARY, OTHERWISE THIS
C  ROUTINE SERVES AS NULL ROUTINE.
C
      RETURN
      END
      SUBROUTINE DASHDF(I1,I2,I3,I4)
C
C  DUMMY ROUTINE FOR ZETA EXTENSION TO CALCOMP LIBRARY.
C  REPLACE WITH ZETA LIBRARY IF HAVE ZETA PLOTTER.
C
      RETURN
      END
       SUBROUTINE DASHS(ARRAY,IJUNK)
C
C  DUMMY ROUTINE FOR CALCOMP LIBRARY ROUTINE DASHS.
C  REPLACE WITH CLACOMP LIBRARY ROUTINE IF AVAILABLE.
C
       DIMENSION ARRAY(*)
       RETURN
       END
      SUBROUTINE NEWPEN(IPENNO)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      PRINT *, 'CALCOMP LIBRARY ROUTINE "NEWPEN" NOT SUPPORTED'
      RETURN
      END
      SUBROUTINE PLOT(X,Y,IPEN)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      PRINT *,'CALCOMP LIBRARY ROUTINE "PLOT" NOT SUPPORTED'
      RETURN
      END
      SUBROUTINE PLOTS(I1,I2,I3)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      PRINT *,'CALCOMP LIBRARY ROUTINE "PLOTS" NOT SUPPORTED'
      RETURN
      END
      SUBROUTINE SYMBOL(XPOS,YPOS,HEIGHT,ITEXT,ANGLE,NUMCHR)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
CCCC  CHARACTER*(*) ITEXT
      DIMENSION ITEXT(*)
C
      PRINT *,'CALCOMP LIBRARY ROUTINE "SYMBOL" NOT SUPPORTED'
      RETURN
      END
      SUBROUTINE GRINFO(ILAHEY,RLAHEY,CLAHEY)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      INTEGER ILAHEY(*)
      REAL RLAHEY(*)
      CHARACTER*(*) CLAHEY
      RETURN
      END
      SUBROUTINE GTEXT(ILINE,ICOL,ISYMBL)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      CHARACTER*(*) ISYMBL
      RETURN
      END
      SUBROUTINE FILL(NP,PX,PY)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      REAL PX(*), PY(*)
      RETURN
      END 
      SUBROUTINE SETPIX(AX,AY,IPEN)
C
C     PROVIDE DUMMY ROUTINES FOR THE CALCOMP LIBRARY
C     ROUTINES FOR SITES THAT DO NOT HAVE IT.
C
      REAL AX, AY
      INTEGER IPEN
      RETURN
      END

      SUBROUTINE DPRCSN(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN COMPLEX SCRIPT NUMERIC.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRCSN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHNU(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.9)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRCSN1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(ICHARN.GE.10)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRCSN2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRCSN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRCSU(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN COMPLEX SCRIPT UPPER CASE.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRCSU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHAL(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.6)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRCSU1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(7.LE.ICHARN.AND.ICHARN.LE.13)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRCSU2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IF(14.LE.ICHARN.AND.ICHARN.LE.20)GOTO1030
      GOTO1039
 1030 CONTINUE
      CALL DRCSU3(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1039 CONTINUE
C
      IF(ICHARN.GE.21)GOTO1040
      GOTO1049
 1040 CONTINUE
      CALL DRCSU4(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1049 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRCSU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRCU(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN COMPLEX UPPER CASE.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRCU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHAL(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.14)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRCU1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(ICHARN.GE.15)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRCU2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRCU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRDL(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN DUPLEX LOWER CASE.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRDL--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHAL(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.11)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRDL1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(12.LE.ICHARN.AND.ICHARN.LE.24)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRDL2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IF(ICHARN.GE.25)GOTO1030
      GOTO1039
 1030 CONTINUE
      CALL DRDL3(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1039 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRDL--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRDN(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN DUPLEX NUMERIC.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRDN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHNU(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.8)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRDN1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(ICHARN.GE.9)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRDN2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRDN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRDS(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN DUPLEX SYMBOLS.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MARCH     1982.
C     UPDATED         --MARCH     1987.
C     UPDATED         --MAY       1982.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHSY(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.9)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRDS1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(ICHARN.GE.10)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRDS2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRDS--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPRDU(ICHAR2,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE AND SET THE HERSHEY CHARACTER SET COORDINATES
C              FOR ROMAN DUPLEX UPPER CASE.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--87/4
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MARCH     1981.
C     UPDATED         --MAY       1982.
C     UPDATED         --MARCH     1987.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 ICHAR2
      CHARACTER*4 IOP
      CHARACTER*4 IBUGD2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IOP(*)
      DIMENSION X(*)
      DIMENSION Y(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      NUMCO=1
      ISTART=1
      ISTOP=1
      NC=1
C
C               ******************************************
C               **  TREAT THE ROMAN SIMPLEX UPPER CASE  **
C               **  HERSHEY CHARACTER SET CASE          **
C               ******************************************
C
C
      IF(IBUGD2.EQ.'OFF')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF DPRDU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ICHAR2
   52 FORMAT('ICHAR2 = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGD2,IFOUND,IERROR
   59 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               **************************************************
C               **  STEP 1--                                    **
C               **  SEARCH FOR THE INPUT CHARACTER(S).          **
C               **  MAP THE CHARACTER(S) INTO A NUMERIC VALUE.  **
C               **************************************************
C
      CALL DPCHAL(ICHAR2,ICHARN,IBUGD2,IFOUND)
      IF(IFOUND.EQ.'NO')GOTO9000
C
      IF(ICHARN.LE.14)GOTO1010
      GOTO1019
 1010 CONTINUE
      CALL DRDU1(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1019 CONTINUE
C
      IF(ICHARN.GE.15)GOTO1020
      GOTO1029
 1020 CONTINUE
      CALL DRDU2(ICHARN,IOP,X,Y,NUMCO,IXMINS,IXMAXS,IXDELS,
     1IBUGD2,IFOUND,IERROR)
      GOTO9000
 1029 CONTINUE
C
      IFOUND='NO'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGD2.EQ.'OFF')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF DPRDU--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGD2,IFOUND,IERROR
 9012 FORMAT('IBUGD2,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)ICHAR2,ICHARN
 9013 FORMAT('ICHAR2,ICHARN = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ISTART,ISTOP,NC,NUMCO
 9014 FORMAT('ISTART,ISTOP,NC,NUMCO = ',4I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMCO.GE.1.AND.NUMCO.LE.1000)GOTO9019
      DO9015I=1,NUMCO
      WRITE(ICOUT,9016)I,IOP(I),X(I),Y(I)
 9016 FORMAT('I,IOP(I),X(I),Y(I) = ',I8,2X,A4,2F10.2)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9019 CONTINUE
      WRITE(ICOUT,9021)IXMINS,IXMAXS,IXDELS
 9021 FORMAT('IXMINS,IXMAXS,IXDELS = ',3I8)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPREAD(IFROW1,IFROW2,IFCOL1,IFCOL2,ISKIP,INTINF,
CCCCC MARCH 1996.  ADD IMALEV TO ARGUMENT LIST
     1IMACRO,IMACNU,IMACCS,IMALEV,IOSW,ICREAF,NCREAF,
     1IREARW,
     1ICOMCH,ICOMSW,
CCCCC APRIL 1995.  ADD FOLLOWING LINE
     1IUNFOF,IUNFNR,IUNFMC,
CCCCC FEBRUARY 2003.  ADD FOLLOWING LINE
     1NUMRCM,
     1IFCOLL,IFCOLU,
     1IBUGS2,IBUGQ,ISUBRO,IFOUND,IERROR)
CCCCC ICOMCH, ICOMSW ARGUMENTS ADDED MAY 1990.
C
C     PURPOSE--READ IN THE VALUES OF A VARIABLE.
C              THE DATA IS LISTED ACROSS
C              A LINE IMAGE.
C              (E.G., X(1) Y(1) Z(1) ETC.)
C              THE DATA IS READ FORM A MASS STORAGE FILE
C              OR (IF NO FILE GIVEN) FROM THE DEFAULT INPUT UNIT
C              (WHICH WILL BE THE TERMINAL).
C     ASSUMPTION--THE INPUT  FILE ALREADY EXISTS;
C                 (THAT IS, DATAPLOT WILL AUTOMATICALLY
C                 OPEN THE FILE
C                 VIA (ON THE UNIVAC 1108), BY AN @ASG,AX ...)
C                 BUT WILL NOT AUTOMATICALLY CREATE THE FILE
C                 VIA (ON THE UNIVAC 1108), BY AN @ASG,UP ...))
C     ASSUMPTION--THE COMPUTER SYSTEM IS SUCH THAT
C                 EQUATING THE FILE NAME TO
C                 THE FORTRAN NUMERIC DESIGNATION
C                 OF 31 (OR HOWEVER THE VARIABLE    IREANU    IS DEFINED
C                 IN INITFO) IS PERMISSIBLE.
C     NOTE--INPUT FOR THE READ COMMAND MAY POTENTIALLY
C           COME FROM 2 DIFFERENT SOURCES--
C                1) THE TERMINAL ITSELF;
C                2) A FILE;
C           DIFFERENT SYSTEMS ALLOW DIFFERENT COMBINATIONS
C           OF THE ABOVE.
C           ALL SYSTEMS WILL ALLOW INPUT FROM THER TERMINAL ITSELF;
C           MOST SYSTEMS WILL ALLOW INPUT FROM A FILE;
C     NOTE--ICOMCH = THE ALLOWABLE COMMENT CHARACTER
C           ICOMSW = THE COMMENT CHARACTER FLAG/SWITCH (ON/OFF)
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--82/7
C     ORIGINAL VERSION--DECEMBER  1977.
C     UPDATED         --JANUARY   1978.
C     UPDATED         --FEBRUARY  1978.
C     UPDATED         --MAY       1978.
C     UPDATED         --JULY      1978.
C     UPDATED         --NOVEMBER  1978.
C     UPDATED         --NOVEMBER  1980.
C     UPDATED         --JANUARY   1981.
C     UPDATED         --JUNE      1981.
C     UPDATED         --NOVEMBER  1981.
C     UPDATED         --JANUARY   1982.
C     UPDATED         --MARCH     1982.
C     UPDATED         --MAY       1982.
C     UPDATED         --DECEMBER  1985.
C     UPDATED         --SEPTEMBER 1987.    (READ MATRIX)
C     UPDATED         --FEBRUARY  1988.    (DEACT. COL. LIM. IF READ NON-FILE)
C     UPDATED         --JUNE      1988.    (CORRECT DOUBLE ENTRY BY READ FUNCT
C     UPDATED         --DECEMBER  1988.    CORRECT BOMB ON 2ND   READ PARAMETER
C     UPDATED         --MAY       1989.    FIX IRIS PROBLEM--LOOP MAX & CPUMAX
C     UPDATED         --MAY       1990.    CHECK FOR COMMENT CHARACTER (UNIX)
C     UPDATED         --MAY       1990.    ERROR CHECK FOR FORMATTED READ
C     UPDATED         --JUNE      1990.    FIX FORMATTED READ/1 LINE BUG
C     UPDATED         --JULY      1990.    UPDATED WRITE/FORMAT STATEMENT
C     UPDATED         --JULY      1990.    BUG/TRACE PRINT OF ICOMCH/FL
C     UPDATED         --JULY      1990.    COMMENT CHECK BUG FIXED
C     UPDATED         --JULY      1990.    RENAME ICOMFL TO ICOMSW
C     UPDATED         --JULY      1993.    FIX MATRIX READ (ALAN)
C     UPDATED         --JULY      1993.    FIX BOMB IF GOOD READ AFTER
C                                          READ NON-EXISTENT FILE
C     UPDATED         --MARCH     1994.    FIX BUG WHERE DELETE AND 
C                                          RETAIN WIPED OUT PARAMETERS
C                                          CREATED VIA READ PARAMETER
C     UPDATED         --APRIL     1995.  SUPPORT FOR UNFORMATTED READ
C     UPDATED         --SEPTEMBER 1995.  ROW LIMITS & BLANK LINES PROBLEM
C     UPDATED         --MARCH     1996.  FIX BUG WHERE TERMINAL READ
C                                        NESTED WITHIN A MACRO
C     UPDATED         --APRIL     1996.  FOR READ STRING, IGNORE SET
C                                        READ FORMAT
C     UPDATED         --OCTOBER   1997.  SUPPORT "SKIP AUTOMATIC",
C                                        READ UNTIL FIND "----"
C     UPDATED         --NOVEMBER  1998.  READ MORE THAN 100 VARIABLES
C                                        (MAKE PARAMETER SETTABLE)
C     UPDATED         --DECEMBER  1999.  READ ROWID
C     UPDATED         --MARCH     2001.  FIX BUGS:
C                                        A) UPDATE LIMIT ON MAX COLUMNS
C                                        B) OFFSET FOR UNFORMATTED READ
C                                        C) MAX FOR ROW LIMITS
C     UPDATED         --JULY      2002.  SUPPORT FOR QUOTES ON
C                                        FILE NAMES.
C     UPDATED         --FEBRUARY  2003.  UP MAXIMUM NUMBER OF
C                                        CHARACTERS READ FROM ONE
C                                        RECORD OF DATA FILE (MAKE
C                                        SETTABLE TO PARAMETER)
C     UPDATED         --FEBRUARY  2003.  AUTOMATICALLY DETERMINE
C                                        NUMBER OF VARIABLES IF NO
C                                        LIST GIVEN.
C     UPDATED         --JUNE      2003.  HANDLE HYPHENS INSIDE OF QUOTED
C                                        FILE NAMES CORRECTLY.
C     UPDATED         --JULY      2003.  BUG WHEN FILE NAME < 80
C                                        CHARACTERS, BUT COMMAND LINE
C                                        > 80 CHARACTERS 
C     UPDATED         --AUGUST    2003.  QUOTES ON FILE NAMES
C                                        AUTOMATIC FOR READ
C     UPDATED         --JANUARY   2004.  IF AUTOMATICALLY DETERMINE
C                                        VARIABLE LIST, CHECK FIRST
C                                        LINE FOR VARIABLE LIST
C     UPDATED         --JANUARY   2004.  SOME RECODING FOR BETTER
C                                        CLARITY
C     UPDATED         --JANUARY   2004.  HANDLE CHARACTER DATA
C     UPDATED         --OCTOBER   2004.  WHEN READING VARIABLES, IF
C                                        NUMBER OF ITEMS IS GREATER
C                                        THAN NUMBER OF ITEMS READ,
C                                        PAD WITH "MISSING VALUE"
C                                        (BASED ON VALUE OF IREAPD)
C     UPDATED         --OCTOBER   2004.  SET READ SUBSET
C                                        <PACK/DISPERSE>  <PACK/DISPERSE>
C     UPDATED         --DECEMBER  2004.  IF GUI RUNNING (SET GUI), THEN
C                                        DO NOT ALLOW TERMINAL READ
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IMACRO
      CHARACTER*12 IMACCS
C
      CHARACTER*4 IOSW
C
      CHARACTER*80 ICREAF
C
      CHARACTER*4 IREARW
C
      CHARACTER*4 IGRPA2
      CHARACTER*4 ICFLAG
C
      CHARACTER*4 IBUGS2
      CHARACTER*4 IBUGQ
      CHARACTER*4 ISUBRO
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
      CHARACTER*4 ICASEQ
      CHARACTER*4 ICASEA
      CHARACTER*4 IECASE
      CHARACTER*4 ISTOR1
      CHARACTER*4 ISTOR2
      CHARACTER*4 ISTOR3
      CHARACTER*4 IB
      CHARACTER*4 IEND
      CHARACTER*4 JVNAM1
      CHARACTER*4 JPNAM1
      CHARACTER*4 JMNAM1
      CHARACTER*4 JFNAM1
      CHARACTER*4 JUNAM1
      CHARACTER*4 JENAM1
      CHARACTER*4 JVNAM2
      CHARACTER*4 JPNAM2
      CHARACTER*4 JMNAM2
      CHARACTER*4 JFNAM2
      CHARACTER*4 JUNAM2
      CHARACTER*4 JENAM2
      CHARACTER*4 IH1
      CHARACTER*4 IH2
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
      CHARACTER*4 ICASRE
      CHARACTER*4 IOFILE
      CHARACTER*4 IOTERM
C
      CHARACTER*4 IFILQ2
C
      CHARACTER*80 IFILE
      CHARACTER*12 ISTAT
      CHARACTER*12 IFORM
      CHARACTER*12 IACCES
      CHARACTER*12 IPROT
      CHARACTER*12 ICURST
      CHARACTER*4 IENDFI
      CHARACTER*4 IREWIN
      CHARACTER*4 ISUBN0
      CHARACTER*4 IERRFI
C
      CHARACTER*80 IFILE2
      CHARACTER*12 ISTAT2
      CHARACTER*12 IFORM2
      CHARACTER*12 IACCE2
      CHARACTER*12 IPROT2
      CHARACTER*12 ICURS2
      CHARACTER*4 IENDF2
      CHARACTER*4 IREWI2
C
CCCCC CHARACTER*80 ICANS
      CHARACTER*200 ICANS
CCCCC CHARACTER*80 ISTRIN
C
      CHARACTER*4 IHLEFT
      CHARACTER*4 IHLEF2
      CHARACTER*4 NEWNAM
C
      CHARACTER*4 ICASTO
C
      CHARACTER*4 IHMAT1
      CHARACTER*4 IHMAT2
C  FOLLOWING 3 LINES MAY 1990.
      CHARACTER*80 IAJUNK
      CHARACTER*4 ICOMCH
      CHARACTER*4 ICOMSW
C
CCCCC THE FOLLOWING LINE WAS ADDED    SEPTEMBER 1995
      CHARACTER*4 LINETY
C
CCCCC NOVEMBER 1998.  DEFINE MAXRDV TO DEFINE MAXIMUM NUMBER OF
CCCCC VARIABLES.
C
CCCCC MARCH 2001.  UP LIMIT (MATRICES IN PARTICULAR CAN HAVBE MORE)
CCCCC PARAMETER(MAXRDV=250)
      PARAMETER(MAXRDV=1000)
      PARAMETER(MAXCHV=20)
C
CCCCC THE FOLLOWING LINES ADDED    FEBRUARY  2003.
      CHARACTER*4 IVRLST
      CHARACTER*4 IVLIST(MAXRDV)
      CHARACTER*4 IVLIS2(MAXRDV)
      CHARACTER*4 IASAVE(MAXRDV)
C
      INTEGER IFCOLL(50)
      INTEGER IFCOLU(50)
      INTEGER ITYPE(MAXRDV)
      CHARACTER*4 ICLIST(MAXRDV)
      CHARACTER*4 ICLIS2(MAXRDV)
C
      DIMENSION JVNAM1(MAXRDV)
      DIMENSION JPNAM1(MAXRDV)
      DIMENSION JMNAM1(MAXRDV)
      DIMENSION JFNAM1(MAXRDV)
      DIMENSION JUNAM1(MAXRDV)
      DIMENSION JENAM1(MAXRDV)
C
      DIMENSION NIV(MAXRDV)
C
      DIMENSION JVNAM2(MAXRDV)
      DIMENSION JPNAM2(MAXRDV)
      DIMENSION JMNAM2(MAXRDV)
      DIMENSION JFNAM2(MAXRDV)
      DIMENSION JUNAM2(MAXRDV)
      DIMENSION JENAM2(MAXRDV)
C
      DIMENSION IEN(MAXRDV)
      DIMENSION IECOL2(MAXRDV)
      DIMENSION IECASE(MAXRDV)
      DIMENSION PVAL(MAXRDV)
      DIMENSION IFSTA2(MAXRDV)
      DIMENSION IFSTO2(MAXRDV)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCOHK.INC'
      INCLUDE 'DPCODA.INC'
      INCLUDE 'DPCOFO.INC'
      INCLUDE 'DPCOF2.INC'
      INCLUDE 'DPCOHO.INC'
      INCLUDE 'DPCOST.INC'
CCCCC MARCH 2001.  ADD FOLLOWING LINE
      INCLUDE 'DPCOMC.INC'
CCCCC APRIL 1995.  ADD FOLLOWING 4 LINES
      INCLUDE 'DPCOZ2.INC'
      DIMENSION XSCRT(3*MAXOBW)
C
      DIMENSION X0(MAXRCL)
      CHARACTER*24 IXC(MAXCHV)
C
      DIMENSION ISTOR1(MAXRCL)
      DIMENSION ISTOR2(MAXRCL)
      DIMENSION ISTOR3(MAXRCL)
      DIMENSION IB(MAXRCL)
C
      EQUIVALENCE (G2RBAG(1),XSCRT(1))
      CHARACTER*4 IFMFLG
      CHARACTER*4 ICRFLG
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      ISUBN1='DPRE'
      ISUBN2='AD  '
C
      MAXCP1=MAXCOL+1
      MAXCP2=MAXCOL+2
      MAXCP3=MAXCOL+3
      MAXCP4=MAXCOL+4
      MAXCP5=MAXCOL+5
      MAXCP6=MAXCOL+6
C
      IFOUND='YES'
      IERROR='NO'
C
      ICASRE='-999'
      IOFILE='-999'
      IOTERM='-999'
C
      IFILQ2=IFILQU
      IFILQU='ON'
C
CCCCC FEBRUARY 2003: ADD FOLLOWING LINE.
CCCCC IF NO VARIABLE LIST GIVEN, THEN TWO CASES:
CCCCC    1) IF SKIP AUTOMATIC ON, THEN READ PREVIOUS LINE TO
CCCCC       DETERMINE VARIABLE LIST. 
CCCCC    2) IF SKIP AUTOMATIC OFF, THEN READ FIRST LINE TO
CCCCC       DETERMINE NUMBER OF VARIABLES.  NAME THEM X1, X2, ETC.
C
      IVRLST='YES'
      DO10I=1,132
        IASAVE(I)='    '
   10 CONTINUE
      DO15I=1,MAXRDV
        IVLIST(I)='    '
        IVLIS2(I)='    '
        ITYPE(I)=0
   15 CONTINUE
      DO13I=1,MAXCHV
        IXC(I)=' '
        ICLIST(I)=' '
        ICLIS2(I)=' '
   13 CONTINUE
      IGRPA2=IGRPAU
C
CCCCC THE FOLLOWING LINE WAS INSERTED MAY 1989
CCCCC MARCH 2001.  SET VALUE TO MAX INTEGER
CCCCC IBILLI=10**9
      IBILLI=I1MACH(9)
      I2=0
      NUMVRD=0
      NUMPRD=0
      NUMFRD=0
C
      AFROW2=IFROW2
C
      MAXN2=MAXCHF
C
      IMATC1=(-999)
      IMATNR=(-999)
      IMATNC=(-999)
CCCCC THE FOLLOWING LINE WAS ADDED    SEPTEMBER 1995
      LINETY='-999'
      NCALL=0
      NCOLS=0
C
C               ***************************
C               **  TREAT THE READ CASE  **
C               ***************************
C
CCCCC NOVEMBER 1998.  DEFINE MAXRDV TO DEFINE MAXIMUM NUMBER OF
CCCCC VARIABLES.
C
      MAXV2=MAXRDV
      MAXP2=MAXRDV
      MAXM2=MAXRDV
      MAXF2=MAXRDV
      MAXU2=MAXRDV
      MAXE2=MAXRDV
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,999)
  999   FORMAT(1X)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,51)
   51   FORMAT('***** AT THE BEGINNING OF DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,52)IFROW1,AFROW2
   52   FORMAT('IFROW1,AFROW2 = ',I8,2X,E15.7)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,53)IFCOL1,IFCOL2,NUMRCM
   53   FORMAT('IFCOL1,IFCOL2,NUMRCM = ',3I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,54)ISKIP,IBUGS2,IBUGQ
   54   FORMAT('ISKIP,IBUGS2,IBUGQ = ',I8,2X,A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,55)IOSW
   55   FORMAT('IOSW = ',A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,56)IMACRO,IMACNU,IMACCS
   56   FORMAT('IMACRO,IMACNU,IMACCS = ',A4,I8,2X,A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,58)IRD,IRD2
   58   FORMAT('IRD,IRD2 = ',2I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,63)IBUGS2,ISUBRO,IERROR
   63   FORMAT('IBUGS2,ISUBRO,IERROR = ',A4,2X,A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,64)IWIDTH
   64   FORMAT('IWIDTH = ',I8)
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,65)(IANSLC(I),I=1,MIN(100,IWIDTH))
   65     FORMAT('(IANSLC(I),I=1,IWIDTH) = ',100A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        WRITE(ICOUT,71)IREANU
   71   FORMAT('IREANU = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,72)IREANA
   72   FORMAT('IREANA = ',A80)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,73)IREAST
   73   FORMAT('IREAST = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,74)IREAFO
   74   FORMAT('IREAFO = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,75)IREAAC
   75   FORMAT('IREAAC = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,76)IREAFO
   76   FORMAT('IREAFO = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,77)IREACS
   77   FORMAT('IREACS = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,81)NUMNAM
   81   FORMAT('NUMNAM = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,82)N2,MAXN2
   82   FORMAT('N2,MAXN2 = ',2I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,84)NCREAF
   84   FORMAT('NCREAF = ',I8)
        CALL DPWRST('XXX','BUG ')
        IF(NCREAF.GE.1)THEN
          WRITE(ICOUT,85)(ICREAF(I:I),I=1,NCREAF)
   85     FORMAT('(ICREAF(I:I),I=1,NCREAF) = ',80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        WRITE(ICOUT,86)IREARW
   86   FORMAT('IREARW = ',A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,87)ICOMCH,ICOMSW
   87   FORMAT('ICOMCH,ICOMSW = ',A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
C               *******************************************************
C               **  STEP 1--                                         **
C               **  CHECK FOR THE PROPER NUMBER OF INPUT ARGUMENTS.  **
C               *******************************************************
C
      ISTEPN='1'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(NUMARG.LT.1)THEN
        IERROR='YES'
        GOTO8800
      ENDIF
C
C               *****************************************
C               **  STEP 1B--                          **
C               **  DETERMINE THE TYPE OF READ CASE--  **
C               **     1) VARIABLE                     **
C               **     2) PARAMETER                    **
C               **     3) FUNCTION (= STRING)          **
C               **     4) MATRIX                       **
C               *****************************************
C
      ICASRE='VARI'
      IF(IHARG(1).EQ.'PARA'.AND.IHARG2(1).EQ.'METE')ICASRE='PARA'
      IF(IHARG(1).EQ.'FUNC'.AND.IHARG2(1).EQ.'TION')ICASRE='FUNC'
      IF(IHARG(1).EQ.'STRI'.AND.IHARG2(1).EQ.'NG')ICASRE='FUNC'
      IF(IHARG(1).EQ.'MATR'.AND.IHARG2(1).EQ.'IX')ICASRE='MATR'
      IF(IHARG(1).EQ.'ROW '.AND.IHARG2(1).EQ.' '.AND.
     1   IHARG(2).EQ.'LABE'.AND.IHARG2(2).EQ.'LS')ICASRE='ROWI'
      IF(IHARG(1).EQ.'ROW '.AND.IHARG2(1).EQ.' '.AND.
     1   IHARG(2).EQ.'LABE'.AND.IHARG2(2).EQ.'L ')ICASRE='ROWI'
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,155)ICASRE
  155   FORMAT('ICASRE = ',A4)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
C               ******************************************************
C               **  STEP 2A--                                       **
C               **  DETERMINE THE TYPE OF READ CASE--               **
C               **       1) FROM TERMINAL;                          **
C               **       2) FROM FILE;                              **
C               **  NOTE--IOTERM  WILL = 'YES' ONLY IN EXPLICIT     **
C               **        TERMINAL CASE                             **
C               **        (THAT IS, ONLY WHEN INPUT IOSW            **
C               **                             = 'TERM')            **
C               **  NOTE--IOFILE  WILL = 'YES' ONLY IN FILE CASE.   **
C               ******************************************************
C
      ISTEPN='2A'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
  200 CONTINUE
      IWORD=2
      IF(ICASRE.EQ.'PARA')IWORD=3
      IF(ICASRE.EQ.'FUNC')IWORD=3
      IF(ICASRE.EQ.'MATR')IWORD=3
      IF(ICASRE.EQ.'ROWI')THEN
        IWORD=4
        IF(NUMARG.LE.2)THEN
          IOFILE='NO'
          GOTO202
        ENDIF
      ENDIF
      CALL DPFILE(IANSLC,IWIDTH,IWORD,
     1IOFILE,IBUGS2,ISUBRO,IERROR)
      IF(IERROR.EQ.'YES')GOTO9000
  202 CONTINUE
C
      IOTERM='NO'
      IF(IOFILE.EQ.'NO'.AND.IOSW.EQ.'TERM')IOTERM='YES'
C
CCCCC DECEMBER 2004.  IF GUI RUNNING, DO NOT ALLOW TERMINAL READ.
C
      IF(IOFILE.EQ.'NO' .AND. IGUIFL.EQ.'ON')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,211)
  211   FORMAT('***** ERROR FROM READ--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,213)
  213   FORMAT('      TERMINAL READS (I.E., READ WITH NO FILE NAME ',
     1         'SPECIFIED)')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,215)
  215   FORMAT('      ARE NOT PERMITTED WHEN RUNNING DATAPLOT FROM ',
     1         'THE GRAPHICAL USER INTERFACE)')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,217)
  217   FORMAT('      ALTERNATIVELY, YOU CAN DO ONE OF THE FOLLOWING:')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,219)
  219   FORMAT('      1) YOU CAN ENTER THE DATA DIRECTLY FROM THE ',
     1         'DATASHEET.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,221)
  221   FORMAT('      2) FROM THE COMMAND LINE WINDOW, YOU CAN USE ',
     1         'THE DATA COMMAND AS FOLLOWS')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,223)
  223   FORMAT('         LET Y = DATA value1 value2 ...')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,225)
  225   FORMAT('      3) THE FIRST TWO METHODS ARE USEFUL FOR SMALL ',
     1         'AMOUNTS OF DATA.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,227)
  227   FORMAT('         FOR MORE THAN A FEW DATA POINTS, IT IS ',
     1         'RECOMMENDED THAT YOU')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,229)
  229   FORMAT('         CREATE THE DATA IN AN ASCII FILE AND THEN')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,231)
  231   FORMAT('         READ THE DATA FROM THAT FILE.')
        CALL DPWRST('XXX','BUG ')
        IERROR='YES'
        GOTO9000
      ENDIF
C
C               *************************************
C               **  STEP 2B--                      **
C               **  IF HAVE THE FILE INPUT CASE--  **
C               **  COPY OVER VARIABLES            **
C               *************************************
C
      ISTEPN='2B'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IOFILE.EQ.'YES')THEN
C
        IOUNIT=IREANU
        IFILE=IREANA
        ISTAT=IREAST
        IFORM=IREAFO
        IACCES=IREAAC
        IPROT=IREAPR
        ICURST=IREACS
C
        ISUBN0='READ'
        IERRFI='NO'
C
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
          WRITE(ICOUT,1183)IOUNIT
 1183     FORMAT('IOUNIT = ',I8)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1184)IFILE
 1184     FORMAT('IFILE = ',A80)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1185)ISTAT,IFORM,IACCES,IPROT,ICURST
 1185     FORMAT('ISTAT,IFORM,IACCES,IPROT,ICURST = ',
     1           A12,2X,A12,2X,A12,2X,A12,2X,A12)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1186)ISUBN0,IERRFI
 1186     FORMAT('ISUBN0,IERRFI = ',A4,2X,A4)
          CALL DPWRST('XXX','BUG ')
        ENDIF
C
      ENDIF
C
C               ***********************************************
C               **  STEP 2C--                                **
C               **  IF HAVE THE FILE INPUT CASE--            **
C               **  CHECK TO SEE IF THE READ FILE MAY EXIST  **
C               ***********************************************
C
      ISTEPN='2C'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IOFILE.EQ.'YES')THEN
C
        IF(ISTAT.EQ.'NONE')THEN
          IERROR='YES'
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1211)
 1211     FORMAT('***** IMPLEMENTATION ERROR IN DPREAD--')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1212)
 1212     FORMAT('      THE DESIRED READING CANNOT BE CARRIED OUT')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1214)
 1214     FORMAT('      BECAUSE THE INTERNAL VARIABLE   IREAST   WHICH')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1215)
 1215     FORMAT('      ALLOWS SUCH READING HAS BEEN SET TO    NONE')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1217)ISTAT,IREAST
 1217     FORMAT('ISTAT,IREAST = ',A12,2X,A12)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1218)
 1218     FORMAT('      ALL READING MUST BE DONE')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1219)
 1219     FORMAT('      DIRECTLY FROM THE TERMINAL.')
          CALL DPWRST('XXX','BUG ')
          GOTO9000
        ENDIF
      ENDIF
C
C               *************************************
C               **  STEP 2D--                      **
C               **  IF HAVE THE FILE INPUT CASE--  **
C               **  EXTRACT THE FILE NAME          **
C               *************************************
C
      ISTEPN='2D'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IOFILE.EQ.'YES')THEN
C
        DO1310I=1,200
          ICANS(I:I)=IANSLC(I)
 1310   CONTINUE
C
        ISTART=1
        ISTOP=IWIDTH
        IWORD=2
        IF(ICASRE.EQ.'PARA')IWORD=3
        IF(ICASRE.EQ.'FUNC')IWORD=3
        IF(ICASRE.EQ.'MATR')IWORD=3
        IF(ICASRE.EQ.'ROWI')IWORD=4
        CALL DPEXWO(ICANS,ISTART,ISTOP,IWORD,
     1              ICOL1,ICOL2,IFILE,NCFILE,
     1              IBUGS2,ISUBRO,IERROR)
C
        IF(NCFILE.LT.1)THEN
          IERROR='YES'
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1341)
 1341     FORMAT('***** ERROR IN DPREAD--')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1342)
 1342     FORMAT('      A USER FILE NAME IS REQUIRED IN THE READ')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1344)
 1344     FORMAT('      COMMAND (FOR EXAMPLE,    READ CALIB.DAT X Y Z)')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1345)
 1345     FORMAT('      BUT NONE WAS GIVEN HERE.')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,1346)
 1346     FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
          CALL DPWRST('XXX','BUG ')
          IF(IWIDTH.GE.1)THEN
            WRITE(ICOUT,1347)(IANSLC(I),I=1,MIN(100,IWIDTH))
 1347       FORMAT('      ',100A1)
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,999)
            CALL DPWRST('XXX','BUG ')
            GOTO9000
          ENDIF
        ENDIF
C
      ENDIF
C
C               *************************************
C               **  STEP 2E--                      **
C               **  IF HAVE THE FILE INPUT CASE--  **
C               **  OPEN THE FILE                  **
C               *************************************
C
      ISTEPN='2E'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IOFILE.EQ.'YES')THEN
C
        IREWIN='ON'
        ICRFLG='ROW'
        IF(NCREAF.GT.0.AND.IOFILE.EQ.'YES')THEN
          IF(ICREAF(1:5).EQ.'(UNFO'.AND.ICASRE.EQ.'VARI')THEN
            IFORM='UNFORMATTED'
            IFMFLG='ON'
            IF(ICREAF(13:16).EQ.'COLU')ICRFLG='COLU'
            IF(ICREAF(1:5).EQ.'(COLU')ICRFLG='COLU'
          ELSEIF(ICREAF(1:5).EQ.'(UNFO'.AND.ICASRE.EQ.'MATR')THEN
            IF(IUNFMC.GT.0)THEN
              IFORM='UNFORMATTED'
              IFMFLG='ON'
            ELSE
              WRITE(ICOUT,999)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,1441)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,1442)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,1443)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,1444)
              CALL DPWRST('XXX','BUG ')
              IERROR='YES'
              GOTO9000
            ENDIF
          ELSE
            IFORM='FORMATTED'
            IFMFLG='OFF'
          ENDIF
        ELSE
          IFORM='FORMATTED'
          IFMFLG='OFF'
        ENDIF
 1441   FORMAT('***** ERROR IN DPREAD--')
 1442   FORMAT('      FOR UNFORMATTED READS OF MATRICES, THE ',
     1         ' FOLLOWING COMMAND IS REQUIRED:')
 1443   FORMAT('         SET UNFORMATTED COLUMNS <VALUE>')
 1444   FORMAT('      WHERE <VALUE> IS THE NUMBER OF COLUMNS IN THE ',
     1         'MATRTIX.')
C
        IF(IREACS(1:4).EQ.'CLOS')
     1    CALL DPOPFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1    IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
        IF(IERRFI.EQ.'YES')GOTO9000
        IF(IREACS(1:4).EQ.'CLOS')IREACS='OPEN'
C
      ENDIF
C
C               ******************************************
C               **  STEP 2F--                           **
C               **  FOR THE 2 CASES--                   **
C               **      1) TERMINAL INPUT;              **
C               **      2) FILE INPUT;                  **
C               **  DEFINE THE INPUT READ UNIT NUMBER,  **
C               **  AND OTHER VARIABLES NEEDED          **
C               **  FOR UPCOMING READS.                 **
C               ******************************************
C
      ISTEPN='2F'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IRD2=IRD
      IF(IMACCS.EQ.'OPEN'.OR.IMALEV.GE.1)THEN
        IRD2=IMACNU
      ENDIF
      IF(IOFILE.EQ.'YES')IRD2=IREANU
      IF(IOTERM.EQ.'YES')IRD2=IRD
C
      IOUNIT=IRD2
C
C               *****************************************
C               **  STEP 3--                           **
C               **  CHECK TO SEE THE TYPE CASE--       **
C               **    1) UNQUALIFIED (THAT IS, FULL);  **
C               **    2) SUBSET; OR                    **
C               **    3) FOR.                          **
C               *****************************************
C
      ISTEPN='3'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      ICASEQ='FULL'
      ILOCQ=NUMARG+1
      IF(NUMARG.LT.1)GOTO390
      DO300J=1,NUMARG
        J1=J
        IF(IHARG(J).EQ.'SUBS'.AND.IHARG2(J).EQ.'ET  ')THEN
          ICASEQ='SUBS'
          ILOCQ=J1
          GOTO390
        ELSEIF(IHARG(J).EQ.'EXCE'.AND.IHARG2(J).EQ.'PT  ')THEN
          ICASEQ='SUBS'
          ILOCQ=J1
          GOTO390
        ELSEIF(IHARG(J).EQ.'FOR '.AND.IHARG2(J).EQ.'    ')THEN
          ICASEQ='FOR'
          ILOCQ=J1
          GOTO390
        ENDIF
  300 CONTINUE
  390 CONTINUE
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,391)NUMARG,ILOCQ
  391   FORMAT('NUMARG,ILOCQ = ',2I8)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
  490 CONTINUE
C
C               ******************************************************
C               **  STEP 4--                                        **
C               **  DETERMINE THE TYPE AND NUMBER OF ITEMS          **
C               **  TO BE READ   .                                  **
C               **  NUMALL = TOTAL NUMBER OF READ  ITEMS            **
C               **           (AS DETERMINED BY INCLUDING ONLY ALL   **
C               **           BEFORE 'SUBSET' OR 'EXCEPT' OR 'FOR')  **
C               **  NUMV   = NUMBER OF VARIABLES TO BE READ    ;    **
C               **  NUMP   = NUMBER OF PARAMETERS TO BE READ    ;   **
C               **  NUMM   = NUMBER OF MODELS TO BE READ            **
C               **           (SHOULD = 0 OR 1)                      **
C               **  NUMF   = NUMBER OF FUNCTIONS TO BE READ         **
C               **  NUMU   = NUMBER OF UNKNOWNS TO BE READ    ;     **
C               **  NUME   = TOTAL NUMBER OF READ  ITEMS            **
C               **           (SHOULD = NUMALL);                     **
C               ******************************************************
C
      ISTEPN='4'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IV=0
      IP=0
      IM=0
      IF=0
      IU=0
      IE=0
C
      JMIN=1
      IF(IOFILE.EQ.'NO'.AND.ICASRE.EQ.'PARA')JMIN=2
      IF(IOFILE.EQ.'NO'.AND.ICASRE.EQ.'FUNC')JMIN=2
      IF(IOFILE.EQ.'NO'.AND.ICASRE.EQ.'MATR')JMIN=2
      IF(IOFILE.EQ.'NO'.AND.ICASRE.EQ.'ROWI')JMIN=3
      IF(IOFILE.EQ.'YES')JMIN=2
      IF(IOFILE.EQ.'YES'.AND.ICASRE.EQ.'PARA')JMIN=3
      IF(IOFILE.EQ.'YES'.AND.ICASRE.EQ.'FUNC')JMIN=3
      IF(IOFILE.EQ.'YES'.AND.ICASRE.EQ.'MATR')JMIN=3
      IF(IOFILE.EQ.'YES'.AND.ICASRE.EQ.'ROWI')JMIN=4
C
CCCCC JULY 2002: QUOTED FILE NAMES MAY CONTAIN SPACES.
CCCCC DETERMINE HOW MANY ARGUMENTS FILE NAME MAY CONTAIN.
CCCCC JUNE 2003: UPDATE TO INCLUDE HYPHENS AS WELL AS SPACES.
C
      IF(IFILE(1:1).EQ.'"')THEN
        DO421I=80,1,-1
          IF(IFILE(I:I).NE.' ')THEN
            ILAST=I
            GOTO424
          ENDIF
  421   CONTINUE
  424   CONTINUE
        ICOUNT=0
        ISPAC=0
        DO426I=1,ILAST
          IF((IFILE(I:I).EQ.' '.OR.IFILE(I:I).EQ.'-') .AND.
     1      ISPAC.EQ.0)THEN
            ISPAC=1
            ICOUNT=ICOUNT+1
          ELSEIF((IFILE(I:I).NE.' '.AND.IFILE(I:I).NE.'-') .AND.
     1      ISPAC.EQ.1)THEN
            ISPAC=0
          ENDIF
  426   CONTINUE
        JMIN=JMIN+ICOUNT
      ENDIF
C
      JMAX=ILOCQ-1
      IF(ICASRE.EQ.'ROWI')JMAX=JMIN
      IF(ICASRE.EQ.'MATR')JMAX=JMIN+MAXCOM-1
C
      IF(ICASRE.EQ.'MATR')THEN
        IF(JMAX.GT.JMIN+MAXRDV-1)JMAX=JMIN+MAXRDV-1
      ENDIF
C
      IF(ICASRE.EQ.'MATR')IHMAT1=IHARG(JMIN)
      IF(ICASRE.EQ.'MATR')IHMAT2=IHARG2(JMIN)
C
      IVALMA=0
      NUMALL=0
      NUMALL=JMAX-JMIN+1
      IF(ICASRE.EQ.'VARI'.AND.NUMALL.LE.0)IVRLST='NO'
      IF(IVRLST.EQ.'NO' .AND. ICASRE.EQ.'VARI')THEN
C
CCCCC FIRST, CASE WHERE SKIP AUTOMATIC IS ON, RETRIEVE
CCCCC VARIABLE LIST FROM LINE JUST BEFORE THE "----".
C
        IF(ISKIP.EQ.-1.AND.IOFILE.EQ.'YES')THEN
          DO4578I=1,MAXOBV
            ILINE=I
            NUMCHA=-1
            CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                  IA,NUMCHA,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
C
            IF(IERROR.EQ.'YES')GOTO8800
            IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1        NUMCHA.EQ.3)THEN
              REWIND IOUNIT
              GOTO8800
            ELSEIF(IA(1).EQ.'-'.AND.IA(2).EQ.'-'.AND.IA(3).EQ.'-'.AND.
     1        IA(4).EQ.'-')THEN
              GOTO4581
            ELSE
              DO4511J=1,132
                IASAVE(J)=IA(J)
 4511         CONTINUE
            ENDIF
 4578     CONTINUE
 4581     CONTINUE
          IF(ILINE.GT.1)THEN
            IFRST=0
            ILAST=0
            INEW=0
            IVAR=0
            CALL DPUPPE(IASAVE,132,IASAVE,IBUGS2,IERROR)
            DO4583J=1,132
              IF(IASAVE(J)(1:1).EQ.' ')THEN
                IF(INEW.EQ.1)THEN
                  IVAR=IVAR+1
                  ILAST=J
                  NCHAR=ILAST-IFRST+1
                  DO4585K=1,MIN(4,NCHAR)
                    IVLIST(IVAR)(K:K)=IASAVE(IFRST+K-1)(1:1)
 4585             CONTINUE
                  IF(NCHAR.GE.5)THEN
                    DO4587K=5,MIN(8,NCHAR)
                      IVLIS2(IVAR)(K-4:K-4)=IASAVE(IFRST+K-1)(1:1)
 4587               CONTINUE
                  ENDIF
                  INEW=0
                ENDIF
              ELSE
                ILAST=J
                IF(INEW.EQ.0)THEN
                  INEW=1
                  IFRST=J
                ENDIF
              ENDIF
 4583       CONTINUE
            REWIND IOUNIT 
            JMIN=1
            JMAX=IVAR
          ENDIF
C
CCCCC SECOND CASE: SKIP AUTOMATIC IS OFF
CCCCC 1) SET COLUMN LIMITS, ROW LIMITS
CCCCC 2) SKIP OVER HEADER LINES (IF NEEDED)
CCCCC 3) READ SINGLE LINE OF DATA
CCCCC 4) DETERMINE NUMBER OF COLUMNS OF DATA IN THAT LINE
CCCCC 5) SET VARIABLE NAMES TO X1, ..., XK
CCCCC    IF IVARLA="ON", FIRST LINE READ SHOULD BE VARIABLE NAMES
CCCCC 6) REWIND
C
        ELSEIF(IOFILE.EQ.'YES')THEN
          IF(ISKIP.GE.0)THEN
            IFRMIN=IFROW1
            IFRMAX=IFROW1+ISKIP
            IF(IFRMAX.LT.IFRMIN)IFRMAX=IFRMIN
            MINCO2=1
            MAXCO2=NUMRCM
            IFCOL3=IFCOL1
            IFCOL4=IFCOL2
            IF(IFRMIN.LT.IFRMAX)THEN
              DO4591IFROW=IFRMIN,IFRMAX-1
                NUMCHA=-1
                CALL DPREFI(
     1              IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1              IA,NUMCHA,
     1              ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
 4591         CONTINUE
            ENDIF
C
            IF(IVARLA.EQ.'OFF')THEN
              NUMLRD=0
 4592         CONTINUE
              DO4597I=1,MAXRCL
                ISTOR1(I)='    '
                ISTOR2(I)='    '
                ISTOR3(I)='    '
                IB(I)='    '
 4597         CONTINUE
              CALL DPREAL(IRD2,IFCOL3,IFCOL4,MINCO2,MAXCO2,X0,NUMDPL,
     1             IXC,NXC,
     1             ICASRE,IFUNC2,N2,MAXN2,
     1             IMACRO,IMACNU,IMACCS,
     1             IANSLC,IWIDTH,IREACS,ISTOR1,ISTOR2,IEND,NUMLRD,
     1             IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1             ICOMCH,ICOMSW,LINETY,IGRPA2,
     1             IFCOLL,IFCOLU,ITYPE,NCOLS,NCALL,IREADL,PREAMV,
     1             MAXRDV,MAXCHV,
     1             IDECPT,
     1             IB,
     1             IERRFI,IBUGS2,ISUBRO,IERROR)
              IF(LINETY.EQ.'BLAN')GOTO4592
              NUMLRD=0
              IF(NUMDPL.GT.0)THEN
                DO4593J=1,NUMDPL
                  IVLIST(J)='X   '
                  IVLIS2(J)='    '
                  IF(J.LE.9)THEN
                    WRITE(IVLIST(J)(2:2),'(I1)')J
                  ELSEIF(J.LE.99)THEN
                    WRITE(IVLIST(J)(2:3),'(I2)')J
                  ELSE
                    WRITE(IVLIST(J)(2:4),'(I3)')J
                  ENDIF
 4593           CONTINUE
              ENDIF
              REWIND IOUNIT 
              NCALL=0
              NCOLS=0
              JMIN=1
              JMAX=NUMDPL
            ELSEIF(IVARLA.EQ.'ON')THEN
              NUMCHA=-1
              CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1             IASAVE,NUMCHA,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
              IF(IERROR.EQ.'YES')GOTO8800
C
              IFRST=0
              ILAST=0
              INEW=0
              IVAR=0
              CALL DPUPPE(IASAVE,132,IASAVE,IBUGS2,IERROR)
              DO34583J=1,132
                IF(IASAVE(J)(1:1).EQ.' ')THEN
                  IF(INEW.EQ.1)THEN
                    IVAR=IVAR+1
                    ILAST=J
                    NCHAR=ILAST-IFRST+1
                    DO34585K=1,MIN(4,NCHAR)
                      IVLIST(IVAR)(K:K)=IASAVE(IFRST+K-1)(1:1)
34585               CONTINUE
                    IF(NCHAR.GE.5)THEN
                      DO34587K=5,MIN(8,NCHAR)
                        IVLIS2(IVAR)(K-4:K-4)=IASAVE(IFRST+K-1)(1:1)
34587                 CONTINUE
                    ENDIF
                    INEW=0
                  ENDIF
                ELSE
                  ILAST=J
                  IF(INEW.EQ.0)THEN
                    INEW=1
                    IFRST=J
                  ENDIF
                ENDIF
34583         CONTINUE
CCCCC DON'T REWIND FILE, DON'T WANT TO READ VARIABLE LABELS AS DATA
CCCCC         REWIND IOUNIT 
              JMIN=1
              JMAX=IVAR
            ENDIF
C
          ENDIF
        ENDIF
      ENDIF
 4589 CONTINUE
C
      IF(JMIN.GT.JMAX)GOTO4290
      IF(ICASRE.EQ.'ROWI')GOTO4290
C
C  JANUARY 2004.  THE DPREAL ROUTINE CAN NOW RETURN CHARACTER AS
C  WELL AS NUMERIC DATA.  FOR THE VARIABLE READ CASE, READ FIRST
C  LINE OF FILE TO EXTRACT THE TYPES FOR EACH OF THE VARIABLES.
C  FOLLOWING CONDITIONS NEED TO APPLY:
C
C  1. THIS IS THE VARIABLE (AS OPPOSSED TO STRING, PARAMETER, MATRIX)
C     READ CASE.
C
C  2. THE CONVERT CHARACTER CASE IS SET TO CHARACTER (AS OPPOSSED
C     TO IGNORE OR ERROR).  THIS IS DETERMINED BY VALUE OF IGRPAU.
C
C  3. THE READ IS FROM FILE RATHER THAN THE KEYBOARD.  FOR THE
C     KEYBOARD READ CASE, IGRPAU IS SET TO IGNORE.
C
C  4. IF A SET READ FORMAT HAS BEEN SET, NO CHARACTER DATA WILL
C     BE READ.
C
      ICFLAG='YES'
      IF(IGRPAU.NE.'CHAR')ICFLAG='NO'
      IF(IOFILE.NE.'YES')ICFLAG='NO'
      IF(ICASRE.NE.'VARI')ICFLAG='NO'
      IF(NCREAF.GT.0)ICFLAG='NO'
C
      IF(ICFLAG.EQ.'YES')THEN
C
        MINCO2=1
        MAXCO2=NUMRCM
        IFCOL3=IFCOL1
        IFCOL4=IFCOL2
        ITEMP=IFROW1+ISKIP-1
        IF(ITEMP.GT.0)THEN
          DO17380IFROW=1,ITEMP
            NUMCHA=-1
            CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                  IA,NUMCHA,
     1                  ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
            IF(IERROR.EQ.'YES')THEN
              IGRPA2='IGNO'
              ICFLAG='NO'
              GOTO17399
            ENDIF
            IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1        NUMCHA.EQ.3)THEN
              IGRPA2='IGNO'
              ICFLAG='NO'
              GOTO17399
            ENDIF
17380     CONTINUE
        ENDIF
C
17391   CONTINUE
        NCALL=0
        NCOLS=0
        CALL DPREAL(IRD2,IFCOL3,IFCOL4,MINCO2,MAXCO2,X0,NUMDPL,
     1              IXC,NXC,
     1              ICASRE,IFUNC2,N2,MAXN2,
     1              IMACRO,IMACNU,IMACCS,
     1              IANSLC,IWIDTH,IREACS,ISTOR1,ISTOR2,IEND,NUMLRD,
     1              IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1              ICOMCH,ICOMSW,LINETY,IGRPA2,
     1              IFCOLL,IFCOLU,ITYPE,NCOLS,NCALL,IREADL,PREAMV,
     1              MAXRDV,MAXCHV,
     1              IDECPT,
     1              IB,
     1              IERRFI,IBUGS2,ISUBRO,IERROR)
        IF(LINETY.EQ.'BLAN')GOTO17391
C
        IF(NXC.LE.0)THEN
          ICFLAG='NO'
          IGRPA2='IGNO'
          GOTO17399
        ENDIF
C
17399   CONTINUE
        REWIND(IOUNIT)
        NCALL=0
        NCOLS=0
      ENDIF
C
      ICNTNU=0
      ICNTCH=0
      ICOUNT=0
C
      DO4200J=JMIN,JMAX
        ICOUNT=ICOUNT+1
        IF(IVRLST.EQ.'NO')THEN
          IH1=IVLIST(J)
          IH2=IVLIS2(J)
        ELSE
          IH1=IHARG(J)
          IH2=IHARG2(J)
        ENDIF
C
C     **********
C     THE FOLLOWING 5 LINES OF CODE IS FOR      READ MATRIX.
C     IT ALLOWS COLUMN VECTOR NAMES TO BE FORMED
C     FROM THE BASE MATRIX NAME
C     BY THE APPENDING OF NUMBERS 1, 2, 3, ...
C     SEPTEMBER 1987
C     **********
C
        IF(ICASRE.EQ.'MATR')THEN
          IVALMA=IVALMA+1
          CALL DPAPN2(IHMAT1,IHMAT2,IVALMA,
     1                IH1,IH2,IBUGS2,ISUBRO,IERROR)
        ENDIF
C
C     ***************
C     THE FOLLOWING CODE ALLOWS THE    TO    KEYWORD
C     TO BE ACTIVATED, AS IN
C     READ FILE.EXT Y1 TO Y10
C     DECEMBER 1986
C     ***************
C
        ICASTO='OFF'
        IF(IH1.EQ.'TO  ')THEN
          ICASTO='ON'
          JM1=J-1
          JP1=J+1
          CALL DPEXTL(IHARG(JM1),IHARG2(JM1),IHARG(JP1),IHARG2(JP1),
     1                KNUMB,IVAL1,IVAL2,IBUGS2,ISUBRO,IERROR)
C
          IVA1P1=IVAL1+1
          IVA2M1=IVAL2-1
          IF(IVA1P1.GT.IVA2M1)GOTO4200
          IVAL=IVAL1
        ELSE
          GOTO4219
        ENDIF
 4215   CONTINUE
        IVAL=IVAL+1
        IF(IVAL.GE.IVAL2)GOTO4200
C
        CALL DPAPNU(IHARG(JM1),IHARG2(JM1),KNUMB,IVAL,
     1              IH1,IH2,IBUGS2,ISUBRO,IERROR)
 4219   CONTINUE
C
C  JANUARY 2004: CHECK WHETHER NAME SHOULD BE ADDED TO
C  REGULAR NAME LIST OR CHARACTER VARIABLE NAME LIST.
C
        IF(ICFLAG.EQ.'YES')THEN
          IF(ITYPE(ICOUNT).EQ.1)THEN
            ICNTCH=ICNTCH+1
            IF(ICNTCH.GT.MAXCHV)GOTO4200
            ICLIST(ICNTCH)=IH1
            ICLIS2(ICNTCH)=IH2
            GOTO4200
          ELSE
            ICNTNU=ICNTNU+1
          ENDIF
        ENDIF
C
        ICASEA='    '
        DO4300I=1,NUMNAM
          I2=I
          IF(IH1.EQ.IHNAME(I).AND.IH2.EQ.IHNAM2(I))THEN
            IF(IUSE(I).EQ.'V')THEN
              ICASEA='V'
              IV=IV+1
              IF(IV.GT.MAXV2)GOTO4370
              JVNAM1(IV)=IH1
              JVNAM2(IV)=IH2
              NIV(IV)=IN(I2)
C
              IF(ICASRE.EQ.'VARI')GOTO4370
              WRITE(ICOUT,999)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4311)
 4311         FORMAT('***** ERROR IN DPREAD--')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4312)
 4312         FORMAT('      A NAME IN THE LIST ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4313)
 4313         FORMAT('      OF VARIABLES TO BE READ ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4314)
 4314         FORMAT('      INCLUDED THE NAME OF A ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4315)
 4315         FORMAT('      PREVIOUSLY-DEFINED PARAMETER OR FUNCTION.')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4316)IH1,IH2
 4316         FORMAT('      THE NAME OF THE PARAMETER OR FUNCTION WAS ',
     1               2A4,'   .')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4317)
 4317         FORMAT('      NO READ WAS CARRIED OUT.')
              CALL DPWRST('XXX','BUG ')
              IERROR='YES'
              GOTO8800
C
            ELSEIF(IUSE(I).EQ.'P')THEN
              ICASEA='P'
              IP=IP+1
              IF(IP.GT.MAXP2)GOTO4370
              JPNAM1(IP)=IH1
              JPNAM2(IP)=IH2
              PVAL(IP)=VALUE(I2)
C
              IF(ICASRE.EQ.'PARA')GOTO4370
              WRITE(ICOUT,999)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4321)
 4321         FORMAT('***** ERROR IN DPREAD--')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4322)
 4322         FORMAT('      A NAME IN THE LIST ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4323)
 4323         FORMAT('      OF PARAMETERS TO BE READ ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4324)
 4324         FORMAT('      INCLUDED THE NAME OF A ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4325)
 4325         FORMAT('      PREVIOUSLY-DEFINED VARIABLE OR FUNCTION.')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4326)IH1,IH2
 4326         FORMAT('      THE NAME OF THE VARIABLE OR FUNCTION WAS ',
     1               2A4,'   .')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4327)
 4327         FORMAT('      NO READ WAS CARRIED OUT.')
              CALL DPWRST('XXX','BUG ')
              IERROR='YES'
              GOTO8800
C
            ELSEIF(IUSE(I).EQ.'M')THEN
              ICASEA='M'
              IM=IM+1
              IF(IM.GT.MAXM2)GOTO4370
              JMNAM1(IM)=IH1
              JMNAM2(IM)=IH2
C
              WRITE(ICOUT,999)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4331)
 4331         FORMAT('***** ERROR IN DPREAD--')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4332)
 4332         FORMAT('      A NAME IN THE LIST OF VARIABLES TO BE')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4334)
 4334         FORMAT('      READ INCLUDED THE NAME OF A ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4335)
 4335         FORMAT('      PREVIOUSLY-DEFINED MODEL.')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4336)IH1,IH2
 4336         FORMAT('      THE NAME OF THE MODEL WAS ',2A4,'  .')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4337)
 4337         FORMAT('      NO READ WAS CARRIED OUT.')
              CALL DPWRST('XXX','BUG ')
              IERROR='YES'
              GOTO8800
C
            ELSEIF(IUSE(I).EQ.'F')THEN
              ICASEA='F'
              IF=IF+1
              IF(IF.GT.MAXF2)GOTO4370
              JFNAM1(IF)=IH1
              JFNAM2(IF)=IH2
              IFSTA2(IF)=IVSTAR(I2)
              IFSTO2(IF)=IVSTOP(I2)
C
              IF(ICASRE.EQ.'FUNC')GOTO4370
              WRITE(ICOUT,999)
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4341)
 4341         FORMAT('***** ERROR IN DPREAD--')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4342)
 4342         FORMAT('      A NAME IN THE LIST ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4343)
 4343         FORMAT('      OF FUNCTIONS (= STRINGS) TO BE READ ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4344)
 4344         FORMAT('      INCLUDED THE NAME OF A ')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4345)
 4345         FORMAT('      PREVIOUSLY-DEFINED VARIABLE OR PARAMETER.')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4346)IH1,IH2
 4346         FORMAT('      THE NAME OF THE VARIABLE OR PARAMETER WAS ',
     1               2A4,'   .')
              CALL DPWRST('XXX','BUG ')
              WRITE(ICOUT,4347)
 4347         FORMAT('      NO READ WAS CARRIED OUT.')
              CALL DPWRST('XXX','BUG ')
              IERROR='YES'
              GOTO8800
C
            ENDIF
          ENDIF
 4300   CONTINUE
C
        ICASEA='U'
        IU=IU+1
        IF(IU.GT.MAXU2)GOTO4370
        JUNAM1(IU)=IH1
        JUNAM2(IU)=IH2
        GOTO4370
C
 4370   CONTINUE
        IE=IE+1
        IF(IE.GT.MAXE2)THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,4381)
 4381     FORMAT('***** ERROR IN DPREAD--')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,4382)
 4382     FORMAT('      THE NUMBER OF NAMES IN THE READ COMMAND')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,4383)
 4383     FORMAT('      HAS JUST EXCEEDED THE ALLOWABLE')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,4384)MAXE2
 4384     FORMAT('      MAXIMUM (',I5,')')
          CALL DPWRST('XXX','BUG ')
          IERROR='YES'
          GOTO8800
        ENDIF
C
        JENAM1(IE)=IH1
        JENAM2(IE)=IH2
        IECASE(IE)='NEW'
        IF(ICASEA.EQ.'V')IECASE(IE)='OLD'
        IECOL2(IE)=-1
        IF(ICASEA.EQ.'V')IECOL2(IE)=IVALUE(I2)
        IF(ICASEA.EQ.'P')IECASE(IE)='OLD'
        IF(ICASEA.EQ.'F')IECASE(IE)='OLD'
C
        IF(ICASTO.EQ.'ON')GOTO4215
C
 4200 CONTINUE
 4290 CONTINUE
C
CCCCC FEBRUARY 2003: IF NO VARIABLES GIVEN, THEN WILL
CCCCC DETERMINE AUTOMATICALLY LATER ON.
C
      NUMV=IV
      NUMP=IP
      NUMM=IM
      NUMF=IF
      NUMU=IU
      NUME=IE
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,4411)NUMALL,NUMV,NUMP,NUMM,NUMF,NUMU,NUME
 4411   FORMAT('NUMALL,NUMV,NUMP,NUMM,NUMF,NUMU,NUME = ',7I6)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4412)
 4412   FORMAT('I,JVNAM1(I),JVNAM2(I),JPNAM1(I),JPNAM2(I),
     1  JMNAM1(I),JMNAM2(I),JFNAM1(I),JFNAM2(I),JUNAM1(I),JUNAM2(I)')
        CALL DPWRST('XXX','BUG ')
        DO4420I=1,15
          WRITE(ICOUT,4421)I,JVNAM1(I),JVNAM2(I),JPNAM1(I),JPNAM2(I),
     1    JMNAM1(I),JMNAM2(I),JFNAM1(I),JFNAM2(I),JUNAM1(I),JUNAM2(I)
 4421     FORMAT(I8,5X,2A4,1X,2A4,1X,2A4,1X,2A4,1X,2A4)
          CALL DPWRST('XXX','BUG ')
 4420   CONTINUE
      ENDIF
C
C               ***************************************************
C               **  STEP 5--                                     **
C               **  CHECK FOR A VALID NUMBER                     **
C               **  (1 TO 100) OF VARIABLES TO BE READ           **
C               **  (NOTE--THIS DOES NOT INCLUDE PARAMETERS      **
C               **  OR MODELS IN THE ABOVE COUNT--               **
C               **  ONLY VARIABLES.)                             **
C               **  CHECK FOR A VALID NUMBER                     **
C               **  (0 TO 100) OF CONSTANTS TO BE READ   .       **
C               **  CHECK FOR A VALID NUMBER                     **
C               **  (0 TO 100) OF MODELS TO BE READ   .          **
C               **  CHECK FOR A VALID NUMBER                     **
C               **  (0 TO 100) OF FUNCTIONS TO BE READ   .       **
C               **  CHECK FOR A VALID NUMBER                     **
C               **  (1 TO 100) OF UNKNOWNS TO BE READ   .        **
C               ***************************************************
C
      IF(NUMV.LT.0 .OR. NUMV.GT.MAXV2)THEN
C
        WRITE(ICOUT,511)
  511   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,512)
  512   FORMAT('      FOR A READ, ')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,513)
  513   FORMAT('      THE NUMBER OF VARIABLES (NOT COUNTING ',
     1         'PARAMETERS OR MODELS')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,514)MAXV2
  514   FORMAT('      MUST BE AT MOST ',I8,'  ;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,515)
  515   FORMAT('      SUCH WAS NOT THE CASE HERE;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,516)
  516   FORMAT('      THE SPECIFIED NUMBER')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,517)NUMV
  517   FORMAT('      OF VARIABLES TO BE READ    WAS ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,518)MAXV2
  518   FORMAT('      NOTE--ONLY THE FIRST ',I8,' VARIABLES')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,519)
  519   FORMAT('      WILL BE READ   .')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,520)
  520   FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,521)(IANSLC(I),I=1,MIN(80,IWIDTH))
  521     FORMAT(80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
      ENDIF
C
      IF(NUMP.LT.0 .OR. NUMP.GT.MAXP2)THEN
C
        WRITE(ICOUT,531)
  531   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,532)
  532   FORMAT('      FOR A READ, THE NUMBER OF PARAMETERS ')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,534)MAXP2
  534   FORMAT('      (CONSTANTS) MUST BE AT MOST ',I8,'  ;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,535)
  535   FORMAT('      SUCH WAS NOT THE CASE HERE; THE SPECIFIED')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,537)NUMP
  537   FORMAT('      NUMBER OF PARAMETERS TO BE READ    WAS ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,538)MAXP2
  538   FORMAT('      NOTE--ONLY THE FIRST ',I8,' PARAMETERS')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,539)
  539   FORMAT('      WILL BE READ   .')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,540)
  540   FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,541)(IANSLC(I),I=1,MIN(80,IWIDTH))
  541     FORMAT(80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
      ENDIF
C
      IF(NUMM.LT.0 .OR. NUMM.GT.MAXM2)THEN
C
        WRITE(ICOUT,551)
  551   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,553)
  553   FORMAT('      FOR A READ, THE NUMBER OF MODELS MUST BE AT')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,555)MAXM2
  555   FORMAT('      MOST ',I8,'  ;  SUCH WAS NOT THE CASE HERE;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,556)NUMM
  556   FORMAT('      THE SPECIFIED NUMBER OF MODELS TO BE READ WAS ',
     1         I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,558)MAXM2
  558   FORMAT('      NOTE--ONLY THE FIRST ',I8,' MODELS WILL BE ',
     1         'READ.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,560)
  560   FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,561)(IANSLC(I),I=1,MIN(80,IWIDTH))
  561     FORMAT(80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
      ENDIF
C
      IF(NUMF.LT.0 .OR. NUMM.GT.MAXF2)THEN
C
        WRITE(ICOUT,571)
  571   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,572)
  572   FORMAT('      FOR A READ, THE NUMBER OF FUNCTIONS MUST BE AT')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,575)MAXF2
  575   FORMAT('      MOST ',I8,'  ;  SUCH WAS NOT THE CASE HERE;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,576)NUMF
  576   FORMAT('      THE SPECIFIED NUMBER OF FUNCTIONS TO BE READ ',
     1         'WAS ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,578)MAXF2
  578   FORMAT('      NOTE--ONLY THE FIRST ',I8,' FUNCTIONS WILL BE ',
     1         'READ.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,560)
  580   FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,581)(IANSLC(I),I=1,MIN(80,IWIDTH))
  581     FORMAT(80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
      ENDIF
C
      IF(NUMU.LT.0 .OR. NUMU.GT.MAXU2)THEN
C
        WRITE(ICOUT,611)
  611   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,612)
  612   FORMAT('      FOR A READ, THE NUMBER OF UNKNOWNS MUST BE AT')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,614)MAXU2
  614   FORMAT('      MUST BE AT MOST ',I8,';  SUCH WAS NOT THE CASE ',
     1         'HERE.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,617)NUMU
  617   FORMAT('      THE SPECIFIED NUMBER OF UNKNOWNS TO BE READ WAS ',
     1         I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,618)MAXU2
  618   FORMAT('      NOTE--ONLY THE FIRST ',I8,' UNKNOWNS')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,619)
  619   FORMAT('      WILL BE READ   .')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,620)
  620   FORMAT('      THE ENTERED COMMAND LINE WAS AS FOLLOWS--')
        CALL DPWRST('XXX','BUG ')
        IF(IWIDTH.GE.1)THEN
          WRITE(ICOUT,621)(IANSLC(I),I=1,MIN(80,IWIDTH))
  621     FORMAT(80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
C
      ENDIF
C
      IF(ICASRE.NE.'ROWI' .AND. NUME.LT.1 .AND. ICNTCH.LT.1)THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4451)
 4451   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4452)
 4452   FORMAT('      NO VARIABLE NAMES WERE PROVIDED IN THE')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4453)
 4453   FORMAT('      READ STATEMENT, HENCE NO READ WAS CARRIED OUT.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4454)
 4454   FORMAT('      ILLUSTRATIVE EXAMPLE TO DEMONSTRATE')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4455)
 4455   FORMAT('      THE PROPER FORM FOR THE READ COMMAND--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4456)
 4456   FORMAT('      SUPPOSE THE ANALYST WISHES TO READ')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4457)
 4457   FORMAT('      DATA FROM THE FILE    CALIB.')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4458)
 4458   FORMAT('      INTO THE INTERNAL VARIABLES Y, X1, AND X2;')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4459)
 4459   FORMAT('      THIS IS DONE BY ENTERING THE COMMAND')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,4460)
 4460   FORMAT('      READ CALIB. Y X1 X2')
        CALL DPWRST('XXX','BUG ')
        IERROR='YES'
        GOTO8800
      ENDIF
C
C               *******************************************************
C               **  STEP 6--                                         **
C               **  THOSE NAMES WHICH ARE OF THE UNKNOWN CATEGORY    **
C               **  WILL BECOME  FUTURE VARIABLES/PARAMETERS/FUNCTIONS.*
C               **  ASSIGN THESE VARIABLES TO THE NEXT AVAILABLE     **
C               **  COLUMNS, AND UPDATE THE NAME TABLE ACCORDINGLY.  **
C               *******************************************************
C
      IF(NUME.GT.0)THEN
        INAM=NUMNAM
        IF(ICASRE.EQ.'VARI')ICOL=NUMCOL
        DO700IE=1,NUME
          IF(ICASRE.EQ.'VARI'.AND.IECASE(IE).EQ.'OLD')GOTO700
          IF(ICASRE.EQ.'PARA'.AND.IECASE(IE).EQ.'OLD')GOTO700
          IF(ICASRE.EQ.'FUNC'.AND.IECASE(IE).EQ.'OLD')GOTO700
          IF(ICASRE.EQ.'MATR'.AND.IECASE(IE).EQ.'OLD')GOTO700
          IF(ICASRE.EQ.'VARI'.AND.IECOL2(IE).GE.1)GOTO700
          IF(ICASRE.EQ.'MATR')GOTO700
          INAM=INAM+1
          IF(ICASRE.EQ.'VARI')ICOL=ICOL+1
C
          IF(INAM.GT.MAXNAM)THEN
            WRITE(ICOUT,999)
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,711)
  711       FORMAT('***** ERROR IN DPREAD--')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,712)
  712       FORMAT('      THE NUMBER OF NAMES')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,713)
  713       FORMAT('      (VARIABLES + PARAMETERS + FUNCTIONS)')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,714)
  714       FORMAT('      HAS JUST EXCEEDED THE MAXIMUM SIZE')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,715)MAXNAM
  715       FORMAT('      (',I5,') OF THE INTERNAL NAME TABLE.')
            CALL DPWRST('XXX','BUG ')
            IERROR='YES'
            GOTO8800
          ENDIF
C
          IF(ICASRE.NE.'PARA' .AND. ICASRE.NE.'FUNC' .AND.
     1       ICASRE.NE.'ROWI' .AND. ICOL.GT.MAXCOL)THEN
             WRITE(ICOUT,999)
             CALL DPWRST('XXX','BUG ')
             WRITE(ICOUT,721)
  721        FORMAT('***** ERROR IN DPREAD--')
             CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,722)
  722       FORMAT('      THE NUMBER OF COLUMNS')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,723)
  723       FORMAT('      IN THE INTERNAL DATAPLOT DATA ARRAY')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,724)
  724       FORMAT('      HAS JUST EXCEEDED THE ALLOWABLE')
            CALL DPWRST('XXX','BUG ')
            WRITE(ICOUT,725)MAXCOL
  725       FORMAT('      MAXIMUM (',I5,')')
            CALL DPWRST('XXX','BUG ')
            IERROR='YES'
            GOTO8800
          ENDIF
C
          IHNAME(INAM)=JENAM1(IE)
          IHNAM2(INAM)=JENAM2(IE)
          IF(ICASRE.EQ.'PARA')IUSE(INAM)='P'
          IF(ICASRE.EQ.'FUNC')IUSE(INAM)='F'
          IF(ICASRE.EQ.'VARI')THEN
            IUSE(INAM)='V'
            IVALUE(INAM)=ICOL
            IECOL2(IE)=ICOL
            IN(INAM)=0
          ENDIF
  700   CONTINUE
        NUMNAM=INAM
        IF(ICASRE.EQ.'VARI')NUMCOL=ICOL
      ENDIF
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,791)NUMNAM,NUMCOL,NUMNAM,ICASRE
  791   FORMAT('NUMNAM,NUMCOL,NUMNAM,ICASRE = ',3I8,2X,A4)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
C               ********************************************************
C               **  STEP 7--                                          **
C               **  FIRST, BRANCH TO THE APPROPRIATE SUBCASE          **
C               **  (DEPENDING ON WHETHER UNQUALIFIED, SUBSET OR FOR);**
C               **  THE DETERMINE THE LENGTH OF THE LONGEST           **
C               **  VARIABLE TO BE READ    IN ;                       **
C               **  THEN READ IN  THE VARIABLES                       **
C               **  THAT WERE SPECIFIED.                              **
C               ********************************************************
C
      ISTEPN='7'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      MAXNRD=MAXN
      IF(IREASB.EQ.'P-P ')ICASEQ='FULL'
      IF(ICASEQ.EQ.'FULL')THEN
        DO7315I=1,MAXNRD
          ISUB(I)=1
 7315   CONTINUE
        NQ2=MAXNRD
      ELSEIF(ICASEQ.EQ.'SUBS')THEN
        NIOLD=MAXNRD
        CALL DPSUBS(NIOLD,ILOCS,NS,IBUGQ,IERROR)
        NQ2=NIOLD
      ELSEIF(ICASEQ.EQ.'FOR')THEN
        NIOLD=MAXNRD
        CALL DPFOR(NIOLD,NFOR,IROW1,IROWN,
     1             NLOCAL,ILOCS,NS,IBUGQ,IERROR)
        NQ2=NFOR
      ENDIF
C
C               *******************************************
C               **  STEP 8--                             **
C               **  IF A DATA ROW MINIMUM EXISTS AND SO  **
C               **  OUR ATTENTION IS FOCUSED ONLY ON     **
C               **  CERTAIN ROWS OF THE DATA FILE,       **
C               **  THEN GO DOWN TO THE FIRST SUCH ROW   **
C               **  IN THE FILE.                         **
C               *******************************************
C
      ISTEPN='8'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IFMFLG.EQ.'ON' .OR. IFROW1.LE.1)GOTO7369
        IFRMIN=1
        IFRMAX=IFROW1-1
        IF(IFRMIN.GT.IFRMAX)GOTO7369
        MINCO2=1
        MAXCO2=NUMRCM
        IF(IRD2.EQ.IRD)MAXCO2=80
        IFCOL3=IFCOL1
        IFCOL4=IFCOL2
C       THE FOLLOWING 2 LINES WERE INSERTED FEBRUARY 1988
C       TO "TURN OFF" THE    COLUMN LIMITS    IF READING FROM A NON-FILE
C       (THAT IS, IF READING FROM THE TERMINAL OR WITHIN A MACRO).
        IF(IOFILE.EQ.'NO')THEN
          IFCOL3=MINCO2
          IFCOL4=MAXCO2
        ENDIF
        IF(IRD2.EQ.IRD.AND.IFCOL4.GT.MAXCO2)IFCOL4=MAXCO2
C
        DO7360IFROW=IFRMIN,IFRMAX
          IF(IOFILE.EQ.'NO')THEN
            READ(IRD2,7361,END=7363,ERR=7363)IJUNK
 7361       FORMAT(A1)
          ELSEIF(IOFILE.EQ.'YES')THEN
            NUMCHA=-1
            CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                  IA,NUMCHA,
     1                  ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
            IF(IERROR.EQ.'YES')GOTO8800
            IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1        NUMCHA.EQ.3)GOTO7363
          ENDIF
          GOTO7360
C
 7363     CONTINUE
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7364)
 7364     FORMAT('***** ERROR IN DPREAD--')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7365)
 7365     FORMAT('      END OF FILE ENCOUNTERED WHILE SKIPPING OVER',
     1           'HEADER LINES.')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7367)
 7367     FORMAT('      NOTE SKIP AND ROW LIMITS SETTINGS--')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7368)ISKIP,IFROW1,AFROW2
 7368     FORMAT('      ISKIP,IFROW1,IFROW2 = ',2I8,2X,E15.7)
          CALL DPWRST('XXX','BUG ')
          IERROR='YES'
          GOTO8800
C
 7360   CONTINUE
 7369 CONTINUE
C
C               *******************************************
C               **  STEP 9--                             **
C               **  IN ADDITION, IF HEADER (= NON-DATA)  **
C               **  LINES EXIST WHICH ARE TO BE SKIPPED  **
C               **  OVER IN THE READ, DO SO HERE.        **
C               *******************************************
C
      ISTEPN='9'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IFMFLG.EQ.'ON' .OR. IOFILE.EQ.'NO')GOTO7389
C
      IF(IFEEDB.EQ.'ON')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        IF(IFROW1.LE.1)THEN
          WRITE(ICOUT,7371)
 7371     FORMAT('THE NUMBER OF HEADER LINES')
          CALL DPWRST('XXX','BUG ')
        ELSEIF(IFROW1.GE.2)THEN
          WRITE(ICOUT,7372)
 7372     FORMAT('THE NUMBER OF (ADDITIONAL) HEADER LINES')
          CALL DPWRST('XXX','BUG ')
        ENDIF
        WRITE(ICOUT,7373)ISKIP
 7373   FORMAT('    BEING SKIPPED = ',I6)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
CCCCC OCTOBER 1997.  SUPPORT "SKIP AUTOMATIC", DENOTED BY ISKIP = -1.
CCCCC READ UNTIL FIND "----".  IF "----" IS NOT FOUND, REWIND THE
CCCCC FILE, AND START READ FROM LINE 1.  ALSO, IF READING FROM
CCCCC THE TERMINAL, THEN THIS OPTION DOESN'T MAKE SENSE, SO
CCCCC ASSUME ISKIP = 0 IN THIS CASE.
C
      IF(ISKIP.EQ.-1.AND.IOFILE.EQ.'YES')THEN
        IFRMIN=1
        MINCO2=1
        MAXCO2=NUMRCM
        IF(IRD2.EQ.IRD)MAXCO2=80
        IFCOL3=IFCOL1
        IFCOL4=IFCOL2
        IF(IRD2.EQ.IRD.AND.IFCOL4.GT.MAXCO2)IFCOL4=MAXCO2
        DO7378I=1,50000
          NUMCHA=-1
          CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                IA,NUMCHA,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
C
          IF(IERROR.EQ.'YES')GOTO8800
          IF(IA(1).EQ.'-'.AND.IA(2).EQ.'-'.AND.IA(3).EQ.'-'.AND.
     1      IA(4).EQ.'-')THEN
            GOTO7389
          ENDIF
          IF(NUMCHA.GE.5)THEN
            DO7379LL=1,NUMCHA-3
              IF(IA(LL).EQ.'-'.AND.IA(LL+1).EQ.'-'.AND.
     1          IA(LL+2).EQ.'-'.AND.IA(LL+3).EQ.'-')THEN
                GOTO7389
              ENDIF
 7379       CONTINUE
          ENDIF
          IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1      NUMCHA.EQ.3)THEN
            REWIND IOUNIT
            GOTO7389
          ENDIF
 7378   CONTINUE
      ENDIF
C
      IF(ISKIP.LE.0)GOTO7389
      IFRMIN=IFROW1
      IFRMAX=IFROW1+ISKIP-1
      IF(IFRMIN.GT.IFRMAX)GOTO7389
      MINCO2=1
      MAXCO2=NUMRCM
      IF(IRD2.EQ.IRD)MAXCO2=80
      IFCOL3=IFCOL1
      IFCOL4=IFCOL2
C     THE FOLLOWING 2 LINES WERE INSERTED FEBRUARY 1988
C     TO "TURN OFF" THE    COLUMN LIMITS    IF READING FROM A NON-FILE
C     (THAT IS, IF READING FROM THE TERMINAL OR WITHIN A MACRO).
      IF(IOFILE.EQ.'NO')THEN
        IFCOL3=MINCO2
        IFCOL4=MAXCO2
      ENDIF
      IF(IRD2.EQ.IRD.AND.IFCOL4.GT.MAXCO2)IFCOL4=MAXCO2
      DO7380IFROW=IFRMIN,IFRMAX
        IF(IOFILE.EQ.'NO')THEN
          READ(IRD2,7382,END=7383)IJUNK
 7382     FORMAT(A1)
        ELSEIF(IOFILE.EQ.'YES')THEN
          NUMCHA=-1
          CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                IA,NUMCHA,
     1                ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
          IF(IERROR.EQ.'YES')GOTO8800
          IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1      NUMCHA.EQ.3)GOTO7383
        ENDIF
        GOTO7380
C
 7383   CONTINUE
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7384)
 7384   FORMAT('***** ERROR IN DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7385)
 7385   FORMAT('      END OF FILE ENCOUNTERED')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7386)
 7386   FORMAT('      WHILE SKIPPING OVER HEADER LINES')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7387)
 7387   FORMAT('      NOTE SKIP AND ROW LIMITS SETTINGS--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7388)ISKIP,IFROW1,AFROW2
 7388   FORMAT('      ISKIP,IFROW1,AFROW2 = ',2I8,2X,E15.7)
        CALL DPWRST('XXX','BUG ')
        IERROR='YES'
        GOTO8800
C
 7380 CONTINUE
 7389 CONTINUE
C
C               ************************
C               **  STEP 10--         **
C               **  READ IN THE DATA  **
C               ************************
C
      ISTEPN='10'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7210)NUME
 7210   FORMAT('NUME = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,7211)IRD,IRD2
 7211   FORMAT('IRD,IRD2 = ',I8,I8)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
      DO7260I=1,MAXRCL
        ISTOR1(I)=' '
        ISTOR2(I)=' '
        ISTOR3(I)=' '
        IB(I)=' '
 7260 CONTINUE
C
      IF(NUME.GT.0)THEN
        DO7300I=1,NUME
          IEN(I)=0
 7300   CONTINUE
      ENDIF
C
      MINCO2=1
      MAXCO2=NUMRCM
      IF(IRD2.EQ.IRD)MAXCO2=80
      IFCOL3=IFCOL1
      IFCOL4=IFCOL2
C     THE FOLLOWING 2 LINES WERE INSERTED FEBRUARY 1988
C     TO "TURN OFF" THE    COLUMN LIMITS    IF READING FROM A NON-FILE
C     (THAT IS, IF READING FROM THE TERMINAL OR WITHIN A MACRO).
      IF(IOFILE.EQ.'NO')THEN
        IFCOL3=MINCO2
        IFCOL4=MAXCO2
      ENDIF
      IF(IRD2.EQ.IRD.AND.IFCOL4.GT.MAXCO2)IFCOL4=MAXCO2
C
      I=0
      IIN=0
      NUMLRD=0
      IENDTY=1
CCCCC THE FOLLOWING LINE WAS ADDED    JUNE 1990
CCCCC TO FIX FORMATTED READ YIELDING ONLY 1 LINE   JUNE 1990
      IEND='NO'
      IF(ISKIP.GE.0)THEN
        IFRMIN=IFROW1+ISKIP
        IF(ICASEQ.EQ.'FOR')IFRMIN=IFROW1+ISKIP+IROW1-1
      ELSE
        IFRMIN=1
        IF(ICASEQ.EQ.'FOR')IFRMIN=IROW1
      ENDIF
C
CCCCC OCTOBER 2004: ACCOUNT FOR SUBSET/FOR CLAUSE LIMITS
C
      IFRMAX=IFROW2
      IF(ICASEQ.EQ.'FOR')THEN
        IFRMAX=MIN(IFROW2,IROWN)
      ENDIF
C
      IF(ICASRE.EQ.'PARA' .OR. ICASRE.EQ.'FUNC')IFRMAX=IFRMIN
      IF(IHOST1.EQ.'CDC'.AND.IFRMAX.GT.130000)IFRMAX=130000
      IF(IFRMAX.GE.IBILLI)IFRMAX=IBILLI
      IF(IFRMIN.GT.IFRMAX)GOTO7470
CCCCC APRIL 1995.  CHECK FOR UNFORMATTED READ CASE.
CCCCC INITIAL IMPLEMENTATION ONLY APPLIES TO VARIABLES (NOT
CCCCC STRINGS, FUNCTIONS, MATRICES).
CCCCC 1) THE FOLLOWING COMMAND:
CCCCC        SET UNFORMATTED COLUMNS <N>
CCCCC    SPECIFIES THE NUMBER OF COLUMNS WHEN READING A MATRIX
CCCCC 2) UNFORMATTED READ ASSUMES A "SQUARE MATRIX" OF NUMBERS 
CCCCC    CONTAINING ONLY REAL NUMBERS WAS WRITTEN (THAT IS, ASSUME
CCCCC    A SINGLE WRITE PERFORMED, NOT A MIXTURE OF DIFFERENT TYPES
CCCCC    ETC.).  THE FOLLOWING 2 COMMANDS PROVIDE A LIMITED AMOUNT
CCCCC    OF FLEXIBILITY:
CCCCC        SET UNFORMATTED OFFSET <VALUE>
CCCCC        SET UNFORMATTED RECORDS <VALUE>
CCCCC    THE FIRST COMMAND SPECIFIES THE NUMBER OF DATA VALUES TO
CCCCC    SKIP AT THE BEGINING OF THE FILE.  THE SECOND COMMAND 
CCCCC    SPECIFIES THE NUMBER OF DATA VALUES TO READ.
CCCCC 3) THERE ARE ESSENTIALLY 2 WAYS TO CREATE THE UNFORMATTED
CCCCC    FILE.  FOR EXAMPLE, ASSUME WRITING 10,000 ROWS OF VARIABLES
CCCCC    X AND Y.  THEN CAN WRITE AS:
CCCCC    A)    WRITE(IUNIT) X,Y
CCCCC    B)    WRITE(IUNIT) (X(I),Y(I),I=1,N)
CCCCC    THE DISTINCTION IS THAT (A) WRITES ALL OF X AND THEN ALL OF
CCCCC    Y WHEREAS (B) WRITES X(1), Y(1), X(2), Y(2), ..., X(N), Y(N).
CCCCC    INITIAL IMPLEMENTATION ASSUMES (B) SINCE THIS CORRESPONDS
CCCCC    TO DATAPLOT'S STORING BY COLUMN.  THE
CCCCC    "SET READ UNFORMATTED-COLUMNWISE" COMMAND SPECIFIES THAT
CCCCC    METHOD (A) WAS USED TO CREATE THE FILE.
CCCCC DATAPLOT WILL READ ENTIRE UNFORMATTED FILE INTO "XSCRT"
CCCCC ARRAY.  IT WILL CHECK HOW MANY DATA VALUES WERE READ.  IT THEN
CCCCC DIVIDES THIS BY NUMBER OF VARIABLES TO BE READ.  THE DO7400
CCCCC LOOP BELOW THEN EXTRACTS EACH ROW OF DATA FROM THIS XSCRT
CCCCC ARRAY.
C
      IF(IFMFLG.EQ.'ON')THEN
C
        IF(IUNFOF.GT.2*MAXOBV)THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,11212)IUNFOF,2*MAXOBW
11212     FORMAT('****** ERROR: OFFSET OF ',I8,' IS GREATER THAN ',
     1           'MAXIMUM ALLOWED OF ',I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
C
        DO11002JJ=1,3*MAXOBW
          XSCRT(JJ)=CPUMIN
11002   CONTINUE
C
        IF(ICASRE.EQ.'MATR')NUME=IUNFMC
C
CCCCC   JULY 1996.  SGI DOESN'T READ IF XSCRT DIMENSIONED BIGGER
CCCCC   THAN NUMBER OF DATA POINTS IN FILE.  USER MAY NEED TO SPECIFY
CCCCC   THE COMMAND "SET UNFORMATTED RECORDS <N>".
C
        IF(IUNFNR.GT.0)THEN
          READ(IRD2,ERR=11080,END=11090,IOSTAT=JSTATS)
     1    (XSCRT(LL),LL=1,IUNFNR+IUNFOF)
        ELSE
          READ(IRD2,ERR=11080,END=11090,IOSTAT=JSTATS)XSCRT
        ENDIF
        GOTO11090
C
11080   CONTINUE
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,11081)JSTATS
11081     FORMAT('****** ERROR TRYING TO READ AN UNFORMATTED FILE, ',
     1           'STATUS NUMBER = ',I8,'.')
          CALL DPWRST('XXX','BUG ')
        GOTO11090
C
11090   CONTINUE
        NSTOP=MAXOBW+IUNFOF
        IF(IUNFNR.GT.0)NSTOP=IUNFNR+IUNFOF
        DO11100JJ=NSTOP,1,-1
          NPTS=JJ
          IF(XSCRT(JJ).NE.CPUMIN)GOTO11109
11100   CONTINUE
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,11111)
11111   FORMAT('****** ERROR: NO DATA FOUND IN THE UNFORMATTED FILE.')
        CALL DPWRST('XXX','BUG ')
        GOTO9000
11109   CONTINUE
        NPTS=NPTS-IUNFOF
        IFRMIN=1
        IFRMAX=NPTS/NUME
      ENDIF
C
      IF(ICASRE.EQ.'ROWI')THEN
         DO17411II=1,MAXOBV
           IROWLB(II)=' '
17411    CONTINUE
      ENDIF
C
CCCCC OCTOBER 2004: SUBSET/FOR/EXPECT CLAUSES ON READ HAVE SOME
CCCCC AMBIGUITY.  THAT IS, DOES THE SUBSET REFER TO THE LINES THAT
CCCCC ARE READ FROM THE FILE OR DOES THE SUBSET REFER TO HOW THE
CCCCC DATA ARE SAVED IN THE OUTPUT VECTORS.  WE ADDRESS THIS WITH
CCCCC THE COMMAND
CCCCC
CCCCC     SET READ SUBSET  <PACK/DISPERSE>   <PACK/DISPERSE>
CCCCC
CCCCC THE FIRST SETTING SPECIFIES HOW THE DATA FILE IS HANDLED
CCCCC (PACK MEANS SUBSET/FOR CLAUSE DOES NOT APPLY TO LINES IN
CCCCC FILE WHILE DISPERSE MEANS THAT IT DOES).  LIKEWISE, THE SECOND
CCCCC SETTING SPECIFIES HOW THE SUBSET/FOR CLAUSE APPLIES TO THE
CCCCC OUTPUT VARIABLES (PACK MEANS SUBSET IGNORED ON OUTPUT VECTOR,
CCCCC DISPERSE MEAMS THAT IT DOES).  THESE SETTINGS ARE CODED AS
CCCCC   "P-D", "P-P", "D-P", "D-D".  THE DEFAULT IS "P-D" (I.E.,
CCCCC THE SUBSET APPLIES TO THE OUTPUT VECTORS, BUT NOT THE INPUT
CCCCC FILE).  FOR EXAMPLE, THE COMMAND
CCCCC
CCCCC            READ X  FOR I = 1  2  10
CCCCC
CCCCC     X      P-D       P-P          D-P      D-D
CCCCC    ===========================================
CCCCC     1       1         1            1        1
CCCCC     2       0         2            3        0
CCCCC     3       2         3            5        3
CCCCC     4       0         4            7        0
CCCCC     5       3         5            9        5
CCCCC     6       0         -            -        0
CCCCC     7       4         -            -        7
CCCCC     8       0         -            -        0
CCCCC     9       5         -            -        9
CCCCC    10       0         -            -        0
C
      NCALL=0
      IMAXRW=IFRMAX-IFRMIN+1
      DO7400IFROW=IFRMIN,IFRMAX
C
        IIN=IIN+1
        IF(ISUB(IIN).NE.1)THEN
          IF(IREASB(1:1).EQ.'D')THEN
            IF(IREASB(3:3).EQ.'D')THEN
              I=I+1
            ENDIF
            NUMCHA=-1
            CALL DPREFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                  IA,NUMCHA,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
            IF(IA(1).EQ.'E'.AND.IA(2).EQ.'O'.AND.IA(3).EQ.'F'.AND.
     1         NUMCHA.EQ.3)THEN
               REWIND IOUNIT
               IENDTY=1
               GOTO7490
            ENDIF
            GOTO7400
          ENDIF
        ENDIF
C
        IF(NCREAF.LE.0 .OR. ICASRE.EQ.'FUNC' .OR. ICASRE.EQ.'ROWI')THEN
          CALL DPREAL(IRD2,IFCOL3,IFCOL4,MINCO2,MAXCO2,X0,NUMDPL,
     1                IXC,NXC,
     1                ICASRE,IFUNC2,N2,MAXN2,
     1                IMACRO,IMACNU,IMACCS,
     1                IANSLC,IWIDTH,IREACS,ISTOR1,ISTOR2,IEND,NUMLRD,
     1                IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1                ICOMCH,ICOMSW,LINETY,IGRPA2,
     1                IFCOLL,IFCOLU,ITYPE,NCOLS,NCALL,IREADL,PREAMV,
     1                MAXRDV,MAXCHV,
     1                IDECPT,
     1                IB,
     1                IERRFI,IBUGS2,ISUBRO,IERROR)
          IF(LINETY.EQ.'BLAN')GOTO7400
          NUMLRD=NUMLRD+1
          NCALL=NCALL+1
C
C  IF CHARACTER DATA ENCOUNTERED, WRITE IT TO FILE
C
          IF(NXC.GT.0 .AND. IGRPAU.EQ.'CHAR')THEN
            IF(NUMLRD.EQ.1)THEN
C
              IOUNI2=IZCHNU
              IFILE2=IZCHNA
              ISTAT2=IZCHST
              IFORM2=IZCHFO
              IACCE2=IZCHAC
              IPROT2=IZCHPR
              ICURS2=IZCHCS
C
              ISUBN0='READ'
              IERRFI='NO'
              CALL DPOPFI(IOUNI2,IFILE2,ISTAT2,IFORM2,IACCE2,IPROT2,
     1                    ICURS2,
     1                    IREWI2,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
              IF(IERRFI.EQ.'YES')GOTO9000
              IZCHCS=ICURS2
C
              WRITE(IOUNI2,'(I8)')NXC
              DO27810ICNT=1,MIN(ICNTCH,MAXCHV)
                WRITE(IOUNI2,'(A4,A4)')ICLIST(ICNT),ICLIS2(ICNT)
27810         CONTINUE
            ENDIF
            WRITE(IOUNI2,'(20(A24,1X))')(IXC(J)(1:24),J=1,NXC)
          ENDIF
        ELSEIF(IFMFLG.EQ.'ON')THEN
C
          NUMLRD=NUMLRD+1
          IF(IUNFNR.GT.0.AND.NUMLRD*NUME.GT.IUNFNR)GOTO7400 
          NUMDPL=NUME
          IF(ICRFLG.EQ.'ROW')THEN
            IPTR1=(NUMLRD-1)*NUME+1+IUNFOF
            IPTR2=IPTR1+NUME-1
            ICOUNT=0
            DO17415JJ=IPTR1,IPTR2
              ICOUNT=ICOUNT+1
              X0(ICOUNT)=XSCRT(JJ)
17415       CONTINUE
          ELSE
            IPTR1=NUMLRD+IUNFOF
            IPTR2=IFRMAX
            DO17515JJ=1,NUME
              ICOUNT=IPTR1+(JJ-1)*IPTR2
              X0(JJ)=XSCRT(ICOUNT)
17515       CONTINUE
          ENDIF
        ELSE
          NUMLRD=NUMLRD+1
          NUMDPL=NUME
          IF(ICOMSW.EQ.'ON')THEN
 7417       CONTINUE
            READ(IRD2,'(A80)',END=7480)IAJUNK
            IF(IAJUNK(1:1).EQ.ICOMCH(1:1))GOTO7417
            BACKSPACE(UNIT=IRD2,IOSTAT=IOS,ERR=7413)
            GOTO7415
 7413       CONTINUE
            WRITE(ICOUT,743)
 743        FORMAT('ERROR TRYING TO BACKSPACE FILE ON FORMATTED READ')
            CALL DPWRST('XXX','BUG ')
            GOTO7417
          ENDIF
          READ(IRD2,ICREAF,END=7480,ERR=7480)(X0(K),K=1,NUME)
          GOTO7415
        ENDIF
C
 7415   CONTINUE
        IF(IERROR.EQ.'YES')GOTO8800
        IF(IFROW.EQ.IFRMIN)THEN
          DO7425K=1,132
            ISTOR3(K)=ISTOR2(K)
 7425     CONTINUE
          GOTO7430
        ENDIF
        IF(IEND.EQ.'YES')GOTO7480
C
 7430   CONTINUE
        I=I+1
C
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7431)
 7431     FORMAT('***** FROM THE MIDDLE OF DPREAD--')
          CALL DPWRST('XXX','BUG ')
          AFRMAX=IFRMAX
          WRITE(ICOUT,7432)IFROW,IFRMIN,AFRMAX,IBUGS2,ISUBRO
 7432     FORMAT('IFROW,IFRMIN,AFRMAX,IBUGS2,ISUBRO = ',2I8,E15.7,
     1           2X,A4,2X,A4)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7433)I,ISUB(I),NUME,IBUGS2,ISUBRO
 7433     FORMAT('I,ISUB(I),NUME,IBUGS2,ISUBRO = ',3I8,2X,A4,2X,A4)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7434)MAXN,MAXCOL,MAXCP1,MAXCP2
 7434     FORMAT('MAXN,MAXCOL,MAXCP1,MAXCP2 = ',4I8)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7435)X0(1),X0(2),X0(3)
 7435     FORMAT('X0(1),X0(2),X0(3) = ',3E15.7)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7436)IECOL2(1),IECOL2(2),IECOL2(3)
 7436     FORMAT('IECOL2(1),IECOL2(2),IECOL2(3) = ',3I8)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7437)IEN(1),IEN(2),IEN(3)
 7437     FORMAT('IEN(1),IEN(2),IEN(3) = ',3I8)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,7438)ICASRE,NUMVRD,NUMPRD,NUMFRD
 7438     FORMAT('ICASRE,NUMVRD,NUMPRD,NUMFRD = ',A4,3I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
C
CCCCC   OCTOBER 2004: IS OUTPUT VECTOR PACKED OR DISPERSED?
C
        IF(I.GT.MAXN .OR. I.GT.IMAXRW)GOTO7480
        IJUNK=I
        IF(IREASB(3:3).EQ.'P' .AND. IREASB(1:1).EQ.'D')IJUNK=IIN
        IF(ISUB(IJUNK).EQ.1)THEN
          GOTO7440
        ELSE
          IF(IREASB(3:3).EQ.'D')THEN
            GOTO7430
          ELSE
            GOTO7400
          ENDIF
        ENDIF
C
 7440   CONTINUE
        IF(ICASRE.EQ.'PARA')THEN
          NUMPRD=NUME
          GOTO7400
        ELSEIF(ICASRE.EQ.'FUNC')THEN
           NUMFRD=NUME
           GOTO7400
        ELSEIF(ICASRE.EQ.'MATR')THEN
C
C     -----BEGIN MATRIX COPY-----
C          IHMAT1 = FIRST  HALF OF MATRIX NAME
C          IHMAT2 = SECOND HALF OF MATRIX NAME
C          INAMMA = NAME INDEX FOR MATRIX
C          IMATC1 = FIRST COLUMN OF THE MATRIX
C          IMATNR = NUMBER OF ROWS    IN THE MATRIX
C          IMATNC = NUMBER OF COLUMNS IN THE NATRIX
C
          IF(NUMLRD.EQ.1)THEN
C
            INAM=NUMNAM
            ICOL=NUMCOL
C
            INAM=INAM+1
            ICOL=ICOL+1
C
            INAMMA=INAM
            IMATC1=ICOL
C
            IHNAME(INAMMA)=IHMAT1
            IHNAM2(INAMMA)=IHMAT2
            IUSE(INAMMA)='M'
            IVALUE(INAMMA)=ICOL
            IN(INAMMA)=0
            IVALU2(INAMMA)=ICOL+NUMDPL-1
            IMATNC=NUMDPL
            NUMNAM=INAM
            NUMCOL=ICOL
C
            ICOL=ICOL-1
            IF(NUMDPL.GT.0)THEN
              DO7452IE=1,NUMDPL
                INAM=INAM+1
                ICOL=ICOL+1
                IHNAME(INAM)=JENAM1(IE)
                IHNAM2(INAM)=JENAM2(IE)
                IUSE(INAM)='V'
                IVALUE(INAM)=ICOL
                IN(INAM)=0
                IECOL2(IE)=ICOL
                IF(IBUGS2.EQ.'ON')THEN
                  WRITE(ICOUT,7453)IE,IECOL2(IE),NUMDPL,INAM,NUMNAM
 7453             FORMAT('IE,IECOL2(IE),NUMDPL,INAM,NUMNAM = ',5I8)
                  CALL DPWRST('XXX','BUG ')
                ENDIF
 7452         CONTINUE
              NUMNAM=INAM
              NUMCOL=ICOL
            ENDIF
          ENDIF
C
          IE2=0
          IMATNR=0
          IF(NUMDPL.GT.0)THEN
            DO7455IE=1,NUMDPL
              IE2=IE
              Z0=X0(IE)
              IF(IBUGS2.EQ.'ON')THEN
                WRITE(ICOUT,7456)IE,IECOL2(IE),NUMDPL,INAM,NUMNAM
 7456           FORMAT('IE,IECOL2(IE),NUMDPL,INAM,NUMNAM = ',5I8)
                CALL DPWRST('XXX','BUG ')
              ENDIF
              ICOLVJ=IECOL2(IE)
              IJ=MAXN*(ICOLVJ-1)+I
              IF(ICOLVJ.LE.MAXCOL)V(IJ)=Z0
              IF(ICOLVJ.EQ.MAXCP1)PRED(I)=Z0
              IF(ICOLVJ.EQ.MAXCP2)RES(I)=Z0
              IF(ICOLVJ.EQ.MAXCP3)YPLOT(I)=Z0
              IF(ICOLVJ.EQ.MAXCP4)XPLOT(I)=Z0
              IF(ICOLVJ.EQ.MAXCP5)X2PLOT(I)=Z0
              IF(ICOLVJ.EQ.MAXCP6)TAGPLO(I)=Z0
              IEN(IE)=I
              IN(INAM)=I
              IN(INAMMA)=I
              IMATNR=I
 7455       CONTINUE
            NUMVRD=IE2
            GOTO7400
          ENDIF
          NUMVRD=IE2-1
          GOTO7400
C
C     -----END MATRIX COPY-----
C
        ELSEIF(ICASRE.EQ.'ROWI')THEN
          IF(I.GT.MAXN)GOTO7480
          IROWLB(I)=' '
          IF(ISUB(I).NE.1)GOTO7400
          ILEN=24
          IF(N2.LT.ILEN)ILEN=N2
          DO7442KK=1,ILEN
            IROWLB(I)(KK:KK)=IFUNC2(KK)(1:1)
7442      CONTINUE
          GOTO7400
        ENDIF
C
C  OCTOBER 2004.  IF NUMBER OF REQUESTED ITEMS IS GREATER THAN
C                 NUMBER OF ITEMS ON THE LINE, PAD WITH MISSING
C                 VALUE (PREAMV).
C
C                 THE SET READ PAD MISSING COLUMNS COMMANDS
C                 DETERMINES WHETHER WE PAD OR USE THE PREVIOUS
C                 BEHAVIOR (I.E., IN SOME CASES, A MISSING COLUMN
C                 MAY INDICATE AN ERROR).
C
        IE2=0
        IF(NUME.LE.0)GOTO7448
        DO7445IE=1,NUME
          IE2=IE
CCCCCC    IF(IE2.GT.NUMDPL)GOTO7448
          IF(IREAPD.EQ.'OFF')THEN
            IF(IE2.GT.NUMDPL)GOTO7448
            Z0=X0(IE)
          ELSE
            IF(IE2.GT.NUMDPL)THEN
              Z0=PREAMV
            ELSE
              Z0=X0(IE)
            ENDIF
          ENDIF
          ICOLVJ=IECOL2(IE)
          IJ=MAXN*(ICOLVJ-1)+I
          IF(ICOLVJ.LE.MAXCOL)V(IJ)=Z0
          IF(ICOLVJ.EQ.MAXCP1)PRED(I)=Z0
          IF(ICOLVJ.EQ.MAXCP2)RES(I)=Z0
          IF(ICOLVJ.EQ.MAXCP3)YPLOT(I)=Z0
          IF(ICOLVJ.EQ.MAXCP4)XPLOT(I)=Z0
          IF(ICOLVJ.EQ.MAXCP5)X2PLOT(I)=Z0
          IF(ICOLVJ.EQ.MAXCP6)TAGPLO(I)=Z0
          IEN(IE)=I
 7445   CONTINUE
        NUMVRD=IE2
        GOTO7400
 7448   CONTINUE
        NUMVRD=IE2-1
 7400 CONTINUE
 7470 CONTINUE
      IENDTY=2
      GOTO7490
C
 7480 CONTINUE
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,7481)NUME
 7481   FORMAT('AT 7480: ERROR OR END OF FILE FOR FORMATTED READ, ',
     1         'NUME = ',I8,'.')
        CALL DPWRST('XXX','BUG ')
        DO7485K=1,NUME
        WRITE(ICOUT,7487)X0(K)
 7487   FORMAT('K, X0(K) = ',I8,2X,G15.7)
        CALL DPWRST('XXX','BUG ')
 7485   CONTINUE
      ENDIF 
      IENDTY=1
      NUMLRD=NUMLRD-1
      GOTO7490
C
 7490 CONTINUE
C
C               *****************************
C               **  STEP 11--              **
C               **  UPDATE THE NAME TABLE  **
C               *****************************
C
      ISTEPN='11'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(ICASRE.EQ.'PARA')THEN
        ISTEPN='7700'
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1    CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
        IF(NUMPRD.GT.0)THEN
          DO7710IE=1,NUMPRD
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
              WRITE(ICOUT,7711)IE,JENAM1(IE),JENAM2(IE),X0(IE)
 7711         FORMAT('IE,JENAM1(IE),JENAM2(IE),X0(IE) = ',
     1               I8,2X,2A4,E15.7)
              CALL DPWRST('XXX','BUG ')
            ENDIF
            DO7720J=1,NUMNAM
              IF(IUSE(J).EQ.'P'.AND.
     1          IHNAME(J).EQ.IH1.AND.IHNAM2(J).EQ.IH2)THEN
                IECOL2(IE)=J
                IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
                  WRITE(ICOUT,7731)IE,J,IECOL2(IE),X0(IE)
 7731             FORMAT('IE,J,IECOL2(IE),X0(IE) = ',3I8,E15.7)
                  CALL DPWRST('XXX','BUG ')
                ENDIF
                VALUE(J)=X0(IE)
                IVALUE(J)=VALUE(J)
CCCCC           FOLLOWING LINE ADDED SO THAT DELETE AND RETAIN WILL NOT 
CCCCC           DELETE PARAMETER CREATED VIA READ PARAMETER.  MARCH 1994.
                IN(J)=1
              ENDIF
 7720       CONTINUE
 7710     CONTINUE
 7790   ENDIF
        GOTO7900
      ELSEIF(ICASRE.EQ.'FUNC')THEN
        ISTEPN='7800'
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1    CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
        IF(NUMFRD.GT.0)THEN
          CALL DPUPPE(IFUNC2,N2,IFUNC3,IBUGS2,IERROR)
          ISTART=IFCOL1
          ISTOP=N2
          DO7810IE=1,NUMFRD
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
               WRITE(ICOUT,7811)IE,JENAM1(IE),JENAM2(IE),IECASE(IE)
 7811          FORMAT('IE,JENAM1(IE),JENAM2(IE),IECASE(IE) = ',
     1                I8,2X,2A4,2X,A4)
               CALL DPWRST('XXX','BUG ')
            ENDIF
            DO7820J=1,NUMNAM
              IF(IUSE(J).EQ.'F'.AND.
     1          IHNAME(J).EQ.IH1.AND.IHNAM2(J).EQ.IH2)THEN
                IECOL2(IE)=J
                IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
                  WRITE(ICOUT,7826)IE,J
 7826             FORMAT('IE,J = ',2I8)
                  CALL DPWRST('XXX','BUG ')
                ENDIF
                IHLEFT=IH1
                IHLEF2=IH2
                NEWNAM='NO'
                IF(IECASE(IE).EQ.'NEW')NEWNAM='YES'
                ILISTL=J
C
                IF(NUMFRD.EQ.1)THEN
                  IF(N2.LE.0)GOTO7832
                  ICOL1=1
                  ICOL2=N2
                  IF(ICOL2.GT.ICOL1+N2-1)ICOL2=ICOL1+N2-1
                  I2=0
                  DO7831I=ICOL1,ICOL2
                    I2=I2+1
                    IFUNC3(I2)=IFUNC2(I2)
 7831             CONTINUE
 7832             CONTINUE
                  N3=I2
C
                ELSE
                  IWORD=IE
                  IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
                    WRITE(ICOUT,7841)ICOL1,ICOL2,ISTART,ISTOP,N2,N3,
     1                               IE,IWORD
 7841               FORMAT('ICOL1,ICOL2,ISTART,ISTOP,N2,N3,IE,IWORD = ',
     1                     8I8)
                    CALL DPWRST('XXX','BUG ')
                  ENDIF
                  CALL DPEXW2(IFUNC2,N2,ISTART,ISTOP,IWORD,
     1                        ICOL1,ICOL2,IFUNC3,N3,
     1                        IBUGS2,ISUBRO,IERROR)
                  IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
                    WRITE(ICOUT,7841)ICOL1,ICOL2,ISTART,ISTOP,N2,N3,
     1                               IE,IWORD
                    CALL DPWRST('XXX','BUG ')
                  ENDIF
                ENDIF
C
                CALL DPINFU(IFUNC3,N3,IHNAME,IHNAM2,IUSE,IVSTAR,IVSTOP,
     1                      NUMNAM,IANSLC,IWIDTH,IHLEFT,IHLEF2,ILISTL,
     1                      NEWNAM,MAXN2,
     1                      IFUNC,NUMCHF,MAXCHF,IBUGS2,IERROR)
C
                IF(NEWNAM.EQ.'YES'.AND.IERROR.EQ.'NO')NUMNAM=NUMNAM-1
C
              ENDIF
 7820       CONTINUE
 7810     CONTINUE
        ENDIF
        GOTO7900
C
      ELSEIF(ICASRE.EQ.'ROWI')THEN
        GOTO7900
      ELSE
C
        ISTEPN='7600'
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
          CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
          WRITE(ICOUT,7601)ICASRE,NUMVRD,NUMNAM,NUME
 7601     FORMAT('ICASRE,NUMVRD,NUMNAM,NUME = ',A4,3I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        IF(NUMVRD.GT.0)THEN
          DO7610IE=1,NUMVRD
            N=IEN(IE)
            ICOLVJ=IECOL2(IE)
            DO7620J=1,NUMNAM
              IF(IUSE(J).EQ.'V'.AND.IVALUE(J).EQ.ICOLVJ)THEN
                IUSE(J)='V'
                IVALUE(J)=ICOLVJ
                IF(N.GT.IN(J))IN(J)=N
                IVSTAR(J)=MAXN*(ICOLVJ-1)+1
                IVSTOP(J)=MAXN*(ICOLVJ-1)+N
              ENDIF
 7620       CONTINUE
 7610     CONTINUE
        ENDIF
C
        NUMVRP=NUMVRD+1
        IF(ICASRE.EQ.'MATR')GOTO7690
        IF(NUMVRP.GT.NUME)GOTO7690
        DO7650IE=NUMVRP,NUME
          IEREV=NUME-IE+NUMVRP
          IF(IECASE(IEREV).EQ.'NEW')THEN
            INAM=NUMNAM
            IHNAME(INAM)='    '
            IHNAM2(INAM)='    '
            IUSE(INAM)='    '
            IVALUE(INAM)=0
            IN(INAM)=0
            NUMNAM=NUMNAM-1
            NUMCOL=NUMCOL-1
          ENDIF
 7650   CONTINUE
 7690   CONTINUE
        GOTO7900
      ENDIF
C
 7900 CONTINUE
C
C               *************************************
C               **  STEP 12--                      **
C               **  WRITE OUT SUMMARY INFORMATION  **
C               **  ABOUT THE FILE THAT WAS READ   **
C               *************************************
C
      ISTEPN='12'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IFEEDB.EQ.'ON')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,8000)
 8000   FORMAT('INPUT DATA FILE SUMMARY INFORMATION--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,8001)IRD2
 8001   FORMAT('INPUT UNIT DEVICE NUMBER         = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,8002)IFCOL3,IFCOL4
 8002   FORMAT('INPUT FILE COLUMN     LIMITS     = ',I8,4X,I8)
        CALL DPWRST('XXX','BUG ')
        IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
          WRITE(ICOUT,1111)AFROW2
 1111     FORMAT('AFROW2 = ',E15.7)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        IF(IFROW2.EQ.INTINF)THEN
          WRITE(ICOUT,8003)IFROW1
 8003     FORMAT('INPUT FILE ROW        LIMITS     = ',I8,4X,'INFINITY')
          CALL DPWRST('XXX','BUG ')
        ELSEIF(IFROW2.NE.INTINF)THEN
          WRITE(ICOUT,8004)IFROW1,IFROW2
 8004     FORMAT('INPUT FILE ROW        LIMITS     = ',I8,4X,I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        WRITE(ICOUT,8005)ISKIP
 8005   FORMAT('NUMBER OF HEADER LINES SKIPPED   = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,8006)NUMLRD
 8006   FORMAT('NUMBER OF DATA   LINES READ      = ',I8)
        CALL DPWRST('XXX','BUG ')
        IF(NUMVRD.GE.1)THEN
          WRITE(ICOUT,8007)NUMVRD
 8007     FORMAT('NUMBER OF VARIABLES    READ      = ',I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        IF(NUMPRD.GE.1)THEN
          WRITE(ICOUT,8008)NUMPRD
 8008     FORMAT('NUMBER OF PARAMETERS   READ      = ',I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        IF(NUMFRD.GE.1)THEN
          WRITE(ICOUT,8009)NUMFRD
 8009     FORMAT('NUMBER OF FUNCTIONS/STRINGS READ = ',I8)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        IF(NCREAF.LE.0)THEN
C
          IFRST=IFCOL3
          IF(IFRST+240-1.GE.IFCOL4)THEN
            ILAST=IFCOL4
          ELSE
            ILAST=IFRST+240-1
          ENDIF
C
          WRITE(ICOUT,8011)
 8011     FORMAT('THE SCANNED REGION OF THE FIRST DATA LINE READ ',
     1           '(TO A MAXIMUM OF 240 CHARACTERS) = ')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8012)(ISTOR3(J),J=IFRST,MIN(240,ILAST))
 8012     FORMAT(240A1)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8013)
 8013     FORMAT('THE SCANNED REGION OF THE LAST  DATA LINE READ ',
     1           '(TO A MAXIMUM OF 240 CHARACTERS) = ')
          CALL DPWRST('XXX','BUG ')
          IF(IENDTY.EQ.1)THEN
            WRITE(ICOUT,8014)(ISTOR1(J),J=IFRST,MIN(240,ILAST))
            CALL DPWRST('XXX','BUG ')
          ELSEIF(IENDTY.EQ.2)THEN
            WRITE(ICOUT,8014)(ISTOR2(J),J=IFRST,MIN(240,ILAST))
 8014       FORMAT(240A1)
            CALL DPWRST('XXX','BUG ')
          ENDIF
        ENDIF
      ENDIF
C
C               *********************************************
C               **  STEP 13--                              **
C               **  PRINT OUT SUMMARY INFORMATION          **
C               **  VARIABLES/PARAMETERS/FUNCTIONS         **
C               **  THAT WERE READ IN.                     **
C               *********************************************
C
      IF(ICASRE.EQ.'PARA')THEN
        IF(IFEEDB.EQ.'ON')THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8201)
 8201     FORMAT('PARAMETER     VALUE')
          CALL DPWRST('XXX','BUG ')
C
          DO8210IE=1,NUME
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            DO8220I=1,NUMNAM
              I2=I
              IF(IH1.EQ.IHNAME(I).AND.IH2.EQ.IHNAM2(I))THEN
                WRITE(ICOUT,8226)IH1,IH2,VALUE(I2)
 8226           FORMAT(A4,A4,4X,E15.7)
                CALL DPWRST('XXX','BUG ')
              ENDIF
 8220       CONTINUE
 8210     CONTINUE
        ENDIF
C
      ELSEIF(ICASRE.EQ.'FUNC')THEN
        IF(IFEEDB.EQ.'ON')THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8301)
 8301     FORMAT('FUNCTION (= STRING)     CONTENT')
          CALL DPWRST('XXX','BUG ')
C
          DO8310IE=1,NUME
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            DO8320I=1,NUMNAM
              I2=I
              IF(IH1.EQ.IHNAME(I).AND.IH2.EQ.IHNAM2(I))THEN
                JMIN=IVSTAR(I2)
                JMAX=IVSTOP(I2)
                WRITE(ICOUT,8326)IH1,IH2,(IFUNC(J),J=JMIN,JMAX)
 8326           FORMAT(A4,A4,10X,80A1)
                CALL DPWRST('XXX','BUG ')
              ENDIF
 8320       CONTINUE
 8310     CONTINUE
        ENDIF
C
      ELSEIF(ICASRE.EQ.'MATR')THEN
        IF(IFEEDB.EQ.'ON')THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8401)IHMAT1,IHMAT2,IMATNR
 8401     FORMAT('        MATRIX ',A4,A4,'--     ',I8,' ROWS')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8402)IMATNC
 8402     FORMAT('               ',4X,4X,'--     ',I8,' COLUMNS')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8404)
 8404     FORMAT('     VARIABLES        COLUMN    OBS/VARIABLE')
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8405)
 8405     FORMAT('(= COLUMN VECTORS)')
          CALL DPWRST('XXX','BUG ')
C
          DO8410IE=1,NUME
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            DO8420I=1,NUMNAM
              I2=I
              IF(IH1.EQ.IHNAME(I).AND.IH2.EQ.IHNAM2(I))THEN
                WRITE(ICOUT,8426)IH1,IH2,IVALUE(I2),IN(I2)
 8426           FORMAT(8X,A4,A4,1X,I8,5X,I8)
                CALL DPWRST('XXX','BUG ')
              ENDIF
 8420       CONTINUE
 8410     CONTINUE
        ENDIF
      ELSEIF(ICASRE.EQ.'ROWI')THEN
        CONTINUE
      ELSE
C
        IF(IFEEDB.EQ.'ON')THEN
          WRITE(ICOUT,999)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,8101)
 8101     FORMAT('VARIABLE     COLUMN    OBS/VARIABLE')
          CALL DPWRST('XXX','BUG ')
C
          DO8110IE=1,NUME
            IH1=JENAM1(IE)
            IH2=JENAM2(IE)
            DO8120I=1,NUMNAM
              I2=I
              IF(IH1.EQ.IHNAME(I).AND.IH2.EQ.IHNAM2(I))THEN
                WRITE(ICOUT,8126)IH1,IH2,IVALUE(I2),IN(I2)
 8126           FORMAT(A4,A4,1X,I8,5X,I8)
                CALL DPWRST('XXX','BUG ')
              ENDIF
 8120       CONTINUE
 8110     CONTINUE
        ENDIF
        GOTO8800
      ENDIF
C
C               ***************************************
C               **  STEP 88--                        **
C               **  FOR THE FILE CASE,               **
C               **  CLOSE THE FILE.                  **
C               ***************************************
C
 8800 CONTINUE
      ISTEPN='88'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')
     1CALL TRACE2(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IOFILE.EQ.'YES'.AND.ICURST.EQ.'OPEN')GOTO8810
      GOTO8890
 8810 CONTINUE
      IENDFI='OFF'
      IREWIN='ON'
      IF(IREARW.EQ.'ON')THEN
         CALL DPCLFI(IOUNIT,IFILE,ISTAT,IFORM,IACCES,IPROT,ICURST,
     1   IENDFI,IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
         IREACS='CLOSED'
      ENDIF
 8890 CONTINUE
C
C               ******************************************
C               **  STEP 89--                           **
C               **  IF THE MACRO STATUS IS OPEN         **
C               **  THEN CHANGE IDEV FROM READ TO MACR  **
C               ******************************************
C
 8900 CONTINUE
CCCCC IF(IMACST.EQ.'OPFI')IDEV='MACR'
CCCCC IF(IMACCS.EQ.'OPEN')IDEV='MACR'
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
C
      IF(IZCHCS.EQ.'OPEN')THEN
         CALL DPCLFI(IOUNI2,IFILE2,ISTAT2,IFORM2,IACCE2,IPROT2,ICURS2,
     1               IENDFI,IREWIN,ISUBN0,IERRFI,IBUGS2,ISUBRO,IERROR)
         IZCHCS='CLOSED'
      ENDIF
C
      IFILQU=IFILQ2
C
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'READ')THEN
        WRITE(ICOUT,999)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9011)
 9011   FORMAT('***** AT THE END       OF DPREAD--')
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9012)IFROW1,AFROW2,ICASRE
 9012   FORMAT('IFROW1,AFROW2,ICASRE = ',I8,2X,E15.7,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9013)IFCOL1,IFCOL2
 9013   FORMAT('IFCOL1,IFCOL2 = ',2I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9014)ISKIP,IBUGS2,IBUGQ
 9014   FORMAT('ISKIP,IBUGS2,IBUGQ = ',I8,2X,A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9015)IFOUND,IERROR
 9015   FORMAT('IFOUND,IERROR = ',A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9016)NUMVRD,NUMPRD,NUMFRD
 9016   FORMAT('NUMVRD,NUMPRD,NUMFRD = ',3I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9017)IMACRO,IMACNU,IMACCS
 9017   FORMAT('IMACRO,IMACNU,IMACCS = ',A4,I8,2X,A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9018)IRD,IRD2
 9018   FORMAT('IRD,IRD2 = ',2I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9019)IOSW,IOFILE,IOTERM
 9019   FORMAT('IOSW,IOFILE,IOTERM = ',A4,2X,A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9020)IBUGS2,ISUBRO,IERROR
 9020   FORMAT('IBUGS2,ISUBRO,IERROR = ',A4,2X,A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9021)IOUNIT
 9021   FORMAT('IOUNIT = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9022)IFILE
 9022   FORMAT('IFILE  = ',A80)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9023)ISTAT
 9023   FORMAT('ISTAT  = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9024)IFORM
 9024   FORMAT('IFORM  = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9025)IACCES
 9025   FORMAT('IACCES = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9026)IPROT
 9026   FORMAT('IPROT  = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9027)ICURST
 9027   FORMAT('ICURST = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9028)IENDFI
 9028   FORMAT('IENDFI = ',A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9029)IREWIN
 9029   FORMAT('IREWIN = ',A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9031)ISUBN0
 9031   FORMAT('ISUBN0 = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9032)IERRFI
 9032   FORMAT('IERRFI = ',A12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9033)NUMNAM
 9033   FORMAT('NUMNAM = ',I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9041)N2,MAXN2,N3
 9041   FORMAT('N2,MAXN2,N3 = ',3I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9042)(IFUNC2(I),I=1,100)
 9042   FORMAT('(IFUNC2(I),I=1,100) = ',100A1)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9043)(IFUNC3(I),I=1,100)
 9043   FORMAT('(IFUNC3(I),I=1,100) = ',100A1)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9051)IHMAT1,IHMAT2,INAMMA,IMATC1,IMATNR,IMATNC
 9051   FORMAT('IHMAT1,IHMAT2,INAMMA,IMATC1,IMATNR,IMATNC = ',
     1         A4,2X,A4,2X,4I8)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9061)NCREAF
 9061   FORMAT('NCREAF = ',I8)
        CALL DPWRST('XXX','BUG ')
        IF(NCREAF.GE.1)THEN
          WRITE(ICOUT,9062)(ICREAF(I:I),I=1,NCREAF)
 9062     FORMAT('(ICREAF(I:I),I=1,NCREAF) = ',80A1)
          CALL DPWRST('XXX','BUG ')
        ENDIF
        WRITE(ICOUT,9071)IREARW
 9071   FORMAT('IREARW = ',A4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,9072)ICOMCH,ICOMSW
 9072   FORMAT('ICOMCH,ICOMSW = ',A4,2X,A4)
        CALL DPWRST('XXX','BUG ')
      ENDIF
C
      RETURN
      END

      SUBROUTINE EDINIT
C
C     PURPOSE--INITIALIZE ALL VALUES IN COMMON
C
C     ORIGINAL VERSION--JANUARY 19,1985
C     UPDATED         --APRIL     1990
C     UPDATED         --AUGUST    1992.  CHANGES FOR SPACE AND
C                                        PORTABILITY (ALAN)
C     UPDATED         --APRIL     1993.  MOVE IMASK TO EDMAI2.FOR
C     UPDATED         --JULY      1993.  DATAPLOT SWITCH AS INPUT ARG
C     UPDATED         --JULY      1993.  MODIFY FOR ALAN MERGE
C
C------------------------------------------------------------------------------
C
      CHARACTER*20 ICJUNK
C
CCCCC CHARACTER*4 ISUBN1
CCCCC CHARACTER*4 ISUBN2
CCCCC CHARACTER*4 ISTEPN
C
C-----COMMON VARIABLES (EDITING)-----------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCOHO.INC'
      INCLUDE 'DPCONP.INC'
      INCLUDE 'EDCOMM.INC'
C
C-----COMMON VARIABLES (GENERAL)-----------------------------------------------
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
C
C-----START POINT-------------------------------------------
C
      IPRISW='OFF'
      IMODE='EDIT'
      IALL='OFF'
C
      IINFIN='*'
C
CCCCC INUMSW='OFF'
      INUMSW='ON'
      IFEESW='ON'
      ITRASW='OFF'
      IPROSW='ON'
      IPROMN='ON'
C
CCCCC THE FOLLOWING 2 LINES WERE COMMENTED OUT             APRIL 1993
CCCCC SO AS TO MOVE THE DEFINITION OF    IMASK             APRIL 1993
CCCCC TO EDMAI2.FOR (TO SIMPLIFY UNIX \\ PROBLEM)          APRIL 1993
CCCCC IMASK='\'
CCCCC IF(IOPSY1.EQ.'UNIX')IMASK='\\'
C
      ISPACH='EQUA'
      ISPACV='SING'
      IJUST='LEFT'
      ITRANS='NEAT'
C
      IBUGMA='OFF'
      IBUGTY='OFF'
      IBUGED='OFF'
      IBUGE2='OFF'
      IBUGE3='OFF'
      IBUGFI='OFF'
      IBUGT1='OFF'
      IBUGT2='OFF'
      IBUGWR='OFF'
      ICURLN=0
      IDELSW='OFF'
      IDELLN=(-999)
C
C -------------------------------------------------------
C
C     1. DEFINE MAXEDC = MAXIMUM NUMBER OF CHARACTERS.    AUGUST 1992
C     2. DEFINE MAXEDL = MAXIMUM NUMBER OF LINES.         AUGUST 1992
C     3. DEFINE MAXROW = MAXIMUM NUMBER OF ROWS.          AUGUST 1992
C     4. DEFINE MAXCMN = MAXIMUM NUMBER OF COMMANDS???    AUGUST 1992
C     (FOR DATAPLOT, THE DEFINITION OF MAXEDC, MAXEDL,    AUGUST 1992
C     AND MAXCMN   IS NOW DONE IN DPCOPA.INC              AUGUST 1992
C     DONE IN    DPCOPA.INC    AS PART OF   EDCOMM.INC)   AUGUST 1992
C
      NUMCHA=0
CCCCC MAXEDC=500000  NOW DONE IN DPCOPA.INC   AUGUST 1993
      NUMLIN=0
CCCCC MAXEDL=25000   NOW DONE IN DPCOPA.INC   AUGUST 1992
      NUMROW=0
      MAXROW=MAXEDL
      NUMCOM=3
CCCCC MAXCMN=100     NOW DONE IN DPCOPA.INC   AUGUST 1992
C
      DO1200I=1,MAXCMN
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990
CCCCC ICOM3(I)='        '
      ICOM3(I)='    '
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990
CCCCC ICOM4(I)='                     '
      ICOM4(I)='    '
      NCCOM3(I)=0
      NCCOM4(I)=0
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990
CCCCC INLIN3(I)='                     '
      INLIN3(I)='                    '
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990
CCCCC INLIN4(I)='                     '
      INLIN4(I)='                    '
      NCINL3(I)=0
      NCINL4(I)=0
 1200 CONTINUE
C
C     DEFINE USER-COMMANDS
C     (CHANGEABLE VIA THE    SET COMMAND   COMMAND)
C     3 SUCH BUILT-IN COMMANDS ARE PROVIDED
C        1) ERASE
C        2) EJECT
C        3) SPLM (= SET PRINTER'S LEFT MARGIN)
C
C     DEFINE COMMAND 1 = ERASE = ESCAPE FORMFEED
C
      ICOM3(1)='ERASE   '
      NCCOM3(1)=5
      ICJUNK='                    '
      ICJUNK(1:1)=CHAR(27)
      ICJUNK(2:2)=CHAR(12)
      ICOM4(1)=ICJUNK
      NCCOM4(1)=2
C
C     DEFINE COMMAND 2 = EJECT = FORMFEED
C
      ICOM3(2)='EJECT   '
      NCCOM3(2)=5
      ICJUNK='                    '
      ICJUNK(1:1)=CHAR(12)
      ICOM4(2)=ICJUNK
      NCCOM4(2)=1
C
C     DEFINE COMMAND 3 =  (= SET PRINTER'S LEFT MARGIN) = ESCAPE 9
C
      ICOM3(3)='SPLM    '
      NCCOM3(3)=4
      ICJUNK='                    '
      ICJUNK(1:1)=CHAR(27)
      ICJUNK(2:2)=CHAR(57)
      ICOM4(3)=ICJUNK
      NCCOM4(3)=2
C
      IOLDLN=ICURLN
      NCHAOL=NUMCHA
      NUMLOL=NUMLIN
      NUMROL=NUMROW
C
      NUMCLS=0
      NUMCFS=0
      NUMCCS=0
C
      NCHH1=0
      NCHH2=0
      NCHH3=0
      NCHH4=0
      NCHH5=0
      NCHH6=0
      NCHH7=0
      NCHH8=0
      NCHH9=0
      NCHH10=0
C
      DO1100I=1,240
      IHOLS1(I:I)=' '
      IHOLS2(I:I)=' '
      IHOLS3(I:I)=' '
      IHOLS4(I:I)=' '
      IHOLS5(I:I)=' '
      IHOLS6(I:I)=' '
      IHOLS7(I:I)=' '
      IHOLS8(I:I)=' '
      IHOLS9(I:I)=' '
      IHOL10(I:I)=' '
 1100 CONTINUE
C
      ICLIM1=1
      ICLIM2=240
      IPLIM1=1
      IPLIM2=240
      ILLIM1=1
      ILLIM2=240
      IMLIM1=1
      IMLIM2=60
      IVWIN1=1
      IVWIN2=100000
      IHWIN1=1
      IHWIN2=240
C
      IINDEC=240
      ICENTC=30
      ITRUNC=240
      ITABC=1
C
      ISCRO1=1
      ISCRO2=24
      ISCCO1=1
      ISCCO2=80
C
      IPRRO1=1
      IPRRO2=50
      IPRCO1=1
      IPRCO2=60
C
      ICXQT='OFF'
      IXQT=(-999)
      ICCALL='OFF'
C
C     DEFINE LOOP COUNTER, STRING & NUMBER OF CHAR. IN STRING MAY 1993
      LOOPCT=0
      LOOPST=' '
      LOOPIW=0
 
C     DEFINE    CHANGE-, LOCATE-, AND BOTTOM-    STATUS SETTINGS
      CHANGE='NO'
      LOCATE='NO'
      BOTTOM='NO'
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      RETURN
      END

      SUBROUTINE GRTRIN(IX,NCHTO2,ICSTR,NCSTR)
CCCCC SUBROUTINE GRTRIN(IX,NCHTOT,ICSTR,NCSTR)
C
C     PURPOSE--TRANSLATE THE INTEGER IX
C              INTO ITS CHARACTER EQUIVALENT.
C              NCHTOT = DESIRED NUMBER OF DIGITS IN INTEGER FORMAT.
C              (SO THAT THE OUTPUT WILL CORRESPOND TO   I(NCHTOT)   FORMAT.
C              THE OUTPUT WILL BE RIGHT-JUSTIFIED AS
C              ONE WOULD EXPECT FROM AN I FORTRAN INTEGER FORMAT.
C     NOTE--THE RESULTING TRANSLATED VALUES
C           WILL BE PLACED IN SPECIFIC ELEMENTS
C           OF THE A130 CHARACTER VARIABLE ICSTR.
C           THE VALUE OF THE VARIABLE    NCSTR
C           REPRESENTS THE NUMBER OF CHARACTERS IN ICSTR
C           THAT HAVE ALREADY BEEN FILLED.
C           THE RESULTING TRANSLATED VALUES WILL GO
C           (RIGHT-JUSTIFIED) INTO THE NEXT    NCHTOT
C           CHARACTERS OF ICSTR.
C           AND THE VALUE OF    NCSTR    WILL BE
C           UPDATED ACCORDINGLY, THAT IS,
C           NEW NCSTR = OLD NCSTR + NCHTOT
C     DANGER--NCSTR IS BOTH AN INPUT ARGUMENT
C             AND AN OUTPUT ARGUMENT OF THIS SUBROUTINE.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C     UPDATED         --MAY 1988
C                       IF NCHTOT IS NEGATIVE, MAKE LEADING ZEROS
C                       EXPLICIT ZEROS RATHER THAN SPACES.  THIS IS
C                       REQUIRED BY THE QUIC DRIVER IN PARTICULAR.
C     UPDATED         --JANUARY  1989. SUN (BY BILL ANDERSON)
C     UPDATED         --JANUARY  1989. POSTSCRIPT (BY ALAN HECKERT)
C     UPDATED         --JANUARY  1989. CGM (BY ALAN HECKERT)
C     UPDATED         --JANUARY  1989. QMS QUIC (BY ALAN HECKERT)
C     UPDATED         --JANUARY  1989. CALCOMP (BY ALAN HECKERT)
C     UPDATED         --JANUARY  1989. ZETA (BY ALAN HECKERT)
C     UPDATED         --JULY     1996. LAHEY DRIVER (ALAN HECKERT)
C     UPDATED         --OCTOBER  1996. QUICKWIN DRIVER (ALAN)
C     UPDATED         --OCTOBER  1996. OPENGL DRIVER (ALAN)
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*130 ICSTR
C
      DIMENSION IDIGIT(20)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C  MAY,1988: CHECK FOR NEGATIVE NCHTOT
      NCHTOT=ABS(NCHTO2)
C
      IASC0=48
C
      IREV=(-999)
      IDIG=(-999)
C
      IERRG4='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRIN')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRIN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IX
   52 FORMAT('IX = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)NCHTOT
   53 FORMAT('NCHTOT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)NCSTR
   61 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO67
      DO65I=1,NCSTR
      WRITE(ICOUT,66)I,ICSTR(I:I)
   66 FORMAT('I,ICSTR(I:I) = ',I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
   65 CONTINUE
   67 CONTINUE
      WRITE(ICOUT,69)IBUGG4,ISUBG4,IERRG4
   69 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               ***********************************
C               **  STEP 1--                     **
C               **  SAVE THE OLD VALUE OF NCSTR  **
C               ***********************************
C
      NCSOLD=NCSTR
C
C
C               ********************************************
C               **  STEP 2--                              **
C               **  FILL THE NEXT   NCHTOT   ELEMENTS     **
C               **  IN ICSTR() WITH BLANKS.               **
C               **  UPDATE NCSTR BY NCSTR + NCHTOT.       **
C               **  MAY,1988: - FILL WITH EXPLICIT ZEROS  **
C               **  IF NCHTOT SENT AS NEGATIVE            **
C               ********************************************
C
C
      IF(NCHTO2.LT.0)GOTO1290
C
      DO1200I=1,NCHTOT
      NCSTR=NCSTR+1
      ICSTR(NCSTR:NCSTR)=' '
 1200 CONTINUE
      GOTO1299
 1290 CONTINUE
      DO1295I=1,NCHTOT
      NCSTR=NCSTR+1
      ICSTR(NCSTR:NCSTR)='0'
 1295 CONTINUE
 1299 CONTINUE
C
C               ********************************
C               **  STEP 3--                  **
C               **  STRIP OUT THE DIGITS      **
C               **  (IN RIGHT TO LEFT ORDER)  **
C               ********************************
C
      ITEN=10
C
      IABSIX=IABS(IX)
      IRESUL=IABSIX
C
      NUMDIG=0
      DO1300I=1,20
      IDIVID=IRESUL
      IRESUL=IDIVID/ITEN
      IREM=IDIVID-IRESUL*ITEN
      NUMDIG=NUMDIG+1
      IDIGIT(NUMDIG)=IREM
      IF(IRESUL.EQ.0)GOTO1390
 1300 CONTINUE
 1390 CONTINUE
C
C               *****************************************************
C               **   STEP 4--                                      **
C               **   CHECK TO SEE THAT TOTAL NUMBER OF CHARACTERS  **
C               **   (= NUMBER OF DIGITS IF IX >= 0, AND           **
C               **   = NUMBER OF DIGITS + 1 IF IX < 0)             **
C               **   IS LESS THAN OR EQUAL TO NCHTOT.              **
C               **   IF YES, THEN GO TO NEXT STEP.                 **
C               **   IF NO, THEN FILL THE NCHTOT ELEMENTS          **
C               **  WITH ASTERISKS                                 **
C               *****************************************************
C
      NUMTOT=NUMDIG
      IF(IX.LT.0)NUMTOT=NUMTOT+1
C
      IF(NUMTOT.LE.NCHTOT)GOTO1490
      DO1400I=1,NCHTOT
      J=I+NCSOLD
      ICSTR(J:J)='*'
 1400 CONTINUE
      GOTO9000
 1490 CONTINUE
C
C               ****************************************
C               **  STEP 5--                          **
C               **  IF HAVE A VALID NUMBER OF DIGITS, **
C               **  TRANSLATE EACH DIGIT TO ITS       **
C               **  CHARACTER EQUIVALENT.             **
C               **  IN DOING SO, PLACE THE ASCII      **
C               **  CHARACTER EQUIVALENT              **
C               **  IN THE USUAL RIGHT-TO-LEFT ORDER  **
C               **  IN ICSTR(.).  IF IX < 0, INSERT   **
C               **  A MINUS BEFORE THE NUMBER.        **
C               **  HAVE THE CHARACTER STRING         **
C               **  RIGHT JUSTIFIED IN THE            **
C               **  NCHTOT ELEMENTS.                  **
C               ****************************************
C
      J=NCSOLD+(NCHTOT-NUMTOT)
      IF(IX.LT.0)J=J+1
      IF(IX.LT.0)ICSTR(J:J)='-'
C
      DO1500I=1,NUMDIG
      IREV=NUMDIG-I+1
      IDIG=IDIGIT(IREV)
      J=J+1
      IASCDI=IDIG+IASC0
CCCCC ICSTR(J:J)=CHAR(IASCDI)
      CALL DPCONA(IASCDI,ICSTR(J:J))
 1500 CONTINUE
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRIN')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRIN--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IX
 9012 FORMAT('IX = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)NCHTOT
 9013 FORMAT('NCHTOT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)IDIVID,IRESUL,IREM,NUMDIG,IDIGIT(NUMDIG)
 9021 FORMAT('IDIVID,IRESUL,IREM,NUMDIG,IDIGIT(NUMDIG) = ',5I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)IREV,NCSTR,IDIG,ICSTR(NCSTR:NCSTR)
 9022 FORMAT('IREV,NCSTR,IDIG,ICSTR(NCSTR:NCSTR) = ',3I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9023)IASC0,IX
 9023 FORMAT('IASC0,IX = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)NUMDIG,NUMTOT
 9031 FORMAT('NUMDIG,NUMTOT = ',2I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMDIG.LE.0)GOTO9037
      DO9035I=1,NUMDIG
      WRITE(ICOUT,9036)I,IDIGIT(I)
 9036 FORMAT('I,IDIGIT(I) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9035 CONTINUE
 9037 CONTINUE
      WRITE(ICOUT,9041)NCSTR
 9041 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO9047
      DO9045I=1,NCSTR
      WRITE(ICOUT,9046)I,ICSTR(I:I)
 9046 FORMAT('I,ICSTR(I:I) = ',I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
 9045 CONTINUE
 9047 CONTINUE
      WRITE(ICOUT,9048)NCSOLD
 9048 FORMAT('NCSOLD = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9049)IBUGG4,ISUBG4,IERRG4
 9049 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRPG(IPATT,ISTRIN,NCSTRI)
C
C     PURPOSE--TRANSLATE A 1-WORD (4-CHARACTER) REPRESENTATION
C              FOR A MARKER INTO A MULTI-WORD REPRESENTATION
C              THAT SUBROUTINE DPSCR7 CAN UNDERSTAND.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 IPATT
      CHARACTER*4 ISTRIN
C
      CHARACTER*1 IC1
C
      DIMENSION ISTRIN(*)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRG4='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRPG')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRPG--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IPATT
   52 FORMAT('IPATT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGG4
   59 FORMAT('IBUGG4 = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      NCSTRI=0
      DO1100I=1,4
      ISTRIN(I)='    '
 1100 CONTINUE
C
      DO1200I=1,4
      IREV=4-I+1
      IC1=IPATT(IREV:IREV)
      IF(IC1.NE.' ')GOTO1250
 1200 CONTINUE
 1250 CONTINUE
      NCSTRI=IREV
      IF(NCSTRI.LE.0)NCSTRI=1
C
      DO1300I=1,NCSTRI
      ISTRIN(I)=IPATT(I:I)
 1300 CONTINUE
C
      IF(NCSTRI.LE.1)GOTO1490
      NCSTRI=NCSTRI+1
      ISTRIN(NCSTRI)='('
      NCSTRI=NCSTRI+1
      ISTRIN(NCSTRI)=')'
 1490 CONTINUE
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRPG')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRPG--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IPATT
 9012 FORMAT('IPATT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)NCSTRI
 9013 FORMAT('NCSTRI = ',I8)
      CALL DPWRST('XXX','BUG ')
      DO9015I=1,NCSTRI
      WRITE(ICOUT,9016)I,ISTRIN(I)
 9016 FORMAT('I,ISTRIN(I) = ',I8,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
      WRITE(ICOUT,9019)IBUGG4,ISUBG4,IERRG4
 9019 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRRE(X,NCHTOT,NCHDEC,ICSTR,NCSTR)
C
C     PURPOSE--TRANSLATE THE REAL (= FLOATING POINT) NUMBER X
C              INTO ITS CHARACTER EQUIVALENT.
C              NCHTOT = DESIRED NUMBER OF CHARACTERS FOR TOTAL NUMBER.
C              NCTDEC = DESIRED NUMBER OF CHARACTERS FOR DECIMAL PART OF NUMBER.
C              THE OUTPUT WILL CORRESPOND TO A FORTRAN F FORMAT.
C              AS IN    F NCHTOT.NCHDEC     FORMAT (E.G., F10.5).
C              THE OUTPUT WILL BE RIGHT-JUSTIFIED AS ONE
C              WOULD EXPECT FROM A F FORTRAN FLOATING POINT FORMAT.
C     NOTE--THE RESULTING TRANSLATED VALUES
C           WILL BE PLACED IN SPECIFIC ELEMENTS
C           OF THE A130 CHARACTER VARIABLE ICSTR.
C           THE VALUE OF THE VARIABLE    NCSTR
C           REPRESENTS THE NUMBER OF CHARACTERS IN ICSTR
C           THAT HAVE ALREADY BEEN FILLED.
C           THE RESULTING TRANSLATED VALUES WILL GO
C           (RIGHT-JUSTIFIED) INTO THE NEXT    NCHTOT
C           CHARACTERS OF ICSTR.
C           AND THE VALUE OF    NCSTR    WILL BE
C           UPDATED ACCORDINGLY, THAT IS,
C           NEW NCSTR = OLD NCSTR + NCHTOT
C     DANGER--NCSTR IS BOTH AN INPUT ARGUMENT
C             AND AN OUTPUT ARGUMENT OF THIS SUBROUTINE.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*130 ICSTR
C
      DIMENSION IINTDI(20)
      DIMENSION IDECDI(20)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IASC0=48
C
      IREV=(-999)
      IDIG=(-999)
C
      IERRG4='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRRE')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRRE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)X
   52 FORMAT('X = ',E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)NCHTOT
   53 FORMAT('NCHTOT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)NCSTR
   61 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO67
      DO65I=1,NCSTR
      WRITE(ICOUT,66)I,ICSTR(I:I)
   66 FORMAT('I,ICSTR(I:I) = ',I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
   65 CONTINUE
   67 CONTINUE
      WRITE(ICOUT,69)IBUGG4,ISUBG4,IERRG4
   69 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               ***********************************
C               **  STEP 1--                     **
C               **  SAVE THE OLD VALUE OF NCSTR  **
C               ***********************************
C
      NCSOLD=NCSTR
C
C
C               ********************************************
C               **  STEP 2--                              **
C               **  FILL THE NEXT   NCHTOT   ELEMENTS     **
C               **  IN ICSTR() WITH BLANKS.               **
C               **  UPDATE NCSTR BY NCSTR + NCHTOT.       **
C               ********************************************
C
      DO1200I=1,NCHTOT
      NCSTR=NCSTR+1
      ICSTR(NCSTR:NCSTR)=' '
 1200 CONTINUE
C
C               ********************************
C               **  STEP 3--                  **
C               **  STRIP OUT THE DIGITS      **
C               **  OF THE INTEGER PART       **
C               **  (IN RIGHT TO LEFT ORDER)  **
C               ********************************
C
      ITEN=10
C
      IX=X
      IABSIX=IABS(IX)
C
      IRESUL=IABSIX
      NUMIND=0
      DO1300I=1,20
      IDIVID=IRESUL
      IRESUL=IDIVID/ITEN
      IREM=IDIVID-IRESUL*ITEN
      NUMIND=NUMIND+1
      IINTDI(NUMIND)=IREM
      IF(IRESUL.EQ.0)GOTO1390
 1300 CONTINUE
 1390 CONTINUE
C
C               ********************************
C               **  STEP 4--                  **
C               **  STRIP OUT NCHDEC DIGITS   **
C               **  OF THE DECIMAL PART       **
C               **  (IN RIGHT TO LEFT ORDER)  **
C               ********************************
C
      ITEN=10
C
      AIABIX=IABSIX
      ABSX=ABS(X)
      DEC=AIABIX-ABSX
      IF(DEC.LT.0.0)DEC=0.0
      DEC=ABSX-AIABIX
      DEC2=DEC*(10.0**NCHDEC)
C
      IY=DEC2
      IABSIY=IABS(IY)
C
      IRESUL=IABSIY
      NUMDED=0
      IF(NCHDEC.LE.0)GOTO1490
      DO1400I=1,NCHDEC
      IDIVID=IRESUL
      IRESUL=IDIVID/ITEN
      IREM=IDIVID-IRESUL*ITEN
      NUMDED=NUMDED+1
      IDECDI(NUMDED)=IREM
 1400 CONTINUE
 1490 CONTINUE
C
C               *****************************************************
C               **   STEP 5--                                      **
C               **   CHECK TO SEE THAT TOTAL NUMBER OF CHARACTERS  **
C               **   (= NUMBER OF DIGITS + 1 IF IX >= 0, AND       **
C               **   = NUMBER OF DIGITS + 2 IF IX < 0)             **
C               **   IS LESS THAN OR EQUAL TO NCHTOT.              **
C               **   IF YES, THEN GO TO NEXT STEP.                 **
C               **   IF NO, THEN FILL THE NCHTOT ELEMENTS          **
C               **   WITH ASTERISKS                                **
C               *****************************************************
C
      NUMTOT=NUMIND+1+NUMDED
      IF(X.LT.0.0)NUMTOT=NUMTOT+1
C
      IF(NUMTOT.LE.NCHTOT)GOTO1590
      DO1500I=1,NCHTOT
      J=I+NCSOLD
      ICSTR(J:J)='*'
 1500 CONTINUE
      GOTO9000
 1590 CONTINUE
C
C               ****************************************
C               **  STEP 6--                          **
C               **  IF HAVE A VALID NUMBER OF DIGITS, **
C               **  TRANSLATE EACH DIGIT TO ITS       **
C               **  CHARACTER EQUIVALENT.             **
C               **  IN DOING SO, PLACE THE ASCII      **
C               **  CHARACTER EQUIVALENT              **
C               **  IN THE USUAL RIGHT-TO-LEFT ORDER  **
C               **  IN ICSTR(.).  IF IX < 0, INSERT   **
C               **  A MINUS BEFORE THE NUMBER.        **
C               **  HAVE THE CHARACTER STRING         **
C               **  RIGHT JUSTIFIED IN THE            **
C               **  NCHTOT ELEMENTS.                  **
C               ****************************************
C
      J=NCSOLD+(NCHTOT-NUMTOT)
      IF(X.LT.0.0)J=J+1
      IF(X.LT.0.0)ICSTR(J:J)='-'
C
      DO1610I=1,NUMIND
      IREV=NUMIND-I+1
      IDIG=IINTDI(IREV)
      J=J+1
      IASCDI=IDIG+IASC0
CCCCC ICSTR(J:J)=CHAR(IASCDI)
      CALL DPCONA(IASCDI,ICSTR(J:J))
 1610 CONTINUE
C
      J=J+1
      ICSTR(J:J)='.'
C
      DO1620I=1,NUMDED
      IREV=NUMDED-I+1
      IDIG=IDECDI(IREV)
      J=J+1
      IASCDI=IDIG+IASC0
CCCCC ICSTR(J:J)=CHAR(IASCDI)
      CALL DPCONA(IASCDI,ICSTR(J:J))
 1620 CONTINUE
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRRE')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRRE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)X
 9012 FORMAT('X = ',E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)NCHTOT,NCHDEC
 9013 FORMAT('NCHTOT,NCHDEC = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)NUMIND,NUMDED,NUMTOT
 9014 FORMAT('NUMIND,NUMDED,NUMTOT = ',3I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)IDIVID,IRESUL,IREM,NUMIND,IINTDI(NUMIND)
 9021 FORMAT('IDIVID,IRESUL,IREM,NUMIND,IINTDI(NUMIND) = ',5I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)IREV,NCSTR,IDIG,ICSTR(NCSTR:NCSTR)
 9022 FORMAT('IREV,NCSTR,IDIG,ICSTR(NCSTR:NCSTR) = ',3I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9023)IASC0,IX
 9023 FORMAT('IASC0,IX = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)NUMIND,NUMTOT
 9031 FORMAT('NUMIND,NUMTOT = ',2I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMIND.LE.0)GOTO9037
      DO9035I=1,NUMIND
      WRITE(ICOUT,9036)I,IINTDI(I)
 9036 FORMAT('I,IINTDI(I) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9035 CONTINUE
 9037 CONTINUE
      WRITE(ICOUT,9041)NUMDED,NUMTOT
 9041 FORMAT('NUMDED,NUMTOT = ',2I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMDED.LE.0)GOTO9047
      DO9045I=1,NUMDED
      WRITE(ICOUT,9046)I,IDECDI(I)
 9046 FORMAT('I,IDECDI(I) = ',2I8)
      CALL DPWRST('XXX','BUG ')
 9045 CONTINUE
 9047 CONTINUE
      WRITE(ICOUT,9051)NCSTR
 9051 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO9057
      DO9055I=1,NCSTR
      WRITE(ICOUT,9056)I,ICSTR(I:I)
 9056 FORMAT('I,ICSTR(I:I) = ',I8,2X,A1)
      CALL DPWRST('XXX','BUG ')
 9055 CONTINUE
 9057 CONTINUE
      WRITE(ICOUT,9058)NCSOLD
 9058 FORMAT('NCSOLD = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9059)IBUGG4,ISUBG4,IERRG4
 9059 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRRP(IPATTT,IHORPA,IVERPA,IDUPPA,IDDOPA)
C  MARCH, 1988: FOR EACH PAATTERN TYPE, SET IPATT TO A STANDARD
C               NAME.
C
C     PURPOSE--CONVERT A 1 WORD REPRESENTATION FOR THE PATTERN
C              (FOR A REGION)
C              INTO 4 SINGLE-WORD REPRESENTATIONS
C              BASED ON HORIZONTAL, VERTICAL,
C              DIAGONAL UP, AND DIAGONAL DOWN
C              COMPONENTS OF THE PATTERN.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 IPATTT
      CHARACTER*4 IHORPA
      CHARACTER*4 IVERPA
      CHARACTER*4 IDUPPA
      CHARACTER*4 IDDOPA
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRRP')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRRP--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IPATTT
   52 FORMAT('IPATTT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IBUGG4,ISUBG4,IERRG4
   59 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      IHORPA='OFF'
      IVERPA='OFF'
      IDUPPA='OFF'
      IDDOPA='OFF'
C
      IF(IPATTT.EQ.'    ')GOTO110
      IF(IPATTT.EQ.'BLAN')GOTO110
      IF(IPATTT.EQ.'NONE')GOTO110
      IF(IPATTT.EQ.'EMPT')GOTO110
C
      IF(IPATTT.EQ.'HORI')GOTO210
      IF(IPATTT.EQ.'H   ')GOTO210
      IF(IPATTT.EQ.'VERT')GOTO220
      IF(IPATTT.EQ.'V   ')GOTO220
      IF(IPATTT.EQ.'SOLI')GOTO220
      IF(IPATTT.EQ.'DU  ')GOTO230
      IF(IPATTT.EQ.'D1  ')GOTO230
      IF(IPATTT.EQ.'DD  ')GOTO240
      IF(IPATTT.EQ.'D2  ')GOTO240
C
      IF(IPATTT.EQ.'HV  ')GOTO310
      IF(IPATTT.EQ.'VH  ')GOTO310
      IF(IPATTT.EQ.'DUDD')GOTO320
      IF(IPATTT.EQ.'D1D2')GOTO320
      IF(IPATTT.EQ.'DDDU')GOTO320
      IF(IPATTT.EQ.'D2D1')GOTO320
C
      IF(IPATTT.EQ.'HDU ')GOTO410
      IF(IPATTT.EQ.'HD1 ')GOTO410
CCCCC OCTOBER 1992.  ADD FOLLOWING 2 LINES
      IF(IPATTT.EQ.'HOD1')GOTO410
      IF(IPATTT.EQ.'D1HO')GOTO410
      IF(IPATTT.EQ.'HDD ')GOTO420
      IF(IPATTT.EQ.'HD2 ')GOTO420
CCCCC OCTOBER 1992.  ADD FOLLOWING 4 LINES
      IF(IPATTT.EQ.'HOD2')GOTO420
      IF(IPATTT.EQ.'D2HO')GOTO420
      IF(IPATTT.EQ.'DDHO')GOTO420
      IF(IPATTT.EQ.'HODD')GOTO420
CCCCC OCTOBER 1992.  ADD FOLLOWING 6 LINES
      IF(IPATTT.EQ.'HO12')GOTO425
      IF(IPATTT.EQ.'12HO')GOTO425
      IF(IPATTT.EQ.'H12 ')GOTO425
      IF(IPATTT.EQ.'12H ')GOTO425
      IF(IPATTT.EQ.'HD12')GOTO425
      IF(IPATTT.EQ.'D12H')GOTO425
C
      IF(IPATTT.EQ.'VDU ')GOTO430
      IF(IPATTT.EQ.'VD1 ')GOTO430
CCCCC OCTOBER 1992.  ADD FOLLOWING 2 LINES
      IF(IPATTT.EQ.'VED1')GOTO430
      IF(IPATTT.EQ.'D1VE')GOTO430
      IF(IPATTT.EQ.'VDD ')GOTO440
CCCCC OCTOBER 1992.  ADD FOLLOWING 2 LINES
      IF(IPATTT.EQ.'VED2')GOTO440
      IF(IPATTT.EQ.'D2VE')GOTO440
CCCCC OCTOBER 1992.  ADD FOLLOWING 4 LINES
      IF(IPATTT.EQ.'VE12')GOTO445
      IF(IPATTT.EQ.'12VE')GOTO445
      IF(IPATTT.EQ.'V12 ')GOTO445
      IF(IPATTT.EQ.'12V ')GOTO445
      IF(IPATTT.EQ.'VD12')GOTO445
      IF(IPATTT.EQ.'D12V')GOTO445
C
      IF(IPATTT.EQ.'HVDU')GOTO510
      IF(IPATTT.EQ.'HVD1')GOTO510
      IF(IPATTT.EQ.'VHDU')GOTO510
      IF(IPATTT.EQ.'VHD1')GOTO510
      IF(IPATTT.EQ.'HVDD')GOTO520
      IF(IPATTT.EQ.'HVD2')GOTO520
      IF(IPATTT.EQ.'VHDD')GOTO520
      IF(IPATTT.EQ.'VHD2')GOTO520
CCCCC OCTOBER 1992.  ADD FOLLOWING LINES
      IF(IPATTT.EQ.'HV12')GOTO610
      IF(IPATTT.EQ.'12HV')GOTO610
C
      IF(IPATTT.EQ.'ALL')GOTO610
C
      GOTO9000
C
  110 CONTINUE
      IHORPA='OFF'
      IVERPA='OFF'
      IDUPPA='OFF'
      IDDOPA='OFF'
      IPATTT='EMPT'
      GOTO9000
C
  210 CONTINUE
      IHORPA='ON'
      IVERPA='OFF'
      IDUPPA='OFF'
      IDDOPA='OFF'
      IPATTT='HORI'
      GOTO9000
C
  220 CONTINUE
      IHORPA='OFF'
      IVERPA='ON'
      IDUPPA='OFF'
      IDDOPA='OFF'
      IF(IPATTT.EQ.'V')IPATTT='VERT'
      GOTO9000
C
  230 CONTINUE
      IHORPA='OFF'
      IVERPA='OFF'
      IDUPPA='ON'
      IDDOPA='OFF'
      IPATTT='D1'
      GOTO9000
C
  240 CONTINUE
      IHORPA='OFF'
      IVERPA='OFF'
      IDUPPA='OFF'
      IDDOPA='ON'
      IPATTT='D2'
      GOTO9000
C
  310 CONTINUE
      IHORPA='ON'
      IVERPA='ON'
      IDUPPA='OFF'
      IDDOPA='OFF'
      IPATTT='HV'
      GOTO9000
C
  320 CONTINUE
      IHORPA='OFF'
      IVERPA='OFF'
      IDUPPA='ON'
      IDDOPA='ON'
      IPATTT='D1D2'
      GOTO9000
C
  410 CONTINUE
      IHORPA='ON'
      IVERPA='OFF'
      IDUPPA='ON'
      IDDOPA='OFF'
      IPATTT='HD1'
      GOTO9000
C
  420 CONTINUE
      IHORPA='ON'
      IVERPA='OFF'
      IDUPPA='OFF'
      IDDOPA='ON'
      IPATTT='HD2'
      GOTO9000
C
CCCCC OCTOBER 1992.  ADD FOLLOWING BLOCK OF CODE
  425 CONTINUE
      IHORPA='ON'
      IVERPA='OFF'
      IDUPPA='ON'
      IDDOPA='ON'
      IPATTT='HD12'
      GOTO9000
C
  430 CONTINUE
      IHORPA='OFF'
      IVERPA='ON'
      IDUPPA='ON'
      IDDOPA='OFF'
      IPATTT='VD1'
      GOTO9000
C
  440 CONTINUE
      IHORPA='OFF'
      IVERPA='ON'
      IDUPPA='OFF'
      IDDOPA='ON'
      IPATTT='VD2'
      GOTO9000
C
CCCCC OCTOBER 1992.  ADD FOLLOWING BLOCK OF CODE
  445 CONTINUE
      IHORPA='OFF'
      IVERPA='ON'
      IDUPPA='ON'
      IDDOPA='ON'
      IPATTT='VD12'
      GOTO9000
C
  510 CONTINUE
      IHORPA='ON'
      IVERPA='ON'
      IDUPPA='ON'
      IDDOPA='OFF'
      IPATTT='HVD1'
      GOTO9000
C
  520 CONTINUE
      IHORPA='ON'
      IVERPA='ON'
      IDUPPA='OFF'
      IDDOPA='ON'
      IPATTT='HVD2'
      GOTO9000
C
  610 CONTINUE
      IHORPA='ON'
      IVERPA='ON'
      IDUPPA='ON'
      IDDOPA='ON'
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT.      **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRRP')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRRP--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IPATTT
 9012 FORMAT('IPATTT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IHORPA,IVERPA,IDUPPA,IDDOPA
 9013 FORMAT('IHORPA,IVERPA,IDUPPA,IDDOPA = ',A4,2X,A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9019)IBUGG4,ISUBG4,IERRG4
 9019 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRSA(PX1,PY1,AX1,AY1,ISUBN0)
C
C     THIS ROUTINE IS A MODIFIED VERSION OF GRTRSD.  IT IS USED
C     ONLY BY THE META FILE DEVICES (I.E., "GENERAL", "GENERAL CODED"
C     AND FOR FUTURE PURPOSES "CGM").  GRTRSA CONVERTS FROM DATAPLOT
C     UNITS TO DEVICE INTEGER UNITS, BUT IT ALSO APPLIES "WINDOW"
C     TRANSFORMATIONS NEEDED BY THE "MULTI-PLOT" AND "WINDOW
C     COORDINATE" COMMANDS.  THE METAFILE DOES NOT SUPPORT ANY
C     PARTICULAR NUMBER OF PICTURE POINTS.  IT DOES HOWEVER NEED
C     TO APPLY THE "WINDOW" TRANSFORMATIONS.
C
C     PURPOSE--TRANSLATE THE STANDARDIZED (0.0 TO 100.0) COORDINATES (PX1,PY1)
C              INTO (INTEGER PICTURE POINT) DEVICE COORDINATES (AX1,AY1)
C     ISUBN0 = NAME OF SUBROUTINE WHICH CALLED GRWRST.
C              (AND THEREBY HAVE WALKBACK INFORMATION).
C     NOTE--THE ONLY VARIABLES IN THE    PLOT CONTROL COMMON
C           THAT ARE USED HEREIN ARE THE ONES IN /RWIND/
C
C     WRITTEN BY--ALAN HECKERT
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2899
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--89.2
C     ORIGINAL VERSION--JANUARY   1989.
C     UPDATED         --APRIL     1992.  FIX SOME DEBUG STATEMENTS
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 ISUBN0
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCOPC.INC'
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRG4='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRSA')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRSA--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ISUBN0
   52 FORMAT('ISUBN0 (NAME OF THE CALLING SUBROUTINE) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IMANUF,IMODEL
   53 FORMAT('IMANUF,IMODEL = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)NUMHPP,NUMVPP
   54 FORMAT('NUMHPP,NUMVPP = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)ANUMHP,ANUMVP
   55 FORMAT('ANUMHP,ANUMVP = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)PX1,PY1
   56 FORMAT('PX1,PY1 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)PWXMIN,PWXMAX,PWYMIN,PWYMAX
   61 FORMAT('PWXMIN,PWXMAX,PWYMIN,PWYMAX = ',4E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,69)IBUGG4
   69 FORMAT('IBUGG4 = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               *************************************
C               **  STEP 1--                       **
C               **  CARRY OUT THE TRANSFORMATION.  **
C               *************************************
C
      AX1=PWXMIN+(PX1/100.0)*(PWXMAX-PWXMIN)
      IF(AX1.LE.0.0)AX1=0.0
      IF(AX1.GE.100.)AX1=100.
C
      AY1=PWYMIN+(PY1/100.0)*(PWYMAX-PWYMIN)
      IF(AY1.LE.0.0)AY1=0.0
      IF(AY1.GE.100.)AY1=100.
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRSA')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRSA--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IMANUF,IMODEL
 9012 FORMAT('IMANUF,IMODEL = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)NUMHPP,NUMVPP
 9013 FORMAT('NUMHPP,NUMVPP = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ANUMHP,ANUMVP
 9014 FORMAT('ANUMHP,ANUMVP = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)PX1,PY1
 9015 FORMAT('PX1,PY1   = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
CCCCC THE FOLLOWING 4 LINES WERE COMMENTED OUT   APRIL 1992
CCCCC WRITE(ICOUT,9016)PWX1,PWY1
C9016 FORMAT('PWX1,PWY1 = ',E15.7,E15.7)
CCCCC CALL DPWRST('XXX','BUG ')
CCCCC WRITE(ICOUT,9017)X1,Y1
C9017 FORMAT('X1,Y1     = ',E15.7,E15.7)
CCCCC CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)AX1,AY1
 9018 FORMAT('AX1,AY1   = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)PWXMIN,PWXMAX,PWYMIN,PWYMAX
 9021 FORMAT('PWXMIN,PWXMAX,PWYMIN,PWYMAX = ',4E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9029)IBUGG4,ISUBG4,IERRG4
 9029 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
 
      SUBROUTINE GRTRSD(PX1,PY1,IX1,IY1,ISUBN0)
C
C     PURPOSE--TRANSLATE THE STANDARDIZED (0.0 TO 100.0) COORDINATES (PX1,PY1)
C              INTO (INTEGER PICTURE POINT) DEVICE COORDINATES (IX1,IY1)
C     ISUBN0 = NAME OF SUBROUTINE WHICH CALLED GRWRST.
C              (AND THEREBY HAVE WALKBACK INFORMATION).
C     NOTE--THE ONLY VARIABLES IN THE    PLOT CONTROL COMMON
C           THAT ARE USED HEREIN ARE THE ONES IN /RWIND/
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     UPDATED   --MARCH     1990. PATCH FOR X11, USE OFFSET VARIABLES
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C     UPDATED--SEPTEMBER 1986.
C     UPDATED--MAY 1990.    FOR X11, USE OFFSET VARIABLES
C     UPDATED--JUNE   1990. FIXED BUG WHEN USING OFFSETS
C     UPDATED--OCTOBER 1996.  SUPPORT MICROSOFT QWIN DRIVER
C     UPDATED--OCTOBER 1996.  SUPPORT MICROSOFT QWIN DRIVER
C     UPDATED--MARCH   2002.  SUPPORT SVG DRIVER
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 ISUBN0
C
C-----COMMON----------------------------------------------------------
C
CCCCC THE FOLLOWING LINE WAS INSERTED MARCH 1989
      INCLUDE 'DPCOPA.INC'
C
      INCLUDE 'DPCOPC.INC'
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRG4='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRSD')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRSD--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)ISUBN0
   52 FORMAT('ISUBN0 (NAME OF THE CALLING SUBROUTINE) = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)IMANUF,IMODEL
   53 FORMAT('IMANUF,IMODEL = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)NUMHPP,NUMVPP
   54 FORMAT('NUMHPP,NUMVPP = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)ANUMHP,ANUMVP
   55 FORMAT('ANUMHP,ANUMVP = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)PX1,PY1
   56 FORMAT('PX1,PY1 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)PWXMIN,PWXMAX,PWYMIN,PWYMAX
   61 FORMAT('PWXMIN,PWXMAX,PWYMIN,PWYMAX = ',4E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,69)IBUGG4
   69 FORMAT('IBUGG4 = ',A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               *************************************
C               **  STEP 1--                       **
C               **  CARRY OUT THE TRANSFORMATION.  **
C               *************************************
C
CCCCC X1=(PX1/100.0)*ANUMHP
      PWX1=PWXMIN+(PX1/100.0)*(PWXMAX-PWXMIN)
      X1=(PWX1/100.0)*ANUMHP
      IX1=X1+0.5
CCCCC FOLLOWING LINE ADDED MARCH, 1990
      IX1=IX1+IOFFSH
      IF(IX1.LE.0)IX1=0
CCCCC JUNE, 1990.  FOLLOWING LINE MODIFIED.  NEED TO ACCOUNT FOR OFFSET
CCCCC WHEN TEST FOR MAXIMUM POINT.
CCCCC IF(IX1.GE.NUMHPP)IX1=NUMHPP-1
      ITEMP=NUMHPP+IOFFSH
      IF(IX1.GE.ITEMP)IX1=ITEMP-1
C
CCCCC Y1=(PY1/100.0)*ANUMVP
CCCCC NEED TO MODIFY FOLLOWING LINE FOR QWIN DRIVER SINCE IT MEASURES
CCCCC FROM TOP TO BOTTOM.  OCTOBER 1996.
      IF(IMANUF.EQ.'QWIN')THEN
        PWYMNT=100.0-PWYMIN
        PWYMXT=100.0-PWYMAX
        PWY1=PWYMNT+(PY1/100.0)*(PWYMXT-PWYMNT)
      ELSE
        PWY1=PWYMIN+(PY1/100.0)*(PWYMAX-PWYMIN)
      ENDIF
      Y1=(PWY1/100.0)*ANUMVP
      IY1=Y1+0.5
CCCCC FOLLOWING LINE ADDED MARCH, 1990
      IY1=IY1+IOFFSV
CCCCC IF(IMANUF.EQ.'REGI')IY1=NUMVPP-1-IY1
C  ABOVE LINE MODIFIED FOR X11 DRIVER MARCH, 1990.
C  ABOVE LINE MODIFIED FOR QWIN DRIVER OCTOBER 1996
CCCCC SAME MODIFICATION FOR PNG, JPG (GD) DEVICE  FEBRUARY 2001
CCCCC SAME MODIFICATION FOR SVG DEVICE  MARCH 2002
CCCCC IF(IMANUF.EQ.'REGI'.OR.IMANUF.EQ.'X11 '.OR.IMANUF.EQ.'QWIN')
CCCCC IF(IMANUF.EQ.'REGI'.OR.IMANUF.EQ.'X11 ')
      IF(IMANUF.EQ.'REGI'.OR.IMANUF.EQ.'X11 '.OR.IMANUF.EQ.'GD'.OR.
     &   IMANUF.EQ.'SVG')
     &IY1=NUMVPP-1-IY1
      IF(IY1.LE.0)IY1=0
CCCCC JUNE, 1990 FOR OFFSET.
CCCCC IF(IY1.GE.NUMVPP)IY1=NUMVPP-1
      ITEMP=NUMVPP+IOFFSV
      IF(IY1.GE.ITEMP)IY1=ITEMP-1
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRSD')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRSD--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IMANUF,IMODEL
 9012 FORMAT('IMANUF,IMODEL = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)NUMHPP,NUMVPP
 9013 FORMAT('NUMHPP,NUMVPP = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)ANUMHP,ANUMVP
 9014 FORMAT('ANUMHP,ANUMVP = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)PX1,PY1
 9015 FORMAT('PX1,PY1   = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)PWX1,PWY1
 9016 FORMAT('PWX1,PWY1 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)X1,Y1
 9017 FORMAT('X1,Y1     = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9018)IX1,IY1
 9018 FORMAT('IX1,IY1   = ',I8,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)PWXMIN,PWXMAX,PWYMIN,PWYMAX
 9021 FORMAT('PWXMIN,PWXMAX,PWYMIN,PWYMAX = ',4E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9029)IBUGG4,ISUBG4,IERRG4
 9029 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRST(ICSTR,NCSTR,
     1ICTRA1,NCTRA1,ICTRA2,NCTRA2,NUMTRA,
     1IBUGG4,ISUBG4,IERRG4)
C
C     PURPOSE--APPLY VARIOUS USER-DEFINED
C              TRANSLATIONS
C              TO EACH OUTPUT GRAPHICS LINE (CHARACTER*130)
C              SO AS TO CREATE A NEW OUTPUT GRAPHICS LINE.
C     EXAMPLE--CHANGE ESC FF TO ESC ESC FF
C              SO AS TO CIRCUMVENT SOME NETWORKS
C              "EATING UP" ESCAPES.
C     CAUTION--THE INPUT ARGUMENTS ICSTR AND NCSTR
C              ARE CHANGED WITHIN THIS SUBROUTINE
C              AND THUS ARE ALSO OUTPUT ARGUMENTS.
C     CAUTION--ICSTR IS CHARACTER*130--NOT CHARACTER*132.
C              THE SAME IS TRUE FOR ICSTR2.
C     NOTE--EVERY OCCURRANCE (NOT JUST THE FIRST
C           OCCURRANCE) WILL BE TRANSLATED ON THE
C           INPUT LINE.
C     WRITTEN BY--JAMES J. FILLIBEN
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--86.6
C     ORIGINAL VERSION--MARCH 1986.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*130 ICSTR
      CHARACTER*30 ICTRA1
      CHARACTER*30 ICTRA2
C
      CHARACTER*4 IBUGG4
      CHARACTER*4 ISUBG4
      CHARACTER*4 IERRG4
C
      CHARACTER*30 ICS1
      CHARACTER*30 ICS2
      CHARACTER*130 ICSTR2
C
      CHARACTER*4 IFOUST
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
CCCCC CHARACTER*4 ISTEPN
C
      DIMENSION ICTRA1(*)
      DIMENSION NCTRA1(*)
      DIMENSION ICTRA2(*)
      DIMENSION NCTRA2(*)
C
C-----COMMON----------------------------------------------------------
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      ISUBN1='GRTR'
      ISUBN2='ST  '
C
      IERRG4='NO'
      IFOUST='NO'
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRST')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGG4,ISUBG4,IERRG4
   52 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)NCSTR
   61 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,62)(ICSTR(I:I),I=1,100)
   62 FORMAT('ICSTR(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,71)NUMTRA
   71 FORMAT('NUMTRA = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMTRA.LE.0)GOTO79
      DO72ITRA=1,NUMTRA
      WRITE(ICOUT,73)ITRA,NCTRA1(ITRA),ICTRA1(ITRA)
   73 FORMAT('ITRA,NCTRA1(ITRA),ICTRA1(ITRA) = ',I8,I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
   72 CONTINUE
      DO75ITRA=1,NUMTRA
      WRITE(ICOUT,76)ITRA,NCTRA2(ITRA),ICTRA2(ITRA)
   76 FORMAT('ITRA,NCTRA2(ITRA),ICTRA2(ITRA) = ',I8,I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
   75 CONTINUE
   79 CONTINUE
   90 CONTINUE
C
C               ***********************************
C               **  STEP 11--                    **
C               **  LOOP THROUGH EACH ELEMENT    **
C               **  IN THE TRANSLATION TABLE.    **
C               ***********************************
C
      IF(NUMTRA.LE.0)GOTO1190
      DO1100ITRA=1,NUMTRA
C
C               ***********************************
C               **  STEP 12--                    **
C               **  FOR THIS GIVEN ELEMENT       **
C               **  IN THE TRANSLATION TABLE,    **
C               **  EXTRACT THE "OLD" SUBSTRING  **
C               ***********************************
C
      NCS1=NCTRA1(ITRA)
      ICS1=ICTRA1(ITRA)
C
C               ***********************************
C               **  STEP 13--                    **
C               **  FOR THIS GIVEN ELEMENT       **
C               **  IN THE TRANSLATION TABLE,    **
C               **  EXTRACT THE "NEW" SUBSTRING  **
C               ***********************************
C
      NCS2=NCTRA2(ITRA)
      ICS2=ICTRA2(ITRA)
C
C               **************************************
C               **  STEP 14--                       **
C               **  APPLY THE DESIRED CHANGE        **
C               **  TO EVERY OCCUURANCE OF THE      **
C               **  OLD STRING IN THE TARGET LINE;  **
C               **  THUS CREATE A NEW LINE.         **
C               **************************************
C
      CALL GRTRS2(ICS1,NCS1,ICS2,NCS2,
     1ICSTR,NCSTR,ICSTR2,NCSTR2,IFOUST,
     1IBUGG4,ISUBG4,IERRG4)
C
C               ******************************************
C               **  STEP 15--                           **
C               **  COPY THE NEWLY-CREATED LINE         **
C               **  BACK ONTO THE ORIGINAL LINE.        **
C               ******************************************
C
      IF(IFOUST.EQ.'NO')GOTO1590
      NCSTR=NCSTR2
      ICSTR=ICSTR2
 1590 CONTINUE
C
C               ***********************************
C               **  STEP 16--                    **
C               **  FINISH THE LOOP              **
C               **  SO AS TO MOVE ONTO THE       **
C               **  NEXT ELEMENT                 **
C               **  OF THE TRANSLATION TABLE,    **
C               ***********************************
 
 1100 CONTINUE
 1190 CONTINUE
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRST')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRST--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGG4,ISUBG4,IERRG4
 9012 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)NCSTR
 9021 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)(ICSTR(I:I),I=1,100)
 9022 FORMAT('ICSTR(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)NUMTRA
 9031 FORMAT('NUMTRA = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NUMTRA.LE.0)GOTO9039
      DO9032ITRA=1,NUMTRA
      WRITE(ICOUT,9033)ITRA,NCTRA1(ITRA),ICTRA1(ITRA)
 9033 FORMAT('ITRA,NCTRA1(ITRA),ICTRA1(ITRA) = ',I8,I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
 9032 CONTINUE
      DO9035ITRA=1,NUMTRA
      WRITE(ICOUT,9036)ITRA,NCTRA2(ITRA),ICTRA2(ITRA)
 9036 FORMAT('ITRA,NCTRA2(ITRA),ICTRA2(ITRA) = ',I8,I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9041)NCSTR2
 9041 FORMAT('NCSTR2 = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9042)(ICSTR2(I:I),I=1,100)
 9042 FORMAT('ICSTR2(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
 9035 CONTINUE
 9039 CONTINUE
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRS2(ICS1,NCS1,ICS2,NCS2,
     1ICSTR,NUMCST,ICSTR2,NUMCS2,IFOUST,
     1IBUGG4,ISUBG4,IERRG4)
C
C     PURPOSE--APPLY A SINGLE USER-DEFINED
C              TRANSLATION
C              TO EACH OUTPUT GRAPHICS LINE
C              SO AS TO CREATE A NEW OUTPUT GRAPHICS LINE.
C              IN PARTICULAR, SCAN ICSTR(.) (CHARACTER*130)
C              FOR EVERY OCCURRANCE
C              OF THE STRING IN ICS1(.).
C              IF FOUND, THEN FORM THE NEW LINE ICSTR2(.)
C              WHICH IS THE SAME AS ICSTR(.) EXCEPT
C              EVERY ICS1(.) HAS BEEN CHANGED TO ICS2(.).
C              IF NOT FOUND, THEN ICSTR2(.) = ICSTR(.)
C     EXAMPLE--CHANGE ESC FF TO ESC ESC FF
C              SO AS TO CIRCUMVENT SOME NETWORKS
C              "EATING UP" ESCAPES.
C     CAUTION--ICSTR IS CHARACTER*130--NOT CHARACTER*132.
C              THE SAME IS TRUE FOR ICSTR2.
C     WRITTEN BY--JAMES J. FILLIBEN
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--86.6
C     ORIGINAL VERSION--MARCH 1986.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*30 ICS1
      CHARACTER*30 ICS2
      CHARACTER*130 ICSTR
      CHARACTER*130 ICSTR2
C
      CHARACTER*4 IFOUST
C
      CHARACTER*4 IBUGG4
      CHARACTER*4 ISUBG4
      CHARACTER*4 IERRG4
C
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
CCCCC CHARACTER*4 ISTEPN
C
C-----COMMON----------------------------------------------------------
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      ISUBN1='GRTR'
      ISUBN2='S2  '
C
      IERRG4='NO'
      IFOUST='NO'
C
      ICLIM1=1
      ICLIM2=130
C
      JPIM1=(-999)
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRS2')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRS2--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,52)IBUGG4,ISUBG4,IERRG4
   52 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)NUMCST
   61 FORMAT('NUMCST = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,62)(ICSTR(I:I),I=1,100)
   62 FORMAT('ICSTR(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,71)NCS1,ICS1
   71 FORMAT('NCS1,ICS1 = ',I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,72)NCS2,ICS2
   72 FORMAT('NCS2,ICS2 = ',I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,81)NUMCS2
   81 FORMAT('NUMCS2 = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,82)(ICSTR2(I:I),I=1,100)
   82 FORMAT('ICSTR2(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               *****************************
C               **  STEP 11--              **
C               **  COPY THE OLD LINE      **
C               **  TO THE NEW LINE.       **
C               *****************************
C
      NUMCS2=NUMCST
      ICSTR2=ICSTR
C
C               *******************************
C               **  STEP 21--                **
C               **  TREAT THE CASE WHEN      **
C               **  STRING 1 IS NULL         **
C               **  (THAT IS, NCS1 <=  0)  **
C               *******************************
C
      IF(NCS1.LE.0)GOTO2100
      GOTO2900
C
 2100 CONTINUE
CCCCC WRITE(ICOUT,774)J,K,NUMCST,JPIM1,NCS1,L,IMIN,IMAX
CC774 FORMAT('FROM 2100--J,K,NUMCST,JPIM1,NCS1,L,IMIN,IMAX = ',8I8)
CCCCC CALL DPWRST('XXX','BUG ')
      IFOUST='YES'
C
C     STEP 21.1--COPY STRING 2 TO THE BEGINNING OF LINE 1
C
      K=0
C
      IMIN=ICLIM1
      IMAX=ICLIM1+NCS2-1
      IF(IMIN.GT.IMAX)GOTO2129
      L=0
      DO2120I=IMIN,IMAX
      K=K+1
      L=L+1
      ICSTR2(K:K)=ICS2(L:L)
CCCCC WRITE(ICOUT,777)I,K,ICSTR2(K:K),IMIN,IMAX
CCCCC CALL DPWRST('XXX','BUG ')
 2120 CONTINUE
 2129 CONTINUE
C
C     STEP 21.2--PUSH (COPY) THE OLD LINE TO THE RIGHT
C
      IMIN=ICLIM1+NCS2
      IMAX=ICLIM2
      IF(IMIN.GT.IMAX)GOTO2139
      DO2130I=IMIN,IMAX
      I2=I-NCS2
      IF(I2.GT.NUMCST)GOTO2139
      K=K+1
      ICSTR2(K:K)=ICSTR(I2:I2)
CCCCC WRITE(ICOUT,777)I,K,ICSTR2(K:K),IMIN,IMAX
CCCCC CALL DPWRST('XXX','BUG ')
 2130 CONTINUE
 2139 CONTINUE
C
      NUMCS2=K
      GOTO9000
C
 2900 CONTINUE
C
C               **********************************
C               **  STEP 31--                   **
C               **  TREAT THE CASE WHEN         **
C               **  THE OLD STRING IS NON-NULL  **
C               **  (THAT IS, NCS1 >= 1)      **
C               **********************************
C
      J=0
      K=0
 3100 CONTINUE
CCCCC WRITE(ICOUT,776)
CC776 FORMAT('-------------------------------')
CCCCC CALL DPWRST('XXX','BUG ')
CCCCC WRITE(ICOUT,780)J,K,NUMCST,JPIM1,NCS1
CC780 FORMAT('AFTER 3100--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
      J=J+1
      IF(J.GT.NUMCST)GOTO3900
      IF(J.GT.ICLIM2)GOTO3900
C
      IF(J.LT.ICLIM1)GOTO3210
      DO3200I=1,NCS1
      JPIM1=J+(I-1)
CCCCC IF(ICS1(I).EQ.IMASK)GOTO3200
      IF(ICSTR(JPIM1:JPIM1).EQ.ICS1(I:I))GOTO3200
      GOTO3210
 3200 CONTINUE
CCCCC WRITE(ICOUT,781)J,K,NUMCST,JPIM1,NCS1
CC781 FORMAT('AFTER 3200 C--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
      GOTO3390
C
 3210 CONTINUE
CCCCC WRITE(ICOUT,779)J,K,NUMCST,JPIM1,NCS1
CC779 FORMAT('AFTER 3210--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
      K=K+1
      ICSTR2(K:K)=ICSTR(J:J)
      GOTO3100
C
 3390 CONTINUE
CCCCC WRITE(ICOUT,782)J,K,NUMCST,JPIM1,NCS1
CC782 FORMAT('AFTER 3390 C--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
C
      IFOUST='YES'
      IF(NCS2.LE.0)GOTO3350
      DO3300I=1,NCS2
      K=K+1
      ICSTR2(K:K)=ICS2(I:I)
 3300 CONTINUE
 3350 CONTINUE
CCCCC WRITE(ICOUT,783)J,K,NUMCST,JPIM1,NCS1
CC783 FORMAT('AFTER 3350 C--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
      J=JPIM1
      GOTO3100
C
 3400 CONTINUE
CCCCC WRITE(ICOUT,784)J,K,NUMCST,JPIM1,NCS1
CC784 FORMAT('AFTER 3400 C--J,K,NUMCST,JPIM1,NCS1 = ',5I8)
CCCCC CALL DPWRST('XXX','BUG ')
      J=J+1
      IF(J.GT.NUMCST)GOTO3900
      K=K+1
      ICSTR2(K:K)=ICSTR(J:J)
      GOTO3400
C
 3900 CONTINUE
      NUMCS2=K
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRS2')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRS2--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9012)IBUGG4,ISUBG4,IERRG4
 9012 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)NUMCST
 9021 FORMAT('NUMCST = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)(ICSTR(I:I),I=1,100)
 9022 FORMAT('ICSTR(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)NCS1,ICS1
 9031 FORMAT('NCS1,ICS1 = ',I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9032)NCS2,ICS2
 9032 FORMAT('NCS2,ICS2 = ',I8,2X,A30)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9041)NUMCS2
 9041 FORMAT('NUMCS2 = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9042)(ICSTR2(I:I),I=1,100)
 9042 FORMAT('ICSTR2(I:I) = ',100A1)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9051)ICLIM1,ICLIM2
 9051 FORMAT('ICLIM1,ICLIM2 = ',2I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9052)IFOUST
 9052 FORMAT('IFOUST = ',A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRTRTK(ICSTR,NCSTR)
C
C     PURPOSE--TRANSLATE 1 LINE OF TEKTRONIX 4014 ASCII DIRECTIVES
C              INTO A SERIES OF DUMMY FORTRAN CALLS BY WHICH
C              OTHER NON-TEKTRONIX GRAPHICS DEVICES MAY BE DRIVEN
C              (E.G., CALCOMP, HP, CHROMATICS, ETC.)
C     INPUT --ICSTR  = THE CHARACTER*130 STRING
C                      CONTAINING THE CONTROL STRING.
C             NCSTR  = THE NUMBER OF ELEMENTS IN ICSTR(.:.)
C                      TO BE PROCESSED.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--SEPTEMBER 1984.
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*130 ICSTR
C
      CHARACTER*1 ICTEXT
      CHARACTER*1 IC1
      CHARACTER*1 IC2
      CHARACTER*4 ILINTY
      CHARACTER*5 ICBYTE
      CHARACTER*4 IOP
C
      DIMENSION ICTEXT(130)
C
      DIMENSION X(100)
      DIMENSION Y(100)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCONP.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IERRG4='NO'
C
      ISIZE=(-999)
      ICBYTE='     '
      JP4=(-999)
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRTK')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRTRTK--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)NCSTR
   54 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO57
      DO55I=1,NCSTR
CCCCC IASCNE=ICHAR(ICSTR(I:I))
      CALL DPCOAN(ICSTR(I:I),IASCNE)
      WRITE(ICOUT,56)I,ICSTR(I:I),IASCNE
   56 FORMAT('I,ICSTR(I:I),IASCNE = ',I8,2X,A1,I8)
      CALL DPWRST('XXX','BUG ')
   55 CONTINUE
   57 CONTINUE
      WRITE(ICOUT,69)IBUGG4,ISUBG4,IERRG4
   69 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
      I=0
C
 1000 CONTINUE
      I=I+1
      IF(I.GT.NCSTR)GOTO9000
      IC1=ICSTR(I:I)
      IP1=I+1
      IC2=ICSTR(2:2)
C
      IF(IC1.EQ.IESCC.AND.IC2.EQ.IFFC)GOTO1100
C
      IF(IC1.EQ.ISYNC)GOTO1200
C
      IF(IC1.EQ.IESCC.AND.IC2.EQ.IBELC)GOTO1300
C
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'`')GOTO1400
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'a')GOTO1400
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'b')GOTO1400
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'c')GOTO1400
C
      IF(IC1.EQ.IESCC.AND.IC2.EQ.';')GOTO1500
      IF(IC1.EQ.IESCC.AND.IC2.EQ.':')GOTO1500
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'9')GOTO1500
      IF(IC1.EQ.IESCC.AND.IC2.EQ.'8')GOTO1500
C
      IF(IC1.EQ.IGSC)GOTO1600
C
      IF(IC1.EQ.IUSC)GOTO1700
C
      GOTO9000
C
C
C               ***********************************
C               **  STEP 1--                     **
C               **  TREAT THE ERASE SCREEN CASE  **
C               ***********************************
C
 1100 CONTINUE
CCCCC CALL ERASESCREEN
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1101)
 1101 FORMAT('ERASE SCREEN')
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
      I=I+1
      GOTO1000
C
C               *************************************
C               **  STEP 2--                       **
C               **  TREAT THE SEND NULL LINE CASE  **
C               *************************************
C
 1200 CONTINUE
      I1=I
      I2=I
      DO1210J=I,NCSTR
      IF(ICSTR(J:J).EQ.ISYNC)I2=J
      IF(ICSTR(J:J).EQ.ISYNC)GOTO1210
      GOTO1211
 1210 CONTINUE
 1211 CONTINUE
      NUMNUL=I2-I1+1
CCCCC CALL SENDNULLLINE(CONSISTING OF NUMNUL CHARACTERS)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1212)NUMNUL
 1212 FORMAT('SEND A NULL LINE CONSISTING OF ',I8,'CHARACTERS')
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
      I=I2
      GOTO1000
C
C               *****************
C               **  STEP 3--   **
C               **  RING BELL  **
C               *****************
C
 1300 CONTINUE
CCCCC CALL RINGBELL
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1301)
 1301 FORMAT('RING BELL')
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
      I=I+1
      GOTO1000
C
C               ************************************
C               **  STEP 4--                      **
C               **  TREAT THE SET LINE TYPE CASE  **
C               ************************************
C
C
 1400 CONTINUE
CCCCC IF(IC2.EQ.'`')CALL SETLINE(SOLID)
CCCCC IF(IC2.EQ.'a')CALL SETLINE(DOTTED)
CCCCC IF(IC2.EQ.'b')CALL SETLINE(DASHED)
CCCCC IF(IC2.EQ.'c')CALL SETLINE(DOT-DASHED)
      ILINTY='SOLI'
      IF(IC2.EQ.'`')ILINTY='SOLI'
      IF(IC2.EQ.'a')ILINTY='DOTT'
      IF(IC2.EQ.'b')ILINTY='DASH'
      IF(IC2.EQ.'c')ILINTY='DODA'
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1411)ILINTY
 1411 FORMAT('SET LINE TYPE TO ',A4)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
      I=I+1
      GOTO1000
C
C               *****************************************
C               **  STEP 5--                           **
C               **  TREAT THE SET CHARACTER SIZE CASE  **
C               *****************************************
C
 1500 CONTINUE
CCCCC IF(IC2.EQ.';')CALL SETCHARSIZE(SMALLEST)
CCCCC IF(IC2.EQ.':')CALL SETCHARSIZE(NEXTTOSMALLEST)
CCCCC IF(IC2.EQ.'9')CALL SETCHARSIZE(NEXTTOLARGEEST)
CCCCC IF(IC2.EQ.'8')CALL SETCHARSIZE(LARGEST)
      ICHASZ=1
      IF(IC2.EQ.';')ISIZE=1
      IF(IC2.EQ.':')ISIZE=2
      IF(IC2.EQ.'9')ISIZE=3
      IF(IC2.EQ.'8')ISIZE=4
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1511)ISIZE
 1511 FORMAT('SET CHARACTER SIZE TO ',I8)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
      I=I+1
      GOTO1000
C
C               **********************************************
C               **  STEP 6--                                **
C               **  TREAT THE GRAPHICS MODE MOVE/DRAW CASE  **
C               **********************************************
C
 1600 CONTINUE
      IOP='MOVE'
      IP1=I+1
      NPLOTP=0
      DO1610J=IP1,NCSTR,5
      JP4=J+4
      ICBYTE(1:5)=ICSTR(J:JP4)
CCCCC IB1=ICHAR(ICBYTE(1:1))
      CALL DPCOAN(ICBYTE(1:1),IB1)
CCCCC IB2=ICHAR(ICBYTE(2:2))
      CALL DPCOAN(ICBYTE(2:2),IB2)
CCCCC IB3=ICHAR(ICBYTE(3:3))
      CALL DPCOAN(ICBYTE(3:3),IB3)
CCCCC IB4=ICHAR(ICBYTE(4:4))
      CALL DPCOAN(ICBYTE(4:4),IB4)
CCCCC IB5=ICHAR(ICBYTE(5:5))
      CALL DPCOAN(ICBYTE(5:5),IB5)
C     A TEKTRONIX 4014 (ENHANCED GRAPHICS)
C     HAS A VISIBLE SCREEN CONSISTING OF
C     4096 HORIZONTAL PICTURE POINTS, AND
C     3124 VERTICAL PICTURE POINTS,
C     (WITH (0,0) AT THE BOTTOM LEFT), THEREFORE,
C     IXPP BELOW WILL RANGE FROM 0 TO 4095, AND
C     IYPP BELOW WILL RANGE FROM 0 TO 3123.
C     IXP BELOW WILL RANGE FROM 0 TO 1.
C     IYP BELOW WILL RANGE FROM 0 TO 1.
C
      IXPP=(IB4-32)*32+(IB5-64)
      IYPP=(IB1-32)*32+(IB3-96)
      IXPP=4*IXPP
      IYPP=4*IYPP
      XPP=IXPP
      YPP=IYPP
      XP=XPP/4095.
      YP=YPP/3123.
C
C     THE FOLLOWING SETTINGS ARE FOR A TYPICAL
C     ALPHANUMERIC TERMINAL SCREEN
C     (80 COLUMNS WIDE BY 24 ROWS DEEP
C     WITH (1,1) AT BOTTOM LEFT).
C
      XLEFT=1.00
      XRIGHT=80.00
      YBOT=1.00
      YTOP=24.00
C
      X2=(XLEFT-0.5)+((XRIGHT+0.5)-(XLEFT-0.5))*XP
      Y2=(YBOT-0.5)+((YTOP+0.5)-(YBOT-0.5))*YP
      IX2=X2+0.5
      IY2=Y2+0.5
C
CCCCC IF(IOP.EQ.'MOVE')CALL PENUP
CCCCC IF(IOP.EQ.'MOVE')CALL MOVETO(IX2,IY2)
CCCCC IF(IOP.EQ.'DRAW')CALL PENDOWN
CCCCC IF(IOP.EQ.'DRAW')CALL DRAWTO(IX2,IY2)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1IOP.EQ.'MOVE')WRITE(ICOUT,1611)IX2,IY2
 1611 FORMAT('PEN UP   AND MOVE TO ',I8,I8)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1IOP.EQ.'MOVE')CALL DPWRST('XXX','BUG ')
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1IOP.EQ.'MOVE')WRITE(ICOUT,1612)IX2,IY2
 1612 FORMAT('PEN DOWN AND DRAW TO ',I8,I8)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1IOP.EQ.'MOVE')CALL DPWRST('XXX','BUG ')
      IOP='DRAW'
      NPLOTP=NPLOTP+1
      X(NPLOTP)=IX2
      Y(NPLOTP)=IY2
 1610 CONTINUE
CCCCC IF(NPLOTP.GE.2)CALL PLOT(X,Y,NPLOTP)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1NPLOTP.GE.2)WRITE(ICOUT,1621)NPLOTP
 1621 FORMAT('PLOT',I8,' POINTS FROM 2 VECTORS X (HOR) ',
     1'AND Y (VER)')
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK'.AND.
     1NPLOTP.GE.2)CALL DPWRST('XXX','BUG ')
      DO1625J=1,NPLOTP
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')WRITE(ICOUT,1626)
     1J,X(J),Y(J)
 1626 FORMAT('      J,X(J),Y(J) = ',I8,2F15.7)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')CALL DPWRST('XXX','BUG ')
 1625 CONTINUE
C
      I=JP4
      GOTO1000
C
C               **********************************************************
C               **  STEP 7--                                            **
C               **  TREAT THE ALPHANUMERIC MODE WRITE TEXT STRING CASE  **
C               **********************************************************
C
 1700 CONTINUE
      IP1=I+1
      NCTEXT=0
      DO1710J=IP1,NCSTR
      IF(ICSTR(J:J).EQ.IGSC)GOTO1790
      ICTEXT(NCTEXT)=ICSTR(J:J)
      NCTEXT=NCTEXT+1
 1710 CONTINUE
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')
     1WRITE(ICOUT,1711)NCTEXT
 1711 FORMAT('WRITE THE ',I8,' TEXT STRING--',80A1)
      IF(IBUGG4.EQ.'ON'.OR.ISUBG4.EQ.'TRTK')
     1CALL DPWRST('XXX','BUG ')
CCCCC CALL WRITETEXT(ICTEXT,NCTEXT)
 1790 CONTINUE
      I=I+NCTEXT
      GOTO1000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'TRTK')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRTRTK--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)IGUNIT,IMANUF
 9013 FORMAT('IGUNIT,IMANUF = ',I8,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)NCSTR
 9014 FORMAT('NCSTR = ',I8)
      CALL DPWRST('XXX','BUG ')
      IF(NCSTR.LE.0)GOTO9017
      DO9015I=1,NCSTR
CCCCC IASCNE=ICHAR(ICSTR(I:I))
      CALL DPCOAN(ICSTR(I:I),IASCNE)
      WRITE(ICOUT,9016)I,ICSTR(I:I),IASCNE
 9016 FORMAT('I,ICSTR(I:I),IASCNE = ',I8,2X,A1,I8)
      CALL DPWRST('XXX','BUG ')
 9015 CONTINUE
 9017 CONTINUE
      WRITE(ICOUT,9029)IBUGG4,ISUBG4,IERRG4
 9029 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRWRTE(PX1,PY1,ICTEXT,NCTEXT,
     1IPATTT,IFONT,ICASE,IJUST,IDIR,ANGLE,IFILLT,ICOL,
     1JPATTT,JFONT,JCASE,JJUST,JDIR,ANGLE2,JFILLT,JCOL,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,PTHICK,
     1JSIZE,
     1JHEIG2,JWIDT2,JVEGA2,JHOGA2,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1JTHICK,PTHIC2,
     1PXLEC,PXLECG,PYLEC,PYLECG,
     1ISYMBL,ISPAC,
     1IMPSW2,AMPSCH,AMPSCW,
     1PX99,PY99)
C
C     PURPOSE--FOR A SPECIFIC GRAPHICS DEVICE,
C              GO TO THE POINT (PX1,PY1) AND WRITE
C              OUT THE TEXT STRING CONTAINED IN THE
C              CHARACTER VECTOR ICTEXT(.),
C              WHICH CONSISTS OF    NCTEXT    CHARACTERS.
C     NOTE--PX1 AND PY1 ARE IN STANDARDIZED COORDINATES
C           THAT IS, EACH IS 0.0 TO 100.0.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C     UPDATED--JULY        1996. FORCE LAHEY DEVICE TO SOFTWARE CHAR.
C     UPDATED--SEPTEMBER   1999. ARGUMENT LIST TO GRWRTG
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 ICTEXT
      CHARACTER*4 IPATTT
      CHARACTER*4 IFONT
      CHARACTER*4 ICASE
      CHARACTER*4 IJUST
      CHARACTER*4 IDIR
      CHARACTER*4 IFILLT
      CHARACTER*4 ICOL
C
      CHARACTER*4 ISYMBL
      CHARACTER*4 ISPAC
      CHARACTER*4 IMPSW2
C
      CHARACTER*4 IFONT2
C
      DIMENSION ICTEXT(*)
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C
C-----START POINT-----------------------------------------------------
C
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'WRTE')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRWRTE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)PX1,PY1
   53 FORMAT('PX1,  PY1   = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)PX99,PY99
   54 FORMAT('PX99,PY99 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)NCTEXT
   55 FORMAT('NCTEXT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)(ICTEXT(I),I=1,NCTEXT)
   56 FORMAT('(ICTEXT(I),I=1,NCTEXT) = ',25A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)JSIZE
   57 FORMAT('JSIZE = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IPATTT,JPATTT
   59 FORMAT('IPATTT,JPATTT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,60)IFONT,JFONT
   60 FORMAT('IFONT,JFONT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)ICASE,JCASE
   61 FORMAT('ICASE,JCASE = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,62)IJUST,JJUST
   62 FORMAT('IJUST,JJUST= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,63)IDIR,JDIR
   63 FORMAT('IDIR,JDIR= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,64)ANGLE,ANGLE2
   64 FORMAT('ANGLE,ANGLE2= ',2E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,65)IFILLT,JFILLT
   65 FORMAT('IFILLT,JFILLT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,66)ICOL,JCOL
   66 FORMAT('ICOL,JCOL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,67)PHEIGH,JHEIG2,PHEIG2
   67 FORMAT('PHEIGH,JHEIG2,PHEIG2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,68)PWIDTH,JWIDT2,PWIDT2
   68 FORMAT('PWIDTH,JWIDT2,PWIDT2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,69)PVEGAP,JVEGA2,PVEGA2
   69 FORMAT('PVEGAP,JVEGA2,PVEGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,70)PHOGAP,JHOGA2,PHOGA2
   70 FORMAT('PHOGAP,JHOGA2,PHOGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,71)PTHICK,JTHICK,PTHIC2
   71 FORMAT('PTHICK,JTHICK,PTHIC2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,73)PXLEC,PXLECG
   73 FORMAT('PXLEC,PXLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,74)PYLEC,PYLECG
   74 FORMAT('PYLEC,PYLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,75)ISYMBL,ISPAC
   75 FORMAT('ISYMBL,ISPAC = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,79)IBUGG4,ISUBG4,IERRG4
   79 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               ********************************************
C               **  STEP 1--                              **
C               **  BRANCH ACCORDING TO THE DIRECTION     **
C               **  AND THE FONT                          **
C               ********************************************
C
CCCCC FOLLOWING SECTION MODIFIED JULY 1996.
      IF(IGFONT.EQ.'OFF')THEN
        IF(IFONT.NE.'TEKT')GOTO1300
        IF(IDIR.EQ.'HORI')GOTO1100
        IF(IDIR.EQ.'VERT')GOTO1200
        GOTO1300
      ELSE
        IF(IGFONT.NE.'TEKT')GOTO1300
        IF(IDIR.EQ.'HORI')GOTO1100
        IF(IDIR.EQ.'VERT')GOTO1200
        GOTO1300
      ENDIF
C
C               **************************************
C               **  STEP 11--                       **
C               **  TREAT THE HORIZONTAL DIRECTION  **
C               **************************************
C
 1100 CONTINUE
      CALL GRWRTH(PX1,PY1,ICTEXT,NCTEXT,
     1IPATTT,IFONT,ICASE,IJUST,IDIR,ANGLE,IFILLT,ICOL,
     1JPATTT,JFONT,JCASE,JJUST,JDIR,ANGLE2,JFILLT,JCOL,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,PTHICK,
     1JSIZE,
     1JHEIG2,JWIDT2,JVEGA2,JHOGA2,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1JTHICK,PTHIC2,
     1PXLEC,PXLECG,PYLEC,PYLECG,
     1ISYMBL,ISPAC,
     1PX99,PY99)
      GOTO9000
C
C               ************************************
C               **  STEP 12--                     **
C               **  TREAT THE VERTICAL DIRECTION  **
C               ************************************
C
 1200 CONTINUE
      CALL GRWRTV(PX1,PY1,ICTEXT,NCTEXT,
     1IPATTT,IFONT,ICASE,IJUST,IDIR,ANGLE,IFILLT,ICOL,
     1JPATTT,JFONT,JCASE,JJUST,JDIR,ANGLE2,JFILLT,JCOL,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,PTHICK,
     1JSIZE,
     1JHEIG2,JWIDT2,JVEGA2,JHOGA2,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1JTHICK,PTHIC2,
     1PXLEC,PXLECG,PYLEC,PYLECG,
     1ISYMBL,ISPAC,
     1PX99,PY99)
      GOTO9000
C
C               ************************************
C               **  STEP 13--                     **
C               **  TREAT THE GENERAL DIRECTION   **
C               ************************************
C
 1300 CONTINUE
      IFONT2=IFONT
      IF(IFONT.EQ.'TEKT')IFONT2='SIMP'
      CALL GRWRTG(PX1,PY1,ICTEXT,NCTEXT,
     1IPATTT,IFONT2,ICASE,IJUST,IDIR,ANGLE,IFILLT,ICOL,
     1JPATTT,JFONT,JCASE,JJUST,JDIR,ANGLE2,JFILLT,JCOL,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,PTHICK,
     1JSIZE,
     1JHEIG2,JWIDT2,JVEGA2,JHOGA2,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1JTHICK,PTHIC2,
     1PXLEC,PXLECG,PYLEC,PYLECG,
     1ISYMBL,ISPAC,
     1IMPSW2,AMPSCH,AMPSCW,
     1PX99,PY99)
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'WRTE')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRWRTE--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)PX1,PY1
 9013 FORMAT('PX1,  PY1   = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)PX99,PY99
 9014 FORMAT('PX99,PY99 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)NCTEXT
 9015 FORMAT('NCTEXT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)(ICTEXT(I),I=1,NCTEXT)
 9016 FORMAT('(ICTEXT(I),I=1,NCTEXT) = ',25A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)JSIZE
 9017 FORMAT('JSIZE = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9019)IPATTT,JPATTT
 9019 FORMAT('IPATTT,JPATTT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9020)IFONT,JFONT
 9020 FORMAT('IFONT,JFONT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)ICASE,JCASE
 9021 FORMAT('ICASE,JCASE= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)IJUST,JJUST
 9022 FORMAT('IJUST,JJUST= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9023)IDIR,JDIR
 9023 FORMAT('IDIR,JDIR= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9024)ANGLE,ANGLE2
 9024 FORMAT('ANGLE,ANGLE2= ',2E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9025)IFILLT,JFILLT
 9025 FORMAT('IFILLT,JFILLT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9026)ICOL,JCOL
 9026 FORMAT('ICOL,JCOL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9027)PHEIGH,JHEIG2,PHEIG2
 9027 FORMAT('PHEIGH,JHEIG2,PHEIG2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9028)PWIDTH,JWIDT2,PWIDT2
 9028 FORMAT('PWIDTH,JWIDT2,PWIDT2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9029)PVEGAP,JVEGA2,PVEGA2
 9029 FORMAT('PVEGAP,JVEGA2,PVEGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9030)PHOGAP,JHOGA2,PHOGA2
 9030 FORMAT('PHOGAP,JHOGA2,PHOGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)PTHICK,JTHICK,PTHIC2
 9031 FORMAT('PTHICK,JTHICK,PTHIC2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9033)PXLEC,PXLECG
 9033 FORMAT('PXLEC,PXLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9034)PYLEC,PYLECG
 9034 FORMAT('PYLEC,PYLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9035)ISYMBL,ISPAC
 9035 FORMAT('ISYMBL,ISPAC = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9039)IBUGG4,ISUBG4,IERRG4
 9039 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRWRTG(PX1,PY1,ICTEXT,NCTEXT,
     1IPATT,IFONT,ICASE,IJUST,IDIR,ANGLE,IFILL,ICOL,
     1JPATT,JFONT,JCASE,JJUST,JDIR,ANGLE2,JFILL,JCOL,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,PTHICK,
     1JSIZE,
     1JHEIG2,JWIDT2,JVEGA2,JHOGA2,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1JTHICK,PTHIC2,
     1PXLEC,PXLECG,PYLEC,PYLECG,
     1ISYMBL,ISPAC,
     1IMPSW2,AMPSCH,AMPSCW,
     1PX99,PY99)
C
C     PURPOSE--FOR A SPECIFIC GRAPHICS DEVICE,
C              AND FOR A GENERAL (SOFTWARE-GENERATED HERSHEY) FONT,
C              GO TO THE POINT (PX1,PY1) AND WRITE OUT
C              THE TEXT STRING
C              (IN A GENERAL DIRECTION)
C              CONTAINED IN THE
C              CHARACTER VECTOR ICTEXT(.),
C              WHICH CONSISTS OF NCTEXT CHARACTERS.
C     NOTE--PX1 AND PY1 ARE IN STANDARDIZED COORDINATES
C           THAT IS, EACH IS 0.0 TO 100.0.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-921-3651
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--83.6
C     ORIGINAL VERSION (AS A SEPARATE SUBROUTINE)--MAY       1983.
C     UPDATED         --SEPTEMBER1997. SUPPORT MULTIPLOT SCALE FACTOR
C
C-----NON-COMMON VARIABLES (GRAPHICS)-------------------------------------------
C
      CHARACTER*4 ICTEXT
C
      CHARACTER*4 IPATT
      CHARACTER*4 IFONT
      CHARACTER*4 ICASE
      CHARACTER*4 IJUST
      CHARACTER*4 IDIR
      CHARACTER*4 IFILL
      CHARACTER*4 ICOL
C
      CHARACTER*4 ISYMBL
      CHARACTER*4 ISPAC
      CHARACTER*4 IMPSW2
C
      CHARACTER*4 IFOUND
      CHARACTER*4 IBUGD2
      CHARACTER*4 IERROR
C  FOLLOWING LINE ADDED NOVEMBER 1994.
      CHARACTER*4 ISUBN0
C
      CHARACTER*4 ISTRIN
C
C  FOLLOWING LINE ADDED JANUARY 1988
C
      CHARACTER*130 ICSTR
C
      DIMENSION ICTEXT(*)
      DIMENSION ISTRIN(130)
C
C
C-----COMMON----------------------------------------------------------
C
      INCLUDE 'DPCOGR.INC'
      INCLUDE 'DPCOBE.INC'
      INCLUDE 'DPCOST.INC'
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C
C-----START POINT-----------------------------------------------------
C
CCCCC ADD FOLLOWING LINE NOVEMBER 1994.
      ISUBN0='WRTG'
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'WRTG')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF GRWRTG--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,53)PX1,PY1
   53 FORMAT('PX1,PY1 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,54)PX99,PY99
   54 FORMAT('PX99,PY99 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,55)NCTEXT
   55 FORMAT('NCTEXT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,56)(ICTEXT(I),I=1,NCTEXT)
   56 FORMAT('(ICTEXT(I),I=1,NCTEXT) = ',25A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,57)JSIZE
   57 FORMAT('JSIZE = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,59)IPATT
   59 FORMAT('IPATT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,60)IFONT,JFONT
   60 FORMAT('IFONT,JFONT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,61)ICASE,JCASE
   61 FORMAT('ICASE,JCASE = ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,62)IJUST,JJUST
   62 FORMAT('IJUST,JJUST= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,63)IDIR,JDIR
   63 FORMAT('IDIR,JDIR= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,64)ANGLE,ANGLE2
   64 FORMAT('ANGLE,ANGLE2= ',2E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,65)IFILL,JFILL
   65 FORMAT('IFILL,JFILL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,66)ICOL,JCOL
   66 FORMAT('ICOL,JCOL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,67)PHEIGH,JHEIG2,PHEIG2
   67 FORMAT('PHEIGH,JHEIG2,PHEIG2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,68)PWIDTH,JWIDT2,PWIDT2
   68 FORMAT('PWIDTH,JWIDT2,PWIDT2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,69)PVEGAP,JVEGA2,PVEGA2
   69 FORMAT('PVEGAP,JVEGA2,PVEGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,70)PHOGAP,JHOGA2,PHOGA2
   70 FORMAT('PHOGAP,JHOGA2,PHOGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,71)PTHICK,JTHICK,PTHIC2
   71 FORMAT('PTHICK,JTHICK,PTHIC2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,73)PXLEC,PXLECG
   73 FORMAT('PXLEC,PXLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,74)PYLEC,PYLECG
   74 FORMAT('PYLEC,PYLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,75)ISYMBL,ISPAC
   75 FORMAT('ISYMBL,ISPAC = ',A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,79)IBUGG4,ISUBG4,IERRG4
   79 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
   90 CONTINUE
C
C               ********************************************
C               **  STEP 1--                              **
C               **  BRANCH ACCORDING TO THE MANUFACTURER  **
C               **  AND THE MODEL                         **
C               ********************************************
C
      IF(IMANUF.EQ.'GENE')GOTO1030
      GOTO1100
C
C
 1030 CONTINUE
      IF(IFNTSW.EQ.'OFF')GOTO1100
      IF(IMODEL.EQ.'CODE')GOTO3200
      GOTO3100
C
C               *************************************************
C               **  STEP 11--                                  **
C               **  TREAT THE GENERAL MODEL                    **
C               **  (TEKTRONIX, HP, DEVICE-INDEPENDENT, ETC.)  **
C               *************************************************
C
 1100 CONTINUE
      NUMCHA=NCTEXT
      DO1110I=1,NUMCHA
      ISTRIN(I)=ICTEXT(I)
 1110 CONTINUE
      X0=PX1
      Y0=PY1
C
      HEIGHT=PHEIGH+PVEGAP
      WIDTH=PWIDTH+PHOGAP
C
      IBUGD2=IBUGG4
      HMAX=100.0
      VMAX=100.0
      AMAX=360.0
C
      CALL DPSCR7(ISTRIN,NUMCHA,X0,Y0,
     1IFONT,ICASE,IJUST,ANGLE,HMAX,VMAX,AMAX,WIDTH,HEIGHT,
     1PHEIGH,PWIDTH,PVEGAP,PHOGAP,
     1PHEIG2,PWIDT2,PVEGA2,PHOGA2,
     1ANUMHP,ANUMVP,
     1IPATT,PTHICK,ICOL,
     1JPATT,JTHICK,PTHIC2,JCOL,
     1ISYMBL,ISPAC,
     1IFILL,
     1IMPSW2,AMPSCH,AMPSCW,
     1PX99,PY99,IFOUND,IBUGD2,IERROR)
C
      GOTO9000
C
C               *****************************************************
C               **  FOR GENERAL DEVICE (AND "SET GENERAL FONT ON") **
C               **  LET POST PROCESSOR WRITE THE STRING IN  ONE OF **
C               **  ITS OWN FONTS. NOTE THAT THE DATAPLOT FONTS    **
C               **  WILL BE MAPPED TO THE POST PROCESSORS FONTS.   **
C               **  NOTE THAT IN THIS CASE, IT IS ASSUMMED THAT    **
C               **  THE POST PROCESSOR WILL ALSO SET THE "ANGLE"   **
C               **  AND THE JUSTIFICATION.                         **
C               *****************************************************
 3100 CONTINUE
      PX1P=PX1
      PY1P=PY1
      ICSTR(1:8)='MOVE TO '
      NCSTR=8
      NCHTOT=10
      NCHDEC=5
      CALL GRTRSA(PX1P,PY1P,AX,AY,ISUBN0)
      PX1P=AX
      PY1P=AY
      CALL GRTRRE(PX1P,NCHTOT,NCHDEC,ICSTR,NCSTR)
      ICSTR(19:20)='  '
      NCSTR=20
      CALL GRTRRE(PY1P,NCHTOT,NCHDEC,ICSTR,NCSTR)
      CALL GRWRST(ICSTR,NCSTR,ISUBN0)
      IF(NCTEXT.LE.0)GOTO3190
      ICSTR(1:11)='WRITE TEXT '
      NCSTR=11
      K=0
      DO3112J=1,NCTEXT
      K=J+NCSTR
      ICSTR(K:K)=ICTEXT(J)
 3112 CONTINUE
      NCSTR=K
      CALL GRWRST(ICSTR,NCSTR,ISUBN0)
 3190 CONTINUE
      GOTO9000
C
C               ***************************************************************
C               **  STEP 32--                                                **
C               **  TREAT THE CODED GENERAL (DEVICE-INDEPENDENT) CASE        **
C               ***************************************************************
C
 3200 CONTINUE
      PX1P=PX1
      PY1P=PY1
      ICSTR(1:5)='MOTO '
      NCSTR=5
      NCHTOT=10
      NCHDEC=5
      CALL GRTRRE(PX1P,NCHTOT,NCHDEC,ICSTR,NCSTR)
      ICSTR(16:17)='  '
      NCSTR=17
      CALL GRTRSA(PX1P,PY1P,AX,AY,ISUBN0)
      PX1P=AX
      PY1P=AY
      CALL GRTRRE(PY1P,NCHTOT,NCHDEC,ICSTR,NCSTR)
      CALL GRWRST(ICSTR,NCSTR,ISUBN0)
      IF(NCTEXT.LE.0)GOTO3290
      ICSTR(1:5)='WRTE '
      NCSTR=5
      K=0
      DO3212J=1,NCTEXT
      K=J+NCSTR
      ICSTR(K:K)=ICTEXT(J)
 3212 CONTINUE
      NCSTR=K
      CALL GRWRST(ICSTR,NCSTR,ISUBN0)
 3290 CONTINUE
      GOTO9000
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGG4.EQ.'OFF'.AND.ISUBG4.NE.'WRTG')GOTO9090
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF GRWRTG--')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9013)PX1,PY1
 9013 FORMAT('PX1,PY1 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9014)PX99,PY99
 9014 FORMAT('PX99,PY99 = ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9015)NCTEXT
 9015 FORMAT('NCTEXT = ',I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9016)(ICTEXT(I),I=1,NCTEXT)
 9016 FORMAT('(ICTEXT(I),I=1,NCTEXT) = ',25A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9017)JSIZE
 9017 FORMAT('JSIZE = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9019)IPATT
 9019 FORMAT('IPATT = ',A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9020)IFONT,JFONT
 9020 FORMAT('IFONT,JFONT= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9021)ICASE,JCASE
 9021 FORMAT('ICASE,JCASE= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9022)IJUST,JJUST
 9022 FORMAT('IJUST,JJUST= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9023)IDIR,JDIR
 9023 FORMAT('IDIR,JDIR= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9024)ANGLE,ANGLE2
 9024 FORMAT('ANGLE,ANGLE2= ',2E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9025)IFILL,JFILL
 9025 FORMAT('IFILL,JFILL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9026)ICOL,JCOL
 9026 FORMAT('ICOL,JCOL= ',A4,I8)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9027)PHEIGH,JHEIG2,PHEIG2
 9027 FORMAT('PHEIGH,JHEIG2,PHEIG2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9028)PWIDTH,JWIDT2,PWIDT2
 9028 FORMAT('PWIDTH,JWIDT2,PWIDT2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9029)PVEGAP,JVEGA2,PVEGA2
 9029 FORMAT('PVEGAP,JVEGA2,PVEGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9030)PHOGAP,JHOGA2,PHOGA2
 9030 FORMAT('PHOGAP,JHOGA2,PHOGA2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9031)PTHICK,JTHICK,PTHIC2
 9031 FORMAT('PTHICK,JTHICK,PTHIC2= ',E15.7,I8,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9033)PXLEC,PXLECG
 9033 FORMAT('PXLEC,PXLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9034)PYLEC,PYLECG
 9034 FORMAT('PYLEC,PYLECG= ',E15.7,E15.7)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9035)ISYMBL,ISPAC
 9035 FORMAT('ISYMBL,ISPAC = ',A4,A4)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9039)IBUGG4,ISUBG4,IERRG4
 9039 FORMAT('IBUGG4,ISUBG4,IERRG4 = ',A4,2X,A4,2X,A4)
      CALL DPWRST('XXX','BUG ')
 9090 CONTINUE
C
      RETURN
      END
      SUBROUTINE GTRCDF(X,A,B,C,D,ANU1,ANU3,ALPHA,CDF)
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE CUMULATIVE DISTRIBUTION
C              FUNCTION VALUE FOR THE GENERALIZED TRAPEZOID
C              DISTRIBUTION.
C              THIS DISTRIBUTION HAS THE FOLLOWING CDF FUNCTION:
C              F(X,A,B,C,D,N1,N2,ALPHA)
C              = 0                                    X < A
C              = [2*ALPHA*(B-A)*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((X-A)/(B-A))**NU1
C                                                     A <= X <  B
C              = [2*ALPHA*(B-A)*NU3 + 2*(X-B)*NU1*NU3*
C              {1 + (ALPHA-1)*(2*C-B-X)/(2*(C-B)}]/
C              [(2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *{(ALPHA-1)*(C-X)/(C-B)+1}
C                                                     B <= X <  C
C              = 1 -
C              [2*(D-C)*NU1]/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((D-X)/(D-C))**NU3
C                                                     C <= X <  D
C              = 1                                    X >= D
C              WHERE
C                  A <= B <= C <= D, NU1, NU3, ALPHA > 0
C              THIS DISTRIBUTION MODELS A "GROWTH PHASE",
C              A "STABLE PHASE", AND A "DECAY PHASE".
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE CUMULATIVE DISTRIBUTION
C                                FUNCTION IS TO BE EVALUATED.
C                     --A      = THE SINGLE PRECISION SHAPE PARAMETER
C                       B      = THE SINGLE PRECISION SHAPE PARAMETER
C                       C      = THE SINGLE PRECISION SHAPE PARAMETER
C                       D      = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU1   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU3   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ALPHA  = THE SINGLE PRECISION SHAPE PARAMETER
C     OUTPUT ARGUMENTS--CDF    = THE SINGLE PRECISION CUMULATIVE
C                                DISTRIBUTION FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION CUMULATIVE DISTRIBUTION
C             FUNCTION VALUE CDF.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS. 
C     RESTRICTIONS--X SHOULD BE BETWEEN A AND D, INCLUSIVELY.
C     OTHER DATAPAC   SUBROUTINES NEEDED--NONE.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN. 
C     REFERENCES--J. RENE VAN DORP AND SAMIEL KOTZ, "GENERALIZED
C                 TRAPEZOIDAL DISTRIBUTIONS", METRIKA, VOL. 58,
C                 ISSUE 1, JULY 2003.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE:  301-975-2855
C     ORIGINAL VERSION--JUNE      2003. 
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION DCDF
      DOUBLE PRECISION DX
      DOUBLE PRECISION DA
      DOUBLE PRECISION DB
      DOUBLE PRECISION DC
      DOUBLE PRECISION DD
      DOUBLE PRECISION DALPHA
      DOUBLE PRECISION DNU1
      DOUBLE PRECISION DNU3
      DOUBLE PRECISION DTERM1
      DOUBLE PRECISION DTERM2
      DOUBLE PRECISION DTERM3
      DOUBLE PRECISION DTERM4
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C---------------------------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(A.GT.B .OR. B.GT.C .OR. C.GT.D)THEN
        WRITE(ICOUT,12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,14)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,16)A,B,C,D
        CALL DPWRST('XXX','BUG ')
        CDF=0.0
        GOTO9000
      ENDIF
      IF(ALPHA.LE.0.0)THEN
        WRITE(ICOUT,22)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,23)ALPHA
        CALL DPWRST('XXX','BUG ')
        CDF=0.0
        GOTO9000
      ENDIF
      IF(ANU1.LE.0.0)THEN
        WRITE(ICOUT,32)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,33)ANU1
        CALL DPWRST('XXX','BUG ')
        CDF=0.0
        GOTO9000
      ENDIF
      IF(ANU3.LE.0.0)THEN
        WRITE(ICOUT,42)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,43)ANU3
        CALL DPWRST('XXX','BUG ')
        CDF=0.0
        GOTO9000
      ENDIF
   12 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   13 FORMAT(
     1'      THE FOUR SHAPE PARAMETERS (A, B, C, D) MUST SATISFY')
   14 FORMAT(
     1'         A <= B <= C <= D')
   16 FORMAT(
     1'      A, B, C, D = ',4E15.7)
   22 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   23 FORMAT(
     1'      THE ALPHA SHAPE PARAMETER MUST BE > 0.  ALPHA = ',E15.7)
   32 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   33 FORMAT(
     1'      THE NU1 SHAPE PARAMETER MUST BE > 0.  NU1 = ',E15.7)
   42 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   43 FORMAT(
     1'      THE NU3 SHAPE PARAMETER MUST BE > 0.  NU3 = ',E15.7)
C
C-----START POINT-----------------------------------------------------
C
      IF(X.LT.A)THEN
        CDF=0.0
        GOTO9000
      ELSEIF(X.GE.D)THEN
        CDF=1.0
        GOTO9000
      ENDIF
C
      DX=DBLE(X)
      DA=DBLE(A)
      DB=DBLE(B)
      DC=DBLE(C)
      DD=DBLE(D)
      DNU1=DBLE(ANU1)
      DNU3=DBLE(ANU3)
      DALPHA=DBLE(ALPHA)
      DTERM2=2.0D0*DALPHA*(DB-DA)*DNU3 +
     1       (DALPHA+1.0D0)*(DC-DB)*DNU1*DNU3 +
     1       2.0D0*(DD-DC)*DNU1
C
      IF(A.LE.X .AND. X.LT.B)THEN
        DTERM1=2.0D0*DALPHA*(DB-DA)*DNU3
        DTERM3=((DX-DA)/(DB-DA))**DNU1
        DCDF=(DTERM1/DTERM2)*DTERM3
      ELSEIF(B.LE.X .AND. X.LT.C)THEN
        DTERM1=2.0D0*DALPHA*(DB-DA)*DNU3
        DTERM3=2.0D0*(DX-DB)*DNU1*DNU3
        DTERM4=1.0D0+(DALPHA-1.0D0)*(2.0D0*DC-DB-DX)/(2.0D0*(DC-DB))
        DCDF=(DTERM1 + DTERM3*DTERM4)/DTERM2
      ELSEIF(C.LE.X .AND. X.LT.D)THEN
        DTERM1=2.0D0*(DD-DC)*DNU1
        DTERM3=((DD-DX)/(DD-DC))**DNU3
        DCDF=1.0D0 - (DTERM1/DTERM2)*DTERM3
      ENDIF
      CDF=REAL(DCDF)
C
 9000 CONTINUE
      RETURN
      END 
      SUBROUTINE GTRPDF(X,A,B,C,D,ANU1,ANU3,ALPHA,PDF)
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE PROBABILITY DENSITY
C              FUNCTION VALUE FOR THE GENERALIZED TRAPEZOID
C              DISTRIBUTION.
C              THIS DISTRIBUTION HAS THE FOLLOWING PDF FUNCTION:
C              f(X,A,B,C,D,N1,N2,ALPHA)
C              = [2*ALPHA*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((X-A)/(B-A))**(NU1-1)
C                                                     A <= X <  B
C              = [2*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *{(ALPHA-1)*(C-X)/(C-B)+1}
C                                                     B <= X <  C
C              = [2*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((D-X)/(D-C))**(NU3-1)
C                               = U*((D-X)/(D-C))     C <= X <  D
C                               = 0                   X < A, X >= D
C              WHERE
C                  A <= B <= C <= D, NU1, NU3, ALPHA > 0
C              THIS DISTRIBUTION MODELS A "GROWTH PHASE",
C              A "STABLE PHASE", AND A "DECAY PHASE".
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE PROBABILITY DENSITY
C                                FUNCTION IS TO BE EVALUATED.
C                     --A      = THE SINGLE PRECISION SHAPE PARAMETER
C                       B      = THE SINGLE PRECISION SHAPE PARAMETER
C                       C      = THE SINGLE PRECISION SHAPE PARAMETER
C                       D      = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU1   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU3   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ALPHA  = THE SINGLE PRECISION SHAPE PARAMETER
C     OUTPUT ARGUMENTS--PDF    = THE SINGLE PRECISION PROBABILITY
C                                DENSITY FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION PROBABILITY DENSITY
C             FUNCTION VALUE PDF.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS. 
C     RESTRICTIONS--X SHOULD BE BETWEEN A AND D, INCLUSIVELY.
C     OTHER DATAPAC   SUBROUTINES NEEDED--NONE.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN. 
C     REFERENCES--J. RENE VAN DORP AND SAMIEL KOTZ, "GENERALIZED
C                 TRAPEZOIDAL DISTRIBUTIONS", METRIKA, VOL. 58,
C                 ISSUE 1, JULY 2003.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE:  301-975-2855
C     ORIGINAL VERSION--JUNE      2003. 
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION DPDF
      DOUBLE PRECISION DX
      DOUBLE PRECISION DA
      DOUBLE PRECISION DB
      DOUBLE PRECISION DC
      DOUBLE PRECISION DD
      DOUBLE PRECISION DALPHA
      DOUBLE PRECISION DNU1
      DOUBLE PRECISION DNU3
      DOUBLE PRECISION DTERM1
      DOUBLE PRECISION DTERM2
      DOUBLE PRECISION DTERM3
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C---------------------------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(A.GT.B .OR. B.GT.C .OR. C.GT.D)THEN
        WRITE(ICOUT,12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,14)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,16)A,B,C,D
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
      IF(ALPHA.LE.0.0)THEN
        WRITE(ICOUT,22)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,23)ALPHA
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
      IF(ANU1.LE.0.0)THEN
        WRITE(ICOUT,32)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,33)ANU1
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
      IF(ANU3.LE.0.0)THEN
        WRITE(ICOUT,42)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,43)ANU3
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
   12 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALZIED TRAPEZOID DISTRIBUTION,')
   13 FORMAT(
     1'      THE FOUR SHAPE PARAMETERS (A, B, C, D) MUST SATISFY')
   14 FORMAT(
     1'         A <= B <= C <= D')
   16 FORMAT(
     1'      A, B, C, D = ',4E15.7)
   22 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   23 FORMAT(
     1'      THE ALPHA SHAPE PARAMETER MUST BE > 0.  ALPHA = ',E15.7)
   32 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   33 FORMAT(
     1'      THE NU1 SHAPE PARAMETER MUST BE > 0.  NU1 = ',E15.7)
   42 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   43 FORMAT(
     1'      THE NU3 SHAPE PARAMETER MUST BE > 0.  NU3 = ',E15.7)
C
C-----START POINT-----------------------------------------------------
C
      IF(X.LT.A .OR. X.GE.D)THEN
        PDF=0.0
        GOTO9000
      ENDIF
C
      DX=DBLE(X)
      DA=DBLE(A)
      DB=DBLE(B)
      DC=DBLE(C)
      DD=DBLE(D)
      DNU1=DBLE(ANU1)
      DNU3=DBLE(ANU3)
      DALPHA=DBLE(ALPHA)
      DTERM1=2.0D0*DNU1*DNU3
      DTERM2=2.0D0*DALPHA*(DB-DA)*DNU3 +
     1       (DALPHA+1.0D0)*(DC-DB)*DNU1*DNU3 +
     1       2.0D0*(DD-DC)*DNU1
      DTERM3=DTERM1/DTERM2
C
      IF(A.LE.X .AND. X.LT.B)THEN
        IF(A.EQ.X .AND. ANU1.LE.1.0)THEN
          WRITE(ICOUT,132)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,133)ANU1
          CALL DPWRST('XXX','BUG ')
          PDF=0.0
          GOTO9000
        ENDIF
  132 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
  133 FORMAT(
     1'      WHEN X = A AND NU1 <= 1, THE PDF IS UNDEFINED.')
        DPDF=DALPHA*DTERM3*((DX-DA)/(DB-DA))**(DNU1-1.0D0)
      ELSEIF(B.LE.X .AND. X.LT.C)THEN
        DPDF=DTERM3*((DALPHA-1.0D0)*(DC-DX)/(DC-DB) + 1.0D0)
      ELSEIF(C.LE.X .AND. X.LT.D)THEN
        IF(D.EQ.X .AND. ANU3.LE.1.0)THEN
          WRITE(ICOUT,232)
          CALL DPWRST('XXX','BUG ')
          WRITE(ICOUT,233)ANU1
          CALL DPWRST('XXX','BUG ')
          PDF=0.0
          GOTO9000
        ENDIF
  232 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
  233 FORMAT(
     1'      WHEN X = D AND NU3 <= 1, THE PDF IS UNDEFINED.')
        DPDF=DTERM3*((DD-DX)/(DD-DC))**(DNU3-1.0D0)
      ENDIF
      PDF=REAL(DPDF)
C
 9000 CONTINUE
      RETURN
      END 
      SUBROUTINE GTRPPF(P,A,B,C,D,ANU1,ANU3,ALPHA,PPF)
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE PERCENT POINT
C              FUNCTION VALUE FOR THE GENERALZIED TRAPEZOID
C              DISTRIBUTION.
C              THIS DISTRIBUTION HAS THE FOLLOWING CDF FUNCTION:
C              F(X,A,B,C,D,N1,N2,ALPHA)
C              = 0                                    X < A
C              = [2*ALPHA*(B-A)*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((X-A)/(B-A))**NU1
C                                                     A <= X <  B
C              = [2*ALPHA*(B-A)*NU3 + 2*(X-B)*NU1*NU3*
C              {1 + (ALPHA-1)*(2*C-B-X)/(2*(C-B)}]/
C              [(2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *{(ALPHA-1)*(C-X)/(C-B)+1}
C                                                     B <= X <  C
C              = 1 -
C              [2*(D-C)*NU1]/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((D-X)/(D-C))**NU3
C                                                     C <= X <  D
C              = 1                                    X >= D
C              WHERE
C                  A <= B <= C <= D, NU1, NU3, ALPHA > 0
C              THE ALGORITHM FOR THE PPF IS TO COMPUTE THE CDF AT
C              X = A, X = B, X = C, AND X = D TO FIND THE APPROPRIATE
C              INTERVAL FOR P.  THEN INVERT THE APPROPRIATE EQUATION
C              ABOVE TO FIND THE PPF VALUE.  FOR THE INTERVAL FOR
C              B < X < C, USE A BISECTION METHOD (ALGEBRA FOR
C              INVERSION GETS A BIT MESSY).
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE PROBABILITY DENSITY
C                                FUNCTION IS TO BE EVALUATED.
C                     --A      = THE SINGLE PRECISION SHAPE PARAMETER
C                       B      = THE SINGLE PRECISION SHAPE PARAMETER
C                       C      = THE SINGLE PRECISION SHAPE PARAMETER
C                       D      = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU1   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU3   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ALPHA  = THE SINGLE PRECISION SHAPE PARAMETER
C     OUTPUT ARGUMENTS--PPF    = THE SINGLE PRECISION PERCENT POINT
C                                FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION PERCENT POINT FUNCTION VALUE PPF.
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS. 
C     RESTRICTIONS--P SHOULD BE BETWEEN 0 AND 1, INCLUSIVELY.
C     OTHER DATAPAC   SUBROUTINES NEEDED--NONE.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN. 
C     REFERENCES--J. RENE VAN DORP AND SAMIEL KOTZ, "GENERALIZED
C                 TRAPEZOIDAL DISTRIBUTIONS", METRIKA, VOL. 58,
C                 ISSUE 1, JULY 2003.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING LABORATORY (205.03)
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE:  301-975-2855
C     ORIGINAL VERSION--JUNE      2003. 
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION DPPF
      DOUBLE PRECISION DP
      DOUBLE PRECISION DA
      DOUBLE PRECISION DB
      DOUBLE PRECISION DC
      DOUBLE PRECISION DD
      DOUBLE PRECISION DALPHA
      DOUBLE PRECISION DNU1
      DOUBLE PRECISION DNU3
      DOUBLE PRECISION DTERM1
      DOUBLE PRECISION DTERM2
      DOUBLE PRECISION DTERM3
      DOUBLE PRECISION DTERM4
      DOUBLE PRECISION DCDF
      DOUBLE PRECISION DCDFL
      DOUBLE PRECISION DCDFR
      DOUBLE PRECISION DXINC
      DOUBLE PRECISION DXL
      DOUBLE PRECISION DXR
      DOUBLE PRECISION DFXL
      DOUBLE PRECISION DFXR
      DOUBLE PRECISION DP1
      DOUBLE PRECISION DFCS
      DOUBLE PRECISION DXRML
      DOUBLE PRECISION DSIG
      DOUBLE PRECISION DEPS
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
      DATA DEPS /0.0000001/
      DATA DSIG /1.0D-7/
      DATA DZERO /0./
      DATA MAXIT /2000/
C
C---------------------------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(P.LT.0.0 .OR. P.GT.1.0)THEN
        WRITE(ICOUT,22)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,23)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,26)P
        CALL DPWRST('XXX','BUG ')
        PPF=0.0
        GOTO9000
      ENDIF
C
      IF(A.GE.B .OR. B.GE.C .OR. C.GE.D)THEN
        WRITE(ICOUT,12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,14)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,16)A,B,C,D
        CALL DPWRST('XXX','BUG ')
        PPF=0.0
        GOTO9000
      ENDIF
      IF(ALPHA.LE.0.0)THEN
        WRITE(ICOUT,22)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,23)ALPHA
        CALL DPWRST('XXX','BUG ')
        PPF=0.0
        GOTO9000
      ENDIF
      IF(ANU1.LE.0.0)THEN
        WRITE(ICOUT,32)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,33)ANU1
        CALL DPWRST('XXX','BUG ')
        PPF=0.0
        GOTO9000
      ENDIF
      IF(ANU3.LE.0.0)THEN
        WRITE(ICOUT,42)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,43)ANU3
        CALL DPWRST('XXX','BUG ')
        PPF=0.0
        GOTO9000
      ENDIF
C
   12 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALZIED TRAPEZOID DISTRIBUTION,')
   13 FORMAT(
     1'      THE FOUR SHAPE PARAMETERS (A, B, C, D) MUST SATISFY')
   14 FORMAT(
     1'         A < B < C < D')
   16 FORMAT(
     1'      A, B, C, D = ',4E15.7)
   22 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALZIED TRAPEZOID PERCENT,')
   23 FORMAT(
     1'      POINT FUNCTION THE VALUE OF THE INPUT ARGUMENT IS ',
     1'OUTSIDE THE ALLOWABLE (0,1) INTERVAL.')
   26 FORMAT(
     1'      VALUE OF INPUT ARGUMENT = ',E15.7)
   32 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   33 FORMAT(
     1'      THE NU1 SHAPE PARAMETER MUST BE > 0.  NU1 = ',E15.7)
   42 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   43 FORMAT(
     1'      THE NU3 SHAPE PARAMETER MUST BE > 0.  NU3 = ',E15.7)
C
C-----START POINT-----------------------------------------------------
C
      P1=0.0
      CALL GTRCDF(B,A,B,C,D,ANU1,ANU3,ALPHA,P2)
      CALL GTRCDF(C,A,B,C,D,ANU1,ANU3,ALPHA,P3)
      P4=1.0
C
      IF(P.EQ.0.0)THEN
        PPF=A
        GOTO9000
      ELSEIF(P.EQ.1.0)THEN
        PPF=D
        GOTO9000
      ELSEIF(P.EQ.P2)THEN
        PPF=B
        GOTO9000
      ELSEIF(P.EQ.P3)THEN
        PPF=C
        GOTO9000
      ENDIF
C
      DP=DBLE(P)
      DALPHA=DBLE(ALPHA)
      DNU1=DBLE(ANU1)
      DNU3=DBLE(ANU3)
      DA=DBLE(A)
      DB=DBLE(B)
      DC=DBLE(C)
      DD=DBLE(D)
      DTERM2=2.0D0*DALPHA*(DB-DA)*DNU3 +
     1       (DALPHA+1.0D0)*(DC-DB)*DNU1*DNU3 +
     1       2.0D0*(DD-DC)*DNU1
C
      IF(P.GE.P1 .AND. P.LE.P2)THEN
        DTERM1=2.0D0*DALPHA*(DB-DA)*DNU3
        DPPF=(DB-DA)*((DTERM2/DTERM1)*DP)**(1.0D0/DNU1) + DA
      ELSEIF(P.GE.P2 .AND. P.LE.P3)THEN
        DXL=DB
        DXR=DC
C
C       BISECTION METHOD
C
        IC = 0
        DFXL = -DP
        DFXR = 1.0D0 - DP
  105   CONTINUE
          DX = (DXL+DXR)*0.5D0
C
C         GTRCDF FOR B < X < C CASE
C
          DTERM1=2.0D0*DALPHA*(DB-DA)*DNU3
          DTERM3=2.0D0*(DX-DB)*DNU1*DNU3
          DTERM4=1.0D0+(DALPHA-1.0D0)*(2.0D0*DC-DB-DX)/(2.0D0*(DC-DB))
          DCDF=(DTERM1 + DTERM3*DTERM4)/DTERM2
C
          DP1=DCDF
          DPPF=DX
          PPF=REAL(DPPF)
          DFCS = DP1 - DP
          IF(DFCS*DFXL.GT.0.0D0)GOTO110
          DXR = DX
          DFXR = DFCS 
          GOTO115
  110     CONTINUE
          DXL = DX
          DFXL = DFCS
  115     CONTINUE
          DXRML = DXR - DXL
          IF(DXRML.LE.DSIG .AND. DABS(DFCS).LE.DEPS)GOTO9000
          IC = IC + 1
          IF(IC.LE.MAXIT)GOTO105
          WRITE(ICOUT,130)
          CALL DPWRST('XXX','BUG ')
  130     FORMAT(
     1    '***** FATAL ERROR--GENERALIZED TRAPEZOID PPF ROUTINE DID ',
     1    'NOT CONVERGE.')
        GOTO9000
C
      ELSEIF(P.GE.P3 .AND. P.LE.P4)THEN
        DTERM1=2.0D0*(DD-DC)*DNU1
        DPPF=DD - (DD-DC)*((1.0D0-DP)*(DTERM2/DTERM1))**(1.0D0/DNU3)
      ENDIF
      PPF=REAL(DPPF)
C
 9000 CONTINUE
      RETURN
      END 
      SUBROUTINE GTRRAN(N,A,B,C,D,ANU1,ANU3,ALPHA,ISEED,X)
C
C     PURPOSE--THIS SUBROUTINE GENERATES A RANDOM SAMPLE OF SIZE N
C              FROM THE GENERALIZED TRAPEZOID DISTRIBUTION
C              THIS DISTRIBUTION HAS THE FOLLOWING PDF FUNCTION:
C              f(X,A,B,C,D,N1,N2,ALPHA)
C              = [2*ALPHA*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((X-A)/(B-A))**(NU1-1)
C                                                     A <= X <  B
C              = [2*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *{(ALPHA-1)*(C-X)/(C-B)+1}
C                                                     B <= X <  C
C              = [2*NU1*NU3/
C              (2*ALPHA*(B-A)*NU3+(ALPHA+1)*(C-B)*NU1*NU3+2*(D-C)*NU1)]
C              *((D-X)/(D-C))**(NU3-1)
C                               = U*((D-X)/(D-C))     C <= X <  D
C                               = 0                   X < A, X >= D
C              WHERE
C                  A <= B <= C <= D, NU1, NU3, ALPHA > 0
C              THIS DISTRIBUTION MODELS THE SIMPLEST CASE OF 
C              A "GROWTH PHASE", A "STABLE PHASE", AND A "DECAY PHASE".
C     INPUT  ARGUMENTS--N      = THE DESIRED INTEGER NUMBER
C                                OF RANDOM NUMBERS TO BE
C                                GENERATED.
C     OUTPUT ARGUMENTS--X      = A SINGLE PRECISION VECTOR
C                                (OF DIMENSION AT LEAST N)
C                                INTO WHICH THE GENERATED
C                                RANDOM SAMPLE WILL BE PLACED.
C                     --A      = THE SINGLE PRECISION SHAPE PARAMETER
C                       B      = THE SINGLE PRECISION SHAPE PARAMETER
C                       C      = THE SINGLE PRECISION SHAPE PARAMETER
C                       D      = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU1   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ANU3   = THE SINGLE PRECISION SHAPE PARAMETER
C                       ALPHA  = THE SINGLE PRECISION SHAPE PARAMETER
C     OUTPUT--A RANDOM SAMPLE OF SIZE N
C             FROM THE GENERALIZED TRAPEZOID DISTRIBUTION
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--THERE IS NO RESTRICTION ON THE MAXIMUM VALUE
C                   OF N FOR THIS SUBROUTINE.
C     OTHER DATAPAC   SUBROUTINES NEEDED--UNIRAN, GTRPPF
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN (1977)
C     REFERENCES--J. RENE VAN DORP AND SAMIEL KOTZ, "GENERALIZED
C                 GENERALIZED TRAPEZOIDAL DISTRIBUTIONS", METRIKA, VOL. 58,
C                 ISSUE 1, JULY 2003.
C               --TOCHER, THE ART OF SIMULATION,
C                 1963, PAGES 14-15.
C               --HAMMERSLEY AND HANDSCOMB, MONTE CARLO METHODS,
C                 1964, PAGE 36.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--2003.6
C     ORIGINAL VERSION--JUNE      2003.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DIMENSION X(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(N.LT.1)THEN
        WRITE(ICOUT, 5)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,47)N
        CALL DPWRST('XXX','BUG ')
        GOTO9000
      ENDIF
    5 FORMAT('***** FATAL ERROR--THE REQUESTED NUMBER OF GENERALIZED',
     1' TRAPEZOID RADOM NUMBERS IS NON-POSITIVE *****')
   47 FORMAT('***** THE VALUE OF THE ARGUMENT IS ',I8,' *****')
      IF(A.GE.B .OR. B.GE.C .OR. C.GE.D)THEN
        WRITE(ICOUT,12)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,13)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,14)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,16)A,B,C,D
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
   12 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   13 FORMAT(
     1'      THE FOUR SHAPE PARAMETERS (A, B, C, D) MUST SATISFY')
   14 FORMAT(
     1'         A < B < C < D')
   16 FORMAT(
     1'      A, B, C, D = ',4E15.7)
      IF(ALPHA.LE.0.0)THEN
        WRITE(ICOUT,22)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,23)ALPHA
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
      IF(ANU1.LE.0.0)THEN
        WRITE(ICOUT,32)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,33)ANU1
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
      IF(ANU3.LE.0.0)THEN
        WRITE(ICOUT,42)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,43)ANU3
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9000
      ENDIF
   22 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   23 FORMAT(
     1'      THE ALPHA SHAPE PARAMETER MUST BE > 0.  ALPHA = ',E15.7)
   32 FORMAT(
     1'***** FATAL ERROR--FOR THE GEnERALIZED TRAPEZOID DISTRIBUTION,')
   33 FORMAT(
     1'      THE NU1 SHAPE PARAMETER MUST BE > 0.  NU1 = ',E15.7)
   42 FORMAT(
     1'***** FATAL ERROR--FOR THE GENERALIZED TRAPEZOID DISTRIBUTION,')
   43 FORMAT(
     1'      THE NU3 SHAPE PARAMETER MUST BE > 0.  NU3 = ',E15.7)
C
C
C     GENERATE N UNIFORM (0,1) RANDOM NUMBERS;
C
      CALL UNIRAN(N,ISEED,X)
C
C     GENERATE N GENERALIZED TRAPEZOID RANDOM NUMBERS
C     USING THE PERCENT POINT FUNCTION TRANSFORMATION METHOD.
C
      DO100I=1,N
      P=X(I)
      CALL GTRPPF(P,A,B,C,D,ANU1,ANU3,ALPHA,PPF)
      X(I)=PPF
  100 CONTINUE
C
 9000 CONTINUE
      RETURN
      END
      SUBROUTINE GVECT(X,Y,N,
     1XTEMP,YTEMP,TATEMP,NTEMP,NTRACE,
     1IBUGG3,ISUBRO,IERROR)
C
C     PURPOSE--XX
C
C     WRITTEN BY--DAVID W. BEHRINGER NOAA/AOML (MIAMI).
C                 AS PART OF NOAA'S CONCX V.3   MARCH 1988.
C     ORIGINAL VERSION (IN DATAPLOT)--AUGUST    1988.
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IBUGG3
      CHARACTER*4 ISUBRO
      CHARACTER*4 IERROR
C
      DIMENSION X(*)
      DIMENSION Y(*)
C
      DIMENSION XTEMP(*)
      DIMENSION YTEMP(*)
      DIMENSION TATEMP(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IF(IBUGG3.EQ.'ON'.OR.ISUBRO.EQ.'VECT')GOTO1010
      GOTO1019
 1010 CONTINUE
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1011)N
 1011 FORMAT('FROM GVECT--N = ',I8)
      CALL DPWRST('XXX','BUG ')
      DO1015I=1,N
      WRITE(ICOUT,1016)I,X(I),Y(I)
 1016 FORMAT('            I,X(I),Y(I) = ',I8,2F10.5)
      CALL DPWRST('XXX','BUG ')
 1015 CONTINUE
 1019 CONTINUE
C
      NTRACE=NTRACE+1
      DO1100I=1,N
      NTEMP=NTEMP+1
      XTEMP(NTEMP)=X(I)
      YTEMP(NTEMP)=Y(I)
      TATEMP(NTEMP)=NTRACE
 1100 CONTINUE
C
      RETURN
      END
      SUBROUTINE GWAPDF(X,A,B,C,PDF)
C
C     PURPOSE--THIS SUBROUTINE COMPUTES THE PROBABILITY DENSITY
C              FUNCTION VALUE FOR THE DISCRETE GENERALIZED WARING
C              DISTRIBUTION WITH SHAPE PARAMETERS A, B, AND C.
C              THIS DISTRIBUTION IS DEFINED FOR ALL INTEGER X >= 0.
C              THE PROBABILITY DENSITY FUNCTION IS:
C              P(X,A,B,C)=G(A+C)*G(B+C)*(A)n(B)n/
C                         G(A+B+C)*G(C)*X!*(A+B+C)n    X = 0, 1, 2, ...
C              WHERE G IS THE GAMMA FUNCTION AND (A)n IS
C              POCHHAMMER'S SYMBOL.  THE ABOVE DEFINTION IS FROM
C              DEVROYE. JOHNSON, KOTZ, AND KEMP GIVE A DEFINITION
C              BASED ON BINOMIAL COEFFICIENTS.
C     INPUT  ARGUMENTS--X      = THE SINGLE PRECISION VALUE AT
C                                WHICH THE PROBABILITY DENSITY
C                                FUNCTION IS TO BE EVALUATED.
C                                X SHOULD BE NON-NEGATIVE.
C                     --A      = THE FIRST SHAPE PARAMETER
C                     --B      = THE SECOND SHAPE PARAMETER
C                     --C      = THE THIRD SHAPE PARAMETER
C     OUTPUT ARGUMENTS--PDF    = THE SINGLE PRECISION DENSITY
C                                FUNCTION VALUE.
C     OUTPUT--THE SINGLE PRECISION PROBABILITY DENSITY
C             FUNCTION VALUE
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--X SHOULD BE A NON-NEGATIVE INTEGER
C                 --A, B, AND C > 0
C     MODE OF INTERNAL OPERATIONS--DOUBLE PRECISION.
C     LANGUAGE--ANSI FORTRAN (1977)
C     REFERENCES--JOHNSON, KOTZ, AND KEMP, "DISCRETE UNIVARIATE
C                 DISTRIBUTIONS", SECOND EDITION, 1992, WILEY,
C                 PP. 242-244.
C               --LUC DEVROYE, "RANDOM VARIATE GENERATION FOR THE
C                 DIGAMMA AND TRIGAMMA DISTRIBUTIONS", JOURNAL OF
C                 STATISTICAL COMPUTATION AND SIMULATION", VOL. 43,
C                 1992, PP. 197-216.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 INFORMATION TECHNOLOGY LABORATORY
C                 NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY
C                 GAITHERESBURG, MD 20899-8980
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C               EXCEPTION--HOLLERITH STRINGS IN FORMAT STATEMENTS
C                          DENOTED BY QUOTES RATHER THAN NH.
C     VERSION NUMBER--2004/4
C     ORIGINAL VERSION--APRIL     2004.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DOUBLE PRECISION DTERM1, DTERM2, DTERM3, DTERM4, DTERM5
      DOUBLE PRECISION DTERM6, DTERM7, DTERM8, DTERM9
      DOUBLE PRECISION DNUM, DENOM
      DOUBLE PRECISION DX, DA, DB, DC
      DOUBLE PRECISION DPDF
      DOUBLE PRECISION DLNGAM
      DOUBLE PRECISION DPOCH
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(A.LE.0.0)THEN
        WRITE(ICOUT,5)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)A
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
      IF(B.LE.0.0)THEN
        WRITE(ICOUT,15)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)B
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
      IF(C.LE.0.0)THEN
        WRITE(ICOUT,25)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)C
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
C
      IX=X+0.5
      IF(IX.LT.0)THEN
        WRITE(ICOUT,4)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)X
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
C
    4 FORMAT('***** ERROR--THE FIRST INPUT ARGUMENT ',
     1'TO THE GWAPDF SUBROUTINE IS LESS THAN 0')
    5 FORMAT('***** ERROR--THE SECOND INPUT ARGUMENT ',
     1'TO THE GWAPDF SUBROUTINE IS NON-POSITIVE.')
   15 FORMAT('***** ERROR--THE THIRD INPUT ARGUMENT ',
     1'TO THE GWAPDF SUBROUTINE IS NON-POSITIVE.')
   25 FORMAT('***** ERROR--THE FOURTH INPUT ARGUMENT ',
     1'TO THE GWAPDF SUBROUTINE IS NON-POSITIVE.')
   46 FORMAT('***** THE VALUE OF THE ARGUMENT IS ',E15.8,' *****')
C
   90 CONTINUE
C
      DX=DBLE(IX)
      DA=DBLE(A)
      DB=DBLE(B)
      DC=DBLE(C)
C
      DTERM1=DLNGAM(DA+DC)
      DTERM2=DLNGAM(DB+DC)
      DTERM3=DLOG(DPOCH(DA,DX))
      DTERM4=DLOG(DPOCH(DB,DX))
      DTERM5=DLNGAM(DA+DB+DC)
      DTERM6=DLNGAM(DC)
      DTERM7=DLNGAM(DX+1.0)
      DTERM8=DLOG(DPOCH(DA+DB+DC,DX))
      DNUM=DTERM1+DTERM2+DTERM3+DTERM4
      DENOM=DTERM5+DTERM6+DTERM7+DTERM8
      DTERM9=DNUM-DENOM
      DPDF=DEXP(DTERM9)
C
      PDF=REAL(DPDF)
C
 9999 CONTINUE
      RETURN
      END
      SUBROUTINE GWARAN(N,A,B,C,ISEED,X)
C
C     PURPOSE--THIS SUBROUTINE GENERATES A RANDOM SAMPLE OF SIZE N
C              FROM THE GENERALIZED WARING DISTRIBUTION
C              WITH SINGLE PRECISION SHAPE PARAMETERS A, B, C.
C              THIS DISTRIBUTION IS DEFINED FOR ALL INTEGER X >= 0.
C              THE PROBABILITY DENSITY FUNCTION IS:
C                 P(X,A,B,C)=G(A+C)*G(B+C)*(a)n*(b)n/
C                            [G(A+B+C)*G(C)*X!*(a+b+c)n  X=0, 1, 2, ...
C                            A, B, C > 0
C                       =P*GAMMA(P+1)*GAMMA(X+1)/GAMMA(X+P+2)
C              ALGORITHM FOR RANDOM NUMBERS IS GIVEN BY DEVROYE,
C              "RANDOM VARIATE GENERATION FOR THE DIGAMMA AND
C              TRIGAMMA DISTRIBUTIONS", xxx.
C     INPUT  ARGUMENTS--N      = THE DESIRED INTEGER NUMBER
C                                OF RANDOM NUMBERS TO BE
C                                GENERATED.
C                     --A      = THE SINGLE PRECISION VALUE
C                                OF THE FIRST SHAPE PARAMETER FOR THE
C                                GENERALIZED WARING DISTRIBUTION.
C                     --B      = THE SINGLE PRECISION VALUE
C                                OF THE SECOND SHAPE PARAMETER FOR THE
C                                GENERALIZED WARING DISTRIBUTION.
C                     --C      = THE SINGLE PRECISION VALUE
C                                OF THE THIRD SHAPE PARAMETER FOR THE
C                                GENERALIZED WARING DISTRIBUTION.
C     OUTPUT ARGUMENTS--X      = A SINGLE PRECISION VECTOR
C                                (OF DIMENSION AT LEAST N)
C                                INTO WHICH THE GENERATED
C                                RANDOM SAMPLE WILL BE PLACED.
C     OUTPUT--A RANDOM SAMPLE OF SIZE N
C             FROM THE GENERALIZED WARING DISTRIBUTION
C     PRINTING--NONE UNLESS AN INPUT ARGUMENT ERROR CONDITION EXISTS.
C     RESTRICTIONS--THERE IS NO RESTRICTION ON THE MAXIMUM VALUE
C                   OF N FOR THIS SUBROUTINE.
C                 --A, B, C SHOULD BE > 0
C     OTHER DATAPAC   SUBROUTINES NEEDED--GAMRAN, POIRAN.
C     FORTRAN LIBRARY SUBROUTINES NEEDED--NONE.
C     MODE OF INTERNAL OPERATIONS--SINGLE PRECISION.
C     LANGUAGE--ANSI FORTRAN (1977)
C     REFERENCES--LUC DEVROYE, "RANDOM VARIATE GENERATION FOR THE
C                 DIGAMMA AND TRIGAMMA DISTRIBUTIONS", JOURNAL OF
C                 STATISITCAL COMPUTATION AND SIMULATION", VOL. 43,
C                 PP. 197-216, 1992.
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 INFORMATION TECHNOLOGY LABORATORY
C                 NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY
C                 GAITHERSBURG, MD 20899-8980
C                 PHONE--301-975-2899
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY.
C           THIS SUBROUTINE MAY NOT BE COPIED, EXTRACTED,
C           MODIFIED, OR OTHERWISE USED IN A CONTEXT
C           OUTSIDE OF THE DATAPLOT LANGUAGE/SYSTEM.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--2004/4
C     ORIGINAL VERSION--APRIL     2004.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
C---------------------------------------------------------------------
C
      DIMENSION X(*)
      DIMENSION U(2)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     CHECK THE INPUT ARGUMENTS FOR ERRORS
C
      IF(N.LT.1)THEN
        WRITE(ICOUT,5)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,47)N
        CALL DPWRST('XXX','BUG ')
        GOTO9999
      ENDIF
      IF(A.LE.0.0)THEN
        WRITE(ICOUT,15)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)A
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
      IF(B.LE.0.0)THEN
        WRITE(ICOUT,15)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)B
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
      IF(C.LE.0.0)THEN
        WRITE(ICOUT,15)
        CALL DPWRST('XXX','BUG ')
        WRITE(ICOUT,46)C
        CALL DPWRST('XXX','BUG ')
        PDF=0.0
        GOTO9999
      ENDIF
C
    5 FORMAT('***** ERROR--NUMBER OF GENERALIZED WARING RANDOM ',
     1'NUMBERS REQUESTED IS LESS THAN 1')
   15 FORMAT('***** ERROR--THE FIRST SHAPE PARAMETER FOR THE ',
     1       'GENERALIZED WARING DISTRIBUTION IS <= 0')
   16 FORMAT('***** ERROR--THE SECOND SHAPE PARAMETER FOR THE ',
     1       'GENERALIZED WARING DISTRIBUTION IS <= 0')
   17 FORMAT('***** ERROR--THE THIRD SHAPE PARAMETER FOR THE ',
     1       'GENERALIZED WARING DISTRIBUTION IS <= 0')
   46 FORMAT('***** THE VALUE OF THE ARGUMENT IS ',E15.8)
   47 FORMAT('***** THE VALUE OF THE ARGUMENT IS ',I8)
C
C     GENERATE N GENERALIZED WARING  RANDOM NUMBERS
C
C     ALGORITHM:
C       1. GENERATE THREE GAMMA RANDOM NUMBERS WITH SHAPE PARAMETERS
C          A, B, AND C (SCALE PARAMETER = 1).
C       2. GAMMA(A)*GAMMA(B)/GAMMA(C) = LAMBDA
C       3. GENERATE A POISSON RANDOM NUMBER WITH SHAPE PARAMETER
C          LAMBDA
C
      NTEMP=1
      DO100I=1,N
        CALL GAMRAN(NTEMP,A,ISEED,U)
        U1=U(1)
        CALL GAMRAN(NTEMP,B,ISEED,U)
        U2=U(1)
        CALL GAMRAN(NTEMP,C,ISEED,U)
        U3=U(1)
        ALAMB=U1*U2/U3
        CALL POIRAN(NTEMP,ALAMB,ISEED,U)
        X(I)=U(1)
  100 CONTINUE
C
 9999 CONTINUE
      RETURN
      END

C     THIS IS FILE TCDRIV.FOR
C     PURPOSE--THESE ARE THE FORTRAN ROUTINES WHICH SERVE AS
C              A DRIVER & BRIDGE BETWEEN THE DATAPLOT FORTRAN
C              AND THE TURBO-C C DRIVER, AND ULTIMATELY
C              THE TURBO C C ROUTINES.
C
C     TIME DRAIN--THE C CODE WILL NOT WORK & WILL GET ERROR MESSAGE:
C                 "REAL MODE LIBRARY TERMINATED IMPROPERLY--
C                 PLEASE REBOOT"
C                 UNLESS    COMSPACE   IN AUTOEXEC.BAT
C                 IS AT LEAST 400000 .
C                 THIS HAS BEEN A PROBLEM 3 TIMES!
C
C     NOTE--IT IS BEST THAT THE TURBO-C LOAD SWITCH (1/0) LOGIC
C           AND THE TURBO-C GRAPHICS STATUS (OPEN/CLOSE) LOGIC
C           IS DONE HEREIN RATHER THAN BE SCATTERED ABOUT
C           IN THE REST OF THE DATAPLOT CODE.
CCCCC NOTE--THE COMMON STRUCTURE IS--
CCCCC COMMON /FC/NTEXTF,NTEXTC,NPLOTF,TEXTFC,TEXTCF,PLOTFC(11)
CCCCC BYTES:       4      4      4      84     84     84*11
C
C NOTE--THESE ARE THE TURBO-C FILES--
C TEXT OUTPUT       7 C:\TURBOC\FRONTEND\DPTEOU.TEX TCSHME+ TCGECO-+
C GRAPHICS OUTPUT   8 C:\TURBOC\FRONTEND\DPGROU.TEX
C TCDRIV DEBUG      9 C:\TURBOC\FRONTEND\TCDEBU.TEX TCLOTC+ TCGETC-
C COM. HIST. INPUT 10 C:\TURBOC\FRONTEND\DPCOIN.TEX TCINCF+- TCWRCO+-+-
C
C     NOTE--THERE ARE 4 TURBO-C SWITCHES--
C           1. TCLOAD
C              HAS CMAIN.EXE BEEN LOADED (& INIT. EXEC.)? YES/NO
C           2. TCMENU
C              IS THE TURBO C MENU ON THE SCREEN?         YES/NO
C           3. TCPLFI        FILE 8
C              WHAT IS STATUS OF THE TURBO C PLOT FILE?   OPEN/CLOS
C           4. TCTEFI        FILE 7
C              WHAT IS STATUS OF THE TURBO C TEXT FILE?   OPEN/CLOS
C
C
C     NOTE--WHEN THE COMMAND    MENU   IS ENTERED ON THE FORTRAN SIDE,
C           THIS IS DETECTED IN     MAIN.FOR
C           AND THEN   TCLOTC IS CALLED FIRST
C           AND        TCSHME IS CALLED SECOND
C           (BOTH FROM    MAIN.FOR)
C     NOTE--THEY ARE INITIALLY ALLOCATED IN DPCODV.INC
C           THEY ARE INITIALLY DEFINED   IN INITOD.FOR
C     WRITTEN BY--JAMES J. FILLIBEN
C     ORIGINAL VERSION--MAY  18, 1991
C     UPDATED         --MAY  26, 1991
C     UPDATED         --JUNE 25, 1991
C
C ----------TCINCO-----------------------------
C
      SUBROUTINE TCINCO(ISUBRO)
C
C     PURPOSE--INITIALIZE TURBO-C COMMON
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     DATAPLOT CALLING ROUTINE--MAIN ONLY
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCINCO IS THE FIRST ROUTINE CALLED
C           TCLOTC IS THE SECOND ROUTINE CALLED
C           AND TCSHME IS THE THIRD ROUTINE CALLED
C           (ALL FROM MAIN)
CCCCC THE FOLLOWING COMMENT LINES WERE ADDED MAY 1992 (JJF)
C     DEFINE THE 4 GENERAL TURBO-C SWITCHES.
C     NOTE--THERE ARE 4 TURBO-C SWITCHES--
C           1. TCLOAD
C              HAS CMAIN.EXE BEEN LOADED (& INIT. EXEC.)? YES/NO
C           2. TCMENU
C              IS THE TURBO C MENU ON/OFF THE SCREEN?     ON/OFF
C           3. TCPLFI
C              WHAT IS STATUS OF THE TURBO C PLOT FILE?   OPEN/CLOS
C           4. TCTEFI
C              WHAT IS STATUS OF THE TURBO C TEXT FILE?   OPEN/CLOS
C     NOTE--THEY ARE INITIALLY ALLOCATED IN DPCODV.INC
C           THEY ARE INITIALLY DEFINED   IN TCINCO.FOR IN TCDRIV.FOR
C           THEY ARE USED                IN TCDRIV.FOR
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ISUBRO
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
CCCCC DELETE THE FOLLOWING LINE AFTER DEBUGGED
CNOPC OPEN(UNIT=9,FILE='C:\TURBOC\FRONTEND\TCDEBU.TEX')
CNOPC OPEN(UNIT=9,FILE='TCDEBU.TEX')
C
      IF(ISUBRO.EQ.'INCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINCO IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
      ENDIF
C
      TCLOAD='NO'
      TCMENU='OFF'
CCCCC THE FOLLOWING 2 LINES WERE CORRECTED JULY 1992 (JJF)
CCCCC TCPLFI='OFF'
CCCCC TCTEFI='OFF'
      TCPLFI='CLOS'
      TCTEFI='CLOS'
      ITCST='OFF'
      TEXTFC=' '
      NTEXTF=0
CCCCC THE FOLLOWING 4 LINES WERE ADDED MAY 1992 (JJF)
      NPLOTF=0
      DO2100I=1,11
      PLOTFC(I)=' '
 2100 CONTINUE
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCLOTC IN TCDRIV--')
         WRITE(9,9012)ISUBRO
 9012    FORMAT(1H ,'ISUBRO= ',A4)
         WRITE(IPR,9013)TCLOAD,TCMENU,TCPLFI,TCTEFI
 9013    FORMAT(1H ,'TCLOAD,TCMENU,TCPLFI,TCTEFI = ',
     1               A4,2X,A4,2X,A4,2X,A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCLOTC-----------------------------
C
      SUBROUTINE TCLOTC(ISUBRO)
C
C     PURPOSE--INITIALIZE (LOAD IN) THE TURBO-C C DRIVER (CMAIN.C)
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--MAIN ONLY
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCLOTC IS THE FIRST ROUTINE CALLED
C           AND TCSHME IS THE SECOND ROUTINE CALLED
C           (BOTH FROM MAIN)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ISUBRO
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCLOTC IN TCDRIV--')
         WRITE(9,52)ISUBRO,TCLOAD
   52    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
      ENDIF
C
      IF(TCLOAD.EQ.'NO')THEN
CNOPC    CALL REAL_MODE_SHORT_CUT@
CCCCC CALL PAUSE('1')
C
CNOPC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAIN.EXE')
CCCCC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAINF.EXE')
C
CCCCC ****************** DANGER ABOVE *********************
CCCCC ***** NOTE--DATAPLOT AND FED HAVE DIFFERENCE C-SIDE MAIN ROUTINES
CCCCC             DATAPLOT USES CMAIN.EXE
CCCCC             FED      USED CMAINF.EXE
CCCCC        IF NOT HAV PROPER CMAIN..  LOADED
CCCCC THEN WILL GET MESSAGE:
CCCCC REAL MODE LIBRARY HAS TERMINATED IMPROPERLY,
CCCCC SYSTEM MUST BE REBOOTED
CCCCC CALL PAUSE('2')
CCCCC CHANGE ABOVE AND ALSO WELL BELOW
         TCLOAD='YES'
      ENDIF
C
      IF(ISUBRO.EQ.'LOTC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCLOTC IN TCDRIV--')
         WRITE(9,9012)ISUBRO,TCLOAD
 9012    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
         WRITE(9,999)
         WRITE(9,9011)
         WRITE(9,9012)ISUBRO,TCLOAD
      ENDIF
C
      RETURN
      END
C
C ----------TCSHME-----------------------------
C
      SUBROUTINE TCSHME(ISUBRO)
C
C     PURPOSE--SHOW THE DATAPLOT GUI MENU UNDER TURBO-C
C     DATAPLOT CALLING ROUTINE--MAIN
C     NOTE--WHEN THE USER ENTERS THE    MENU   COMMAND
C           FROM THE FORTRAN SIDE (BEFORE ANY MENU IS ON THE SCREEN)
C           TCLOTC IS THE FIRST ROUTINE CALLED
C           AND TCSHME IS THE SECOND ROUTINE CALLED
C           (BOTH FROM MAIN)
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ISUBRO
CCCCC INTEGER*4 NBYTES
      INTEGER NBYTES
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'SHME'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCSHME IN TCDRIV--')
         WRITE(9,52)ISUBRO,TCLOAD
   52    FORMAT(1H ,'ISUBRO,TCLOAD = ',A4,2X,A4)
      ENDIF
C
      IF(TCMENU.EQ.'OFF')THEN
         TEXTFC(1:4)='SHME'
         TEXTFC(5:8)='SHME'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CNOPC    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CNOPC    CALL REAL_MODE@
         TCMENU='ON'
CNOPC    OPEN(UNIT=7,FILE='C:\TURBOC\FRONTEND\DPTEOU.TEX')
         OPEN(UNIT=7,FILE='DPTEOU.TEX')
         IPR=7
         TCTEFI='OPEN'
      ENDIF
C
      IF(ISUBRO.EQ.'SHME'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCSHME IN TCDRIV--')
         WRITE(9,9012)ISUBRO,TCLOAD,TEXTCF(1:4)
 9012    FORMAT(1H ,'ISUBRO,TCLOAD,TEXTCF(1:4) = ',A4,2X,A4,2X,A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCGECO-----------------------------
C
      SUBROUTINE TCGECO(IB,NIB,IBUGS2,ISUBRO)
C
C     PURPOSE--GET A DATAPLOT COMMAND FROM THE GUI MENU
C     DATAPLOT CALLING ROUTINE--DPGETC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC INTEGER*4 NBYTES
      INTEGER NBYTES
C
      CHARACTER*4 ISTEPN
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
C
      CHARACTER*4 IBUGS2
      CHARACTER*4 ISUBRO
CCCCC CHARACTER*4 IFOUND
CCCCC CHARACTER*4 IERROR
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      CHARACTER*80 IB
C
      ISUBN1='TCGE'
      ISUBN2='CO  '
C
      ISTEPN='--0-'
CCCCC ISUBRO='GECO'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
  105 FORMAT(1H ,'TRACE AT STEP ',A4,' OF ',A4,A4)
      NIB=0
      IF(TCMENU.EQ.'ON')THEN
         ENDFILE 7
         CLOSE(7)
         IPR=6
         TCTEFI='CLOS'
         TEXTCF=' '
         TEXTFC(1:4)='GECO'
         TEXTFC(5:8)='GECO'
      ISTEPN='1'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
C
CNOPC    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CNOPC    CALL REAL_MODE@
C
CCCCC    NBYTES=8+80
         NBYTES=12+84+84
CNOPC    CALL COPY_FROM_REAL_MODE@(NTEXTF,NBYTES)
      ISTEPN='4'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
      WRITE(9,885)NTEXTF,NTEXTC
  885 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--NTEXTF,NTEXTC = ',2I8)
      WRITE(9,886)TEXTFC(1:10)
  886 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTFC(1:10) = ',A10)
      WRITE(9,887)TEXTCF(1:10)
  887 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTCF(1:10) = ',A10)
C
         NIB=NTEXTC
         IB=TEXTCF
C
         IF(TEXTCF(1:4).EQ.'EXME'.OR.TEXTCF(1:4).EQ.'ERRO')THEN
            TCMENU='OFF'
            TCTEFI='CLOS'
         ELSE IF(TEXTCF(1:4).EQ.'EXIT')THEN
            TCMENU='OFF'
            TCTEFI='CLOS'
CCCCC       ENDFILE 9  6/12/92
CCCCC       CLOSE(9) 6/12/92
            ENDFILE 9
            CLOSE(9)
CCCCC THE FOLLOWING LINE WAS ADDED AUGUST 1992
            RETURN
         ELSE
CNOPC       OPEN(UNIT=7,FILE='C:\TURBOC\FRONTEND\DPTEOU.TEX')
            OPEN(UNIT=7,FILE='DPTEOU.TEX')
            IPR=7
            TCTEFI='OPEN'
         ENDIF
C
      ENDIF
C
      WRITE(9,888)TEXTCF(1:10)
  888 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--TEXTCF(1:10) = ',A10)
      WRITE(9,889)IB
  889 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--IB = ',A80)
      WRITE(9,890)NIB
  890 FORMAT(1H ,'FROM TCDRIV/TCGECO.FOR--NIB = ',I4)
      DO895I=1,80
      JIB=ICHAR(IB(I:I))
      IF(JIB.LE.31)IB(I:I)=' '
CCCCC WRITE(9,896)I,IB(I:I),JIB
CC896 FORMAT(1H ,'I,IB(I:I),JIB = ',I8,2X,A1,I8)
  895 CONTINUE
      WRITE(9,990)
  990 FORMAT(1H )
C
      ISTEPN='-99-'
      IF(IBUGS2.EQ.'ON'.OR.ISUBRO.EQ.'GECO'.OR.ISUBRO.EQ.'DRIV')
     1WRITE(9,105)ISTEPN,ISUBN1,ISUBN2
      RETURN
      END
C
C ----------TCINDE-----------------------------
C
      SUBROUTINE TCINDE
C
C     PURPOSE--INITIALIZE (LOAD IN) THE TURBO-C C DRIVER (CMAIN.C)
C              (THIS IS DONE ONLY ONCE PER DATAPLOT RUN)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--GRINDE
C     NOTE--WHEN THE MENU IS ON THE SCREEN
C           AND THE USER ENTERS A PLOT COMMAND (SUCH AS HISTOGRAM Y),
C           TCINDE IS THE FIRST ROUTINE CALLED
C           AND TCOPDE IS THE SECOND ROUTINE CALLED
C           IN GETTING THE PLOT ONTO THE MENU'S PLOT WINDOW.
C           (TCINDE FROM GRINDE    AND    TCOPDE FROM GROPDE).
C           NOTE THAT THE FIRST CALL (TCINDE) IS IN FACT UNNECESSARY
C           SINCE THE FORTRAN-TO-C LINK HAS ALREADY BEEN ESTABLISHED
C           BACK IN THE SUBROUTINE TCLOTC--WHICH WAS CALLED
C           WHEN THE USER CAUSED THE MENU TO APPEAR
C           BY ENTERING THE FORTRAN-SIDE COMMAND    MENU.
C     NOTE--TCINDE.FOR    HAS NO CORRESPONDANCE IN    TUDRIV.C
C
      CHARACTER*4 ISUBRO
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
CCCCC THE FOLLOWING LINE SHOULD BE COMMENTED OUT WHEN DEBUGGED
      ISUBRO='DRIV'
      IF(ISUBRO.EQ.'INDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINDE IN TCDRIV--')
         WRITE(9,53)TCPLFI,TCTEFI,TCLOAD
   53    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,54)TCMENU,IPLATF
   54    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,55)TEXTFC(1:20)
   55    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,56)TEXTCF(1:20)
   56    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      IF(TCLOAD.EQ.'NO')THEN
CNOPC    CALL REAL_MODE_SHORT_CUT@
CCCCC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAINF.EXE')
CNOPC    CALL LOAD_REAL_MODE_LIBRARY@('C:\TURBOC\FRONTEND\CMAIN.EXE')
         TCLOAD='YES'
      ENDIF
C
      IPLATF='WITHINMENU'
      IF(TCMENU.EQ.'OFF')IPLATF='STANDALONE'
C
      IF(ISUBRO.EQ.'INDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCINDE IN TCDRIV--')
         WRITE(9,9013)TCPLFI,TCTEFI,TCLOAD
 9013    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,9014)TCMENU,IPLATF
 9014    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,9015)TEXTFC(1:20)
 9015    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,9016)TEXTCF(1:20)
 9016    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      RETURN
      END
C
C ----------TCOPDE-----------------------------
C
      SUBROUTINE TCOPDE
C
C     PURPOSE--OPEN TURBO-C GRAPHICS
C              (THE INITIALIZATION IS ALREADY ASSUMED TO BE DONE)
C     NOTE--THE CALL TO REAL_MODE_LIBRARY@ MUST BE DONE
C           AT MOST ONCE DURING ANY DATAPLOT RUN.
C     DATAPLOT CALLING ROUTINE--GROPDE
C     NOTE--WHEN THE MENU IS ON THE SCREEN
C           AND THE USER ENTERS A PLOT COMMAND (SUCH AS HISTOGRAM Y),
C           TCINDE IS THE FIRST ROUTINE CALLED
C           AND TCOPDE IS THE SECOND ROUTINE CALLED
C           IN GETTING THE PLOT ONTO THE MENU'S PLOT WINDOW.
C           (TCINDE FROM GRINDE    AND    TCOPDE FROM GROPDE).
C           NOTE THAT THE FIRST CALL (TCINDE) IS IN FACT UNNECESSARY
C           SINCE THE FORTRAN-TO-C LINK HAS ALREADY BEEN ESTABLISHED
C           BACK IN THE SUBROUTINE TCLOTC--WHICH WAS CALLED
C           WHEN THE USER CAUSED THE MENU TO APPEAR
C           BY ENTERING THE FORTRAN-SIDE COMMAND    MENU.
C
      CHARACTER*4 ISUBRO
CCCCC INTEGER*4 NBYTES
      INTEGER NBYTES
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
CCCCC THE FOLLOWING LINE SHOULD BE COMMENTED OUT WHEN DEBUGGED
      ISUBRO='DRIV'
      IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCOPDE IN TCDRIV--')
         WRITE(9,53)TCPLFI,TCTEFI,TCLOAD
   53    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,54)TCMENU,IPLATF
   54    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,55)TEXTFC(1:20)
   55    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,56)TEXTCF(1:20)
   56    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
CCCCC WRITE(6,777)TCPLFI
CC777 FORMAT(1H ,'TCPLFI = ',A4)
C
      IF(TCPLFI.EQ.'CLOS')THEN
CCCCC    OPEN(UNIT=8,FILE='C:\TURBOC\FRONTEND\DPGROU.TEX')
         TEXTFC(1:4)='PLOT'
         TEXTFC(5:8)='OPDE'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CNOPC    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CNOPC    CALL REAL_MODE@
         NPLOTF=0
         TCPLFI='OPEN'
      ENDIF
C
CCCCC WRITE(6,778)TCPLFI
CC778 FORMAT(1H ,'TCPLFI = ',A4)
C
      COMMFC='INDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IPLATF,INULC
  112 FORMAT(A4,1X,A10,A1)
CCCCC IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCOPDE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='OPDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
      IF(NPLOTF.GE.10) CALL TCSEND
C
      IF(ISUBRO.EQ.'OPDE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9011)
 9011    FORMAT(1H ,'***** AT THE END       OF TCOPDE IN TCDRIV--')
         WRITE(9,9013)TCPLFI,TCTEFI,TCLOAD
 9013    FORMAT(1H ,'TCPLFI,TCTEFI,TCLOAD= ',A4,2X,A4,2X,A4)
         WRITE(9,9014)TCMENU,IPLATF
 9014    FORMAT(1H ,'TCMENU,IPLATF = ',A4,2X,A10)
         WRITE(9,9015)TEXTFC(1:20)
 9015    FORMAT(1H ,'TEXTFC(1:20) = ',A20)
         WRITE(9,9016)TEXTCF(1:20)
 9016    FORMAT(1H ,'TEXTCF(1:20) = ',A20)
      ENDIF
C
      RETURN
      END
C
C ----------TCCLDE-----------------------------
C
      SUBROUTINE TCCLDE
C
C     PURPOSE--CLOSE TURBO C GRAPHICS
C     DATAPLOT CALLING ROUTINE--GRCLDE
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='CLDE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(NPLOTF.GE.10) CALL TCSEND
CNOPC CALL TCSEND
C
CCCCC ENDFILE 8
CCCCC CLOSE(8)
      TCPLFI='CLOS'
C
CCCCC CLOSE(9)
C
CCCCC TEXTFC=' '
CCCCC TEXTFC(1:4)='CLDE'
CCCCC NBYTES=8+4
CCCCC CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CCCCC CALL REAL_MODE@
C
      RETURN
      END
C
C ----------TCCHEX-----------------------------
C
      SUBROUTINE TCCHEX
C
C     PURPOSE--CHECK FOR EXPOSE AND CONFIGURATION EVENTS.
C              (NOT NEEDED FOR TURBO C)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCREMO-----------------------------
C
      SUBROUTINE TCREMO
C
C     PURPOSE--READ POSITION FROM THE GRAPHICS WINDOW.
C              THE MOUSE POSITION AT THE NEXT MOUSE CLICK
C              WILL BE DETERMINED.
C              THIS ROUTINE WILL WAIT UNTIL A MOUSE BUTTON
C              IS PRESSED.
C              THIS IS USED BY THE DATAPLOT CROSS-HAIR COMMAND.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCERSC-----------------------------
C
      SUBROUTINE TCERSC
C
C     PURPOSE--ERASE THE SCREEN (= REGION (X1,Y1)-(X2,Y2).)
C              DEFINE A VIEWPORT THAT WILL BE USED
C              AS THE GRAPHICS AREA.
C              (AND ERASE THE AREA ONLY).
C     DATAPLOT CALLING ROUTINE--GRERSC
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='ERSC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'ERSC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCERSC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCRIBE-----------------------------
C
      SUBROUTINE TCRIBE
C
C     PURPOSE--RING THE BELL
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='RIBE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'RIBE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCRIBE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCCOSC-----------------------------
C
      SUBROUTINE TCCOSC
C
C     PURPOSE--COPY THE SCREEN
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='COSC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111 FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'COSC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCCOSC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCRESC----------------------------
C
      SUBROUTINE TCRESC(PX1,PY1)
C
C     PURPOSE--READ THE SCREEN (VIA CROSS-HAIR OR MOUSE)
CCCCC ***** NOT YET WORKING *****
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='RESC'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'RESC'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCRESC.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCUPSC-----------------------------
C
      SUBROUTINE TCUPSC
C
C     PURPOSE--COPY THE PIXMAP TO THE SCREEN.
C              UPDATE THE GRAPHICS WINDOW WITH
C              A PREVIOUSLY SAVED WINDOW.
C              (NOT USED FOR PC DRIVER)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCFLBU-----------------------------
C
      SUBROUTINE TCFLBU
C
C     PURPOSE--FLUSH THE SCREEN BUFFER.
C              (NEEDED ON PC?)
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      RETURN
      END
C
C ----------TCSEMO-----------------------------
C
      SUBROUTINE TCSEMO(IMODE)
C
C     PURPOSE--SET THE MODE
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 IMODE
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='SEMO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IMODE,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEMO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEMO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSECO-----------------------------
C
      SUBROUTINE TCSECO(ICASE,ICOL)
C
C     PURPOSE--SET THE COLOR
C
CCCCC INTEGER*4 NBYTES
      INTEGER NBYTES
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ICASE
      CHARACTER*4 ICOL
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      IF(TCPLFI.EQ.'CLOS')THEN
CCCCC    OPEN(UNIT=8,FILE='C:\TURBOC\FRONTEND\DPGROU.TEX')
         TEXTFC(1:4)='PLOT'
         TEXTFC(5:8)='SECO'
CCCCC    NBYTES=8+4
CCCCC    NBYTES=12+4
         NBYTES=12+4+4
CNOPC    CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CNOPC    CALL REAL_MODE@
         NPLOTF=0
         TCPLFI='OPEN'
C
         COMMFC='INDE'
         NPLOTF=NPLOTF+1
         PLOTFC(NPLOTF)=' '
         WRITE(PLOTFC(NPLOTF),112)COMMFC,IPLATF,INULC
  112    FORMAT(A4,1X,A10,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSECO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC    IF(NPLOTF.GE.10) CALL TCSEND
C
         COMMFC='OPDE'
         NPLOTF=NPLOTF+1
         PLOTFC(NPLOTF)=' '
         WRITE(PLOTFC(NPLOTF),111)COMMFC,INULC
  111    FORMAT(A4,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC    IF(NPLOTF.GE.10) CALL TCSEND
C
      ENDIF
C
      COMMFC='SECO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),113)COMMFC,ICASE,ICOL,INULC
  113 FORMAT(A4,1X,A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SECO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEPA-----------------------------
C
      SUBROUTINE TCSEPA(ICASE,IPATT)
C
C     PURPOSE--SET THE PATTERN
C
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ICASE
      CHARACTER*4 IPATT
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='SEPA'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),113)COMMFC,ICASE,IPATT,INULC
  113 FORMAT(A4,1X,A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEPA'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEPA.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSETH----------------------------
C
      SUBROUTINE TCSETH(PTHICK)
C
C     PURPOSE--SET LINE THICKNESS.
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='SETH'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PTHICK,INULC
  122 FORMAT(A4,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'SETH'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSETH.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEFO----------------------------
C
      SUBROUTINE TCSEFO(FONT)
C
C     PURPOSE--SET TEXT FONT.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 FONT
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='SEFO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,FONT,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEFO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEFO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSECA----------------------------
C
      SUBROUTINE TCSECA(ICASE)
C
C     PURPOSE--SET TEXT CASE.
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 ICASE
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='SECA'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,ICASE,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SECA'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSECA.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEFI----------------------------
C
      SUBROUTINE TCSEFI(IFILL)
C
C     PURPOSE--SET REGION FILL.???
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      CHARACTER*4 IFILL
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='SEFI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IFILL,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEFI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEFI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSESI----------------------------
C
      SUBROUTINE TCSESI(PHEIGH,PWIDTH,PVEGAP,PHOGAP)
C
C     PURPOSE--SET TEXT SIZE.
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='SESI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PHEIGH,PWIDTH,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'SESI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSESI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEDI----------------------------
C
      SUBROUTINE TCSEDI(IDIR)
C
C     PURPOSE--SET TEXT DIRECTION.
      CHARACTER*4 IDIR
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='SEDI'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,IDIR,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEDI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEDI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCSEJU----------------------------
C
      SUBROUTINE TCSEJU(JUST)
C
C     PURPOSE--SET TEXT JUSTIFICATION.
      CHARACTER*4 JUST
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='SEJU'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),112)COMMFC,JUST,INULC
  112 FORMAT(A4,1X,A4,A1)
CCCCC IF(ISUBRO.EQ.'SEJU'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEJU.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCMOTO----------------------------
C
      SUBROUTINE TCMOTO(PX1,PY1)
C
C     PURPOSE--MOVE TO A POINT (INVISIBLY)
C              DO NOT DRAW.   DO NOT ACTIVATE THE PIXEL.
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'MOTO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCMOTO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRPO----------------------------
C
      SUBROUTINE TCDRPO(PX1,PY1)
C
C     PURPOSE--DRAW A POINT (ACTIVATE A PIXEL).
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='DRPO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),122)COMMFC,PX1,PY1,INULC
  122 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRPO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRPO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRLI----------------------------
C
      SUBROUTINE TCDRLI(PX1,PY1,PX2,PY2)
C
C     PURPOSE--DRAW A (P1-SEGMENT) LINE FROM (PX1,PY1) TO (PX2,PY2).
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRLI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRLI.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
      IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRLI'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRBO----------------------------
C
      SUBROUTINE TCDRBO(PX1,PY1,PX2,PY2)
C
C     PURPOSE--DRAW A BOX (BUT DO NOTHING ABOUT FILL).
C              THE COLOR OF THE BOX BORDER IS DICTATED BY
C              THE LAST CALL TO TCFIFC (FORE!GROUND COLOR).
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRBO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY1,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY2,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
CCCCC IF(ISUBRO.EQ.'DRBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCDRPL----------------------------
C
      SUBROUTINE TCDRPL(PXV,PYV,NV)
C
C     PURPOSE--DRAW A LINE OR POLYLINE.
C              NOTE THAT THE ATTRIBUTES OF THE LINE HAVE ALREADY
C              BEEN SET (BY THE TCSELP, TCSELT, AND TCSEFG ROUTINES).
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      DIMENSION PXV(*)
      DIMENSION PYV(*)
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PXV(1),PYV(1),INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'DRPL'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCDRPL.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      IF(NV.LE.1)GOTO1090
      COMMFC='DRTO'
      DO1000I=2,NV
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PXV(I),PYV(I),INULC
CCCCC IF(ISUBRO.EQ.'DRPL'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
 1000 CONTINUE
 1090 CONTINUE
C
      RETURN
      END
C
C ----------TCFIBO----------------------------
C
      SUBROUTINE TCFIBO(PX1,PY1,PX2,PY2)
C
C     PURPOSE--FILL A BOX (BUT ONLY WITH SOLID FILL).
C              THE COLOR OF THE FILL IS DICTATED BY
C              THE LAST CALL TO ...
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              PROGRAM (I.E., SEND THE INDIVIDUAL LINES TO THE
C              TCDRLI ROUTINE).  ???
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='MOTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
  123 FORMAT(A4,1X,F10.5,1X,F10.5,A1)
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCFIBO.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      COMMFC='DRTO'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY1,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX2,PY2,INULC
      IF(NPLOTF.GE.10) CALL TCSEND
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY2,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),123)COMMFC,PX1,PY1,INULC
CCCCC IF(ISUBRO.EQ.'FIBO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCWRTE----------------------------
C
      SUBROUTINE TCWRTE(ISTRI4,NSTRI4)
C
C     PURPOSE--WRITE OUT A HORIZONTAL STRING AT CURRENT POISTION
      CHARACTER*4 ISTRI4
      DIMENSION ISTRI4(*)
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
      COMMFC='WRTE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      WRITE(PLOTFC(NPLOTF),132)COMMFC,(ISTRI4(I),I=1,NSTRI4),INULC
  132 FORMAT(A4,1X,80A1,A1)
CCCCC IF(ISUBRO.EQ.'WRTE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCWRTE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
C
      RETURN
      END
C
C ----------TCFIRE----------------------------
C
      SUBROUTINE TCFIRE(PXV,PYV,NV)
C
C     PURPOSE--FILL A REGION.
C              RECTANGULAR REGIONS WILL BE FILLED DIFFERENTLY
C              THAN NON-RECTANGULAR REGIONS.  DATAPLOT ONLY
C              HANDLES CONVEX POLYGONS, SO SET THIS (FOR FASTER
C              PERFORMANCE).
C              THIS ROUTINE ONLY DOES SOLID FILL.
C              THE COLOR OF THE FILL IS DICTATED BY
C              THE LAST CALL TO TCFIFC (FORE!GROUND COLOR).
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              HATCH PATTERNS MUST BE DRAWN BY THE CALLING
C              PROGRAM (I.E., SEND THE INDIVIDUAL LINES TO THE
C              TCDRLI ROUTINE).
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
      DIMENSION PXV(*)
      DIMENSION PYV(*)
CCCCC OCTOBER 1993.  ADD FOLLOWING LINE
      CHARACTER*4 COMMFC
C
      COMMFC='FIRE'
      NPLOTF=NPLOTF+1
      PLOTFC(NPLOTF)=' '
      DO2100I=1,NV
CCCCC NOT YET DONE
CCCCC IF(ISUBRO.EQ.'FIRE'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCFIRE.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
CNOPC IF(NPLOTF.GE.10) CALL TCSEND
 2100 CONTINUE
C
      RETURN
      END
C
C ----------TCSEND----------------------------
C
      SUBROUTINE TCSEND
C
C     PURPOSE--SEND NGRBYT BYTES
C              OF TC'S COMMON--
C                 84 BYTES OF TEXTFC,
C                 4 BYTES OF NTEXTF,
C                 4 BYTES FOR NPLOTF,
C                 (AT MOST) 11*84 BYTES OF PLOTFC
C              TO THE C-SIDE.
C
C     WRITTEN BY--JAMES J. FILLIBEN
C     ORIGINAL VERSION--MAY  18, 1991
C
CCCCC INTEGER*4 NBYTES
      INTEGER NBYTES
      INCLUDE 'DPCODV.INC'
      INCLUDE 'DPCONP.INC'
C
CCCCC IF(ISUBRO.EQ.'SEND'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,811)
  811    FORMAT(1H ,'FROM TCSEND.FOR--NPLOTF,PLOTFC(NPLOTF) =')
         WRITE(9,812)NPLOTF,PLOTFC(NPLOTF)
  812    FORMAT(1H ,I4,2X,A84)
CCCCC ENDIF
C
CCCCC NBYTES=(8+84)+(84*NPLOTF)
      NBYTES=(12+84+84)+(84*NPLOTF)
CNOPC CALL COPY_TO_REAL_MODE@(NTEXTF,NBYTES)
CNOPC CALL REAL_MODE@
      NPLOTF=0
C
      RETURN
      END
C
C ----------TCINCF-----------------------------
C
      SUBROUTINE TCINCF(ISUBRO)
C
C     PURPOSE--INITIALIZE (= MAKE EMPTY) THE FILE ...DPCOIN
C              THAT WILL RECEIVE COMMAND LINES.
C     DATAPLOT CALLING ROUTINE--MAIN
C
      CHARACTER*4 ISUBRO
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'INCF'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCINCF IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
      ENDIF
C
CNOPC OPEN(UNIT=10,FILE='C:\TURBOC\FRONTEND\DPCOIN.TEX')
      OPEN(UNIT=10,FILE='DPCOIN.TEX')
      ENDFILE 10
      CLOSE(10)
C
      IF(ISUBRO.EQ.'INCF'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9021)
 9021    FORMAT(1H ,'***** AT THE END       OF TCINCF IN TCDRIV--')
         WRITE(9,9022)ISUBRO
 9022    FORMAT(1H ,'ISUBRO = ',A4)
      ENDIF
C
      RETURN
      END
C
C ----------TCWRCO-----------------------------
C
      SUBROUTINE TCWRCO(STRING,ISUBRO)
C
C     PURPOSE--WRITE THE LAST ENTERED COMMAND LINE
C              (CONSISTING OF 80 CHARACTERS IN STRING())
C              TO THE END OF FILE ...TCCOMF.TEX
C     DATAPLOT CALLING ROUTINE--DPGETC
C
      CHARACTER*80 STRING
      CHARACTER*4 ISUBRO
      CHARACTER*1 ICJUNK
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
C
      IF(ISUBRO.EQ.'WRCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
  999    FORMAT(1H )
         WRITE(9,51)
   51    FORMAT(1H ,'***** AT THE BEGINNING OF TCWRCO IN TCDRIV--')
         WRITE(9,52)ISUBRO
   52    FORMAT(1H ,'ISUBRO = ',A4)
         WRITE(9,54)STRING(1:80)
   54    FORMAT(1H ,'STRING(1:80) = ',A80)
      ENDIF
C
CNOPC OPEN(UNIT=10,FILE='C:\TURBOC\FRONTEND\DPCOIN.TEX')
      OPEN(UNIT=10,FILE='DPCOIN.TEX')
C
      DO1100I=1,1000000
      READ(10,1105,END=1180)ICJUNK
 1105 FORMAT(A1)
 1100 CONTINUE
C
 1180 CONTINUE
      BACKSPACE 10
C
      WRITE(10,1181)STRING(1:80)
 1181 FORMAT(A80)
C
      ENDFILE 10
      CLOSE(10)
C
      IF(ISUBRO.EQ.'WRCO'.OR.ISUBRO.EQ.'DRIV')THEN
         WRITE(9,999)
         WRITE(9,9021)
 9021    FORMAT(1H ,'***** AT THE END       OF TCWRCO IN TCDRIV--')
         WRITE(9,9022)ISUBRO
 9022    FORMAT(1H ,'ISUBRO = ',A4)
         WRITE(9,9024)STRING(1:80)
 9024    FORMAT(1H ,'STRING(1:80) = ',A80)
      ENDIF
C
      RETURN
      END

      program temp
c
      character*1 ia
      real nor01, nor05
c
      open(1,file='NORPPCCS.DAT')
      open(2,file='TEMP01.DAT')
      open(3,file='TEMP05.DAT')
c
      do10i=1,25
        read(1,'(a1)')ia
   10 continue
c
      do20i=1,998
        read(1,*) in,nor01,nor05
        write(2,22)i,nor01
        write(3,24)i,nor05
   20 continue
   22 format('DATA ANOR01(',I3,') / ',F7.4,' /')
   24 format('DATA ANOR05(',I3,') / ',F7.4,' /')
c
      stop
      end

      PROGRAM INSTALL_1
C
C  CREATE THE FOLLOWING FILES FOR THE WINDOWS DATAPLOT
C  INSTALLATION:
C
C  1. DPCOMM.BAT - RUNS THE COMMAND LINE VERSION
C  2. DP.BAT     - RUUNS THE GUI VERSION
C  3. FRSCRIPT\XDPCONFIG_NT  - CONFIG FILE FOR WINDOWS NT/2000/XP
C  4. FRSCRIPT\XDPCONFIG_98  - CONFIG FILE FOR WINDOWS 95/98/ME
C
C  THE DATAPLOT DIRECTORY WILL BE ADDED AS A COMMAND LINE ARGUMENT
C  WHEN THIS PROGRAM IS RUN.
C
      CHARACTER*256 IPATH, IPATH2, BUF
      CHARACTER*256 IDIR1, IDIR2, IDIR3, IDIR4
      CHARACTER*256 IEXEC, ILIB
C
      NUM=NARGS()
      IPATH=' '
      IPATH(1:21)='C:\Program Files\NIST'
      IF(NUM.GT.1)THEN
        CALL GETARG(1,BUF,ISTATUS)
        IPATH=' '
        IPATH(1:ISTATUS)=BUF(1:ISTATUS)
        NCPATH=ISTATUS
        IF(IPATH(NCPATH:NCPATH).EQ.'"')NCPATH=NCPATH-1
        IF(IPATH(NCPATH:NCPATH).EQ.'\')NCPATH=NCPATH-1
        IF(IPATH(1:1).EQ.'"')THEN
           DO10I=2,NCPATH
             IPATH2(I-1:I-1)=IPATH(I:I)
 10        CONTINUE
           NCPATH=NCPATH-1
           IPATH(1:NCPATH)=IPATH2(1:NCPATH)
        ENDIF
      ENDIF
C
C  NOW CREATE THE DPCOMM.BAT FILE
C
      IDIR1=' '
      IDIR2=' '
      IDIR3=' '
      IDIR4=' '
      IDIR1(1:NCPATH)=IPATH(1:NCPATH)
      NSTRT=NCPATH+1
      NSTOP=NCPATH+9
      IDIR1(NSTRT:NSTOP)='\DATAPLOT'
      IDIR2(1:NSTOP)=IDIR1(1:NSTOP)
      IDIR3(1:NSTOP)=IDIR1(1:NSTOP)
      NSTRT2=NSTOP+1
      NSTOP2=NSTOP+9
      IDIR3(NSTRT2:NSTOP2)='\FRSCRIPT'
      IDIR4(1:NSTOP2)=IDIR3(1:NSTOP2)
      NSTRT3=NSTOP+1
      NSTOP3=NSTOP+11
      IDIR1(NSTRT3:NSTOP3)='\DPCOMM.BAT'
      NSTRT4=NSTOP+1
      NSTOP4=NSTOP+7
      IDIR2(NSTRT4:NSTOP4)='\DP.BAT'
      NSTRT5=NSTOP2+1
      NSTOP5=NSTOP2+13
      IDIR3(NSTRT5:NSTOP5)='\XDPCONFIG_98'
      NSTRT6=NSTOP2+1
      NSTOP6=NSTOP2+13
      IDIR4(NSTRT6:NSTOP6)='\XDPCONFIG_NT'
C
C  OPEN THE OUTPUT FILES
C
      OPEN(11,FILE=IDIR1)
      OPEN(12,FILE=IDIR2)
      OPEN(13,FILE=IDIR3)
      OPEN(14,FILE=IDIR4)
C
C  DEFINE PATH TO GUI EXECUTABLE, LIBRARY
C
      IEXEC=' '
      IEXEC(1:NCPATH)=IPATH(1:NCPATH)
      IEXEC(NSTR:NSTOP)='\DATAPLOT'
      NSTRT7=NSTRT+1
      NSTOP7=NSTRT+12
      IEXEC(NSTRT7:NSTOP7)='\DPLAHEY.EXE'
      ILIB=' '
      ILIB(1:NCPATH)=IPATH(1:NCPATH)
      ILIB(NSTR:NSTOP)='\DATAPLOT'
C
C  CREATE DPCOMM.BAT FILE
C
      WRITE(11,101)
  101 FORMAT('REM THIS FILE CONTAINS A BATCH JOB TO RUN THE ',
     1       'COMMAND LINE VERSION OF')
      WRITE(11,102)
  102 FORMAT('REM DATAPLOT THAT CAN BE EXECUTED FROM A SHORTCUT.')
      WRITE(11,103)
  103 FORMAT('REM')
      WRITE(11,104)
  104 FORMAT('REM IN THE SHORTCUT, THE COMMAND LINE SHOULD BE ',
     1       'SETUP AS:')
      WRITE(11,105)
  105 FORMAT('REM')
      WRITE(11,106)
  106 FORMAT('REM      "C:\Program Files\NIST\DATAPLOT\DPCOMM.BAT"')
      WRITE(11,107)
  107 FORMAT('REM')
      WRITE(11,108)
  108 FORMAT('')
      WRITE(11,109)
  109 FORMAT('REM SET LOCATION OF DATAPLOT DIRECTORY')
      WRITE(11,110)IPATH(1:NCPATH)
  110 FORMAT('SET DPDIR=',A)
      WRITE(11,111)
  111 FORMAT('')
      WRITE(11,112)
  112 FORMAT('REM FOLLOWING LINES FOR BOTH COMMAND LINE (AND GUI) ',
     1      'VERSION OF DATAPLOT')
      WRITE(11,113)
  113 FORMAT('SET DATAPLO$=%DPDIR%\DATAPLOT\')
      WRITE(11,114)
  114 FORMAT('SET FED$=%DPDIR%\DATAPLOT\')
      WRITE(11,115)
  115 FORMAT('SET PATH=%PATH%;%DPDIR%\DATAPLOT')
      WRITE(11,116)
  116 FORMAT('')
      WRITE(11,117)
  117 FORMAT('REM FOLLOWING COMMAND LINE OPTIONS SUPPORTED:')
      WRITE(11,118)
  118 FORMAT('REM')
      WRITE(11,119)
  119 FORMAT('REM SIZE (defaults to VGA size screen):')
      WRITE(11,120)
  120 FORMAT('REM   -svga     (for SVGA size screen)')
      WRITE(11,121)
  121 FORMAT('REM   -large    (for >= 1280x1040 resolutions)')
      WRITE(11,122)
  122 FORMAT('REM COLOR MODE:')
      WRITE(11,123)
  123 FORMAT('REM   -true     (use if true color mode set ',
     1       'for display)')
      WRITE(11,124)
  124 FORMAT('REM             (omit this option if true color ',
     1       'mode not set,')
      WRITE(11,125)
  125 FORMAT('REM             if you do not see any text on the ',
     1       ' screen, reverse')
      WRITE(11,126)
  126 FORMAT('REM             setting given here)')
      WRITE(11,127)
  127 FORMAT('REM TILING:')
      WRITE(11,128)
  128 FORMAT('REM   -tile     set if you want text and graphics ',
     1       'windows tiled')
      WRITE(11,129)
  129 FORMAT('REM')
      WRITE(11,130)
  130 FORMAT('REM You can set these options either here or on ',
     1       'the shortcut that intiates')
      WRITE(11,131)
  131 FORMAT('REM DPCOMM.BAT.')
      WRITE(11,132)
  132 FORMAT('')
      WRITE(11,133)
  133 FORMAT('"%DPDIR%\DATAPLOT\DATAPLOT.EXE" %1 %2 %3 %4 %5 %6 %7')
C
C
C  NOW CREATE THE DP.BAT FILE
C
      WRITE(12,201)
  201 FORMAT('REM THIS FILE CONTAINS A BATCH JOB THAT CAN BE ',
     1       'EXECUTED FROM A SHORTCUT.')
      WRITE(12,202)
  202 FORMAT('REM')
      WRITE(12,203)
  203 FORMAT('REM THE "DPDIR" AND "TCLDIR" VARIABLES DEFINE THE ',
     1       'LOCATION OF THE')
      WRITE(12,204)
  204 FORMAT('REM DATAPLOT AND TCL\TK DIRECTORIES RESPECTIVELY.  IF ',
     1       'THESE ARE')
      WRITE(12,205)
  205 FORMAT('REM SET CORRECTLTY, NO OTHER EDITS SHOULD BE REQUIRED ',
     1       'IN THIS FILE.')
      WRITE(12,206)
  206 FORMAT('REM')
      WRITE(12,207)
  207 FORMAT('')
      WRITE(12,208)IPATH(1:NCPATH)
  208 FORMAT('SET DPDIR=',A)
      WRITE(12,209)
  209 FORMAT('SET TCLDIR=C:\Program Files')
      WRITE(12,210)
  210 FORMAT('')
      WRITE(12,211)
  211 FORMAT('SET DATAPLO$=%DPDIR%\DATAPLOT\')
      WRITE(12,212)
  212 FORMAT('SET FED$=%DPDIR%\DATAPLOT\')
      WRITE(12,213)
  213 FORMAT('SET PATH=%PATH%;%DPDIR%\DATAPLOT')
      WRITE(12,214)
  214 FORMAT('')
      WRITE(12,215)
  215 FORMAT('SET TCL_LIBRARY=%TCLDIR%\TCL\LIB\TCL8.3')
      WRITE(12,216)
  216 FORMAT('SET TK_LIBRARY=%TCLDIR%\TCL\LIB\TK8.3')
      WRITE(12,217)
  217 FORMAT('')
      WRITE(12,218)
  218 FORMAT('SET XDP_FILE=%DPDIR%\DATAPLOT\FRMENUS')
      WRITE(12,219)
  219 FORMAT('SET XDP_CODE=%DPDIR%\DATAPLOT\FRSCRIPT')
      WRITE(12,220)
  220 FORMAT(' ')
      WRITE(12,221)
  221 FORMAT('REM FOLLOWING COPIES OVER THE APPROPRIATE XDPCONFIG ',
     1       'FILE.')
      WRITE(12,222)
  222 FORMAT('REM DEFAULT TO WINDOWS 98, WINDOWS 2000/NT/XP USE ',
     1       'THE SAME,')
      WRITE(12,223)
  223 FORMAT('REM WINDOWS 95/98/ME USE THE SAME.')
      WRITE(12,224)
  224 FORMAT(' ')
      WRITE(12,225)
  225 FORMAT('COPY FRSCRIPT\XDPCONFIG_98  XDPCONFIG')
      WRITE(12,226)
  226 FORMAT('IF %OS% == WINDOWS_NT COPY FRSCRIPT\XDPCONFIG_NT ',
     1       'XDPCONFIG')
      WRITE(12,227)
  227 FORMAT('IF %OS% == WINDOWS_XP COPY FRSCRIPT\XDPCONFIG_NT ',
     1       'XDPCONFIG')
      WRITE(12,228)
  228 FORMAT(' ')
      WRITE(12,229)
  229 FORMAT('REM THE FOLLOWING ACTUALLY INITIATES THE DATAPLOT GUI.')
      WRITE(12,230)
  230 FORMAT('REM NOTE THAT THE "-right" OPTION JUSTIFIES THE ',
     1       'WINDOWS TO THE RIGHT')
      WRITE(12,231)
  231 FORMAT('REM OF THE SCREEN.  YOU CAN CHANGE THIS TO "-left" ',
     1       'FOR LEFT')
      WRITE(12,232)
  232 FORMAT('REM JUSTIFICATION OR OMIT FOR CENTER JUSTIFICATION.  ',
     1       'THIS IS')
      WRITE(12,233)
  233 FORMAT('REM SIMPLY A MATTER OF TASTE.')
      WRITE(12,234)
  234 FORMAT('')
      WRITE(12,235)
  235 FORMAT('"%TCLDIR%\Tcl\bin\wish83.exe" ',
     1       '"%DPDIR%\dataplot\frscript\xdp" -pc -right %1 %2 %3')
C
C  NOW CREATE XDPCONFIG_NT
C
      WRITE(13,301)
  301 FORMAT('#  This file contains executable and font ',
     1       'specifications for xdp.')
      WRITE(13,302)
  302 FORMAT(' ')
      WRITE(13,303)
  303 FORMAT('#  This file can exist in several locations.  It ',
     1       'is searched for in several')
      WRITE(13,304)
  304 FORMAT('#  directories and the first occurance of the file ',
     1       'is the one that will be')
      WRITE(13,305)
  305 FORMAT('#  used.  This way a user can have a different set ',
     1       'of fonts than the default')
      WRITE(13,306)
  306 FORMAT('#  values.')
      WRITE(13,307)
  307 FORMAT(' ')
      WRITE(13,308)
  308 FORMAT('#  The order of the directories where xdp looks for ',
     1       'this file is:')
      WRITE(13,309)
  309 FORMAT('#  (1) the current directory, (2) the user's home ',
     1       'directory, (3) the system')
      WRITE(13,310)
  310 FORMAT('#  directory for the xdp Tcl files.  The file can ',
     1       'be named xdpConfig or .xdpConfig')
      WRITE(13,311)
  311 FORMAT(' ')
      WRITE(13,312)
  312 FORMAT(' ')
      WRITE(13,313)
  313 FORMAT('#  The executable specification gives the pathname ',
     1       'for Dataplot executables')
      WRITE(13,314)
  314 FORMAT('#  on different platforms.  The second field ',
     1       'contains the name of the platform ')
      WRITE(13,315)
  315 FORMAT('#  (windows, unix) or operating system (IRIX, ',
     1       'AIX, HP-UX, SunOS, etc.).  The ')
      WRITE(13,316)
  316 FORMAT('#  operating system is usually only specified ',
     1       'for unix platforms.  Executable')
      WRITE(13,317)
  317 FORMAT('#  specifications based on operating system must ',
     1       'appear after those specified ')
      WRITE(13,318)
  318 FORMAT('#  by platform.')
      WRITE(13,319)
  319 FORMAT(' ')
      WRITE(13,320)
  320 FORMAT('#')
      WRITE(13,321)IEXEC(1:NSTOP7)
  321 FORMAT('dataplot windows   ',A)
      WRITE(13,322)
  322 FORMAT('dataplot unix     dataplot')
      WRITE(13,323)
  323 FORMAT(' ')
      WRITE(13,324)ILIB(1:NSTOP)
  324 FORMAT('library   windows  ',A)
      WRITE(13,325)
  325 FORMAT('library  unix     /usr/local/apps/dataplot/lib')
      WRITE(13,326)
  326 FORMAT(' ')
      WRITE(13,327)
  327 FORMAT('print    windows  ',
     1       '"c:/Program Files/Windows NT/Accessories/Wordpad.exe"')
      WRITE(13,328)
  328 FORMAT('edit     windows  ',
     1       '"c:/Program Files/Windows NT/Accessories/Wordpad.exe"')
      WRITE(13,329)
  329 FORMAT(' ')
      WRITE(13,330)
  330 FORMAT('# You can select which Internet browser you prefer ',
     1       'here.')
      WRITE(13,331)
  331 FORMAT('# browser  windows  ',
     1       '"c:/Program Files/Internet Explorer/Iexplore.exe"')
      WRITE(13,332)
  332 FORMAT('# browser  windows  ',
     1'"c:Program Files/Plus!/Microsoft Internet/Iexplore.exe"')
      WRITE(13,333)
  333 FORMAT('browser  windows  ',
     1'"c:/Program Files/NETSCAPE/Communicator/PROGRAM/netscape.exe"')
      WRITE(13,334)
  334 FORMAT('')
      WRITE(13,335)
  335 FORMAT('print    unix     lpr')
      WRITE(13,336)
  336 FORMAT('edit     unix     nedit')
      WRITE(13,337)
  337 FORMAT('browser  unix     netscape')
      WRITE(13,338)
  338 FORMAT('')
      WRITE(13,339)
  339 FORMAT('#  The font specifications allow a system ',
     1       'administrator or user to easily')
      WRITE(13,340)
  340 FORMAT('#  change the fonts used by xdp to their tastes or ',
     1       'limitations of the hardware.')
      WRITE(13,341)
  341 FORMAT(' ')
      WRITE(13,342)
  342 FORMAT('#  The first field contains the name of the ',
     1       'platform (windows, unix) or')
      WRITE(13,343)
  343 FORMAT('#  operating system (IRIX, AIX, HP-UX, SunOS, etc.).  ',
     1      'The operating system')
      WRITE(13,344)
  344 FORMAT('#  is usually only specified for unix platforms.  ',
     1       'Font specifications based')
      WRITE(13,345)
  345 FORMAT('#  on operating system must appear after those ',
     1       'specified by platform.')
      WRITE(13,346)
  346 FORMAT(' ')
      WRITE(13,347)
  347 FORMAT('#  The second field contains only the strings ',
     1       'variable, fixed_small, or')
      WRITE(13,348)
  348 FORMAT('#  fixed_large.  These refer to the 3 different ',
     1       'types of fonts used in xdp.')
      WRITE(13,349)
  349 FORMAT('#  The variable font is used for buttons and menus.',
     1       '  The fixed fonts are used')
      WRITE(13,350)
  350 FORMAT('#  for forms, some menus, entries, and text output.')
      WRITE(13,351)
  351 FORMAT(' ')
      WRITE(13,352)
  352 FORMAT('#  The third field contains the font in Tcl format.  ',
     1       'Each font contains ')
      WRITE(13,353)
  353 FORMAT('#  three fields.  The first is the font family.  ',
     1       'If the family name')
      WRITE(13,354)
  354 FORMAT('#  contains blanks, then it must be enclosed in ',
     1       'braces.  The second field')
      WRITE(13,355)
  355 FORMAT('#  contains the point size of the font.  A + or - ',
     1       'can be in front of the point')
      WRITE(13,356)
  356 FORMAT('#  size.  This tells xdp that if a font with that ',
     1       'point size cannot be found, ')
      WRITE(13,357)
  357 FORMAT('#  then either increment or decrement the point size ',
     1       'to find one that matches.')
      WRITE(13,358)
  358 FORMAT('#  The third field contains the string bold or ',
     1       'normal.  The entire font ')
      WRITE(13,359)
  359 FORMAT('#  specification must be enclosed in braces.')
      WRITE(13,360)
  360 FORMAT(' ')
      WRITE(13,361)
  361 FORMAT('windows variable    {{MS Sans Serif} 8 normal}')
      WRITE(13,362)
  362 FORMAT('windows fixed_small {Fixedsys 10 normal}')
      WRITE(13,363)
  363 FORMAT('windows fixed_large {Fixedsys 10 normal}')
      WRITE(13,364)
  364 FORMAT('')
      WRITE(13,365)
  365 FORMAT('unix variable    {Helvetica -12 bold}')
      WRITE(13,366)
  366 FORMAT('unix fixed_small {fixed +10 bold}')
      WRITE(13,367)
  367 FORMAT('unix fixed_large {fixed +11 bold}')
      WRITE(13,368)
  368 FORMAT('')
      WRITE(13,369)
  369 FORMAT('IRIX variable    {Helvetica -12 bold}')
      WRITE(13,370)
  370 FORMAT('IRIX fixed_small {screen +10 bold}')
      WRITE(13,371)
  371 FORMAT('IRIX fixed_large {screen +13 bold}')
      WRITE(13,372)
  372 FORMAT('')
      WRITE(13,373)
  373 FORMAT('HP-UX variable    {Helvetica +12 bold}')
      WRITE(13,374)
  374 FORMAT('HP-UX fixed_small {fixed +11 bold}')
      WRITE(13,375)
  375 FORMAT('HP-UX fixed_large {fixed +12 bold}')
C
C  NOW CREATE XDPCONFIG_98
C
      WRITE(14,401)
  401 FORMAT('#  This file contains executable and font ',
     1       'specifications for xdp.')
      WRITE(14,402)
  402 FORMAT(' ')
      WRITE(14,403)
  403 FORMAT('#  This file can exist in several locations.  It ',
     1       'is searched for in several')
      WRITE(14,404)
  404 FORMAT('#  directories and the first occurance of the file ',
     1       'is the one that will be')
      WRITE(14,405)
  405 FORMAT('#  used.  This way a user can have a different set ',
     1       'of fonts than the default')
      WRITE(14,406)
  406 FORMAT('#  values.')
      WRITE(14,407)
  407 FORMAT('')
      WRITE(14,408)
  408 FORMAT('#  The order of the directories where xdp looks ',
     1       'for this file is:')
      WRITE(14,409)
  409 FORMAT('#  (1) the current directory, (2) the user's home ',
     1       'directory, (3) the system')
      WRITE(14,410)
  410 FORMAT('#  directory for the xdp Tcl files.  The file can ',
     1       'be names xdpConfig or .xdpConfig')
      WRITE(14,411)
  411 FORMAT(' ')
      WRITE(14,412)
  412 FORMAT(' ')
      WRITE(14,413)
  413 FORMAT('#  The executable specification gives the pathname ',
     1       'for Dataplot executables')
      WRITE(14,414)
  414 FORMAT('#  on different platforms.  The second field ',
     1       'contains the name of the platform ')
      WRITE(14,415)
  415 FORMAT('#  (windows, unix) or operating system (IRIX, AIX, ',
     1       'HP-UX, SunOS, etc.).  The ')
      WRITE(14,416)
  416 FORMAT('#  operating system is usually only specified for ',
     1       'unix platforms.  Executable')
      WRITE(14,417)
  417 FORMAT('#  specifications based on operating system must ',
     1       'appear after those specified ')
      WRITE(14,418)
  418 FORMAT('#  by platform.')
      WRITE(14,419)
  419 FORMAT('')
      WRITE(14,420)
  420 FORMAT('#')
      WRITE(14,421)IEXEC(1:NSTOP7)
  421 FORMAT('dataplot windows  ',A)
      WRITE(14,422)
  422 FORMAT('dataplot unix     dataplot')
      WRITE(14,423)
  423 FORMAT(' ')
      WRITE(14,424)ILIB(1:NSTOP)
  424 FORMAT('library  windows  ',A)
      WRITE(14,425)
  425 FORMAT('library  unix     /usr/local/apps/dataplot/lib')
      WRITE(14,426)
  426 FORMAT('')
      WRITE(14,427)
  427 FORMAT('print    windows  ',
     1       '"c:/Program Files/Accessories/Wordpad.exe"')
      WRITE(14,428)
  428 FORMAT('edit     windows  ',
     1       '"c:/Program Files/Accessories/Wordpad.exe"')
      WRITE(14,429)
  429 FORMAT(' ')
      WRITE(14,430)
  430 FORMAT('# You can selct either the Internet Explorer or ',
     1       'the Netscape browser')
      WRITE(14,431)
  431 FORMAT('# browser  windows  ',
     1      '"c:/Program Files/Internet Explorer/Iexplore.exe"')
      WRITE(14,432)
  432 FORMAT('# browser  windows  ',
     1'"c:Program Files/Plus!/Microsoft Internet/Iexplore.exe"')
      WRITE(14,433)
  433 FORMAT('browser  windows  ',
     1'"c:/Program Files/NETSCAPE/Communicator/PROGRAM/netscape.exe"')
      WRITE(14,434)
  434 FORMAT('')
      WRITE(14,435)
  435 FORMAT('print    unix     lp')
      WRITE(14,436)
  436 FORMAT('print    IRIX     lpr')
      WRITE(14,437)
  437 FORMAT('edit     unix     nedit')
      WRITE(14,438)
  438 FORMAT('browser  unix     netscape')
      WRITE(14,439)
  439 FORMAT(' ')
      WRITE(14,440)
  440 FORMAT('#  The font specifications allow a system ',
     1       'administrator or user to easily')
      WRITE(14,441)
  441 FORMAT('#  change the fonts used by xdp to their tastes ',
     1       'or limitations of the hardware.')
      WRITE(14,442)
  442 FORMAT(' ')
      WRITE(14,443)
  443 FORMAT('#  The first field contains the name of the ',
     1       'platform (windows, unix) or')
      WRITE(14,444)
  444 FORMAT('#  operating system (IRIX, AIX, HP-UX, SunOS, etc.).',
     1       '  The operating system')
      WRITE(14,445)
  445 FORMAT('#  is usually only specified for unix platforms.',
     1       '  Font specifications based')
      WRITE(14,446)
  446 FORMAT('#  on operating system must appear after those ',
     1       'specified by platform.')
      WRITE(14,447)
  447 FORMAT(' ')
      WRITE(14,448)
  448 FORMAT('#  The second field contains only the strings ',
     1       'variable, fixed_small, or')
      WRITE(14,449)
  449 FORMAT('#  fixed_large.  These refer to the 3 different ',
     1       'types of fonts used in xdp.')
      WRITE(14,450)
  450 FORMAT('#  The variable font is used for buttons and menus.',
     1       '  The fixed fonts are used')
      WRITE(14,451)
  451 FORMAT('#  for forms, some menus, entries, and text output.')
      WRITE(14,452)
  452 FORMAT('')
      WRITE(14,453)
  453 FORMAT('#  The third field contains the font in Tcl format.',
     1       '  Each font contains ')
      WRITE(14,454)
  454 FORMAT('#  three fields.  The first is the font family.  If',
     1       ' the family name')
      WRITE(14,455)
  455 FORMAT('#  contains blanks, then it must be enclosed in ',
     1       'braces.  The second field')
      WRITE(14,456)
  456 FORMAT('#  contains the point size of the font.  A + or - ',
     1       'can be in front of the point')
      WRITE(14,457)
  457 FORMAT('#  size.  This tells xdp that if a font with that ',
     1       'point size cannot be found, ')
      WRITE(14,458)
  458 FORMAT('#  then either increment or decrement the point size',
     1       ' to find one that matches.')
      WRITE(14,459)
  459 FORMAT('#  The third field contains the string bold or ',
     1       'normal.  The entire font ')
      WRITE(14,460)
  460 FORMAT('#  specification must be enclosed in braces.')
      WRITE(14,461)
  461 FORMAT('')
      WRITE(14,462)
  462 FORMAT('windows variable    {{MS Sans Serif} 8 normal}')
      WRITE(14,463)
  463 FORMAT('windows fixed_small {Fixedsys 10 normal}')
      WRITE(14,464)
  464 FORMAT('windows fixed_large {Fixedsys 10 normal}')
      WRITE(14,465)
  465 FORMAT('')
      WRITE(14,466)
  466 FORMAT('unix variable    {Helvetica -12 bold}')
      WRITE(14,467)
  467 FORMAT('unix fixed_small {fixed +10 bold}')
      WRITE(14,468)
  468 FORMAT('unix fixed_large {fixed +11 bold}')
      WRITE(14,469)
  469 FORMAT('')
      WRITE(14,470)
  470 FORMAT('IRIX variable    {Helvetica -12 bold}')
      WRITE(14,471)
  471 FORMAT('IRIX fixed_small {screen +10 bold}')
      WRITE(14,472)
  472 FORMAT('IRIX fixed_large {screen +13 bold}')
      WRITE(14,473)
  473 FORMAT('')
      WRITE(14,474)
  474 FORMAT('HP-UX variable    {Helvetica +12 bold}')
      WRITE(14,475)
  475 FORMAT('HP-UX fixed_small {fixed +11 bold}')
      WRITE(14,476)
  476 FORMAT('HP-UX fixed_large {fixed +12 bold}')
C
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
C
      STOP
      END

      SUBROUTINE GLDRAW(IX,IY,NPTS)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE GLATTR(ICODE,ISTYLE,AWIDTH)
      RETURN
      END
      SUBROUTINE GLREFL(AX,AY,NPTS)
      INTEGER AX(*), AY(*)
      RETURN
      END
      SUBROUTINE GLPOIN(IX,IY,ASIZE)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE GLCIRC(IX,IY,IRAD,IFILL,JCOL)
      RETURN
      END
      SUBROUTINE GLCHEC(IEXPOS,IERR)
      RETURN
      END
      SUBROUTINE GLUPDA(IFRONT)
      RETURN
      END
      SUBROUTINE GLCLEA()
      RETURN
      END
      SUBROUTINE GLSAVG(IFILE,IERR)
      INTEGER IFILE(*)
      RETURN
      END
      SUBROUTINE GLRESG(IFILE,ITITLE,IWIND,IWINDN,IERR)
      INTEGER IFILE(*),ITITLE(*)
      RETURN
      END
      SUBROUTINE GLCYCL(IERR,IBUTTN)
      RETURN
      END
      SUBROUTINE GLLOC(IXRET,IYRET,IERR)
      RETURN
      END
      SUBROUTINE GLCLDE
      RETURN
      END
      SUBROUTINE GLOPDE
      RETURN
      END
      SUBROUTINE GLEND
      RETURN
      END
      SUBROUTINE GLRGFL(IX,IY,NPTS)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE GLSECO(INDX,RED,GREEN,BLUE)
      RETURN
      END
      SUBROUTINE GLSEPA(INDEX)
      RETURN
      END
      SUBROUTINE GLTEXV(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE GLTEXH(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE GLTATT(IFONT,IERROR)
      INTEGER IFONT(*)
      RETURN
      END
      SUBROUTINE GLINIT(IXP,IYP,IOR,IXPIX,IYPIX,INAME,IWIND,ICOUNT,
     1                 IERR)
C
      INTEGER INAME(*)
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
      WRITE(ICOUT,110)
  110 FORMAT('OPEN-GL DRIVER NOT INSTALLED ON THIS IMPLEMENTATION.')
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,120)
  120 FORMAT('CONTACT YOUR LOCAL SITE COORDINATER FOR MORE ',
     1       'INFORMATION.')
      CALL DPWRST('XXX','BUG ')
      RETURN
      END
      SUBROUTINE GLERAS(IXPIX,IYPIX,IOR,IXRET,IYRET,RED,BLUE,GREEN)
      RETURN
      END

      SUBROUTINE EDWRST(ISUBN0)
C
C     PURPOSE--WRITE OUT THE STRING IN ICOUT.
C
C     DATE--JANUARY 24,1985
C     UPDATED--MAY 1993 SO ALL OUTPUT THROUGH SINGLE ROUTINE
C     UPDATED--AUGUST  1993 COMPILE ERROR ON RS-6000
C
C---------------------------------------------------------------------
C
      CHARACTER*6 ISUBN0
CCCCC AUGUST 1993.  ADD FOLLOWING TO AVOID COMPILE ERROR ON RS-6000
      CHARACTER*4 ISUBN1
      CHARACTER*4 ISUBN2
      CHARACTER*4 ISTEPN
C
C-----COMMON VARIABLES (EDITING)-----------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'EDCOMM.INC'
C
C-----COMMON VARIABLES (GENERAL)-----------------------------------------------
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
C
C-----START POINT-------------------------------------------
C
      ISUBN1='EDWR'
      ISUBN2='ST  '
C
      IF(IBUGWR.EQ.'OFF'.AND.ISUBRO.NE.'WRST')GOTO90
      WRITE(IPR,999)
  999 FORMAT(1X)
      WRITE(IPR,51)
   51 FORMAT(1H ,'***** AT THE BEGINNING OF EDWRST--')
      WRITE(IPR,52)ISUBN0
   52 FORMAT(1H ,'THE CALLING ROUTINE WAS ',A6)
      WRITE(IPR,53)NCOUT,ILOUT
   53 FORMAT(1H ,'NCOUT,ILOUT = ',2I8)
      WRITE(IPR,55)
   55 FORMAT(1H ,'          123456789.123456789.123456789.123456789.')
      WRITE(IPR,56)ICOUT(1:40)
   56 FORMAT(1H ,'ICOUT = ',40A1)
      WRITE(IPR,63)ICOUT
   63 FORMAT(1H ,'ICOUT = ',A230)
      WRITE(IPR,64)IPRISW,IOUNIT,INUMSW
   64 FORMAT(1H ,'IPRISW,IOUNIT,INUMSW = ',A4,I8,2X,A4)
      WRITE(IPR,999)
      IF(IBUGT1.EQ.'ON')CALL EDTRA1
   90 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED    MAY 1993
CCCCC TO ALLOW A SINGLE OUTPUT OF TEXT MATERIAL  MAY 1993
C               **************************************************
C               **  STEP 10--                                   **
C               **  DETERMINE THE LENGTH OF THE STRING          **
C               **  (BY IGNORING BLANK CHARACTERS AT THE END)   **
C               **************************************************
C
      IF(NCOUT.LE.-1)THEN
         DO1000I=1,240
            J=240-I+1
            IF(ICOUT(J:J).NE.' ')GOTO1050
 1000    CONTINUE
         NCOUT=1
         GOTO1090
 1050    CONTINUE
         NCOUT=J
 1090    CONTINUE
      ENDIF
C
C               ****************************
C               **  STEP 11--             **
C               **  WRITE OUT THE STRING  **
C               ****************************
C
      ISTEPN='11'
CCCCC IF(IBUGWR.EQ.'ON'.OR.ISUBRO.EQ.'WRST')
CCCCC1CALL EDTRA3(ISTEPN,ISUBN1,ISUBN2)
C
      IF(IPRISW.EQ.'ON')IOUNIT=IPRINU
C
      IF(IPRISW.EQ.'OFF'.AND.INUMSW.EQ.'OFF')GOTO1110
      GOTO1119
C
 1110 CONTINUE
      NCOUT2=NCOUT
      IF(NCOUT.GT.238)NCOUT2=238
      WRITE(IPR,1111)(ICOUT(I:I),I=1,NCOUT2)
 1111 FORMAT(1H ,238A1)
C
      IF(ICOUT(1:5).EQ.'[TOP]')GOTO1114
      IF(ICOUT(1:8).EQ.'[BOTTOM]')GOTO1114
      IF(ICOUT(1:4).EQ.'**ST')GOTO1114
      IF(ICOUT(1:4).EQ.'**st')GOTO1114
      IF(IPRISW.EQ.'ON')
     1WRITE(IOUNIT,1112)(ICOUT(I:I),I=1,NCOUT2)
 1112 FORMAT(1H ,238A1)
 1114 CONTINUE
C
      GOTO1190
 1119 CONTINUE
C
      IF(IPRISW.EQ.'ON'.OR.INUMSW.EQ.'ON')GOTO1120
      GOTO1190
C
 1120 CONTINUE
      NCOUT2=NCOUT
      IF(NCOUT.GT.120)NCOUT2=120
C
      IF(ILOUT.EQ.-999)THEN
         WRITE(IPR,1121)(ICOUT(I:I),I=1,NCOUT2)
 1121    FORMAT(1H ,230A1)
      ELSE IF(ILOUT.LE.0.AND.ILOUT.NE.-999)THEN
         WRITE(IPR,1122)(ICOUT(I:I),I=1,NCOUT2)
 1122    FORMAT(1H ,10X,230A1)
      ELSE IF(ILOUT.GE.1)THEN
         WRITE(IPR,1123)ILOUT,(ICOUT(I:I),I=1,NCOUT2)
 1123    FORMAT(1H ,I6,':',3X,230A1)
      ENDIF
C
      IF(IPRISW.EQ.'ON')THEN
         IF(ILOUT.EQ.-999)THEN
            WRITE(IOUNIT,1131)(ICOUT(I:I),I=1,NCOUT2)
 1131       FORMAT(1H ,230A1)
         ELSE IF(ILOUT.LE.0.AND.ILOUT.NE.-999)THEN
            WRITE(IOUNIT,1132)(ICOUT(I:I),I=1,NCOUT2)
 1132       FORMAT(1H ,10X,230A1)
         ELSE IF(ILOUT.GE.1)THEN
            WRITE(IOUNIT,1133)ILOUT,(ICOUT(I:I),I=1,NCOUT2)
 1133       FORMAT(1H ,I6,':',3X,230A1)
         ENDIF
      ENDIF
C
 1190 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS ADDED    MAY 1993
CCCCC TO ALLOW A SINGLE OUTPUT OF TEXT MATERIAL  MAY 1993
      ICOUT=' '
      NCOUT=(-999)
      ILOUT=(-999)
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGWR.EQ.'OFF'.AND.ISUBRO.NE.'WRST')GOTO9090
      WRITE(IPR,999)
      WRITE(IPR,9011)
 9011 FORMAT(1H ,'***** AT THE END       OF EDWRST--')
      WRITE(IPR,9012)NCOUT,ILOUT
 9012 FORMAT(1H ,'NCOUT,ILOUT = ',2I8)
      WRITE(IPR,9013)ICOUT
 9013 FORMAT(1H ,'ICOUT = ',A230)
      WRITE(IPR,9014)IPRISW,IPRINU,IOUNIT
 9014 FORMAT(1H ,'IPRISW,IPRINU,IOUNIT = ',A4,2I8)
      WRITE(IPR,999)
      IF(IBUGT2.EQ.'ON')CALL EDTRA2
 9090 CONTINUE
C
      RETURN
      END

      SUBROUTINE XDRAW(IX,IY,NPTS)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE XPOINT(IX,IY)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE XEND
      RETURN
      END
      SUBROUTINE XREGFL(IX,IY,NPTS)
      INTEGER IX(*), IY(*)
      RETURN
      END
      SUBROUTINE XCHECK(IEXPOSE,IERROR)
      RETURN
      END
      SUBROUTINE XCLEAR
      RETURN
      END
      SUBROUTINE XUPDAT(IJUNK)
      RETURN
      END
      SUBROUTINE XRDLOC(IX,IY,IERROR)
      RETURN
      END
      SUBROUTINE XFORE(INDEX)
      RETURN
      END
      SUBROUTINE XLATTR(INDEX,ICODE)
      RETURN
      END
      SUBROUTINE XTATTR(IFONT,IERROR)
      INTEGER IFONT(*)
      RETURN
      END
      SUBROUTINE XTEXTV(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE XTEXTH(ISTRNG,IXPOS,IYPOS,IJUSTH,IJUSTV,IERROR)
      INTEGER ISTRNG(*)
      RETURN
      END
      SUBROUTINE XINIT(IXP,IYP,IORIEN,IXRET,IYRET,IADE,IWIND,
     &IJUNK,IERROR)
      INTEGER IJUNK(*), IADE(*)
      WRITE(*,*) ' X11 HAS NOT BEEN INSTALLED AT YOUR SITE'
      WRITE(*,*) ' CONTACT YOUR LOCAL SITE COORDINATER FOR '
      WRITE(*,*) ' MORE INFORMATION'
      RETURN
      END
      SUBROUTINE XERASE(IX,IY,IORIEN,IXRET,IYRET,IBACK,IFLAG)
      RETURN
      END
      SUBROUTINE XSAVEG(IADE,IERROR)
      INTEGER IADE(*)
      IERROR=4
      RETURN
      END
      SUBROUTINE XRESTG(IADE,IADE2,IWIND,IWINDN,IERROR)
      INTEGER IADE(*), IADE2(*), IWIND(*)
      IERROR=4
      RETURN
      END
      SUBROUTINE XCYCLE(IERROR,IBUTTN)
      INTEGER IERROR, IBUTTN
      IERROR=4
      RETURN
      END

      PROGRAM EDMAIN
C     PURPOSE--THIS IS THE MAIN ROUTINE FOR THE    FED    EDITOR
C
      INCLUDE 'DPCOPA.INC'
C
      CHARACTER*4 ISOURC
      CHARACTER*4 IDPSW
      CHARACTER*80 IEDIFI
C
C-----START POINT------------------------------------------------
C
C     STEP 1--
C     DEFINE DEFAULT DIRECTORY, EXTENSION AND CASE FOR THE EDITOR
C
      IEDDIR=' '
      IEDDIR='FED$'
      NCEDT1=4
C
      IEDEXT=' '
      IEDEXT='.DAT'
      NCEDT2=4
C
      IEDCAS=' '
      IEDCAS='UPPE'
C
C     STEP 2--
C     CALL THE EDITOR
C
      ISOURC='FILE'
      IDPSW='OFF'
      CALL EDMAI2(ISOURC,IEDIFI,IDPSW)
C
      STOP
      END

C     ..........DPDDS3..........
 
      SUBROUTINE DPDDS3(Y1,N1,IORDAR,IORDMA,DELTAT,NUMVAR,ILOCV,
CCCCC1XTEMP1,XTEMP2,MAXNXT,PRED2,RES2,RESSD,RESDF,IBUGA3,IERROR)
     1XTEMP1,XTEMP2,XDDS,YDDS,AT,MAXNXT,PRED2,RES2,RESSD,RESDF,
     1IBUGA3,IERROR)
CCCCC APRIL 1996.  ADD XDDS, YDDS, AT TO ARGUMENT LIST
CCCCC PROGRAM DPDDS3
CCCCC  UPDATED--AUGUST        1995.  CRAY DOESN'T LIKE "*" FORMAT
CCCCC                                FOR INTERNAL WRITE 
******************************************************************
*                                                                *
*    THIS PROGRAM FITS UNIVARIATE (ARMA) AND EXTENDED (EARMA)    *
*  MODELS TO TIME SERIES DATA, WITH OPTIONAL DETERMINISTIC TREND *
*  ESTIMATION FOR UNIVARIATE MODELS. IT IS DESIGNED TO BE USED   *
*  WITH THE BOOK:                                                *
*        "TIME SERIES AND SYSTEM ANALYSIS WITH APPLICATIONS"     *
*                  BY S. M. PANDIT AND S. M. WU                  *
*                                                                *
*              THIS CODE WRITTEN BY WILLIAM WITTIG               *
*                              AT                                *
*               MICHIGAN TECHNOLOGICAL UNIVERSITY                *
*                             1982                               *
*                                                                *
*         SUBROUTINE LS ADAPTED FROM CODE WRITTEN AT             *
*              UNIVERSITY OF WISCONSIN-MADISON                   *
*                                                                *
*      THIS CODE IS INTENDED FOR INSTRUCTIONAL USE ONLY!         *
*                                                                *
*****NOTE***** THIS CODE HAS BEEN REVISED FROM APPENDIX III      *
*              VERSION, WRITTEN FOR UNIVAC 1100/80, TO RUN ON    *
*              IBM 4381.  EVERY CHANGED STATEMENT IS ACCOMPANIED *
*              BY THE ORIGINAL STATEMENT WITH 'CCCCC' AT THE     *
*              BEGINNING.                                        *
*                                                                *
****WARNING*** THE FORTRAN 77 PRETEST DOLOOP FEATURE            *
*              IS USED EXTENSIVLY!                               *
*                                                                *
*  PARAMETER STORAGE IN THE PAR ARRAY IS AS FOLLOWS:             *
*  1. ESTIMATED SEASONALITY PARAMETERS, 2. MEANS, 3. PHI0 TERMS, *
*  4. PHI TERMS: SERIES 1, SERIES 2, ETC., 5. THETA TERMS        *
*                                                                *
*  ZERO LAG INVERSE FUNCTION COEFFICIENTS ARE STORED AT THE      *
*  END OF THE LAST COLUMN OF THE XTX ARRAY. (SUBROUTINE EAR)     *
*  JANUARY 1995.  ALAN HECKERT MADE THE FOLLOWING CHANGES FOR    *
*  NON-PC SYSTEMS.
*  1) CHANGED REAL*4 AND REAL*8 TO REAL AND DOUBLE PRECISION     *
*     (REAL*4 ETC. NOT ANSI STANDARD).  THERE ARE STILL 2        *
*     COMPLEX*16 STATEMENTS, WHICH MAY NEED TO BE MODIFIED ON    *
*     SOME SYSTEMS.                                              *
*  2) THE COMMON BLOCK DATA WAS RENAMED DDSDAT.                  *
*  3) THE "/" IN SOME FORMAT STATEMENTS WAS MODIFIED (BOMBS ON   *
*     UNIX WITH INTERNAL READ/WRITE WHICH DATAPLOT USES TO FUNNEL*
*     ALL OUTPUT THROUGH SINGLE ROUTINE.                         *
C     UPDATED         --APRIL     1996. DDS CODE MODIFIED (ALAN):
C                                       A) SOME DIMENSIONS TO DPDDS, USE
C                                          EQUIVALENCE
C                                       B) I/O CONSISTENT WITH DATAPLOT
C                                       C) USE IERROR RATHER THAN STOP
C                                       D) INCLUDE FILE FOR DDS COMMON
C                                          BLOCKS AND PARAMETER STATEMENTS
C                                       THESE CHANGES PROPOGATE TO LOWER
C                                       LEVEL DDS ROUTINES
******************************************************************
C
C     CALLING SEQUENCE:
C
C        DPDDS3 - DETPAR EAR GJR INVAL LS ATSCOR ANALYS
C
C        DETPAR - .
C        EAR - MODEL XX XA
C        GJR - .
C        INVAL - EAR GJR STBLIZ
C        LS - MODEL DIF STBLIZ GJR
C        ATSCOR - .
C        ANALYS - SPECTRUM GREEN FREQ EIGEN
C
C        STBLIZ - EIGEN
C        DIF - .
C        XA - .
C        MODEL - DETPAR
C        XX - .
C        FREQ - .
C        EIGEN - .
C        GREEN - .
C        SPECTRUM - .
C
CCCCC APRIL 1996.  FOLLOWING PUT IN INCLUDE FILE
CCCCC PARAMETER (MXSER=3,MXSR2=MXSER**2,MXNOB=1024,MXPAR=45,MXINV=50,
CCCCC>          MXNOB1=MXNOB+1,MXINV1=MXINV+1)
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
C
CCCCC DOUBLE PRECISION XTX(MXINV,MXINV1),XX
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
CCCCC COMMON /SEASON/ NPOLY,NEXP,NSIN,ISEAS(30),SEAS(30),DELTA
CCCCC APRIL 1996.  YDDS, XDDS DIMENSIONED IN 
CCCCC COMMON/DDSDAT/ YDDS(MXNOB,MXSER),XDDS(MXNOB,MXSER)
CCCCC COMMON /BLOK1/ STEP,CONTOL,ITMAX,IFREF
CCCCC COMMON /JOSHI/ XX
      DOUBLE PRECISION XTX(MXINV,MXINV1)
CCCCC APRIL 1996.  USE DPOPFI TO OPEN FILES
C
      CHARACTER*80 IFILE1
      CHARACTER*12 ISTAT1
      CHARACTER*12 IFORM1
      CHARACTER*12 IACCE1
      CHARACTER*12 IPROT1
      CHARACTER*12 ICURS1
      CHARACTER*4 IERRF1
      CHARACTER*4 IENDF1
      CHARACTER*4 IREWI1
C
      CHARACTER*80 IFILE2
      CHARACTER*12 ISTAT2
      CHARACTER*12 IFORM2
      CHARACTER*12 IACCE2
      CHARACTER*12 IPROT2
      CHARACTER*12 ICURS2
      CHARACTER*4 IERRF2
      CHARACTER*4 IENDF2
      CHARACTER*4 IREWI2
C
      CHARACTER*80 IFILE3
      CHARACTER*12 ISTAT3
      CHARACTER*12 IFORM3
      CHARACTER*12 IACCE3
      CHARACTER*12 IPROT3
      CHARACTER*12 ICURS3
      CHARACTER*4 IERRF3
      CHARACTER*4 IENDF3
      CHARACTER*4 IREWI3
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      DIMENSION Y1(*)
      DIMENSION PRED2(*)
      DIMENSION RES2(*)
C
      CHARACTER*4 IBUGA3
      CHARACTER*4 IERROR
CCCCC MAY 1995.  ADD FOLLOWING LINE
      CHARACTER*4 ISUBRO
CCCCC APRIL 1996.  ADD FOLLOWING LINE
      CHARACTER*4 ISUBN0
C
      DIMENSION AT(MXNOB1,MXSER),PAR(MXPAR),AVG(MXSER),VAR(MXSER)
     >          ,OSSQ(MXSER),SCA(MXSER)
CCCCC CHARACTER*40 TITLE
      CHARACTER FORMT*50
C
      IF(IBUGA3.EQ.'OFF'.AND.ISUBRO.NE.'DDS3')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,51)
   51 FORMAT('**** AT THE BEGINNING OF DPDDS3--')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,52)IBUGA3
   52 FORMAT('IBUGA3 = ',A4)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,53)DELTAT,NUMVAR,ILOCV
   53 FORMAT('DELTAT,NUMVAR,ILOCV = ',E15.7,I8,I8)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,55)N1
   55 FORMAT('N1 = ',I8)
      CALL DPWRST('XXX','WRIT')
      DO56I=1,N1
      WRITE(ICOUT,57)I,Y1(I)
   57 FORMAT('I,Y1(I) = ',I8,E15.7)
      CALL DPWRST('XXX','WRIT')
   56 CONTINUE
      WRITE(ICOUT,65)IORDAR,IORDMA
   65 FORMAT('IORDAR,IORDMA = ',2I8)
      CALL DPWRST('XXX','WRIT')
   90 CONTINUE
CCCCC WRITE(ICOUT,65)IORDAR,IORDMA
CCC65 FORMAT('IORDAR,IORDMA = ',2I8)
CCCCC CALL DPWRST('XXX','WRIT')
C
      NPHI0=0
      NPHI=0
      NSEASP=0
      NSEAS=0
      NEWFLAG=0
C
      DO2000 JJ1 = 1,MXSER
         DO2001 JJ2 = 1,MXSER
            LAG(JJ1,JJ2)=1
2001    CONTINUE
2000  CONTINUE
      IPAR=1
      IOUT=6
      IIN=5
      INDEX=1
      IFINV=0
      IFATS=0
      IFGREEN=0
      IFSPECTR=0
C
      ITEST=1
C
C     READ INPUT DATA
C
      IF(ITEST.EQ.1)THEN
CCCCC    WRITE(IOUT,1000)
1000     FORMAT(' THE PROGRAM READS FROM FILE "5" AND WRITES TO '
     >   ,/,' FILE "6/12."  IF YOUR EXEC IS NOT SET UP THIS WAY,',/,
     >    ' ENTER A "1", OR ENTER A "0" TO CONTINUE.  NOTE THAT ',/,
     >    ' ALL RESULTS ARE ECHOED TO THE SCREEN.')
CCCCC    READ(IIN,*) ICONT
         ICONT=0
CCCCC APRIL 1996.  SET IERROR FLAG INSTEAD OF STOP
CCCCC    IF(ICONT.EQ.1) STOP 'RE-DO YOUR EXEC TO FIT THE PROGRAM.'
         IF(ICONT.EQ.1) THEN
           WRITE(ICOUT,1001)
 1001      FORMAT('*****ERROR IN DPDDS, BAD VALUE FOR ICONT FLAG')
           CALL DPWRST('XXX','WRIT')
           IERROR='YES'
           GOTO9999
         ENDIF
CCCCC    READ(5,10) TITLE
10       FORMAT(A)
C
CCCCC    READ(5,*) NOB,NSER,DELTA,NMOD,INCPH,INCTH
         NOB=N1
         NSER=1
         DELTA=DELTAT
         NMOD=1
         INCPH=1
         INCTH=1
C
CCCCC    READ(5,*) ((NAR(J,I),J=1,NSER),NMA(I),I=1,NSER)
         NAR(1,1)=IORDAR
         NMA(1)=IORDMA
C
CCCCC    READ(5,*) STEP,CONTOL,ITMAX,IFREF
         STEP=.001
         CONTOL=.00001
         ITMAX=20
         IFREF=0
C
CCCCC    READ(5,*) IFMEAN,IFAT,IFDIF,IFLAG,IFSEAS,IFSER,IFPRT
         IFMEAN=0
         IFAT=0
         IFDIF=0
         IFLAG=0
         IFSEAS=0
         IFSER=0
         IFPRT=1
C
CCCCC    READ(5,*) IFATS,IFGREEN,IFSPECTR
         IFATS=1
         IFGREEN=1
         IFSPECTR=1
C
      ENDIF
C
CCCCC    WRITE(ICOUT,*) TITLE
CCCCC WRITE(ICOUT,'(2I5,E15.8,3I4)') NOB,NSER,DELTA,NMOD,INCPH,INCTH
CCCCC    DO15I=1,NSER
CCC15        WRITE(ICOUT,*) (NAR(J,I),J=1,NSER),NMA(I)
CCCCC  WRITE(ICOUT,'(2E15.8,2I6)') STEP,CONTOL,ITMAX,IFREF
CCCCC WRITE(ICOUT,'(7I6)') IFMEAN,IFAT,IFDIF,IFLAG,IFSEAS,IFSER,IFPRT
C
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,30)
   30 FORMAT(1H ,'  DDS (Data Dependent System) Modeling')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,31)
   31 FORMAT(1H ,'  S. M. Pandit, S. M. Wu, & G. A. Joshi')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,32)
   32 FORMAT(1H ,'  906-487-2153              701-231-8671')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,33)
   33 FORMAT(1H ,'  Reference--Time Series & System Analysis')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,34)
   34 FORMAT(1H ,'             With Applications. Pandit/Wu (1983)')
      CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
      IF(NSER.GE.2)THEN
         WRITE(ICOUT,41)NSER
   41    FORMAT(1H ,'Number of Time Series             = ',I8)
         CALL DPWRST('XXX','WRIT')
      ENDIF
      IF(NSER.GE.2)CALL DPWRST('XXX','WRIT')
      WRITE(ICOUT,42)N1
   42 FORMAT(1H ,'Number of Observations per Series = ',I8)
      CALL DPWRST('XXX','WRIT')
CCCCC WRITE(ICOUT,43)IORDAR
CCC43 FORMAT(1H ,'Order of Autoregressive Terms    = ',I8)
CCCCC WRITE(ICOUT,44)IORDMA
CCC44 FORMAT(1H ,'Order of Moving Average Terms    = ',I8)
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
C
C     ECHO CHECK INPUT
CCCCC WRITE(ICOUT,20) NSER
CCCCC WRITE(3,20) NSER
CCC20 FORMAT (5X,'SERIES',I4)
CCC20 FORMAT (5X,'SERIES',I4,': ARMA(',I3,6X,I3,',',I3,' )',/)
CCCCC WRITE(ICOUT,*) TITLE
CCCCC WRITE(3,30) (TITLE(JJ1),JJ1=1,17)
CCC30 FORMAT (6X,'DATA DEPENDENT SYSTEMS MODELING ROUTINE - MTU 1982
CCCCC>',
CCCCC>//,6X,'THIS PROGRAM FITS UNIVARIATE ARMA AND EXTENDED ',/,6X
CCCCC>,'MODELS TO TIME SERIES DATA, WITH OPTIONAL DETERMINISTIC TREND
CCCCC>',/,6X,'ESTIMATION FOR UNIVARIATE MODELS.',
CCCCC>'  IT IS DESIGNED TO BE USED'
CCCCC>,/,6X,'WITH THE BOOK:' ,
CCCCC>/,6X,'   "TIME SERIES AND SYSTEM ANALYSIS WITH APPLICATIONS"'
CCCCC>,/,6X,'             BY S. M. PANDIT AND S. M. WU' ,
CCCCC>//,6X,'    THIS CODE IS INTENDED FOR INSTRUCTIONAL USE ONLY!'
CCCCC>,/,2X,70('*'),////,1X,17A4)
CCCCC WRITE(ICOUT,60) IFMEAN,IFAT,IFDIF,NMOD,IFPRT,IFLAG,IFSEAS,IFSER,
CCCCC>INCPH,INCTH
CCCCC WRITE(3,60) IFMEAN,IFAT,IFDIF,NMOD,IFPRT,IFLAG,IFSEAS,IFSER,
CCCCC>INCPH,INCTH
CCC60 FORMAT(/,15X,'PROGRAM CONTROL FLAGS',/,5X,'IFMEAN:',I3,4X,
CCCCC>'IFAT:',I3,'  IFDIF:',I3,'  NMOD:',I3,'  IFPRT:',I3,
CCCCC> /,6X,'IFLAG:',
CCCCC>I3,'  IFSEAS:',I3,'  IFSER:',I3,' INCPH:',I3,'  INCTH:',I3)
CCCCC WRITE(ICOUT,70) STEP,CONTOL,ITMAX,IFREF
CCCCC WRITE(3,70) STEP,CONTOL,ITMAX,IFREF
CCC70 FORMAT (5X,'STEP=',E10.4,'   CONVERGENCE TOLERANCE=',E10.4
CCCCC>,/,5X,I5,' ITERATIONS MAX    IFREF:',I4,//)
CCCCC WRITE(ICOUT,600) MXSER,MXNOB,MXPAR,MXINV
CC600  FORMAT(/,' --- PROGRAM SIZE LIMITS ---',
CCCCC>       /,'      MAX # SERIES=',I4,
CCCCC>       /,'      MAX # OBSER =',I4,
CCCCC>       /,'      MAX # PARAM =',I4,
CCCCC>       /,'      MAX # INVER =',I4,
CCCCC>       /)
CCCCC WRITE(ICOUT,601)
CC601   FORMAT(/,' (***LAST UPDATE***13 AUG 84 /19:02:14|)',
CCCCC>       /,' (1.SUMMARY ELT IN 11.                   )',
CCCCC>       /,' (2.IF NMOD=1, AT-S IN 12.               )',
CCCCC>       /,' (3.FIX: AT(MXNOB)->AT(MXNOB1) IN MODEL  )',
CCCCC>       /,/)
CCCCC WRITE(ICOUT,40)NSER,NOB,DELTA
CCCCC WRITE(3,40)NSER,NOB,DELTA
CCC40 FORMAT (1X,I6,' SERIES WITH',I5,' OBSERVATIONS, DELTA =',E10.4,//,
CCCCC>      '    INPUT STARTING MODEL ORDERS:',/)
CCCCC    DO50I=1,NSER
CCC50       WRITE(ICOUT,*) I,(NAR(J,I),J=1,NSER),NMA(I)
C     CHECK FOR ERRORS IN INPUT
CCCCC IF(NSER.GT.MXSER) STOP'TOO MANY DATA SETS, MXSER=3'
CCCCC IF(NOB.GT.MXNOB) STOP'TOO MANY OBSERVATIONS, MXNOB=1024'
CCCCC IF(IFSEAS.GT.0.AND.IFDIF.NE.0)
CCCCC>   STOP'NUMERICAL DERIVATIVES MUST BE USED WITH SEASONALITY'
CCCCC IF(IFSEAS.GT.0.AND.NSER.GT.1)
CCCCC>   STOP'ONLY ONE SERIES MAY BE USED WITH SEASONALITY'
CCCCC IF(IFSEAS.EQ.1.AND.NMOD.LT.0)
CCCCC>   STOP'NO STOCHASTIC INITIAL VALUES FOR IFSEAS = 1'
CCCCC IF((IFSEAS.EQ.1.OR.IFSEAS.EQ.3).AND.NMOD.GT.1)
CCCCC>   STOP'ONLY ONE MODEL AT A TIME FOR IFSEAS=1 OR 3'
C
C     DETERMINE LAGS FOR MULTI-VARIATE MODELS
C
CCCCC APRIL 1996.  IN FOLLOWING BLOCK, USE IRD AS THE INPUT UNIT
         IF(NSER.GT.1)THEN
            DO100I=1,NSER
                  IF(IFLAG.EQ.0)THEN
                     DO80J=I+1,NSER
80                      LAG(J,I)=0.0
                   ELSE
                      IF(I.EQ.1)THEN
CCCCC                    READ(5,*) (LAG(J,I),J=2,NSER)
                         READ(IRD,*) (LAG(J,I),J=2,NSER)
                      ELSEIF(I.EQ.NSER)THEN
CCCCC                    READ(5,*) (LAG(J,I),J=1,I-1)
                         READ(IRD,*) (LAG(J,I),J=1,I-1)
                      ELSE
CCCCC                   READ(5,*) (LAG(J,I),J=1,I-1),(LAG(J,I),J=I+1,NSER)
                        READ(IRD,*) (LAG(J,I),J=1,I-1),
     >                              (LAG(J,I),J=I+1,NSER)
                      ENDIF
                 ENDIF
CCCCC            WRITE(ICOUT,90) I,(LAG(J,I),J=1,NSER)
CCC90            FORMAT (5X,'SERIES',I4,':  LAGS=',10(I5,','),/)
CCCCC            CALL DPWRST('XXX','WRIT')
100         CONTINUE
         ENDIF
C
C     READ SEASONALITY INPUT IF SEASONALITY FLAG IS SET
C
CCCCC APRIL 1996.  IN FOLLOWING BLOCK, USE IRD AS THE INPUT UNIT, SET
CCCCC IERROR FLAG INSTEAD OF STOP
         IF(IFSEAS.GT.0)THEN
CCCCC       READ(5,*) NPOLY,NEXP,NSIN
            READ(IRD,*) NPOLY,NEXP,NSIN
            NSEASP=NPOLY+2*NEXP+4*NSIN+1
CCCCC       IF(NSEASP.GT.30)
CCCCC>         STOP'TOO MANY SEASONALITY PARAMETERS, MAX=30'
            IF(NSEASP.GT.30)THEN
              WRITE(ICOUT,1011)
 1011         FORMAT('*****ERROR IN DPDDS--TOO MANY SEASONAILITY ',
     1               'PARAMETERS, MAXIMUM = 30.')
              CALL DPWRST('XXX','WRIT')
              IERROR='YES'
              GOTO9999
            ENDIF
CCCCC       READ(5,*) (SEAS(I),ISEAS(I),I=1,NSEASP)
            READ(IRD,*) (SEAS(I),ISEAS(I),I=1,NSEASP)
            WRITE(ICOUT,111) NPOLY,NEXP
111         FORMAT(5X,'SEASONALITY:',I3,' POLYNOMIAL,',I3,
     >             ' EXPONENTIAL')
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,112) NSIN
112         FORMAT(' AND',I3,' SINUSOIDAL TRENDS')
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,113) 
 113        FORMAT (' ')
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,110) (I,SEAS(I),I=1,NSEASP)
CCCCC       WRITE(3,110) NPOLY,NEXP,NSIN,(I,SEAS(I),I=1,NSEASP)
110         FORMAT(5X,5('BETA(',I2,')=',E11.4,5X))
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,116) 
 116        FORMAT (' ')
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,117) 
 117        FORMAT(5X,'ESTIMATION FLAGS:')
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,115) (I,ISEAS(I),I=1,NSEASP)
CCCCC       WRITE(3,115) (I,ISEAS(I),I=1,NSEASP)
115         FORMAT(7X,5('IC(',I2,')=',I4,14X))
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,116) 
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,116) 
            CALL DPWRST('XXX','WRIT')
C
C     MODIFY SEASONALITY PARAMETERS FOR SAMPLING INTERVAL
C
            N=NPOLY+1
               DO120I=1,NEXP
                  N=N+2
                  SEAS(N)=SEAS(N)*DELTA
  120          CONTINUE
               DO130I=1,NSIN
                  N=N+2
                  SEAS(N)=SEAS(N)*DELTA
                  N=N+2
                  SEAS(N)=SEAS(N)*DELTA*6.2831853
  130          CONTINUE
C
C     LOAD SEASONALITY PARAMETERS INTO PARAMETER ARRAY
C
               IF(IFSEAS.EQ.1.OR.IFSEAS.EQ.3)THEN
                     DO140I=1,NSEASP
                        IF(ISEAS(I).EQ.0)THEN
                           PAR(IPAR)=SEAS(I)
                           ISEAS(IPAR)=I
                           IPAR=IPAR+1
                        ENDIF
140                  CONTINUE
                  NSEAS=IPAR-1
               ENDIF
         ENDIF
C
C     READ IN DATA SERIES
C
CCCCC AUGUST, 1995.  MODIFIY FOLLOWING LINE FOR CRAY.
CCCCC CRAY DOESN'T ALLOW FREE FORMAT FOR INTERNAL WRITE.
      IF(IBUGA3.EQ.'ON'.OR.ISUBRO.EQ.'DDS3')THEN
CCCCC    WRITE(ICOUT,*)'JUST BEFORE THE DEFINITION OF YDDS'
         WRITE(ICOUT,9072)
 9072    FORMAT('JUST BEFORE THE DEFINITION OF YDDS')
         CALL DPWRST('XXX','WRIT')
CCCCC    WRITE(ICOUT,*)NOB,NSER
         WRITE(ICOUT,9073)NOB,NSER
 9073    FORMAT(I8,3X,I8)
         CALL DPWRST('XXX','WRIT')
      ENDIF
C
CCCCC READ(5,*) ((YDDS(I,J),I=1,NOB),J=1,NSER)
      DO144I=1,NOB
         YDDS(I,1)=Y1(I)
  144 CONTINUE
 
      IF(IBUGA3.EQ.'ON'.OR.ISUBRO.EQ.'DDS3')THEN
CCCCC AUGUST, 1995.  MODIFIY FOLLOWING LINE FOR CRAY.
CCCCC CRAY DOESN'T ALLOW FREE FORMAT FOR INTERNAL WRITE.
CCCCC    WRITE(ICOUT,*)'THE YDDS DEFINITION LOOP HAS JUST BEEN EXECUTED'
         WRITE(ICOUT,9075)
 9075    FORMAT('THE YDDS DEFINITION LOOP HAS JUST BEEN EXECUTED')
         CALL DPWRST('XXX','WRIT')
      ENDIF
C
C     DETREND DATA TO ESTIMATE STOCHASTIC PART OF COMBINED MODELS
C
CCCCC APRIL 1996.  ADD XDDS, YDDS TO CALL LIST, NOB PASSED THROUGH
CCCCC COMMON
CCCCC IF(IFSEAS.EQ.2)   CALL DETPAR(NOB)
      IF(IFSEAS.EQ.2)   CALL DETPAR(XDDS,YDDS)
C
C     FIND AVERAGE AND VARIANCE OF EACH SERIES AND PRINT
C
CCCCC WRITE(ICOUT,145)
CC145 FORMAT (//,'   CHARACTERISTICS OF THE DATA',/)
CCCCC CALL DPWRST('XXX','WRIT')
C
         DO190I=1,NSER
            SUM=0.0
            VAR(I)=0.0
            DO150J=1,NOB
                  SUM=SUM+YDDS(J,I)
  150       CONTINUE
CCCCC       AVG(I)=SUM/NOB
            AVG(I)=SUM/REAL(NOB)
            DO160J=1,NOB
                  VAR(I)=VAR(I)+(YDDS(J,I)-AVG(I))**2
  160       CONTINUE
            VAR(I)=VAR(I)/REAL(NOB-1)
            SDI=SQRT(VAR(I))
C
            WRITE(ICOUT,170)
  170       FORMAT(1H ,'Series     Obs.  Average     Variance   SD')
            CALL DPWRST('XXX','WRIT')
C
            WRITE(ICOUT,171) I,N1,AVG(I),VAR(I),SDI
  171       FORMAT(1H ,I3,2X,I8,4X,3G11.5)
            CALL DPWRST('XXX','WRIT')
C
C     SCALE DATA FOR EARMA MODELS
C
            IF(NSER.GT.1)THEN
               SCA(I)=VAR(I)
               IF(IFMEAN.GT.0) SCA(I)=SCA(I)+AVG(I)**2
               SCA(I)=SQRT(SCA(I))
               DO185J=1,NOB
                   YDDS(J,I)=YDDS(J,I)/SCA(I)
  185          CONTINUE
               AVG(I)=AVG(I)/SCA(I)
           ENDIF
C
C     SUBTRACT AVERAGE FROM DATA IF MEAN IS NOT ESTIMATED
C
           IF(IFMEAN.LE.0.AND.IFSEAS.EQ.0)THEN
              IF(IFMEAN.LT.0) AVG(I)=XDDS(-IFMEAN,I)
              DO180J=1,NOB
                YDDS(J,I)=YDDS(J,I)-AVG(I)
                XDDS(J,I)=YDDS(J,I)
  180         CONTINUE
           ENDIF
190      CONTINUE
C
C     CHECK FOR INITIAL VALUE FLAG
C
         IF(NMOD.LT.0)THEN
            IFINV=1
            NMOD=-NMOD
         ENDIF
CCCCC APRIL 1996.  OPEN FILES VIA THE DPOPFI ROUTINE
C
C
         IF(IFATS .EQ. 1)THEN
CCCCC          OPEN(UNIT=2,FILE='residuals.out',STATUS='UNKNOWN')
               IOUNI1=2
               IFILE1='residual.out'
               ISTAT1='UNKNOWN'
               IFORM1='FORMATTED'
               IACCE1='SEQUENTIAL'
               IPROT1='WRITE'
               ICURS1='CLOSED'
               ISUBN0='DDS3'
               IERRF1='NO'
               IREWI1='ON'
               CALL DPOPFI(IOUNI1,IFILE1,ISTAT1,IFORM1,IACCE1,IPROT1,
     1                     ICURS1,
     1                     IREWI1,ISUBN0,IERRF1,IBUGA3,ISUBRO,IERROR)
               IF(IERRF1.EQ.'YES')THEN
                 WRITE(ICOUT,1091)
 1091            FORMAT('***** ERROR IN DDS--UNABLE TO OPEN ',
     >                  'residuals.out')
                 CALL DPWRST('XXX','WRIT')
                 IERROR='YES'
                 GOTO9999
               ENDIF
         ENDIF
         IF(IFGREEN .EQ. 1)THEN
CCCCC          OPEN(UNIT=3,FILE='green.out',STATUS='UNKNOWN')
               IOUNI2=3
               IFILE2='green.out'
               ISTAT2='UNKNOWN'
               IFORM2='FORMATTED'
               IACCE2='SEQUENTIAL'
               IPROT2='WRITE'
               ICURS2='CLOSED'
               ISUBN0='DDS3'
               IERRF2='NO'
               IREWI2='ON'
               CALL DPOPFI(IOUNI2,IFILE2,ISTAT2,IFORM2,IACCE2,IPROT2,
     1                     ICURS2,
     1                     IREWI2,ISUBN0,IERRF2,IBUGA3,ISUBRO,IERROR)
               IF(IERRF2.EQ.'YES')THEN
                 WRITE(ICOUT,1092)
 1092            FORMAT('***** ERROR IN DDS--UNABLE TO OPEN green.out')
                 CALL DPWRST('XXX','WRIT')
                 IERROR='YES'
                 GOTO9999
               ENDIF
         ENDIF
         IF(IFSPECTR .EQ. 1)THEN
CCCCC          OPEN(UNIT=4,FILE='spectrum.out',STATUS='UNKNOWN')
               IOUNI3=4
               IFILE3='spectrum.out'
               ISTAT3='UNKNOWN'
               IFORM3='FORMATTED'
               IACCE3='SEQUENTIAL'
               IPROT3='WRITE'
               ICURS3='CLOSED'
               ISUBN0='DDS3'
               IERRF3='NO'
               IREWI3='ON'
               CALL DPOPFI(IOUNI3,IFILE3,ISTAT3,IFORM3,IACCE3,IPROT3,
     1                     ICURS3,
     1                     IREWI3,ISUBN0,IERRF3,IBUGA3,ISUBRO,IERROR)
               IF(IERRF3.EQ.'YES')THEN
                 WRITE(ICOUT,1093)
 1093            FORMAT('***** ERROR IN DDS--UNABLE TO OPEN ',
     >                  'spectrum.out')
                 CALL DPWRST('XXX','WRIT')
                 IERROR='YES'
                 GOTO9999
               ENDIF
         ENDIF
C
C     LOOP ON NUMBER OF MODELS
C
         DO290 MOD=1,NMOD
C
C     SET INITIAL VALUES OF MEANS IF ESTIMATED
C
            IF(IFMEAN.GT.0.AND.IFSEAS.EQ.0)THEN
               IPAR=NSEAS+1
                  DO210I=1,NSER
                     PAR(IPAR)=AVG(I)
                     IF(IFMEAN.GT.1) PAR(IPAR)=YDDS(IFMEAN-1,I)
                     IPAR=IPAR+1
C
C     SUBTRACT AVERAGE TO RESET DATA FOR INITIAL VALUES OF NEW MODEL
C
                        DO210J=1,NOB
                           XDDS(J,I)=YDDS(J,I)-AVG(I)
  210                   CONTINUE
            ENDIF
C
C     SKIP STOCHASTIC ESTIMATION FOR DETERMINISTIC MODELS
C
         NPAR=NSEAS
         IF(IFSEAS.EQ.1)THEN
             NEWFLAG=1
             GO TO 280
         ENDIF
C
C     CHECK SERIES INDEX FLAG
C
            IF(IFSER.GT.0.AND.IFSER.LE.NSER)THEN
               INDEX=IFSER
               GO TO 280
            ENDIF
C
C     LOOP ON NUMBER OF DATA SERIES
C
             INDEX=1
C
  280 CONTINUE
            IF(INDEX .LE. NSER)THEN
CCCCC       DO280 INDEX=1,NSER
             IF(NEWFLAG .EQ. 1)THEN
                 NEWFLAG = 0
                 GO TO 250
             ENDIF
C
C     FIND NUMBER OF PHI0'S AND PHI'S, AND MAXLAG FOR THIS SERIES
C
220            NPHI0=0
               NPHI=0
               MAXLAG=1
                  DO230I=INDEX+1,NSER
230                  IF(LAG(I,INDEX).EQ.0)NPHI0=NPHI0+1
                     DO235I=1,NSER
                       ML=LAG(I,INDEX)+NAR(I,INDEX)-1
                       IF(ML.GT.MAXLAG) MAXLAG=ML
                       NPHI=NPHI+NAR(I,INDEX)
  235                CONTINUE
                     MAXLAG=MAX(MAXLAG,NMA(INDEX))
                     NPAR=NPHI0+NPHI+NMA(INDEX)+IPAR-1
C
C     SET INITIAL VALUES OF INITIAL AT'S IF ESTIMATED
C
                     IF(IFAT.LT.0)THEN
                        DO240I=1,MAXLAG
                           PAR(NPAR+I)=0.1
  240                   CONTINUE
                        NPAR=NPAR+MAXLAG
                     ENDIF
CCCCC APRIL 1996.  SET ERROR FLAG INSTEAD OF STOP
CCCCC                IF(NPAR.GT.MXPAR) STOP'TOO MANY PARAMETERS, MXPAR=45'
                     IF(NPAR.GT.MXPAR) THEN
                       WRITE(ICOUT,9110)
                       CALL DPWRST('XXX','WRIT')
                       IERROR='YES'
                       GOTO9999
                     ENDIF
 9110 FORMAT('***** ERROR IN DDS--MAXIMUM OF 45 PARAMETERS EXCEEDED.')
CCCCC               WRITE(ICOUT,'(/////)')
CCCCC               CALL DPWRST('XXX','WRIT')
C                   IF(IFPRT.GT.0)
C    >              WRITE(ICOUT,*) INDEX,(NAR(J,INDEX),J=1,NSER),NMA(INDEX)
C                   CALL DPWRST('XXX','WRIT')
C
C     PURE AR MODELS
C
                  IF(NMA(INDEX).EQ.0.AND.IFINV.NE.1)THEN
                     ISIZ=NPHI+NPHI0
                     ISIZ1=ISIZ+1
CCCCC APRIL 1996.  ADD XDDS, YDDS TO ARGUMENT LIST
CCCCC                CALL EAR(XTX,NAR(1,INDEX),LAG(1,INDEX),PAR,ISIZ)
                     CALL EAR(XTX,NAR(1,INDEX),LAG(1,INDEX),PAR,ISIZ,
     >                        XDDS,YDDS)
                     CALL GJR(XTX,ISIZ,4,MXINV,MXINV1,IERROR)
                     IPAR=IPAR-1
C
C     LOAD PHI0'S INTO PAR
C
                     DO245I=1,NPHI0
                           PAR(I+IPAR)=XTX(NPHI+I,ISIZ1)
  245                CONTINUE
                     IPAR=IPAR+NPHI0
C
C     LOAD PHI'S INTO PAR
C
                      DO246I=1,NPHI
                           PAR(I+IPAR)=XTX(I,ISIZ1)
  246                 CONTINUE
                     IPAR=IPAR-NPHI0+1
                     GO TO 250
                  ENDIF
C
C     READ INITIAL VALUES IF IFINV = 1 (NMOD LT 0)
C
CCCCC APRIL 1996.  USE IRD
                  IF(IFINV.EQ.1)THEN
                     IF(IFMEAN.GT.0.AND.IFSEAS.EQ.0)
CCCCC>               READ(5,*) (PAR(I),I=IPAR-NSER,IPAR-1)
CCCCC                READ(5,*) (PAR(I),I=IPAR,NPAR)
     >               READ(IRD,*) (PAR(I),I=IPAR-NSER,IPAR-1)
                     READ(IRD,*) (PAR(I),I=IPAR,NPAR)
                  ELSE
C
C     FIND INITIAL VALUES BY INVERSE FUNCTION METHOD
C
CCCCC APRIL 1995.  ADD XDDS, YDDS TO ARGUMENT LIST
CCCCC                CALL INVAL(XTX,PAR,SCA,NPAR)
                     CALL INVAL(XTX,PAR,SCA,NPAR,XDDS,YDDS,IERROR)
                  ENDIF
C
C     SCALE INITIAL PARAMETERS FOR EARMA MODELS
C
                  IF(NSER.GT.1)THEN
                     N=NSEAS+1
                     IF(IFMEAN.GE.1) N=N+NSER
C
C     SCALE ZERO LAG TERMS
C
                        DO247I=INDEX+1,NSER
                           IF(LAG(I,INDEX).EQ.0)THEN
                              PAR(N)=PAR(N)*SCA(I)/SCA(INDEX)
                              N=N+1
                           ENDIF
247                     CONTINUE
C
C     SCALE REST OF PHI TERMS
C
                         DO249I=1,NSER
                           IF(I.NE.INDEX)THEN
                             NN=N
                             SCALE=SCA(I)/SCA(INDEX)
                             DO248J=1,NAR(I,INDEX)
                               PAR(NN)=PAR(NN)*SCALE
                               NN=NN+1
  248                        CONTINUE
                           ENDIF
                           N=N+NAR(I,INDEX)
  249                    CONTINUE
                    ENDIF
C
C     DO NON-LINEAR LEAST SQUARES SEARCH TO FIND BEST PARAMETERS
C
  250 CONTINUE
CCCCC APRIL 1996.  ADD XDDS, YDDS TO ARGUMENT LIST
               CALL LS(NPAR,PAR,AT(1,INDEX),FORMT,IFDIF,SCA,IFPRT,
CCCCC1         SEXT,NDF,IORDAR,IORDMA)
     1         SEXT,NDF,IORDAR,IORDMA,XDDS,YDDS,IERROR)
               IF(IERROR.EQ.'YES')GOTO9999
C
C     CHECK FOR AUTO-REFINEMENT OF PARAMETERS
C
                  IF(IFREF.GT.0)THEN
                     IFREF=-IFREF
                     STEP=STEP*10.**FLOAT(IFREF)
                     CONTOL=CONTOL*10.**FLOAT(IFREF)
CCCCC                IF(IFPRT.GT.0) WRITE(3,255) STEP,CONTOL
                     IF(IFPRT.GT.0) THEN
                       WRITE(ICOUT,256)
256                    FORMAT(' ')
                       CALL DPWRST('XXX','WRIT')
                       WRITE(ICOUT,256)
                       CALL DPWRST('XXX','WRIT')
                       WRITE(ICOUT,255) STEP
255                    FORMAT(' NEW CONVERGENCE PARAMETERS:',5X,'STEP='
     >                        ,E10.4,5X)
                       CALL DPWRST('XXX','WRIT')
                       WRITE(ICOUT,257) CONTOL
257                    FORMAT(1X,' CONVERGENCE TOLERANCE=',E10.4)
                       CALL DPWRST('XXX','WRIT')
                     ENDIF
C
C     REDO ESTIMATION AND RESTORE ESTIMATION PARAMETERS
C
CCCCC APRIL 1996.  ADD XDDS, YDDS TO ARGUMENT LIST
                     CALL LS(NPAR,PAR,AT(1,INDEX),FORMT,IFDIF,SCA,IFPRT,
CCCCC1                       SEXT,NDF,IORDAR,IORDMA)
     1                       SEXT,NDF,IORDAR,IORDMA,XDDS,YDDS,IERROR)
                     IF(IERROR.EQ.'YES')GOTO9999
                     IFREF=-IFREF
                     STEP=STEP*10.**FLOAT(IFREF)
                     CONTOL=CONTOL*10.**FLOAT(IFREF)
                  ENDIF
C
CCCCC COPY PREDICTED VALUES AND RESIDUALS INTO PRED2 AND RES2
CCCCC FOR USE BY DATAPLOT
C
      DO750I=1,NOB
         RES2(I)=AT(I,1)
         PRED2(I)=Y1(I)-RES2(I)
  750 CONTINUE
      RESSD=SEXT
      RESDF=NDF
C
C     PRINT THE RESIDUALS FOR THE CURRENT MODEL
C
CCCCC APRIL 1996.  USE IOUNI1 INSTEAD OF HARD-CODED 2.
        IF(IFATS .EQ. 1)THEN
          WRITE(IOUNI1,771)
  771     FORMAT('This is Dataplot file  RESIDUAL.OUT  (DDS command)')
          WRITE(IOUNI1,772) NAR(1,INDEX), NMA(INDEX)
  772     FORMAT('Residuals for ARMA(',I2,',',I2,') model')
          WRITE(IOUNI1,773)
  773     FORMAT(1H )
          WRITE(IOUNI1,774)
  774     FORMAT('residuals')
          WRITE(IOUNI1,775)
  775     FORMAT('--------------------------------------------(line 5)')
          DO776 I =1,NSER
CCCCC       WRITE(2,777) I
CC777       FORMAT('SERIES NUMBER', I3)
            DO778J=1,NOB
              WRITE(IOUNI1,779) AT(J,I)
779           FORMAT(F10.3)
778         CONTINUE
776       CONTINUE
        ENDIF
C
C     FIND AND PRINT F-TEST VALUE
C
         IF(NMOD.GT.1)THEN
               IF(MOD.GT.1)THEN
                  FTST=(OSSQ(INDEX)/AT(NOB+1,INDEX)-1.)*
     >            FLOAT((NOB-NPAR)/(NSER*INCPH+INCTH))
                  WRITE(ICOUT,264) 
 264              FORMAT (' ')
                  CALL DPWRST('XXX','WRIT')
                  WRITE(ICOUT,264) 
                  CALL DPWRST('XXX','WRIT')
                  WRITE(ICOUT,265) FTST
CCCCC             WRITE(3,265) FTST
265               FORMAT(' F-TEST WITH LAST MODEL FOR THIS SERIES ='
     >                   ,F10.3)
                  CALL DPWRST('XXX','WRIT')
               ENDIF
            OSSQ(INDEX)=AT(NOB+1,INDEX)
         ENDIF
      NDEX = NSER
      IF(IFSER.GT.0) NDEX = IFSER
CCCCC IF(NMOD.EQ.1) WRITE(12,'(5E15.8)') (AT(I,NDEX),I=1,NOB)
C
C     FIND CORRELATIONS OF RESIDUALS
C
CCCCC APRIL 1996.  ADD MXNOB1, MXSER TO ARGUMENT LIST
CCCCC          CALL ATSCOR(AT,NOB,INDEX,IFSER)
               CALL ATSCOR(AT,NOB,INDEX,IFSER,MXNOB1,MXSER)
C
C     FIND ROOTS, FREQUENCIES, DAMPING, AND GREEN'S FUNCTION COEFFICIENTS
C
CCCCC APRIL 1996.  IN FOLLOWING BLOCK OF CODE, USE IOUNI2 RATHER THAN 3.
               IF(IFSEAS.NE.1.AND.IFPRT.GT.0)THEN
                 IF(IFGREEN .EQ. 1)THEN
                   WRITE(IOUNI2,781)
  781              FORMAT('This is Dataplot file GREEN.OUT ',
     >                    '(DDS command)')
                   WRITE(IOUNI2,782) NAR(1,INDEX), NMA(INDEX)
  782              FORMAT('Greens function for ARMA(',I2,',',I2,
     >                    ') model')
                   WRITE(IOUNI2,783)
  783              FORMAT(1H )
                   WRITE(IOUNI2,784)
  784              FORMAT('index   Green (total)   Green (comp. 1) ...')
                   WRITE(IOUNI2,785)
  785              FORMAT('------------------------------------------',
     >                    '(line 5)')
                 ENDIF
CCCCC APRIL 1996.  IN FOLLOWING BLOCK OF CODE, USE IOUNI3 RATHER THAN 4.
                 IF(IFSPECTR .EQ. 1)THEN
                   WRITE(IOUNI3,791)
  791              FORMAT('This is Dataplot file  SPECTRUM.OUT  ',
     >                    '(DDS command)')
                   WRITE(IOUNI3,792) NAR(1,INDEX), NMA(INDEX)
  792              FORMAT('Spectrum for ARMA(',I2,',',I2,') model')
                   WRITE(IOUNI3,793)
  793              FORMAT(1H )
                   WRITE(IOUNI3,794)
  794              FORMAT('index   Spectrum (total)   Spectrum ',
     >                    '(comp. 1) ','...')
                   WRITE(IOUNI3,795)
  795              FORMAT('------------------------------------------',
     >                    '(line 5)')
                 ENDIF
CCCCC APRIL 1996.  ADD I/O UNITS TO ARGUMENT LIST, DELTA PASSED
CCCCC THROUGH COMMON.
CCCCC            CALL ANALYS(PAR,DELTA,VAR)
                 CALL ANALYS(PAR,VAR,IOUNI2,IOUNI3)
               ENDIF
C
C     UPDATE MODEL ORDERS FOR NEXT MODEL
C
                  DO270I=1,NSER
                     NAR(I,INDEX)=NAR(I,INDEX)+INCPH
  270             CONTINUE
                  NMA(INDEX)=NMA(INDEX)+INCTH
CCCCC             WRITE(ICOUT,285)
CCCCC             CALL DPWRST('XXX','WRIT')
                  INDEX=INDEX+1
                  IF(IFSER .EQ. 0) GO TO 280
        ENDIF
CCCCC       WRITE(3,285)
CC285       FORMAT (///,1X,72('*'),//)
290      CONTINUE
C
CCCCC WRITE(IOUT,'(42A1)')  ' A SUMMARY OF MODEL(S) IS(ARE) IN FILE 6.'
CCCCC IF(NMOD.EQ.1) WRITE(IOUT,2004) NDEX
2004  FORMAT(' ',I5,'-TH SERIES RESIDUALS ARE IN FILE 12.')
C
CCCCC WRITE OUT MESSAGES ABOUT THE OUTPUT FILES
C
      IF(IFATS .EQ. 1)THEN
         WRITE(ICOUT,999)
         CALL DPWRST('XXX','WRIT')
         WRITE(ICOUT,770)
  770    FORMAT(1H ,'Residuals       written to file   RESIDUAL.OUT')
         CALL DPWRST('XXX','WRIT')
      ENDIF
      IF(IFGREEN .EQ. 1)THEN
         WRITE(ICOUT,780)
  780    FORMAT(1H ,'Greens function written to file      GREEN.OUT')
         CALL DPWRST('XXX','WRIT')
      ENDIF
      IF(IFSPECTR .EQ. 1)THEN
         WRITE(ICOUT,790)
  790    FORMAT(1H ,'Spectrum        written to file   SPECTRUM.OUT')
         CALL DPWRST('XXX','WRIT')
      ENDIF
C
CCCCC APRIL 1996.  USE DPCLFI ROUTINE
      IF(IFATS .EQ. 1)THEN
CCCCC   CLOSE(2)
C
        IENDF1='OFF'
        IREWI1='ON'
        CALL DPCLFI(IOUNI1,IFILE1,ISTAT1,IFORM1,IACCE1,IPROT1,ICURS1,
     1  IENDF1,IREWI1,ISUBN0,IERRF1,IBUGA3,ISUBRO,IERROR)
        IF(IERRF1.EQ.'YES')THEN
          WRITE(ICOUT,9211)
 9211     FORMAT('**** ERROR IN DDS TRYING TO CLOSE RESIDUAL.OUT FILE.')
          IERROR='YES'
          GOTO9999
        ENDIF
C
      ENDIF
      IF(IFGREEN .EQ. 1)THEN
CCCCC   CLOSE(3)
        IENDF2='OFF'
        IREWI2='ON'
        CALL DPCLFI(IOUNI2,IFILE2,ISTAT2,IFORM2,IACCE2,IPROT2,ICURS2,
     1  IENDF2,IREWI2,ISUBN0,IERRF2,IBUGA3,ISUBRO,IERROR)
        IF(IERRF2.EQ.'YES')THEN
          WRITE(ICOUT,9221)
 9221     FORMAT('**** ERROR IN DDS TRYING TO CLOSE GREEN.OUT FILE.')
          IERROR='YES'
          GOTO9999
        ENDIF
C
      ENDIF
      IF(IFSPECTR .EQ. 1)THEN
CCCCC   CLOSE(4)
        IENDF3='OFF'
        IREWI3='ON'
        CALL DPCLFI(IOUNI3,IFILE3,ISTAT3,IFORM3,IACCE3,IPROT3,ICURS3,
     1  IENDF3,IREWI3,ISUBN0,IERRF3,IBUGA3,ISUBRO,IERROR)
        IF(IERRF3.EQ.'YES')THEN
          WRITE(ICOUT,9231)
 9231     FORMAT('**** ERROR IN DDS TRYING TO CLOSE SPECTRUM.OUT FILE.')
          IERROR='YES'
          GOTO9999
        ENDIF
      ENDIF
C
CCCCC STOP
CCCCC APRIL 1996.  ADD FOLLOWING LINE
 9999 CONTINUE
      RETURN
      END
 
C     ..........DETPAR..........
 
      SUBROUTINE DETPAR(XDDS,YDDS)
CCCCC APRIL 1996.  ADD XDDS, YDDS TO THE CALL LIST, PASS NOB THROUGH
CCCCC COMMON
CCCCC SUBROUTINE DETPAR(NOB)
C
C     PURPOSE--SUBTRACTS THE DETERMINISTIC TRENDS FROM THE DATA
C
CCCCC COMMENT OUT FOLLOWING 3 LINES, ADD DDS INCLUDE FILE
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45)
CCCCC COMMON/DDSDAT/ YDDS(MXNOB,MXSER),XDDS(MXNOB,MXSER)
CCCCC COMMON /SEASON/ NPOLY,NEXP,NSIN,ISEAS(30),SEAS(30),DELTA
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
       DO40 IT=1,NOB
            N=2
            S=SEAS(1)
               DO10I=1,NPOLY
                  S=S+SEAS(N)*(DELTA*IT)**I
                  N=N+1
  10           CONTINUE
               DO20I=1,NEXP
                  S=S+SEAS(N)*EXP(SEAS(N+1)*IT)
                  N=N+2
  20           CONTINUE
               DO30I=1,NSIN
                  S=S+SEAS(N)*EXP(SEAS(N+1)*IT)*
     >              (SEAS(N+2)*SIN(SEAS(N+3)*IT)+SQRT(1-SEAS(N+2)**2)*
     >              COS(SEAS(N+3)*IT))
                 N=N+4
  30           CONTINUE
            XDDS(IT,1)=YDDS(IT,1)-S
  40  CONTINUE
      RETURN
      END
 
C     ..........EAR..........
 
      SUBROUTINE EAR(XTX,NAR2,LAG2,PAR,ISIZ,XDDS,YDDS)
CCCCC APRIL 1996.  ADD XDDS, YDDS ARGUMENTS
CCCCC RENAME LAG AND NAR TO LAG2 AND NAR2 TO AVOID NAME CONFLICT
CCCCC WITH DPCODD.INC COMMON BLOCK
CCCCC SUBROUTINE EAR(XTX,NAR,LAG,PAR,ISIZ)
C
C     PURPOSE--FORMS THE XTX AND XTY MATRICES FOR EAR MODELS
C
CCCCC APRIL 1996.  FOLLOWING DECLARATIONS IN DDS INCLUDE FILE
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45,MXINV=50,MXINV1=MXINV+1)
      DOUBLE PRECISION XTX,SUM
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
CCCCC COMMON/DDSDAT/ YDDS(MXNOB,MXSER),XDDS(MXNOB,MXSER)
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
C
CCCCC APRIL 1996.  GLOBALLY RENAME LAG AND NAR TO LAG2 AND NAR2
CCCCC DIMENSION XTX(MXINV,MXINV1),LAG(MXSER),LAGT(MXSER)
CCCCC DIMENSION PAR(MXPAR),NAR(MXSER)
      DIMENSION XTX(MXINV,MXINV1),LAG2(MXSER),LAGT(MXSER)
      DIMENSION PAR(MXPAR),NAR2(MXSER)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C
C     SUBTRACT MEAN AND SEASONALITY FOR INITIAL VALUES
C
CCCCC APRIL 1996.  ADD XDDS, YDDS TO ARGUMENT LIST
CCCCC IF(IFSEAS.EQ.3) CALL MODEL(PAR,AT,0)
      IF(IFSEAS.EQ.3) CALL MODEL(PAR,AT,0,XDDS,YDDS)
C
C     SET TEMPORARY LAGS
C
      DO10I=1,NSER
CCCCC   LAGT(I)=LAG(I)
        LAGT(I)=LAG2(I)
        IF(LAGT(I).EQ.0) LAGT(I)=1
   10 CONTINUE
C
C     FORM INVARIANT PART OF XTX BY BLOCK COLUMNS
C
      IROW=1
      ICOL=1
      DO30I=1,NSER
C
C     FORM DIAGONAL BLOCK
C
CCCCC APRIL 1996.  ADD MXINV, MXINV1 TO ARGUMENT LIST, RENAME TO
CCCCC AVOID CONFLICT WITH XX COMMON BLOCK
CCCCC   CALL XX(XDDS(2-LAGT(I),I),XTX,NAR(I),IROW,ICOL,MAXLAG,NOB)
        CALL XXZ(XDDS(2-LAGT(I),I),XTX,NAR2(I),IROW,ICOL,MAXLAG,NOB,
     >          MXINV,MXINV1)
C
C     FORM REST OF COLUMN
C
         DO20J=I+1,NSER
CCCCC      IROW=IROW+NAR(J-1)
           IROW=IROW+NAR2(J-1)
CCCCC      CALL XA(XDDS(2-LAGT(I),I),XDDS(2-LAGT(J),J),XTX,NAR(I),
CCCCC APRIL 1996.  ADD ARRAY DIMENSION TO ARGUMENT LIST
CCCCC>             NAR(J),IROW,ICOL,MAXLAG,NOB)
           CALL XA(XDDS(2-LAGT(I),I),XDDS(2-LAGT(J),J),XTX,NAR2(I),
     >             NAR2(J),IROW,ICOL,MAXLAG,NOB,MXINV,MXINV1)
  20     CONTINUE
CCCCC    ICOL=ICOL+NAR(I)
         ICOL=ICOL+NAR2(I)
         IROW=ICOL
  30  CONTINUE
C
C    FORM IMMEDIATE BLOCKS - LOOP DOWN THE ROWS
C
      DO50I=INDEX+1,NSER
CCCCC   IF(LAG(I).EQ.0)THEN
        IF(LAG2(I).EQ.0)THEN
          ICOL=1
C
C     LOOP ACROSS THE BLOCKS
C
          DO40J=1,NSER
C
C     LOOP ON ELEMENTS PER BLOCK
C
CCCCC     DO40K=1,NAR(J)
          DO40K=1,NAR2(J)
             SUM=0.0
             DO35L=MAXLAG+1,NOB
               SUM=SUM-XDDS(L-K-LAGT(J)+1,J)*XDDS(L,I)
  35         CONTINUE
             XTX(IROW,ICOL)=SUM
             ICOL=ICOL+1
  40     CONTINUE
C
C     FORM IMMEDIATE DIAGONAL BLOCK
C
          DO70J=INDEX+1,I
CCCCC       IF(LAG(J).EQ.0)THEN
            IF(LAG2(J).EQ.0)THEN
              SUM=0.0
              DO60K=MAXLAG+1,NOB
                SUM=SUM+XDDS(K,I)*XDDS(K,J)
  60          CONTINUE
              XTX(IROW,ICOL)=SUM
              ICOL=ICOL+1
            ENDIF
70        CONTINUE
          IROW=IROW+1
        ENDIF
50    CONTINUE
C
C     FORM XTY - SECTION CORRESPONDING TO INVARIANT PART
C
      IROW=1
      DO90I=1,NSER
CCCCC DO90J=1,NAR(I)
      DO90J=1,NAR2(I)
        SUM=0.0
        DO80K=MAXLAG+1,NOB
          SUM=SUM+XDDS(K-J-LAGT(I)+1,I)*XDDS(K,INDEX)
  80    CONTINUE
        XTX(IROW,ISIZ+1)=SUM
        IROW=IROW+1
  90  CONTINUE
C
C     IMMEDIATE PART
C
      DO110I=INDEX+1,NSER
CCCCC   IF(LAG(I).EQ.0)THEN
        IF(LAG2(I).EQ.0)THEN
          SUM=0.0
          DO100J=MAXLAG+1,NOB
            SUM=SUM-XDDS(J,I)*XDDS(J,INDEX)
  100     CONTINUE
          XTX(IROW,ISIZ+1)=SUM
          IROW=IROW+1
       ENDIF
  110 CONTINUE
C
C    DEFINE UPPER TRIANGLE OF XTX
C
      DO120I=1,ISIZ-1
      DO120J=I+1,ISIZ
        XTX(I,J)=XTX(J,I)
  120 CONTINUE
      RETURN
      END
 
C     ..........GJR..........
 
      SUBROUTINE GJR (A,N,IW,ISIZ,ISIZ1,IERROR)
CCCCC APRIL 1996.  ADD IERROR FLAG
CCCCC SUBROUTINE GJR (A,N,IW,ISIZ,ISIZ1)
C
C     PURPOSE--DOES A GAUSS-JORDAN REDUCTION
C
CCCCC APRIL 1996.  USE DPCODD.INC
CCCCC PARAMETER (MXINV=50)
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      CHARACTER*4 IERROR
C
      DOUBLE PRECISION A
      DIMENSION A(ISIZ,ISIZ1),JC(MXINV)
C     IW=:, 1- FIND INVERSE, 4- SOLVE AX=B, 5- BOTH
C     JC IS THE PERMUTATION VECTOR
C     KI IS THE OPTION KEY FOR MATRIX INVERSION
C     L IS THE COLUMN CONTROL FOR AX=B
C     M IS THE COLUMN CONTOL FOR MATRIX INVERSION
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      K=0
      M=1
      L=N+(IW/4)
      KI=2-MOD(IW,2)
CCCCC GO TO (10,30), KI
      IF(KI.EQ.1)THEN
C     INITIALIZE JC FOR INVERSION
        DO20I=1,N
          JC(I)=I
  20    CONTINUE
      ENDIF
C     SEARCH FOR PIVOT ROW
      DO120I=1,N
CCCCC   GO TO (50,40), KI
        IF(KI.EQ.2) M=I
        IF(I.EQ.N) GO TO 95
        X=-1.
        DO60J=I,N
          IF(X.GT.ABS(A(J,I))) GO TO 60
          X=ABS(A(J,I))
          K=J
60      CONTINUE
        IF(K.EQ.I) GO TO 95
CCCCC   GO TO (70,80), KI
        IF(KI.EQ.1)THEN
            MU=JC(I)
            JC(I)=JC(K)
            JC(K)=MU
        ENDIF
C     INTERCHANGE ROW I AND ROW K
        DO90J=M,L
          X=A(I,J)
          A(I,J)=A(K,J)
          A(K,J)=X
  90    CONTINUE
C
C     TEST FOR SINGULARITY
C
  95    CONTINUE
        IF(ABS(A(I,I)).EQ.0.)THEN
C
C     MATRIX IS SINGULAR
C
CCCCC APRIL 1996.  USE IERROR FLAG RATHER THAN STOP
CCCCC     PRINT*,'***ERROR*** IN GJR. MATRIX IS SINGULAR'
CCCCC     STOP'line 714'
          WRITE(ICOUT,9011)
 9011     FORMAT('***** ERROR--FROM DDS ROUTINE GJR, SINGULAR MATRIX ',
     >           'ENCOUNTERED.')
          IERROR='YES'
          GOTO9999 
        ENDIF
        X=A(I,I)
        A(I,I)=1.
C
C     REDUCTION OF THE I-TH ROW
C
        DO100J=M,L
100       A(I,J)=A(I,J)/X
C
C     REDUCTION OF ALL REMAINING ROWS
C
        DO120K=1,N
          IF(K.EQ.I) GO TO 120
          X=A(K,I)
          A(K,I)=0.
          DO110J=M,L
            A(K,J)=A(K,J)-X*A(I,J)
110       CONTINUE
120     CONTINUE
C
C     AX=B AND DET.(A) ARE NOW COMPUTED
C
CCCCC GO TO (130,180), KI
C
C     PERMUTATION OF THE COLUMNS FOR MATRIX INVERSION
C
      IF(KI.EQ.1)THEN
         DO170J=1,N
            IF(JC(J).EQ.J) GO TO 170
            JJ=J+1
            DO140I=JJ,N
              IF(JC(I).EQ.J) GO TO 150
140         CONTINUE
150         JC(I)=JC(J)
            DO160K=1,N
              X=A(K,I)
              A(K,I)=A(K,J)
              A(K,J)=X
160         CONTINUE
170      CONTINUE
      ENDIF
      JC(1)=N
C
CCCCC APRIL 1996.  ADD FOLLOWING LINE
 9999 CONTINUE
      RETURN
      END
 
C     ..........INVAL..........
 
      SUBROUTINE INVAL(XTX,PAR,SCA,NPAR,XDDS,YDDS,IERROR)
CCCCC SUBROUTINE INVAL(XTX,PAR,SCA,NPAR)
CCCCC APRIL 1996.  ADD TO ARGUMENT LIST
C
C     PURPOSE--FINDS THE INITIAL VALUES OF THE STOCHASTIC PARAMETER
C              USING THE INVERSE FUNCTION METHOD
C
CCCCC APRIL 1996.  USE DDS INCLUDE FILE FOR FOLLOWING.
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      CHARACTER*4 IERROR
CCCCC CHARACTER*4 IFLAG
C
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45,MXINV=50,MXINV1=MXINV+1)
      DOUBLE PRECISION XTX(MXINV,MXINV1)
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
      DIMENSION PAR(MXPAR),N(MXSER),THETA(MXPAR),SCA(MXSER)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     FIND MAXIMUM AUTOREGRESSIVE ORDER AND INVERSE FUNCTION ORDER
C
      NM=1
      DO10I=1,NSER
         IF(NAR(I,INDEX).GT.NM) NM=NAR(I,INDEX)
  10  CONTINUE
C
C     SET INDEXES
C
      M=NMA(INDEX)
      NP=0
      IF(NAR(INDEX,INDEX).EQ.0.OR.NM.EQ.1.AND.M.EQ.1) NP=1
      NM=MAX(NM,M)+M+NP
      ISIZ=NSER*NM+NPHI0
      NXTY=ISIZ+1
      OFFSET=NSEAS
      IF(IFMEAN.GT.0.AND.IFSEAS.EQ.0) OFFSET=OFFSET+NSER
      NN=OFFSET+NPHI0+NPHI
      MXLAG=MAXLAG
      MAXLAG=1
C
C     SET AR ORDERS AND FIND NEW MAXIMUM LAG
C
      DO20I=1,NSER
         N(I)=NM
         ML=NM+LAG(I,INDEX)-1
         IF(ML.GT.MAXLAG) MAXLAG=ML
  20  CONTINUE
C
C     FIT EAR(NM) MODEL TO GET INVERSE FUNCTION COEFFICIENTS
C
CCCCC APRIL 1996.  ARGUMENT LIST FOR FOLLOWING ROUTINES
CCCCC CALL EAR(XTX,N,LAG(1,INDEX),PAR,ISIZ)
CCCCC CALL GJR(XTX,ISIZ,4,MXINV,MXINV1)
      CALL EAR(XTX,N,LAG(1,INDEX),PAR,ISIZ,XDDS,YDDS)
      CALL GJR(XTX,ISIZ,4,MXINV,MXINV1,IERROR)
      IF(IERROR.EQ.'YES')GOTO9999
C
C     UNSCALE INVERSE FUNCTION COEFFICIENTS
C
      K=1
      DO22I=1,NSER
        IF(I.NE.INDEX)THEN
          SCALE=SCA(INDEX)/SCA(I)
          KK=K
          DO21J=1,N(I)
            XTX(KK,NXTY)=XTX(KK,NXTY)*SCALE
            KK=KK+1
  21      CONTINUE
        ENDIF
        K=K+N(I)
  22  CONTINUE
C
C     UNSCALE ZERO LAG TERMS
C
         DO23I=INDEX+1,NSER
               IF(LAG(I,INDEX).EQ.0)THEN
                  XTX(K,NXTY)=XTX(K,NXTY)*SCA(INDEX)/SCA(I)
                  K=K+1
               ENDIF
23       CONTINUE
C
CCCCC WRITE(ICOUT,25) (XTX(I,NXTY),I=1,ISIZ)
CCC25 FORMAT (//,' THE INVERSE FUNCTION COEFFICIENTS ARE:',
CCCCC>/,9(/,8E14.6))
CCCCC CALL DPWRST('XXX','WRIT')
C
C     FIND INITIAL THETA'S
C
CCCCC APRIL 1996.  RENAME MP1 TO MP1Z TO AVOID COMMON BLOCK CONFLICT
CCCCC MP1=M+1
      MP1Z=M+1
      DO40J=1,M
CCCCC   DO40K=1,MP1
        DO40K=1,MP1Z
          SUM=0.0
          DO30I=0,(NSER-1)*NM,NM
            SUM=SUM+XTX(I+J+K,NXTY)
  30    CONTINUE
        XTX(J,K)=SUM
  40  CONTINUE
CCCCC APRIL 1996.  ADD IERROR TO ARGUMENT LIST
CCCCC CALL GJR(XTX,M,4,MXINV,MXINV1)
      CALL GJR(XTX,M,4,MXINV,MXINV1,IERROR)
      IF(IERROR.EQ.'YES')GOTO9999
C
C     CHECK FOR INVERTIBILITY AND FIX IF UNSTABLE
C
         DO50I=1,M
CCCCC       II=MP1-I
            II=MP1Z-I
CCCCC       THETA(I)=XTX(II,MP1)
            THETA(I)=XTX(II,MP1Z)
  50     CONTINUE
CCCCC    PRINT*,'THETAS BEFORE STBLIZ',(THETA(I),I=1,NMA(INDEX))  @@DIA
         CALL STBLIZ(THETA,M,IERROR)
CCCCC    PRINT*,'THETAS AFTER STBLIZ',(THETA(I),I=1,NMA(INDEX))  @@DIA
C
C     LOAD THETAS INTO PAR
C
         DO60I=1,M
            PAR(NN+I)=THETA(I)
  60     CONTINUE
C
C     FIND INITIAL PHI'S
C
         JPAR=OFFSET+NPHI0+1
         L=OFFSET+1
         DO80I=1,NSER
            IPAR=(I-1)*NM+1
C
C     FIND PHI0'S FOR SERIES I
C
            PHI0=0.0
            IF(I.EQ.INDEX) PHI0=1.0
            IF(LAG(I,INDEX).EQ.0)THEN
               IZHU = NSER*NM+L-OFFSET
               PAR(L)=XTX(IZHU,NXTY)
               PHI0=PAR(L)
              L=L+1
            ENDIF
C
C     FIND REST OF PHI'S FOR SERIES I
C
            DO80J=1,NAR(I,INDEX)
               SUM=0.0
               IF(J.LE.M) SUM=THETA(J)*PHI0
               DO70K=1,MIN(J-1,M)
                   SUM=SUM-THETA(K)*XTX(IPAR-K,NXTY)
  70           CONTINUE
               PAR(JPAR)=XTX(IPAR,NXTY)+SUM
               JPAR=JPAR+1
               IPAR=IPAR+1
  80     CONTINUE
C
C     PRINT INITIAL PARAMETER VALUES
C
CCCCC WRITE(ICOUT,90) (PAR(I),I=1,NPAR)
CCC90 FORMAT (//,' INITIAL PARAMETERS =',9E12.5)
CCCCC CALL DPWRST('XXX','WRIT')
      MAXLAG=MXLAG
CCCCC APRIL 1996.  ADD FOLLOWING LINE
 9999 CONTINUE
      RETURN
      END
 
C     ..........LS..........
 
      SUBROUTINE LS (NPAR,PAR,F,FORMT,IFDIF,SCA,IFPRT,SEXT,NDF,
CCCCC APRIL 1996.  ADD XDDS, YDDS, IERROR TO ARGUMENT LIST
CCCCC1               IORDAR,IORDMA)
     1               IORDAR,IORDMA,XDDS,YDDS,IERROR)
C
C     PURPOSE--DOES A MARQUART-LEVENBERG TYPE NON-LINEAR SEARCH
C
CCCCC APRIL 1996.  USE DDS INCLUDE FILE FOR SOME OF THE FOLLOWING
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      INCLUDE 'DPCOZ2.INC'
      DIMENSION XDDS(MAXOBV,MXSER) 
      DIMENSION YDDS(MAXOBV,MXSER) 
      CHARACTER*4 IERROR
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXNOB1=MXNOB+1,MXPAR=45,
CCCCC>MXPAR1=MXPAR+1)
      LOGICAL LG,FLAG
      CHARACTER FORMT*50
      DOUBLE PRECISION PIVOT,CMULT,DENOM,SSRED,TRED
CCCCC DOUBLE PRECISION A(MXPAR1,MXPAR1),PARB(MXPAR),XX,FLR
      DOUBLE PRECISION A(MXPAR1,MXPAR1),PARB(MXPAR),FLR
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
CCCCC COMMON /SEASON/ NPOLY,NEXP,NSIN,ISEAS(30),SEAS(30),DELTA
CCCCC COMMON /BLOK1/ STEP,CONTOL,ITMAX,IFREF
CCCCC COMMON /JOSHI/ XX
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      DIMENSION PAR(MXPAR),CHMAX(MXPAR),Z(MXNOB,MXPAR1),F(MXNOB1)
      DIMENSION SS(3),FL(3),FD(4),SD(4),LSTP(MXPAR1),SPDA(MXPAR1),
     >          SCA(MXSER)
CCCCC APRIL 1996.  ADD FOLLOWING EQUIVALENCE
      EQUIVALENCE (G2RBAG(IGAR11),Z(1,1))
      FINF=1.E19
C
CCCCC IF(IFPRT.GT.0) WRITE(ICOUT,10) NPAR
CCCCC IF(IFPRT.GT.0) WRITE(3,10) NPAR
CCC10 FORMAT (//,'   VERSION 4R1 OF LS, 09-03-82, WITH',I4,
CCCCC>' PARAMETERS',/)
CCCCC IF(IFPRT.GT.0) CALL DPWRST('XXX','WRIT')
C
      DEL=-.001
      BNDLW=-FINF
      BNDUP=FINF
      DO20I=1,NPAR
         CHMAX(I)=.2*ABS(PAR(I))
20    CONTINUE
CCCCC APRIL 1996.  SET ERROR FLAG INSTEAD OF STOP.
      DO60I=1,NPAR
CCCCC    IF(PAR(I).EQ.0.0) STOP 'A PARAMETER IS EQUAL TO ZERO'
         IF(PAR(I).EQ.0.0) THEN
           WRITE(ICOUT,12)
  12       FORMAT('******ERROR IN DDS ROUTINE LS--A PARAMETER IS ',
     >            'EQUAL TO ZERO.')
           CALL DPWRST('XXX','WRIT')
           IERROR='YES'
           GOTO9999
         ENDIF
CCCCC    IF(PAR(I).LT.BNDLW.OR.PAR(I).GT.BNDUP)
         IF(PAR(I).LT.BNDLW.OR.PAR(I).GT.BNDUP)THEN
           WRITE(ICOUT,22)
  22       FORMAT('******ERROR IN DDS ROUTINE LS--A PARAMETER IS ',
     >            'OUTSIDE ITS BOUNDS.')
           CALL DPWRST('XXX','WRIT')
           IERROR='YES'
           GOTO9999
         ENDIF
60    CONTINUE
C
C     MAIN ITERATION LOOP
C
      ITNO=1
      NPAR1=NPAR+1
      NFUNC=0
   70 CONTINUE
C
CCC70 IF(IFPRT.GT.0) WRITE(ICOUT,80) ITNO,NFUNC
CCCCC IF(IFPRT.GT.0) WRITE(3,80) ITNO,NFUNC
CCC80 FORMAT (/,' START ITERATION NO.',I3,' NO. OF CALLS TO MODEL',I4)
CCCCC IF(IFPRT.GT.0) CALL DPWRST('XXX','WRIT')
C
      FLAG=.TRUE.
C
C     FIND AT'S OF ORIGINAL PARAMETERS
C
   85 CONTINUE
CCCCC APRIL 1996.  ADD XDDS, YDDS ARGUMENTS
CCCCC CALL MODEL (PAR,F,1)
      CALL MODEL (PAR,F,1,XDDS,YDDS)
      NFUNC=NFUNC+1
C
C     STORE AT'S IN LAST COLUMN OF Z
C
      DO90 IOB=1,NOB
            Z(IOB,NPAR1)=-F(IOB)
   90 CONTINUE
      ITNO=ITNO+1
C
C     FIND DERIVATIVES WITH RESPECT TO EACH PARAMETER
C
      IF(IFDIF.NE.0)THEN
C
C     ANALYTICAL
C
CCCCC APRIL 1996.  ADD XDDS, YDDS ARRAYS, PASS IFMEAN THROUGH COMMON
CCCCC    CALL DIF(PAR,Z,F,IS,IFMEAN)
         CALL DIF(PAR,Z,F,IS,XDDS,YDDS)
      ELSE
C
C     NUMERICAL
C
         DO130 IPAR=1,NPAR
           IF(ABS(PAR(IPAR)).LE.1.E-25)THEN
             WRITE(ICOUT,101) 
 101         FORMAT (' ')
             CALL DPWRST('XXX','WRIT')
             WRITE(ICOUT,100) IPAR
CCCCC        WRITE(3,100) IPAR
100          FORMAT (' THE VALUE OF PAR(',I3,') IS TOO SMALL FOR'
     1       , 'DETERMINING THE DERIVATIVE')
             CALL DPWRST('XXX','WRIT')
CCCCC APRIL 1996.  SET ERROR FLAG RATHER THAN STOP
CCCCC        STOP'line 915'
             IERROR='YES'
             GOTO9999
           ENDIF
           PARD=PAR(IPAR)
           DPAR=ABS(PAR(IPAR)*DEL)
           S1=BNDUP-PARD-DPAR
           S2=PARD-DPAR-BNDLW
           IF(S1.LT.0..AND.S2.GT.S1)THEN
              PAR(IPAR)=AMAX1(PARD-DPAR,BNDLW)
              DENOM=PARD-PAR(I)
CCCCC APRIL 1996.  ADD XDDS, YDDS
CCCCC         CALL MODEL (PAR,F,1)
              CALL MODEL (PAR,F,1,XDDS,YDDS)
              NFUNC=NFUNC+1
              DO110 IOB=1,NOB
                 Z(IOB,IPAR)=-(Z(IOB,NPAR1)+F(IOB))/DENOM
  110         CONTINUE
            ELSE
              PAR(IPAR)=AMIN1(PARD+DPAR,BNDUP)
              DENOM=PAR(IPAR)-PARD
CCCCC APRIL 1996.  ADD XDDS, YDDS
CCCCC         CALL MODEL (PAR,F,1)
              CALL MODEL (PAR,F,1,XDDS,YDDS)
              NFUNC=NFUNC+1
              DO120 IOB=1,NOB
                        Z(IOB,IPAR)=(F(IOB)+Z(IOB,NPAR1))/DENOM
  120         CONTINUE
            ENDIF
            PAR(IPAR)=PARD
130      CONTINUE
         IS=1
      ENDIF
C
C     FORM XTX AND XTY MATRIX
C
      DO150 IPAR=1,NPAR1
         DO150 JPAR=1,IPAR
             XX=0.0
             DO140 IOB=IS,NOB
                 XX=XX+1.0D0*Z(IOB,IPAR)*Z(IOB,JPAR)
  140        CONTINUE
             A(IPAR,JPAR)=XX
             A(JPAR,IPAR)=XX
  150 CONTINUE
CCCCC IF(ITNO.EQ.2.AND.IFPRT.GT.0) WRITE(ICOUT,160) A(NPAR1,NPAR1)
CCCCC IF(ITNO.EQ.2.AND.IFPRT.GT.0) WRITE(3,160) A(NPAR1,NPAR1)
CC160 FORMAT (//,' INITIAL SUM OF SQUARES =',D12.4,/)
CCCCC CALL DPWRST('XXX','WRIT')
C     FIND GAUSS-NEWTON CORRECTIONS (XX'XX)**-1(XX'Y)
      NES=0
      NTRANS=0
      SSB=A(NPAR1,NPAR1)
      DO170I=1,NPAR
        LSTP(I)=0
        PARB(I)=PAR(I)
        SPDA(I)=STEP*A(I,I)
  170 CONTINUE
C
  180 CONTINUE
      SSRED=0
      NPIV=0
      DO190I=1,NPAR
         IF(LSTP(I).NE.0.OR.A(I,I).LE.SPDA(I).OR.ABS(CHMAX(I))
     >       .LT.1./FINF) GO TO 190
         TRED=A(I,NPAR1)**2/A(I,I)
         IF(TRED.GE.SSRED)THEN
           SSRED=TRED
           NPIV=I
         ENDIF
190   CONTINUE
      IF(NPIV.EQ.0) GO TO 225
      NTRANS=NTRANS+1
      NES=NES+1
      LSTP(NPIV)=NPIV
C
C     DO GAUSS JORDAN MODIFICATION FOR THIS ROW AND COLUMN
C
      PIVOT=A(NPIV,NPIV)
      A(NPIV,NPIV)=1.D0
      DO200J=1,NPAR1
         A(NPIV,J)=A(NPIV,J)/PIVOT
  200 CONTINUE
      DO220I=1,NPAR1
         IF(I.NE.NPIV)THEN
           CMULT=A(I,NPIV)
           DO210J=1,NPAR1
              IF(J.NE.NPIV)A(I,J)=A(I,J)-CMULT*A(NPIV,J)
  210      CONTINUE
           A(I,NPIV)=-A(I,NPIV)/PIVOT
         ENDIF
220   CONTINUE
      GO TO 180
C
  225 CONTINUE
CCCCC APRIL 1996.  SET ERROR FLAG INSTEAD OF STOP
CCCCC IF(NTRANS.LE.0) STOP'NO PARAMETER CHANGES POSSIBLE. INSPECT BOUND
      IF(NTRANS.LE.0) THEN
        WRITE(ICOUT,229)
        CALL DPWRST('XXX','WRIT')
  229   FORMAT('******ERROR IN DDS ROUTINE LS--NO PARAMETER CHANGES ',
     >         'POSSIBLE. INSPECT BOUNDS & CHMAX ARRAY')
        IERROR='YES'
        GOTO9999
      ENDIF
      SSE1=A(NPAR1,NPAR1)
      DO230I=1,NPAR
         IF(LSTP(I).EQ.0)A(I,NPAR1)=0.D0
230   CONTINUE
C
C     FIND MAXIMUM ALLOWABLE LAMBDA
C
      ILAM=0
      FLAM=1
      ILMAX=0
      FLMAX=FINF
      QMAX=FINF
      DO240I=1,NPAR
         ABSA=DABS(A(I,NPAR1))
         IF(ABSA.GE.1./FINF)THEN
           QLAM=ABS(CHMAX(I))
           IF(CHMAX(I).LE.0.0)QLAM=QLAM*DABS(PARB(I))
             IF(FLAM*ABSA.GT.QLAM)THEN
               ILAM=I
               FLAM=QLAM/ABSA
             ENDIF
             IF(A(I,NPAR1).GT.0.0)QMAX=BNDUP-PARB(I)
             IF(A(I,NPAR1).LT.0.0)QMAX=PARB(I)-BNDLW
             IF(QMAX.LT.FLMAX*ABSA)THEN
               ILMAX=I
               FLMAX=QMAX/ABSA
             ENDIF
         ENDIF
240   CONTINUE
C
CCCCC IF(ILAM.NE.0.AND.IFPRT.GT.0) THEN
CCCCC    WRITE(ICOUT,250)ILAM,FLAM
CCCCC    WRITE(3,250)ILAM,FLAM
CC250 FORMAT (' PARAMETER',I4,' LIMITS THE CORRECTIONS TO ',E12.4,
CCCCC>/,' TIMES THE GAUSS-NEWTON VALUES.')
CCCCC     CALL DPWRST('XXX','WRIT')
CCCCC ENDIF
C
CCCCC IF(FLMAX.LT.1..AND.ILMAX.NE.ILAM.AND.IFPRT.GT.0)THEN
CCCCC    WRITE(ICOUT,250) ILMAX,FLMAX
CCCCC    WRITE(3,250) ILMAX,FLMAX
CCCCC    CALL DPWRST('XXX','WRIT')
CCCCC ENDIF
C
CCCCC APRIL 1996.  SET ERROR FLAG INSTEAD OF STOP
CCCCC IF(FLAM.LT.1./FINF) STOP'NO PARAMETER CHANGES POSSIBLE. INSPECT B
CCCCC>OUNDS & CHMAX ARRAY'
      IF(FLAM.LT.1./FINF) THEN
        WRITE(ICOUT,259)
        CALL DPWRST('XXX','WRIT')
  259   FORMAT('******ERROR IN DDS ROUTINE LS--NO PARAMETER CHANGES ',
     >         'POSSIBLE. INSPECT BOUNDS & CHMAX ARRAY')
        IERROR='YES'
        GOTO9999
      ENDIF
      SBEST=SSB
      FBEST=0
      FLR=2*FINF
      SSP=SSE1
      SS(1)=SSB
      FL(1)=0
      SS(2)=1.01*FINF
      FL(2)=1.01*FLMAX
      SS(3)=1.02*FINF
      FL(3)=1.02*FLMAX
      FLT=FLAM
      KEY=0
      LG=.TRUE.
C
C     ADJUST LAMBDA UNTIL BEST SSQ FOUND FOR THIS ITERATION
C
      DO390 IGRID=1,ITMAX
  260    CONTINUE
         DO270I=1,NPAR
            PAR(I)=PARB(I)+FLT*A(I,NPAR1)
            IF(PAR(I).GT.BNDUP)PAR(I)=BNDUP
            IF(PAR(I).LT.BNDLW)PAR(I)=BNDLW
  270    CONTINUE
C
C     FIND SSQ OF AT'S FOR NEW PARAMETERS
C
CCCCC APRIL 1996.  ADD XDDS, YDDS
CCCCC    CALL MODEL (PAR,F,1)
         CALL MODEL (PAR,F,1,XDDS,YDDS)
         NFUNC=NFUNC+1
         SST=0.
         DO290 IOB=1,NOB
            DF=ABS(F(IOB))
C
C     CHECK FOR UNSTABLE MODEL
C
            IF(DF.GT.1.E15)THEN
              WRITE(ICOUT,281) 
 281          FORMAT (' ')
              CALL DPWRST('XXX','WRIT')
              WRITE(ICOUT,280) IOB,F(IOB)
CCCCC         WRITE(3,280) IOB,F(IOB)
C280          FORMAT (1X,/,' AT(',I3,') =',E10.3,' IS TOO LARGE')
 280          FORMAT (' AT(',I3,') =',E10.3,' IS TOO LARGE')
              CALL DPWRST('XXX','WRIT')
              IF(FLAG)THEN
CCCCC APRIL 1996.  USE DATAPLOT I/O
CCCCC           PRINT*,'UNSTABLE MODEL- FIX AND RESTART ITERATION'
                WRITE(ICOUT,283)
  283           FORMAT('*****FROM DDS ROUTINE LS--UNSTABLE MODEL, FIX',
     >                 ' AND RESTART ITERATION')
                CALL DPWRST('XXX','WRIT')
                FLAG=.FALSE.
                N=NSEAS+NPHI0+NPHI+1
                IF(IFMEAN.GT.0.AND.IFSEAS.EQ.0) N=N+NSER
CCCCC           CALL STBLIZ(PAR(N),NMA(INDEX))
                CALL STBLIZ(PAR(N),NMA(INDEX),IERROR)
                IF(IERROR.EQ.'YES')GOTO9999
                GO TO 85
              ELSE
CCCCC           STOP'UNSTABLE MODEL - SECOND TRY'
                WRITE(ICOUT,287)
  287           FORMAT('*****FROM DDS ROUTINE LS--UNSTABLE MODEL, ',
     >                 'SECOND TRY')
                CALL DPWRST('XXX','WRIT')
              ENDIF
            ENDIF
            SST=SST+DF**2
  290    CONTINUE
         SSR=SST
         LG=LG.AND.SST.GT.SSB
         IF(KEY .EQ. 1)THEN
CCCCC      IF(IFPRT.GT.0) WRITE(ICOUT,310) IGRID,FLR,SSR
CCCCC      IF(IFPRT.GT.0)CALL DPWRST('XXX','WRIT')
           GO TO 410
         ENDIF
C
C     CHECK FOR CONVERGENCE
C
         IF((ABS(FLT-1.).LE.CONTOL.OR.ABS(FLT-FLMAX).LE.CONTOL).AND.
     >      ABS(SST-SSE1).LE.ABS(SSE1)*CONTOL.AND..NOT.LG)THEN
            FLR=FLT
  300       CONTINUE
CC300       IF(IFPRT.GT.0) WRITE(ICOUT,310) IGRID,FLR,SSR
CCCCC       IF(IFPRT.GT.0) WRITE(3,310) IGRID,FLR,SSR
CC310       FORMAT(' SEARCH CONVERGED AFTER',I3,' CYCLES, WITH LAMBDA ='
CCCCC>      ,D13.5,/,' AND SSQ =',E13.5,/)
CCCCC       CALL DPWRST('XXX','WRIT')
            GO TO 410
         ENDIF
         INS=0
         K=0
         DO320I=1,3
            IF(FL(I).GT.FLT.AND.INS.EQ.0)INS=I
            IF(INS.GT.0)K=1
            IK=I+K
            FD(IK)=FL(I)
            SD(IK)=SS(I)
  320    CONTINUE
         IF(INS.EQ.0)INS=4
         FD(INS)=FLT
         SD(INS)=SST
         K=0
         IF((SD(2).GT.SD(3).OR.INS.EQ.4).AND.IGRID.GT.2)K=1
         IF(SD(1).LE.SD(2))K=0
         DO330I=1,3
            IK=I+K
            FL(I)=FD(IK)
            SS(I)=SD(IK)
  330    CONTINUE
C
C     STORE BEST VALUES OF SSQ AND LAMBDA
C
         IF(SST.LT.SBEST)THEN
            SBEST=SST
            FBEST=FLT
         ENDIF
C
C     FIND NEW LAMBDA
C
         IF(FL(3).LE.FLMAX) GO TO 340
         IF(SS(1).LE.SS(2)) GO TO 350
         FLT=0.1*FL(1)+0.9*FL(2)
         GO TO 390
C
  340    CONTINUE
         DENOM=(FL(3)-FL(1))*(SS(2)-SS(1))+(FL(1)-FL(2))*(SS(3)-SS(1))
         IF(DENOM.LE.-1./FINF.AND.FL(3).LT.FINF) GO TO 370
         SSP=FINF
         IF(SS(1).GT.SS(2)) GO TO 360
C
  350    CONTINUE
         FLT=0.9*FL(1)+0.1*FL(2)
         GO TO 390
C
  360    CONTINUE
         FLT=FLMAX
         IF(FL(3).GE.0.98*FLMAX)FLT=0.1*FL(2)+0.9*FL(3)
         IF(FL(3).LT.0.49*FLMAX)FLT=2.*FL(3)
         GO TO 390
C
  370 CONTINUE
         FOLD=FLR
         FLR=((FL(3)**2-FL(1)**2)*(SS(2)-SS(1))+(FL(1)**2-FL(2)**2)*
     1   (SS(3)-SS(1)))/2./DENOM
         IF(FLR.GE.FLMAX)FLR=FLMAX
         IF(FLR.LE.FL(1))FLR=FL(1)
         SSR=SS(1)+(SS(2)-SS(1))*(FLR-FL(1))*(FLR-FL(3))/(FL(2)-FL(1))
     1   /(FL(2)-FL(3))+(SS(3)-SS(1))*(FLR-FL(1))*(FLR-FL(2))/(FL(3)-
     2   FL(1))/(FL(3)-FL(2))
         IF(ABS(SSR-SSP).GT.ABS(CONTOL*SSP).AND.DABS(FOLD-FLR).GT.
     >   DABS(CONTOL*FLR)) GO TO 380
         IF(SSR.LT.0..OR.FLR.LE.FL(1).OR.FLR.GT.FL(3).OR.LG) GO TO 380
         FLT=FLR
         KEY=1
         GO TO 260
C
  380    CONTINUE
         SSP=SSR
         FLT=0.9*FL(1)+0.1*FL(2)
         IF(FLR.GT.FLT)FLT=FLR
         FT=0.1*FL(1)+0.9*FL(2)
         IF(FLR.GT.FT)FLT=FT
         FT=0.9*FL(2)+0.1*FL(3)
         IF(FLR.LT.FT)FLT=FT
         IF(FLR.GE.FT)FLT=FLR
         FT=0.1*FL(2)+0.9*FL(3)
         IF(FLR.GT.FT)FLT=FT
         IF(FLR.GT.FL(3)) GO TO 360
  390 CONTINUE
C
      IGRID=ITMAX+1
      IF(IFPRT.GT.0)THEN
         WRITE(ICOUT,401)ITMAX
  401    FORMAT (' SEARCH TOOK FULL',I4,' CYCLES. BEST TRIAL POINT')
         CALL DPWRST('XXX','WRIT')
         WRITE(ICOUT,402)FBEST,SBEST
  402    FORMAT('  LAMBDA = ',E13.5,' SSQ = ',E13.5)
         CALL DPWRST('XXX','WRIT')
      ENDIF
      FLR=FBEST
      SSR=SBEST
C
C     MODIFY PARAMETERS FOR BEST CASE
C
  410 CONTINUE
      DO420I=1,NPAR
          PAR(I)=PARB(I)+A(I,NPAR1)*FLR
          IF(PAR(I).GT.BNDUP)PAR(I)=BNDUP
          IF(PAR(I).LT.BNDLW)PAR(I)=BNDLW
420   CONTINUE
      IF(SSB.LT.SSR.AND.IFPRT.GT.0) WRITE(ICOUT,430) SSR,SSB
CCCCC IF(SSB.LT.SSR.AND.IFPRT.GT.0) WRITE(3,430) SSR,SSB
430   FORMAT (1H ,' CURRENT SSQ',E15.8,' EXCEEDS SSQ',E15.8,
     1' OF PREVIOUS ITERATION')
      IF(SSB.LT.SSR.AND.IFPRT.GT.0) CALL DPWRST('XXX','WRIT')
      IF(ITNO.LE.ITMAX.AND.ABS((SSR-SSB)/CONTOL).GT.SSB.AND.IGRID.GT.1)
     1 GO TO 70
C
      IF(ABS((SSR-SSB)/CONTOL).GT.SSB.AND.IGRID.GT.1)THEN
         WRITE(ICOUT,441) 
 441     FORMAT (' ')
         CALL DPWRST('XXX','WRIT')
         WRITE(ICOUT,441) 
         CALL DPWRST('XXX','WRIT')
         WRITE(ICOUT,440)
 440     FORMAT (' ********CONVERGENCE CRITERION IS NOT SATISFIED',
     1   '********')
         WRITE(ICOUT,442)
 442     FORMAT(
     1    '******** MAXIMUM NUMBER OF ITERATIONS WAS REACHED ********')
         CALL DPWRST('XXX','WRIT')
CCCCC    WRITE(3,440)
C440      FORMAT (//' ********CONVERGENCE CRITERION IS NOT SATISFIED',
CCCCC1   '********'
CCCCC2,/,'******** MAXIMUM NUMBER OF ITERATIONS WAS REACHED ********')
      ENDIF
C
      IF(IFREF.GT.0) RETURN
C
C     FIND CONFIDENCE BOUNDS
C
      NDF=NOB-NES
      SEXT=0
      IF(NDF.GT.0)SEXT=SQRT(SSR/FLOAT(NDF))
C
C     REFORM XTX MATRIX AND INVERT IT
C
      DO460I=1,NPAR
         DO460J=1,I
            XX=0.0
            DO450K=IS,NOB
               XX=XX+Z(K,I)*Z(K,J)
  450       CONTINUE
            A(I,J)=XX
            A(J,I)=XX
  460 CONTINUE
CCCCC APRIL 1996.  ADD IERROR TO ARGUMENT LIST.  USE DATAPLOT I/O
CCCCC CALL GJR (A,NPAR,1,MXPAR1,MXPAR1)
      CALL GJR (A,NPAR,1,MXPAR1,MXPAR1,IERROR)
      IF(IERROR.EQ.'YES')GOTO9999
      DO470I=1,NPAR
            IF(A(I,I).LT.0.0)THEN
               A(I,I)=-A(I,I)
CCCCC          IF(IFPRT.GT.0) PRINT*,'***WARNING***',I,
CCCCC>         ' TH DIAGONAL OF COVARIANCE MATRIX IS NEGATIVE'
               IF(IFPRT.GT.0) THEN
                 WRITE(ICOUT,469)I
 469             FORMAT('*****WARNING FROM DDS ROUTINE LS--',I5,
     >                 'TH DIAGONAL OF COVARIANCE MATRIX IS NEGATIVE.')
               ENDIF
            ENDIF
            A(I,NPAR1)=DSQRT(A(I,I))
            PARB(I)=A(I,NPAR1)*SEXT*1.96
470   CONTINUE
C
C     FIND FINAL AT'S AND PRINT FINAL SSQ
C
CCCCC APRIL 1996.  ADD XDDS AND YDDS
CCCCC CALL MODEL (PAR,F,1)
      CALL MODEL (PAR,F,1,XDDS,YDDS)
      NFUNC=NFUNC+1
      XX=0.0
      DO630I=1,NOB
         XX=XX+F(I)*F(I)
  630 CONTINUE
      F(NOB+1)=SNGL(XX)
C
C     UNSCALE RESIDUAL SSQ FOR EARMA MODELS
C
      IF(NSER.GT.1) XX=XX*SCA(INDEX)**2
C
CCCCC WRITE(ICOUT,640) XX
CCCCC WRITE(3,640) XX
CC640 FORMAT(//,72('*'),///,1X,
CCCCC>  'FINAL RESIDUAL SUM OF SQUARES = ',D12.6,/)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,'(4H SSQ,D15.8)') XX
CCCCC CALL DPWRST('XXX','WRIT')
C
C     UNSCALE DETERMINISTIC PARAMETERS
C
      IF(IFSEAS.EQ.1.OR.IFSEAS.EQ.3)THEN
         N=1
         DO471I=1,NEXP
            N=N+2
            PAR(N)=PAR(N)/DELTA
            PARB(N)=PARB(N)/DELTA
  471    CONTINUE
         DO472I=1,NSIN
            N=N+2
            PAR(N)=PAR(N)/DELTA
            PARB(N)=PARB(N)/DELTA
            N=N+2
            PAR(N)=PAR(N)/DELTA/6.2831853
            PARB(N)=PARB(N)/DELTA/6.2831853
  472    CONTINUE
      ENDIF
C
C     UNSCALE EARMA PARAMETERS AND CONFIDENCE BOUNDS
C
      IF(NSER.GT.1)THEN
         N=NSEAS+1
            IF(IFMEAN.GE.1)THEN
               DO476I=1,NSER
                  PAR(N)=PAR(N)*SCA(I)
                  PARB(N)=PARB(N)*SCA(I)
                  N=N+1
  476          CONTINUE
            ENDIF
C
C     UNSCALE ZERO LAG TERMS
C
            DO473I=INDEX+1,NSER
               IF(LAG(I,INDEX).EQ.0)THEN
                  PAR(N)=PAR(N)*SCA(INDEX)/SCA(I)
                  PARB(N)=PARB(N)*SCA(INDEX)/SCA(I)
                  N=N+1
               ENDIF
473         CONTINUE
C
C     SCALE REST OF PHI TERMS
C
              DO475I=1,NSER
                 IF(I.NE.INDEX)THEN
                    NN=N
                    SCALE=SCA(INDEX)/SCA(I)
                    DO474J=1,NAR(I,INDEX)
                       PAR(NN)=PAR(NN)*SCALE
                       PARB(NN)=PARB(NN)*SCALE
                       NN=NN+1
  474               CONTINUE
                 ENDIF
                 N=N+NAR(I,INDEX)
  475         CONTINUE
           ENDIF
C
C     PRINT PARAMETERS AND CONFIDENCE BOUNDS
C
CCCCC WRITE(ICOUT,*) INDEX,(NAR(J,INDEX),J=1,NSER),NMA(INDEX)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,480)
CCCCC WRITE(3,480)
CC480 FORMAT (////,' BEST PARAMETER VALUES AND 95% CONFIDENCE LIMITS ',
CCCCC>'ESTIMATED',/,
CCCCC>' BY LINEARIZATION FOR THE INDIVIDUAL PARAMETERS ARE',
CCCCC>' AS FOLLOWS:')
CCCCC CALL DPWRST('XXX','WRIT')
C
      NP=1
C
C     PRINT SEASONALITY PARAMETERS
C
      IF(IFSEAS.EQ.1.OR.IFSEAS.EQ.3)THEN
         J1=(NSEAS+3)/4
         DO490 J2=1,J1
            I1=(J2-1)*4+1
            I2=MIN0(NSEAS,J2*4)
C
CCCCC       WRITE(ICOUT,485) (ISEAS(J),J=I1,I2)
CCCCC       WRITE(3,485) (ISEAS(J),J=I1,I2)
485         FORMAT (/,1X,'I  = ',3X,I3,3(5X,I3))
CCCCC       CALL DPWRST('XXX','WRIT')
C
            WRITE(ICOUT,495) (PAR(J),PARB(J),J=I1,I2)
CCCCC       WRITE(3,495) (PAR(J),PARB(J),J=I1,I2)
495         FORMAT (11X,'BETA(I) = ',4(E11.5,' +/-',E10.5,3X,/))
CCCCC       CALL DPWRST('XXX','WRIT')
  490    CONTINUE
C
         NP=NSEAS+1
      ENDIF
C
C     PRINT MEANS
C
      IF(IFMEAN.GT.0.AND.IFSEAS.EQ.0)THEN
CCCCC    WRITE(ICOUT,500) (I,PAR(I),PARB(I),I=NP,NP+NSER-1)
CCCCC    WRITE(3,500) (I,PAR(I),PARB(I),I=NP,NP+NSER-1)
CC500    FORMAT (/,4X,'SERIES',I3,' MEAN = ',E11.5,' +/-',E10.5)
CCCCC    CALL DPWRST('XXX','WRIT')
C
CCCCC    WRITE(ICOUT,'(4H MNS,2E15.8)') (PAR(I),PARB(I),I=NP,NP+NSER-1)
CCCCC    CALL DPWRST('XXX','WRIT')
C
         NP=NP+NSER
      ENDIF
C
C     PRINT PHI'S
C
      WRITE(ICOUT,999)
  999 FORMAT(1H )
      CALL DPWRST('XXX','WRIT')
C
CCCCC AUGUST, 1995.  MODIFIY FOLLOWING LINE FOR CRAY.
CCCCC CRAY DOESN'T ALLOW FREE FORMAT FOR INTERNAL WRITE.
CCCCC WRITE(ICOUT,*)'             ARMA Modeling'
      WRITE(ICOUT,9081)
 9081 FORMAT('             ARMA Modeling')
      CALL DPWRST('XXX','WRIT')
C
CCCCC THE FOLLOWING LINE MUST BE FIXED--REPLACE IORDAR AND IORDMA
C
      WRITE(ICOUT,505)IORDAR,IORDMA
  505 FORMAT(1X,5X,'AR Order = ',I4,'     MA Order = ',I4)
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,506)
  506 FORMAT(1X,'                Estimate     95% Conf. Halfwidth')
      CALL DPWRST('XXX','WRIT')
C
      IF(IFSEAS.NE.1)THEN
         L=NP
         NP=NP+NPHI0-1
         DO550I=1,NSER
            IF(LAG(I,INDEX).EQ.0)THEN
               WRITE(ICOUT,510)INDEX,I,PAR(L)
  510          FORMAT(1H ,I4,I4,G10.5)
               CALL DPWRST('XXX','WRIT')
               LAGT=1
               L=L+1
            ELSE
               LAGT=LAG(I,INDEX)
            ENDIF
            J1=(NAR(I,INDEX)+3)/4
            DO530 J2=1,J1
               I1=(J2-1)*4+1
               I2=MIN0(NAR(I,INDEX),J2*4)
               L1 = I1 + NP
               L2 = I2 + NP
               DO546J=L1,L2
                  WRITE(ICOUT,547) J,PAR(J),PARB(J)
  547             FORMAT(1X,'AR(',I3,')',2X,F15.6,' +-',F15.6)
                  CALL DPWRST('XXX','WRIT')
  546          CONTINUE
  530       CONTINUE
            NP=NP+NAR(I,INDEX)
  550    CONTINUE
C
C     PRINT THETAS
C
         WRITE(ICOUT,999)
         CALL DPWRST('XXX','WRIT')
         J1=(NMA(INDEX)+3)/4
         DO560 J2=1,J1
            I1=(J2-1)*4+1
            I2=MIN0(NMA(INDEX),J2*4)
            L1 = I1 + NP
            L2 = I2 + NP
            DO576J=L1,L2
               JMNP=J-NP
               WRITE(ICOUT,577) JMNP,PAR(J),PARB(J)
  577          FORMAT(1X,'MA(',I3,')',2X,F15.6,' +-',F15.6)
               CALL DPWRST('XXX','WRIT')
  576       CONTINUE
  560    CONTINUE
         NP=NP+NMA(INDEX)
      ENDIF
C
      IF(NSER.GT.1) SEXT=SEXT*SCA(INDEX)
C
      WRITE(ICOUT,999)
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,580)SEXT
  580 FORMAT(1X,5X,'Residual Standard Deviation = ',G13.7)
      CALL DPWRST('XXX','WRIT')
C
C     FIND AND PRINT CORRELATION MATRIX
C
      DO590I=1,NPAR
         DO590J=1,I
            A(I,J)=A(I,J)/A(I,NPAR1)/A(J,NPAR1)
  590 CONTINUE
C
CCCCC IF(IFPRT.GT.0) WRITE(ICOUT,600)
CCCCC IF(IFPRT.GT.0) WRITE(3,600)
CC600 FORMAT (/,' NORMALIZED CORRELATION MATRIX OF PARAMETER',
CCCCC> ' ESTIMATES',/)
CCCCC CALL DPWRST('XXX','WRIT')
C
      J1=(NPAR+9)/10
      DO610 J2=1,J1
         I1=(J2-1)*10+1
         I2=MIN0(NPAR,J2*10)
         DO610I=I1,NPAR
            II=MIN0(I,I2)
  610 CONTINUE
CCCCC IF(IFPRT.GT.0) WRITE(ICOUT,620) (A(I,J),J=I1,II)
CC620 FORMAT (6X,10(F10.7,2X))
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCC APRIL 1996.  ADD FOLLOWING LINE
 9999 CONTINUE
      RETURN
      END
 
C     ..........ATSCOR..........
 
      SUBROUTINE ATSCOR(AT,NOB,INDEX,IFSER,MXNOB1,MXSER)
CCCCC APRIL 1996.  PASS DIMENSION SPECIFIERS AS PART OF ARGUMENT LIST
CCCCC SUBROUTINE ATSCOR(AT,NOB,INDEX,IFSER)
C
C     PURPOSE--CALCULATES CORRELATIONS OF THE RESIDUALS FOR 30 LAGS
C
CCCCC APRIL 1996.  COMMENT OUT FOLLOWING LINE.
CCCCC PARAMETER (MXSER=3,MXSR2=MXSER**2,MXNOB=1024,MXNOB1=MXNOB+1)
      DOUBLE PRECISION SUM,SUM1,SUM2
      DIMENSION AT(MXNOB1,MXSER)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      A=2./NOB
C
C     FIND AND PRINT THE AVERAGE OF THE RESIDUALS
C
      AVG=0.0
      DO10I=1,NOB
         AVG=AVG+AT(I,INDEX)
  10  CONTINUE
      AVG=AVG/NOB
C
CCCCC WRITE(ICOUT,20) INDEX,AVG
CCCCC WRITE(3,20) INDEX,AVG
CCC20 FORMAT (////,6X,
CCCCC> 'THE AVERAGE OF THE RESIDUALS FOR SERIES',I5,
CCCCC>'  =',E15.6)
CCCCC CALL DPWRST('XXX','WRIT')
C
C     MEAN SUBTRACT THE AT'S FOR THIS SERIES
C
      DO25I=1,NOB
         AT(I,INDEX)=AT(I,INDEX)-AVG
   25 CONTINUE
C
C     CALCULATE THE CORRELATIONS
C
      DO110I=1,INDEX-1
         IF(IFSER.EQ.0)THEN
C
C     FIND CROSS CORRELATIONS BETWEEN THE SERIES
C
            SSQ=0.0
            Q=SQRT(AT(NOB+1,I)*AT(NOB+1,INDEX))
C
CCCCC       WRITE(ICOUT,30) I,INDEX
CCCCC       WRITE(3,30) I,INDEX
CCC30       FORMAT (//,7X,'CORRELATIONS OF SERIES'
CCCCC>      ,I3,' RESIDUALS ',
CCCCC>      'WITH SERIES',I3,' RESIDUALS',//,1X,'LAG'
CCCCC>      ,1X,'CORRELATION',3X,'UNIFIED',2X,'LAG'
CCCCC>      ,1X,'CORRELATION',3X,'UNIFIED',/,
CCCCC>      2(1X,3('-'),1X,11('-'),3X,7('-'),1X))
CCCCC       CALL DPWRST('XXX','WRIT')
C
             DO55K=0,30
                SUM1=0.0
                SUM2=0.0
                DO40J=K+1,NOB
                   SUM1=SUM1+AT(J,I)*AT(J-K,INDEX)
                   SUM2=SUM2+AT(J-K,I)*AT(J,INDEX)
  40            CONTINUE
                R1=SUM1/Q
                R2=SUM2/Q
                SE=SQRT(FLOAT(NOB-K))
                S1=R1*SE
                S2=R2*SE
                SSQ=SSQ+R1**2+R2**2
C
CCCCC            WRITE(ICOUT,60) K,R1,S1,-K,R2,S2
CCCCC            WRITE(3,60) K,R1,S1,-K,R2,S2
CCC60            FORMAT(1X,I3,1X,F11.6,1X,F11.6,2X,I3,1X,F11.6,1X
CCCCC>                  ,F11.6)
CCCCC            CALL DPWRST('XXX','WRIT')
C
   55        CONTINUE
CCCCC        WRITE(ICOUT,65) SSQ
CCCCC        WRITE(3,65) SSQ
CCC65        FORMAT(//,3X,'THE SUM OF SQUARES OF THE CROSS',
CCCCC>       ' CORRELATIONS =',E12.4)
CCCCC        CALL DPWRST('XXX','WRIT')
C
         ENDIF
C
110   CONTINUE
C
C     FIND THE AUTOCORRELATIONS OF THE INDEX SERIES
C
      SSQ=0.0
      VAR=1./NOB
      Q=AT(NOB+1,INDEX)
C
CCCCC WRITE(ICOUT,70) INDEX
CCC70 FORMAT(//,10X,'AUTO CORRELATIONS OF SERIES',I3,' RESIDUALS'
CCCCC>, //,10X,'LAG',7X,'CORRELATION',13X,'UNIFIED',/)
CCCCC CALL DPWRST('XXX','WRIT')
C
      UAM = 0.
      LAGUAM=0
      LFUAG2=0
      NUAG2 =0
      DO90K=1,30
         SUM=0.0
         DO80J=1,NOB-K
                     SUM=SUM+AT(J,INDEX)*AT(J+K,INDEX)
  80     CONTINUE
         R=SUM/Q
         S=R/SQRT(VAR)
         AS = ABS(S)
         IF(AS.GT.2.)THEN
            IF(LFUAG2.EQ.0)THEN
               LFUAG2 = K
               NUAG2 = 1
            ELSE
               NUAG2 = NUAG2 + 1
            ENDIF
         ENDIF
         IF(AS.GT.ABS(UAM))THEN
            UAM = S
            LAGUAM = K
         ENDIF
         SSQ=SSQ+R**2
         VAR=VAR+A*R**2
C
CCCCC    WRITE(ICOUT,100) K,R,S
CCCCC    WRITE(3,100) K,R,S
CC100    FORMAT (10X,I3,5X,F12.7,10X,F12.7)
CCCCC    CALL DPWRST('XXX','WRIT')
C
   90 CONTINUE
C
CCCCC WRITE(ICOUT,105) SSQ
CCCCC WRITE(3,105) SSQ
CC105 FORMAT(//,9X,'THE SUM OF SQUARES OF THE AUTO',
CCCCC>' CORRELATIONS =',E12.4)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,106) UAM,LAGUAM,NUAG2,LFUAG2
CCCCC WRITE(3,106) UAM,LAGUAM,NUAG2,LFUAG2
CC106 FORMAT(/,9X,
CCCCC>' THE MAXIMUM UNIFIED AUTOCORRELATION IS',E15.8,/,9X,
CCCCC>'   OCCURING AT LAG . . . . . . . . . . . ',I3,/,9X,
CCCCC>' THE NO. OF UNI. AUTCOR. WITH :UA: > 2 IS',I3,/,9X,
CCCCC>'   THE FIRST OCCURS AT LAG . . . . . . . ',I3)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,'(E15.4,3I5)') UAM,LAGUAM,LFUAG2,NUAG2
CCCCC CALL DPWRST('XXX','WRIT')
C
      RETURN
      END
 
C     ..........ANALYS..........
 
      SUBROUTINE ANALYS(PAR,VAR,IOUNI2,IOUNI3)
CCCCC APRIL 1996.  ADD I/O UNITS TO ARGUMENT LIST, PASS DELTA THROUGH
CCCCC COMMON
CCCCC SUBROUTINE ANALYS(PAR,DELTA,VAR)
C
C     PURPOSE--FINDS THE ROOTS,FREQUENCIES,AND DAMPING, AND THE
C
C     GREEN'S FUNCTION AND IMPULSE RESPONSE COEFFICIENTS OF THE MODEL
CCCCC APRIL 1996.  USE DPCODD.INC FOR FOLLOWING
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45)
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      COMPLEX ROOT(MXPAR)
      DIMENSION PAR(MXPAR),VAR(MXSER)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     FIND ROOTS OF AUTOREGRESSIVE SIDE
C
      IF(NAR(INDEX,INDEX).EQ.0) RETURN
      N=NPHI0+NSEAS+1
      IF(IFMEAN.GE.1.AND.IFSEAS.EQ.0) N=N+NSER
      DO10I=1,INDEX-1
         N=N+NAR(I,INDEX)
  10  CONTINUE
      NR=NAR(INDEX,INDEX)
CCCCC THE FOLLOWING LINE WAS QUESTIONABLY CHANGED--JJF NOVEMBER 1994
CCCCC CALL EIGEN(PAR(N),NR,ROOT)
      CALL EIGEN(PAR,NR,ROOT)
C
CCCCC WRITE(ICOUT,30)
CCC30 FORMAT (////,37X,20('*'),'MODEL CHARACTERISTICS',20('*'),///)
CCCCC CALL DPWRST('XXX','WRIT')
C
C     FIND EXPLICIT GREEN'S FUNCTION AND IMPULSE RESPONSE
C
      N=NSEAS+1
      IF(IFMEAN.GE.1.AND.IFSEAS.EQ.0) N=N+NSER
      N1=N
      N=N+NPHI0
      M=N+NPHI
      DO63I=1,NSER
C
C     SET ZERO LAG TERMS
C
         IF(LAG(I,INDEX).EQ.0)THEN
            PHI0=PAR(N1)
            N1=N1+1
            N2=N
            NN=NAR(I,INDEX)
         ELSE
            PHI0=PAR(N)
            N2=N+1
            NN=NAR(I,INDEX)-1
         ENDIF
C
C     FIND FUNCTION FOR SERIES I
C
         IF(I.NE.INDEX.AND.NR.GT.NN)THEN
            WRITE(ICOUT,61) INDEX,I
61          FORMAT(44X,'IMPULSE RESPONSE FUNCTION OF SERIES',
     >      I3,' TO SERIES',I3)
            CALL DPWRST('XXX','WRIT')
            WRITE(ICOUT,62)
62          FORMAT(' ')
            CALL DPWRST('XXX','WRIT')
C
            CALL GREENZ(PHI0,PAR(N2),ROOT,NR,NN,LAG(I,INDEX),'IMP(j) =',
CCCCC APRIL 1996.  ADD I/O UNITS TO ARGUMENT LIST, PASS DELTA THROUGH
CCCCC COMMON
CCCCC>                  DELTA,VAR(I))
     >                  VAR(I),IOUNI2,IOUNI3)
         ELSEIF(I.EQ.INDEX.AND.NR.GT.NMA(INDEX))THEN
C
CCCCC       WRITE(ICOUT,62) INDEX
CCC62       FORMAT (44X,'GREEN''S FUNCTION OF SERIES',I3,
CCCCC>      ' WITH ITS RESIDUALS',/)
CCCCC       CALL DPWRST('XXX','WRIT')
C
            CALL GREENZ(1.0,PAR(M),ROOT,NR,NMA(INDEX),0,'  G(j) =',
CCCCC APRIL 1996.  ADD I/O UNITS TO ARGUMENT LIST, PASS DELTA THROUGH
CCCCC COMMON
CCCCC>                 DELTA,VAR(I))
     >                 VAR(I),IOUNI2,IOUNI3)
C
         ELSEIF(I.EQ.INDEX.AND.NR.LE.NMA(INDEX))THEN
CCCCC       WRITE(ICOUT,409) INDEX
CC409       FORMAT(44X,'EXPLICIT FORM OF SERIES',I3,' GREENS',
CCCCC>      ' FUNCTION AND',/,50X,'COMPONENTS OF SPECTRUM',
CCCCC>      ' DONOT EXIST',/)
CCCCC       CALL DPWRST('XXX','WRIT')
C
CCCCC APRIL 1996.  ADD TO ARGUMENT LIST, MAKE NAME 6 CHARACTERS
CCCCC PASS DELTA THROUGH COMMON
CCCCC       CALL SPECTRUM(1.0,PAR(M),PAR(N),NR,NMA(INDEX),0,
CCCCC>                    DELTA)
            CALL SPCTRM(1.0,PAR(M),PAR(N),NR,NMA(INDEX),0,IOUNI3)
C
         ENDIF
         N=N+NAR(I,INDEX)
  63  CONTINUE
C
C     FIND FREQENCIES AND DAMPING OF AUTOREGRESSIVE OPERATOR
C
CCCCC WRITE(ICOUT,64)
CCC64 FORMAT (///,45X,'CHARACTERISTICS OF THE AUTOREGRESSIVE OPERATOR')
CCCCC CALL DPWRST('XXX','WRIT')
C
      CALL FREQ(NR,ROOT,DELTA)
C
C     FIND ROOTS OF MOVING AVERAGE SIDE
C
      NR=NMA(INDEX)
      IF(NR.GT.0)THEN
         N=NSEAS+NPHI0+NPHI+1
         IF(IFMEAN.GE.1.AND.IFSEAS.EQ.0) N=N+NSER
CCCCC THE FOLLOWING LINE WAS QUESTIONABLY CHANGED--JJF NOVEMBER 1994
CCCCC    CALL EIGEN(PAR(N),NR,ROOT)
         CALL EIGEN(PAR,NR,ROOT)
C
C     FIND FREQENCIES AND DAMPING OF MOVING AVERAGE OPERATOR
C
CCCCC    WRITE(ICOUT,80)
CCC80    FORMAT(/////,45X,'CHARACTERISTICS OF THE MOVING',
CCCCC>   ' AVERAGE OPERATOR')
CCCCC    CALL DPWRST('XXX','WRIT')
C
         CALL FREQ(NR,ROOT,DELTA)
      ENDIF
      RETURN
      END
 
C     ..........STBLIZ..........
 
      SUBROUTINE STBLIZ(THETA,N,IERROR)
C
C     PURPOSE--CHECKS FOR STABILITY OF THETA AND FIXES IF NECESSARY
C
      PARAMETER (MXPAR=45,MXPAR1=MXPAR+1)
      COMPLEX ROOT(MXPAR),UNSRT,RPRIME
CCCCC COMPLEX*16 CTHETA(MXPAR),F,FPRIME
      COMPLEX    CTHETA(MXPAR),F,FPRIME
      DIMENSION THETA(MXPAR),NSTABL(MXPAR)
      CHARACTER*4 IERROR
C
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
C     COMPUTE DISCRETE ROOTS
C
      CALL EIGEN(THETA,N,ROOT(1))
C     PRINT*,'INITIAL NUS',(ROOT(I),I=1,N)  @@DIA
C
C     CHECK FOR UNSTABLE MODEL
C
      ISTABL=0
      EPS=0.0001
      DO20I=1,N
         IF(CABS(ROOT(I)).GT.1.0+EPS)THEN
           ISTABL=ISTABL+1
            NSTABL(ISTABL)=I
         ENDIF
20    CONTINUE
C     PRINT*,'ISTABL=',ISTABL,'NSTABL=',(NSTABL(I),I=1,ISTABL) @@DIA
C
C     STABILIZE ANY UNSTABLE ROOTS - IF NECESSARY
C
      IF(ISTABL.GT.0)THEN
         DO30I=1,N
            CTHETA(I)=CMPLX(THETA(I),0.)
  30     CONTINUE
         DO50I=1,ISTABL
            UNSRT=ROOT(NSTABL(I))
            RPRIME=1./UNSRT
C           PRINT*,'UNSRT=',UNSRT,' RPRIME=',RPRIME  @@DIA
C
C     PARTIAL REVERSE ROUTINE - UPDATE PARAMETERS FOR ONE ALTERED ROOT
C
            F=CTHETA(1)-UNSRT
            CTHETA(1)=F+RPRIME
            DO40J=2,N
               FPRIME=F*RPRIME
               F=CTHETA(J)+F*UNSRT
               CTHETA(J)=F-FPRIME
  40        CONTINUE
  50     CONTINUE
         DO60I=1,N
            THETA(I)=REAL(CTHETA(I))
  60     CONTINUE
      ENDIF
C     PRINT*,'NEW THETAS',(THETA(I),I=1,N)  @@DIA
C     PRINT*,'NEW CTHETAS',(CTHETA(I),I=1,N)  @@DIA
      CALL EIGEN(THETA,N,ROOT(1))
C     PRINT*,'FINAL NUS',(ROOT(I),I=1,N)  @@DIA
      RETURN
      END
 
C     ..........DIF..........
 
      SUBROUTINE DIF(PAR,Z,AT,IS,XDDS,YDDS)
CCCCC APRIL 1996.  ADD XDDS AND YDDS, PASS IFMEAN THROUGH COMMON
CCCCC SUBROUTINE DIF(PAR,Z,AT,IS,IFMEAN)
C
C     PURPOSE--FINDS THE ANALYTICAL DERIVATIVES OF THE
C              RESIDUALS WITH RESPECT TO THE STOCHASTIC PARAMETERS
C
CCCCC APRIL 1996.  USE DPCODD.INC
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXNOB1=MXNOB+1,MXPAR=45,
CCCCC>MXPAR1=MXPAR+1)
      DOUBLE PRECISION S
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON/DDSDAT/ YDDS(MXNOB,MXSER),XDDS(MXNOB,MXSER)
      DIMENSION PAR(MXPAR),AT(MXNOB1),Z(MXNOB,MXPAR1)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IZ=1
      KPAR=NPHI0+NPHI+1
C
C     FIND DERIVATIVES WITH RESPECT TO MEANS IF ESTIMATED
C
         IF(IFMEAN.GE.1)THEN
C
C     RESTORE ORIGINAL DATA VALUES
C
            DO5I=1,NSER
               DO5J=1,NOB
                  XDDS(J,I)=YDDS(J,I)
   5        CONTINUE 
            KPAR=KPAR+NSER
            IPAR=NSER+1
            JPAR=IPAR+NPHI0
            DO30 IZ=1,NSER
               SUM=0.0
               IF(IZ.EQ.INDEX)SUM=-1.0
               IF(IZ.GT.INDEX.AND.LAG(IZ,INDEX).EQ.0)THEN
                  SUM=-PAR(IPAR)
                  IPAR=IPAR+1
               ENDIF
               DO10J=1,NAR(IZ,INDEX)
                  SUM=SUM+PAR(JPAR)
                  JPAR=JPAR+1
  10           CONTINUE
               DO30 IT=1,NOB
                  S=SUM
                  K=KPAR
                  DO20J=1,MIN(IT-1,NMA(INDEX))
                      S=S+PAR(K)*Z(IT-J,IZ)
                      K=K+1
  20              CONTINUE
                  Z(IT,IZ)=S
  30        CONTINUE
         ENDIF
C
C     FIND DERIVATIVES WITH RESPECT TO PHI0'S
C
         DO60I=1+INDEX,NSER
            IF(LAG(I,INDEX).EQ.0)THEN
               DO50 IT=1,NOB
                  K=KPAR
                  S=XDDS(IT,I)
                  DO40J=1,MIN(IT-1,NMA(INDEX))
                      S=S+PAR(K)*Z(IT-J,IZ)
                      K=K+1
  40              CONTINUE
                  Z(IT,IZ)=S
  50           CONTINUE
               IZ=IZ+1
            ENDIF
60      CONTINUE
C
C     FIND DERIVATIVES WITH RESPECT TO PHI'S - PHI1 FIRST
C
         DO140I=1,NSER
            LAGT=LAG(I,INDEX)
            IF(LAGT.EQ.0)LAGT=1
            N=1
  65        CONTINUE
            DO80 IT=1,LAGT
                S=0.0
                IF(IFMEAN.GE.1)S=PAR(I)
                K=KPAR
                DO70J=1,MIN(IT-1,NMA(INDEX))
                    S=S+PAR(K)*Z(IT-J,IZ)
                      K=K+1
  70            CONTINUE
                 Z(IT,IZ)=S
  80        CONTINUE
            DO100 IT=LAGT+1,NOB
               S=0.0
               IF(IFMEAN.GE.1)S=PAR(I)
               K=KPAR
               DO90J=1,MIN(IT-1,NMA(INDEX))
                   S=S+PAR(K)*Z(IT-J,IZ)
                   K=K+1
  90            CONTINUE
                Z(IT,IZ)=S-XDDS(IT-LAGT,I)
 100        CONTINUE
C
C     DO THE REST OF THE PHI'S FOR THIS SERIES
C
            IZ=IZ+1
            IF(IFMEAN.GE.1)THEN
               N=N+1
               LAGT=LAGT+1
               IF(N.LE.NAR(I,INDEX))GO TO 65
            ELSE
               DO130J=2,NAR(I,INDEX)
                  DO110 IT=I,J
                     Z(IT,IZ)=0.0
  110             CONTINUE
                  DO120 IT=J+1,NOB
                     Z(IT,IZ)=Z(IT-1,IZ-1)
  120             CONTINUE
                  IZ=IZ+1
  130          CONTINUE
            ENDIF
140     CONTINUE
C
C     FIND DERIVATIVES WITH RESPECT TO THETA - THETA1 FIRST
C
         Z(1,IZ)=0.0
         DO160 IT=2,NOB
            S=0.0
            K=KPAR
            DO150J=1,MIN(IT-1,NMA(INDEX))
               S=S+PAR(K)*Z(IT-J,IZ)
               K=K+1
  150       CONTINUE
            Z(IT,IZ)=S+AT(IT-1)
  160   CONTINUE
C
C     DO THE REST OF THE THETA TERMS
C
         DO180I=2,NMA(INDEX)
            IZ=IZ+1
            DO170 IT=1,I
               Z(IT,IZ)=0.0
  170       CONTINUE
            DO180 IT=I+1,NOB
                 Z(IT,IZ)=Z(IT-1,IZ-1)
  180    CONTINUE
      IS=MAXLAG
      RETURN
      END
 
C     ..........XA..........
 
      SUBROUTINE XA(X1,X2,XTX,N,M,IR,IC,MAXLAG,NOB,MXINV,MXINV1)
CCCCC APRIL 1996.  ADD ARRAY DIMENSION TO ARGUMENT LIST
CCCCC SUBROUTINE XA(X1,X2,XTX,N,M,IR,IC,MAXLAG,NOB)
C     PURPOSE--FORMS THE OFF DIAGONAL BLOCKS
C
C     NOTE--IR AND IC ARE THE POSITION OF THE UPPER LEFT ELEMEN
C
CCCCC APRIL 1996.  USE IMPLICIT DIMENSION
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45,MXINV=50,MXINV1=MXINV+1)
      DOUBLE PRECISION XTX,SUM
CCCCC DIMENSION X1(MXNOB),X2(MXNOB),XTX(MXINV,MXINV1)
      DIMENSION X1(*),X2(*),XTX(MXINV,MXINV1)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      NOBM1=NOB-1
      NP1=N+1
C
C     FORM UPPER RIGHT HALF
C
C     GET INITIAL WINDOW
C
      DO20I=N-1,1,-1
         SUM=0.0
         DO10J=MAXLAG,NOBM1
            SUM=SUM+X1(J-I)*X2(J)
  10     CONTINUE
         XTX(IR,IC+I)=SUM
C
C     WINDOW REST OF DIAGONAL
C
         DO20J=1,MIN(M-1,N-I-1)
             SUM=SUM+X1(N-J-I)*X2(N-J)-X1(NOB-J-I)*X2(NOB-J)
             XTX(IR+J,IC+I+J)=SUM
  20  CONTINUE
C
C     FORM LOWER LEFT HALF
C
C     GET INITIAL WINDOW
C
      DO40I=0,M-1
         SUM=0.0
         DO30J=MAXLAG,NOBM1
            SUM=SUM+X1(J)*X2(J-I)
  30     CONTINUE
         XTX(IR+I,IC)=SUM
C
C     WINDOW REST OF DIAGONAL
C
         DO40J=1,M-I-1
            SUM=SUM+X1(M-J)*X2(M-J-I)-X1(NOB-J)*X2(NOB-J-I)
            XTX(IR+I+J,IC+J)=SUM
  40     CONTINUE
C
      RETURN
      END
 
C     ..........MODEL..........
 
      SUBROUTINE MODEL(PAR,AT,IFIRST,XDDS,YDDS)
CCCCC APRIL 1996.  ADD XDDS, YDDS TO ARGUMENT LIST
CCCCC SUBROUTINE MODEL(PAR,AT,IFIRST)
C
C     PURPOSE--FINDS THE RESIDUALS (AT'S) OF THE MODEL
C
      DOUBLE PRECISION SUM
CCCCC APRIL 1996.  REPLACE FOLLOWING WITH DPCODD.INC
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
      DIMENSION XDDS(MAXOBV,MXSER)
      DIMENSION YDDS(MAXOBV,MXSER)
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXNOB1=MXNOB+1,MXPAR=45)
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /LAG/ LAG(MXSER,MXSER),NAR(MXSER,MXSER),NMA(MXSER)
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
CCCCC COMMON /SEASON/ NPOLY,NEXP,NSIN,ISEAS(30),SEAS(30),DELTA
CCCCC COMMON/DDSDAT/ YDDS(MXNOB,MXSER),XDDS(MXNOB,MXSER)
      DIMENSION PAR(MXPAR),AT(MXNOB1)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IPAR=1
C
C     SEASONALITY PARAMETERS
C
      IF(IFSEAS.EQ.1.OR.IFSEAS.EQ.3)THEN
C
C     LOAD SEASONALITY ARRAY
C
         N=1
         DO10I=1,NSEAS
            SEAS(ISEAS(I))=PAR(IPAR)
            IPAR=IPAR+1
10       CONTINUE
C
C     SUBTRACT SEASONALITY FROM DATA
C
CCCCC APRIL 1996.  ADD XDDS, YDDS ARGUMENTS, NOB PASSED THROUGH COMMON
CCCCC    CALL DETPAR(NOB)
         CALL DETPAR(XDDS,YDDS)
         IF(IFIRST.EQ.0) RETURN
C
C     SUBTRACT MEAN IF ESTIMATED
C
      ELSEIF(IFMEAN.GE.1.AND.IFSEAS.EQ.0)THEN
         DO40I=1,NSER
            DO30J=1,NOB
               XDDS(J,I)=YDDS(J,I)-PAR(IPAR)
  30        CONTINUE
            IPAR=IPAR+1
  40     CONTINUE
      ENDIF
      IF(IFSEAS.EQ.1)THEN
         DO20I=1,NOB
            AT(I)=XDDS(I,1)
  20     CONTINUE
         RETURN
      ENDIF
C
C     FIND FIRST MAXLAG AT'S
C
      JPAR=IPAR
      IF(IFAT.EQ.0)THEN
         DO50I=1,MAXLAG
            AT(I)=0.0
  50     CONTINUE
      ELSEIF(IFAT.GT.0)THEN
         DO100 IT=1,MAXLAG
           IPAR=JPAR
           SUM=0.0
C
C     FIND PHI(0) TERMS
C
           DO60I=INDEX+1,NSER
              IF(LAG(I,INDEX).EQ.0)THEN
                 SUM=SUM+PAR(IPAR)*XDDS(IT,I)
                 IPAR=IPAR+1
              ENDIF
60         CONTINUE
C
C     FIND REST OF PHI TERMS
C
           KPAR=IPAR
           DO80I=1,NSER
              LAGT=LAG(I,INDEX)
              IF(LAGT.EQ.0) LAGT=1
              IPAR=KPAR
              DO70J=LAGT,MIN(IT,LAGT+NAR(I,INDEX))-1
                 SUM=SUM-PAR(IPAR)*XDDS(IT-J,I)
                 IPAR=IPAR+1
  70          CONTINUE
              KPAR=KPAR+NAR(I,INDEX)
  80       CONTINUE
C
C     DOTHETA TERMS
C
           DO90I=1,MIN(IT-1,NMA(INDEX))
              SUM=SUM+PAR(KPAR)*AT(IT-I)
              KPAR=KPAR+1
  90       CONTINUE
           AT(IT)=XDDS(IT,INDEX)+SUM
 100     CONTINUE
      ELSE
         NP=IPAR+NPHI0+NPHI+NMA(INDEX)-1
         DO1I=1,MAXLAG
            AT(I)=PAR(NP+I)
 1       CONTINUE
      ENDIF
C
C     FIND REST OF AT'S
C
      DO140 IT=MAXLAG+1,NOB
        IPAR=JPAR
        SUM=0.0
        DO110I=INDEX+1,NSER
           IF(LAG(I,INDEX).EQ.0)THEN
              SUM=SUM+PAR(IPAR)*XDDS(IT,I)
              IPAR=IPAR+1
           ENDIF
110     CONTINUE
        DO120I=1,NSER
           LAGT=LAG(I,INDEX)
           IF(LAGT.EQ.0) LAGT=1
           DO120J=LAGT,LAGT+NAR(I,INDEX)-1
               SUM=SUM-PAR(IPAR)*XDDS(IT-J,I)
               IPAR=IPAR+1
  120   CONTINUE
        DO130I=1,NMA(INDEX)
           SUM=SUM+PAR(IPAR)*AT(IT-I)
           IPAR=IPAR+1
  130   CONTINUE
        AT(IT)=XDDS(IT,INDEX)+SUM
  140 CONTINUE
      MXLAG1 = MAXLAG+1
      RETURN
      END
 
C     ..........XX..........
 
      SUBROUTINE XXZ(XDDS,XTX,N,IR,IC,MAXLAG,NOB,MXINV,MXINV1)
CCCCC APRIL 1996.  ADD MXINV, MXINV1 TO ARGUMENT LIST, RENAME TO
CCCCC AVOID NAME CONFLICT.
CCCCC SUBROUTINE XX(XDDS,XTX,N,IR,IC,MAXLAG,NOB)
C
C     PURPOSE--FORMS THE LOWER TRIANGLE OF THE DIAGONAL BLOCKS
C
C     IR AND IC ARE THE POSITION OF THE UPPER LEFT CORNER
CCCCC APRIL 1996.  USE ARGUMENT LIST TO DIMENSION ARRAYS
CCCCC PARAMETER (MXSER=3,MXNOB=1024,MXPAR=45,MXINV=50,MXINV1=MXINV+1)
      DOUBLE PRECISION XTX,SUM
CCCCC DIMENSION XDDS(MXNOB),XTX(MXINV,MXINV1)
      DIMENSION XDDS(*),XTX(MXINV,MXINV1)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      K=NOB+1
      L=N+1
      DO20I=0,N-1
         SUM=0.0
C
C     FORM INITIAL WINDOW
C
         DO10J=MAXLAG,NOB-1
            SUM=SUM+XDDS(J-I)*XDDS(J)
  10     CONTINUE
         XTX(IR+I,IC)=SUM
C
C     WINDOW REST OF DIAGONAL
C
         DO20J=1,N-I-1
            IF(J.EQ.0) GO TO 20
            SUM=SUM+XDDS(N-J)*XDDS(N-J-I)-XDDS(NOB-J)*XDDS(NOB-J-I)
            XTX(IR+I+J,IC+J)=SUM
  20  CONTINUE
      RETURN
      END
 
C     ..........FREQ..........
 
      SUBROUTINE FREQ(NR,ROOT,DELTA)
C
C     PURPOSE--CALCULATES FREQUENCY AND DAMPING FROM THE ROOTS
C
CCCCC THE FOLLOWING LINE WAS FIXED--JJF    NOVEMBER 1994
CCCCC COMPLEX ROOT(1),CROOT
      COMPLEX ROOT(*),CROOT
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
CCCCC WRITE(ICOUT,10)
CCC10 FORMAT (/,46X,'DISCRETE',14X,'NATURAL',/,43X,
CCCCC>'COMPLEX ROOTS',11X,
CCCCC>'FREQUENCY',10X,'DAMPING',/,43X,'REAL',6X,'IMAG',12X,'(HZ)',
CCCCC>14X,'RATIO',/,41X,52('-'))
CCCCC CALL DPWRST('XXX','WRIT')
C
         DO40I=1,NR
C
C     FIND FREQUENCY AND DAMPING FOR 2ND ORDER ROOT
C
            AIROOT=AIMAG(ROOT(I))
               IF(AIROOT.GT.0)THEN
                  CROOT=CLOG(ROOT(I))/DELTA
                  ACROOT=CABS(CROOT)
                  W=ACROOT/6.2831853
                  Z=-REAL(CROOT)/ACROOT
C
CCCCC             WRITE(ICOUT,20) ROOT(I),W,Z
CCC20             FORMAT (40X,F7.4,' +/-',F7.4,2(7X,E11.4))
CCCCC             CALL DPWRST('XXX','WRIT')
C
C     FIND BREAK FREQUENCY FOR REAL ROOTS
C
               ELSEIF(AIROOT.EQ.0)THEN
                  RROOT=REAL(ROOT(I))
                     IF(RROOT.LE.0)THEN
C
C     NEGATIVE ROOT - SET BREAK FREQUENCY AT NYQUIST FREQUENCYDDS(
C
                        W=0.5/DELTA
                     ELSE
C     POSITIVE ROOT - CALCULATE BREAK FREQUENCY
C
                        W=-ALOG(RROOT)/(DELTA*6.2831853)
                     ENDIF
C
CCCCC             WRITE(ICOUT,30) REAL(ROOT(I)),W
CCC30             FORMAT (40X,F7.4,18X,E11.4)
CCCCC             CALL DPWRST('XXX','WRIT')
C
               ENDIF
40       CONTINUE
C
      RETURN
      END
 
C     ..........EIGEN..........
 
      SUBROUTINE EIGEN(PAR,N,ROOT)
C
C     PURPOSE--USES A MODIFIED BAIRSTOW METHOD FOR ROOT EXTRACTION
C
CCCCC APRIL 1996.  USE DPCODD.INC
CCCCC PARAMETER (MXPAR=45,MP=6*MXPAR/5,MP1=MP+1,MXPAR1=MXPAR+1)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
CCCCC THE FOLLOWING LINE WAS FIXED--JJF    NOVEMBER 1994
CCCCC REAL PAR(1),A(MXPAR1)
CCCCC REAL PAR(MXPAR),A(MXPAR1)
      REAL PAR(*),A(MXPAR1)
      COMPLEX ROOT(MXPAR)
      DIMENSION H(MP),B(MP1),C(MP1),U(MXPAR),V(MXPAR)
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      REAL CPUMIN,CPUMAX
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      TEMP=0.
      DENOM=1.
      N1=N+1
      A(1)=-1.
      A(N1)=1./PAR(N)
      DO5I=2,N
         II=N1-I
         A(I)=-PAR(II)*A(N1)
    5 CONTINUE
      IREV=1
      NC=N+1
C
C     THIS LOOP STORES THE COEFFICIENTS OF THE ORIGINAL POLYNOMIAL INTO H
C
      DO10I=1,NC
         B(I)=0.
         H(I)=A(I)
   10 CONTINUE
      P=0.
      Q=0.
      R=0.
C
C     THE FOLLOWING SECTION CHECKS TO SEE IF 0 IS A ROOT
C
   30 CONTINUE
      IF(H(1).NE.0)GO TO 40
      NC=NC-1
      V(NC)=0.
      U(NC)=0.
C
C     THIS LOOP STORES THE COEFFICIENTS OF THE DEPRESSED POLYNOMIAL INTO H
C
      DO20I=1,NC
         H(I)=H(I+1)
   20 CONTINUE
      GO TO 30
C
C     GENERATE FIRST OR SECOND ORDER ROOTS
C
   40 CONTINUE
      IF(NC.EQ.1)GO TO 320
      IF(NC.NE.2)GO TO 50
      R=-H(1)/H(2)
      GO TO 200
C
   50 CONTINUE
      IF(NC.NE.3)GO TO 60
      P=H(2)/H(3)
      Q=H(1)/H(3)
      GO TO 240
C
C     REVERSE COEFFICIENT ORDER IF WILL SPEED CONVERGENCE OF P,Q,& R
C
   60 CONTINUE
      IF(DABS(H(NC-1)/H(NC)).GE.DABS(H(2)/H(1)))GO TO 100
C
C     REVERSE COEFFICIENTS AND SET IREV FOR INTERCHANGE
C
      IREV=-IREV
      M=NC/2
      DO70I=1,M
         NL=NC+1-I
         TEMP=H(NL)
         H(NL)=H(I)
         H(I)=TEMP
   70 CONTINUE
C
C     INITIAL GUESS OF P,Q,& R AFTER FIRST FACTOR AND ITS ROOTS FOUND
C
      IF(Q.EQ.0)GO TO 80
      P=P/Q
      Q=1./Q
      GO TO 90
C
   80 CONTINUE
      P=0.
   90 CONTINUE
      IF(R.EQ.0)GO TO 100
      R=1./R
C
C     SET ERROR CRITERION AND FIRST 2 B'S AND C'S
C
  100 CONTINUE
      E=5.E-10
      B(NC)=H(NC)
      C(NC)=H(NC)
      B(NC+1)=0.
      C(NC+1)=0.
      NP=NC-1
C
C     LOOP TO FIND THE LINEAR AND QUADRATIC FACTORS OF THE GIVEN POLYNOMIA
C
  190 CONTINUE
      DO110J=1,1000
C
C     THIS SECTION FINDS THE LINEAR FACTORS
C
         DO120K=1,NP
            I=NC-K
            B(I)=H(I)+R*B(I+1)
            C(I)=B(I)+R*C(I+1)
  120    CONTINUE
C
C     CHECK IF R IS CONSTANT TERM OF FACTOR - ELSE NEW R
C
         IF(DABS(B(1)/H(1)).LE.E)GO TO 200
         IF(C(2).EQ.0.)GO TO 130
         R=R-B(1)/C(2)
         GO TO 140
  130    CONTINUE
         R=R+1
C
C     THIS SECTION FINDS THE QUADRATIC FACTORS
C
  140    CONTINUE
         DO150K=1,NP
            I=NC-K
            B(I)=H(I)-P*B(I+1)-Q*B(I+2)
            C(I)=B(I)-P*C(I+1)-Q*C(I+2)
  150    CONTINUE
C
C     CHECK IF P&Q ARE COEFFICIENTS OF QUADRATIC FACTOR - ELSE NEW P&Q
C
         IF(H(2).EQ.0.) IF(DABS(B(2)/H(1))-E)160,160,170
         IF(DABS(B(2)/H(2))-E)160,160,170
C
  160    CONTINUE
         IF(DABS(B(1)/H(1))-E)240,240,170
  170    CONTINUE
         DENOM=C(3)**2-(C(2)-B(2))*C(4)
         IF(DENOM.EQ.0)GO TO 180
         P=P+(B(2)*C(3)-B(1)*C(4))/DENOM
         Q=Q+(-B(2)*(C(2)-B(2))+B(1)*C(3))/DENOM
         GO TO 110
C
  180    CONTINUE
         P=P-2.
         Q=Q*(Q+1.)
  110 CONTINUE
C
C     CHANGE E IF NOT CONVERGED AFTER 1000 ITERATIONS AND TRY AGAIN
C
      E=E*10.
      GO TO 190
C
C     THIS SECTION FINDS THE ROOTS OF THE LINEAR FACTORS
C
  200 CONTINUE
      NC=NC-1
      V(NC)=0.
      IF(IREV.EQ.-1)GO TO 210
      U(NC)=R
      GO TO 220
  210 CONTINUE
      U(NC)=1./R
C
C     STORE DEPRESSED POLYNOMIAL IN H TO FIND NEXT FACTOR
C
  220 CONTINUE
      DO230I=1,NC
         H(I)=B(I+1)
  230 CONTINUE
      GO TO 40
C
C     THIS SECTION FINDS THE ROOTS OF THE QUADRATIC FACTORS
C
  240 CONTINUE
      NC=NC-2
      IF(IREV.EQ.-1)GO TO 250
      QP=Q
      PP=P/2.
      GO TO 260
C
  250 CONTINUE
      QP=1./Q
      PP=P/(Q*2.)
  260 CONTINUE
      DISCRM=PP**2-QP
C
C     DETERMINE IF QUADRATIC ROOT IS REAL OR IMAGINARY
C
      IF(DISCRM.GE.0.)GO TO 270
      U(NC+1)=-PP
      U(NC)=-PP
      V(NC+1)=DSQRT(-DISCRM)
      V(NC)=-V(NC+1)
      GO TO 280
C
  270 CONTINUE
      IF(PP.EQ.0.)GO TO 290
      U(NC+1)=-(PP/DABS(PP))*(DABS(PP)+DSQRT(DISCRM))
      GO TO 300
  290 CONTINUE
      U(NC+1)=-DSQRT(DISCRM)
  300 CONTINUE
      V(NC+1)=0.
      U(NC)=QP/U(NC+1)
      V(NC)=0.
C
C     STORE DEPRESSED POLYNOMIAL IN H TO FIND NEXT FACTOR
C
  280 CONTINUE
      DO310I=1,NC
         H(I)=B(I+2)
  310 CONTINUE
      GO TO 40
  320 CONTINUE
      DO330I=1,N
         ROOT(I)=CMPLX(SNGL(U(I)),SNGL(V(I)))
  330 CONTINUE
      RETURN
      END
 
C     ..........GREEN..........
 
      SUBROUTINE GREENZ(THT0,THETA,ROOT,N,M,LAG2,TITLE,VAR,
     >                 IOUNI2,IOUNI3)
CCCCC APRIL 1996.  ADD IOUNIT, IOUNI2, RENAME LAG TO LAG2, PASS
CCCCC DELTA THROUGH COMMON
CCCCC SUBROUTINE GREEN(THT0,THETA,ROOT,N,M,LAG,TITLE,DELTA,VAR)
C
C     PURPOSE--FINDS THE SMALL G'S OF THE GREEN'S FUNCTION
C
      CHARACTER*8 TITLE,TTL
CCCCC COMPLEX CROOT
CCCCC COMPLEX ROOT,CNUM,DEN,D(45),G(45)
CCCCC DIMENSION ROOT(1),THETA(1)
CCCCC COMPLEX ROOT(*),THETA(*),CNUM,DEN,D(45),G(45),CROOT
CCCCC COMPLEX ROOT(*),CNUM,DEN,D(45),G(45),CROOT
      COMPLEX ROOT(*),G(45),CROOT
CCCCC COMPLEX*16 CNUM,DEN,D(45)
      COMPLEX    CNUM,DEN,D(45)
      DIMENSION THETA(*)
CCCCC APRIL 1996.  USE DPCODD.INC
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /JOSHI/ XX
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
      COMPLEX COMPSPECTR(45)
      DOUBLE PRECISION TOTGREEN, COMPGREEN(45), TOTSPECTR, RCOMPSPEC(45)
      DOUBLE PRECISION OMEGA, BETA
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      TTL=TITLE
         DO50I=1,N
               CNUM=THT0*ROOT(I)**(N-1)
                  DO10J=1,M
10                   CNUM=CNUM-THETA(J)*ROOT(I)**(N-1-J)
               DEN=CMPLX(1.0,0.0)
                  DO20J=1,N
20                   IF(I.NE.J) DEN=DEN*(ROOT(I)-ROOT(J))
               G(I)=CNUM/DEN
               IF(AIMAG(ROOT(I)) .GE. 0.0)THEN
C
C     PRINT TERM CORRESPONDING TO THIS G
C
                  IF(AIMAG(ROOT(I)).EQ.0)THEN
C
CCCCC                WRITE(ICOUT,30) TTL,REAL(G(I)),REAL(ROOT(I))
CCC30                FORMAT(5X,A,3X,E11.5,'*(',E11.5,')**J',/)
CCCCC                CALL DPWRST('XXX','WRIT')
C
                  ELSE
                     CAR=CABS(ROOT(I))
C
CCCCC                WRITE(ICOUT,40)
CCCCC>                TTL,2.*CABS(G(I)),CAR,ACOS(REAL(ROOT(I))/CAR)
CCCCC>               /(DELTA*6.2831853),ATAN2(AIMAG(G(I)),REAL(G(I)))
CCCCC                WRITE(3,40)
CCCCC>                TTL,2.*CABS(G),CAR,ACOS(REAL(ROOT(I))/CAR)
CCCCC>               /(DELTA*6.2831853),ATAN2(AIMAG(G),REAL(G))
CCC40                FORMAT (5X,A,3X,E11.5,'*(',E11.5,')**J*',
CCCCC>               'COS{2*PI*',E11.5,'*J+(',E11.5,')}'/)
CCCCC                CALL DPWRST('XXX','WRIT')
C
                  ENDIF
               TTL='       +'
            ENDIF
50       CONTINUE
C
CCCCC WRITE(ICOUT,60) LAG2
CCC60 FORMAT(45X,'FOR j GREATER THAN OR EQUAL TO',I3,///)
CCC     ***************** ICOUNT IS FOR COUNTING THE NUMBER OF MODES ***
CCCCC CALL DPWRST('XXX','WRIT')
C
      J=0
      ICOUNT=0
      TOTGREEN=1.
      DO701I=1,N
         IF(AIMAG(ROOT(I)) .GE. 0.0)THEN
            IF(AIMAG(ROOT(I)).EQ.0)THEN
               ICOUNT=ICOUNT+1
               COMPGREEN(ICOUNT)=REAL(G(I))
            ELSE
               ICOUNT=ICOUNT+1
               COMPGREEN(ICOUNT)=2.0*REAL(G(I))
            ENDIF
            TOTGREEN=1.
         ENDIF
701   CONTINUE
CCCCC APRIL 1996.  USE IOUNI3
CCCCC WRITE(3,703) DELTA*J,TOTGREEN,(COMPGREEN(K),K=1,ICOUNT)
      IF(ICOUNT.GE.1.AND.ICOUNT.LE.45)THEN
      WRITE(IOUNI2,703) DELTA*J,TOTGREEN,(COMPGREEN(K),K=1,ICOUNT)
703   FORMAT(F8.4,2X,F11.4,45(2X,F11.4))
      ELSE
      WRITE(IOUNI2,1703) DELTA*J,TOTGREEN
1703  FORMAT(F8.4,2X,F11.4)
      ENDIF
C
      DO802J=1,100
      ICOUNT=0
      TOTGREEN=0.
      DO801I=1,N
               IF(AIMAG(ROOT(I)) .GE. 0.0)THEN
                  IF(AIMAG(ROOT(I)).EQ.0)THEN
C
CCC     *********EXPONENTIAL MODE ************************
C
                     ICOUNT=ICOUNT+1
                     COMPGREEN(ICOUNT) = G(I)*ROOT(I)**J
                   ELSE
C
CCC     ********** SINUSOIDAL MODE ****************************
C
                     CAR=CABS(ROOT(I))
                     OMEGA=ACOS(REAL(ROOT(I))/CAR)
                     BETA=ATAN2(AIMAG(G(I)),REAL(G(I)))
                     ICOUNT=ICOUNT+1
                     COMPGREEN(ICOUNT)=CAR**J*COS(OMEGA*J+BETA)
                     COMPGREEN(ICOUNT)=2.*CABS(G(I))*COMPGREEN(ICOUNT)
                  ENDIF
                  TOTGREEN=TOTGREEN+COMPGREEN(ICOUNT)
              ENDIF
801   CONTINUE
CCCCC APRIL 1996.  USE IOUNIT
        IF(IFGREEN .EQ. 1)THEN
CCCCC      WRITE(3,803) DELTA*J,TOTGREEN,(COMPGREEN(K),K=1,ICOUNT)
          IF(ICOUNT.GE.1.AND.ICOUNT.LE.45)THEN
           WRITE(IOUNI2,803) DELTA*J,TOTGREEN,(COMPGREEN(K),K=1,ICOUNT)
803         FORMAT(F8.4,2X,F11.4,45(2X,F11.4))
          ELSE
            WRITE(IOUNI2,1803) DELTA*J,TOTGREEN
1803        FORMAT(F8.4,2X,F11.4)
          ENDIF
        ENDIF
802   CONTINUE
      IFLAG=0
      EPS=0.0001
      DO70I=1,N
        IF(CABS(ROOT(I)) .GT. 1.0+EPS)THEN
            IFLAG = IFLAG+1
        ENDIF
C
CCCCC CHANGED HERE
CCCCC WRITE(ICOUT,*)I,ROOT(I),IFLAG
CCCCC CALL DPWRST('XXX','WRIT')
C
70    CONTINUE
C
      WRITE(ICOUT,999)
  999 FORMAT(1H )
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,81)
   81 FORMAT(1H ,
     1'Index  Roots    Roots   Natural  Damping   Green    Green',
     1'   Var.')
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,82)
   82 FORMAT(1H ,
     1'       Real     Imag     Freq.    Ratio    Real     Imag ',
     1'   D(I)')
      CALL DPWRST('XXX','WRIT')
C
      WRITE(ICOUT,84)
   84 FORMAT(1H ,
     1'---------------------------------------------------------',
     1'---------')
      CALL DPWRST('XXX','WRIT')
C
CCCCC CHANGED HERE
CCCCC WRITE(ICOUT,*)IFLAG
CCCCC CALL DPWRST('XXX','WRIT')
CCCCC PAUSE
C
      IF(IFLAG.LE.0)THEN
         Z=0.0
         DO80I=1,N
            D(I)=CMPLX(0.0,0.0)
            EPS=0.0001
C
            DO90J=1,N
               DENOM=1.0-(ROOT(I)*ROOT(J))
CCCCC          PATCH--THE FOLLOWING 2 LINES MUST BE FIXED
               IF(ABS(DENOM).LE.EPS)DENOM=EPS
               D(I) = D(I)+G(I)*G(J)/DENOM
   90       CONTINUE
C
CCCCC       D(I)=D(I)*XX/(NOB-N-M-1)    RES. VAR INSERTED LATER
            RESVAR=XX/(NOB-N-M-1)
C
   80    CONTINUE
      ENDIF
C
C     FIND FREQUENCY AND DAMPING FOR 2ND ORDER ROOT
C
      DO85I=1,N
         AIROOT=AIMAG(ROOT(I))
         ZD=(-999.0)
         IF(AIROOT.NE.0)THEN
            CROOT=CLOG(ROOT(I))/DELTA
            ACROOT=CABS(CROOT)
            W=ACROOT/6.2831853
            ZD=-REAL(CROOT)/ACROOT
C
C        FIND BREAK FREQUENCY FOR REAL ROOTS.
C        IF NEGATIVE ROOT - SET BREAK FREQUENCY AT NYQUIST FREQ
C        IF POSITIVE ROOT -CALCULATE BREAK FREQUENCY
C
         ELSEIF(AIROOT.EQ.0)THEN
            RROOT=REAL(ROOT(I))
            IF(RROOT.LE.0)THEN
               W=0.5/DELTA
            ELSE
               W=-ALOG(RROOT)/(DELTA*6.2831853)
            ENDIF
         ENDIF
C
         IF(IFLAG.LE.0.AND.AIMAG(ROOT(I)).NE.0)THEN
            WRITE(ICOUT,101)I,REAL(ROOT(I)),AIMAG(ROOT(I)),W,ZD,
     1      REAL(G(I)),AIMAG(G(I)),REAL(D(I))
  101       FORMAT(1H ,I2,2X,6F9.3,E10.3)
            CALL DPWRST('XXX','WRIT')
C
         ELSEIF(IFLAG.GT.0.AND.AIMAG(ROOT(I)).NE.0)THEN
            WRITE(ICOUT,102)I,REAL(ROOT(I)),AIMAG(ROOT(I)),W,ZD,
     1      REAL(G(I)),AIMAG(G(I))
  102       FORMAT(1H ,I2,6F9.3,'  Infin.')
            CALL DPWRST('XXX','WRIT')
C
         ELSEIF(IFLAG.LE.0.AND.AIMAG(ROOT(I)).EQ.0)THEN
            WRITE(ICOUT,103)I,REAL(ROOT(I)),AIMAG(ROOT(I)),W,
     1      REAL(G(I)),AIMAG(G(I)),REAL(D(I))
  103       FORMAT(1H ,I2,2X,3F9.3,'  Undef. ',2F9.3,E10.3)
            CALL DPWRST('XXX','WRIT')
C
         ELSEIF(IFLAG.GT.0.AND.AIMAG(ROOT(I)).EQ.0)THEN
            WRITE(ICOUT,104)I,REAL(ROOT(I)),AIMAG(ROOT(I)),W,
     1      REAL(G(I)),AIMAG(G(I))
  104       FORMAT(1H ,I2,2X,3F9.3,'  Undef. ',2F9.3,'  Infin.')
            CALL DPWRST('XXX','WRIT')
C
         ENDIF
C
         Z = Z+REAL(D(I))
   85 CONTINUE
C
      IF(IFLAG.GT.0)THEN
         WRITE(ICOUT,999)
         CALL DPWRST('XXX','WRIT')
CCCCC AUGUST, 1995.  MODIFIY FOLLOWING LINE FOR CRAY.
CCCCC CRAY DOESN'T ALLOW FREE FORMAT FOR INTERNAL WRITE.
CCCCC    WRITE(ICOUT,*)'Caution--Root > 1 ==> Non-Stationary'
         WRITE(ICOUT,9085)
 9085    FORMAT('Caution--Root > 1 ==> Non-Stationary')
         CALL DPWRST('XXX','WRIT')
      ENDIF
C
CCCCC STEP XX--CALCULATE SPECTRA
C
      DO805J=1,500
C
      ICOUNT=0
 
      TOTSPECTR=0.
      DEN = CEXP(CMPLX(0.0,-2.0*3.141593*0.001*J))
      DO806I=1,N
               IF(AIMAG(ROOT(I)) .GE. 0.0)THEN
                  IF(AIMAG(ROOT(I)).EQ.0)THEN
C
CCC     *********EXPONENTIAL MODE ************************
C
                     ICOUNT=ICOUNT+1
                     COMPSPECTR(ICOUNT) = 
     >               2.*DELTA*D(I)*(1.-ROOT(I)*ROOT(I))
     >               /((1.-ROOT(I)*DEN)*(1.-(ROOT(I)/DEN)))
                   ELSE
C
CCC     ********** SINUSOIDAL MODE ****************************
C
                     ICOUNT=ICOUNT+1
                     COMPSPECTR(ICOUNT) = 
     >               4.*DELTA*D(I)*(1.-ROOT(I)*ROOT(I))
     >               /((1.-ROOT(I)*DEN)*(1.-(ROOT(I)/DEN)))
C
CCCCC CHANGE HERE TWICE
CCCCC WRITE(ICOUT,*) J,I,ICOUNT,D(I),ROOT(I)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,*)DEN,DELTA,G(I),THETA(I)
CCCCC CALL DPWRST('XXX','WRIT')
C
CCCCC WRITE(ICOUT,*)COMPSPECTR(ICOUNT)
CCCCC CALL DPWRST('XXX','WRIT')
C
                  ENDIF
                  COMPSPECTR(ICOUNT)=COMPSPECTR(ICOUNT)*RESVAR
                  RCOMPSPEC(ICOUNT)=REAL(COMPSPECTR(ICOUNT))
C
CCCCC PATCH--THE FOLLOWING LINE MUST BE FIXED
C
                  RCOMPSPEC(ICOUNT)=ABS(RCOMPSPEC(ICOUNT))
                  TOTSPECTR=TOTSPECTR+RCOMPSPEC(ICOUNT)
C
CCCCC CHANGED HERE
CCCCC WRITE(ICOUT,*)RCOMPSPEC(ICOUNT),TOTSPECTR
CCCCC CALL DPWRST('XXX','WRIT')
C
              ENDIF
806   CONTINUE
      IF(IFSPECTR .EQ. 1)THEN
C
CCCCC APRIL 1996.  USE IOUNI2
CCCCC WRITE(4,808) J*0.001/DELTA,TOTSPECTR,(RCOMPSPEC(K),K=1,ICOUNT)
      WRITE(IOUNI3,808) 
     >  J*0.001/DELTA,TOTSPECTR,(RCOMPSPEC(K),K=1,ICOUNT)
  808 FORMAT(E11.4,2X,E11.4,45(2X,E11.4))
C
      ENDIF
805   CONTINUE
 
      RETURN
      END
 
C     ..........SPECTRUM..........
 
      SUBROUTINE SPCTRM(THT0,THETA,PHI,N,M,LAG2,IOUNIT)
CCCCC APRIL 1996.  ADD TO ARGUMENT LIST, MAKE NAME 6 CHARACTERS
CCCCC RENAME LAG TO LAG2, PASS DELTA THROUGH COMMON
CCCCC SUBROUTINE SPECTRUM(THT0,THETA,PHI,N,M,LAG,DELTA)
C
C      PURPOSE--CALCULATES THE SPECTRUM WHEN THE NUMBER OF
C               MOVING AVERAGE PARAMETERS IS MORE THAN OR EQUAL TO AR
C
CCCCC APRIL 1996.  USE DPCODD.INC
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'DPCODD.INC'
CCCCC DOUBLE PRECISION XX
CCCCC COMMON /INDEX/ INDEX,MAXLAG,NOB,NSER,NPHI0,NPHI,NSEAS
CCCCC COMMON /JOSHI/ XX
CCCCC DIMENSION PHI(1),THETA(1)
      DIMENSION PHI(*),THETA(*)
      DOUBLE PRECISION TOTSPECTR
CCCCC COMMON /FLAG/ IFMEAN,IFAT,IFSEAS,IFGREEN,IFSPECTR
      COMPLEX CNUM,DEN
 
C
C-----COMMON VARIABLES (GENERAL)--------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      WRITE(*,*) 'N=',N
      DO405I=1,N
      WRITE(*,*) 'SPEC-PHI',I,'=',PHI(I)
405   CONTINUE
      WRITE(*,*) 'M=',M
      DO408I=1,M
      WRITE(*,*) 'SPEC-THETA',I,'=',THETA(I)
408   CONTINUE
      WRITE(*,*) '****RSS***=', XX
      DO400J=1,500
      TOTSPECTR=2.*DELTA*XX/(NOB-N-M-1)
      DEN=CEXP(CMPLX(0.,0.001*2.*3.14*J*N))
      CNUM=CEXP(CMPLX(0.,0.001*2.*3.14*J*M))
      DO401I=1,N
        DEN=DEN-(PHI(I)*CEXP(CMPLX(0.,0.001*2.*3.14*J*(N-I))))
401   CONTINUE
      DO402I=1,M
        CNUM=CNUM-(THETA(I)*CEXP(CMPLX(0.,0.001*2.*3.14*J*(M-I))))
402   CONTINUE
      TOTSPECTR=TOTSPECTR*(CABS(CNUM))**2
      TOTSPECTR=TOTSPECTR/((CABS(DEN))**2)
CCCCC APRIL 1996.  USE UNIT NUMBER INSTEAD OF HARD-CODING
      IF(IFSPECTR .EQ. 1)THEN
CCCCC    WRITE(4,403) J*0.001/DELTA,TOTSPECTR
         WRITE(IOUNIT,403) J*0.001/DELTA,TOTSPECTR
403      FORMAT(E11.4,2X,E11.4)
      ENDIF
400   CONTINUE
C
      RETURN
      END

       SUBROUTINE EDSEAR(IMARK,ICOLL1,ICOLL2,IBLASW,ISHIFN,IEXEIM,
     1ISEQNU,ICSEQN,NCSEQN,IPPLIN,IPPOFF,IERASW,IMANUF,IMODEL,
     1ILPOFF,
CCCCC THE FOLLOWING LINE WAS AUGMENTED JULY 1992
CCCCC1IHARLC,IHARL2)
     1IHARLC,IHARL2,STOPSW)
C
C     PURPOSE--THIS SUBROUTINES DETERMINES IF THE ENTERED COMMAND
C              IS IN THE EDIT DICTIONARY, AND BRANCHES ACCORDINGLY
C              SO AS TO CARRY OUT THE COMMAND.
C
C     THE EDIT COMMANDS SEARCHED FOR ARE AS FOLLOWS--
C
C
C           UNDO = UNDO FROM PREVIOUS TOP
C           .
C
C       NUMBERS ON/OFF
C     DC
C     DX
C     X
C     CALL
C     EA = EXTEND ALL
C
C     NEAT
C
C     VW
C     HW
C     LET
C     ON BRIEF & OFF BRIEF   TO FEEDBACK ON/OFF
C     ON TRACE & OFF TRACE
C     TIME
C LD = LOCATE AND DELETE
C LR = LOCATE AND RETAIN
C MARGIN
C FILE (TO BE EDITED)
C NEW FILE OR EXISTING FILE
C SPACE (SINGLE OR DOUBLE)
C JUSTIFICATION LEFT, RIGHT CENTER, BOTH
C     CENTER
C     INDENT
C HYPENATION
C FORMAT
C MATCH
C DOUBLE
C CALL
C A
C Z
C     MOVE
C     COPY WITH 4 ARGS
C      MATCH
C      LET
C           NA = PRINT NAME OF FILE BEING EDITED
C     DISPLAY LI = PRINT CURRENT LINE NUMBER
C     DISPLAY LE = PRINT CURRENT LINE LENGTH
C     DISPLAY " " = PRINT BLANK LINE
C     STAT
C     ALLOW
C     PROMPT
C STATUS
C  PRINT SCREENFUL (PS)
C     TRACE
C
C SET IBUG..
C SET ISUBRO ..
C PROBE
C DUMP
C     ASCII
C
C     WRITTEN BY--JAMES J. FILLIBEN
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--85.1
C     ORIGINAL VERSION--DECEMBER  1985.
C     UPDATED         --DECEMBER  1988.   LOCATE (NEXT) PERIOD (ONLY)    LPER
C     UPDATED         --APRIL     1990.
C     UPDATED         --JULY      1992. ADD STOP SWITCH (STOPSW)
C     UPDATED         --MAY       1993. LOOP
C     UPDATED         --MAY       1993. IF
C     UPDATED         --DECEMBER  1994. PRINT PREVIOUS PAGE
C     UPDATED         --DECEMBER  1994. PRINT PAGE VIA / ? " '
C     UPDATED         --DECEMBER  1994. GENERAL UPDATING
C     UPDATED         --FEBRUARY  1995. SYNONYMS FOR DELETE
C     UPDATED         --FEBRUARY  1995. NAME CONFLICT BETWEEN FIRST
C                                       AND FIND
C
C---------------------------------------------------------------------
C
C
      CHARACTER*4 IGLOBA
C
      CHARACTER*4 IFEESV
C
      CHARACTER*1 IANS0
C
      CHARACTER*4 IBLASW
C
      CHARACTER*4 IEXEIM
C
CCCCC CHARACTER*4 IJUNSW
C
      CHARACTER*132 ICTEMP
C
      CHARACTER*10 ICSEQN
C
      CHARACTER*4 IERASW
C
      CHARACTER*4 IMANUF
      CHARACTER*4 IMODEL
C
      CHARACTER*4 IVALID
C
      CHARACTER*4 IHARLC
      CHARACTER*4 IHARL2
C
CCCCC THE FOLLOWING LINE WAS ADDED JULY 1992
      CHARACTER*4 STOPSW
C
      CHARACTER*11 ICJU11
C
      CHARACTER*1 ICJUNK
C
C----------------------------------------------------------------------------
C
      DIMENSION IHARLC(*)
      DIMENSION IHARL2(*)
C
      DIMENSION IANS0(132)
C
C
CCCCC CHARACTER*4 ISUBN1
CCCCC CHARACTER*4 ISUBN2
CCCCC CHARACTER*4 ISTEPN
C
C-----COMMON VARIABLES (EDITING)-----------------------------------------------
C
      INCLUDE 'DPCOPA.INC'
      INCLUDE 'EDCOMM.INC'
CCCCC SEPTEMBER 1993.  ADD FOLLOWING LINE
      INCLUDE 'DPCONP.INC'
C
C-----COMMON VARIABLES (GENERAL)-----------------------------------------------
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
C
C-----START POINT-----------------------------------------------------
C
   50 CONTINUE
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.NE.'SEAR')GOTO90
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,51)
   51 FORMAT('***** AT THE BEGINNING OF EDSEAR--')
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,52)ICURLN
   52 FORMAT('ICURLN = ',I8)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,53)IWIDTH
   53 FORMAT('IWIDTH = ',I8)
      CALL EDWRST('EDSEAR')
      IF(IWIDTH.GE.0)THEN
         WRITE(ICOUT,54)(IANS(I),I=1,IWIDTH)
   54    FORMAT('(IANS(I),I=1,IWIDTH) = ',100A1)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(IWIDTH.GE.0)CALL EDWRST('EDSEAR')
      WRITE(ICOUT,55)IBUGED,IBUGE2
   55 FORMAT('IBUGED,IBUGE2 = ',A4,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,61)IMARK
   61 FORMAT('IMARK = ',I8)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,62)ICOLL1,ICOLL2,IJUST
   62 FORMAT('ICOLL1,ICOLL2,IJUST = ',2I8,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,63)IEXEIM
   63 FORMAT('IEXEIM = ',A4)
      CALL EDWRST('EDSEAR')
CCCCC WRITE(ICOUT,70)INEGAT,IFOUND,IERROR
CCC70 FORMAT('INEGSW,IFOUND,IERROR = ',A4,2X,A4,2X,A4)
      WRITE(ICOUT,76)IDELSW,IDELLN
   76 FORMAT('IDELSW,IDELLN = ',A4,2X,I8)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,77)ICOM,ICOM2
   77 FORMAT('ICOM,ICOM2 = ',A4,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,81)NUMARG
   81 FORMAT('NUMARG = ',I8)
      CALL EDWRST('EDSEAR')
      DO82I=1,NUMARG
      WRITE(ICOUT,83)I,IHARG(I),IHARG2(I),IARGT(I),IARG(I),ARG(I)
   83 FORMAT('I,IHARG(I),IHARG2(I),IARGT(I),IARG(I),ARG(I) = ',
     1I8,2X,A4,2X,A4,2X,A4,2X,I8,E15.7)
      CALL EDWRST('EDSEAR')
   82 CONTINUE
   90 CONTINUE
C
      IFOUND='NO'
      IERROR='NO'
C
C
C               **********************************************
C               **  TREAT THE SPECIAL CASES UNDER A PRIOR DELETE
C               **********************************************
C
      IF(IDELSW.EQ.'OFF')GOTO190
C
      IF(ICOM.EQ.'PRINT'.AND.NUMARG.EQ.0)GOTO110
      IF(ICOM.EQ.'P'.AND.NUMARG.EQ.0)GOTO110
      IF(ICOM.EQ.'P2'.AND.NUMARG.EQ.0)GOTO110
C
      IF(ICOM.EQ.'PRINT'.AND.NUMARG.GE.1)GOTO120
      IF(ICOM.EQ.'P'.AND.NUMARG.GE.1)GOTO120
      IF(ICOM.EQ.'P2'.AND.NUMARG.GE.1)GOTO120
CCCCC IF(ICOM(1:2).EQ.'DE')GOTO120
      IF(ICOM.EQ.'D')GOTO120
CCCCC FEBRUARY 1995.  ADD FOLLOWING LINE BACK FOR SYNONYMS
      IF(ICOM(1:2).EQ.'DE')GOTO120
      IF(ICOM(1:2).EQ.'DH')GOTO120
      IF(ICOM.EQ.'HD')GOTO120
      IF(ICOM(1:2).EQ.'CH')GOTO120
      IF(ICOM.EQ.'C')GOTO120
      IF(ICOM(1:3).EQ.'EXT')GOTO120
      IF(ICOM.EQ.'DTL')GOTO120
      IF(ICOM.EQ.'HD')GOTO120
      IF(ICOM.EQ.'DH')GOTO120
      IF(ICOM.EQ.'HD')GOTO120
C
      IF(ICOM(1:3).EQ.'INS')GOTO130
      IF(ICOM.EQ.'IN')GOTO130
      IF(ICOM.EQ.'I')GOTO130
CCCCC IF(ICOM(1:2).EQ.'LO')GOTO130
      IF(ICOM.EQ.'L')GOTO130
      IF(ICOM.EQ.'LB')GOTO130
      IF(ICOM.EQ.'LBA')GOTO130
      IF(ICOM.EQ.'LO')GOTO130
      IF(ICOM.EQ.'LA')GOTO130
      IF(ICOM.EQ.'LBL')GOTO130
      IF(ICOM.EQ.'LOBL')GOTO130
      IF(ICOM.EQ.'LABL')GOTO130
      IF(ICOM.EQ.'LPER')GOTO130
      IF(ICOM.EQ.'LKIL')GOTO130
      IF(ICOM.EQ.'LR')GOTO130
      IF(ICOM.EQ.'LDEL')GOTO130
      IF(ICOM.EQ.'LLD')GOTO130
      IF(ICOM(1:2).EQ.'FI')GOTO130
      IF(ICOM.EQ.'F')GOTO130
      IF(ICOM(1:1).EQ.'N')GOTO130
      IF(ICOM.EQ.'    ')GOTO130
      IF(ICOM.EQ.'LI')GOTO130
      IF(ICOM.EQ.'LIB')GOTO130
      IF(ICOM.EQ.'LP')GOTO130
CCCC? IF(ICOM.EQ.'LC')GOTO130
C
      GOTO140
C
  110 CONTINUE
      IF(IFEESW.EQ.'OFF')GOTO119
CCCCC THE FOLLOWING 9 LINES WERE CHANGED MAY 1993
CCCCC IF(IPRISW.EQ.'OFF'.AND.INUMSW.EQ.'OFF')THEN
CCCCC    WRITE(ICOUT,113)
CC113    FORMAT('[DELETED LINE]')
CCCCC    CALL EDWRST('EDSEAR')
CCCCC ENDIF
CCCCC IF(IPRISW.EQ.'ON'.OR.INUMSW.EQ.'ON')THEN
CCCCC    WRITE(ICOUT,114)ICURLN
CC114    FORMAT(I6,':',3X,'[DELETED LINE]')
CCCCC    CALL EDWRST('EDSEAR')
CCCCC ENDIF
CCCCC THE FOLLOWING 4 LINES WERE ADDED MAY 1993
CCCCC ICURLN=ICURLN-1
      IDELSW='OFF'
      IDELLN=(-999)
      GOTO190
  119 CONTINUE
      IFOUND='YES'
      IERROR='NO'
      GOTO9000
C
  120 CONTINUE
      IF(IFEESW.EQ.'OFF')GOTO129
CCCCC THE FOLLOWING 9 LINES WERE CHANGED MAY 1993
CCCCC IF(IPRISW.EQ.'OFF'.AND.INUMSW.EQ.'OFF')THEN
CCCCC    WRITE(ICOUT,123)
CC123    FORMAT('[ERROR--OPERATING ON A DELETED LINE]')
CCCCC    CALL EDWRST('EDSEAR')
CCCCC ENDIF
CCCCC IF(IPRISW.EQ.'ON'.OR.INUMSW.EQ.'ON')THEN
CCCCC    WRITE(ICOUT,124)ICURLN
CC124    FORMAT(I6,':',3X,'[ERROR--OPERATING ON A DELETED LINE]')
CCCCC    CALL EDWRST('EDSEAR')
CCCCC ENDIF
CCCCC THE FOLLOWING 4 LINES WERE ADDED MAY 1993
CCCCC ICURLN=ICURLN-1
      IDELSW='OFF'
      IDELLN=(-999)
      GOTO190
  129 CONTINUE
      IFOUND='YES'
      IERROR='NO'
      GOTO9000
C
  130 CONTINUE
      ICURLN=ICURLN-1
      IDELSW='OFF'
      IDELLN=(-999)
      GOTO190
C
  140 CONTINUE
      IDELSW='OFF'
      IDELLN=(-999)
      GOTO190
C
  190 CONTINUE
C
C               **********************************************
C               **  TREAT THE EDIT CASE                     **
C               **  CHANGE FROM INPUT MODE TO EDIT  MODE    **
C               **********************************************
C
      IF(IWIDTH.NE.4)GOTO299
      IF(IANS(1).NE.'E'.AND.IANS(1).NE.'e')GOTO299
      IF(IANS(2).NE.'D'.AND.IANS(2).NE.'d')GOTO299
      IF(IANS(3).NE.'I'.AND.IANS(3).NE.'i')GOTO299
      IF(IANS(4).NE.'T'.AND.IANS(4).NE.'t')GOTO299
      GOTO220
C
  220 CONTINUE
      CALL EDEDIT
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
  299 CONTINUE
C
C               **********************************************
C               **  TREAT THE INPUT CASE                    **
C               **  CHANGE FROM EDIT  MODE TO INPUT MODE    **
C               **********************************************
C
      IF(ICOM(1:3).EQ.'INP')GOTO320
      GOTO399
C
  320 CONTINUE
      CALL EDINPU
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
  399 CONTINUE
C
C               **************************************************************
C               **  TREAT THE INPUT MODE INSERT CASE--                      **
C               **  INSERT A LINE WHILE IN INPUT MODE                       **
C               **  (OR ERASE THE SCREEN [IF ENTER CONTROL E = ASCII NUMERIC 5]
C               **  (THE ONLY 2 PRACTICAL ACTIVITIES YOU CAN DO IN INPUT MODE)
C               **************************************************************
C
      IF(IMODE.EQ.'INPU')GOTO420
      GOTO499
C
  420 CONTINUE
      IF(IWIDTH.GE.1)IASC=ICHAR(IANS(1))
      IF(IWIDTH.EQ.1.AND.IASC.EQ.5)CALL EDERAS(IMANUF,IMODEL)
      IF(IWIDTH.NE.1.OR.IASC.NE.5)CALL EDININ
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
  499 CONTINUE
C
C               ****************************
C               **  TREAT THE DEFINE CASE **
C               ****************************
C
      IF(ICOM.EQ.'DEFI')GOTO1020
      GOTO1099
C
 1020 CONTINUE
      CALL EDDEFI(IHARLC,IHARL2)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1099 CONTINUE
C
C               ****************************
C               **  TREAT THE PRINT CASE  **
C               ****************************
C
      IF(ICOM(1:2).EQ.'PR')GOTO1120
      IF(ICOM.EQ.'P')GOTO1120
      IF(ICOM.EQ.'P2')GOTO1120
      GOTO1199
C
 1120 CONTINUE
      IF(ICOM.EQ.'P2')IPRISW='ON'
      CALL EDPRIN
      IF(ICOM.EQ.'P2')IPRISW='OFF'
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1199 CONTINUE
C
C               ***********************************************************
C               **  TREAT THE PRINT (STARTING WITH NEXT LINE) CASE CASE  **
C               ***********************************************************
C
C
      IF(ICOM.EQ.'PN')GOTO1210
      GOTO1299
C
 1210 CONTINUE
      IPRISW='ON'
      CALL EDPRNE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1299 CONTINUE
C
C               *****************************
C               **  TREAT THE LOCATE CASE  **
C               *****************************
C
CCCCC IF(ICOM(1:2).EQ.'LO')GOTO1320
      IF(ICOM.EQ.'L')GOTO1320
      IF(ICOM.EQ.'LO')GOTO1320
CCCCC FEBRUARY 1995.  ADD LOC, LOCA AS SYNONYMS
      IF(ICOM(1:3).EQ.'LOC')GOTO1320
      IF(ICOM.EQ.'LA')GOTO1320
      GOTO1399
C
 1320 CONTINUE
      IALL='OFF'
      IF(ICOM.EQ.'LA')IALL='ON'
      CALL EDLOCA
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1399 CONTINUE
CCCCC FEBRUARY 1995.  NAME CONFLICT WITH FIND.  MOVE THIS COMMAND
CCCCC TO BEFORE FIND (SO CAN STILL USE F AND FI AS SYNONYMS FOR FIND).
C
C               ****************************
C               **  TREAT THE FIRST CASE  **
C               ****************************
C
      IF(ICOM.EQ.'FIRS')GOTO4220
      IF(ICOM.EQ.'FIR')GOTO4220
CCCCC IF(ICOM.EQ.'FI')GOTO4220
      GOTO4299
C
 4220 CONTINUE
CCCCC IF(ICURLN.GE.2)CALL EDWRWF(ID)
      CALL EDFIRS
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 4299 CONTINUE
C
C               ****************************
C               **  TREAT THE FIND  CASE  **
C               ****************************
C
      IF(ICOM(1:2).EQ.'FI')GOTO1420
      IF(ICOM.EQ.'F')GOTO1420
      GOTO1499
C
 1420 CONTINUE
      CALL EDFIND
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1499 CONTINUE
C
C               ****************************************
C               **  TREAT THE PRINT TILL LOCATE CASE  **
C               ****************************************
C
      IF(ICOM.EQ.'PL')GOTO1520
      IF(ICOM.EQ.'PTL')GOTO1520
      GOTO1599
C
 1520 CONTINUE
      IL1=ICURLN
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESV=IFEESW
      IFEESW='OFF'
      CALL EDLOCA
      IL2=ICURLN
C
      ICOM='PRIN'
CCCCC THE FOLLOWING LINE WAS FIXED APRIL 1990
CCCCC ICOM2='T    '
      ICOM2='T   '
      NUMARG=2
      IARG(1)=IL1
      IARG(2)=IL2
      IARGT(1)='NUMB'
      IARGT(2)='NUMB'
      IFEESW=IFEESV
      CALL EDPRIN
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1599 CONTINUE
C
C               *********************************
C               **  TREAT THE PRINT PAGE CASE  **
C               *********************************
C
      IF(ICOM.EQ.'PP')GOTO1620
      IF(ICOM.EQ.'PP2')GOTO1620
      GOTO1699
C
 1620 CONTINUE
      IF(ICOM.EQ.'PP2')IPRISW='ON'
      CALL EDPP(IPPLIN,IPPOFF)
      IF(ICOM.EQ.'PP2')IPRISW='OFF'
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 1699 CONTINUE
C
C               *****************************
C               **  TREAT THE CHANGE CASE  **
C               *****************************
C
      IF(ICOM.EQ.'CA')THEN
         IGLOBA='ON'
         CALL EDCHAN(IGLOBA)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
      IF(ICOM(1:2).EQ.'CH'.OR.ICOM.EQ.'C')THEN
         IGLOBA='OFF'
         CALL EDCHAN(IGLOBA)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ************************************
C               **  TREAT THE CHANGE ALL CASE     **
C               ************************************
C
      IF(ICOM.EQ.'CG')THEN
         IGLOBA='ON'
         CALL EDCHAN(IGLOBA)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE DELETE CASE  **
C               *****************************
C
CCCCC IF(ICOM(1:2).EQ.'DE')GOTO2220
CCCCC FEBRUARY 1995.  ACCEPT SYNONYMS.
CCCCC IF(ICOM.EQ.'D')THEN
      IF(ICOM.EQ.'D'.OR.ICOM(1:2).EQ.'DE')THEN
         CALL EDDELE
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE INSERT CASE  **
C               *****************************
C
      IF(ICOM(1:3).EQ.'INS'.OR.
     1ICOM.EQ.'IN'.OR.
     1ICOM.EQ.'I')THEN
         CALL EDINSE
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
CCCCC           ******************************
CCCCC           **  TREAT THE TRANSLATE CASE  **
CCCCC           ******************************
CCCCC
CCCCC IF(ICOM(1:3).EQ.'TRA')GOTO2420
CCCCC GOTO2499
CCCCC
C2420 CONTINUE
CCCCC CALL EDTRAN
CCCCC IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
CCCCC
C2499 CONTINUE
CCCCC
C
CCCC FEBRUARY 1995.  MOVE TO BEFORE EXTEND CASE TO AVOID
CCCC NAME CONFLICT WITH EXTEND COMMAND.
C               *****************************************
C               **  TREAT THE EXTEND ALL CASE          **
C               **  EA     EXTALL                      **
C               *****************************************
C
      IF(ICOM.EQ.'EA'.OR.ICOM.EQ.'EXTA')THEN
         ICOM='EA  '
         ICOM2='    '
         CALL EDEA
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE EXTEND CASE  **
C               *****************************
C
      IF(ICOM(1:3).EQ.'EXT')THEN
         CALL EDEXTE
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE CARRIAGE RETURN CASE  **
C               ** = NEXT                           **
C               *****************************
C
      IF(ICOM.EQ.'    ')THEN
         ICOM='N   '
         NUMARG=0
         CALL EDNEXT
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
CCCCC THE FOLLOWING SECTION IS NEW      DECEMBER 1994
C               **********************************
C               **  TREAT THE DELETE WORD CASE  **
C               **********************************
C
      IF(ICOM.EQ.'DW')THEN
CCCCC    CALL EDDW
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************************
C               **  TREAT THE DELETE TILL LOCATE CASE  **
C               *****************************************
C
      IF(ICOM.EQ.'DTL')GOTO2620
      GOTO2699
C
 2620 CONTINUE
      IFEESV=IFEESW
C
      IL1=ICURLN
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESW='OFF'
      CALL EDLOCA
CCCCC IL2=ICURLN
      IL2=ICURLN-1
C
      ICOM='DELE'
      ICOM2='TE  '
      NUMARG=2
      IARG(1)=IL1
      IARG(2)=IL2
      IARGT(1)='NUMB'
      IARGT(2)='NUMB'
      IFEESW=IFEESV
      CALL EDDELE
C
      ICOM='PRIN'
      ICOM2='T   '
      NUMARG=0
      IFEESW=IFEESV
      CALL EDPRIN
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 2699 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE AND INSERT CASE   **
C               *****************************************
C
      IF(ICOM.EQ.'LI')GOTO2720
      GOTO2799
C
 2720 CONTINUE
C
      IWIDT0=IWIDTH
      DO2730I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,2731)I,IANS(I),IANS0(I)
 2731    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
 2730 CONTINUE
C
      DO2740IDUMMY=1,100000
C
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.4)GOTO2758
      DO2750I=4,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO2758
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,2751)I,J,IANS0(I),IANS(J)
 2751 FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
 2750 CONTINUE
      IWIDTH=J
 2758 CONTINUE
      ICOM='LO'
      CALL EDLOCA
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,2759)ICURLN,NUMLIN
 2759    FORMAT('ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICURLN.GT.NUMLIN)GOTO2779
C
      IANS(1)='I'
      IANS(2)='N'
      IANS(3)=' '
      IARGUM=1
      J=3
      IF(IWIDT0.LT.4)GOTO2765
      DO2760I=4,IWIDT0
      IF(IANS0(I).EQ.' ')IARGUM=IARGUM+1
      IF(IARGUM.EQ.1)GOTO2760
      IF(IARGUM.EQ.2.AND.IANS0(I).EQ.' ')GOTO2760
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,2761)I,J,IANS0(I),IANS(J)
 2761    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
 2760 CONTINUE
 2765 CONTINUE
      IF(IARGUM.EQ.1)GOTO2766
      GOTO2769
 2766 CONTINUE
      J=J+1
      IANS(J)=' '
 2769 CONTINUE
      NUMARG=IARGUM-1
      IWIDTH=J
      ICOM='IN'
      CALL EDINSE
C
 2740 CONTINUE
C
 2779 CONTINUE
C
      IWIDTH=IWIDT0
      DO2780I=1,IWIDT0
      IANS(I)=IANS0(I)
 2780 CONTINUE
      ICOM='LI'
C
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 2799 CONTINUE
C
C               *****************************************
C               **  TREAT THE IB (INSERT BEFORE) CASE  **
C               *****************************************
C
      IF(ICOM.EQ.'IB')GOTO2820
      IF(ICOM.EQ.'UI')GOTO2820
      GOTO2899
C
 2820 CONTINUE
      IF(IBUGE2.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,2821)ICURLN,NUMLIN
 2821    FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
C
      NUMASV=NUMARG
      IFEESV=IFEESW
C
      ICOM='UP  '
      ICOM2='    '
      NUMARG=0
      IFEESW='OFF'
      CALL EDUP
      IF(IERROR.EQ.'YES')GOTO9000
C
      ICOM='IN  '
      ICOM2='    '
      NUMARG=1
      IFEESW=IFEESV
      CALL EDINSE
      IF(IERROR.EQ.'YES')GOTO9000
C
      ICOM='IB  '
      ICOM2='    '
      NUMARG=NUMASV
      IFEESW=IFEESV
CCCCC ICURLN=ICURLN-1
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 2899 CONTINUE
C
C               *****************************
C               **  TREAT THE EXIT   CASE  **
C               *****************************
C
      IF(ICOM.EQ.'EXIT'.OR.
     1ICOM.EQ.'EXI'.OR.
     1ICOM.EQ.'EX'.OR.
     1ICOM.EQ.'E'.OR.
     1ICOM.EQ.'END'.OR.
     1ICOM.EQ.'STOP'.OR.
     1ICOM.EQ.'HALT'.OR.
     1ICOM.EQ.'QUIT'.OR.
     1ICOM.EQ.'BYE'.OR.
     1ICOM.EQ.'EXRR')THEN
CCCCC    THE FOLLOWING LINE WAS AUGMENTED JULY 1992
CCCCC    CALL EDEXIT
         CALL EDEXIT(STOPSW)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE ABORT  CASE  **
C               *****************************
C
      IF(ICOM.EQ.'AB'.OR.
     1ICOM(1:3).EQ.'ABO'.OR.
     1ICOM.EQ.'ABRR')THEN
CCCCC    THE FOLLOWING LINE WAS AUGMENTED JULY 1992
CCCCC    CALL EDABOR
         CALL EDABOR(STOPSW)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE UNDO   CASE  **
C               *****************************
C
      IF(ICOM.EQ.'UNDO')THEN
         CALL EDUNDO
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ****************************
C               **  TREAT THE TOP   CASE  **
C               ****************************
C
      IF(ICOM.EQ.'TOP')GOTO4120
      IF(ICOM.EQ.'TO')GOTO4120
      IF(ICOM.EQ.'T')GOTO4120
      GOTO4199
C
 4120 CONTINUE
CCCCC IF(ICURLN.GE.1)CALL EDWRWF(ID)
      CALL EDTOP
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 4199 CONTINUE
CCCCC FEBRUARY 1995.  NAME CONFLICT WITH FIRST.  MOVE THIS COMMAND
CCCCC TO BEFORE FIND (SO CAN STILL USE F AND FI AS SYNONYMS FOR FIND).
C
C               ****************************
C               **  TREAT THE FIRST CASE  **
C               ****************************
C
CCCCC IF(ICOM.EQ.'FIRS')GOTO4220
CCCCC IF(ICOM.EQ.'FIR')GOTO4220
CCCCC IF(ICOM.EQ.'FI')GOTO4220
CCCCC GOTO4299
C
C4220 CONTINUE
CCCCC IF(ICURLN.GE.2)CALL EDWRWF(ID)
CCCCC CALL EDFIRS
CCCCC IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
C4299 CONTINUE
C
C               ****************************
C               **  TREAT THE GO    CASE  **
C               ****************************
C
      IF(ICOM.EQ.'GO'.OR.ICOM.EQ.'G')THEN
CCCCC    IF(NUMARG.GE.1.AND.IARGT(NUMARG).EQ.'NUMB'.AND.
CCCCC1   IARG(NUMARG).LT.ICURLN)CALL EDWRWF(ID)
         CALL EDGO(IMARK)
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
 
C               *******************************
C               **  TREAT THE <NUMBER> CASE  **
C               *******************************
C
      IF(ICOM.EQ.'.')GOTO4499
      IF(ICOMT.EQ.'NUMB'.AND.ICOM.NE.'    ')GOTO4420
      GOTO4499
C
 4420 CONTINUE
CCCCC IF(ICOMI.LT.ICURLN)CALL EDWRWF(ID)
      CALL EDGONU
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 4499 CONTINUE
C
C               ****************************
C               **  TREAT THE LAST  CASE  **
C               ****************************
C
      IF(ICOM(1:3).EQ.'LAS')THEN
CCCCC    IF(ICURLN.GT.NUMLIN)CALL EDWRWF(ID)
         CALL EDLAST
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ******************************
C               **  TREAT THE BOTTOM  CASE  **
C               ******************************
C
      IF(ICOM(1:1).EQ.'B')THEN
         CALL EDBOTT
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ****************************
C               **  TREAT THE UP    CASE  **
C               ****************************
C
      IF(ICOM.EQ.'UP'.OR.ICOM.EQ.'U')THEN
CCCCC    IF(NUMARG.GE.1)CALL EDWRWF(ID)
         CALL EDUP
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C               ****************************
C               **  TREAT THE NEXT  CASE  **
C               ****************************
C
      IF(ICOM.EQ.'N'.OR.ICOM.EQ.'NEXT'.OR.ICOM(1:2).EQ.'DO')THEN
         CALL EDNEXT
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE HOLD   CASE  **
C               *****************************
C
      IF(ICOM(1:2).EQ.'HO'.OR.ICOM.EQ.'H')THEN
         CALL EDHOLD
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ***************************************
C               **  TREAT THE HOLD AND DELETE  CASE  **
C               ***************************************
C
      IF(ICOM.EQ.'HD'.OR.ICOM(1:2).EQ.'DH')THEN
         CALL EDHOLD
         NUMARG=0
         CALL EDDELE
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               ********************************
C               **  TREAT THE DUPLICATE CASE  **
C               ********************************
C
      IF(ICOM(1:2).EQ.'DU')THEN
         CALL EDDUPL
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      ENDIF
C
C               *****************************
C               **  TREAT THE COPY    CASE **
C               **  COPY                   **
C               **  COPY  JUNK.            **
C               **  COPY  5 7              **
C               **  COPY  JUNK. 5 7        **
C               **  COPY  5 7 10           **
C               *****************************
C
      IF(ICOM.EQ.'COPY')GOTO5720
      IF(ICOM.EQ.'COP')GOTO5720
      IF(ICOM.EQ.'CO')GOTO5720
      GOTO5799
C
 5720 CONTINUE
      IF(NUMARG.LE.1)GOTO5721
      IF(NUMARG.EQ.2)GOTO5722
      IF(NUMARG.EQ.3.AND.IARGT(1).EQ.'WORD')GOTO5723
      GOTO5724
C
 5721 CONTINUE
      CALL EDCOP1
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      GOTO5799
C
 5722 CONTINUE
      CALL EDCOP2
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      GOTO5799
C
 5723 CONTINUE
      CALL EDCOP2
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      GOTO5799
C
 5724 CONTINUE
      CALL EDCOP3
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      GOTO5799
C
 5799 CONTINUE
C
C               *****************************
C               **  TREAT THE DCOPY   CASE **
C               **  (IDENTICAL TO MOVE)    **
C               **  DCOPY                  **
C               **  DCOPY JUNK.            **
C               **  DCOPY 5 7              **
C               **  DCOPY JUNK. 5 7        **
C               **  DCOPY 5 7 10           **
C               **  MOVE                   **
C               **  MOVE  JUNK.            **
C               **  MOVE  5 7              **
C               **  MOVE  JUNK. 5 7        **
C               **  MOVE  5 7 10           **
C               *****************************
C
      IF(ICOM.EQ.'DCOP')GOTO5820
      IF(ICOM.EQ.'MOVE')GOTO5820
      IF(ICOM.EQ.'MOV')GOTO5820
      IF(ICOM.EQ.'MO')GOTO5820
      IF(ICOM.EQ.'M')GOTO5820
      GOTO5899
C
 5820 CONTINUE
      IF(NUMARG.LE.1)GOTO5821
      IF(NUMARG.EQ.2)GOTO5822
      IF(NUMARG.EQ.3.AND.IARGT(1).EQ.'WORD')GOTO5823
      GOTO5824
C
 5821 CONTINUE
      CALL EDCOP1
      IF(IFOUND.EQ.'NO')GOTO5899
      IF(IERROR.EQ.'YES')GOTO9000
      ITEMP1=IBLIM1
      ITEMP2=IBLIM2
      GOTO5830
C
 5822 CONTINUE
      CALL EDCOP2
      IF(IFOUND.EQ.'NO')GOTO5899
      IF(IERROR.EQ.'YES')GOTO9000
      ITEMP1=IARG(1)
      ITEMP2=IARG(2)
      GOTO5830
C
 5823 CONTINUE
      CALL EDCOP2
      IF(IFOUND.EQ.'NO')GOTO5899
      IF(IERROR.EQ.'YES')GOTO9000
      ITEMP1=IARG(2)
      ITEMP2=IARG(3)
      GOTO5830
C
 5824 CONTINUE
      CALL EDCOP3
      IF(IFOUND.EQ.'NO')GOTO5899
      IF(IERROR.EQ.'YES')GOTO9000
      ITEMP1=IARG(1)
      ITEMP2=IARG(2)
      ITEMP3=IARG(3)
      IFUDGE=0
      IF(ITEMP3.LT.ITEMP1)IFUDGE=ITEMP2-ITEMP1+1
      ITEMP1=ITEMP1+IFUDGE
      ITEMP2=ITEMP2+IFUDGE
      GOTO5830
C
 5830 CONTINUE
      ICOM='DELE'
      ICOM2='TE  '
      NUMARG=2
      IARG(1)=ITEMP1
      IARG(2)=ITEMP2
      IARGT(1)='NUMB'
      IARGT(2)='NUMB'
      CALL EDDELE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
      GOTO5899
C
 5899 CONTINUE
C
C               *****************************
C               **  TREAT THE ADD    CASE  **
C               *****************************
C
      IF(ICOM(1:2).EQ.'AD')GOTO5920
      GOTO5999
C
 5920 CONTINUE
      CALL EDADD
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 5999 CONTINUE
C
C               ****************************
C               **  TREAT THE SCALE CASE  **
C               ****************************
C
      IF(ICOM.EQ.'SCAL')GOTO7020
      IF(ICOM.EQ.'SCA')GOTO7020
CCCCC IF(ICOM.EQ.'SC')GOTO7020
      GOTO7099
C
 7020 CONTINUE
      CALL EDSCAL
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7099 CONTINUE
C
C               ***************************************
C               **  TREAT THE . CASE                 **
C               **  (NULL COMMAND, E.G., A COMMENT)  **
C               ***************************************
C
      IF(ICOM.EQ.'.')GOTO7120
CCCCC IF(ICOM.EQ.'    ')GOTO7120
      GOTO7199
C
 7120 CONTINUE
      CALL EDPERI
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7199 CONTINUE
C
C               *****************************
C               **  TREAT THE HELP   CASE  **
C               *****************************
C
      IF(ICOM(1:2).EQ.'HE')GOTO7220
      GOTO7299
C
 7220 CONTINUE
      CALL EDHELP
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7299 CONTINUE
C
C               *****************************
C               **  TREAT THE SET    CASE  **
C               *****************************
C
      IF(ICOM.EQ.'SET')GOTO7350
      IF(ICOM.EQ.'SE')GOTO7350
      IF(ICOM.EQ.'S')GOTO7350
      IF(ICOM.EQ.'SC1')GOTO7310
      IF(ICOM.EQ.'SC2')GOTO7320
      IF(ICOM.EQ.'SC')GOTO7330
      IF(ICOM.EQ.'MARK')GOTO7330
      IF(ICOM.EQ.'SM')GOTO7340
      GOTO7399
C
 7310 CONTINUE
      IF(NUMARG.LE.0)GOTO7311
      IARG(2)=IARG(1)
 7311 CONTINUE
      ICOM='SET '
      ICOM2='    '
      IHARG(1)='BEGI'
      IHARG2(1)='    '
      NUMARG=NUMARG+1
      GOTO7350
C
 7320 CONTINUE
      IF(NUMARG.LE.0)GOTO7321
      IARG(2)=IARG(1)
 7321 CONTINUE
      ICOM='SET '
      ICOM2='    '
      IHARG(1)='END '
      IHARG2(1)='    '
      NUMARG=NUMARG+1
      GOTO7350
C
 7330 CONTINUE
      IF(NUMARG.LE.0)GOTO7331
      IARG(3)=IARG(2)
      IARG(2)=IARG(1)
 7331 CONTINUE
      ICOM='SET '
      ICOM2='    '
      IHARG(1)='COPY'
      IHARG2(1)='    '
      NUMARG=NUMARG+1
      GOTO7350
C
 7340 CONTINUE
      IF(NUMARG.LE.0)GOTO7341
      IARG(2)=IARG(1)
 7341 CONTINUE
      ICOM='SET '
      ICOM2='    '
      IHARG(1)='MARK'
      IHARG2(1)='    '
      NUMARG=NUMARG+1
      GOTO7350
C
 7350 CONTINUE
      CALL EDSET(IMARK,ICOLL1,ICOLL2,ISHIFN,IPPLIN,IPPOFF,IERASW,
     1ISEQNU,ILPOFF)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7399 CONTINUE
C
C               *****************************
C               **  TREAT THE SHOW   CASE  **
C               *****************************
C
      IF(ICOM.EQ.'SHOW')GOTO7420
      IF(ICOM.EQ.'SHO')GOTO7420
      IF(ICOM.EQ.'SH')GOTO7420
      GOTO7499
C
 7420 CONTINUE
      CALL EDSHOW
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7499 CONTINUE
C
C               *****************************
C               **  TREAT THE STATUS CASE  **
C               *****************************
C
      IF(ICOM.EQ.'STAT')GOTO7520
      IF(ICOM.EQ.'STA')GOTO7520
      IF(ICOM.EQ.'ST')GOTO7520
      GOTO7599
C
 7520 CONTINUE
      CALL EDSTAT
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 7599 CONTINUE
C
C               ******************************
C               **  TREAT THE TRUNCATE CASE **
C               ******************************
C
      IF(ICOM(1:3).EQ.'TRU')GOTO8120
      IF(ICOM.EQ.'TR')GOTO8120
      GOTO8199
C
 8120 CONTINUE
      CALL EDTRUN
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 8199 CONTINUE
C
C               ******************************
C               **  TREAT THE CENTER   CASE **
C               ******************************
C
      IF(ICOM(1:2).EQ.'CE')GOTO8420
      GOTO8499
C
 8420 CONTINUE
      CALL EDCENT
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 8499 CONTINUE
C
C               ******************************
C               **  TREAT THE INDENT   CASE **
C               ******************************
C
      IF(ICOM(1:3).EQ.'IND')GOTO8520
      GOTO8599
C
 8520 CONTINUE
      CALL EDINDE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 8599 CONTINUE
C
C               ******************************
C               **  TREAT THE ERASE    CASE **
C               ******************************
C
      IF(ICOM.EQ.'ERAS')GOTO8820
      IF(ICOM.EQ.'ERA')GOTO8820
      IF(ICOM.EQ.'ER')GOTO8820
      GOTO8899
C
 8820 CONTINUE
      CALL EDERAS(IMANUF,IMODEL)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 8899 CONTINUE
C               ******************************
C               **  TREAT THE LIST   CASE   **
C               ******************************
C
      IF(ICOM(1:3).EQ.'LIS')GOTO9120
      GOTO9199
C
 9120 CONTINUE
      CALL EDLIST
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 9199 CONTINUE
C
C               ******************************
C               **  TREAT THE CALL   CASE   **
C               ******************************
C
      IF(ICOM.EQ.'CALL')GOTO9220
      IF(ICOM(1:3).EQ.'CAL')GOTO9220
      GOTO9299
C
 9220 CONTINUE
      CALL EDCALL
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 9299 CONTINUE
C               ******************************
C               **  TREAT THE EXECUTE CASE  **
C               ******************************
C
      IF(ICOM.EQ.'EXEC')GOTO9320
      IF(ICOM.EQ.'EXE')GOTO9320
      IF(ICOM.EQ.'X')GOTO9320
      GOTO9399
C
 9320 CONTINUE
      CALL EDX
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 9399 CONTINUE
C
C               ******************************
C               **  TREAT THE SAVE     CASE **
C               ******************************
C
      IF(ICOM.EQ.'SAVE')GOTO9420
      IF(ICOM.EQ.'SAV')GOTO9420
      IF(ICOM.EQ.'SA')GOTO9420
      GOTO9499
C
 9420 CONTINUE
      CALL EDSAVE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 9499 CONTINUE
C
C               ******************************
C               **  TREAT THE RESTORE  CASE **
C               ******************************
C
      IF(ICOM.EQ.'REST')GOTO9520
      IF(ICOM.EQ.'RES')GOTO9520
      GOTO9599
C
 9520 CONTINUE
      CALL EDREST
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
 9599 CONTINUE
C
C               *****************************
C               **  TREAT THE DUMP   CASE  **
C               *****************************
C
      IF(ICOM.EQ.'DUMP')GOTO11320
      GOTO11399
C
11320 CONTINUE
      CALL EDDUMP
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
11399 CONTINUE
C
C               *****************************
C               **  TREAT THE CUT    CASE  **
C               *****************************
C
      IF(ICOM.EQ.'CUT')GOTO11420
      IF(ICOM.EQ.'CU')GOTO11420
      GOTO11499
C
11420 CONTINUE
      CALL EDCUT
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
11499 CONTINUE
C
C               *****************************
C               **  TREAT THE DELETE AND INSERT CASE  **
C               *****************************
C
      IF(ICOM.EQ.'DI')GOTO11520
      GOTO11599
C
11520 CONTINUE
      CALL EDDI
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
11599 CONTINUE
C
CCCCC          *****************************
CCCCC          **  TREAT THE FORMAT CASE  **
CCCCC          *****************************
CCCCC
CCCCC IF(ICOM(1:2).EQ.'FO')GOTO11620
CCCCC GOTO11699
CCCCC
C1620 CONTINUE
CCCCC CALL EDFORM
CCCCC IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
CCCCC
C1699 CONTINUE
CCCCC
CCCCC          *********************************
CCCCC          **  TREAT THE PRINT PARAGRAPH CASE  **
CCCCC          *********************************
CCCCC
CCCCC IF(ICOM.EQ.'PPAR')GOTO11720
CCCCC GOTO11799
CCCCC
C1720 CONTINUE
CCCCC CALL EDPPAR
CCCCC IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
CCCCC
C1799 CONTINUE
CCCCC
C               *********************************
C               **  TREAT THE PRINT ALL CASE  **
C               *********************************
C
      IF(ICOM.EQ.'PA')GOTO11820
      GOTO11899
C
11820 CONTINUE
      CALL EDPA
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
11899 CONTINUE
C
C               *********************************
C               **  TREAT THE SHIFT CASE  **
C               *********************************
C
      IF(ICOM(1:3).EQ.'SHI')GOTO11920
      GOTO11999
C
11920 CONTINUE
      CALL EDSHIF(ISHIFN)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
11999 CONTINUE
C
CCCCC           *********************************
CCCCC           **  TREAT THE SPLIT CASE  **
CCCCC           *********************************
CCCCC
CCCCC IF(ICOM(1:2).EQ.'SP')GOTO12020
CCCCC GOTO12099
CCCCC
C2020 CONTINUE
CCCCC CALL EDSPLI
CCCCC IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
CCCCC
C2099 CONTINUE
CCCCC
C               ********************************************
C               **  TREAT THE LOCATE AND KEEP (ALL) CASE  **
C               ********************************************
C
      IF(ICOM.EQ.'LKIL')GOTO12120
      IF(ICOM.EQ.'LR')GOTO12120
      GOTO12199
C
12120 CONTINUE
      IFEESV=IFEESW
      DO12130IDUMMY=1,1000000
C
      IF(IBUGE2.EQ.'ON')WRITE(ICOUT,12121)ICURLN,NUMLIN
12121 FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN = ',2I8)
      IF(IBUGE2.EQ.'ON')CALL EDWRST('EDSEAR')
C
      ICURL2=ICURLN
CCCCC IF(ICURLN.EQ.NUMLIN)GOTO12149
      IF(ICURLN.GE.NUMLIN)GOTO12149
C
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESW=IFEESV
      CALL EDLOCA
      IF(IERROR.EQ.'YES')GOTO9000
CCCCC IF(ICURLN.GT.NUMLIN)GOTO12149
C
      ICOM='DELE'
      ICOM2='TE  '
      IL1=ICURL2+1
      IL2=ICURLN-1
      IF(ICURLN.GT.NUMLIN)IL2=ICURLN
      IF(IL1.GT.IL2)GOTO12129
      NUMARG=2
      IARG(1)=IL1
      IARG(2)=IL2
      IARGT(1)='NUMB'
      IARGT(2)='NUMB'
      IFEESW='OFF'
      CALL EDDELE
      IF(IERROR.EQ.'YES')GOTO9000
      ICURLN=ICURLN-1
C
      ICOM='NEXT'
      ICOM2='    '
      NUMARG=0
      IFEESW='OFF'
      CALL EDNEXT
      IF(IERROR.EQ.'YES')GOTO9000
C
12129 CONTINUE
12130 CONTINUE
C
12149 CONTINUE
      IFEESW=IFEESV
      ICOM='LKIL'
      ICOM2='    '
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
12199 CONTINUE
C
C               ********************************************
C               **  TREAT THE LOCATE AND DELETE (ALL) CASE  **
C               ********************************************
C
      IF(ICOM.EQ.'LDEL')GOTO12220
      GOTO12299
C
12220 CONTINUE
      IFEESV=IFEESW
      DO12230IDUMMY=1,1000000
C
      IF(IBUGE2.EQ.'ON')WRITE(ICOUT,12221)ICURLN,NUMLIN
12221 FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN = ',2I8)
      IF(IBUGE2.EQ.'ON')CALL EDWRST('EDSEAR')
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESW=IFEESV
      CALL EDLOCA
      IF(IERROR.EQ.'YES')GOTO9000
      IF(ICURLN.GT.NUMLIN)GOTO12249
C
      ICOM='DELE'
      ICOM2='TE  '
      NUMARG=0
      IFEESW='OFF'
      CALL EDDELE
      IF(IERROR.EQ.'YES')GOTO9000
      ICURLN=ICURLN-1
C
12230 CONTINUE
C
12249 CONTINUE
      IFEESW=IFEESV
      ICOM='LDEL'
      ICOM2='    '
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
12299 CONTINUE
C
C               ***********************************
C               **  TREAT THE LOCATE BLANK CASE  **
C               ***********************************
C
      IF(ICOM(1:3).EQ.'LBL')GOTO12320
      IF(ICOM.EQ.'LOBL')GOTO12320
      IF(ICOM.EQ.'LABL')GOTO12320
      IF(ICOM.EQ.'LPER')GOTO12330
      GOTO12399
C
12320 CONTINUE
      IALL='OFF'
      IF(ICOM.EQ.'LABL')IALL='ON'
      CALL EDLOBL
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
12330 CONTINUE
      IALL='OFF'
      CALL EDLOPE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
12399 CONTINUE
C
C               ********************************************
C               **  TREAT THE LOCATE (ALL) BACK-TO-BACK
C               **  AND DELETE THE SECOND LINE CASE
C               ********************************************
C
      IF(ICOM.EQ.'LLD')GOTO12420
      GOTO12499
C
12420 CONTINUE
      IFEESV=IFEESW
CCCCC ICL1=0
      ICLN1=0
      DO12430IDUMMY=1,1000000
C
      IF(IBUGE2.EQ.'ON')WRITE(ICOUT,12421)ICURLN,NUMLIN
12421 FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN = ',2I8)
      IF(IBUGE2.EQ.'ON')CALL EDWRST('EDSEAR')
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESW=IFEESV
      CALL EDLOCA
      IF(IERROR.EQ.'YES')GOTO9000
      IF(ICURLN.GT.NUMLIN)GOTO12449
      IF(ICURLN.EQ.ICLN1+1)GOTO12441
      ICLN1=ICURLN
      GOTO12430
C
12441 CONTINUE
      ICOM='DELE'
      ICOM2='TE  '
      NUMARG=0
      IFEESW='OFF'
      CALL EDDELE
      IF(IERROR.EQ.'YES')GOTO9000
      ICURLN=ICURLN-1
      ICLN1=0
C
12430 CONTINUE
C
12449 CONTINUE
      IFEESW=IFEESV
      ICOM='LDEL'
      ICOM2='    '
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
12499 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE ALL AND INSERT BEFORE CASE   **
C               *****************************************
C
      IF(ICOM.EQ.'LIB')GOTO12520
      GOTO12599
C
12520 CONTINUE
C
      IWIDT0=IWIDTH
      DO12530I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,12531)I,IANS(I),IANS0(I)
12531    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
12530 CONTINUE
C
      DO12540IDUMMY=1,100000
C
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.5)GOTO12558
      DO12550I=5,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO12558
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,12551)I,J,IANS0(I),IANS(J)
12551    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
12550 CONTINUE
      IWIDTH=J
12558 CONTINUE
      ICOM='LO'
      CALL EDLOCA
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,12559)ICURLN,NUMLIN
12559    FORMAT('ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICURLN.GT.NUMLIN)GOTO12579
C
      ICOM='UP  '
      ICOM2='    '
      NUMARG=0
      CALL EDUP
C
      IANS(1)='I'
      IANS(2)='N'
      IANS(3)=' '
      IARGUM=1
      J=3
      IF(IWIDT0.LT.5)GOTO12565
      DO12560I=5,IWIDT0
      IF(IANS0(I).EQ.' ')IARGUM=IARGUM+1
      IF(IARGUM.EQ.1)GOTO12560
      IF(IARGUM.EQ.2.AND.IANS0(I).EQ.' ')GOTO12560
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,12561)I,J,IANS0(I),IANS(J)
12561    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
12560 CONTINUE
12565 CONTINUE
      IF(IARGUM.EQ.1)GOTO12566
      GOTO12569
12566 CONTINUE
      J=J+1
      IANS(J)=' '
12569 CONTINUE
      NUMARG=IARGUM-1
      IWIDTH=J
      ICOM='IN'
      CALL EDINSE
C
      ICOM='N   '
      ICOM2='    '
      NUMARG=0
      CALL EDNEXT
C
12540 CONTINUE
C
12579 CONTINUE
C
      IWIDTH=IWIDT0
      DO12580I=1,IWIDT0
      IANS(I)=IANS0(I)
12580 CONTINUE
      ICOM='LIB'
C
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
12599 CONTINUE
C
CCCC FEBRUARY 1995.  MOVE TO BEFORE EXTEND CASE TO AVOID
CCCC NAME CONFLICT WITH EXTEND COMMAND.
C               *****************************************
C               **  TREAT THE EXTEND ALL CASE          **
C               **  EA     EXTALL                      **
C               *****************************************
C
CCCCC IF(ICOM.EQ.'EA'.OR.ICOM.EQ.'EXTA')THEN
CCCCC    ICOM='EA  '
CCCCC    ICOM2='    '
CCCCC    CALL EDEA
CCCCC    IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
CCCCC ENDIF
C
C               *****************************
C               **  TREAT THE NEAT   CASE  **
C               *****************************
C
      IF(ICOM(1:3).EQ.'NEA')GOTO12720
      GOTO12799
C
12720 CONTINUE
      CALL EDNEAT(ICOLL1,ICOLL2,IBLASW)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
12799 CONTINUE
C
CCCCC THE FOLLOWING SECTION WAS UPDATED   DECEMBER 1994
C               ********************************************
C               **  TREAT THE / = PRINT 20 LINES (A PSEUDO-SCREEN) CASE  **
C               ** SYNONYMS: / ? ' "                      **
C               ********************************************
C
      IF(ICOM.EQ.'/'.OR.ICOM.EQ.'?'.OR.
     1ICOM(1:1).EQ.CHAR(39).OR.ICOM.EQ.'"')THEN
         ICOM='P   '
         ICOM2='    '
         NUMARG=1
         IARG(1)=20
         IARGT(1)='NUMB'
         CALL EDERAS(IMANUF,IMODEL)
         CALL EDPRIN
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
         ICOM='/ '
         ICOM2='    '
      ENDIF
C
CCCCC THE FOLLOWING SECTION WAS ADDED   DECEMBER 1994
C               ********************************************
C               **  TREAT THE \ OR | COMMAND:    **
C               ** GO UP 20 LINES AND PRINT THIS CURRENT PAGE
C               ********************************************
C
CUNIX IF(ICOM.EQ.'\'.OR.ICOM.EQ.'|'.OR.
      IF(ICOM.EQ.'\\'.OR.ICOM.EQ.'|'.OR.
     1   ICOM.EQ.']'.OR.ICOM.EQ.'}')THEN
C
         ICOM='UP  '
         ICOM2='    '
         NUMARG=1
         IARG(1)=18
         IARGT(1)='NUMB'
CCCCC FEBRUARY 1995.  ONLY WANT ONE UP COMMAND, NOT TWO.
CCCCC    CALL EDUP
         CALL EDUP
         CALL EDERAS(IMANUF,IMODEL)
         IF(IERROR.EQ.'YES')GOTO9000
C
         ICOM='P   '
         ICOM2='    '
         NUMARG=1
         IARG(1)=20
         IARGT(1)='NUMB'
         CALL EDPRIN
         IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
      ENDIF
C
C               *****************************************
C               **  TREAT THE LOCATE BACKWARDS CASE    **
C               *****************************************
C
      IF(ICOM.EQ.'LB')GOTO12920
      IF(ICOM.EQ.'LBA')GOTO12920
      GOTO12999
C
12920 CONTINUE
      IALL='OFF'
      IF(ICOM.EQ.'LBA')IALL='ON'
      CALL EDLB
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
12999 CONTINUE
C
C               **********************************
C               **  TREAT THE MAKE FORMAT CASE  **
C               **  (A MACRO)                   **
C               **********************************
C
      IF(ICOM.EQ.'MF')GOTO13120
      GOTO13199
C
13120 CONTINUE
      NCTEMP=16
      ICTEMP(1:16)='CALL FED$:MF.FED'
      CALL EDCOST(ICTEMP,NCTEMP)
      IEXEIM='YES'
      IFOUND='YES'
      GOTO9000
C
13199 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE (ALL) AND SEQUENCE CASE   **
C               *****************************************
C
      IF(ICOM.EQ.'LS')GOTO13220
      GOTO13299
C
13220 CONTINUE
C
      IWIDT0=IWIDTH
      DO13230I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13231)I,IANS(I),IANS0(I)
13231    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
13230 CONTINUE
C
      DO13240IDUMMY=1,100000
C
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.4)GOTO13258
      DO13250I=4,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO13258
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13251)I,J,IANS0(I),IANS(J)
13251    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
13250 CONTINUE
      IWIDTH=J
13258 CONTINUE
      ICOM='LO'
      CALL EDLOCA
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13259)ICURLN,NUMLIN
13259    FORMAT('ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICURLN.GT.NUMLIN)GOTO13279
C
      IANS(1)='C'
      IANS(2)=' '
      IANS(3)='/'
      IARGUM=1
      J=3
      IF(IWIDT0.LT.4)GOTO13265
      DO13260I=4,IWIDT0
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13261)I,J,IANS0(I),IANS(J)
13261    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
13260 CONTINUE
13265 CONTINUE
      J=J+1
      IANS(J)='/'
      IF(NUMARG.GE.2)ISEQNU=IARG(2)
      CALL EDCOIH(ISEQNU,ICSEQN,NCSEQN,IVALID)
      IF(NCSEQN.LE.0)GOTO13271
      DO13270I=1,NCSEQN
      J=J+1
      IANS(J)=ICSEQN(I:I)
13270 CONTINUE
      ISEQNU=ISEQNU+1
13271 CONTINUE
      NUMARG=1
      J=J+1
      IANS(J)='/'
      IWIDTH=J
      ICOM='C'
      IGLOBA='OFF'
      CALL EDCHAN(IGLOBA)
C
13240 CONTINUE
C
13279 CONTINUE
      ISEQNU=1
      ICSEQN='1         '
      NCSEQN=1
C
      IWIDTH=IWIDT0
      DO13280I=1,IWIDT0
      IANS(I)=IANS0(I)
13280 CONTINUE
      ICOM='LS'
C
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
13299 CONTINUE
C
C               *******************************************
C               **  TREAT THE DEVICE MANUFACTURER CASE   **
C               **  (= TERMINAL DEFINITION CASE)         **
C               *******************************************
C
      IF(NUMARG.GE.2)THEN
         IF(ICOM.EQ.'DEVI'.AND.IHARG(1).EQ.'1')THEN
            IF(IHARG(2).EQ.'TEKT')GOTO13320
            IF(IHARG(2).EQ.'IBM')GOTO13320
            IF(IHARG(2).EQ.'IBM-')GOTO13320
            IF(IHARG(2).EQ.'HDS')GOTO13320
            IF(IHARG(2).EQ.'QUME')GOTO13320
            IF(IHARG(2).EQ.'VT')GOTO13320
            IF(IHARG(2).EQ.'VT-1')GOTO13320
            IF(IHARG(2).EQ.'VT-2')GOTO13320
C
            IF(IHARG(2).EQ.'TURB')GOTO13320
            IF(IHARG(2).EQ.'DOS')GOTO13320
            IF(IHARG(2).EQ.'UNIX')GOTO13320
            IF(IHARG(2).EQ.'X11')GOTO13320
            IF(IHARG(2).EQ.'X')GOTO13320
            IF(IHARG(2).EQ.'MOTI')GOTO13320
            IF(IHARG(2).EQ.'MAC')GOTO13320
            IF(IHARG(2).EQ.'MACI')GOTO13320
         ENDIF
      ENDIF
      GOTO13399
C
13320 CONTINUE
      ICOM=IHARG(2)
      CALL EDDEMN(IMANUF,IMODEL)
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
13399 CONTINUE
C
C               ******************************
C               **  TREAT THE NEWS   CASE   **
C               ******************************
C
      IF(ICOM(1:4).EQ.'NEWS')GOTO13420
      GOTO13499
C
13420 CONTINUE
      CALL EDLINE
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
13499 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE (ALL) AND PRINT (SOME OFFSET) CASE   **
C               *****************************************
C
      IF(ICOM.EQ.'LP')GOTO13520
      GOTO13599
C
13520 CONTINUE
C
      IWIDT0=IWIDTH
      DO13530I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13531)I,IANS(I),IANS0(I)
13531    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
13530 CONTINUE
C
      IFEESV=IFEESW
      DO13540IDUMMY=1,100000
C
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.5)GOTO13558
      DO13550I=5,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO13558
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13551)I,J,IANS0(I),IANS(J)
13551    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
13550 CONTINUE
      IWIDTH=J
13558 CONTINUE
      ICOM='LO'
      IFEESW='OFF'
      CALL EDLOCA
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,13559)ICURLN,NUMLIN
13559    FORMAT('ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICURLN.GT.NUMLIN)GOTO13579
C
13560 CONTINUE
      ICOM='NEXT'
      ICOM2='    '
      NUMARG=1
      IARG(1)=ILPOFF
      IARGT(1)='NUMB'
      IFEESW=IFEESV
      CALL EDNEXT
C
      ICOM='NEXT'
      ICOM2='    '
      NUMARG=1
      IARG(1)=(-ILPOFF)
      IARGT(1)='NUMB'
      IFEESW='OFF'
      CALL EDNEXT
C
13540 CONTINUE
C
13579 CONTINUE
      IFEESW=IFEESV
C
      IWIDTH=IWIDT0
      DO13580I=1,IWIDT0
      IANS(I)=IANS0(I)
13580 CONTINUE
      ICOM='LP'
C
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
13599 CONTINUE
C
C               ******************************
C               **  TREAT THE OPEN   CASE   **
C               ******************************
C
      IF(ICOM(1:4).EQ.'OPEN')GOTO14120
      GOTO14199
C
14120 CONTINUE
      CALL EDOPEN
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
14199 CONTINUE
C
C               ******************************
C               **  TREAT THE CLOSE  CASE   **
C               ******************************
C
      IF(ICOM(1:4).EQ.'CLOS')GOTO14220
      GOTO14299
C
14220 CONTINUE
      CALL EDCLOS
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
14299 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE AND JUMP IF NOT FOUND   CASE   **
C               *****************************************
C
      IF(ICOM(1:4).EQ.'LJNF')GOTO14320
      GOTO14399
C
14320 CONTINUE
      ICOM='LOCA'
      ICOM2='TE  '
      CALL EDLOCA
      IF(IFOUND.EQ.'NO')GOTO14399
      IF(IERROR.EQ.'YES')GOTO9000
      IF(IFOUND.EQ.'YES'.AND.ICURLN.LE.NUMLIN)GOTO9000
      DO14330I=1,1000
      READ(ICALNU,14335)ICJU11
14335 FORMAT(A11)
      IF(ICJU11.EQ.'END OF LJNF')GOTO9000
14330 CONTINUE
C
14399 CONTINUE
C
C               ********************************************
C               **  TREAT THE LOCATE AND DELETE (ALL) BLANK (LINES) CASE  **
C               ********************************************
C
      IF(ICOM.EQ.'LDBL')GOTO14420
      GOTO14499
C
14420 CONTINUE
      IFEESV=IFEESW
      DO14430IDUMMY=1,1000000
C
      IF(IBUGE2.EQ.'ON')WRITE(ICOUT,14421)ICURLN,NUMLIN
14421 FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN = ',2I8)
      IF(IBUGE2.EQ.'ON')CALL EDWRST('EDSEAR')
      ICOM='LBL '
      ICOM2='    '
      IFEESW=IFEESV
      IALL='OFF'
      CALL EDLOBL
      IF(IERROR.EQ.'YES')GOTO9000
      IF(ICURLN.GT.NUMLIN)GOTO14449
C
      ICOM='DELE'
      ICOM2='TE  '
      NUMARG=0
      IFEESW='OFF'
      CALL EDDELE
      IF(IERROR.EQ.'YES')GOTO9000
      ICURLN=ICURLN-1
C
14430 CONTINUE
C
14449 CONTINUE
      IFEESW=IFEESV
      ICOM='LDBL'
      ICOM2='    '
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
14499 CONTINUE
C
C               *****************************************
C               **  TREAT THE LOCATE (ALL) AND SEQUENCE--RIGHT JUSTIFIED CASE   **
C               *****************************************
C
      IF(ICOM.EQ.'LSRJ')GOTO14520
      GOTO14599
C
14520 CONTINUE
C
      IWIDT0=IWIDTH
      IWIDST=IWIDT0-6+1
      DO14530I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,14531)I,IANS(I),IANS0(I)
14531    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
14530 CONTINUE
C
      DO14540IDUMMY=1,100000
C
      IANS(1)='L'
      IANS(2)='O'
      IANS(3)=' '
      IWIDTH=2
      J=3
      IF(IWIDT0.LT.6)GOTO14558
      DO14550I=6,IWIDT0
      IF(IANS0(I).EQ.' ')IWIDTH=J
      IF(IANS0(I).EQ.' ')GOTO14558
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
          WRITE(ICOUT,14551)I,J,IANS0(I),IANS(J)
14551    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
14550 CONTINUE
      IWIDTH=J
14558 CONTINUE
      ICOM='LO'
      CALL EDLOCA
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,14559)ICURLN,NUMLIN
14559    FORMAT('ICURLN,NUMLIN = ',2I8)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICURLN.GT.NUMLIN)GOTO14579
C
      IANS(1)='C'
      IANS(2)='A'
      IANS(3)=' '
      IANS(4)='/'
      IARGUM=1
      J=4
      IF(IWIDT0.LT.6)GOTO14565
      DO14560I=6,IWIDT0
      J=J+1
      IANS(J)=IANS0(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,14561)I,J,IANS0(I),IANS(J)
14561    FORMAT('I,J,IANS0(I),IANS(J) = ',2I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
14560 CONTINUE
14565 CONTINUE
      J=J+1
      IANS(J)='/'
      IF(NUMARG.GE.2)ISEQNU=IARG(2)
      CALL EDCOIH(ISEQNU,ICSEQN,NCSEQN,IVALID)
      IF(NCSEQN.LE.0)GOTO14578
CCCCC DO14570I=1,NCSEQN
      JSAVE=J
      DO14570I=1,IWIDST
      J=J+1
      IANS(J)=' '
14570 CONTINUE
      J=JSAVE
      IBLANK=IWIDST-NCSEQN
      IF(IBLANK.LE.0)GOTO14572
      DO14573I=1,IBLANK
      J=J+1
14573 CONTINUE
14572 CONTINUE
      DO14575I=1,NCSEQN
      J=J+1
      IANS(J)=ICSEQN(I:I)
14575 CONTINUE
      ISEQNU=ISEQNU+1
14578 CONTINUE
      NUMARG=1
      J=J+1
      IANS(J)='/'
      IWIDTH=J
      ICOM='C'
      IGLOBA='ON'
      CALL EDCHAN(IGLOBA)
C
14540 CONTINUE
C
14579 CONTINUE
      ISEQNU=1
      ICSEQN='1         '
      NCSEQN=1
C
      IWIDTH=IWIDT0
      DO14580I=1,IWIDT0
      IANS(I)=IANS0(I)
14580 CONTINUE
      ICOM='LSRJ'
C
      IF(IFOUND.EQ.'YES'.OR.IERROR.EQ.'YES')GOTO9000
C
14599 CONTINUE
C
C               *****************************************
C               **  TREAT THE CHANGE TILL LOCATE CASE  **
C               *****************************************
C
      IF(ICOM.EQ.'CTL')GOTO14620
      GOTO14699
C
14620 CONTINUE
      IFEESV=IFEESW
C
      IWIDT0=IWIDTH
      DO14630I=1,IWIDTH
      IANS0(I)=IANS(I)
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,14631)I,IANS(I),IANS0(I)
14631    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
14630 CONTINUE
C
      IANS(1)='L'
      IANS(2)=' '
      IANS(3)=' '
      IANS(4)=' '
      ICJUNK=IANS(5)
      ICOUNT=0
      DO14640I=5,IWIDTH
      IF(IANS(I).EQ.ICJUNK)ICOUNT=ICOUNT+1
      IANS(I)=' '
      IF(ICOUNT.GE.3)GOTO14649
14640 CONTINUE
14649 CONTINUE
C
      IL1=ICURLN
      ICOM='LOCA'
      ICOM2='TE  '
      IFEESW='OFF'
      IALL='OFF'
      CALL EDLOCA
      IF(IERROR.EQ.'YES')GOTO9000
CCCCC IL2=ICURLN
      IL2=ICURLN-1
C
      IANS(1)='C'
      IANS(2)=' '
      IANS(3)=' '
      IANS(4)=' '
      ICJUNK=IANS0(5)
      ICOUNT=0
      IWIDJU=IWIDTH
      DO14650I=5,IWIDTH
      IANS(I)=IANS0(I)
      IF(ICOUNT.GE.3)IANS(I)=' '
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,14651)I,IANS(I),IANS0(I)
14651    FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
         CALL EDWRST('EDSEAR')
      ENDIF
      IF(ICOUNT.GE.3)GOTO14650
      IF(IANS(I).EQ.ICJUNK)ICOUNT=ICOUNT+1
      IF(IANS(I).EQ.ICJUNK.AND.ICOUNT.EQ.3)IWIDJU=I
14650 CONTINUE
14659 CONTINUE
      IWIDTH=IWIDJU
      ICOM='C   '
      ICOM2='    '
      NUMARG=NUMARG-1
C
      IF(IBUGED.EQ.'ON'.OR.ISUBRO.EQ.'SEAR')THEN
         WRITE(ICOUT,999)
         CALL EDWRST('EDSEAR')
         DO14660I=1,IWIDTH
            WRITE(ICOUT,14661)I,IANS(I),IANS0(I)
14661       FORMAT('I,IANS(I),IANS0(I) = ',I8,2X,A1,2X,A1)
            CALL EDWRST('EDSEAR')
14660    CONTINUE
      ENDIF
C
      IF(IL2.LT.IL1)GOTO14679
      DO14670IDUMMY=IL1,IL2
C
      ICURLN=IDUMMY
      IF(IBUGE2.EQ.'ON')WRITE(ICOUT,14671)ICURLN,NUMLIN
14671 FORMAT('***** FROM EDSEAR--ICURLN,NUMLIN,IL1,IL2 = ',4I8)
      IF(IBUGE2.EQ.'ON')CALL EDWRST('EDSEAR')
C
      IFEESW=IFEESV
      IF(ICURLN.GT.NUMLIN)GOTO14679
      IGLOBA='ON'
      CALL EDCHAN(IGLOBA)
      IF(IERROR.EQ.'YES')GOTO9000
C
14670 CONTINUE
14679 CONTINUE
C
      ICURLN=IL2
      ICOM='PRIN'
      ICOM2='T   '
      NUMARG=0
      IFEESW=IFEESV
      CALL EDPRIN
      IF(IERROR.EQ.'YES')GOTO9000
C
      ICURLN=IL2+1
      ICOM='PRIN'
      ICOM2='T   '
      NUMARG=0
      IFEESW=IFEESV
      CALL EDPRIN
      IF(IERROR.EQ.'YES')GOTO9000
C
      ICOM='CTL '
      ICOM2='    '
      NUMARG=NUMARG+1
      IWIDTH=IWIDT0
      DO14680I=1,IWIDTH
      IANS(I)=IANS0(I)
14680 CONTINUE
C
      IFOUND='YES'
      GOTO9000
C
14699 CONTINUE
C
C               *********************************************
C               **  TREAT THE    PRINT BLANK LINE   CASE   **
C               *********************************************
C
      IF(ICOM.EQ.'PBL')THEN
         WRITE(ICOUT,999)
         CALL EDWRST('EDSEAR')
         IFOUND='YES'
         GOTO9000
      ENDIF
C
C               **********************************************
C               **  TREAT THE    PRINT DOTTED LINE   CASE   **
C               **********************************************
C
      IF(ICOM.EQ.'PDL')THEN
         WRITE(ICOUT,14710)
14710    FORMAT('--------------------------------------------------')
         CALL EDWRST('EDSEAR')
         IFOUND='YES'
         GOTO9000
      ENDIF
C
C               *********************************************
C               **  TREAT THE    PRINT ERROR LINE   CASE   **
C               *********************************************
C
      IF(ICOM.EQ.'PEL')THEN
         WRITE(ICOUT,14711)IBELC,IBELC,IBELC,IBELC,IBELC
14711    FORMAT(5A1)
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14711)IBELC,IBELC,IBELC,IBELC,IBELC
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14711)IBELC,IBELC,IBELC,IBELC,IBELC
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14711)IBELC,IBELC,IBELC,IBELC,IBELC
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14711)IBELC,IBELC,IBELC,IBELC,IBELC
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14712)
14712    FORMAT('***** ERROR ENCOUNTERED *****')
         CALL EDWRST('EDSEAR')
         IFOUND='YES'
         GOTO9000
      ENDIF
C
C               **************************************************
C               **            TREAT THE LOOP CASE               **
C               **************************************************
C
      IF(ICOM.EQ.'LOOP')THEN
         LOOPCT=IARG(1)
         LOOPST=' '
         ILOC=IWIDTH+1
         DO14721I=1,IWIDTH
            I2=I
            IF(IANS(I).EQ.' ')GOTO14722
14721    CONTINUE
14722    CONTINUE
         IMIN=I2+1
         DO14723I=IMIN,IWIDTH
            I2=I
            IF(IANS(I).EQ.' ')GOTO14724
14723    CONTINUE
14724    CONTINUE
         IMIN=I2+1
         J=0
         DO14725I=IMIN,IWIDTH
            J=J+1
            LOOPST(J:J)=IANS(I)
14725    CONTINUE
         LOOPIW=J
         WRITE(ICOUT,999)
         CALL EDWRST('EDSEAR')
         WRITE(ICOUT,14726)LOOPCT
14726    FORMAT('LOOP COUNT  = ',I8)
         CALL EDWRST('EDMAI2')
         WRITE(ICOUT,14727)(LOOPST(I:I),I=1,LOOPIW)
14727    FORMAT('LOOP STRING = ',240A1)
         CALL EDWRST('EDMAI2')
         WRITE(ICOUT,999)
         CALL EDWRST('EDSEAR')
         IFOUND='YES'
         GOTO9000
      ENDIF
C
CCCCC THE FOLLOWING SECTION WAS ADDED MAY 1993
C               **************************************************
C               **            TREAT THE IF CASE                 **
C               **      EXAMPLE--IF CHANGE YES UP        ZZ
C               **      EXAMPLE--IF CHANGE NO UP        ZZ
C               **      EXAMPLE--IF LOCATE YES UP        ZZ
C               **      EXAMPLE--IF LOCATE NO UP        ZZ
C               **************************************************
C
      IF(ICOM.EQ.'IF')THEN
         IF((IHARG(1).EQ.'CHAN'.AND.IHARG(2).EQ.CHANGE).OR.
     1      (IHARG(1).EQ.'LOCA'.AND.IHARG(2).EQ.LOCATE))THEN
            J=0
            IF(IHARG(2).EQ.'YES')IMIN=15
            IF(IHARG(2).EQ.'NO')IMIN=14
            DO14730I=IMIN,IWIDTH
               J=J+1
               IANS(J)=IANS(I)
14730       CONTINUE
            IWIDTH=J
            ICOM=IHARG(3)
            ICOM2=IHARG2(3)
            CALL EDSHLE(3)
            GOTO50
         ELSE
            IANS(1)='.'
            IWIDTH=1
            ICOM='.    '
            ICOM2='    '
            NUMARG=0
            GOTO50
         ENDIF
      ENDIF
C
C               *****************
C               **  STEP 90--  **
C               **  EXIT       **
C               *****************
C
 9000 CONTINUE
      IF(IBUGED.EQ.'OFF'.AND.ISUBRO.NE.'SEAR')GOTO9090
      WRITE(ICOUT,999)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9011)
 9011 FORMAT('***** AT THE END       OF EDSEAR--')
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9012)ICURLN
 9012 FORMAT('ICURLN = ',I8)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9013)IWIDTH
 9013 FORMAT('IWIDTH = ',I8)
      CALL EDWRST('EDSEAR')
      IF(IWIDTH.GE.0)THEN
         WRITE(ICOUT,9014)(IANS(I),I=1,IWIDTH)
 9014    FORMAT('(IANS(I),I=1,IWIDTH) = ',100A1)
         CALL EDWRST('EDSEAR')
      ENDIF
      WRITE(ICOUT,9015)IBUGED,IBUGE2
 9015 FORMAT('IBUGED,IBUGE2 = ',A4,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9021)IMARK
 9021 FORMAT('IMARK = ',I8)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9022)ICOLL1,ICOLL2,IJUST
 9022 FORMAT('ICOLL1,ICOLL2,IJUST = ',2I8,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9023)IEXEIM
 9023 FORMAT('IEXEIM = ',A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9024)IFOUND,IERROR
 9024 FORMAT('IFOUND,IERROR = ',A4,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9031)ICOM,ICOM2
 9031 FORMAT('ICOM,ICOM2 = ',A4,2X,A4)
      CALL EDWRST('EDSEAR')
      WRITE(ICOUT,9041)NUMARG
 9041 FORMAT('NUMARG = ',I8)
      CALL EDWRST('EDSEAR')
      DO9042I=1,NUMARG
      WRITE(ICOUT,9043)I,IHARG(I),IHARG2(I),IARGT(I),IARG(I),ARG(I)
 9043 FORMAT('I,IHARG(I),IHARG2(I),IARGT(I),IARG(I),ARG(I) = ',
     1I8,2X,A4,2X,A4,2X,A4,2X,I8,E15.7)
      CALL EDWRST('EDSEAR')
 9042 CONTINUE
 9090 CONTINUE
      RETURN
      END
